/****************************************************************************
 * Copyright (C) 2014-2018 Intel Corporation.   All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * @file gen_swr_context_llvm.h
 *
 * @brief auto-generated file
 *
 * DO NOT EDIT
 *
 * Generation Command Line:
 *   ../src/gallium/drivers/swr/rasterizer/codegen/gen_llvm_types.py
 *     --input
 *     ../src/gallium/drivers/swr/swr_context.h
 *     --output
 *     src/gallium/drivers/swr/rasterizer/codegen/gen_swr_context_llvm.h
 *
 ******************************************************************************/
// clang-format off

#pragma once

namespace SwrJit
{
    using namespace llvm;

    INLINE static StructType* Gen_swr_jit_texture(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("swr_jit_texture");
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* width         */ Type::getInt32Ty(ctx),
                /* height        */ Type::getInt32Ty(ctx),
                /* depth         */ Type::getInt32Ty(ctx),
                /* first_level   */ Type::getInt32Ty(ctx),
                /* last_level    */ Type::getInt32Ty(ctx),
                /* base_ptr      */ PointerType::get(Type::getInt8Ty(ctx), 0),
                /* num_samples   */ Type::getInt32Ty(ctx),
                /* sample_stride */ Type::getInt32Ty(ctx),
                /* row_stride    */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_TEXTURE_LEVELS),
                /* img_stride    */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_TEXTURE_LEVELS),
                /* mip_offsets   */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_TEXTURE_LEVELS),
            };

            pRetType = StructType::create(members, "swr_jit_texture", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("swr_context.h", "../src/gallium/drivers/swr");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("width",         74),
                std::make_pair("height",        75),
                std::make_pair("depth",         76),
                std::make_pair("first_level",   77),
                std::make_pair("last_level",    78),
                std::make_pair("base_ptr",      79),
                std::make_pair("num_samples",   80),
                std::make_pair("sample_stride", 81),
                std::make_pair("row_stride",    82),
                std::make_pair("img_stride",    83),
                std::make_pair("mip_offsets",   84),
            };
            pJitMgr->CreateDebugStructType(pRetType, "swr_jit_texture", pFile, 73, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t swr_jit_texture_width         = 0;
    static const uint32_t swr_jit_texture_height        = 1;
    static const uint32_t swr_jit_texture_depth         = 2;
    static const uint32_t swr_jit_texture_first_level   = 3;
    static const uint32_t swr_jit_texture_last_level    = 4;
    static const uint32_t swr_jit_texture_base_ptr      = 5;
    static const uint32_t swr_jit_texture_num_samples   = 6;
    static const uint32_t swr_jit_texture_sample_stride = 7;
    static const uint32_t swr_jit_texture_row_stride    = 8;
    static const uint32_t swr_jit_texture_img_stride    = 9;
    static const uint32_t swr_jit_texture_mip_offsets   = 10;

    INLINE static StructType* Gen_swr_jit_sampler(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("swr_jit_sampler");
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* min_lod      */ Type::getFloatTy(ctx),
                /* max_lod      */ Type::getFloatTy(ctx),
                /* lod_bias     */ Type::getFloatTy(ctx),
                /* border_color */ ArrayType::get(Type::getFloatTy(ctx), 4),
            };

            pRetType = StructType::create(members, "swr_jit_sampler", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("swr_context.h", "../src/gallium/drivers/swr");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("min_lod",      88),
                std::make_pair("max_lod",      89),
                std::make_pair("lod_bias",     90),
                std::make_pair("border_color", 91),
            };
            pJitMgr->CreateDebugStructType(pRetType, "swr_jit_sampler", pFile, 87, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t swr_jit_sampler_min_lod      = 0;
    static const uint32_t swr_jit_sampler_max_lod      = 1;
    static const uint32_t swr_jit_sampler_lod_bias     = 2;
    static const uint32_t swr_jit_sampler_border_color = 3;

    INLINE static StructType* Gen_swr_draw_context(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("swr_draw_context");
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* constantVS       */ ArrayType::get(PointerType::get(Type::getFloatTy(ctx), 0), PIPE_MAX_CONSTANT_BUFFERS),
                /* num_constantsVS  */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_CONSTANT_BUFFERS),
                /* constantFS       */ ArrayType::get(PointerType::get(Type::getFloatTy(ctx), 0), PIPE_MAX_CONSTANT_BUFFERS),
                /* num_constantsFS  */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_CONSTANT_BUFFERS),
                /* constantGS       */ ArrayType::get(PointerType::get(Type::getFloatTy(ctx), 0), PIPE_MAX_CONSTANT_BUFFERS),
                /* num_constantsGS  */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_CONSTANT_BUFFERS),
                /* constantTCS      */ ArrayType::get(PointerType::get(Type::getFloatTy(ctx), 0), PIPE_MAX_CONSTANT_BUFFERS),
                /* num_constantsTCS */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_CONSTANT_BUFFERS),
                /* constantTES      */ ArrayType::get(PointerType::get(Type::getFloatTy(ctx), 0), PIPE_MAX_CONSTANT_BUFFERS),
                /* num_constantsTES */ ArrayType::get(Type::getInt32Ty(ctx), PIPE_MAX_CONSTANT_BUFFERS),
                /* texturesVS       */ ArrayType::get(Gen_swr_jit_texture(pJitMgr), PIPE_MAX_SHADER_SAMPLER_VIEWS),
                /* samplersVS       */ ArrayType::get(Gen_swr_jit_sampler(pJitMgr), PIPE_MAX_SAMPLERS),
                /* texturesFS       */ ArrayType::get(Gen_swr_jit_texture(pJitMgr), PIPE_MAX_SHADER_SAMPLER_VIEWS),
                /* samplersFS       */ ArrayType::get(Gen_swr_jit_sampler(pJitMgr), PIPE_MAX_SAMPLERS),
                /* texturesGS       */ ArrayType::get(Gen_swr_jit_texture(pJitMgr), PIPE_MAX_SHADER_SAMPLER_VIEWS),
                /* samplersGS       */ ArrayType::get(Gen_swr_jit_sampler(pJitMgr), PIPE_MAX_SAMPLERS),
                /* texturesTCS      */ ArrayType::get(Gen_swr_jit_texture(pJitMgr), PIPE_MAX_SHADER_SAMPLER_VIEWS),
                /* samplersTCS      */ ArrayType::get(Gen_swr_jit_sampler(pJitMgr), PIPE_MAX_SAMPLERS),
                /* texturesTES      */ ArrayType::get(Gen_swr_jit_texture(pJitMgr), PIPE_MAX_SHADER_SAMPLER_VIEWS),
                /* samplersTES      */ ArrayType::get(Gen_swr_jit_sampler(pJitMgr), PIPE_MAX_SAMPLERS),
                /* userClipPlanes   */ ArrayType::get(ArrayType::get(Type::getFloatTy(ctx), 4), PIPE_MAX_CLIP_PLANES),
                /* polyStipple      */ ArrayType::get(Type::getInt32Ty(ctx), 32),
                /* renderTargets    */ ArrayType::get(Gen_SWR_SURFACE_STATE(pJitMgr), SWR_NUM_ATTACHMENTS),
                /* swr_query_result */ PointerType::get(Type::getInt32Ty(ctx), 0),
                /* pAPI             */ PointerType::get(Type::getInt32Ty(ctx), 0),
                /* pTileAPI         */ PointerType::get(Type::getInt32Ty(ctx), 0),
                /* soPrims          */ PointerType::get(Type::getInt64Ty(ctx), 0),
            };

            pRetType = StructType::create(members, "swr_draw_context", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("swr_context.h", "../src/gallium/drivers/swr");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("constantVS",       95),
                std::make_pair("num_constantsVS",  96),
                std::make_pair("constantFS",       97),
                std::make_pair("num_constantsFS",  98),
                std::make_pair("constantGS",       99),
                std::make_pair("num_constantsGS",  100),
                std::make_pair("constantTCS",      101),
                std::make_pair("num_constantsTCS", 102),
                std::make_pair("constantTES",      103),
                std::make_pair("num_constantsTES", 104),
                std::make_pair("texturesVS",       106),
                std::make_pair("samplersVS",       107),
                std::make_pair("texturesFS",       108),
                std::make_pair("samplersFS",       109),
                std::make_pair("texturesGS",       110),
                std::make_pair("samplersGS",       111),
                std::make_pair("texturesTCS",      112),
                std::make_pair("samplersTCS",      113),
                std::make_pair("texturesTES",      114),
                std::make_pair("samplersTES",      115),
                std::make_pair("userClipPlanes",   117),
                std::make_pair("polyStipple",      119),
                std::make_pair("renderTargets",    121),
                std::make_pair("swr_query_result", 122),
                std::make_pair("pAPI",             123),
                std::make_pair("pTileAPI",         124),
                std::make_pair("soPrims",          126),
            };
            pJitMgr->CreateDebugStructType(pRetType, "swr_draw_context", pFile, 94, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t swr_draw_context_constantVS       = 0;
    static const uint32_t swr_draw_context_num_constantsVS  = 1;
    static const uint32_t swr_draw_context_constantFS       = 2;
    static const uint32_t swr_draw_context_num_constantsFS  = 3;
    static const uint32_t swr_draw_context_constantGS       = 4;
    static const uint32_t swr_draw_context_num_constantsGS  = 5;
    static const uint32_t swr_draw_context_constantTCS      = 6;
    static const uint32_t swr_draw_context_num_constantsTCS = 7;
    static const uint32_t swr_draw_context_constantTES      = 8;
    static const uint32_t swr_draw_context_num_constantsTES = 9;
    static const uint32_t swr_draw_context_texturesVS       = 10;
    static const uint32_t swr_draw_context_samplersVS       = 11;
    static const uint32_t swr_draw_context_texturesFS       = 12;
    static const uint32_t swr_draw_context_samplersFS       = 13;
    static const uint32_t swr_draw_context_texturesGS       = 14;
    static const uint32_t swr_draw_context_samplersGS       = 15;
    static const uint32_t swr_draw_context_texturesTCS      = 16;
    static const uint32_t swr_draw_context_samplersTCS      = 17;
    static const uint32_t swr_draw_context_texturesTES      = 18;
    static const uint32_t swr_draw_context_samplersTES      = 19;
    static const uint32_t swr_draw_context_userClipPlanes   = 20;
    static const uint32_t swr_draw_context_polyStipple      = 21;
    static const uint32_t swr_draw_context_renderTargets    = 22;
    static const uint32_t swr_draw_context_swr_query_result = 23;
    static const uint32_t swr_draw_context_pAPI             = 24;
    static const uint32_t swr_draw_context_pTileAPI         = 25;
    static const uint32_t swr_draw_context_soPrims          = 26;

} // namespace SwrJit


// clang-format on
