/* This file is autogenerated by sid_tables.py from sid.h. Do not edit directly. */

/*
 * Copyright 2015-2019 Advanced Micro Devices, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * on the rights to use, copy, modify, merge, publish, distribute, sub
 * license, and/or sell copies of the Software, and to permit persons to whom
 * the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) AND/OR THEIR SUPPLIERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef SID_TABLES_H
#define SID_TABLES_H

struct si_field {
        unsigned name_offset;
        unsigned mask;
        unsigned num_values;
        unsigned values_offset; /* offset into sid_strings_offsets */
};

struct si_reg {
        unsigned name_offset;
        unsigned offset;
        unsigned num_fields;
        unsigned fields_offset;
};

struct si_packet3 {
        unsigned name_offset;
        unsigned op;
};

static const struct si_packet3 packet3_table[] = {
	{0, PKT3_NOP},
	{4, PKT3_SET_BASE},
	{13, PKT3_CLEAR_STATE},
	{25, PKT3_INDEX_BUFFER_SIZE},
	{43, PKT3_DISPATCH_DIRECT},
	{59, PKT3_DISPATCH_INDIRECT},
	{77, PKT3_OCCLUSION_QUERY},
	{93, PKT3_SET_PREDICATION},
	{109, PKT3_COND_EXEC},
	{119, PKT3_PRED_EXEC},
	{129, PKT3_DRAW_INDIRECT},
	{143, PKT3_DRAW_INDEX_INDIRECT},
	{163, PKT3_INDEX_BASE},
	{174, PKT3_DRAW_INDEX_2},
	{187, PKT3_CONTEXT_CONTROL},
	{203, PKT3_INDEX_TYPE},
	{214, PKT3_DRAW_INDIRECT_MULTI},
	{234, PKT3_DRAW_INDEX_AUTO},
	{250, PKT3_DRAW_INDEX_IMMD},
	{266, PKT3_NUM_INSTANCES},
	{280, PKT3_DRAW_INDEX_MULTI_AUTO},
	{302, PKT3_INDIRECT_BUFFER_SI},
	{321, PKT3_INDIRECT_BUFFER_CONST},
	{343, PKT3_STRMOUT_BUFFER_UPDATE},
	{365, PKT3_DRAW_INDEX_OFFSET_2},
	{385, PKT3_WRITE_DATA},
	{396, PKT3_DRAW_INDEX_INDIRECT_MULTI},
	{422, PKT3_MEM_SEMAPHORE},
	{436, PKT3_MPEG_INDEX},
	{447, PKT3_WAIT_REG_MEM},
	{460, PKT3_MEM_WRITE},
	{470, PKT3_INDIRECT_BUFFER_CIK},
	{490, PKT3_COPY_DATA},
	{500, PKT3_PFP_SYNC_ME},
	{512, PKT3_SURFACE_SYNC},
	{525, PKT3_ME_INITIALIZE},
	{539, PKT3_COND_WRITE},
	{550, PKT3_EVENT_WRITE},
	{562, PKT3_EVENT_WRITE_EOP},
	{578, PKT3_RELEASE_MEM},
	{590, PKT3_CONTEXT_REG_RMW},
	{606, PKT3_ONE_REG_WRITE},
	{620, PKT3_ACQUIRE_MEM},
	{632, PKT3_REWIND},
	{639, PKT3_LOAD_UCONFIG_REG},
	{656, PKT3_LOAD_SH_REG},
	{668, PKT3_LOAD_CONTEXT_REG},
	{685, PKT3_SET_CONFIG_REG},
	{700, PKT3_SET_CONTEXT_REG},
	{716, PKT3_SET_SH_REG},
	{727, PKT3_SET_SH_REG_OFFSET},
	{745, PKT3_SET_UCONFIG_REG},
	{761, PKT3_SET_UCONFIG_REG_INDEX},
	{783, PKT3_LOAD_CONST_RAM},
	{798, PKT3_WRITE_CONST_RAM},
	{814, PKT3_DUMP_CONST_RAM},
	{829, PKT3_INCREMENT_CE_COUNTER},
	{850, PKT3_INCREMENT_DE_COUNTER},
	{871, PKT3_WAIT_ON_CE_COUNTER},
	{890, PKT3_SET_SH_REG_INDEX},
	{907, PKT3_LOAD_CONTEXT_REG_INDEX},
	{930, PKT3_IT_OPCODE_C},
	{942, PKT3_CP_DMA},
	{949, PKT3_DMA_DATA},
};

static const struct si_reg gfx10_reg_table[] = {
	{958, 1028, 10, 0},
	{971, 1032, 20, 10},
	{986, 1036, 10, 30},
	{1002, 1040, 12, 40},
	{1023, 1044, 4, 52},
	{1041, 1048, 3, 56},
	{1059, 1052, 11, 59},
	{1074, 1056, 1, 70},
	{1088, 1060, 1, 71},
	{1102, 1064, 1, 72},
	{1119, 1076, 9, 73},
	{1135, 1080, 1, 82},
	{1152, 1116, 5, 83},
	{1167, 1120, 7, 88},
	{1182, 1124, 2, 95},
	{1202, 1128, 1, 97},
	{1221, 1132, 4, 98},
	{1241, 1136, 7, 102},
	{1257, 2480, 1, 109},
	{1271, 2484, 1, 109},
	{1285, 2488, 1, 109},
	{1299, 2492, 1, 109},
	{1313, 2496, 1, 109},
	{1327, 2500, 1, 109},
	{1341, 2504, 1, 109},
	{1355, 2508, 1, 109},
	{1369, 2512, 1, 109},
	{1383, 2516, 1, 109},
	{1397, 2520, 1, 109},
	{1412, 2524, 1, 109},
	{1427, 2528, 1, 109},
	{1442, 2532, 1, 109},
	{1457, 2536, 1, 109},
	{1472, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{1530, 2560, 1, 109},
	{1554, 2564, 1, 109},
	{1578, 2568, 1, 113},
	{1602, 32776, 27, 114},
	{1615, 32784, 21, 141},
	{1627, 32788, 14, 162},
	{1643, 32792, 14, 162},
	{1659, 32796, 15, 176},
	{1672, 32824, 14, 162},
	{1688, 32828, 14, 162},
	{1704, 33296, 21, 191},
	{1718, 33300, 28, 212},
	{1735, 33304, 15, 240},
	{1756, 33308, 28, 255},
	{1770, 33312, 32, 283},
	{1787, 33316, 13, 315},
	{1808, 33320, 9, 328},
	{1826, 33324, 1, 337},
	{1849, 33344, 2, 338},
	{1870, 33348, 1, 340},
	{1890, 33352, 1, 341},
	{1913, 33356, 9, 342},
	{1931, 33436, 1, 351},
	{1954, 36096, 1, 352},
	{1980, 36100, 2, 353},
	{2006, 36104, 1, 352},
	{2032, 36108, 2, 353},
	{2058, 36112, 2, 355},
	{2079, 36116, 4, 357},
	{2100, 36120, 4, 361},
	{2127, 36124, 17, 365},
	{2148, 36128, 6, 382},
	{2171, 36132, 1, 388},
	{2200, 36140, 1, 388},
	{2230, 36144, 1, 388},
	{2262, 36148, 1, 388},
	{2293, 36152, 1, 388},
	{2326, 36348, 5, 389},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 10, 400},
	{2407, 36656, 14, 410},
	{2425, 36660, 4, 424},
	{2443, 36664, 12, 428},
	{2461, 36668, 2, 440},
	{2479, 37120, 9, 442},
	{2495, 39160, 5, 451},
	{2510, 39184, 5, 456},
	{2524, 39188, 5, 456},
	{2538, 39192, 5, 456},
	{2552, 39196, 5, 456},
	{2566, 39200, 5, 456},
	{2580, 39204, 5, 456},
	{2594, 39208, 5, 456},
	{2608, 39212, 5, 456},
	{2622, 39216, 5, 456},
	{2636, 39220, 5, 456},
	{2650, 39224, 5, 456},
	{2665, 39228, 5, 456},
	{2680, 39232, 5, 456},
	{2695, 39236, 5, 456},
	{2710, 39240, 5, 456},
	{2725, 39244, 5, 456},
	{2740, 39248, 5, 456},
	{2755, 39252, 5, 456},
	{2770, 39256, 5, 456},
	{2785, 39260, 5, 456},
	{2800, 39264, 5, 456},
	{2815, 39268, 5, 456},
	{2830, 39272, 5, 456},
	{2845, 39276, 5, 456},
	{2860, 39280, 5, 456},
	{2875, 39284, 5, 456},
	{2890, 39288, 5, 456},
	{2905, 39292, 5, 456},
	{2920, 39296, 5, 456},
	{2935, 39300, 5, 456},
	{2950, 39304, 5, 456},
	{2965, 39308, 5, 456},
	{2980, 39312, 4, 461},
	{2999, 39316, 4, 461},
	{3018, 39320, 4, 461},
	{3037, 39324, 4, 461},
	{3056, 39328, 4, 461},
	{3075, 39332, 4, 461},
	{3094, 39336, 4, 461},
	{3113, 39340, 4, 461},
	{3132, 39344, 4, 461},
	{3151, 39348, 4, 461},
	{3170, 39352, 4, 461},
	{3190, 39356, 4, 461},
	{3210, 39360, 4, 461},
	{3230, 39364, 4, 461},
	{3250, 39368, 4, 461},
	{3270, 39372, 4, 461},
	{3290, 40960},
	{3308, 40964, 4, 465},
	{3326, 40968, 3, 469},
	{3344, 40972, 9, 472},
	{3362, 40976, 2, 481},
	{3380, 40980, 7, 483},
	{3398, 40984, 10, 490},
	{3416, 40988},
	{3434, 45060, 1, 500},
	{3458, 45080, 1, 501},
	{3483, 45084, 3, 502},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 507},
	{3573, 45100, 10, 518},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{4019, 45168, 1, 109},
	{4046, 45172, 1, 109},
	{4073, 45176, 1, 109},
	{4100, 45180, 1, 109},
	{4127, 45184, 1, 109},
	{4154, 45188, 1, 109},
	{4181, 45192, 1, 109},
	{4208, 45196, 1, 109},
	{4235, 45200, 1, 109},
	{4262, 45204, 1, 109},
	{4289, 45208, 1, 109},
	{4316, 45212, 1, 109},
	{4343, 45216, 1, 109},
	{4370, 45220, 1, 109},
	{4397, 45224, 1, 109},
	{4424, 45228, 1, 109},
	{4451, 45248, 8, 528},
	{4474, 45252, 5, 536},
	{4507, 45256, 1, 541},
	{4534, 45260, 1, 541},
	{4561, 45264, 1, 541},
	{4588, 45268, 1, 541},
	{4615, 45316, 1, 500},
	{4639, 45332, 1, 501},
	{4664, 45336, 3, 502},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 543},
	{4779, 45356, 14, 555},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5225, 45424, 1, 109},
	{5252, 45428, 1, 109},
	{5279, 45432, 1, 109},
	{5306, 45436, 1, 109},
	{5333, 45440, 1, 109},
	{5360, 45444, 1, 109},
	{5387, 45448, 1, 109},
	{5414, 45452, 1, 109},
	{5441, 45456, 1, 109},
	{5468, 45460, 1, 109},
	{5495, 45464, 1, 109},
	{5522, 45468, 1, 109},
	{5549, 45472, 1, 109},
	{5576, 45476, 1, 109},
	{5603, 45480, 1, 109},
	{5630, 45484, 1, 109},
	{5657, 45504, 8, 528},
	{5680, 45508, 5, 536},
	{5713, 45512, 1, 541},
	{5740, 45516, 1, 541},
	{5767, 45520, 1, 541},
	{5794, 45524, 1, 541},
	{5821, 45548, 9, 569},
	{5848, 45552, 6, 578},
	{5875, 45556, 5, 584},
	{5902, 45568, 1, 501},
	{5927, 45572, 2, 589},
	{5951, 45576, 1, 505},
	{5983, 45580, 1, 505},
	{6015, 45584, 1, 505},
	{6039, 45588, 1, 506},
	{6063, 45596, 4, 591},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 13, 595},
	{6153, 45612, 9, 608},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{6599, 45680, 1, 109},
	{6626, 45684, 1, 109},
	{6653, 45688, 1, 109},
	{6680, 45692, 1, 109},
	{6707, 45696, 1, 109},
	{6734, 45700, 1, 109},
	{6761, 45704, 1, 109},
	{6788, 45708, 1, 109},
	{6815, 45712, 1, 109},
	{6842, 45716, 1, 109},
	{6869, 45720, 1, 109},
	{6896, 45724, 1, 109},
	{6923, 45728, 1, 109},
	{6950, 45732, 1, 109},
	{6977, 45736, 1, 109},
	{7004, 45740, 1, 109},
	{7031, 45760, 8, 528},
	{7056, 45764, 5, 536},
	{7091, 45768, 1, 541},
	{7120, 45772, 1, 541},
	{7149, 45776, 1, 541},
	{7178, 45780, 1, 541},
	{7207, 45808, 6, 578},
	{7234, 45852, 4, 591},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7300, 45864, 10, 617},
	{7324, 45868, 6, 578},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{7770, 46068, 5, 584},
	{7797, 46080, 1, 501},
	{7822, 46084, 1, 500},
	{7846, 46088, 1, 505},
	{7878, 46092, 1, 505},
	{7910, 46096, 1, 505},
	{7934, 46100, 1, 506},
	{7958, 46108, 4, 627},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 12, 631},
	{8048, 46124, 9, 643},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{8494, 46192, 1, 109},
	{8521, 46196, 1, 109},
	{8548, 46200, 1, 109},
	{8575, 46204, 1, 109},
	{8602, 46208, 1, 109},
	{8629, 46212, 1, 109},
	{8656, 46216, 1, 109},
	{8683, 46220, 1, 109},
	{8710, 46224, 1, 109},
	{8737, 46228, 1, 109},
	{8764, 46232, 1, 109},
	{8791, 46236, 1, 109},
	{8818, 46240, 1, 109},
	{8845, 46244, 1, 109},
	{8872, 46248, 1, 109},
	{8899, 46252, 1, 109},
	{8926, 46272, 8, 528},
	{8951, 46276, 5, 536},
	{8986, 46280, 1, 541},
	{9015, 46284, 1, 541},
	{9044, 46288, 1, 541},
	{9073, 46292, 1, 541},
	{9102, 46324, 5, 584},
	{9129, 46364, 4, 591},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9195, 46376, 9, 652},
	{9219, 46380, 5, 584},
	{9243, 46384, 1, 109},
	{9269, 46388, 1, 109},
	{9295, 46392, 1, 109},
	{9321, 46396, 1, 109},
	{9347, 46400, 1, 109},
	{9373, 46404, 1, 109},
	{9399, 46408, 1, 109},
	{9425, 46412, 1, 109},
	{9451, 46416, 1, 109},
	{9477, 46420, 1, 109},
	{9503, 46424, 1, 109},
	{9530, 46428, 1, 109},
	{9557, 46432, 1, 109},
	{9584, 46436, 1, 109},
	{9611, 46440, 1, 109},
	{9638, 46444, 1, 109},
	{9665, 47104, 13, 661},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 1, 680},
	{9928, 47160, 1, 109},
	{9957, 47164, 1, 680},
	{9986, 47168, 1, 109},
	{10019, 47172, 1, 680},
	{10052, 47176, 12, 681},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 6, 705},
	{10125, 47192, 1, 711},
	{10152, 47196, 1, 711},
	{10179, 47200, 2, 712},
	{10200, 47204, 1, 711},
	{10227, 47208, 1, 711},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 5, 716},
	{10358, 47232, 1, 721},
	{10378, 47236, 1, 722},
	{10401, 47240, 9, 723},
	{10418, 47248, 1, 541},
	{10439, 47252, 1, 541},
	{10460, 47256, 1, 541},
	{10481, 47260, 1, 541},
	{10502, 47264, 1, 732},
	{10520, 47268, 1, 733},
	{10539, 47272, 1, 501},
	{10561, 47276, 3, 734},
	{10578, 47280, 1, 737},
	{10607, 47284, 1, 738},
	{10636, 47288, 3, 734},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{10980, 47604, 2, 739},
	{11004, 47608, 1, 109},
	{11025, 47612, 1, 109},
	{11041, 163840, 10, 741},
	{11059, 163844, 11, 751},
	{11076, 163848, 7, 762},
	{11090, 163852, 23, 769},
	{11109, 163856, 16, 792},
	{11129, 163860, 1, 808},
	{11148, 163868, 2, 809},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{11285, 163896, 3, 819},
	{11301, 163900, 8, 822},
	{11319, 163904, 14, 830},
	{11329, 163908, 9, 844},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{11419, 163928, 2, 853},
	{11437, 163932, 1, 855},
	{11455, 163944, 1, 856},
	{11473, 163948, 1, 856},
	{11497, 163952, 1, 856},
	{11516, 163956, 1, 856},
	{11541, 163960, 1, 856},
	{11563, 163964, 9, 857},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 868},
	{11643, 164332, 1, 868},
	{11664, 164336, 1, 868},
	{11685, 164340, 1, 868},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13602, 164692, 3, 920},
	{13624, 164696, 2, 923},
	{13652, 164700, 7, 925},
	{13681, 164704, 1, 932},
	{13702, 164708, 1, 933},
	{13712, 164712, 1, 934},
	{13720, 164768, 4, 935},
	{13742, 164772, 4, 935},
	{13763, 164776, 4, 939},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13859, 164880, 10, 947},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13941, 164900, 8, 961},
	{13956, 164904, 4, 969},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16462, 165404, 1, 993},
	{16485, 165444, 12, 994},
	{16505, 165448, 12, 994},
	{16525, 165452, 12, 994},
	{16545, 165456, 12, 994},
	{16565, 165460, 12, 994},
	{16585, 165464, 12, 994},
	{16605, 165468, 12, 994},
	{16625, 165472, 12, 994},
	{16645, 165476, 12, 994},
	{16665, 165480, 12, 994},
	{16685, 165484, 12, 994},
	{16706, 165488, 12, 994},
	{16727, 165492, 12, 994},
	{16748, 165496, 12, 994},
	{16769, 165500, 12, 994},
	{16790, 165504, 12, 994},
	{16811, 165508, 12, 994},
	{16832, 165512, 12, 994},
	{16853, 165516, 12, 994},
	{16874, 165520, 12, 994},
	{16895, 165524, 9, 1006},
	{16916, 165528, 9, 1006},
	{16937, 165532, 9, 1006},
	{16958, 165536, 9, 1006},
	{16979, 165540, 9, 1006},
	{17000, 165544, 9, 1006},
	{17021, 165548, 9, 1006},
	{17042, 165552, 9, 1006},
	{17063, 165556, 9, 1006},
	{17084, 165560, 9, 1006},
	{17105, 165564, 9, 1006},
	{17126, 165568, 9, 1006},
	{17147, 165572, 3, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 6, 1041},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17271, 165640, 1, 1054},
	{17293, 165644, 5, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17357, 165716, 8, 1069},
	{17375, 165720, 8, 1077},
	{17396, 165724, 17, 1085},
	{17417, 165728, 6, 1102},
	{17435, 165732, 6, 1102},
	{17453, 165736, 6, 1102},
	{17471, 165740, 6, 1102},
	{17489, 165744, 6, 1102},
	{17507, 165748, 6, 1102},
	{17525, 165752, 6, 1102},
	{17543, 165756, 6, 1102},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 1118},
	{17824, 165864, 1, 1119},
	{17837, 165872, 8, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17893, 165884, 1, 1129},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 4, 1152},
	{17962, 165900, 17, 1156},
	{17980, 165904, 20, 1173},
	{17996, 165908, 16, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 28, 1219},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18138, 165936, 7, 1279},
	{18167, 165940, 2, 1286},
	{18189, 165944, 2, 1288},
	{18204, 165948, 5, 1290},
	{18234, 165952, 5, 1295},
	{18249, 165956, 1, 1300},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 1315},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 1335},
	{18602, 166468, 3, 1350},
	{18621, 166472, 7, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 1389},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 8, 1396},
	{18861, 166528, 1, 1384},
	{18872, 166532, 3, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 1409},
	{18955, 166548, 2, 1412},
	{18982, 166552, 5, 1414},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 6, 1420},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 9, 1429},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19686, 166732, 2, 1454},
	{19705, 166736, 5, 1456},
	{19727, 166740, 19, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 12, 1483},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 3, 1506},
	{20103, 166804, 8, 1509},
	{20122, 166808, 4, 1517},
	{20148, 166812, 3, 1409},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 5, 1537},
	{20240, 166880, 6, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{20955, 166976, 4, 1587},
	{20976, 166980, 12, 1591},
	{20996, 166984, 2, 1603},
	{21016, 166988, 20, 1605},
	{21054, 166992, 2, 1625},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 3, 1632},
	{21185, 167024, 19, 1635},
	{21200, 167028, 8, 1654},
	{21217, 167032, 12, 1662},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21359, 167060, 1, 808},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 3, 1632},
	{21440, 167084, 19, 1635},
	{21455, 167088, 8, 1654},
	{21472, 167092, 12, 1662},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21614, 167120, 1, 808},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 3, 1632},
	{21695, 167144, 19, 1635},
	{21710, 167148, 8, 1654},
	{21727, 167152, 12, 1662},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21869, 167180, 1, 808},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 3, 1632},
	{21950, 167204, 19, 1635},
	{21965, 167208, 8, 1654},
	{21982, 167212, 12, 1662},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22124, 167240, 1, 808},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 3, 1632},
	{22205, 167264, 19, 1635},
	{22220, 167268, 8, 1654},
	{22237, 167272, 12, 1662},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22379, 167300, 1, 808},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 3, 1632},
	{22460, 167324, 19, 1635},
	{22475, 167328, 8, 1654},
	{22492, 167332, 12, 1662},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22634, 167360, 1, 808},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 3, 1632},
	{22715, 167384, 19, 1635},
	{22730, 167388, 8, 1654},
	{22747, 167392, 12, 1662},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22889, 167420, 1, 808},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 3, 1632},
	{22970, 167444, 19, 1635},
	{22985, 167448, 8, 1654},
	{23002, 167452, 12, 1662},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{23144, 167480, 1, 808},
	{23163, 167488, 1, 1677},
	{23182, 167492, 1, 1677},
	{23201, 167496, 1, 1677},
	{23220, 167500, 1, 1677},
	{23239, 167504, 1, 1677},
	{23258, 167508, 1, 1677},
	{23277, 167512, 1, 1677},
	{23296, 167516, 1, 1677},
	{23315, 167520, 1, 1677},
	{23340, 167524, 1, 1677},
	{23365, 167528, 1, 1677},
	{23390, 167532, 1, 1677},
	{23415, 167536, 1, 1677},
	{23440, 167540, 1, 1677},
	{23465, 167544, 1, 1677},
	{23490, 167548, 1, 1677},
	{23515, 167552, 1, 1677},
	{23540, 167556, 1, 1677},
	{23565, 167560, 1, 1677},
	{23590, 167564, 1, 1677},
	{23615, 167568, 1, 1677},
	{23640, 167572, 1, 1677},
	{23665, 167576, 1, 1677},
	{23690, 167580, 1, 1677},
	{23715, 167584, 1, 1677},
	{23738, 167588, 1, 1677},
	{23761, 167592, 1, 1677},
	{23784, 167596, 1, 1677},
	{23807, 167600, 1, 1677},
	{23830, 167604, 1, 1677},
	{23853, 167608, 1, 1677},
	{23876, 167612, 1, 1677},
	{23899, 167616, 3, 1678},
	{23917, 167620, 3, 1678},
	{23935, 167624, 3, 1678},
	{23953, 167628, 3, 1678},
	{23971, 167632, 3, 1678},
	{23989, 167636, 3, 1678},
	{24007, 167640, 3, 1678},
	{24025, 167644, 3, 1678},
	{24043, 167648, 8, 1681},
	{24061, 167652, 8, 1681},
	{24079, 167656, 8, 1681},
	{24097, 167660, 8, 1681},
	{24115, 167664, 8, 1681},
	{24133, 167668, 8, 1681},
	{24151, 167672, 8, 1681},
	{24169, 167676, 8, 1681},
	{24187, 196608, 1, 1689},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 1, 1695},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 1, 1713},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25429, 196808, 1, 1738},
	{25450, 196812, 1, 1738},
	{25473, 196816, 1, 1738},
	{25489, 196852, 1, 1739},
	{25511, 196856, 1, 1739},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{25653, 196896, 1, 1738},
	{25676, 196908, 1, 680},
	{25695, 196912, 1, 109},
	{25713, 196916, 1, 1749},
	{25740, 196920, 1, 1749},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 4, 1760},
	{25987, 196968, 1, 109},
	{26002, 196972, 1, 1749},
	{26026, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 1, 1764},
	{26202, 197032, 2, 1765},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 1, 1769},
	{26274, 197048, 2, 1770},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 1773},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 1773},
	{26392, 197080, 5, 1775},
	{26412, 197084, 7, 1781},
	{26431, 197088, 7, 1781},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 13, 1790},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 2, 1805},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 7, 1811},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 7, 1811},
	{26750, 197160, 7, 1818},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 4, 1829},
	{26834, 197180, 2, 1833},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26880, 197192, 1, 1836},
	{26894, 197196, 1, 1837},
	{26908, 197200, 1, 1838},
	{26930, 197204, 1, 1839},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{27040, 197232, 2, 1843},
	{27062, 197236, 2, 1845},
	{27084, 197240, 2, 1843},
	{27107, 197244, 2, 1845},
	{27130, 197248, 2, 1843},
	{27152, 197252, 2, 1845},
	{27174, 197364, 1, 1847},
	{27195, 197368, 1, 1848},
	{27215, 197372, 1, 1849},
	{27235, 197376, 1, 1848},
	{27252, 197380, 1, 1849},
	{27269, 197384, 1, 1850},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27444, 197424, 1, 1854},
	{27459, 197428, 1, 1855},
	{27474, 197432, 1, 1856},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 1863},
	{27593, 197464, 3, 1867},
	{27615, 197468, 1, 1870},
	{27635, 197472, 1, 1871},
	{27649, 197476, 1, 1872},
	{27663, 197480, 1, 1873},
	{27675, 197484, 1, 1874},
	{27691, 197488, 1, 1871},
	{27708, 197492, 1, 1872},
	{27725, 197496, 1, 1873},
	{27740, 197500, 1, 1874},
	{27759, 197552, 1, 1875},
	{27784, 197556, 1, 1875},
	{27808, 197560, 1, 1876},
	{27828, 197568, 1, 1877},
	{27854, 197572, 1, 1690},
	{27883, 197576, 1, 1877},
	{27908, 197580, 1, 1690},
	{27936, 197584, 1, 1877},
	{27959, 197588, 1, 1690},
	{27985, 197592, 1, 1877},
	{28007, 197596, 1, 1690},
	{28032, 197600, 1, 1877},
	{28051, 197604, 1, 1690},
	{28073, 197608, 1, 1396},
	{28087, 197612, 1, 1877},
	{28104, 197616, 1, 1690},
	{28124, 197620, 8, 1878},
	{28141, 197624, 13, 1886},
	{28158, 197628, 1, 1803},
	{28175, 197632, 1, 1827},
	{28195, 197636, 1, 1804},
	{28212, 197640, 1, 1788},
	{28232, 197644, 2, 1899},
	{28251, 197888, 8, 1901},
	{28272, 197892, 8, 1901},
	{28293, 198656, 6, 1909},
	{28308, 198912, 1, 1915},
	{28331, 198916, 1, 1915},
	{28354, 198920, 1, 1916},
	{28373, 198924, 1, 1396},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{28520, 198948, 1, 944},
	{28536, 198952, 1, 945},
	{28551, 198956, 2, 1412},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{28611, 198968, 1, 1917},
	{28632, 198972, 2, 1918},
	{28657, 198976, 1, 1920},
	{28680, 198980, 1, 1921},
	{28699, 198984, 1, 1920},
	{28715, 198988, 1, 856},
	{28734, 198992, 1, 1920},
	{28754, 198996, 1, 856},
	{28777, 199000, 1, 1920},
	{28795, 199004, 1, 856},
	{28816, 199008, 9, 1922},
	{28841, 199012, 1, 943},
	{28857, 199016, 1, 1931},
	{28878, 199020, 4, 1932},
	{28886, 199024, 1, 109},
	{28900, 199028, 1, 109},
	{28914, 199032, 1, 109},
	{28928, 199036, 3, 1936},
	{28943, 199040, 2, 1939},
	{28955, 199044, 1, 856},
	{28981, 199048, 3, 1941},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29655, 199952, 1, 109},
	{29682, 199956, 1, 109},
	{29709, 199960, 1, 109},
	{29736, 199964, 1, 109},
	{29763, 199968, 7, 1954},
	{29774, 199972, 2, 1961},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 1973},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 10, 1992},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 2007},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{30588, 200960, 1, 2016},
	{30610, 200964, 1, 2016},
	{30634, 200968, 1, 2016},
	{30658, 200972, 1, 2016},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30924, 213040, 1, 109},
	{30947, 213044, 1, 109},
	{30970, 213048, 1, 109},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{31269, 213504, 1, 2017},
	{31288, 213508, 1, 2018},
	{31307, 213512, 1, 2017},
	{31326, 213516, 1, 2018},
	{31345, 213520, 1, 2017},
	{31364, 213524, 1, 2018},
	{31383, 213528, 1, 2017},
	{31402, 213532, 1, 2018},
	{31421, 213536, 1, 2017},
	{31440, 213540, 1, 2018},
	{31459, 213544, 1, 2017},
	{31478, 213548, 1, 2018},
	{31497, 213552, 1, 2017},
	{31516, 213556, 1, 2018},
	{31535, 213560, 1, 2017},
	{31554, 213564, 1, 2018},
	{31573, 213568, 1, 2017},
	{31592, 213572, 1, 2018},
	{31611, 213576, 1, 2017},
	{31630, 213580, 1, 2018},
	{31649, 213584, 1, 2017},
	{31669, 213588, 1, 2018},
	{31689, 213592, 1, 2017},
	{31709, 213596, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2019},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2019},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2019},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2019},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33269, 215424, 1, 2017},
	{33290, 215428, 1, 2018},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{33783, 216576, 1, 2017},
	{33804, 216580, 1, 2018},
	{33825, 216584, 1, 2017},
	{33846, 216588, 1, 2018},
	{33867, 216592, 1, 2017},
	{33888, 216596, 1, 2018},
	{33909, 216600, 1, 2017},
	{33930, 216604, 1, 2018},
	{33951, 216640, 1, 2017},
	{33972, 216644, 1, 2018},
	{33993, 216648, 1, 2017},
	{34014, 216652, 1, 2018},
	{34035, 216656, 1, 2017},
	{34056, 216660, 1, 2018},
	{34077, 216664, 1, 2017},
	{34098, 216668, 1, 2018},
	{34119, 216704, 1, 2017},
	{34140, 216708, 1, 2018},
	{34161, 216712, 1, 2017},
	{34182, 216716, 1, 2018},
	{34203, 216720, 1, 2017},
	{34224, 216724, 1, 2018},
	{34245, 216728, 1, 2017},
	{34266, 216732, 1, 2018},
	{34287, 216832, 1, 2017},
	{34307, 216836, 1, 2018},
	{34327, 216840, 1, 2017},
	{34347, 216844, 1, 2018},
	{34367, 216848, 1, 2017},
	{34387, 216852, 1, 2018},
	{34407, 216856, 1, 2017},
	{34427, 216860, 1, 2018},
	{34447, 216864, 1, 2017},
	{34468, 216868, 1, 2018},
	{34489, 216872, 1, 2017},
	{34510, 216876, 1, 2018},
	{34531, 216880, 1, 2017},
	{34552, 216884, 1, 2018},
	{34573, 216888, 1, 2017},
	{34594, 216892, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{34999, 217856, 1, 2017},
	{35019, 217860, 1, 2018},
	{35039, 217864, 1, 2017},
	{35059, 217868, 1, 2018},
	{35079, 217872, 1, 2017},
	{35099, 217876, 1, 2018},
	{35119, 217880, 1, 2017},
	{35139, 217884, 1, 2018},
	{35159, 217984, 1, 2020},
	{35184, 217988, 2, 2021},
	{35209, 218016, 1, 2020},
	{35235, 218020, 2, 2021},
	{35261, 218080, 1, 2017},
	{35286, 218084, 1, 2017},
	{35311, 218088, 1, 2018},
	{35336, 218092, 1, 2018},
	{35361, 218096, 1, 2017},
	{35387, 218100, 1, 2018},
	{35413, 218224, 1, 2017},
	{35435, 218228, 1, 2018},
	{35457, 218232, 1, 2017},
	{35479, 218236, 1, 2018},
	{35501, 218240, 1, 2017},
	{35521, 218244, 1, 2018},
	{35541, 218248, 1, 2017},
	{35561, 218252, 1, 2018},
	{35581, 218624, 1, 2017},
	{35603, 218628, 1, 2018},
	{35625, 218632, 1, 2017},
	{35647, 218636, 1, 2018},
	{35669, 218640, 1, 2017},
	{35691, 218644, 1, 2018},
	{35713, 218648, 1, 2017},
	{35735, 218652, 1, 2018},
	{35757, 218656, 1, 2017},
	{35779, 218660, 1, 2018},
	{35801, 218664, 1, 2017},
	{35823, 218668, 1, 2018},
	{35845, 218672, 1, 2017},
	{35867, 218676, 1, 2018},
	{35889, 218680, 1, 2017},
	{35911, 218684, 1, 2018},
	{35933, 218880, 1, 2017},
	{35954, 218884, 1, 2018},
	{35975, 218888, 1, 2017},
	{35996, 218892, 1, 2018},
	{36017, 218896, 1, 2017},
	{36038, 218900, 1, 2018},
	{36059, 218904, 1, 2017},
	{36080, 218908, 1, 2018},
	{36101, 219136, 1, 2017},
	{36121, 219140, 1, 2018},
	{36141, 219144, 1, 2017},
	{36161, 219148, 1, 2018},
	{36181, 219152, 1, 2017},
	{36201, 219156, 1, 2018},
	{36221, 219160, 1, 2017},
	{36241, 219164, 1, 2018},
	{36261, 219392, 1, 2017},
	{36281, 219396, 1, 2018},
	{36301, 221184, 5, 2023},
	{36325, 221188, 4, 2028},
	{36350, 221192, 5, 2023},
	{36374, 221196, 5, 2023},
	{36398, 221200, 4, 2028},
	{36423, 221204, 5, 2023},
	{36447, 221208, 4, 2028},
	{36472, 221212, 5, 2023},
	{36496, 221216, 4, 2032},
	{36512, 221220, 5, 2023},
	{36536, 221224, 3, 2036},
	{36570, 221228, 3, 2039},
	{36604, 221232, 3, 2042},
	{36629, 221236, 3, 2045},
	{36654, 221240, 3, 2042},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 20, 2057},
	{36821, 221444, 20, 2057},
	{36846, 221448, 15, 2077},
	{36874, 221452, 15, 2077},
	{36902, 221456, 15, 2077},
	{36930, 221460, 15, 2077},
	{36958, 221492, 8, 2092},
	{36986, 221496, 8, 2092},
	{37014, 221696, 5, 2100},
	{37037, 221700, 4, 2105},
	{37061, 221704, 5, 2100},
	{37084, 221708, 4, 2105},
	{37108, 221712, 5, 2100},
	{37131, 221716, 4, 2105},
	{37155, 221720, 5, 2100},
	{37178, 221724, 4, 2105},
	{37202, 221728, 2, 2109},
	{37225, 221736, 2, 2109},
	{37248, 221744, 2, 2109},
	{37271, 221752, 2, 2109},
	{37294, 221760, 2, 2109},
	{37317, 221768, 2, 2109},
	{37340, 221776, 2, 2109},
	{37364, 221784, 2, 2109},
	{37388, 222208, 5, 2111},
	{37414, 222212, 4, 2116},
	{37441, 222216, 5, 2111},
	{37467, 222220, 4, 2116},
	{37494, 222224, 5, 2111},
	{37520, 222228, 4, 2116},
	{37547, 222232, 5, 2111},
	{37573, 222236, 4, 2116},
	{37600, 222464, 5, 2111},
	{37626, 222468, 4, 2116},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 5, 2111},
	{37859, 222724, 5, 2111},
	{37883, 222728, 5, 2111},
	{37907, 222732, 5, 2111},
	{37931, 222736, 4, 2116},
	{37956, 222740, 4, 2116},
	{37981, 222744, 4, 2116},
	{38006, 222748, 4, 2116},
	{38031, 222752, 1, 2023},
	{38055, 222756, 1, 2023},
	{38079, 222760, 8, 2120},
	{38100, 222976, 4, 2128},
	{38123, 222980, 4, 2128},
	{38146, 222984, 4, 2128},
	{38169, 222988, 4, 2128},
	{38192, 222992, 4, 2128},
	{38215, 222996, 4, 2128},
	{38238, 223000, 4, 2128},
	{38261, 223004, 4, 2128},
	{38284, 223008, 4, 2128},
	{38307, 223012, 4, 2128},
	{38330, 223016, 4, 2128},
	{38354, 223020, 4, 2128},
	{38378, 223024, 4, 2128},
	{38402, 223028, 4, 2128},
	{38426, 223032, 4, 2128},
	{38450, 223036, 4, 2128},
	{38474, 223104, 9, 2132},
	{38494, 223112, 1, 2141},
	{38515, 223232, 5, 2111},
	{38540, 223236, 4, 2116},
	{38566, 223240, 8, 2142},
	{38589, 223488, 3, 2150},
	{38612, 223492, 3, 2150},
	{38635, 223496, 3, 2150},
	{38658, 223500, 3, 2150},
	{38681, 223504, 2, 2153},
	{38705, 223508, 2, 2153},
	{38729, 223744, 5, 2111},
	{38753, 223748, 5, 2111},
	{38777, 223752, 5, 2111},
	{38801, 223756, 5, 2111},
	{38825, 223760, 4, 2116},
	{38850, 224000, 5, 2155},
	{38873, 224004, 4, 2160},
	{38897, 224008, 3, 2164},
	{38920, 224256, 5, 2155},
	{38943, 224260, 4, 2160},
	{38967, 224264, 3, 2164},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{39136, 224768, 5, 2111},
	{39161, 224772, 4, 2105},
	{39187, 224776, 5, 2111},
	{39212, 224780, 4, 2105},
	{39238, 224784, 3, 2167},
	{39263, 224788, 3, 2167},
	{39288, 224832, 5, 2111},
	{39313, 224836, 4, 2105},
	{39339, 224840, 5, 2111},
	{39364, 224844, 4, 2105},
	{39390, 224848, 3, 2167},
	{39415, 224852, 3, 2167},
	{39440, 224896, 5, 2111},
	{39465, 224900, 4, 2105},
	{39491, 224904, 3, 2167},
	{39516, 224908, 3, 2167},
	{39541, 224912, 3, 2167},
	{39566, 225024, 5, 2111},
	{39590, 225028, 4, 2105},
	{39615, 225032, 3, 2167},
	{39639, 225036, 3, 2167},
	{39663, 225040, 3, 2167},
	{39687, 225048, 5, 2111},
	{39712, 225052, 4, 2105},
	{39738, 225056, 3, 2167},
	{39763, 225060, 3, 2167},
	{39788, 225064, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40225, 225812, 1, 2208},
	{40244, 225816, 2, 2209},
	{40270, 225820, 2, 2211},
	{40293, 225824, 1, 2213},
	{40316, 225828, 2, 2214},
	{40343, 225832, 1, 2213},
	{40370, 225836, 2, 2216},
	{40395, 225840, 2, 2218},
	{40423, 225844, 2, 2220},
	{40451, 225848, 2, 2222},
	{40474, 225852, 2, 2224},
	{40497, 225856, 1, 2226},
	{40530, 225860, 2, 2227},
	{40563, 225864, 1, 2229},
	{40595, 225868, 2, 2227},
	{40627, 225872, 2, 2230},
	{40646, 225876, 2, 2232},
	{40673, 225880, 1, 2234},
	{40700, 225884, 2, 2235},
	{40727, 225888, 2, 2237},
	{40754, 225892, 10, 2239},
	{40775, 225896, 8, 2249},
	{40794, 225900, 8, 2257},
	{40813, 225904, 2, 2265},
	{40837, 225908, 2, 2267},
	{40869, 225912, 2, 2269},
	{40899, 225916, 4, 2271},
	{40935, 225920, 3, 2275},
	{40968, 225924, 1, 2278},
	{40986, 225932, 1, 2279},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{41071, 226060, 4, 2283},
	{41097, 226064, 3, 2287},
	{41126, 226068, 1, 109},
	{41155, 226072, 3, 2287},
	{41184, 226076, 1, 109},
	{41213, 226192, 1, 2290},
	{41234, 226196, 1, 2290},
	{41261, 226304, 5, 2182},
	{41285, 226308, 4, 2187},
	{41310, 226312, 2, 2191},
	{41334, 226316, 5, 2182},
	{41358, 226320, 4, 2187},
	{41383, 226324, 2, 2191},
	{41407, 226328, 10, 2291},
	{41429, 226432, 5, 2301},
	{41456, 226436, 5, 2301},
	{41483, 226440, 6, 2306},
	{41515, 226480, 5, 2301},
	{41543, 226484, 5, 2301},
	{41571, 226488, 5, 2301},
	{41599, 226492, 5, 2301},
	{41627, 226496, 5, 2301},
	{41655, 226500, 5, 2301},
	{41683, 226504, 5, 2301},
	{41711, 226508, 5, 2301},
	{41739, 226512, 6, 2306},
	{41772, 226544, 5, 2111},
	{41801, 226548, 5, 2111},
	{41830, 226552, 4, 2116},
	{41860, 226556, 4, 2116},
	{41890, 226560, 8, 2142},
	{41917, 226564, 8, 2142},
	{41944, 226608, 5, 2111},
	{41974, 226612, 4, 2116},
	{42005, 226616, 8, 2142},
	{42033, 226688, 5, 2182},
	{42057, 226692, 4, 2187},
	{42082, 226696, 3, 2312},
	{42106, 226700, 2, 2315},
	{42132, 226704, 2, 2315},
	{42158, 226816, 5, 2111},
	{42184, 226820, 4, 2116},
	{42211, 226824, 5, 2111},
	{42237, 226828, 5, 2111},
	{42263, 226832, 5, 2111},
	{42289, 226836, 1, 2023},
	{42315, 226840, 1, 2023},
	{42341, 226844, 1, 2023},
	{42367, 226848, 1, 2023},
	{42393, 226880, 4, 2116},
	{42420, 226884, 4, 2116},
	{42447, 226888, 4, 2116},
	{42474, 227072, 5, 2111},
	{42499, 227076, 4, 2105},
	{42525, 227080, 3, 2167},
	{42550, 227084, 3, 2167},
	{42575, 227088, 3, 2167},
	{42600, 227200, 5, 2111},
	{42624, 227204, 4, 2105},
	{42649, 227208, 3, 2167},
	{42673, 227212, 3, 2167},
	{42697, 227216, 3, 2167},
	{42721, 227328, 5, 2111},
	{42745, 227332, 4, 2116},
	{42770, 227336, 8, 2142},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 2325},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 7, 2331},
	{42878, 1168, 12, 2338},
	{42893, 1280, 6, 2350},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
	{42920, 1414, 15, 2356},
};

static const struct si_reg gfx103_reg_table[] = {
	{42929, 40, 1, 2371},
	{42944, 44, 1, 2371},
	{958, 1028, 8, 0},
	{971, 1032, 20, 10},
	{986, 1036, 10, 2372},
	{1002, 1040, 12, 40},
	{1023, 1044, 4, 52},
	{1041, 1048, 3, 56},
	{1059, 1052, 8, 2382},
	{1074, 1056, 1, 70},
	{1088, 1060, 1, 71},
	{1102, 1064, 1, 72},
	{1119, 1076, 2, 80},
	{1135, 1080, 1, 82},
	{1530, 1104, 1, 109},
	{1554, 1108, 1, 109},
	{1152, 1116, 5, 83},
	{1167, 1120, 6, 88},
	{1182, 1124, 2, 95},
	{1202, 1128, 1, 97},
	{1221, 1132, 4, 98},
	{1241, 1136, 5, 102},
	{42967, 1140, 1, 2390},
	{1257, 2480, 1, 109},
	{1271, 2484, 1, 109},
	{1285, 2488, 1, 109},
	{1299, 2492, 1, 109},
	{1313, 2496, 1, 109},
	{1327, 2500, 1, 109},
	{1341, 2504, 1, 109},
	{1355, 2508, 1, 109},
	{1369, 2512, 1, 109},
	{1383, 2516, 1, 109},
	{1397, 2520, 1, 109},
	{1412, 2524, 1, 109},
	{1427, 2528, 1, 109},
	{1442, 2532, 1, 109},
	{1457, 2536, 1, 109},
	{1472, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{1602, 32776, 29, 2391},
	{1615, 32784, 20, 2420},
	{1627, 32788, 14, 162},
	{1643, 32792, 14, 162},
	{1659, 32796, 15, 176},
	{1672, 32824, 14, 162},
	{1688, 32828, 14, 162},
	{1704, 33296, 21, 191},
	{1718, 33300, 28, 212},
	{1735, 33304, 15, 240},
	{1756, 33308, 28, 255},
	{1770, 33312, 32, 283},
	{1787, 33316, 13, 315},
	{1808, 33320, 9, 328},
	{1826, 33324, 1, 337},
	{42989, 33328, 1, 2440},
	{1849, 33344, 2, 338},
	{1870, 33348, 1, 340},
	{1890, 33352, 1, 341},
	{1913, 33356, 9, 342},
	{1931, 33436, 1, 351},
	{1954, 36096, 1, 352},
	{1980, 36100, 2, 353},
	{2006, 36104, 1, 352},
	{2032, 36108, 2, 353},
	{2058, 36112, 2, 355},
	{2079, 36116, 4, 357},
	{2100, 36120, 6, 2441},
	{2127, 36124, 20, 2447},
	{2148, 36128, 7, 2467},
	{2171, 36132, 1, 388},
	{2200, 36140, 1, 388},
	{2230, 36144, 1, 388},
	{2262, 36148, 1, 388},
	{2293, 36152, 1, 388},
	{43016, 36156, 3, 2474},
	{2326, 36348, 5, 389},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 11, 2477},
	{2407, 36656, 14, 410},
	{2425, 36660, 4, 424},
	{2443, 36664, 12, 428},
	{2461, 36668, 2, 440},
	{2479, 37168, 9, 2488},
	{2495, 39160, 6, 2497},
	{3290, 40960},
	{3308, 40964, 4, 465},
	{3326, 40968, 3, 469},
	{3344, 40972, 9, 472},
	{3362, 40976, 3, 2503},
	{3380, 40980, 8, 2506},
	{3398, 40984, 11, 2514},
	{3416, 40988},
	{3434, 45060, 1, 500},
	{3458, 45080, 1, 501},
	{3483, 45084, 3, 502},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 12, 2525},
	{3573, 45100, 10, 518},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{4019, 45168, 1, 109},
	{4046, 45172, 1, 109},
	{4073, 45176, 1, 109},
	{4100, 45180, 1, 109},
	{4127, 45184, 1, 109},
	{4154, 45188, 1, 109},
	{4181, 45192, 1, 109},
	{4208, 45196, 1, 109},
	{4235, 45200, 1, 109},
	{4262, 45204, 1, 109},
	{4289, 45208, 1, 109},
	{4316, 45212, 1, 109},
	{4343, 45216, 1, 109},
	{4370, 45220, 1, 109},
	{4397, 45224, 1, 109},
	{4424, 45228, 1, 109},
	{4451, 45248, 8, 528},
	{4507, 45256, 1, 541},
	{4534, 45260, 1, 541},
	{4561, 45264, 1, 541},
	{4588, 45268, 1, 541},
	{4615, 45316, 1, 500},
	{4639, 45332, 1, 501},
	{4664, 45336, 3, 502},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 543},
	{4779, 45356, 14, 555},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5225, 45424, 1, 109},
	{5252, 45428, 1, 109},
	{5279, 45432, 1, 109},
	{5306, 45436, 1, 109},
	{5333, 45440, 1, 109},
	{5360, 45444, 1, 109},
	{5387, 45448, 1, 109},
	{5414, 45452, 1, 109},
	{5441, 45456, 1, 109},
	{5468, 45460, 1, 109},
	{5495, 45464, 1, 109},
	{5522, 45468, 1, 109},
	{5549, 45472, 1, 109},
	{5576, 45476, 1, 109},
	{5603, 45480, 1, 109},
	{5630, 45484, 1, 109},
	{5657, 45504, 8, 528},
	{5713, 45512, 1, 541},
	{5740, 45516, 1, 541},
	{5767, 45520, 1, 541},
	{5794, 45524, 1, 541},
	{5821, 45548, 9, 569},
	{5902, 45568, 1, 501},
	{5927, 45572, 2, 589},
	{5951, 45576, 1, 505},
	{5983, 45580, 1, 505},
	{6015, 45584, 1, 505},
	{6039, 45588, 1, 506},
	{6063, 45596, 4, 591},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 13, 595},
	{6153, 45612, 9, 608},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{6599, 45680, 1, 109},
	{6626, 45684, 1, 109},
	{6653, 45688, 1, 109},
	{6680, 45692, 1, 109},
	{6707, 45696, 1, 109},
	{6734, 45700, 1, 109},
	{6761, 45704, 1, 109},
	{6788, 45708, 1, 109},
	{6815, 45712, 1, 109},
	{6842, 45716, 1, 109},
	{6869, 45720, 1, 109},
	{6896, 45724, 1, 109},
	{6923, 45728, 1, 109},
	{6950, 45732, 1, 109},
	{6977, 45736, 1, 109},
	{7004, 45740, 1, 109},
	{7031, 45760, 8, 528},
	{7091, 45768, 1, 541},
	{7120, 45772, 1, 541},
	{7149, 45776, 1, 541},
	{7178, 45780, 1, 541},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7797, 46080, 1, 501},
	{7822, 46084, 1, 500},
	{7846, 46088, 1, 505},
	{7878, 46092, 1, 505},
	{7910, 46096, 1, 505},
	{7934, 46100, 1, 506},
	{7958, 46108, 4, 627},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 12, 631},
	{8048, 46124, 9, 643},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{8494, 46192, 1, 109},
	{8521, 46196, 1, 109},
	{8548, 46200, 1, 109},
	{8575, 46204, 1, 109},
	{8602, 46208, 1, 109},
	{8629, 46212, 1, 109},
	{8656, 46216, 1, 109},
	{8683, 46220, 1, 109},
	{8710, 46224, 1, 109},
	{8737, 46228, 1, 109},
	{8764, 46232, 1, 109},
	{8791, 46236, 1, 109},
	{8818, 46240, 1, 109},
	{8845, 46244, 1, 109},
	{8872, 46248, 1, 109},
	{8899, 46252, 1, 109},
	{8926, 46272, 8, 528},
	{8986, 46280, 1, 541},
	{9015, 46284, 1, 541},
	{9044, 46288, 1, 541},
	{9073, 46292, 1, 541},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9665, 47104, 13, 661},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 1, 680},
	{9928, 47160, 1, 109},
	{9957, 47164, 1, 680},
	{9986, 47168, 1, 109},
	{10019, 47172, 1, 680},
	{10052, 47176, 12, 681},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 6, 705},
	{10125, 47192, 1, 711},
	{10152, 47196, 1, 711},
	{10179, 47200, 2, 712},
	{10200, 47204, 1, 711},
	{10227, 47208, 1, 711},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 5, 716},
	{10358, 47232, 1, 721},
	{10378, 47236, 1, 722},
	{10401, 47240, 9, 723},
	{10418, 47248, 1, 541},
	{10439, 47252, 1, 541},
	{10460, 47256, 1, 541},
	{10481, 47260, 1, 541},
	{10502, 47264, 1, 732},
	{10520, 47268, 1, 733},
	{10539, 47272, 1, 501},
	{10561, 47276, 3, 734},
	{10578, 47280, 1, 737},
	{10607, 47284, 1, 738},
	{10636, 47288, 3, 734},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{10980, 47604, 2, 739},
	{11004, 47608, 1, 109},
	{11025, 47612, 1, 109},
	{43040, 47616, 1, 109},
	{43057, 47620, 1, 109},
	{11041, 163840, 11, 2537},
	{11059, 163844, 11, 751},
	{11076, 163848, 7, 762},
	{11090, 163852, 23, 769},
	{11109, 163856, 18, 2548},
	{11129, 163860, 1, 808},
	{11148, 163868, 2, 809},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{11285, 163896, 3, 819},
	{11301, 163900, 8, 822},
	{11319, 163904, 14, 830},
	{11329, 163908, 9, 844},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{11419, 163928, 2, 853},
	{11437, 163932, 1, 855},
	{43074, 163940, 3, 2566},
	{11455, 163944, 1, 856},
	{11473, 163948, 1, 856},
	{11497, 163952, 1, 856},
	{11516, 163956, 1, 856},
	{11541, 163960, 1, 856},
	{11563, 163964, 13, 2569},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 868},
	{11643, 164332, 1, 868},
	{11664, 164336, 1, 868},
	{11685, 164340, 1, 868},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13602, 164692, 3, 920},
	{13624, 164696, 2, 923},
	{13652, 164700, 6, 2582},
	{13681, 164704, 1, 932},
	{13702, 164708, 1, 933},
	{13712, 164712, 1, 934},
	{43095, 164716, 1, 109},
	{43117, 164720, 1, 109},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13859, 164880, 14, 2588},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13941, 164900, 8, 961},
	{13956, 164904, 4, 969},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16462, 165404, 1, 993},
	{16485, 165444, 13, 2602},
	{16505, 165448, 13, 2602},
	{16525, 165452, 13, 2602},
	{16545, 165456, 13, 2602},
	{16565, 165460, 13, 2602},
	{16585, 165464, 13, 2602},
	{16605, 165468, 13, 2602},
	{16625, 165472, 13, 2602},
	{16645, 165476, 13, 2602},
	{16665, 165480, 13, 2602},
	{16685, 165484, 13, 2602},
	{16706, 165488, 13, 2602},
	{16727, 165492, 13, 2602},
	{16748, 165496, 13, 2602},
	{16769, 165500, 13, 2602},
	{16790, 165504, 13, 2602},
	{16811, 165508, 13, 2602},
	{16832, 165512, 13, 2602},
	{16853, 165516, 13, 2602},
	{16874, 165520, 13, 2602},
	{16895, 165524, 10, 2615},
	{16916, 165528, 10, 2615},
	{16937, 165532, 10, 2615},
	{16958, 165536, 10, 2615},
	{16979, 165540, 10, 2615},
	{17000, 165544, 10, 2615},
	{17021, 165548, 10, 2615},
	{17042, 165552, 10, 2615},
	{17063, 165556, 10, 2615},
	{17084, 165560, 10, 2615},
	{17105, 165564, 10, 2615},
	{17126, 165568, 10, 2615},
	{17147, 165572, 4, 2625},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 6, 2629},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17271, 165640, 1, 1054},
	{17293, 165644, 5, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{43139, 165712, 8, 2635},
	{17357, 165716, 8, 2643},
	{17375, 165720, 8, 1077},
	{17396, 165724, 17, 1085},
	{17417, 165728, 6, 1102},
	{17435, 165732, 6, 1102},
	{17453, 165736, 6, 1102},
	{17471, 165740, 6, 1102},
	{17489, 165744, 6, 1102},
	{17507, 165748, 6, 1102},
	{17525, 165752, 6, 1102},
	{17543, 165756, 6, 1102},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 1118},
	{17824, 165864, 1, 1119},
	{17837, 165872, 6, 2651},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17893, 165884, 1, 1129},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 5, 2657},
	{17962, 165900, 17, 1156},
	{17980, 165904, 20, 1173},
	{17996, 165908, 16, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 30, 2662},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18138, 165936, 5, 1279},
	{18189, 165944, 3, 2692},
	{18204, 165948, 5, 1290},
	{18234, 165952, 5, 1295},
	{18249, 165956, 1, 1300},
	{43165, 165960, 6, 2695},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 1315},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 1335},
	{18602, 166468, 3, 1350},
	{18621, 166472, 6, 2701},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 1389},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 9, 2707},
	{18861, 166528, 1, 1384},
	{18872, 166532, 3, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 1409},
	{18955, 166548, 2, 1412},
	{18982, 166552, 3, 2716},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 6, 1420},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 10, 2719},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19686, 166732, 2, 1454},
	{19705, 166736, 5, 1456},
	{19727, 166740, 19, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 12, 1483},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 3, 1506},
	{20103, 166804, 8, 1509},
	{20122, 166808, 4, 1517},
	{20148, 166812, 3, 1409},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 5, 1537},
	{20240, 166880, 8, 2729},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{20955, 166976, 4, 1587},
	{20976, 166980, 12, 1591},
	{20996, 166984, 2, 1603},
	{21016, 166988, 20, 1605},
	{21054, 166992, 2, 1625},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 3, 1632},
	{21185, 167024, 19, 2737},
	{21200, 167028, 8, 1654},
	{21217, 167032, 14, 2756},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21359, 167060, 1, 808},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 3, 1632},
	{21440, 167084, 19, 2737},
	{21455, 167088, 8, 1654},
	{21472, 167092, 14, 2756},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21614, 167120, 1, 808},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 3, 1632},
	{21695, 167144, 19, 2737},
	{21710, 167148, 8, 1654},
	{21727, 167152, 14, 2756},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21869, 167180, 1, 808},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 3, 1632},
	{21950, 167204, 19, 2737},
	{21965, 167208, 8, 1654},
	{21982, 167212, 14, 2756},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22124, 167240, 1, 808},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 3, 1632},
	{22205, 167264, 19, 2737},
	{22220, 167268, 8, 1654},
	{22237, 167272, 14, 2756},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22379, 167300, 1, 808},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 3, 1632},
	{22460, 167324, 19, 2737},
	{22475, 167328, 8, 1654},
	{22492, 167332, 14, 2756},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22634, 167360, 1, 808},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 3, 1632},
	{22715, 167384, 19, 2737},
	{22730, 167388, 8, 1654},
	{22747, 167392, 14, 2756},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22889, 167420, 1, 808},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 3, 1632},
	{22970, 167444, 19, 2737},
	{22985, 167448, 8, 1654},
	{23002, 167452, 14, 2756},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{23144, 167480, 1, 808},
	{23163, 167488, 1, 1677},
	{23182, 167492, 1, 1677},
	{23201, 167496, 1, 1677},
	{23220, 167500, 1, 1677},
	{23239, 167504, 1, 1677},
	{23258, 167508, 1, 1677},
	{23277, 167512, 1, 1677},
	{23296, 167516, 1, 1677},
	{23315, 167520, 1, 1677},
	{23340, 167524, 1, 1677},
	{23365, 167528, 1, 1677},
	{23390, 167532, 1, 1677},
	{23415, 167536, 1, 1677},
	{23440, 167540, 1, 1677},
	{23465, 167544, 1, 1677},
	{23490, 167548, 1, 1677},
	{23515, 167552, 1, 1677},
	{23540, 167556, 1, 1677},
	{23565, 167560, 1, 1677},
	{23590, 167564, 1, 1677},
	{23615, 167568, 1, 1677},
	{23640, 167572, 1, 1677},
	{23665, 167576, 1, 1677},
	{23690, 167580, 1, 1677},
	{23715, 167584, 1, 1677},
	{23738, 167588, 1, 1677},
	{23761, 167592, 1, 1677},
	{23784, 167596, 1, 1677},
	{23807, 167600, 1, 1677},
	{23830, 167604, 1, 1677},
	{23853, 167608, 1, 1677},
	{23876, 167612, 1, 1677},
	{23899, 167616, 3, 1678},
	{23917, 167620, 3, 1678},
	{23935, 167624, 3, 1678},
	{23953, 167628, 3, 1678},
	{23971, 167632, 3, 1678},
	{23989, 167636, 3, 1678},
	{24007, 167640, 3, 1678},
	{24025, 167644, 3, 1678},
	{24043, 167648, 9, 2770},
	{24061, 167652, 9, 2770},
	{24079, 167656, 9, 2770},
	{24097, 167660, 9, 2770},
	{24115, 167664, 9, 2770},
	{24133, 167668, 9, 2770},
	{24151, 167672, 9, 2770},
	{24169, 167676, 9, 2770},
	{24187, 196608, 1, 1689},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 1, 1695},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 1, 1713},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25489, 196852, 1, 1739},
	{25511, 196856, 1, 1739},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{43180, 196896, 5, 2779},
	{25676, 196908, 1, 680},
	{25695, 196912, 1, 109},
	{25713, 196916, 1, 1749},
	{25740, 196920, 1, 1749},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 4, 1760},
	{25987, 196968, 1, 109},
	{26002, 196972, 1, 1749},
	{26026, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 1, 1764},
	{26202, 197032, 2, 1765},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 1, 1769},
	{26274, 197048, 2, 1770},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 2784},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 2784},
	{26392, 197080, 5, 1775},
	{26412, 197084, 7, 1781},
	{26431, 197088, 7, 1781},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 13, 1790},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 2, 1805},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 7, 1811},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 7, 1811},
	{26750, 197160, 7, 1818},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 5, 2786},
	{26834, 197180, 2, 338},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26894, 197196, 1, 1837},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{27040, 197232, 2, 1843},
	{27062, 197236, 2, 1845},
	{27084, 197240, 2, 1843},
	{27107, 197244, 2, 1845},
	{27130, 197248, 2, 1843},
	{27152, 197252, 2, 1845},
	{43199, 197256, 1, 109},
	{43221, 197260, 1, 109},
	{43243, 197280, 1, 1753},
	{43265, 197284, 1, 1754},
	{43287, 197288, 1, 1755},
	{43314, 197292, 1, 1756},
	{43341, 197296, 1, 1757},
	{43368, 197300, 1, 1758},
	{27174, 197364, 1, 1847},
	{27195, 197368, 1, 1848},
	{27215, 197372, 1, 1849},
	{27252, 197380, 1, 1849},
	{27269, 197384, 1, 1850},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 1863},
	{27593, 197464, 5, 2791},
	{27615, 197468, 1, 1870},
	{27635, 197472, 1, 1871},
	{27649, 197476, 1, 1872},
	{27663, 197480, 1, 1873},
	{27675, 197484, 1, 1874},
	{27691, 197488, 1, 1871},
	{27708, 197492, 1, 1872},
	{27725, 197496, 1, 1873},
	{27740, 197500, 1, 1874},
	{27759, 197552, 1, 1875},
	{27784, 197556, 1, 1875},
	{27808, 197560, 1, 1876},
	{27828, 197568, 1, 1877},
	{27854, 197572, 1, 1690},
	{27883, 197576, 1, 1877},
	{27908, 197580, 1, 1690},
	{27936, 197584, 1, 1877},
	{27959, 197588, 1, 1690},
	{27985, 197592, 1, 1877},
	{28007, 197596, 1, 1690},
	{28032, 197600, 1, 1877},
	{28051, 197604, 1, 1690},
	{28073, 197608, 1, 1396},
	{28087, 197612, 1, 1877},
	{28104, 197616, 1, 1690},
	{28124, 197620, 8, 1878},
	{28141, 197624, 13, 1886},
	{28158, 197628, 1, 1803},
	{28175, 197632, 1, 1827},
	{28195, 197636, 1, 1804},
	{28212, 197640, 1, 1788},
	{28232, 197644, 2, 1899},
	{28251, 197888, 8, 1901},
	{28272, 197892, 8, 1901},
	{28293, 198656, 6, 1909},
	{28308, 198912, 1, 1915},
	{28331, 198916, 1, 1915},
	{28354, 198920, 1, 1916},
	{28373, 198924, 2, 2796},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{28520, 198948, 1, 944},
	{28536, 198952, 1, 945},
	{28551, 198956, 2, 1412},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{28611, 198968, 1, 1917},
	{28632, 198972, 2, 2798},
	{28657, 198976, 1, 1920},
	{28680, 198980, 1, 1921},
	{28699, 198984, 1, 1920},
	{28715, 198988, 1, 856},
	{28734, 198992, 1, 1920},
	{28754, 198996, 1, 856},
	{28777, 199000, 1, 1920},
	{28795, 199004, 1, 856},
	{28816, 199008, 9, 1922},
	{28841, 199012, 1, 943},
	{28857, 199016, 1, 1931},
	{28878, 199020, 4, 1932},
	{28886, 199024, 1, 109},
	{28900, 199028, 1, 109},
	{28914, 199032, 1, 109},
	{28928, 199036, 3, 1936},
	{28943, 199040, 2, 1939},
	{28955, 199044, 1, 856},
	{28981, 199048, 3, 1941},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29655, 199952, 1, 109},
	{29682, 199956, 1, 109},
	{29709, 199960, 1, 109},
	{29736, 199964, 1, 109},
	{29763, 199968, 5, 2800},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 1973},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 11, 2805},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 2007},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{30588, 200960, 1, 2016},
	{30610, 200964, 1, 2016},
	{30634, 200968, 1, 2016},
	{30658, 200972, 1, 2016},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30924, 213040, 1, 109},
	{30947, 213044, 1, 109},
	{30970, 213048, 1, 109},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{43395, 213648, 1, 2017},
	{43415, 213652, 1, 2018},
	{43435, 213656, 1, 2017},
	{43455, 213660, 1, 2018},
	{43475, 213664, 1, 2017},
	{43495, 213668, 1, 2018},
	{43515, 213672, 1, 2017},
	{43535, 213676, 1, 2018},
	{43555, 213680, 1, 2017},
	{43580, 213684, 1, 2018},
	{43605, 213688, 1, 2017},
	{43630, 213692, 1, 2018},
	{43655, 213696, 1, 2017},
	{43680, 213700, 1, 2018},
	{43705, 213704, 1, 2017},
	{43730, 213708, 1, 2018},
	{43755, 213712, 1, 2017},
	{43778, 213716, 1, 2018},
	{43801, 213720, 1, 2017},
	{43824, 213724, 1, 2018},
	{43847, 213728, 1, 2017},
	{43870, 213732, 1, 2018},
	{43893, 213736, 1, 2017},
	{43916, 213740, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2018},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2018},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2018},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2018},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33269, 215424, 1, 2017},
	{33290, 215428, 1, 2018},
	{43939, 215432, 1, 2020},
	{43959, 215436, 2, 2021},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{33783, 216576, 1, 2017},
	{33804, 216580, 1, 2018},
	{33825, 216584, 1, 2017},
	{33846, 216588, 1, 2018},
	{33867, 216592, 1, 2017},
	{33888, 216596, 1, 2018},
	{33909, 216600, 1, 2017},
	{33930, 216604, 1, 2018},
	{33951, 216640, 1, 2017},
	{33972, 216644, 1, 2018},
	{33993, 216648, 1, 2017},
	{34014, 216652, 1, 2018},
	{34035, 216656, 1, 2017},
	{34056, 216660, 1, 2018},
	{34077, 216664, 1, 2017},
	{34098, 216668, 1, 2018},
	{34119, 216704, 1, 2017},
	{34140, 216708, 1, 2018},
	{34161, 216712, 1, 2017},
	{34182, 216716, 1, 2018},
	{34203, 216720, 1, 2017},
	{34224, 216724, 1, 2018},
	{34245, 216728, 1, 2017},
	{34266, 216732, 1, 2018},
	{34287, 216832, 1, 2017},
	{34307, 216836, 1, 2018},
	{34327, 216840, 1, 2017},
	{34347, 216844, 1, 2018},
	{34367, 216848, 1, 2017},
	{34387, 216852, 1, 2018},
	{34407, 216856, 1, 2017},
	{34427, 216860, 1, 2018},
	{34447, 216864, 1, 2017},
	{34468, 216868, 1, 2018},
	{34489, 216872, 1, 2017},
	{34510, 216876, 1, 2018},
	{34531, 216880, 1, 2017},
	{34552, 216884, 1, 2018},
	{34573, 216888, 1, 2017},
	{34594, 216892, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{34999, 217856, 1, 2017},
	{35019, 217860, 1, 2018},
	{35039, 217864, 1, 2017},
	{35059, 217868, 1, 2018},
	{35079, 217872, 1, 2017},
	{35099, 217876, 1, 2018},
	{35119, 217880, 1, 2017},
	{35139, 217884, 1, 2018},
	{35209, 218016, 1, 2020},
	{35235, 218020, 2, 2021},
	{43979, 218024, 1, 2020},
	{44002, 218028, 2, 2021},
	{35261, 218080, 1, 2017},
	{35286, 218084, 1, 2017},
	{35311, 218088, 1, 2018},
	{35336, 218092, 1, 2018},
	{35413, 218224, 1, 2017},
	{35435, 218228, 1, 2018},
	{35457, 218232, 1, 2017},
	{35479, 218236, 1, 2018},
	{35501, 218240, 1, 2017},
	{35521, 218244, 1, 2018},
	{35541, 218248, 1, 2017},
	{35561, 218252, 1, 2018},
	{35581, 218624, 1, 2017},
	{35603, 218628, 1, 2018},
	{35625, 218632, 1, 2017},
	{35647, 218636, 1, 2018},
	{35669, 218640, 1, 2017},
	{35691, 218644, 1, 2018},
	{35713, 218648, 1, 2017},
	{35735, 218652, 1, 2018},
	{35757, 218656, 1, 2017},
	{35779, 218660, 1, 2018},
	{35801, 218664, 1, 2017},
	{35823, 218668, 1, 2018},
	{35845, 218672, 1, 2017},
	{35867, 218676, 1, 2018},
	{35889, 218680, 1, 2017},
	{35911, 218684, 1, 2018},
	{35933, 218880, 1, 2017},
	{35954, 218884, 1, 2018},
	{35975, 218888, 1, 2017},
	{35996, 218892, 1, 2018},
	{36017, 218896, 1, 2017},
	{36038, 218900, 1, 2018},
	{36059, 218904, 1, 2017},
	{36080, 218908, 1, 2018},
	{36101, 219136, 1, 2017},
	{36121, 219140, 1, 2018},
	{36141, 219144, 1, 2017},
	{36161, 219148, 1, 2018},
	{36181, 219152, 1, 2017},
	{36201, 219156, 1, 2018},
	{36221, 219160, 1, 2017},
	{36241, 219164, 1, 2018},
	{36261, 219392, 1, 2017},
	{36281, 219396, 1, 2018},
	{44025, 219400, 1, 2020},
	{44044, 219404, 2, 2021},
	{44063, 219520, 1, 2020},
	{44092, 219524, 2, 2021},
	{44121, 219528, 1, 2017},
	{44143, 219532, 1, 2018},
	{44165, 219536, 1, 2017},
	{44187, 219540, 1, 2018},
	{44209, 219568, 1, 2020},
	{44238, 219572, 2, 2021},
	{44267, 219576, 1, 2017},
	{44289, 219580, 1, 2018},
	{44311, 219584, 1, 2017},
	{44333, 219588, 1, 2018},
	{44355, 219616, 1, 2020},
	{44384, 219620, 2, 2021},
	{44413, 219624, 1, 2017},
	{44435, 219628, 1, 2018},
	{44457, 219632, 1, 2017},
	{44479, 219636, 1, 2018},
	{44501, 219664, 1, 2020},
	{44530, 219668, 2, 2021},
	{44559, 219672, 1, 2017},
	{44581, 219676, 1, 2018},
	{44603, 219680, 1, 2017},
	{44625, 219684, 1, 2018},
	{36301, 221184, 5, 2023},
	{36325, 221188, 4, 2028},
	{36350, 221192, 5, 2023},
	{36374, 221196, 5, 2023},
	{36398, 221200, 4, 2028},
	{36423, 221204, 5, 2023},
	{36447, 221208, 4, 2028},
	{36472, 221212, 5, 2023},
	{36496, 221216, 4, 2032},
	{36512, 221220, 5, 2023},
	{36536, 221224, 3, 2036},
	{36570, 221228, 3, 2039},
	{36604, 221232, 3, 2042},
	{36629, 221236, 3, 2045},
	{36654, 221240, 3, 2042},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 20, 2057},
	{36821, 221444, 20, 2057},
	{36846, 221448, 15, 2077},
	{36874, 221452, 15, 2077},
	{36902, 221456, 15, 2077},
	{36930, 221460, 15, 2077},
	{36958, 221492, 8, 2092},
	{36986, 221496, 8, 2092},
	{44647, 221840, 5, 2100},
	{44671, 221844, 4, 2105},
	{44696, 221848, 5, 2100},
	{44720, 221852, 4, 2105},
	{44745, 221856, 5, 2100},
	{44769, 221860, 4, 2105},
	{44794, 221864, 5, 2100},
	{44818, 221868, 4, 2105},
	{44843, 221872, 5, 2100},
	{44872, 221876, 4, 2105},
	{44902, 221880, 5, 2100},
	{44931, 221884, 4, 2105},
	{44961, 221888, 5, 2100},
	{44990, 221892, 4, 2105},
	{45020, 221896, 5, 2100},
	{45049, 221900, 4, 2105},
	{45079, 221904, 5, 2100},
	{45106, 221908, 4, 2105},
	{45134, 221912, 5, 2100},
	{45161, 221916, 4, 2105},
	{45189, 221920, 5, 2100},
	{45216, 221924, 4, 2105},
	{45244, 221928, 5, 2100},
	{45271, 221932, 4, 2105},
	{37388, 222208, 5, 2111},
	{37414, 222212, 4, 2116},
	{37441, 222216, 5, 2111},
	{37467, 222220, 4, 2116},
	{37494, 222224, 5, 2111},
	{37520, 222228, 4, 2116},
	{37547, 222232, 5, 2111},
	{37573, 222236, 4, 2116},
	{37600, 222464, 5, 2111},
	{37626, 222468, 4, 2116},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 5, 2111},
	{37859, 222724, 5, 2111},
	{37883, 222728, 5, 2111},
	{37907, 222732, 5, 2111},
	{37931, 222736, 4, 2116},
	{37956, 222740, 4, 2116},
	{37981, 222744, 4, 2116},
	{38006, 222748, 4, 2116},
	{38031, 222752, 1, 2023},
	{38055, 222756, 1, 2023},
	{38079, 222760, 8, 2120},
	{38100, 222976, 3, 2816},
	{38123, 222980, 3, 2816},
	{38146, 222984, 3, 2816},
	{38169, 222988, 3, 2816},
	{38192, 222992, 3, 2816},
	{38215, 222996, 3, 2816},
	{38238, 223000, 3, 2816},
	{38261, 223004, 3, 2816},
	{38284, 223008, 3, 2816},
	{38307, 223012, 3, 2816},
	{38330, 223016, 3, 2816},
	{38354, 223020, 3, 2816},
	{38378, 223024, 3, 2816},
	{38402, 223028, 3, 2816},
	{38426, 223032, 3, 2816},
	{38450, 223036, 3, 2816},
	{38474, 223104, 15, 2819},
	{38494, 223112, 1, 2141},
	{38515, 223232, 5, 2111},
	{38540, 223236, 4, 2116},
	{38566, 223240, 8, 2142},
	{45299, 223244, 5, 2301},
	{45321, 223248, 5, 2301},
	{45343, 223252, 6, 2306},
	{38589, 223488, 5, 2111},
	{38612, 223492, 5, 2111},
	{38635, 223496, 3, 2167},
	{38658, 223500, 3, 2167},
	{38681, 223504, 4, 2116},
	{38705, 223508, 4, 2116},
	{38729, 223744, 5, 2111},
	{38753, 223748, 5, 2111},
	{38777, 223752, 5, 2111},
	{38801, 223756, 5, 2111},
	{38825, 223760, 4, 2116},
	{45370, 223764, 4, 2116},
	{45395, 223768, 4, 2116},
	{45420, 223772, 4, 2116},
	{38850, 224000, 5, 2111},
	{38873, 224004, 4, 2116},
	{38897, 224008, 3, 2167},
	{38920, 224256, 5, 2111},
	{38943, 224260, 4, 2116},
	{38967, 224264, 3, 2167},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{39136, 224768, 5, 2111},
	{39161, 224772, 4, 2105},
	{39187, 224776, 5, 2111},
	{39212, 224780, 4, 2105},
	{39238, 224784, 3, 2167},
	{39263, 224788, 3, 2167},
	{39288, 224832, 5, 2111},
	{39313, 224836, 4, 2105},
	{39339, 224840, 5, 2111},
	{39364, 224844, 4, 2105},
	{39390, 224848, 3, 2167},
	{39415, 224852, 3, 2167},
	{39440, 224896, 5, 2111},
	{39465, 224900, 4, 2105},
	{39491, 224904, 3, 2167},
	{39516, 224908, 3, 2167},
	{39541, 224912, 3, 2167},
	{39566, 225024, 5, 2111},
	{39590, 225028, 4, 2105},
	{39615, 225032, 3, 2167},
	{39639, 225036, 3, 2167},
	{39663, 225040, 3, 2167},
	{39687, 225048, 5, 2111},
	{39712, 225052, 4, 2105},
	{39738, 225056, 3, 2167},
	{39763, 225060, 3, 2167},
	{39788, 225064, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40225, 225812, 1, 2208},
	{40244, 225816, 2, 2209},
	{40270, 225820, 2, 2211},
	{40293, 225824, 1, 2213},
	{40316, 225828, 2, 2214},
	{40343, 225832, 1, 2213},
	{40370, 225836, 2, 2216},
	{40395, 225840, 2, 2218},
	{40423, 225844, 2, 2220},
	{40451, 225848, 2, 2222},
	{40474, 225852, 2, 2224},
	{40497, 225856, 1, 2226},
	{40530, 225860, 2, 2227},
	{40563, 225864, 1, 2229},
	{40595, 225868, 2, 2227},
	{40627, 225872, 2, 2230},
	{40646, 225876, 2, 2232},
	{40673, 225880, 1, 2234},
	{40700, 225884, 2, 2834},
	{40727, 225888, 2, 2237},
	{40754, 225892, 17, 2836},
	{40775, 225896, 9, 2853},
	{40794, 225900, 19, 2862},
	{40813, 225904, 1, 2265},
	{40837, 225908, 1, 2267},
	{40869, 225912, 2, 2269},
	{40899, 225916, 4, 2271},
	{40935, 225920, 3, 2275},
	{40968, 225924, 1, 2278},
	{45445, 225928, 7, 2201},
	{40986, 225932, 1, 2279},
	{45478, 225936, 1, 2881},
	{45505, 225940, 1, 2882},
	{45531, 225944, 4, 2271},
	{45571, 225948, 2, 2883},
	{45605, 225952, 2, 2883},
	{45635, 225956, 2, 2232},
	{45666, 225960, 1, 2234},
	{45697, 225964, 4, 2885},
	{45731, 225968, 3, 2275},
	{45768, 225972, 3, 2889},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{41071, 226060, 4, 2283},
	{41097, 226064, 3, 2287},
	{41126, 226068, 1, 109},
	{41155, 226072, 3, 2287},
	{41184, 226076, 1, 109},
	{41213, 226192, 1, 2290},
	{41261, 226304, 5, 2182},
	{41285, 226308, 4, 2187},
	{41310, 226312, 2, 2191},
	{41334, 226316, 5, 2182},
	{41358, 226320, 4, 2187},
	{41383, 226324, 2, 2191},
	{41407, 226328, 10, 2291},
	{41515, 226480, 5, 2301},
	{41543, 226484, 5, 2301},
	{41571, 226488, 5, 2301},
	{41599, 226492, 5, 2301},
	{41627, 226496, 5, 2301},
	{41655, 226500, 5, 2301},
	{41683, 226504, 5, 2301},
	{41711, 226508, 5, 2301},
	{41739, 226512, 6, 2306},
	{45809, 226516, 5, 2301},
	{45834, 226520, 5, 2301},
	{45859, 226524, 5, 2301},
	{45884, 226528, 5, 2301},
	{45909, 226532, 6, 2306},
	{41772, 226544, 5, 2111},
	{41801, 226548, 5, 2111},
	{41830, 226552, 4, 2116},
	{41860, 226556, 4, 2116},
	{41890, 226560, 8, 2142},
	{41917, 226564, 8, 2142},
	{42033, 226688, 5, 2182},
	{42057, 226692, 4, 2187},
	{42082, 226696, 3, 2312},
	{42106, 226700, 2, 2315},
	{42132, 226704, 2, 2315},
	{42158, 226816, 5, 2111},
	{42184, 226820, 4, 2116},
	{42211, 226824, 5, 2111},
	{42237, 226828, 5, 2111},
	{42263, 226832, 5, 2111},
	{42289, 226836, 1, 2023},
	{42315, 226840, 1, 2023},
	{42341, 226844, 1, 2023},
	{42367, 226848, 1, 2023},
	{42393, 226880, 4, 2116},
	{42420, 226884, 4, 2116},
	{42447, 226888, 4, 2116},
	{42474, 227072, 5, 2111},
	{42499, 227076, 4, 2105},
	{42525, 227080, 3, 2167},
	{42550, 227084, 3, 2167},
	{42575, 227088, 3, 2167},
	{42600, 227200, 5, 2111},
	{42624, 227204, 4, 2105},
	{42649, 227208, 3, 2167},
	{42673, 227212, 3, 2167},
	{42697, 227216, 3, 2167},
	{42721, 227328, 5, 2111},
	{42745, 227332, 4, 2116},
	{42770, 227336, 8, 2142},
	{45939, 227340, 5, 2301},
	{45960, 227344, 5, 2301},
	{45981, 227348, 6, 2306},
	{46007, 227456, 5, 2301},
	{46038, 227460, 5, 2301},
	{46069, 227464, 6, 2306},
	{46105, 227468, 1, 2892},
	{46129, 227472, 5, 2111},
	{46155, 227476, 4, 2116},
	{46182, 227480, 5, 2111},
	{46208, 227484, 4, 2116},
	{46235, 227504, 5, 2301},
	{46266, 227508, 5, 2301},
	{46297, 227512, 6, 2306},
	{46333, 227516, 1, 2892},
	{46357, 227520, 5, 2111},
	{46383, 227524, 4, 2116},
	{46410, 227528, 5, 2111},
	{46436, 227532, 4, 2116},
	{46463, 227552, 5, 2301},
	{46494, 227556, 5, 2301},
	{46525, 227560, 6, 2306},
	{46561, 227564, 1, 2892},
	{46585, 227568, 5, 2111},
	{46611, 227572, 4, 2116},
	{46638, 227576, 5, 2111},
	{46664, 227580, 4, 2116},
	{46691, 227600, 5, 2301},
	{46722, 227604, 5, 2301},
	{46753, 227608, 6, 2306},
	{46789, 227612, 1, 2892},
	{46813, 227616, 5, 2111},
	{46839, 227620, 4, 2116},
	{46866, 227624, 5, 2111},
	{46892, 227628, 4, 2116},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 2325},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 7, 2331},
	{42878, 1168, 12, 2338},
	{42893, 1280, 6, 2350},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
	{42920, 1414, 15, 2356},
};

static const struct si_reg gfx6_reg_table[] = {
	{958, 68, 9, 2893},
	{971, 72, 24, 2902},
	{986, 76, 3, 2926},
	{46919, 80, 11, 2929},
	{1023, 84, 4, 2940},
	{1041, 88, 2, 2944},
	{1059, 92, 4, 2946},
	{1074, 96, 1, 70},
	{1088, 100, 1, 2950},
	{1102, 104, 1, 72},
	{46933, 108, 1, 2951},
	{46950, 112, 13, 2952},
	{46966, 2480, 1, 1877},
	{46981, 2484, 1, 2965},
	{46996, 2488, 1, 1877},
	{47011, 2492, 1, 2965},
	{1257, 2496, 1, 109},
	{1271, 2500, 1, 109},
	{1285, 2504, 1, 109},
	{1299, 2508, 1, 109},
	{1313, 2512, 1, 109},
	{1327, 2516, 1, 109},
	{1341, 2520, 1, 109},
	{1355, 2524, 1, 109},
	{1369, 2528, 1, 109},
	{1383, 2532, 1, 109},
	{1397, 2536, 1, 109},
	{1412, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{47026, 3660, 21, 2966},
	{47039, 3664, 20, 2987},
	{47051, 3668, 16, 3007},
	{47064, 32768, 1, 3023},
	{47074, 32772, 2, 3024},
	{1602, 32776, 17, 3026},
	{47089, 32780, 2, 3043},
	{1615, 32784, 24, 3045},
	{1627, 32788, 11, 3069},
	{1643, 32792, 11, 3069},
	{47103, 32800, 6, 3080},
	{47119, 32804, 1, 3086},
	{47135, 32808, 1, 109},
	{28293, 32812, 6, 3087},
	{47151, 32816, 2, 3093},
	{47171, 32820, 1, 3095},
	{47193, 32848, 6, 3096},
	{47204, 32852, 22, 3102},
	{47224, 32856, 4, 3124},
	{47240, 32864, 2, 3128},
	{36796, 32880, 19, 3130},
	{36821, 32884, 19, 3130},
	{30993, 32888, 1, 2017},
	{31014, 32892, 1, 2018},
	{31035, 32896, 1, 2017},
	{31056, 32900, 1, 2018},
	{36846, 32920, 12, 3149},
	{36874, 32924, 12, 3149},
	{31077, 32936, 1, 2017},
	{31101, 32940, 1, 2018},
	{31125, 32944, 1, 2017},
	{31149, 32948, 1, 2018},
	{47254, 33008, 1, 3161},
	{47140, 33012, 1, 3162},
	{47266, 33020, 1, 109},
	{47279, 33024, 1, 1741},
	{47297, 33028, 1, 1742},
	{47315, 33032, 1, 1743},
	{47333, 33036, 1, 1744},
	{47351, 33040, 1, 1745},
	{47369, 33044, 1, 1746},
	{47387, 33048, 1, 1747},
	{47405, 33052, 1, 1748},
	{47423, 33536, 10, 3163},
	{24187, 33792, 2, 3173},
	{24207, 33796, 1, 1690},
	{24227, 33800, 1, 1691},
	{24247, 33804, 1, 1692},
	{24267, 33808, 1, 1693},
	{24288, 33812, 1, 1694},
	{24309, 33816, 2, 3175},
	{24331, 33820, 1, 3177},
	{24353, 33824, 1, 1697},
	{24383, 33828, 1, 1698},
	{24413, 33832, 1, 1699},
	{24442, 33836, 1, 1700},
	{24471, 33840, 1, 1701},
	{24501, 33844, 1, 1702},
	{24531, 33848, 1, 1703},
	{24560, 33852, 1, 1704},
	{24589, 33856, 1, 1705},
	{24619, 33860, 1, 1706},
	{24649, 33864, 1, 1707},
	{24678, 33868, 1, 1708},
	{24707, 33872, 1, 1709},
	{24737, 33876, 1, 1710},
	{24767, 33880, 1, 1711},
	{24796, 33884, 1, 1712},
	{24825, 33888, 2, 3178},
	{24847, 33892, 1, 3180},
	{24869, 33896, 1, 1715},
	{24892, 33900, 1, 1716},
	{24915, 33904, 1, 1717},
	{24938, 33908, 1, 1718},
	{24961, 33912, 1, 1719},
	{24984, 33916, 1, 1720},
	{25007, 33920, 1, 1721},
	{25031, 33924, 1, 1722},
	{25055, 33928, 1, 1723},
	{25079, 33932, 1, 1724},
	{25103, 33936, 1, 1725},
	{25127, 33940, 1, 1726},
	{25151, 33944, 1, 1727},
	{25175, 33948, 1, 1728},
	{25199, 33952, 1, 1729},
	{25221, 33956, 1, 1730},
	{25243, 33960, 1, 1731},
	{25264, 33964, 1, 1732},
	{25285, 33968, 1, 1733},
	{25309, 33972, 1, 1734},
	{25333, 33976, 1, 1735},
	{25357, 33980, 1, 1735},
	{25381, 33984, 1, 1736},
	{25405, 33988, 1, 1737},
	{25533, 34044, 1, 1740},
	{25549, 34048, 1, 1741},
	{25562, 34052, 1, 1742},
	{25575, 34056, 1, 1743},
	{25588, 34060, 1, 1744},
	{25601, 34064, 1, 1745},
	{25614, 34068, 1, 1746},
	{25627, 34072, 1, 1747},
	{25640, 34076, 1, 1748},
	{25767, 34112, 2, 1750},
	{25780, 34116, 1, 1752},
	{25951, 34144, 1, 1759},
	{25969, 34148, 3, 3181},
	{25987, 34152, 1, 109},
	{26002, 34156, 1, 1749},
	{26026, 34160, 1, 1749},
	{26050, 34164, 1, 1753},
	{26069, 34168, 1, 1754},
	{26088, 34172, 1, 1755},
	{26112, 34176, 1, 1756},
	{26136, 34180, 1, 1757},
	{26160, 34184, 1, 1758},
	{26184, 34212, 2, 3184},
	{26202, 34216, 1, 3186},
	{26220, 34220, 1, 1767},
	{26238, 34224, 1, 1768},
	{26256, 34228, 2, 3187},
	{26274, 34232, 1, 3189},
	{26292, 34236, 1, 1772},
	{26310, 34240, 2, 1773},
	{26329, 34244, 5, 3190},
	{26348, 34256, 1, 1780},
	{26372, 34260, 2, 1773},
	{26392, 34264, 5, 3190},
	{26466, 34284, 1, 1789},
	{26487, 34288, 23, 3195},
	{26501, 34292, 1, 1803},
	{26515, 34296, 1, 1804},
	{26529, 34300, 4, 3218},
	{26545, 34304, 1, 1807},
	{26564, 34308, 1, 3222},
	{26586, 34312, 1, 1809},
	{26605, 34316, 1, 3223},
	{26627, 34320, 9, 3224},
	{26645, 34324, 1, 1807},
	{26665, 34328, 1, 3222},
	{26688, 34332, 1, 1809},
	{26708, 34336, 1, 3223},
	{26731, 34340, 9, 3224},
	{26750, 34344, 5, 3233},
	{26762, 34348, 2, 1825},
	{26796, 34356, 1, 3238},
	{26814, 34360, 5, 2786},
	{26834, 34364, 1, 1833},
	{26851, 34368, 1, 340},
	{26867, 34372, 1, 1835},
	{26880, 34376, 1, 1836},
	{26894, 34380, 1, 1837},
	{26908, 34384, 1, 1838},
	{26930, 34388, 1, 1839},
	{26950, 34392, 1, 1840},
	{26972, 34396, 1, 1841},
	{47446, 34416, 15, 3239},
	{47463, 34420, 18, 3254},
	{47480, 34424, 31, 3272},
	{47497, 34428, 16, 3303},
	{47510, 34432, 24, 3319},
	{47518, 34436, 1, 3343},
	{47536, 34440, 1, 3344},
	{47555, 34444, 3, 3345},
	{47574, 34448, 1, 3348},
	{47592, 34460, 1, 3349},
	{47613, 34512, 2, 3350},
	{47625, 34516, 1, 3352},
	{47637, 34520, 9, 3353},
	{47648, 34528, 4, 3362},
	{47661, 34532, 1, 3366},
	{47678, 34552, 1, 3367},
	{47690, 34556, 1, 3367},
	{47702, 34560, 1, 3367},
	{47714, 34564, 2, 3368},
	{47731, 34568, 2, 3370},
	{27285, 34572, 1, 1851},
	{27304, 34576, 1, 3372},
	{27323, 34580, 1, 1853},
	{27340, 34584, 1, 1854},
	{27358, 34588, 1, 3373},
	{27376, 34592, 1, 1856},
	{27392, 34596, 1, 1857},
	{27410, 34600, 1, 3374},
	{27428, 34604, 1, 1859},
	{27444, 34608, 1, 1854},
	{27459, 34612, 1, 3373},
	{27474, 34616, 1, 1856},
	{27487, 34620, 1, 1857},
	{27502, 34624, 1, 3374},
	{27517, 34628, 1, 1859},
	{27530, 34632, 1, 1860},
	{27544, 34636, 1, 3375},
	{27558, 34640, 1, 1862},
	{47752, 34644, 4, 3376},
	{47771, 34648, 4, 3380},
	{47790, 34652, 3, 3384},
	{47808, 34656, 2, 3387},
	{47828, 34660, 2, 3389},
	{47846, 34664, 2, 3391},
	{47859, 34668, 1, 3393},
	{47872, 34672, 1, 3394},
	{47886, 34676, 1, 3395},
	{47899, 34680, 3, 3396},
	{47912, 34684, 1, 3399},
	{47924, 34688, 2, 3400},
	{47939, 34692, 2, 3402},
	{47955, 34696, 2, 3404},
	{47971, 34700, 1, 3406},
	{47983, 34708, 2, 3407},
	{47995, 34712, 2, 3409},
	{48009, 34716, 1, 3411},
	{48023, 34720, 2, 3412},
	{48041, 34724, 2, 3414},
	{48060, 34728, 2, 3416},
	{48079, 34780, 12, 3418},
	{36496, 34812, 4, 2032},
	{48097, 34944, 5, 3430},
	{48120, 34948, 2, 3435},
	{48143, 34952, 2, 3435},
	{48166, 34956, 2, 3435},
	{48189, 34960, 1, 2017},
	{48208, 34964, 1, 2018},
	{48227, 34968, 1, 2017},
	{48246, 34972, 1, 2018},
	{48265, 34976, 1, 2017},
	{48284, 34980, 1, 2018},
	{48303, 34984, 1, 2017},
	{48322, 34988, 1, 2018},
	{48341, 34992, 1, 3437},
	{48364, 34996, 1, 3438},
	{48388, 35000, 1, 3439},
	{48411, 35004, 1, 3440},
	{48436, 35008, 2, 3441},
	{48456, 35012, 8, 3443},
	{48479, 35016, 1, 1915},
	{48498, 35020, 1, 1915},
	{48517, 35024, 4, 3451},
	{48533, 35028, 1, 3455},
	{48553, 35032, 1, 3456},
	{48569, 35036, 5, 3457},
	{48584, 35040, 2, 3462},
	{48599, 35044, 1, 109},
	{48614, 35048, 2, 3464},
	{48628, 35052, 1, 109},
	{48642, 35056, 10, 3466},
	{48658, 35100, 1, 3476},
	{48684, 35104, 5, 3430},
	{48708, 35108, 5, 3430},
	{48732, 35112, 2, 3435},
	{48756, 35116, 2, 3435},
	{48780, 35120, 1, 2017},
	{48800, 35124, 1, 2018},
	{48820, 35128, 1, 2017},
	{48840, 35132, 1, 2018},
	{48860, 35136, 1, 2017},
	{48880, 35140, 1, 2018},
	{48900, 35144, 1, 2017},
	{48920, 35148, 1, 2018},
	{28354, 35160, 1, 3477},
	{28373, 35164, 1, 3478},
	{28388, 35168, 1, 674},
	{28421, 35172, 1, 674},
	{28454, 35176, 1, 674},
	{28487, 35180, 1, 674},
	{28577, 35184, 1, 1394},
	{28593, 35188, 1, 1407},
	{48940, 35196, 10, 3479},
	{48958, 35200, 2, 3489},
	{48975, 35204, 10, 3491},
	{48992, 35208, 1, 1917},
	{49009, 35212, 3, 3501},
	{49024, 35248, 2, 3504},
	{49045, 35256, 1, 1920},
	{49064, 35260, 4, 3506},
	{49090, 35264, 4, 3506},
	{49118, 35328, 1, 3510},
	{49135, 35332, 1, 109},
	{49152, 35344, 1, 3511},
	{49170, 35348, 9, 3512},
	{49184, 35352, 10, 3521},
	{37388, 35360, 3, 3430},
	{37441, 35364, 3, 3430},
	{37494, 35368, 2, 2164},
	{37547, 35372, 2, 2164},
	{31729, 35376, 1, 2017},
	{31751, 35380, 1, 2019},
	{31773, 35384, 1, 2017},
	{31795, 35388, 1, 2019},
	{31817, 35392, 1, 2017},
	{31839, 35396, 1, 2019},
	{31861, 35400, 1, 2017},
	{31883, 35404, 1, 2019},
	{49201, 35408, 1, 3531},
	{49219, 35412, 1, 3532},
	{28997, 35424, 1, 1944},
	{37600, 35456, 3, 3533},
	{37653, 35460, 1, 2128},
	{37679, 35464, 1, 2128},
	{37705, 35468, 1, 2128},
	{37731, 35472, 1, 2128},
	{37757, 35476, 1, 2128},
	{37783, 35480, 1, 2128},
	{37809, 35484, 1, 2128},
	{31905, 35488, 1, 2017},
	{31927, 35492, 1, 2018},
	{31949, 35496, 1, 2017},
	{31971, 35500, 1, 2018},
	{31993, 35504, 1, 2017},
	{32015, 35508, 1, 2018},
	{32037, 35512, 1, 2017},
	{32059, 35516, 1, 2018},
	{32081, 35520, 1, 2017},
	{32103, 35524, 1, 2018},
	{32125, 35528, 1, 2017},
	{32147, 35532, 1, 2018},
	{32169, 35536, 1, 2017},
	{32191, 35540, 1, 2018},
	{32213, 35544, 1, 2017},
	{32235, 35548, 1, 2018},
	{29022, 35600, 2, 1945},
	{49241, 35620, 2, 3536},
	{49266, 35624, 10, 3538},
	{49283, 35788, 4, 3548},
	{49299, 35796, 4, 3552},
	{49318, 35800, 1, 3556},
	{49335, 35804, 1, 109},
	{49352, 35824, 26, 3557},
	{49366, 35840, 9, 3583},
	{49376, 35844, 9, 3592},
	{29763, 35848, 3, 3601},
	{49387, 35852, 3, 3604},
	{49406, 35856, 6, 3607},
	{49421, 35860, 4, 3613},
	{38474, 35864, 9, 3617},
	{49435, 35868, 4, 3626},
	{49455, 35872, 4, 3626},
	{49477, 35876, 4, 3630},
	{32497, 35968, 1, 2017},
	{32516, 35972, 1, 2018},
	{32535, 35976, 1, 2017},
	{32554, 35980, 1, 2018},
	{32573, 35984, 1, 2017},
	{32592, 35988, 1, 2018},
	{32611, 35992, 1, 2017},
	{32630, 35996, 1, 2018},
	{32649, 36000, 1, 2017},
	{32668, 36004, 1, 2018},
	{32687, 36008, 1, 2017},
	{32706, 36012, 1, 2018},
	{32725, 36016, 1, 2017},
	{32744, 36020, 1, 2018},
	{32763, 36024, 1, 2017},
	{32782, 36028, 1, 2018},
	{32801, 36032, 1, 2017},
	{32820, 36036, 1, 2018},
	{32839, 36040, 1, 2017},
	{32858, 36044, 1, 2018},
	{32877, 36048, 1, 2017},
	{32897, 36052, 1, 2018},
	{32917, 36056, 1, 2017},
	{32937, 36060, 1, 2018},
	{32957, 36064, 1, 2017},
	{32977, 36068, 1, 2018},
	{32997, 36072, 1, 2017},
	{33017, 36076, 1, 2018},
	{33037, 36080, 1, 2017},
	{33057, 36084, 1, 2018},
	{33077, 36088, 1, 2017},
	{33097, 36092, 1, 2018},
	{38100, 36096, 6, 3634},
	{38123, 36100, 6, 3634},
	{38146, 36104, 6, 3634},
	{38169, 36108, 6, 3634},
	{38192, 36112, 6, 3634},
	{38215, 36116, 6, 3634},
	{38238, 36120, 6, 3634},
	{38261, 36124, 6, 3634},
	{38284, 36128, 6, 3634},
	{38307, 36132, 6, 3634},
	{38330, 36136, 6, 3634},
	{38354, 36140, 6, 3634},
	{38378, 36144, 6, 3634},
	{38402, 36148, 6, 3634},
	{38426, 36152, 6, 3634},
	{38450, 36156, 6, 3634},
	{49497, 36224, 2, 3640},
	{49513, 36228, 2, 3640},
	{49529, 36232, 4, 3642},
	{49546, 36236, 4, 3642},
	{49564, 36320, 8, 3646},
	{49577, 36324, 1, 109},
	{49589, 36336, 1, 3654},
	{49600, 36340, 1, 3654},
	{49611, 36352, 1, 737},
	{49632, 36356, 1, 3655},
	{2079, 36360, 8, 3656},
	{2100, 36364, 3, 3664},
	{49653, 36368, 2, 3667},
	{29547, 36384, 1, 109},
	{29574, 36388, 1, 109},
	{29601, 36392, 1, 109},
	{29628, 36396, 1, 109},
	{2058, 36400, 2, 3669},
	{2148, 36404, 5, 3671},
	{49679, 36408, 15, 3676},
	{2127, 36412, 1, 3691},
	{49700, 36416, 1, 388},
	{49721, 36424, 1, 3692},
	{49745, 36440, 3, 3693},
	{49763, 36444, 4, 3696},
	{49782, 36448, 3, 3700},
	{49797, 36452, 1, 109},
	{49819, 36456, 1, 109},
	{49841, 36460, 1, 109},
	{49863, 36464, 1, 109},
	{49885, 36480, 4, 3703},
	{49900, 36484, 3, 3707},
	{49911, 36488, 3, 3710},
	{49922, 36492, 4, 3713},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 14, 3717},
	{3290, 36624, 1, 394},
	{3308, 36628, 5, 3731},
	{3326, 36632, 4, 3736},
	{3344, 36636, 11, 3740},
	{3362, 36640, 2, 3751},
	{3380, 36644, 2, 3753},
	{3398, 36648, 4, 3755},
	{3416, 36652, 1, 3759},
	{2407, 36656, 13, 3760},
	{2425, 36660, 4, 424},
	{2443, 36664, 9, 3773},
	{2461, 36668, 3, 3782},
	{2479, 37120, 6, 442},
	{29788, 38156, 1, 866},
	{2495, 39160, 9, 3785},
	{2510, 39184, 6, 3794},
	{2524, 39188, 5, 3795},
	{2538, 39192, 5, 3795},
	{2552, 39196, 5, 3795},
	{2566, 39200, 5, 3795},
	{2580, 39204, 5, 3795},
	{2594, 39208, 5, 3795},
	{2608, 39212, 5, 3795},
	{2622, 39216, 5, 3795},
	{2636, 39220, 5, 3795},
	{2650, 39224, 5, 3795},
	{2665, 39228, 5, 3795},
	{2680, 39232, 5, 3795},
	{2695, 39236, 5, 3795},
	{2710, 39240, 5, 3795},
	{2725, 39244, 5, 3795},
	{2740, 39248, 5, 3795},
	{2755, 39252, 5, 3795},
	{2770, 39256, 5, 3795},
	{2785, 39260, 5, 3795},
	{2800, 39264, 5, 3795},
	{2815, 39268, 5, 3795},
	{2830, 39272, 5, 3795},
	{2845, 39276, 5, 3795},
	{2860, 39280, 5, 3795},
	{2875, 39284, 5, 3795},
	{2890, 39288, 5, 3795},
	{2905, 39292, 5, 3795},
	{2920, 39296, 5, 3795},
	{2935, 39300, 5, 3795},
	{2950, 39304, 5, 3795},
	{2965, 39308, 5, 3795},
	{49934, 45056, 1, 505},
	{49955, 45060, 1, 506},
	{49976, 45064, 1, 505},
	{49997, 45068, 1, 506},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 3800},
	{3573, 45100, 6, 3811},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{50018, 45312, 1, 505},
	{50039, 45316, 1, 506},
	{50060, 45320, 1, 505},
	{50081, 45324, 1, 506},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 3817},
	{4779, 45356, 10, 3829},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{50102, 45568, 1, 505},
	{50123, 45572, 1, 506},
	{50144, 45576, 1, 505},
	{50165, 45580, 1, 506},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 11, 3839},
	{6153, 45612, 4, 3850},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{50186, 45824, 1, 505},
	{50207, 45828, 1, 506},
	{50228, 45832, 1, 505},
	{50249, 45836, 1, 506},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7300, 45864, 12, 3817},
	{7324, 45868, 6, 3854},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{50270, 46080, 1, 505},
	{50291, 46084, 1, 506},
	{50312, 46088, 1, 505},
	{50333, 46092, 1, 506},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 10, 3860},
	{8048, 46124, 6, 3870},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{50354, 46336, 1, 505},
	{50375, 46340, 1, 506},
	{50396, 46344, 1, 505},
	{50417, 46348, 1, 506},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9195, 46376, 11, 3876},
	{9219, 46380, 5, 3887},
	{9243, 46384, 1, 109},
	{9269, 46388, 1, 109},
	{9295, 46392, 1, 109},
	{9321, 46396, 1, 109},
	{9347, 46400, 1, 109},
	{9373, 46404, 1, 109},
	{9399, 46408, 1, 109},
	{9425, 46412, 1, 109},
	{9451, 46416, 1, 109},
	{9477, 46420, 1, 109},
	{9503, 46424, 1, 109},
	{9530, 46428, 1, 109},
	{9557, 46432, 1, 109},
	{9584, 46436, 1, 109},
	{9611, 46440, 1, 109},
	{9638, 46444, 1, 109},
	{9665, 47104, 12, 3892},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{50438, 47148, 1, 3904},
	{9898, 47152, 1, 109},
	{9913, 47156, 2, 3905},
	{50458, 47160, 1, 109},
	{50473, 47164, 1, 680},
	{50488, 47168, 1, 109},
	{50503, 47172, 1, 680},
	{10052, 47176, 10, 3907},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 7, 3917},
	{50518, 47192, 2, 3924},
	{50549, 47196, 2, 3924},
	{10179, 47200, 2, 712},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{50580, 53300, 29, 3926},
	{50597, 55348, 29, 3926},
	{11041, 163840, 9, 741},
	{11059, 163844, 9, 3955},
	{11076, 163848, 4, 3964},
	{11090, 163852, 23, 769},
	{11109, 163856, 15, 792},
	{11129, 163860, 1, 808},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{50614, 163900, 7, 3968},
	{11319, 163904, 8, 3975},
	{11329, 163908, 5, 3983},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{50628, 163928, 2, 3988},
	{50642, 163932, 1, 3990},
	{11587, 163968, 1, 866},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13681, 164704, 1, 932},
	{50657, 164708, 1, 3991},
	{13712, 164712, 1, 934},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16485, 165444, 6, 994},
	{16505, 165448, 6, 994},
	{16525, 165452, 6, 994},
	{16545, 165456, 6, 994},
	{16565, 165460, 6, 994},
	{16585, 165464, 6, 994},
	{16605, 165468, 6, 994},
	{16625, 165472, 6, 994},
	{16645, 165476, 6, 994},
	{16665, 165480, 6, 994},
	{16685, 165484, 6, 994},
	{16706, 165488, 6, 994},
	{16727, 165492, 6, 994},
	{16748, 165496, 6, 994},
	{16769, 165500, 6, 994},
	{16790, 165504, 6, 994},
	{16811, 165508, 6, 994},
	{16832, 165512, 6, 994},
	{16853, 165516, 6, 994},
	{16874, 165520, 6, 994},
	{16895, 165524, 4, 1006},
	{16916, 165528, 4, 1006},
	{16937, 165532, 4, 1006},
	{16958, 165536, 4, 1006},
	{16979, 165540, 4, 1006},
	{17000, 165544, 4, 1006},
	{17021, 165548, 4, 1006},
	{17042, 165552, 4, 1006},
	{17063, 165556, 4, 1006},
	{17084, 165560, 4, 1006},
	{17105, 165564, 4, 1006},
	{17126, 165568, 4, 1006},
	{17147, 165572, 2, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 3, 3992},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17293, 165644, 4, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 3995},
	{17824, 165864, 1, 1119},
	{17837, 165872, 5, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 3, 3996},
	{17962, 165900, 12, 1156},
	{17980, 165904, 19, 1173},
	{17996, 165908, 13, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 26, 1219},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 3999},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 1335},
	{18621, 166472, 4, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 4003},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 7, 4008},
	{18872, 166532, 2, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 4015},
	{18955, 166548, 1, 1412},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 6, 1420},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 7, 4018},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19727, 166740, 6, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 8, 4025},
	{19868, 166768, 6, 1495},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 2, 1506},
	{20103, 166804, 7, 4033},
	{20122, 166808, 4, 1517},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 4, 1537},
	{20240, 166880, 5, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 2, 3964},
	{21185, 167024, 15, 4040},
	{21200, 167028, 6, 1654},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 2, 3964},
	{21440, 167084, 15, 4040},
	{21455, 167088, 6, 1654},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 2, 3964},
	{21695, 167144, 15, 4040},
	{21710, 167148, 6, 1654},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 2, 3964},
	{21950, 167204, 15, 4040},
	{21965, 167208, 6, 1654},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 2, 3964},
	{22205, 167264, 15, 4040},
	{22220, 167268, 6, 1654},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 2, 3964},
	{22460, 167324, 15, 4040},
	{22475, 167328, 6, 1654},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 2, 3964},
	{22715, 167384, 15, 4040},
	{22730, 167388, 6, 1654},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 2, 3964},
	{22970, 167444, 15, 4040},
	{22985, 167448, 6, 1654},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{195, 880, 4, 4055},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 4059},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 9, 4064},
	{42893, 1280, 4, 4073},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
};

static const struct si_reg gfx7_reg_table[] = {
	{958, 68, 9, 4077},
	{971, 72, 24, 2902},
	{986, 76, 3, 4086},
	{46919, 80, 11, 4089},
	{1023, 84, 4, 2940},
	{1041, 88, 2, 2944},
	{1059, 92, 4, 4100},
	{1074, 96, 1, 70},
	{1088, 100, 1, 2950},
	{1102, 104, 1, 72},
	{46933, 108, 1, 2951},
	{46950, 112, 13, 2952},
	{46966, 2480, 1, 1877},
	{46981, 2484, 1, 2965},
	{46996, 2488, 1, 1877},
	{47011, 2492, 1, 2965},
	{1257, 2496, 1, 109},
	{1271, 2500, 1, 109},
	{1285, 2504, 1, 109},
	{1299, 2508, 1, 109},
	{1313, 2512, 1, 109},
	{1327, 2516, 1, 109},
	{1341, 2520, 1, 109},
	{1355, 2524, 1, 109},
	{1369, 2528, 1, 109},
	{1383, 2532, 1, 109},
	{1397, 2536, 1, 109},
	{1412, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{47026, 3660, 21, 2966},
	{47039, 3664, 20, 2987},
	{47051, 3668, 16, 3007},
	{1602, 32776, 17, 4104},
	{1615, 32784, 24, 3045},
	{1627, 32788, 11, 3069},
	{1643, 32792, 11, 3069},
	{1672, 32824, 11, 3069},
	{1688, 32828, 11, 3069},
	{1704, 33296, 16, 4121},
	{1718, 33300, 28, 212},
	{1735, 33304, 17, 4137},
	{1756, 33308, 18, 4154},
	{1770, 33312, 31, 4172},
	{1787, 33316, 7, 4203},
	{50667, 33320, 1, 3349},
	{1826, 33324, 1, 337},
	{1849, 33344, 1, 1833},
	{1870, 33348, 1, 340},
	{1931, 33436, 1, 351},
	{49611, 36352, 1, 737},
	{49632, 36356, 1, 3655},
	{2079, 36360, 9, 4210},
	{2100, 36364, 3, 3664},
	{49653, 36368, 2, 3667},
	{50682, 36372, 2, 4219},
	{50704, 36376, 1, 4221},
	{2058, 36400, 2, 3669},
	{2148, 36404, 5, 4222},
	{49679, 36408, 15, 3676},
	{2127, 36412, 1, 3691},
	{49700, 36416, 1, 388},
	{49721, 36424, 1, 3692},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 14, 3717},
	{3290, 36624, 1, 394},
	{3308, 36628, 5, 3731},
	{3326, 36632, 4, 3736},
	{3344, 36636, 11, 3740},
	{3362, 36640, 2, 3751},
	{3380, 36644, 2, 3753},
	{3398, 36648, 4, 3755},
	{3416, 36652, 1, 3759},
	{2407, 36656, 13, 3760},
	{2425, 36660, 4, 424},
	{2443, 36664, 9, 3773},
	{2461, 36668, 3, 3782},
	{2479, 37120, 6, 442},
	{2495, 39160, 9, 3785},
	{2510, 39184, 5, 3795},
	{2524, 39188, 5, 3795},
	{2538, 39192, 5, 3795},
	{2552, 39196, 5, 3795},
	{2566, 39200, 5, 3795},
	{2580, 39204, 5, 3795},
	{2594, 39208, 5, 3795},
	{2608, 39212, 5, 3795},
	{2622, 39216, 5, 3795},
	{2636, 39220, 5, 3795},
	{2650, 39224, 5, 3795},
	{2665, 39228, 5, 3795},
	{2680, 39232, 5, 3795},
	{2695, 39236, 5, 3795},
	{2710, 39240, 5, 3795},
	{2725, 39244, 5, 3795},
	{2740, 39248, 5, 3795},
	{2755, 39252, 5, 3795},
	{2770, 39256, 5, 3795},
	{2785, 39260, 5, 3795},
	{2800, 39264, 5, 3795},
	{2815, 39268, 5, 3795},
	{2830, 39272, 5, 3795},
	{2845, 39276, 5, 3795},
	{2860, 39280, 5, 3795},
	{2875, 39284, 5, 3795},
	{2890, 39288, 5, 3795},
	{2905, 39292, 5, 3795},
	{2920, 39296, 5, 3795},
	{2935, 39300, 5, 3795},
	{2950, 39304, 5, 3795},
	{2965, 39308, 5, 3795},
	{2980, 39312, 4, 461},
	{2999, 39316, 4, 461},
	{3018, 39320, 4, 461},
	{3037, 39324, 4, 461},
	{3056, 39328, 4, 461},
	{3075, 39332, 4, 461},
	{3094, 39336, 4, 461},
	{3113, 39340, 4, 461},
	{3132, 39344, 4, 461},
	{3151, 39348, 4, 461},
	{3170, 39352, 4, 461},
	{3190, 39356, 4, 461},
	{3210, 39360, 4, 461},
	{3230, 39364, 4, 461},
	{3250, 39368, 4, 461},
	{3270, 39372, 4, 461},
	{49934, 45056, 1, 505},
	{49955, 45060, 1, 506},
	{49976, 45064, 1, 505},
	{49997, 45068, 1, 506},
	{3483, 45084, 3, 502},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 3800},
	{3573, 45100, 6, 518},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{50018, 45312, 1, 505},
	{50039, 45316, 1, 506},
	{50060, 45320, 1, 505},
	{50081, 45324, 1, 506},
	{4664, 45336, 3, 502},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 3817},
	{4779, 45356, 10, 555},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5848, 45552, 6, 578},
	{5875, 45556, 5, 584},
	{50102, 45568, 1, 505},
	{50123, 45572, 1, 506},
	{50144, 45576, 1, 505},
	{50165, 45580, 1, 506},
	{6063, 45596, 3, 502},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 11, 3839},
	{6153, 45612, 4, 569},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{7207, 45808, 6, 578},
	{50186, 45824, 1, 505},
	{50207, 45828, 1, 506},
	{50228, 45832, 1, 505},
	{50249, 45836, 1, 506},
	{7234, 45852, 3, 502},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7300, 45864, 12, 3817},
	{7324, 45868, 6, 578},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{7770, 46068, 5, 584},
	{50270, 46080, 1, 505},
	{50291, 46084, 1, 506},
	{50312, 46088, 1, 505},
	{50333, 46092, 1, 506},
	{7958, 46108, 2, 627},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 10, 3860},
	{8048, 46124, 6, 643},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{9102, 46324, 5, 584},
	{50354, 46336, 1, 505},
	{50375, 46340, 1, 506},
	{50396, 46344, 1, 505},
	{50417, 46348, 1, 506},
	{9129, 46364, 3, 502},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9195, 46376, 11, 3876},
	{9219, 46380, 5, 584},
	{9243, 46384, 1, 109},
	{9269, 46388, 1, 109},
	{9295, 46392, 1, 109},
	{9321, 46396, 1, 109},
	{9347, 46400, 1, 109},
	{9373, 46404, 1, 109},
	{9399, 46408, 1, 109},
	{9425, 46412, 1, 109},
	{9451, 46416, 1, 109},
	{9477, 46420, 1, 109},
	{9503, 46424, 1, 109},
	{9530, 46428, 1, 109},
	{9557, 46432, 1, 109},
	{9584, 46436, 1, 109},
	{9611, 46440, 1, 109},
	{9638, 46444, 1, 109},
	{9665, 47104, 12, 3892},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 2, 3905},
	{50458, 47160, 1, 109},
	{50473, 47164, 1, 680},
	{50488, 47168, 1, 109},
	{50503, 47172, 1, 680},
	{10052, 47176, 10, 3907},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 6, 705},
	{50518, 47192, 2, 3924},
	{50549, 47196, 2, 3924},
	{10179, 47200, 2, 712},
	{50732, 47204, 2, 3924},
	{50763, 47208, 2, 3924},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 4, 716},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{50580, 53300, 29, 3926},
	{50597, 55348, 29, 3926},
	{11041, 163840, 9, 741},
	{11059, 163844, 9, 3955},
	{11076, 163848, 4, 3964},
	{11090, 163852, 23, 769},
	{11109, 163856, 15, 792},
	{11129, 163860, 1, 808},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{50614, 163900, 7, 3968},
	{11319, 163904, 8, 3975},
	{11329, 163908, 5, 3983},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{50628, 163928, 2, 3988},
	{50642, 163932, 1, 3990},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 4227},
	{11643, 164332, 1, 4227},
	{11664, 164336, 1, 4227},
	{11685, 164340, 1, 4227},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13602, 164692, 3, 920},
	{13624, 164696, 2, 923},
	{13681, 164704, 1, 932},
	{50657, 164708, 1, 3991},
	{13712, 164712, 1, 934},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16485, 165444, 6, 994},
	{16505, 165448, 6, 994},
	{16525, 165452, 6, 994},
	{16545, 165456, 6, 994},
	{16565, 165460, 6, 994},
	{16585, 165464, 6, 994},
	{16605, 165468, 6, 994},
	{16625, 165472, 6, 994},
	{16645, 165476, 6, 994},
	{16665, 165480, 6, 994},
	{16685, 165484, 6, 994},
	{16706, 165488, 6, 994},
	{16727, 165492, 6, 994},
	{16748, 165496, 6, 994},
	{16769, 165500, 6, 994},
	{16790, 165504, 6, 994},
	{16811, 165508, 6, 994},
	{16832, 165512, 6, 994},
	{16853, 165516, 6, 994},
	{16874, 165520, 6, 994},
	{16895, 165524, 4, 1006},
	{16916, 165528, 4, 1006},
	{16937, 165532, 4, 1006},
	{16958, 165536, 4, 1006},
	{16979, 165540, 4, 1006},
	{17000, 165544, 4, 1006},
	{17021, 165548, 4, 1006},
	{17042, 165552, 4, 1006},
	{17063, 165556, 4, 1006},
	{17084, 165560, 4, 1006},
	{17105, 165564, 4, 1006},
	{17126, 165568, 4, 1006},
	{17147, 165572, 2, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 3, 3992},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17293, 165644, 4, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 3995},
	{17824, 165864, 1, 1119},
	{17837, 165872, 5, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 3, 3996},
	{17962, 165900, 12, 1156},
	{17980, 165904, 19, 1173},
	{17996, 165908, 13, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 26, 1219},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 3999},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 1335},
	{18602, 166468, 2, 1350},
	{18621, 166472, 4, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 4003},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 7, 4008},
	{18861, 166528, 1, 1384},
	{18872, 166532, 2, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 4015},
	{18955, 166548, 1, 1412},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 6, 1420},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 7, 4018},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19727, 166740, 6, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 8, 4025},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 2, 1506},
	{20103, 166804, 7, 4033},
	{20122, 166808, 4, 1517},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 4, 1537},
	{20240, 166880, 5, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 2, 3964},
	{21185, 167024, 15, 4040},
	{21200, 167028, 6, 1654},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 2, 3964},
	{21440, 167084, 15, 4040},
	{21455, 167088, 6, 1654},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 2, 3964},
	{21695, 167144, 15, 4040},
	{21710, 167148, 6, 1654},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 2, 3964},
	{21950, 167204, 15, 4040},
	{21965, 167208, 6, 1654},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 2, 3964},
	{22205, 167264, 15, 4040},
	{22220, 167268, 6, 1654},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 2, 3964},
	{22460, 167324, 15, 4040},
	{22475, 167328, 6, 1654},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 2, 3964},
	{22715, 167384, 15, 4040},
	{22730, 167388, 6, 1654},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 2, 3964},
	{22970, 167444, 15, 4040},
	{22985, 167448, 6, 1654},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{24187, 196608, 2, 3173},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 2, 3175},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 2, 3178},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 3, 4228},
	{25987, 196968, 1, 109},
	{26002, 196972, 1, 1749},
	{26026, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 2, 3184},
	{26202, 197032, 1, 1765},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 2, 3187},
	{26274, 197048, 1, 1770},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 1773},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 1773},
	{26392, 197080, 5, 1775},
	{26412, 197084, 8, 4231},
	{26431, 197088, 8, 4231},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 23, 3195},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 4, 3218},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 9, 3224},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 9, 3224},
	{26750, 197160, 5, 3233},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 5, 2786},
	{26834, 197180, 1, 1833},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26880, 197192, 1, 1836},
	{26894, 197196, 1, 1837},
	{26908, 197200, 1, 1838},
	{26930, 197204, 1, 1839},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27444, 197424, 1, 1854},
	{27459, 197428, 1, 1855},
	{27474, 197432, 1, 1856},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 4239},
	{27593, 197464, 4, 4243},
	{28293, 198656, 6, 3087},
	{48479, 198912, 1, 1915},
	{48498, 198916, 1, 1915},
	{28354, 198920, 1, 3477},
	{28373, 198924, 1, 3478},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{48992, 198968, 1, 1917},
	{49024, 198972, 2, 1918},
	{49045, 198976, 1, 1920},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29763, 199968, 3, 3601},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 4247},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 9, 4251},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 2007},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{50794, 213504, 1, 2017},
	{50813, 213508, 1, 2018},
	{50832, 213512, 1, 2017},
	{50851, 213516, 1, 2018},
	{50870, 213520, 1, 2017},
	{50889, 213524, 1, 2018},
	{50908, 213528, 1, 2017},
	{50927, 213532, 1, 2018},
	{48189, 213536, 1, 2017},
	{48208, 213540, 1, 2018},
	{48227, 213544, 1, 2017},
	{48246, 213548, 1, 2018},
	{48265, 213552, 1, 2017},
	{48284, 213556, 1, 2018},
	{48303, 213560, 1, 2017},
	{48322, 213564, 1, 2018},
	{48780, 213568, 1, 2017},
	{48800, 213572, 1, 2018},
	{48820, 213576, 1, 2017},
	{48840, 213580, 1, 2018},
	{48860, 213584, 1, 2017},
	{48880, 213588, 1, 2018},
	{48900, 213592, 1, 2017},
	{48920, 213596, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2019},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2019},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2019},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2019},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{50946, 216576, 1, 2017},
	{50966, 216580, 1, 2018},
	{50986, 216584, 1, 2017},
	{51006, 216588, 1, 2018},
	{51026, 216592, 1, 2017},
	{51046, 216596, 1, 2018},
	{51066, 216600, 1, 2017},
	{51086, 216604, 1, 2018},
	{51106, 216640, 1, 2017},
	{51126, 216644, 1, 2018},
	{51146, 216648, 1, 2017},
	{51166, 216652, 1, 2018},
	{51186, 216656, 1, 2017},
	{51206, 216660, 1, 2018},
	{51226, 216664, 1, 2017},
	{51246, 216668, 1, 2018},
	{51266, 216704, 1, 2017},
	{51286, 216708, 1, 2018},
	{51306, 216712, 1, 2017},
	{51326, 216716, 1, 2018},
	{51346, 216720, 1, 2017},
	{51366, 216724, 1, 2018},
	{51386, 216728, 1, 2017},
	{51406, 216732, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{36301, 221184, 1, 2057},
	{36325, 221188, 2, 4260},
	{36350, 221192, 3, 4262},
	{36374, 221196, 1, 2057},
	{36398, 221200, 2, 4260},
	{36423, 221204, 1, 2057},
	{36447, 221208, 2, 4260},
	{36472, 221212, 3, 4262},
	{36496, 221216, 4, 2032},
	{36512, 221220, 3, 4262},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 19, 3130},
	{36821, 221444, 19, 3130},
	{36846, 221448, 12, 3149},
	{36874, 221452, 12, 3149},
	{36902, 221456, 12, 3149},
	{36930, 221460, 12, 3149},
	{51426, 221696, 2, 3435},
	{51449, 221700, 2, 3435},
	{51472, 221704, 2, 3435},
	{51495, 221708, 2, 3435},
	{48097, 221712, 5, 2111},
	{48120, 221716, 2, 3435},
	{48143, 221720, 2, 3435},
	{48166, 221724, 2, 3435},
	{51518, 221728, 4, 2116},
	{48684, 221744, 5, 2111},
	{48708, 221748, 5, 2111},
	{48732, 221752, 2, 3435},
	{48756, 221756, 2, 3435},
	{51542, 221760, 4, 2116},
	{51567, 221764, 4, 2116},
	{48658, 221776, 1, 3476},
	{37388, 222208, 3, 2111},
	{37414, 222212, 2, 2028},
	{37441, 222216, 3, 2111},
	{37467, 222220, 2, 2028},
	{37494, 222224, 2, 2167},
	{37547, 222228, 2, 2167},
	{37600, 222464, 3, 2111},
	{37626, 222468, 2, 2028},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 3, 2111},
	{37859, 222724, 3, 2111},
	{37883, 222728, 3, 2111},
	{37907, 222732, 3, 2111},
	{37931, 222736, 2, 2028},
	{37956, 222740, 2, 2028},
	{37981, 222744, 2, 2028},
	{38006, 222748, 2, 2028},
	{38031, 222752, 1, 2155},
	{38055, 222756, 1, 2155},
	{38079, 222760, 8, 2120},
	{38100, 222976, 6, 4265},
	{38123, 222980, 6, 4265},
	{38146, 222984, 6, 4265},
	{38169, 222988, 6, 4265},
	{38192, 222992, 6, 4265},
	{38215, 222996, 6, 4265},
	{38238, 223000, 6, 4265},
	{38261, 223004, 6, 4265},
	{38284, 223008, 6, 4265},
	{38307, 223012, 6, 4265},
	{38330, 223016, 6, 4265},
	{38354, 223020, 6, 4265},
	{38378, 223024, 6, 4265},
	{38402, 223028, 6, 4265},
	{38426, 223032, 6, 4265},
	{38450, 223036, 6, 4265},
	{38474, 223104, 9, 3617},
	{51592, 223108, 2, 3667},
	{38494, 223112, 1, 2141},
	{38589, 223488, 3, 2150},
	{38612, 223492, 3, 2150},
	{38635, 223496, 3, 2150},
	{38658, 223500, 3, 2150},
	{38681, 223504, 2, 2153},
	{38705, 223508, 2, 2153},
	{38729, 223744, 3, 2150},
	{38753, 223748, 3, 2150},
	{38777, 223752, 3, 2150},
	{38801, 223756, 3, 2150},
	{38825, 223760, 2, 2153},
	{38850, 224000, 5, 2155},
	{38873, 224004, 4, 2160},
	{38897, 224008, 5, 2155},
	{38920, 224256, 5, 2155},
	{38943, 224260, 4, 2160},
	{38967, 224264, 5, 2155},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{51612, 224768, 5, 2111},
	{51636, 224772, 4, 2105},
	{51661, 224776, 5, 2111},
	{51685, 224780, 4, 2105},
	{51710, 224784, 3, 2167},
	{51734, 224788, 3, 2167},
	{51758, 224832, 5, 2111},
	{51782, 224836, 4, 2105},
	{51807, 224840, 5, 2111},
	{51831, 224844, 4, 2105},
	{51856, 224848, 3, 2167},
	{51880, 224852, 3, 2167},
	{51904, 224896, 5, 2111},
	{51928, 224900, 4, 2105},
	{51953, 224904, 3, 2167},
	{51977, 224908, 3, 2167},
	{52001, 224912, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40270, 225812, 1, 4271},
	{40293, 225816, 1, 2213},
	{52025, 225820, 2, 4272},
	{52058, 225824, 2, 4272},
	{52091, 225828, 2, 4272},
	{52124, 225832, 2, 4272},
	{52156, 225836, 2, 4272},
	{52188, 225840, 2, 4272},
	{52220, 225844, 2, 4272},
	{52253, 225848, 2, 4272},
	{52285, 225856, 2, 4272},
	{52317, 225860, 2, 4272},
	{52350, 225864, 2, 4272},
	{52383, 225868, 2, 4272},
	{52416, 225872, 2, 4272},
	{52448, 225876, 2, 4272},
	{52480, 225880, 2, 4272},
	{52513, 225884, 2, 4272},
	{52546, 225888, 2, 4272},
	{52579, 225892, 2, 4272},
	{52612, 225896, 2, 4272},
	{40316, 225900, 1, 4271},
	{40343, 225904, 1, 2213},
	{40225, 225908, 1, 2208},
	{40244, 225912, 1, 4274},
	{52644, 225916, 2, 4272},
	{52678, 225920, 2, 4272},
	{52712, 225924, 2, 4272},
	{52746, 225928, 2, 4272},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 4275},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 9, 4064},
	{42893, 1280, 6, 4280},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
};

static const struct si_reg gfx8_reg_table[] = {
	{958, 68, 10, 4286},
	{971, 72, 23, 4296},
	{986, 76, 4, 4319},
	{46919, 80, 11, 4089},
	{1023, 84, 4, 2940},
	{1041, 88, 2, 2944},
	{1059, 92, 6, 4323},
	{1074, 96, 1, 70},
	{1088, 100, 1, 2950},
	{1102, 104, 1, 72},
	{46933, 108, 1, 2951},
	{46950, 112, 13, 4329},
	{1119, 116, 5, 4342},
	{46966, 2480, 1, 1877},
	{46981, 2484, 1, 2965},
	{46996, 2488, 1, 1877},
	{47011, 2492, 1, 2965},
	{1257, 2496, 1, 109},
	{1271, 2500, 1, 109},
	{1285, 2504, 1, 109},
	{1299, 2508, 1, 109},
	{1313, 2512, 1, 109},
	{1327, 2516, 1, 109},
	{1341, 2520, 1, 109},
	{1355, 2524, 1, 109},
	{1369, 2528, 1, 109},
	{1383, 2532, 1, 109},
	{1397, 2536, 1, 109},
	{1412, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{47026, 3660, 21, 2966},
	{47039, 3664, 20, 2987},
	{47051, 3668, 16, 3007},
	{1602, 32776, 18, 4347},
	{1615, 32784, 24, 3045},
	{1627, 32788, 11, 3069},
	{1643, 32792, 11, 3069},
	{1672, 32824, 11, 3069},
	{1688, 32828, 11, 3069},
	{1704, 33296, 15, 4365},
	{1718, 33300, 28, 212},
	{1735, 33304, 14, 4380},
	{1756, 33308, 21, 4394},
	{1770, 33312, 31, 4172},
	{1787, 33316, 9, 4415},
	{1826, 33324, 1, 337},
	{1849, 33344, 1, 338},
	{1870, 33348, 1, 340},
	{1931, 33436, 1, 351},
	{49700, 36416, 1, 388},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 14, 4424},
	{3290, 36624, 1, 394},
	{3308, 36628, 5, 4438},
	{3326, 36632, 4, 3736},
	{3344, 36636, 11, 3740},
	{3362, 36640, 2, 3751},
	{3380, 36644, 2, 3753},
	{3398, 36648, 8, 4443},
	{3416, 36652, 1, 4451},
	{2407, 36656, 14, 4452},
	{2425, 36660, 4, 424},
	{2443, 36664, 10, 4466},
	{2461, 36668, 3, 3782},
	{2479, 37120, 6, 442},
	{2495, 39160, 9, 3785},
	{2510, 39184, 5, 3795},
	{2524, 39188, 5, 3795},
	{2538, 39192, 5, 3795},
	{2552, 39196, 5, 3795},
	{2566, 39200, 5, 3795},
	{2580, 39204, 5, 3795},
	{2594, 39208, 5, 3795},
	{2608, 39212, 5, 3795},
	{2622, 39216, 5, 3795},
	{2636, 39220, 5, 3795},
	{2650, 39224, 5, 3795},
	{2665, 39228, 5, 3795},
	{2680, 39232, 5, 3795},
	{2695, 39236, 5, 3795},
	{2710, 39240, 5, 3795},
	{2725, 39244, 5, 3795},
	{2740, 39248, 5, 3795},
	{2755, 39252, 5, 3795},
	{2770, 39256, 5, 3795},
	{2785, 39260, 5, 3795},
	{2800, 39264, 5, 3795},
	{2815, 39268, 5, 3795},
	{2830, 39272, 5, 3795},
	{2845, 39276, 5, 3795},
	{2860, 39280, 5, 3795},
	{2875, 39284, 5, 3795},
	{2890, 39288, 5, 3795},
	{2905, 39292, 5, 3795},
	{2920, 39296, 5, 3795},
	{2935, 39300, 5, 3795},
	{2950, 39304, 5, 3795},
	{2965, 39308, 5, 3795},
	{2980, 39312, 4, 461},
	{2999, 39316, 4, 461},
	{3018, 39320, 4, 461},
	{3037, 39324, 4, 461},
	{3056, 39328, 4, 461},
	{3075, 39332, 4, 461},
	{3094, 39336, 4, 461},
	{3113, 39340, 4, 461},
	{3132, 39344, 4, 461},
	{3151, 39348, 4, 461},
	{3170, 39352, 4, 461},
	{3190, 39356, 4, 461},
	{3210, 39360, 4, 461},
	{3230, 39364, 4, 461},
	{3250, 39368, 4, 461},
	{3270, 39372, 4, 461},
	{49934, 45056, 1, 505},
	{49955, 45060, 1, 506},
	{49976, 45064, 1, 505},
	{49997, 45068, 1, 506},
	{3483, 45084, 3, 502},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 3800},
	{3573, 45100, 6, 518},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{50018, 45312, 1, 505},
	{50039, 45316, 1, 506},
	{50060, 45320, 1, 505},
	{50081, 45324, 1, 506},
	{4664, 45336, 3, 502},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 3817},
	{4779, 45356, 11, 4476},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5848, 45552, 6, 578},
	{5875, 45556, 5, 584},
	{50102, 45568, 1, 505},
	{50123, 45572, 1, 506},
	{50144, 45576, 1, 505},
	{50165, 45580, 1, 506},
	{6063, 45596, 4, 591},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 11, 3839},
	{6153, 45612, 4, 569},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{7207, 45808, 6, 578},
	{50186, 45824, 1, 505},
	{50207, 45828, 1, 506},
	{50228, 45832, 1, 505},
	{50249, 45836, 1, 506},
	{7234, 45852, 4, 591},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7300, 45864, 12, 3817},
	{7324, 45868, 6, 578},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{7770, 46068, 5, 584},
	{50270, 46080, 1, 505},
	{50291, 46084, 1, 506},
	{50312, 46088, 1, 505},
	{50333, 46092, 1, 506},
	{7958, 46108, 3, 627},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 10, 3860},
	{8048, 46124, 6, 643},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{9102, 46324, 5, 584},
	{50354, 46336, 1, 505},
	{50375, 46340, 1, 506},
	{50396, 46344, 1, 505},
	{50417, 46348, 1, 506},
	{9129, 46364, 4, 591},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9195, 46376, 11, 3876},
	{9219, 46380, 5, 584},
	{9243, 46384, 1, 109},
	{9269, 46388, 1, 109},
	{9295, 46392, 1, 109},
	{9321, 46396, 1, 109},
	{9347, 46400, 1, 109},
	{9373, 46404, 1, 109},
	{9399, 46408, 1, 109},
	{9425, 46412, 1, 109},
	{9451, 46416, 1, 109},
	{9477, 46420, 1, 109},
	{9503, 46424, 1, 109},
	{9530, 46428, 1, 109},
	{9557, 46432, 1, 109},
	{9584, 46436, 1, 109},
	{9611, 46440, 1, 109},
	{9638, 46444, 1, 109},
	{9665, 47104, 12, 3892},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 2, 3905},
	{50458, 47160, 1, 109},
	{50473, 47164, 1, 680},
	{50488, 47168, 1, 109},
	{50503, 47172, 1, 680},
	{10052, 47176, 10, 3907},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 6, 705},
	{50518, 47192, 2, 3924},
	{50549, 47196, 2, 3924},
	{10179, 47200, 2, 712},
	{50732, 47204, 2, 3924},
	{50763, 47208, 2, 3924},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 5, 716},
	{10358, 47232, 1, 721},
	{10378, 47236, 1, 722},
	{10561, 47240, 3, 734},
	{10578, 47244, 1, 737},
	{10607, 47248, 1, 738},
	{52780, 47252, 2, 4487},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{11025, 47612, 1, 109},
	{50580, 53300, 29, 3926},
	{50597, 55348, 29, 3926},
	{11041, 163840, 10, 741},
	{11059, 163844, 9, 3955},
	{11076, 163848, 4, 3964},
	{11090, 163852, 23, 769},
	{11109, 163856, 15, 792},
	{11129, 163860, 1, 808},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{50614, 163900, 7, 3968},
	{11319, 163904, 10, 4489},
	{11329, 163908, 6, 4499},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{50628, 163928, 2, 3988},
	{50642, 163932, 1, 3990},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 4227},
	{11643, 164332, 1, 4227},
	{11664, 164336, 1, 4227},
	{11685, 164340, 1, 4227},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13602, 164692, 3, 920},
	{13624, 164696, 2, 923},
	{13681, 164704, 1, 932},
	{50657, 164708, 1, 3991},
	{13712, 164712, 1, 934},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13941, 164900, 3, 4505},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16485, 165444, 12, 994},
	{16505, 165448, 12, 994},
	{16525, 165452, 12, 994},
	{16545, 165456, 12, 994},
	{16565, 165460, 12, 994},
	{16585, 165464, 12, 994},
	{16605, 165468, 12, 994},
	{16625, 165472, 12, 994},
	{16645, 165476, 12, 994},
	{16665, 165480, 12, 994},
	{16685, 165484, 12, 994},
	{16706, 165488, 12, 994},
	{16727, 165492, 12, 994},
	{16748, 165496, 12, 994},
	{16769, 165500, 12, 994},
	{16790, 165504, 12, 994},
	{16811, 165508, 12, 994},
	{16832, 165512, 12, 994},
	{16853, 165516, 12, 994},
	{16874, 165520, 12, 994},
	{16895, 165524, 9, 1006},
	{16916, 165528, 9, 1006},
	{16937, 165532, 9, 1006},
	{16958, 165536, 9, 1006},
	{16979, 165540, 9, 1006},
	{17000, 165544, 9, 1006},
	{17021, 165548, 9, 1006},
	{17042, 165552, 9, 1006},
	{17063, 165556, 9, 1006},
	{17084, 165560, 9, 1006},
	{17105, 165564, 9, 1006},
	{17126, 165568, 9, 1006},
	{17147, 165572, 2, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 3, 3992},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17293, 165644, 4, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 3995},
	{17824, 165864, 1, 1119},
	{17837, 165872, 5, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 3, 4508},
	{17962, 165900, 12, 1156},
	{17980, 165904, 19, 1173},
	{17996, 165908, 13, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 27, 4511},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 3999},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 4538},
	{18602, 166468, 2, 1350},
	{18621, 166472, 4, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 4003},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 7, 4553},
	{18861, 166528, 1, 1384},
	{18872, 166532, 2, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 4560},
	{18955, 166548, 1, 1412},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 7, 4563},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 8, 4570},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19705, 166736, 3, 1456},
	{19727, 166740, 10, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 10, 4578},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 2, 1506},
	{20103, 166804, 7, 4033},
	{20122, 166808, 4, 1517},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 4, 1537},
	{20240, 166880, 5, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 2, 3964},
	{21185, 167024, 18, 4588},
	{21200, 167028, 6, 1654},
	{21217, 167032, 9, 1662},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21359, 167060, 1, 808},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 2, 3964},
	{21440, 167084, 18, 4588},
	{21455, 167088, 6, 1654},
	{21472, 167092, 9, 1662},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21614, 167120, 1, 808},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 2, 3964},
	{21695, 167144, 18, 4588},
	{21710, 167148, 6, 1654},
	{21727, 167152, 9, 1662},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21869, 167180, 1, 808},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 2, 3964},
	{21950, 167204, 18, 4588},
	{21965, 167208, 6, 1654},
	{21982, 167212, 9, 1662},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22124, 167240, 1, 808},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 2, 3964},
	{22205, 167264, 18, 4588},
	{22220, 167268, 6, 1654},
	{22237, 167272, 9, 1662},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22379, 167300, 1, 808},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 2, 3964},
	{22460, 167324, 18, 4588},
	{22475, 167328, 6, 1654},
	{22492, 167332, 9, 1662},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22634, 167360, 1, 808},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 2, 3964},
	{22715, 167384, 18, 4588},
	{22730, 167388, 6, 1654},
	{22747, 167392, 9, 1662},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22889, 167420, 1, 808},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 2, 3964},
	{22970, 167444, 18, 4588},
	{22985, 167448, 6, 1654},
	{23002, 167452, 9, 1662},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{23144, 167480, 1, 808},
	{24187, 196608, 1, 1689},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 1, 1695},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 1, 1713},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25489, 196852, 2, 4606},
	{25511, 196856, 2, 4606},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 5, 4608},
	{25987, 196968, 1, 109},
	{26002, 196972, 1, 1749},
	{26026, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 2, 3184},
	{26202, 197032, 3, 4613},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 2, 3187},
	{26274, 197048, 3, 4616},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 1773},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 1773},
	{26392, 197080, 5, 1775},
	{26412, 197084, 8, 4619},
	{26431, 197088, 8, 4619},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 26, 4627},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 4, 3218},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 9, 3224},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 9, 3224},
	{26750, 197160, 5, 3233},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 4, 1829},
	{26834, 197180, 1, 1833},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26880, 197192, 1, 1836},
	{26894, 197196, 1, 1837},
	{26908, 197200, 1, 1838},
	{26930, 197204, 1, 1839},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{52809, 197228, 1, 1835},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27444, 197424, 1, 1854},
	{27459, 197428, 1, 1855},
	{27474, 197432, 1, 1856},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 4653},
	{27593, 197464, 4, 4243},
	{27615, 197468, 1, 4657},
	{27759, 197552, 1, 1875},
	{27784, 197556, 1, 1875},
	{27808, 197560, 1, 1876},
	{27828, 197568, 1, 1877},
	{27854, 197572, 1, 1690},
	{27883, 197576, 1, 1877},
	{27908, 197580, 1, 1690},
	{27936, 197584, 1, 1877},
	{27959, 197588, 1, 1690},
	{27985, 197592, 1, 1877},
	{28007, 197596, 1, 1690},
	{28032, 197600, 1, 1877},
	{28051, 197604, 1, 1690},
	{28073, 197608, 1, 1396},
	{28087, 197612, 1, 1877},
	{28104, 197616, 1, 1690},
	{28124, 197620, 8, 1878},
	{28293, 198656, 6, 3087},
	{48479, 198912, 1, 1915},
	{48498, 198916, 1, 1915},
	{28354, 198920, 1, 3477},
	{28373, 198924, 1, 1396},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{48992, 198968, 1, 1917},
	{49024, 198972, 2, 1918},
	{49045, 198976, 1, 1920},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{49611, 199872, 1, 737},
	{49632, 199876, 1, 3655},
	{2079, 199880, 8, 4210},
	{2100, 199884, 3, 3664},
	{49653, 199888, 2, 3667},
	{2127, 199892, 1, 3691},
	{49679, 199896, 15, 3676},
	{50682, 199900, 1, 4219},
	{50704, 199904, 1, 4658},
	{2058, 199908, 2, 3669},
	{2148, 199912, 5, 4222},
	{49721, 199916, 1, 3692},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29763, 199968, 6, 1954},
	{29774, 199972, 2, 1961},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 1973},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 9, 4251},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 4659},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{50794, 213504, 1, 2017},
	{50813, 213508, 1, 2018},
	{50832, 213512, 1, 2017},
	{50851, 213516, 1, 2018},
	{50870, 213520, 1, 2017},
	{50889, 213524, 1, 2018},
	{50908, 213528, 1, 2017},
	{50927, 213532, 1, 2018},
	{48189, 213536, 1, 2017},
	{48208, 213540, 1, 2018},
	{48227, 213544, 1, 2017},
	{48246, 213548, 1, 2018},
	{48265, 213552, 1, 2017},
	{48284, 213556, 1, 2018},
	{48303, 213560, 1, 2017},
	{48322, 213564, 1, 2018},
	{48780, 213568, 1, 2017},
	{48800, 213572, 1, 2018},
	{48820, 213576, 1, 2017},
	{48840, 213580, 1, 2018},
	{48860, 213584, 1, 2017},
	{48880, 213588, 1, 2018},
	{48900, 213592, 1, 2017},
	{48920, 213596, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2019},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2019},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2019},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2019},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{50946, 216576, 1, 2017},
	{50966, 216580, 1, 2018},
	{50986, 216584, 1, 2017},
	{51006, 216588, 1, 2018},
	{51026, 216592, 1, 2017},
	{51046, 216596, 1, 2018},
	{51066, 216600, 1, 2017},
	{51086, 216604, 1, 2018},
	{51106, 216640, 1, 2017},
	{51126, 216644, 1, 2018},
	{51146, 216648, 1, 2017},
	{51166, 216652, 1, 2018},
	{51186, 216656, 1, 2017},
	{51206, 216660, 1, 2018},
	{51226, 216664, 1, 2017},
	{51246, 216668, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{36301, 221184, 1, 2057},
	{36325, 221188, 2, 4260},
	{36350, 221192, 3, 4262},
	{36374, 221196, 1, 2057},
	{36398, 221200, 2, 4260},
	{36423, 221204, 1, 2057},
	{36447, 221208, 2, 4260},
	{36472, 221212, 3, 4262},
	{36496, 221216, 4, 2032},
	{36512, 221220, 3, 4262},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 19, 3130},
	{36821, 221444, 19, 3130},
	{36846, 221448, 12, 3149},
	{36874, 221452, 12, 3149},
	{36902, 221456, 12, 3149},
	{36930, 221460, 12, 3149},
	{51426, 221696, 2, 3435},
	{51449, 221700, 2, 3435},
	{51472, 221704, 2, 3435},
	{51495, 221708, 2, 3435},
	{48097, 221712, 5, 2111},
	{48120, 221716, 2, 3435},
	{48143, 221720, 2, 3435},
	{48166, 221724, 2, 3435},
	{51518, 221728, 4, 2116},
	{48684, 221744, 5, 2111},
	{48708, 221748, 5, 2111},
	{48732, 221752, 2, 3435},
	{48756, 221756, 2, 3435},
	{51542, 221760, 4, 2116},
	{51567, 221764, 4, 2116},
	{48658, 221776, 1, 3476},
	{37388, 222208, 3, 2111},
	{37414, 222212, 2, 2028},
	{37441, 222216, 3, 2111},
	{37467, 222220, 2, 2028},
	{37494, 222224, 2, 2167},
	{37547, 222228, 2, 2167},
	{37600, 222464, 3, 2111},
	{37626, 222468, 2, 2028},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 3, 2111},
	{37859, 222724, 3, 2111},
	{37883, 222728, 3, 2111},
	{37907, 222732, 3, 2111},
	{37931, 222736, 2, 2028},
	{37956, 222740, 2, 2028},
	{37981, 222744, 2, 2028},
	{38006, 222748, 2, 2028},
	{38031, 222752, 1, 2155},
	{38055, 222756, 1, 2155},
	{38079, 222760, 8, 2120},
	{38100, 222976, 6, 3634},
	{38123, 222980, 6, 3634},
	{38146, 222984, 6, 3634},
	{38169, 222988, 6, 3634},
	{38192, 222992, 6, 3634},
	{38215, 222996, 6, 3634},
	{38238, 223000, 6, 3634},
	{38261, 223004, 6, 3634},
	{38284, 223008, 6, 3634},
	{38307, 223012, 6, 3634},
	{38330, 223016, 6, 3634},
	{38354, 223020, 6, 3634},
	{38378, 223024, 6, 3634},
	{38402, 223028, 6, 3634},
	{38426, 223032, 6, 3634},
	{38450, 223036, 6, 3634},
	{38474, 223104, 9, 3617},
	{51592, 223108, 2, 3667},
	{38494, 223112, 1, 2141},
	{38589, 223488, 3, 2150},
	{38612, 223492, 3, 2150},
	{38635, 223496, 3, 2150},
	{38658, 223500, 3, 2150},
	{38681, 223504, 2, 2153},
	{38705, 223508, 2, 2153},
	{38729, 223744, 3, 2150},
	{38753, 223748, 3, 2150},
	{38777, 223752, 3, 2150},
	{38801, 223756, 3, 2150},
	{38825, 223760, 2, 2153},
	{38850, 224000, 5, 2155},
	{38873, 224004, 4, 2160},
	{38897, 224008, 5, 2155},
	{38920, 224256, 5, 2155},
	{38943, 224260, 4, 2160},
	{38967, 224264, 5, 2155},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{51612, 224768, 5, 2111},
	{51636, 224772, 4, 2105},
	{51661, 224776, 5, 2111},
	{51685, 224780, 4, 2105},
	{51710, 224784, 3, 2167},
	{51734, 224788, 3, 2167},
	{51758, 224832, 5, 2111},
	{51782, 224836, 4, 2105},
	{51807, 224840, 5, 2111},
	{51831, 224844, 4, 2105},
	{51856, 224848, 3, 2167},
	{51880, 224852, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40270, 225812, 1, 4271},
	{40293, 225816, 1, 2213},
	{52025, 225820, 2, 4272},
	{52058, 225824, 2, 4272},
	{52091, 225828, 2, 4272},
	{52124, 225832, 2, 4272},
	{52156, 225836, 2, 4272},
	{52188, 225840, 2, 4272},
	{52220, 225844, 2, 4272},
	{52253, 225848, 2, 4272},
	{52285, 225856, 2, 4272},
	{52317, 225860, 2, 4272},
	{52350, 225864, 2, 4272},
	{52383, 225868, 2, 4272},
	{52416, 225872, 2, 4272},
	{52448, 225876, 2, 4272},
	{52480, 225880, 2, 4272},
	{52513, 225884, 2, 4272},
	{52546, 225888, 2, 4272},
	{52612, 225896, 2, 4272},
	{40316, 225900, 1, 4271},
	{40343, 225904, 1, 2213},
	{40225, 225908, 1, 2208},
	{40244, 225912, 1, 4274},
	{52644, 225916, 2, 4272},
	{52678, 225920, 2, 4272},
	{52712, 225924, 2, 4272},
	{52746, 225928, 2, 4272},
	{41213, 226044, 1, 2290},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 4275},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 9, 4064},
	{42893, 1280, 6, 4280},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
};

static const struct si_reg gfx81_reg_table[] = {
	{958, 68, 10, 4286},
	{971, 72, 23, 4296},
	{986, 76, 4, 4319},
	{46919, 80, 11, 4089},
	{1023, 84, 4, 2940},
	{1041, 88, 2, 2944},
	{1059, 92, 6, 4323},
	{1074, 96, 1, 70},
	{1088, 100, 1, 71},
	{1102, 104, 1, 72},
	{46933, 108, 1, 2951},
	{46950, 112, 13, 4329},
	{1119, 116, 5, 4342},
	{46966, 2480, 1, 1877},
	{46981, 2484, 1, 2965},
	{46996, 2488, 1, 1877},
	{47011, 2492, 1, 2965},
	{1257, 2496, 1, 109},
	{1271, 2500, 1, 109},
	{1285, 2504, 1, 109},
	{1299, 2508, 1, 109},
	{1313, 2512, 1, 109},
	{1327, 2516, 1, 109},
	{1341, 2520, 1, 109},
	{1355, 2524, 1, 109},
	{1369, 2528, 1, 109},
	{1383, 2532, 1, 109},
	{1397, 2536, 1, 109},
	{1412, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{47026, 3660, 21, 2966},
	{47039, 3664, 20, 2987},
	{47051, 3668, 16, 3007},
	{1602, 32776, 18, 4347},
	{1615, 32784, 24, 3045},
	{1627, 32788, 11, 3069},
	{1643, 32792, 11, 3069},
	{1672, 32824, 11, 3069},
	{1688, 32828, 11, 3069},
	{1704, 33296, 15, 4365},
	{1718, 33300, 28, 212},
	{1735, 33304, 14, 4380},
	{1756, 33308, 21, 4394},
	{1770, 33312, 31, 4172},
	{1787, 33316, 9, 4415},
	{1826, 33324, 1, 337},
	{1849, 33344, 1, 338},
	{1870, 33348, 1, 340},
	{1931, 33436, 1, 351},
	{49700, 36416, 1, 388},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 14, 4424},
	{3290, 36624, 1, 394},
	{3308, 36628, 5, 4665},
	{3326, 36632, 4, 3736},
	{3344, 36636, 11, 3740},
	{3362, 36640, 2, 3751},
	{3380, 36644, 2, 3753},
	{3398, 36648, 8, 4443},
	{3416, 36652, 1, 4451},
	{2407, 36656, 14, 4452},
	{2425, 36660, 4, 424},
	{2443, 36664, 10, 4466},
	{2461, 36668, 3, 3782},
	{2479, 37120, 6, 442},
	{2495, 39160, 9, 3785},
	{2510, 39184, 5, 3795},
	{2524, 39188, 5, 3795},
	{2538, 39192, 5, 3795},
	{2552, 39196, 5, 3795},
	{2566, 39200, 5, 3795},
	{2580, 39204, 5, 3795},
	{2594, 39208, 5, 3795},
	{2608, 39212, 5, 3795},
	{2622, 39216, 5, 3795},
	{2636, 39220, 5, 3795},
	{2650, 39224, 5, 3795},
	{2665, 39228, 5, 3795},
	{2680, 39232, 5, 3795},
	{2695, 39236, 5, 3795},
	{2710, 39240, 5, 3795},
	{2725, 39244, 5, 3795},
	{2740, 39248, 5, 3795},
	{2755, 39252, 5, 3795},
	{2770, 39256, 5, 3795},
	{2785, 39260, 5, 3795},
	{2800, 39264, 5, 3795},
	{2815, 39268, 5, 3795},
	{2830, 39272, 5, 3795},
	{2845, 39276, 5, 3795},
	{2860, 39280, 5, 3795},
	{2875, 39284, 5, 3795},
	{2890, 39288, 5, 3795},
	{2905, 39292, 5, 3795},
	{2920, 39296, 5, 3795},
	{2935, 39300, 5, 3795},
	{2950, 39304, 5, 3795},
	{2965, 39308, 5, 3795},
	{2980, 39312, 4, 461},
	{2999, 39316, 4, 461},
	{3018, 39320, 4, 461},
	{3037, 39324, 4, 461},
	{3056, 39328, 4, 461},
	{3075, 39332, 4, 461},
	{3094, 39336, 4, 461},
	{3113, 39340, 4, 461},
	{3132, 39344, 4, 461},
	{3151, 39348, 4, 461},
	{3170, 39352, 4, 461},
	{3190, 39356, 4, 461},
	{3210, 39360, 4, 461},
	{3230, 39364, 4, 461},
	{3250, 39368, 4, 461},
	{3270, 39372, 4, 461},
	{49934, 45056, 1, 505},
	{49955, 45060, 1, 506},
	{49976, 45064, 1, 505},
	{49997, 45068, 1, 506},
	{3483, 45084, 3, 502},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 3800},
	{3573, 45100, 6, 518},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{50018, 45312, 1, 505},
	{50039, 45316, 1, 506},
	{50060, 45320, 1, 505},
	{50081, 45324, 1, 506},
	{4664, 45336, 3, 502},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 3817},
	{4779, 45356, 11, 4476},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5848, 45552, 6, 578},
	{5875, 45556, 5, 584},
	{50102, 45568, 1, 505},
	{50123, 45572, 1, 506},
	{50144, 45576, 1, 505},
	{50165, 45580, 1, 506},
	{6063, 45596, 4, 591},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 11, 3839},
	{6153, 45612, 4, 569},
	{6177, 45616, 1, 109},
	{6203, 45620, 1, 109},
	{6229, 45624, 1, 109},
	{6255, 45628, 1, 109},
	{6281, 45632, 1, 109},
	{6307, 45636, 1, 109},
	{6333, 45640, 1, 109},
	{6359, 45644, 1, 109},
	{6385, 45648, 1, 109},
	{6411, 45652, 1, 109},
	{6437, 45656, 1, 109},
	{6464, 45660, 1, 109},
	{6491, 45664, 1, 109},
	{6518, 45668, 1, 109},
	{6545, 45672, 1, 109},
	{6572, 45676, 1, 109},
	{7207, 45808, 6, 578},
	{50186, 45824, 1, 505},
	{50207, 45828, 1, 506},
	{50228, 45832, 1, 505},
	{50249, 45836, 1, 506},
	{7234, 45852, 4, 591},
	{7258, 45856, 1, 505},
	{7279, 45860, 1, 506},
	{7300, 45864, 12, 3817},
	{7324, 45868, 6, 578},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{7770, 46068, 5, 584},
	{50270, 46080, 1, 505},
	{50291, 46084, 1, 506},
	{50312, 46088, 1, 505},
	{50333, 46092, 1, 506},
	{7958, 46108, 3, 627},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 10, 3860},
	{8048, 46124, 6, 643},
	{8072, 46128, 1, 109},
	{8098, 46132, 1, 109},
	{8124, 46136, 1, 109},
	{8150, 46140, 1, 109},
	{8176, 46144, 1, 109},
	{8202, 46148, 1, 109},
	{8228, 46152, 1, 109},
	{8254, 46156, 1, 109},
	{8280, 46160, 1, 109},
	{8306, 46164, 1, 109},
	{8332, 46168, 1, 109},
	{8359, 46172, 1, 109},
	{8386, 46176, 1, 109},
	{8413, 46180, 1, 109},
	{8440, 46184, 1, 109},
	{8467, 46188, 1, 109},
	{9102, 46324, 5, 584},
	{50354, 46336, 1, 505},
	{50375, 46340, 1, 506},
	{50396, 46344, 1, 505},
	{50417, 46348, 1, 506},
	{9129, 46364, 4, 591},
	{9153, 46368, 1, 505},
	{9174, 46372, 1, 506},
	{9195, 46376, 11, 3876},
	{9219, 46380, 5, 584},
	{9243, 46384, 1, 109},
	{9269, 46388, 1, 109},
	{9295, 46392, 1, 109},
	{9321, 46396, 1, 109},
	{9347, 46400, 1, 109},
	{9373, 46404, 1, 109},
	{9399, 46408, 1, 109},
	{9425, 46412, 1, 109},
	{9451, 46416, 1, 109},
	{9477, 46420, 1, 109},
	{9503, 46424, 1, 109},
	{9530, 46428, 1, 109},
	{9557, 46432, 1, 109},
	{9584, 46436, 1, 109},
	{9611, 46440, 1, 109},
	{9638, 46444, 1, 109},
	{9665, 47104, 12, 3892},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 2, 3905},
	{50458, 47160, 1, 109},
	{50473, 47164, 1, 680},
	{50488, 47168, 1, 109},
	{50503, 47172, 1, 680},
	{10052, 47176, 10, 3907},
	{10070, 47180, 11, 693},
	{10088, 47184, 1, 704},
	{10101, 47188, 6, 705},
	{50518, 47192, 2, 3924},
	{50549, 47196, 2, 3924},
	{10179, 47200, 2, 712},
	{50732, 47204, 2, 3924},
	{50763, 47208, 2, 3924},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 5, 716},
	{10358, 47232, 1, 721},
	{10378, 47236, 1, 722},
	{10561, 47240, 3, 734},
	{10578, 47244, 1, 737},
	{10607, 47248, 1, 738},
	{52780, 47252, 2, 4487},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{11025, 47612, 1, 109},
	{50580, 53300, 29, 3926},
	{50597, 55348, 29, 3926},
	{11041, 163840, 10, 741},
	{11059, 163844, 9, 3955},
	{11076, 163848, 4, 3964},
	{11090, 163852, 23, 769},
	{11109, 163856, 15, 792},
	{11129, 163860, 1, 808},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{50614, 163900, 7, 3968},
	{11319, 163904, 10, 4489},
	{11329, 163908, 6, 4499},
	{11345, 163912, 1, 808},
	{11360, 163916, 1, 808},
	{11381, 163920, 1, 808},
	{11397, 163924, 1, 808},
	{50628, 163928, 2, 3988},
	{50642, 163932, 1, 3990},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 4227},
	{11643, 164332, 1, 4227},
	{11664, 164336, 1, 4227},
	{11685, 164340, 1, 4227},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 905},
	{13602, 164692, 3, 920},
	{13624, 164696, 2, 923},
	{13681, 164704, 1, 932},
	{50657, 164708, 1, 3991},
	{13712, 164712, 1, 934},
	{13780, 164864, 1, 943},
	{13797, 164868, 1, 944},
	{13814, 164872, 1, 945},
	{13830, 164876, 1, 946},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13941, 164900, 3, 4505},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16485, 165444, 12, 994},
	{16505, 165448, 12, 994},
	{16525, 165452, 12, 994},
	{16545, 165456, 12, 994},
	{16565, 165460, 12, 994},
	{16585, 165464, 12, 994},
	{16605, 165468, 12, 994},
	{16625, 165472, 12, 994},
	{16645, 165476, 12, 994},
	{16665, 165480, 12, 994},
	{16685, 165484, 12, 994},
	{16706, 165488, 12, 994},
	{16727, 165492, 12, 994},
	{16748, 165496, 12, 994},
	{16769, 165500, 12, 994},
	{16790, 165504, 12, 994},
	{16811, 165508, 12, 994},
	{16832, 165512, 12, 994},
	{16853, 165516, 12, 994},
	{16874, 165520, 12, 994},
	{16895, 165524, 9, 1006},
	{16916, 165528, 9, 1006},
	{16937, 165532, 9, 1006},
	{16958, 165536, 9, 1006},
	{16979, 165540, 9, 1006},
	{17000, 165544, 9, 1006},
	{17021, 165548, 9, 1006},
	{17042, 165552, 9, 1006},
	{17063, 165556, 9, 1006},
	{17084, 165560, 9, 1006},
	{17105, 165564, 9, 1006},
	{17126, 165568, 9, 1006},
	{17147, 165572, 2, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 3, 3992},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17293, 165644, 4, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17357, 165716, 8, 1069},
	{17375, 165720, 8, 1077},
	{17396, 165724, 17, 1085},
	{17417, 165728, 6, 1102},
	{17435, 165732, 6, 1102},
	{17453, 165736, 6, 1102},
	{17471, 165740, 6, 1102},
	{17489, 165744, 6, 1102},
	{17507, 165748, 6, 1102},
	{17525, 165752, 6, 1102},
	{17543, 165756, 6, 1102},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 3995},
	{17824, 165864, 1, 1119},
	{17837, 165872, 5, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 4, 4670},
	{17962, 165900, 13, 1156},
	{17980, 165904, 19, 1173},
	{17996, 165908, 13, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 27, 4511},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 3999},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 4538},
	{18602, 166468, 2, 1350},
	{18621, 166472, 4, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 4003},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 7, 4553},
	{18861, 166528, 1, 1384},
	{18872, 166532, 2, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 4560},
	{18955, 166548, 1, 1412},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19054, 166568, 7, 4563},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 8, 4570},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19705, 166736, 4, 4674},
	{19727, 166740, 10, 1461},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 10, 4578},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 2, 1506},
	{20103, 166804, 7, 4033},
	{20122, 166808, 4, 1517},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 4, 1537},
	{20240, 166880, 5, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{20955, 166976, 1, 1587},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{21138, 167012, 2, 1629},
	{21154, 167016, 1, 1631},
	{21170, 167020, 2, 3964},
	{21185, 167024, 18, 4678},
	{21200, 167028, 6, 1654},
	{21217, 167032, 9, 1662},
	{21239, 167036, 1, 808},
	{21255, 167040, 1, 1674},
	{21277, 167044, 1, 808},
	{21293, 167048, 1, 1631},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21359, 167060, 1, 808},
	{21378, 167068, 1, 808},
	{21393, 167072, 2, 1629},
	{21409, 167076, 1, 1631},
	{21425, 167080, 2, 3964},
	{21440, 167084, 18, 4678},
	{21455, 167088, 6, 1654},
	{21472, 167092, 9, 1662},
	{21494, 167096, 1, 808},
	{21510, 167100, 1, 1674},
	{21532, 167104, 1, 808},
	{21548, 167108, 1, 1631},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21614, 167120, 1, 808},
	{21633, 167128, 1, 808},
	{21648, 167132, 2, 1629},
	{21664, 167136, 1, 1631},
	{21680, 167140, 2, 3964},
	{21695, 167144, 18, 4678},
	{21710, 167148, 6, 1654},
	{21727, 167152, 9, 1662},
	{21749, 167156, 1, 808},
	{21765, 167160, 1, 1674},
	{21787, 167164, 1, 808},
	{21803, 167168, 1, 1631},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21869, 167180, 1, 808},
	{21888, 167188, 1, 808},
	{21903, 167192, 2, 1629},
	{21919, 167196, 1, 1631},
	{21935, 167200, 2, 3964},
	{21950, 167204, 18, 4678},
	{21965, 167208, 6, 1654},
	{21982, 167212, 9, 1662},
	{22004, 167216, 1, 808},
	{22020, 167220, 1, 1674},
	{22042, 167224, 1, 808},
	{22058, 167228, 1, 1631},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22124, 167240, 1, 808},
	{22143, 167248, 1, 808},
	{22158, 167252, 2, 1629},
	{22174, 167256, 1, 1631},
	{22190, 167260, 2, 3964},
	{22205, 167264, 18, 4678},
	{22220, 167268, 6, 1654},
	{22237, 167272, 9, 1662},
	{22259, 167276, 1, 808},
	{22275, 167280, 1, 1674},
	{22297, 167284, 1, 808},
	{22313, 167288, 1, 1631},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22379, 167300, 1, 808},
	{22398, 167308, 1, 808},
	{22413, 167312, 2, 1629},
	{22429, 167316, 1, 1631},
	{22445, 167320, 2, 3964},
	{22460, 167324, 18, 4678},
	{22475, 167328, 6, 1654},
	{22492, 167332, 9, 1662},
	{22514, 167336, 1, 808},
	{22530, 167340, 1, 1674},
	{22552, 167344, 1, 808},
	{22568, 167348, 1, 1631},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22634, 167360, 1, 808},
	{22653, 167368, 1, 808},
	{22668, 167372, 2, 1629},
	{22684, 167376, 1, 1631},
	{22700, 167380, 2, 3964},
	{22715, 167384, 18, 4678},
	{22730, 167388, 6, 1654},
	{22747, 167392, 9, 1662},
	{22769, 167396, 1, 808},
	{22785, 167400, 1, 1674},
	{22807, 167404, 1, 808},
	{22823, 167408, 1, 1631},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22889, 167420, 1, 808},
	{22908, 167428, 1, 808},
	{22923, 167432, 2, 1629},
	{22939, 167436, 1, 1631},
	{22955, 167440, 2, 3964},
	{22970, 167444, 18, 4678},
	{22985, 167448, 6, 1654},
	{23002, 167452, 9, 1662},
	{23024, 167456, 1, 808},
	{23040, 167460, 1, 1674},
	{23062, 167464, 1, 808},
	{23078, 167468, 1, 1631},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{23144, 167480, 1, 808},
	{24187, 196608, 1, 1689},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 1, 1695},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 1, 1713},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25489, 196852, 2, 4606},
	{25511, 196856, 2, 4606},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 5, 4608},
	{25987, 196968, 1, 109},
	{26002, 196972, 1, 1749},
	{26026, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 2, 3184},
	{26202, 197032, 3, 4613},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 2, 3187},
	{26274, 197048, 3, 4616},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 1773},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 1773},
	{26392, 197080, 5, 1775},
	{26412, 197084, 8, 4619},
	{26431, 197088, 8, 4619},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 26, 4627},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 4, 3218},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 9, 3224},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 9, 3224},
	{26750, 197160, 5, 3233},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 4, 1829},
	{26834, 197180, 1, 1833},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26880, 197192, 1, 1836},
	{26894, 197196, 1, 1837},
	{26908, 197200, 1, 1838},
	{26930, 197204, 1, 1839},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{52809, 197228, 1, 1835},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27444, 197424, 1, 1854},
	{27459, 197428, 1, 1855},
	{27474, 197432, 1, 1856},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 4653},
	{27593, 197464, 4, 4243},
	{27615, 197468, 1, 4657},
	{27759, 197552, 1, 1875},
	{27784, 197556, 1, 1875},
	{27808, 197560, 1, 1876},
	{27828, 197568, 1, 1877},
	{27854, 197572, 1, 1690},
	{27883, 197576, 1, 1877},
	{27908, 197580, 1, 1690},
	{27936, 197584, 1, 1877},
	{27959, 197588, 1, 1690},
	{27985, 197592, 1, 1877},
	{28007, 197596, 1, 1690},
	{28032, 197600, 1, 1877},
	{28051, 197604, 1, 1690},
	{28073, 197608, 1, 1396},
	{28087, 197612, 1, 1877},
	{28104, 197616, 1, 1690},
	{28124, 197620, 8, 1878},
	{28293, 198656, 6, 3087},
	{48479, 198912, 1, 1915},
	{48498, 198916, 1, 1915},
	{28354, 198920, 1, 3477},
	{28373, 198924, 1, 1396},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{48992, 198968, 1, 1917},
	{49024, 198972, 2, 1918},
	{49045, 198976, 1, 1920},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{49611, 199872, 1, 737},
	{49632, 199876, 1, 3655},
	{2079, 199880, 8, 4210},
	{2100, 199884, 3, 3664},
	{49653, 199888, 2, 3667},
	{2127, 199892, 1, 3691},
	{49679, 199896, 15, 3676},
	{50682, 199900, 1, 4219},
	{50704, 199904, 1, 4658},
	{2058, 199908, 2, 3669},
	{2148, 199912, 5, 4222},
	{49721, 199916, 1, 3692},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29763, 199968, 6, 1954},
	{29774, 199972, 2, 1961},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 1973},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 9, 4696},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 4659},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{50794, 213504, 1, 2017},
	{50813, 213508, 1, 2018},
	{50832, 213512, 1, 2017},
	{50851, 213516, 1, 2018},
	{50870, 213520, 1, 2017},
	{50889, 213524, 1, 2018},
	{50908, 213528, 1, 2017},
	{50927, 213532, 1, 2018},
	{48189, 213536, 1, 2017},
	{48208, 213540, 1, 2018},
	{48227, 213544, 1, 2017},
	{48246, 213548, 1, 2018},
	{48265, 213552, 1, 2017},
	{48284, 213556, 1, 2018},
	{48303, 213560, 1, 2017},
	{48322, 213564, 1, 2018},
	{48780, 213568, 1, 2017},
	{48800, 213572, 1, 2018},
	{48820, 213576, 1, 2017},
	{48840, 213580, 1, 2018},
	{48860, 213584, 1, 2017},
	{48880, 213588, 1, 2018},
	{48900, 213592, 1, 2017},
	{48920, 213596, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2019},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2019},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2019},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2019},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{50946, 216576, 1, 2017},
	{50966, 216580, 1, 2018},
	{50986, 216584, 1, 2017},
	{51006, 216588, 1, 2018},
	{51026, 216592, 1, 2017},
	{51046, 216596, 1, 2018},
	{51066, 216600, 1, 2017},
	{51086, 216604, 1, 2018},
	{51106, 216640, 1, 2017},
	{51126, 216644, 1, 2018},
	{51146, 216648, 1, 2017},
	{51166, 216652, 1, 2018},
	{51186, 216656, 1, 2017},
	{51206, 216660, 1, 2018},
	{51226, 216664, 1, 2017},
	{51246, 216668, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{36301, 221184, 1, 2057},
	{36325, 221188, 2, 4260},
	{36350, 221192, 3, 4262},
	{36374, 221196, 1, 2057},
	{36398, 221200, 2, 4260},
	{36423, 221204, 1, 2057},
	{36447, 221208, 2, 4260},
	{36472, 221212, 3, 4262},
	{36496, 221216, 4, 2032},
	{36512, 221220, 3, 4262},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 19, 3130},
	{36821, 221444, 19, 3130},
	{36846, 221448, 12, 3149},
	{36874, 221452, 12, 3149},
	{36902, 221456, 12, 3149},
	{36930, 221460, 12, 3149},
	{51426, 221696, 2, 3435},
	{51449, 221700, 2, 3435},
	{51472, 221704, 2, 3435},
	{51495, 221708, 2, 3435},
	{48097, 221712, 5, 2111},
	{48120, 221716, 2, 3435},
	{48143, 221720, 2, 3435},
	{48166, 221724, 2, 3435},
	{51518, 221728, 4, 2116},
	{48684, 221744, 5, 2111},
	{48708, 221748, 5, 2111},
	{48732, 221752, 2, 3435},
	{48756, 221756, 2, 3435},
	{51542, 221760, 4, 2116},
	{51567, 221764, 4, 2116},
	{48658, 221776, 1, 3476},
	{37388, 222208, 3, 2111},
	{37414, 222212, 2, 2028},
	{37441, 222216, 3, 2111},
	{37467, 222220, 2, 2028},
	{37494, 222224, 2, 2167},
	{37547, 222228, 2, 2167},
	{37600, 222464, 3, 2111},
	{37626, 222468, 2, 2028},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 3, 2111},
	{37859, 222724, 3, 2111},
	{37883, 222728, 3, 2111},
	{37907, 222732, 3, 2111},
	{37931, 222736, 2, 2028},
	{37956, 222740, 2, 2028},
	{37981, 222744, 2, 2028},
	{38006, 222748, 2, 2028},
	{38031, 222752, 1, 2155},
	{38055, 222756, 1, 2155},
	{38079, 222760, 8, 2120},
	{38100, 222976, 6, 3634},
	{38123, 222980, 6, 3634},
	{38146, 222984, 6, 3634},
	{38169, 222988, 6, 3634},
	{38192, 222992, 6, 3634},
	{38215, 222996, 6, 3634},
	{38238, 223000, 6, 3634},
	{38261, 223004, 6, 3634},
	{38284, 223008, 6, 3634},
	{38307, 223012, 6, 3634},
	{38330, 223016, 6, 3634},
	{38354, 223020, 6, 3634},
	{38378, 223024, 6, 3634},
	{38402, 223028, 6, 3634},
	{38426, 223032, 6, 3634},
	{38450, 223036, 6, 3634},
	{38474, 223104, 9, 3617},
	{51592, 223108, 2, 3667},
	{38494, 223112, 1, 2141},
	{38589, 223488, 3, 2150},
	{38612, 223492, 3, 2150},
	{38635, 223496, 3, 2150},
	{38658, 223500, 3, 2150},
	{38681, 223504, 2, 2153},
	{38705, 223508, 2, 2153},
	{38729, 223744, 3, 2150},
	{38753, 223748, 3, 2150},
	{38777, 223752, 3, 2150},
	{38801, 223756, 3, 2150},
	{38825, 223760, 2, 2153},
	{38850, 224000, 5, 2155},
	{38873, 224004, 4, 2160},
	{38897, 224008, 5, 2155},
	{38920, 224256, 5, 2155},
	{38943, 224260, 4, 2160},
	{38967, 224264, 5, 2155},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{51612, 224768, 5, 2111},
	{51636, 224772, 4, 2105},
	{51661, 224776, 5, 2111},
	{51685, 224780, 4, 2105},
	{51710, 224784, 3, 2167},
	{51734, 224788, 3, 2167},
	{51758, 224832, 5, 2111},
	{51782, 224836, 4, 2105},
	{51807, 224840, 5, 2111},
	{51831, 224844, 4, 2105},
	{51856, 224848, 3, 2167},
	{51880, 224852, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40270, 225812, 1, 4271},
	{40293, 225816, 1, 2213},
	{52025, 225820, 2, 4272},
	{52058, 225824, 2, 4272},
	{52091, 225828, 2, 4272},
	{52124, 225832, 2, 4272},
	{52156, 225836, 2, 4272},
	{52188, 225840, 2, 4272},
	{52220, 225844, 2, 4272},
	{52253, 225848, 2, 4272},
	{52285, 225856, 2, 4272},
	{52317, 225860, 2, 4272},
	{52350, 225864, 2, 4272},
	{52383, 225868, 2, 4272},
	{52416, 225872, 2, 4272},
	{52448, 225876, 2, 4272},
	{52480, 225880, 2, 4272},
	{52513, 225884, 2, 4272},
	{52546, 225888, 2, 4272},
	{52612, 225896, 2, 4272},
	{40316, 225900, 1, 4271},
	{40343, 225904, 1, 2213},
	{40225, 225908, 1, 2208},
	{40244, 225912, 1, 4274},
	{41213, 226044, 1, 2290},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 4275},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 9, 4064},
	{42893, 1280, 6, 4280},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
};

static const struct si_reg gfx9_reg_table[] = {
	{958, 68, 14, 4705},
	{971, 72, 23, 4719},
	{986, 76, 7, 4742},
	{46919, 80, 11, 4089},
	{1023, 84, 4, 2940},
	{1041, 88, 2, 2944},
	{1059, 92, 7, 4749},
	{1074, 96, 1, 70},
	{1088, 100, 1, 71},
	{1102, 104, 1, 72},
	{46933, 108, 1, 2951},
	{46950, 112, 13, 4756},
	{1119, 116, 7, 4769},
	{1135, 120, 1, 82},
	{1257, 2480, 1, 109},
	{1271, 2484, 1, 109},
	{1285, 2488, 1, 109},
	{1299, 2492, 1, 109},
	{1313, 2496, 1, 109},
	{1327, 2500, 1, 109},
	{1341, 2504, 1, 109},
	{1355, 2508, 1, 109},
	{1369, 2512, 1, 109},
	{1383, 2516, 1, 109},
	{1397, 2520, 1, 109},
	{1412, 2524, 1, 109},
	{1427, 2528, 1, 109},
	{1442, 2532, 1, 109},
	{1457, 2536, 1, 109},
	{1472, 2540, 1, 109},
	{1487, 2544, 1, 110},
	{1498, 2552, 1, 111},
	{1514, 2556, 1, 112},
	{1602, 32776, 25, 4776},
	{1615, 32784, 24, 4801},
	{1627, 32788, 12, 4825},
	{1643, 32792, 12, 4825},
	{1672, 32824, 12, 4825},
	{1688, 32828, 12, 4825},
	{1704, 33296, 16, 4837},
	{1718, 33300, 28, 212},
	{1735, 33304, 14, 240},
	{1756, 33308, 21, 4853},
	{1770, 33312, 31, 4172},
	{1787, 33316, 11, 315},
	{1826, 33324, 1, 337},
	{1849, 33344, 1, 338},
	{1870, 33348, 1, 340},
	{1890, 33352, 1, 341},
	{1931, 33436, 1, 351},
	{2335, 36608, 1, 394},
	{2353, 36612, 4, 395},
	{2371, 36616, 1, 399},
	{2389, 36620, 12, 4874},
	{3290, 36624, 1, 394},
	{3308, 36628, 8, 4886},
	{3326, 36632, 3, 3736},
	{3344, 36636, 8, 4894},
	{3362, 36640, 3, 4902},
	{3380, 36644, 7, 4905},
	{3398, 36648, 8, 4443},
	{3416, 36652, 1, 4451},
	{2407, 36656, 14, 4452},
	{2425, 36660, 4, 424},
	{2443, 36664, 10, 4912},
	{2461, 36668, 3, 4922},
	{2495, 39160, 13, 4925},
	{2510, 39184, 5, 3795},
	{2524, 39188, 5, 3795},
	{2538, 39192, 5, 3795},
	{2552, 39196, 5, 3795},
	{2566, 39200, 5, 3795},
	{2580, 39204, 5, 3795},
	{2594, 39208, 5, 3795},
	{2608, 39212, 5, 3795},
	{2622, 39216, 5, 3795},
	{2636, 39220, 5, 3795},
	{2650, 39224, 5, 3795},
	{2665, 39228, 5, 3795},
	{2680, 39232, 5, 3795},
	{2695, 39236, 5, 3795},
	{2710, 39240, 5, 3795},
	{2725, 39244, 5, 3795},
	{2740, 39248, 5, 3795},
	{2755, 39252, 5, 3795},
	{2770, 39256, 5, 3795},
	{2785, 39260, 5, 3795},
	{2800, 39264, 5, 3795},
	{2815, 39268, 5, 3795},
	{2830, 39272, 5, 3795},
	{2845, 39276, 5, 3795},
	{2860, 39280, 5, 3795},
	{2875, 39284, 5, 3795},
	{2890, 39288, 5, 3795},
	{2905, 39292, 5, 3795},
	{2920, 39296, 5, 3795},
	{2935, 39300, 5, 3795},
	{2950, 39304, 5, 3795},
	{2965, 39308, 5, 3795},
	{2980, 39312, 4, 461},
	{2999, 39316, 4, 461},
	{3018, 39320, 4, 461},
	{3037, 39324, 4, 461},
	{3056, 39328, 4, 461},
	{3075, 39332, 4, 461},
	{3094, 39336, 4, 461},
	{3113, 39340, 4, 461},
	{3132, 39344, 4, 461},
	{3151, 39348, 4, 461},
	{3170, 39352, 4, 461},
	{3190, 39356, 4, 461},
	{3210, 39360, 4, 461},
	{3230, 39364, 4, 461},
	{3250, 39368, 4, 461},
	{3270, 39372, 4, 461},
	{3483, 45084, 4, 4938},
	{3507, 45088, 1, 505},
	{3528, 45092, 1, 506},
	{3549, 45096, 11, 4942},
	{3573, 45100, 10, 4953},
	{3597, 45104, 1, 109},
	{3623, 45108, 1, 109},
	{3649, 45112, 1, 109},
	{3675, 45116, 1, 109},
	{3701, 45120, 1, 109},
	{3727, 45124, 1, 109},
	{3753, 45128, 1, 109},
	{3779, 45132, 1, 109},
	{3805, 45136, 1, 109},
	{3831, 45140, 1, 109},
	{3857, 45144, 1, 109},
	{3884, 45148, 1, 109},
	{3911, 45152, 1, 109},
	{3938, 45156, 1, 109},
	{3965, 45160, 1, 109},
	{3992, 45164, 1, 109},
	{4019, 45168, 1, 109},
	{4046, 45172, 1, 109},
	{4073, 45176, 1, 109},
	{4100, 45180, 1, 109},
	{4127, 45184, 1, 109},
	{4154, 45188, 1, 109},
	{4181, 45192, 1, 109},
	{4208, 45196, 1, 109},
	{4235, 45200, 1, 109},
	{4262, 45204, 1, 109},
	{4289, 45208, 1, 109},
	{4316, 45212, 1, 109},
	{4343, 45216, 1, 109},
	{4370, 45220, 1, 109},
	{4397, 45224, 1, 109},
	{4424, 45228, 1, 109},
	{4664, 45336, 4, 4938},
	{4688, 45340, 1, 542},
	{4713, 45344, 1, 505},
	{4734, 45348, 1, 506},
	{4755, 45352, 12, 4963},
	{4779, 45356, 14, 4975},
	{4803, 45360, 1, 109},
	{4829, 45364, 1, 109},
	{4855, 45368, 1, 109},
	{4881, 45372, 1, 109},
	{4907, 45376, 1, 109},
	{4933, 45380, 1, 109},
	{4959, 45384, 1, 109},
	{4985, 45388, 1, 109},
	{5011, 45392, 1, 109},
	{5037, 45396, 1, 109},
	{5063, 45400, 1, 109},
	{5090, 45404, 1, 109},
	{5117, 45408, 1, 109},
	{5144, 45412, 1, 109},
	{5171, 45416, 1, 109},
	{5198, 45420, 1, 109},
	{5225, 45424, 1, 109},
	{5252, 45428, 1, 109},
	{5279, 45432, 1, 109},
	{5306, 45436, 1, 109},
	{5333, 45440, 1, 109},
	{5360, 45444, 1, 109},
	{5387, 45448, 1, 109},
	{5414, 45452, 1, 109},
	{5441, 45456, 1, 109},
	{5468, 45460, 1, 109},
	{5495, 45464, 1, 109},
	{5522, 45468, 1, 109},
	{5549, 45472, 1, 109},
	{5576, 45476, 1, 109},
	{5603, 45480, 1, 109},
	{5630, 45484, 1, 109},
	{5821, 45552, 9, 569},
	{5927, 45572, 2, 4989},
	{5951, 45576, 1, 505},
	{5983, 45580, 1, 505},
	{7258, 45584, 1, 505},
	{7279, 45588, 1, 506},
	{6063, 45596, 4, 4938},
	{6087, 45600, 1, 505},
	{6108, 45604, 1, 506},
	{6129, 45608, 12, 4991},
	{6153, 45612, 9, 5003},
	{7348, 45872, 1, 109},
	{7374, 45876, 1, 109},
	{7400, 45880, 1, 109},
	{7426, 45884, 1, 109},
	{7452, 45888, 1, 109},
	{7478, 45892, 1, 109},
	{7504, 45896, 1, 109},
	{7530, 45900, 1, 109},
	{7556, 45904, 1, 109},
	{7582, 45908, 1, 109},
	{7608, 45912, 1, 109},
	{7635, 45916, 1, 109},
	{7662, 45920, 1, 109},
	{7689, 45924, 1, 109},
	{7716, 45928, 1, 109},
	{7743, 45932, 1, 109},
	{52825, 45936, 1, 109},
	{52852, 45940, 1, 109},
	{52879, 45944, 1, 109},
	{52906, 45948, 1, 109},
	{52933, 45952, 1, 109},
	{52960, 45956, 1, 109},
	{52987, 45960, 1, 109},
	{53014, 45964, 1, 109},
	{53041, 45968, 1, 109},
	{53068, 45972, 1, 109},
	{53095, 45976, 1, 109},
	{53122, 45980, 1, 109},
	{53149, 45984, 1, 109},
	{53176, 45988, 1, 109},
	{53203, 45992, 1, 109},
	{53230, 45996, 1, 109},
	{7822, 46084, 1, 4989},
	{7846, 46088, 1, 505},
	{7878, 46092, 1, 505},
	{9153, 46096, 1, 505},
	{9174, 46100, 1, 506},
	{7958, 46108, 4, 5012},
	{7982, 46112, 1, 505},
	{8003, 46116, 1, 506},
	{8024, 46120, 11, 5016},
	{8048, 46124, 7, 5027},
	{9243, 46128, 1, 109},
	{9269, 46132, 1, 109},
	{9295, 46136, 1, 109},
	{9321, 46140, 1, 109},
	{9347, 46144, 1, 109},
	{9373, 46148, 1, 109},
	{9399, 46152, 1, 109},
	{9425, 46156, 1, 109},
	{9451, 46160, 1, 109},
	{9477, 46164, 1, 109},
	{9503, 46168, 1, 109},
	{9530, 46172, 1, 109},
	{9557, 46176, 1, 109},
	{9584, 46180, 1, 109},
	{9611, 46184, 1, 109},
	{9638, 46188, 1, 109},
	{53257, 46192, 1, 109},
	{53284, 46196, 1, 109},
	{53311, 46200, 1, 109},
	{53338, 46204, 1, 109},
	{53365, 46208, 1, 109},
	{53392, 46212, 1, 109},
	{53419, 46216, 1, 109},
	{53446, 46220, 1, 109},
	{53473, 46224, 1, 109},
	{53500, 46228, 1, 109},
	{53527, 46232, 1, 109},
	{53554, 46236, 1, 109},
	{53581, 46240, 1, 109},
	{53608, 46244, 1, 109},
	{53635, 46248, 1, 109},
	{53662, 46252, 1, 109},
	{53689, 46384, 1, 109},
	{53719, 46388, 1, 109},
	{53749, 46392, 1, 109},
	{53779, 46396, 1, 109},
	{53809, 46400, 1, 109},
	{53839, 46404, 1, 109},
	{53869, 46408, 1, 109},
	{53899, 46412, 1, 109},
	{53929, 46416, 1, 109},
	{53959, 46420, 1, 109},
	{53989, 46424, 1, 109},
	{54020, 46428, 1, 109},
	{54051, 46432, 1, 109},
	{54082, 46436, 1, 109},
	{54113, 46440, 1, 109},
	{54144, 46444, 1, 109},
	{54175, 46448, 1, 109},
	{54206, 46452, 1, 109},
	{54237, 46456, 1, 109},
	{54268, 46460, 1, 109},
	{54299, 46464, 1, 109},
	{54330, 46468, 1, 109},
	{54361, 46472, 1, 109},
	{54392, 46476, 1, 109},
	{54423, 46480, 1, 109},
	{54454, 46484, 1, 109},
	{54485, 46488, 1, 109},
	{54516, 46492, 1, 109},
	{54547, 46496, 1, 109},
	{54578, 46500, 1, 109},
	{54609, 46504, 1, 109},
	{54640, 46508, 1, 109},
	{9665, 47104, 11, 5034},
	{9692, 47108, 1, 674},
	{9706, 47112, 1, 674},
	{9720, 47116, 1, 674},
	{9734, 47120, 1, 675},
	{9750, 47124, 1, 675},
	{9766, 47128, 1, 675},
	{9782, 47132, 2, 676},
	{9803, 47136, 2, 676},
	{9824, 47140, 2, 676},
	{9845, 47144, 1, 678},
	{9873, 47148, 1, 679},
	{9898, 47152, 1, 109},
	{9913, 47156, 1, 680},
	{9928, 47160, 1, 109},
	{9957, 47164, 1, 680},
	{9986, 47168, 1, 109},
	{10019, 47172, 1, 680},
	{10052, 47176, 11, 5045},
	{10070, 47180, 12, 5056},
	{10088, 47184, 1, 704},
	{10101, 47188, 7, 5068},
	{50518, 47192, 2, 3924},
	{50549, 47196, 2, 3924},
	{10179, 47200, 2, 712},
	{50732, 47204, 2, 3924},
	{50763, 47208, 2, 3924},
	{10254, 47212, 1, 714},
	{10272, 47216, 1, 714},
	{10290, 47220, 1, 714},
	{10308, 47224, 1, 715},
	{10336, 47228, 5, 716},
	{10358, 47232, 1, 721},
	{10378, 47236, 1, 722},
	{10561, 47240, 3, 734},
	{10578, 47244, 1, 737},
	{10607, 47248, 1, 738},
	{10539, 47252, 1, 501},
	{10654, 47360, 1, 109},
	{10674, 47364, 1, 109},
	{10694, 47368, 1, 109},
	{10714, 47372, 1, 109},
	{10734, 47376, 1, 109},
	{10754, 47380, 1, 109},
	{10774, 47384, 1, 109},
	{10794, 47388, 1, 109},
	{10814, 47392, 1, 109},
	{10834, 47396, 1, 109},
	{10854, 47400, 1, 109},
	{10875, 47404, 1, 109},
	{10896, 47408, 1, 109},
	{10917, 47412, 1, 109},
	{10938, 47416, 1, 109},
	{10959, 47420, 1, 109},
	{11004, 47608, 1, 109},
	{11025, 47612, 1, 109},
	{11041, 163840, 10, 741},
	{11059, 163844, 9, 3955},
	{11076, 163848, 5, 5075},
	{11090, 163852, 23, 769},
	{11109, 163856, 16, 792},
	{11129, 163860, 1, 808},
	{11541, 163864, 1, 856},
	{50628, 163868, 2, 809},
	{11165, 163872, 1, 811},
	{11185, 163876, 1, 812},
	{11205, 163880, 1, 813},
	{11222, 163884, 1, 814},
	{11237, 163888, 2, 815},
	{11261, 163892, 2, 817},
	{11319, 163896, 13, 5080},
	{11329, 163900, 8, 5093},
	{11345, 163904, 1, 808},
	{11455, 163908, 1, 856},
	{11360, 163912, 1, 808},
	{11473, 163916, 1, 856},
	{11381, 163920, 1, 808},
	{11497, 163924, 1, 856},
	{11397, 163928, 1, 808},
	{11516, 163932, 1, 856},
	{11285, 163936, 3, 819},
	{54671, 163944, 1, 5101},
	{54682, 163948, 1, 5101},
	{11587, 163968, 1, 866},
	{11603, 163972, 1, 867},
	{11622, 164328, 1, 868},
	{11643, 164332, 1, 868},
	{11664, 164336, 1, 868},
	{11685, 164340, 1, 868},
	{11706, 164344, 1, 869},
	{11724, 164348, 1, 869},
	{11742, 164352, 2, 870},
	{11762, 164356, 3, 872},
	{11786, 164360, 2, 875},
	{11810, 164364, 1, 877},
	{11830, 164368, 2, 872},
	{11850, 164372, 2, 875},
	{11870, 164376, 2, 872},
	{11890, 164380, 2, 875},
	{11910, 164384, 2, 872},
	{11930, 164388, 2, 875},
	{11950, 164392, 2, 872},
	{11970, 164396, 2, 875},
	{11990, 164400, 7, 878},
	{12005, 164404, 2, 885},
	{12034, 164408, 8, 887},
	{12049, 164412, 8, 895},
	{12064, 164416, 3, 872},
	{12089, 164420, 2, 875},
	{12114, 164424, 1, 869},
	{12132, 164428, 1, 869},
	{12150, 164432, 3, 872},
	{12175, 164436, 2, 875},
	{12200, 164440, 3, 872},
	{12225, 164444, 2, 875},
	{12250, 164448, 3, 872},
	{12275, 164452, 2, 875},
	{12300, 164456, 3, 872},
	{12325, 164460, 2, 875},
	{12350, 164464, 3, 872},
	{12375, 164468, 2, 875},
	{12400, 164472, 3, 872},
	{12425, 164476, 2, 875},
	{12450, 164480, 3, 872},
	{12475, 164484, 2, 875},
	{12500, 164488, 3, 872},
	{12525, 164492, 2, 875},
	{12550, 164496, 3, 872},
	{12575, 164500, 2, 875},
	{12600, 164504, 3, 872},
	{12625, 164508, 2, 875},
	{12650, 164512, 3, 872},
	{12676, 164516, 2, 875},
	{12702, 164520, 3, 872},
	{12728, 164524, 2, 875},
	{12754, 164528, 3, 872},
	{12780, 164532, 2, 875},
	{12806, 164536, 3, 872},
	{12832, 164540, 2, 875},
	{12858, 164544, 3, 872},
	{12884, 164548, 2, 875},
	{12910, 164552, 3, 872},
	{12936, 164556, 2, 875},
	{12962, 164560, 1, 903},
	{12981, 164564, 1, 904},
	{13000, 164568, 1, 903},
	{13019, 164572, 1, 904},
	{13038, 164576, 1, 903},
	{13057, 164580, 1, 904},
	{13076, 164584, 1, 903},
	{13095, 164588, 1, 904},
	{13114, 164592, 1, 903},
	{13133, 164596, 1, 904},
	{13152, 164600, 1, 903},
	{13171, 164604, 1, 904},
	{13190, 164608, 1, 903},
	{13209, 164612, 1, 904},
	{13228, 164616, 1, 903},
	{13247, 164620, 1, 904},
	{13266, 164624, 1, 903},
	{13285, 164628, 1, 904},
	{13304, 164632, 1, 903},
	{13323, 164636, 1, 904},
	{13342, 164640, 1, 903},
	{13362, 164644, 1, 904},
	{13382, 164648, 1, 903},
	{13402, 164652, 1, 904},
	{13422, 164656, 1, 903},
	{13442, 164660, 1, 904},
	{13462, 164664, 1, 903},
	{13482, 164668, 1, 904},
	{13502, 164672, 1, 903},
	{13522, 164676, 1, 904},
	{13542, 164680, 1, 903},
	{13562, 164684, 1, 904},
	{13582, 164688, 15, 5102},
	{13602, 164692, 3, 5117},
	{13624, 164696, 2, 923},
	{13652, 164700, 3, 925},
	{13681, 164704, 1, 932},
	{13702, 164708, 1, 933},
	{13712, 164712, 1, 934},
	{13720, 164768, 4, 935},
	{13742, 164772, 4, 935},
	{13763, 164776, 4, 939},
	{13830, 164876, 1, 946},
	{13884, 164884, 1, 957},
	{13897, 164888, 1, 958},
	{13912, 164892, 1, 959},
	{13926, 164896, 1, 960},
	{13941, 164900, 9, 5120},
	{13980, 164908, 6, 973},
	{13999, 164912, 4, 979},
	{14017, 164916, 4, 983},
	{14038, 164924, 1, 987},
	{14057, 164928, 1, 988},
	{14077, 164932, 1, 989},
	{14096, 164936, 1, 990},
	{14116, 164940, 1, 991},
	{14135, 164944, 1, 992},
	{14155, 164948, 1, 987},
	{14176, 164952, 1, 988},
	{14198, 164956, 1, 989},
	{14219, 164960, 1, 990},
	{14241, 164964, 1, 991},
	{14262, 164968, 1, 992},
	{14284, 164972, 1, 987},
	{14305, 164976, 1, 988},
	{14327, 164980, 1, 989},
	{14348, 164984, 1, 990},
	{14370, 164988, 1, 991},
	{14391, 164992, 1, 992},
	{14413, 164996, 1, 987},
	{14434, 165000, 1, 988},
	{14456, 165004, 1, 989},
	{14477, 165008, 1, 990},
	{14499, 165012, 1, 991},
	{14520, 165016, 1, 992},
	{14542, 165020, 1, 987},
	{14563, 165024, 1, 988},
	{14585, 165028, 1, 989},
	{14606, 165032, 1, 990},
	{14628, 165036, 1, 991},
	{14649, 165040, 1, 992},
	{14671, 165044, 1, 987},
	{14692, 165048, 1, 988},
	{14714, 165052, 1, 989},
	{14735, 165056, 1, 990},
	{14757, 165060, 1, 991},
	{14778, 165064, 1, 992},
	{14800, 165068, 1, 987},
	{14821, 165072, 1, 988},
	{14843, 165076, 1, 989},
	{14864, 165080, 1, 990},
	{14886, 165084, 1, 991},
	{14907, 165088, 1, 992},
	{14929, 165092, 1, 987},
	{14950, 165096, 1, 988},
	{14972, 165100, 1, 989},
	{14993, 165104, 1, 990},
	{15015, 165108, 1, 991},
	{15036, 165112, 1, 992},
	{15058, 165116, 1, 987},
	{15079, 165120, 1, 988},
	{15101, 165124, 1, 989},
	{15122, 165128, 1, 990},
	{15144, 165132, 1, 991},
	{15165, 165136, 1, 992},
	{15187, 165140, 1, 987},
	{15208, 165144, 1, 988},
	{15230, 165148, 1, 989},
	{15251, 165152, 1, 990},
	{15273, 165156, 1, 991},
	{15294, 165160, 1, 992},
	{15316, 165164, 1, 987},
	{15338, 165168, 1, 988},
	{15361, 165172, 1, 989},
	{15383, 165176, 1, 990},
	{15406, 165180, 1, 991},
	{15428, 165184, 1, 992},
	{15451, 165188, 1, 987},
	{15473, 165192, 1, 988},
	{15496, 165196, 1, 989},
	{15518, 165200, 1, 990},
	{15541, 165204, 1, 991},
	{15563, 165208, 1, 992},
	{15586, 165212, 1, 987},
	{15608, 165216, 1, 988},
	{15631, 165220, 1, 989},
	{15653, 165224, 1, 990},
	{15676, 165228, 1, 991},
	{15698, 165232, 1, 992},
	{15721, 165236, 1, 987},
	{15743, 165240, 1, 988},
	{15766, 165244, 1, 989},
	{15788, 165248, 1, 990},
	{15811, 165252, 1, 991},
	{15833, 165256, 1, 992},
	{15856, 165260, 1, 987},
	{15878, 165264, 1, 988},
	{15901, 165268, 1, 989},
	{15923, 165272, 1, 990},
	{15946, 165276, 1, 991},
	{15968, 165280, 1, 992},
	{15991, 165284, 1, 987},
	{16013, 165288, 1, 988},
	{16036, 165292, 1, 989},
	{16058, 165296, 1, 990},
	{16081, 165300, 1, 991},
	{16103, 165304, 1, 992},
	{16126, 165308, 1, 993},
	{16140, 165312, 1, 993},
	{16154, 165316, 1, 993},
	{16168, 165320, 1, 993},
	{16182, 165324, 1, 993},
	{16196, 165328, 1, 993},
	{16210, 165332, 1, 993},
	{16224, 165336, 1, 993},
	{16238, 165340, 1, 993},
	{16252, 165344, 1, 993},
	{16266, 165348, 1, 993},
	{16280, 165352, 1, 993},
	{16294, 165356, 1, 993},
	{16308, 165360, 1, 993},
	{16322, 165364, 1, 993},
	{16336, 165368, 1, 993},
	{16350, 165372, 1, 993},
	{16364, 165376, 1, 993},
	{16378, 165380, 1, 993},
	{16392, 165384, 1, 993},
	{16406, 165388, 1, 993},
	{16420, 165392, 1, 993},
	{16434, 165396, 1, 993},
	{16448, 165400, 1, 993},
	{16462, 165404, 1, 993},
	{16485, 165444, 12, 994},
	{16505, 165448, 12, 994},
	{16525, 165452, 12, 994},
	{16545, 165456, 12, 994},
	{16565, 165460, 12, 994},
	{16585, 165464, 12, 994},
	{16605, 165468, 12, 994},
	{16625, 165472, 12, 994},
	{16645, 165476, 12, 994},
	{16665, 165480, 12, 994},
	{16685, 165484, 12, 994},
	{16706, 165488, 12, 994},
	{16727, 165492, 12, 994},
	{16748, 165496, 12, 994},
	{16769, 165500, 12, 994},
	{16790, 165504, 12, 994},
	{16811, 165508, 12, 994},
	{16832, 165512, 12, 994},
	{16853, 165516, 12, 994},
	{16874, 165520, 12, 994},
	{16895, 165524, 9, 1006},
	{16916, 165528, 9, 1006},
	{16937, 165532, 9, 1006},
	{16958, 165536, 9, 1006},
	{16979, 165540, 9, 1006},
	{17000, 165544, 9, 1006},
	{17021, 165548, 9, 1006},
	{17042, 165552, 9, 1006},
	{17063, 165556, 9, 1006},
	{17084, 165560, 9, 1006},
	{17105, 165564, 9, 1006},
	{17126, 165568, 9, 1006},
	{17147, 165572, 2, 1015},
	{17165, 165580, 16, 1018},
	{17182, 165584, 16, 1018},
	{17200, 165588, 7, 1034},
	{17221, 165592, 5, 1041},
	{17239, 165600, 7, 1047},
	{17254, 165608, 2, 712},
	{17293, 165644, 4, 1055},
	{17315, 165648, 1, 1060},
	{17335, 165652, 8, 1061},
	{17357, 165716, 8, 1069},
	{17375, 165720, 8, 1077},
	{17396, 165724, 17, 1085},
	{17417, 165728, 6, 1102},
	{17435, 165732, 6, 1102},
	{17453, 165736, 6, 1102},
	{17471, 165740, 6, 1102},
	{17489, 165744, 6, 1102},
	{17507, 165748, 6, 1102},
	{17525, 165752, 6, 1102},
	{17543, 165756, 6, 1102},
	{17561, 165760, 9, 1108},
	{17579, 165764, 9, 1108},
	{17597, 165768, 9, 1108},
	{17615, 165772, 9, 1108},
	{17633, 165776, 9, 1108},
	{17651, 165780, 9, 1108},
	{17669, 165784, 9, 1108},
	{17687, 165788, 9, 1108},
	{54699, 165792, 1, 5101},
	{54714, 165796, 1, 5101},
	{54729, 165800, 1, 5101},
	{54744, 165804, 1, 5101},
	{54759, 165808, 1, 5101},
	{54774, 165812, 1, 5101},
	{54789, 165816, 1, 5101},
	{54804, 165820, 1, 5101},
	{17705, 165836, 1, 1117},
	{17719, 165840, 1, 1117},
	{17734, 165844, 1, 993},
	{17752, 165848, 1, 993},
	{17770, 165852, 1, 993},
	{17787, 165856, 1, 993},
	{17808, 165860, 1, 1118},
	{17824, 165864, 1, 1119},
	{17837, 165872, 8, 1120},
	{17856, 165876, 1, 109},
	{17871, 165880, 1, 1128},
	{17920, 165888, 10, 1130},
	{17937, 165892, 12, 1140},
	{17945, 165896, 4, 4670},
	{17962, 165900, 16, 1156},
	{17980, 165904, 20, 1173},
	{17996, 165908, 15, 1193},
	{18015, 165912, 10, 1209},
	{18030, 165916, 28, 5129},
	{18048, 165920, 16, 1247},
	{18066, 165924, 4, 1263},
	{18090, 165928, 1, 1267},
	{18115, 165932, 11, 1268},
	{18138, 165936, 6, 5157},
	{18167, 165940, 3, 5163},
	{18189, 165944, 2, 1288},
	{18204, 165948, 5, 1290},
	{18234, 165952, 6, 5166},
	{18267, 166400, 2, 1301},
	{18284, 166404, 2, 1303},
	{18303, 166408, 1, 1305},
	{18319, 166412, 4, 1306},
	{18338, 166416, 1, 1310},
	{18359, 166420, 1, 1311},
	{18372, 166424, 1, 1312},
	{18395, 166428, 1, 1313},
	{18418, 166432, 1, 1314},
	{18438, 166436, 4, 1315},
	{18458, 166440, 1, 1319},
	{18479, 166444, 1, 1320},
	{18494, 166448, 6, 1321},
	{18516, 166452, 6, 1321},
	{18538, 166456, 8, 1327},
	{18564, 166460, 8, 1327},
	{18590, 166464, 15, 4538},
	{18602, 166468, 3, 1350},
	{18621, 166472, 7, 1353},
	{18639, 166476, 24, 1360},
	{18657, 166480, 1, 1384},
	{18669, 166484, 1, 1385},
	{18683, 166488, 1, 1386},
	{18697, 166492, 1, 1387},
	{18711, 166496, 1, 1388},
	{18734, 166500, 1, 1388},
	{18757, 166504, 1, 1388},
	{18780, 166508, 5, 1389},
	{18801, 166512, 1, 1384},
	{18812, 166516, 1, 1394},
	{18825, 166520, 1, 1395},
	{18842, 166524, 7, 5172},
	{18861, 166528, 1, 1384},
	{18872, 166532, 3, 1404},
	{18891, 166536, 1, 1407},
	{18913, 166540, 1, 1408},
	{18935, 166544, 3, 5179},
	{54819, 166548, 1, 5182},
	{18982, 166552, 4, 5183},
	{19004, 166560, 1, 1419},
	{19029, 166564, 1, 1419},
	{19073, 166572, 1, 1426},
	{19096, 166576, 1, 1426},
	{19119, 166580, 1, 1427},
	{19133, 166584, 1, 1428},
	{19148, 166588, 8, 5187},
	{19165, 166592, 4, 1438},
	{19192, 166596, 4, 1442},
	{19219, 166600, 4, 1446},
	{19238, 166608, 1, 674},
	{19264, 166612, 1, 1450},
	{19289, 166620, 1, 1451},
	{19317, 166624, 1, 674},
	{19343, 166628, 1, 1450},
	{19368, 166636, 1, 1451},
	{19396, 166640, 1, 674},
	{19422, 166644, 1, 1450},
	{19447, 166652, 1, 1451},
	{19475, 166656, 1, 674},
	{19501, 166660, 1, 1450},
	{19526, 166668, 1, 1451},
	{19554, 166696, 1, 1451},
	{19585, 166700, 1, 674},
	{19628, 166704, 1, 1452},
	{19666, 166712, 1, 1453},
	{19705, 166736, 5, 1456},
	{19727, 166740, 13, 5195},
	{19748, 166744, 3, 1480},
	{19765, 166748, 1, 1426},
	{19786, 166752, 1, 1426},
	{19809, 166756, 1, 1426},
	{19832, 166760, 1, 1426},
	{19855, 166764, 8, 5208},
	{19868, 166768, 6, 1495},
	{19885, 166772, 1, 1501},
	{19909, 166776, 2, 1502},
	{19939, 166780, 1, 1504},
	{19963, 166784, 1, 1505},
	{19993, 166788, 1, 1451},
	{20024, 166792, 1, 1505},
	{20053, 166796, 1, 1451},
	{20083, 166800, 2, 1506},
	{20103, 166804, 8, 1509},
	{20122, 166808, 4, 1517},
	{20148, 166812, 3, 5179},
	{20172, 166868, 8, 1521},
	{20198, 166872, 8, 1529},
	{20224, 166876, 5, 1537},
	{20240, 166880, 6, 1542},
	{20256, 166884, 3, 1548},
	{20271, 166888, 1, 993},
	{20294, 166892, 1, 993},
	{20317, 166896, 1, 993},
	{20340, 166900, 1, 993},
	{20363, 166904, 8, 1551},
	{20397, 166908, 8, 1559},
	{20431, 166912, 8, 1567},
	{20465, 166916, 8, 1575},
	{20499, 166920, 8, 1551},
	{20533, 166924, 8, 1559},
	{20567, 166928, 8, 1567},
	{20601, 166932, 8, 1575},
	{20635, 166936, 8, 1551},
	{20669, 166940, 8, 1559},
	{20703, 166944, 8, 1567},
	{20737, 166948, 8, 1575},
	{20771, 166952, 8, 1551},
	{20805, 166956, 8, 1559},
	{20839, 166960, 8, 1567},
	{20873, 166964, 8, 1575},
	{20907, 166968, 2, 1583},
	{20931, 166972, 2, 1585},
	{20955, 166976, 3, 1587},
	{20976, 166980, 11, 5216},
	{20996, 166984, 2, 1603},
	{21016, 166988, 18, 5227},
	{21054, 166992, 1, 1625},
	{21074, 167000, 1, 1627},
	{21102, 167004, 1, 1628},
	{21123, 167008, 1, 808},
	{23163, 167012, 1, 1677},
	{23899, 167016, 3, 1678},
	{21170, 167020, 3, 5245},
	{21185, 167024, 16, 5248},
	{21200, 167028, 10, 5264},
	{21217, 167032, 11, 1662},
	{21239, 167036, 1, 808},
	{23315, 167040, 1, 1677},
	{21277, 167044, 1, 808},
	{23515, 167048, 1, 1677},
	{21315, 167052, 1, 1675},
	{21337, 167056, 1, 1676},
	{21359, 167060, 1, 808},
	{23715, 167064, 1, 1677},
	{21378, 167068, 1, 808},
	{23182, 167072, 1, 1677},
	{23917, 167076, 3, 1678},
	{21425, 167080, 3, 5245},
	{21440, 167084, 16, 5248},
	{21455, 167088, 10, 5264},
	{21472, 167092, 11, 1662},
	{21494, 167096, 1, 808},
	{23340, 167100, 1, 1677},
	{21532, 167104, 1, 808},
	{23540, 167108, 1, 1677},
	{21570, 167112, 1, 1675},
	{21592, 167116, 1, 1676},
	{21614, 167120, 1, 808},
	{23738, 167124, 1, 1677},
	{21633, 167128, 1, 808},
	{23201, 167132, 1, 1677},
	{23935, 167136, 3, 1678},
	{21680, 167140, 3, 5245},
	{21695, 167144, 16, 5248},
	{21710, 167148, 10, 5264},
	{21727, 167152, 11, 1662},
	{21749, 167156, 1, 808},
	{23365, 167160, 1, 1677},
	{21787, 167164, 1, 808},
	{23565, 167168, 1, 1677},
	{21825, 167172, 1, 1675},
	{21847, 167176, 1, 1676},
	{21869, 167180, 1, 808},
	{23761, 167184, 1, 1677},
	{21888, 167188, 1, 808},
	{23220, 167192, 1, 1677},
	{23953, 167196, 3, 1678},
	{21935, 167200, 3, 5245},
	{21950, 167204, 16, 5248},
	{21965, 167208, 10, 5264},
	{21982, 167212, 11, 1662},
	{22004, 167216, 1, 808},
	{23390, 167220, 1, 1677},
	{22042, 167224, 1, 808},
	{23590, 167228, 1, 1677},
	{22080, 167232, 1, 1675},
	{22102, 167236, 1, 1676},
	{22124, 167240, 1, 808},
	{23784, 167244, 1, 1677},
	{22143, 167248, 1, 808},
	{23239, 167252, 1, 1677},
	{23971, 167256, 3, 1678},
	{22190, 167260, 3, 5245},
	{22205, 167264, 16, 5248},
	{22220, 167268, 10, 5264},
	{22237, 167272, 11, 1662},
	{22259, 167276, 1, 808},
	{23415, 167280, 1, 1677},
	{22297, 167284, 1, 808},
	{23615, 167288, 1, 1677},
	{22335, 167292, 1, 1675},
	{22357, 167296, 1, 1676},
	{22379, 167300, 1, 808},
	{23807, 167304, 1, 1677},
	{22398, 167308, 1, 808},
	{23258, 167312, 1, 1677},
	{23989, 167316, 3, 1678},
	{22445, 167320, 3, 5245},
	{22460, 167324, 16, 5248},
	{22475, 167328, 10, 5264},
	{22492, 167332, 11, 1662},
	{22514, 167336, 1, 808},
	{23440, 167340, 1, 1677},
	{22552, 167344, 1, 808},
	{23640, 167348, 1, 1677},
	{22590, 167352, 1, 1675},
	{22612, 167356, 1, 1676},
	{22634, 167360, 1, 808},
	{23830, 167364, 1, 1677},
	{22653, 167368, 1, 808},
	{23277, 167372, 1, 1677},
	{24007, 167376, 3, 1678},
	{22700, 167380, 3, 5245},
	{22715, 167384, 16, 5248},
	{22730, 167388, 10, 5264},
	{22747, 167392, 11, 1662},
	{22769, 167396, 1, 808},
	{23465, 167400, 1, 1677},
	{22807, 167404, 1, 808},
	{23665, 167408, 1, 1677},
	{22845, 167412, 1, 1675},
	{22867, 167416, 1, 1676},
	{22889, 167420, 1, 808},
	{23853, 167424, 1, 1677},
	{22908, 167428, 1, 808},
	{23296, 167432, 1, 1677},
	{24025, 167436, 3, 1678},
	{22955, 167440, 3, 5245},
	{22970, 167444, 16, 5248},
	{22985, 167448, 10, 5264},
	{23002, 167452, 11, 1662},
	{23024, 167456, 1, 808},
	{23490, 167460, 1, 1677},
	{23062, 167464, 1, 808},
	{23690, 167468, 1, 1677},
	{23100, 167472, 1, 1675},
	{23122, 167476, 1, 1676},
	{23144, 167480, 1, 808},
	{23876, 167484, 1, 1677},
	{24187, 196608, 1, 1689},
	{24207, 196612, 1, 1690},
	{24227, 196616, 1, 1691},
	{24247, 196620, 1, 1692},
	{24267, 196624, 1, 1693},
	{24288, 196628, 1, 1694},
	{24309, 196632, 1, 1695},
	{24331, 196636, 1, 1696},
	{24353, 196640, 1, 1697},
	{24383, 196644, 1, 1698},
	{24413, 196648, 1, 1699},
	{24442, 196652, 1, 1700},
	{24471, 196656, 1, 1701},
	{24501, 196660, 1, 1702},
	{24531, 196664, 1, 1703},
	{24560, 196668, 1, 1704},
	{24589, 196672, 1, 1705},
	{24619, 196676, 1, 1706},
	{24649, 196680, 1, 1707},
	{24678, 196684, 1, 1708},
	{24707, 196688, 1, 1709},
	{24737, 196692, 1, 1710},
	{24767, 196696, 1, 1711},
	{24796, 196700, 1, 1712},
	{24825, 196704, 1, 1713},
	{24847, 196708, 1, 1714},
	{24869, 196712, 1, 1715},
	{24892, 196716, 1, 1716},
	{24915, 196720, 1, 1717},
	{24938, 196724, 1, 1718},
	{24961, 196728, 1, 1719},
	{24984, 196732, 1, 1720},
	{25007, 196736, 1, 1721},
	{25031, 196740, 1, 1722},
	{25055, 196744, 1, 1723},
	{25079, 196748, 1, 1724},
	{25103, 196752, 1, 1725},
	{25127, 196756, 1, 1726},
	{25151, 196760, 1, 1727},
	{25175, 196764, 1, 1728},
	{25199, 196768, 1, 1729},
	{25221, 196772, 1, 1730},
	{25243, 196776, 1, 1731},
	{25264, 196780, 1, 1732},
	{25285, 196784, 1, 1733},
	{25309, 196788, 1, 1734},
	{25333, 196792, 1, 1735},
	{25357, 196796, 1, 1735},
	{25381, 196800, 1, 1736},
	{25405, 196804, 1, 1737},
	{25489, 196852, 1, 4610},
	{25511, 196856, 1, 4610},
	{25533, 196860, 1, 1740},
	{25549, 196864, 1, 1741},
	{25562, 196868, 1, 1742},
	{25575, 196872, 1, 1743},
	{25588, 196876, 1, 1744},
	{25601, 196880, 1, 1745},
	{25614, 196884, 1, 1746},
	{25627, 196888, 1, 1747},
	{25640, 196892, 1, 1748},
	{25695, 196912, 1, 109},
	{25713, 196916, 1, 1749},
	{25740, 196920, 1, 1749},
	{25767, 196928, 2, 1750},
	{25780, 196932, 1, 1752},
	{25793, 196936, 1, 1753},
	{25816, 196940, 1, 1754},
	{25839, 196944, 1, 1755},
	{25867, 196948, 1, 1756},
	{25895, 196952, 1, 1757},
	{25923, 196956, 1, 1758},
	{25951, 196960, 1, 1759},
	{25969, 196964, 4, 5274},
	{54849, 196968, 1, 109},
	{54867, 196972, 1, 1749},
	{54894, 196976, 1, 1749},
	{26050, 196980, 1, 1753},
	{26069, 196984, 1, 1754},
	{26088, 196988, 1, 1755},
	{26112, 196992, 1, 1756},
	{26136, 196996, 1, 1757},
	{26160, 197000, 1, 1758},
	{26184, 197028, 1, 1764},
	{26202, 197032, 2, 5278},
	{26220, 197036, 1, 1767},
	{26238, 197040, 1, 1768},
	{26256, 197044, 1, 1769},
	{26274, 197048, 2, 5280},
	{26292, 197052, 1, 1772},
	{26310, 197056, 2, 1773},
	{26329, 197060, 5, 1775},
	{26348, 197072, 1, 1780},
	{26372, 197076, 2, 1773},
	{26392, 197080, 5, 1775},
	{26412, 197084, 5, 5282},
	{26431, 197088, 5, 5282},
	{26449, 197092, 1, 1788},
	{26466, 197100, 1, 1789},
	{26487, 197104, 13, 1790},
	{26501, 197108, 1, 1803},
	{26515, 197112, 1, 1804},
	{26529, 197116, 2, 1805},
	{26545, 197120, 1, 1807},
	{26564, 197124, 1, 1808},
	{26586, 197128, 1, 1809},
	{26605, 197132, 1, 1810},
	{26627, 197136, 7, 1811},
	{26645, 197140, 1, 1807},
	{26665, 197144, 1, 1808},
	{26688, 197148, 1, 1809},
	{26708, 197152, 1, 1810},
	{26731, 197156, 7, 1811},
	{26750, 197160, 6, 5287},
	{26762, 197164, 2, 1825},
	{26779, 197168, 1, 1827},
	{26796, 197172, 1, 1828},
	{26814, 197176, 4, 1829},
	{26834, 197180, 1, 1833},
	{26851, 197184, 1, 340},
	{26867, 197188, 1, 1835},
	{26880, 197192, 1, 1836},
	{26894, 197196, 1, 1837},
	{26908, 197200, 1, 1838},
	{26930, 197204, 1, 1839},
	{26950, 197208, 1, 1840},
	{26972, 197212, 1, 1841},
	{26992, 197216, 1, 1836},
	{27009, 197220, 1, 1837},
	{27026, 197224, 1, 1842},
	{52809, 197228, 1, 1835},
	{27174, 197364, 1, 1847},
	{27195, 197368, 1, 1848},
	{27215, 197372, 1, 1849},
	{27235, 197376, 1, 1848},
	{27252, 197380, 1, 1849},
	{27269, 197384, 1, 1850},
	{27285, 197388, 1, 1851},
	{27304, 197392, 1, 1852},
	{27323, 197396, 1, 1853},
	{27340, 197400, 1, 1854},
	{27358, 197404, 1, 1855},
	{27376, 197408, 1, 1856},
	{27392, 197412, 1, 1857},
	{27410, 197416, 1, 1858},
	{27428, 197420, 1, 1859},
	{27444, 197424, 1, 1854},
	{27459, 197428, 1, 1855},
	{27474, 197432, 1, 1856},
	{27487, 197436, 1, 1857},
	{27502, 197440, 1, 1858},
	{27517, 197444, 1, 1859},
	{27530, 197448, 1, 1860},
	{27544, 197452, 1, 1861},
	{27558, 197456, 1, 1862},
	{27570, 197460, 4, 5293},
	{27593, 197464, 3, 1867},
	{27615, 197468, 1, 1870},
	{27759, 197552, 1, 1875},
	{27784, 197556, 1, 1875},
	{27808, 197560, 1, 1876},
	{27828, 197568, 1, 1877},
	{27854, 197572, 1, 1690},
	{27883, 197576, 1, 1877},
	{27908, 197580, 1, 1690},
	{27936, 197584, 1, 1877},
	{27959, 197588, 1, 1690},
	{27985, 197592, 1, 1877},
	{28007, 197596, 1, 1690},
	{28032, 197600, 1, 1877},
	{28051, 197604, 1, 1690},
	{28073, 197608, 1, 1396},
	{28087, 197612, 1, 1877},
	{28104, 197616, 1, 1690},
	{28124, 197620, 8, 1878},
	{28141, 197624, 13, 1886},
	{28158, 197628, 1, 1803},
	{28175, 197632, 1, 1827},
	{28195, 197636, 1, 1804},
	{28212, 197640, 1, 1788},
	{28232, 197644, 2, 1899},
	{28251, 197888, 8, 5297},
	{28272, 197892, 8, 5297},
	{28293, 198656, 6, 3087},
	{48498, 198916, 1, 1915},
	{28354, 198920, 1, 1916},
	{28373, 198924, 2, 5305},
	{28388, 198928, 1, 674},
	{28421, 198932, 1, 674},
	{28454, 198936, 1, 674},
	{28487, 198940, 1, 674},
	{13780, 198944, 1, 943},
	{13797, 198948, 1, 944},
	{13814, 198952, 1, 945},
	{18955, 198956, 2, 1412},
	{28577, 198960, 1, 1394},
	{28593, 198964, 1, 1407},
	{48992, 198968, 1, 1917},
	{49024, 198972, 2, 1918},
	{49045, 198976, 1, 1920},
	{54921, 198980, 1, 856},
	{28699, 198984, 1, 1920},
	{28715, 198988, 1, 856},
	{28734, 198992, 1, 1920},
	{28754, 198996, 1, 856},
	{28777, 199000, 1, 1920},
	{28795, 199004, 1, 856},
	{19054, 199008, 9, 1922},
	{28857, 199016, 1, 1931},
	{28997, 199168, 1, 1944},
	{29022, 199172, 2, 1945},
	{29047, 199184, 2, 1947},
	{29073, 199188, 2, 1947},
	{29099, 199192, 2, 1947},
	{29125, 199212, 2, 1947},
	{29151, 199296, 2, 1949},
	{29179, 199300, 1, 1951},
	{29203, 199304, 1, 1952},
	{29227, 199308, 1, 1953},
	{29260, 199312, 1, 1953},
	{29288, 199328, 2, 1949},
	{29317, 199332, 1, 1951},
	{29342, 199336, 1, 1952},
	{29367, 199340, 1, 1953},
	{29401, 199344, 1, 1953},
	{29430, 199360, 2, 1949},
	{29454, 199364, 1, 1951},
	{29474, 199368, 1, 1952},
	{29494, 199372, 1, 1953},
	{29523, 199376, 1, 1953},
	{18249, 199380, 1, 1300},
	{49611, 199872, 1, 737},
	{49632, 199876, 1, 3655},
	{2079, 199880, 7, 4210},
	{2100, 199884, 3, 3664},
	{49653, 199888, 2, 3667},
	{2127, 199892, 1, 3691},
	{49679, 199896, 15, 5307},
	{50682, 199900, 1, 4219},
	{50704, 199904, 1, 4658},
	{2058, 199908, 2, 3669},
	{2148, 199912, 6, 5322},
	{49721, 199916, 1, 3692},
	{49700, 199920, 1, 388},
	{29547, 199936, 1, 109},
	{29574, 199940, 1, 109},
	{29601, 199944, 1, 109},
	{29628, 199948, 1, 109},
	{29763, 199968, 6, 1954},
	{29774, 199972, 2, 1961},
	{29788, 200192, 1, 866},
	{29807, 200196, 1, 867},
	{29829, 200448, 1, 1963},
	{29853, 200452, 1, 1964},
	{29876, 200456, 1, 1963},
	{29900, 200460, 1, 1964},
	{29923, 200464, 1, 1963},
	{29947, 200468, 1, 1964},
	{29970, 200472, 1, 1963},
	{29994, 200476, 1, 1964},
	{30017, 200696, 1, 1963},
	{30036, 200700, 1, 1964},
	{30054, 200704, 1, 1965},
	{30066, 200708, 1, 1966},
	{30078, 200712, 1, 1967},
	{30096, 200716, 1, 1968},
	{30115, 200720, 1, 1969},
	{30133, 200724, 1, 1970},
	{30145, 200728, 1, 1971},
	{30157, 200732, 1, 1970},
	{30175, 200736, 1, 1971},
	{30193, 200740, 1, 1972},
	{30212, 200744, 4, 1973},
	{30226, 200748, 2, 1977},
	{30244, 200752, 2, 1979},
	{30258, 200756, 2, 1981},
	{30272, 200760, 2, 1983},
	{30289, 200764, 2, 1985},
	{30306, 200768, 1, 1987},
	{30319, 200772, 2, 1988},
	{30331, 200776, 1, 109},
	{30345, 200780, 1, 109},
	{30361, 200784, 1, 109},
	{30375, 200788, 1, 109},
	{30391, 200792, 1, 109},
	{30406, 200796, 1, 109},
	{30423, 200800, 1, 109},
	{30438, 200804, 1, 109},
	{30455, 200808, 2, 1990},
	{30477, 200812, 10, 5328},
	{30494, 200816, 2, 2002},
	{30515, 200820, 2, 2004},
	{30527, 200824, 1, 2006},
	{30542, 200828, 6, 4659},
	{30557, 200832, 2, 2013},
	{30571, 200836, 1, 2015},
	{2479, 200960, 9, 442},
	{54943, 200964, 11, 5338},
	{54961, 200968, 2, 5349},
	{54979, 200972, 4, 5351},
	{30684, 212992, 1, 2017},
	{30704, 212996, 1, 2018},
	{30724, 213000, 1, 2017},
	{30744, 213004, 1, 2018},
	{30764, 213008, 1, 2017},
	{30784, 213012, 1, 2018},
	{30804, 213016, 1, 2017},
	{30824, 213020, 1, 2018},
	{30844, 213024, 1, 2017},
	{30864, 213028, 1, 2018},
	{30884, 213032, 1, 2017},
	{30904, 213036, 1, 2018},
	{30924, 213040, 1, 109},
	{30947, 213044, 1, 109},
	{30970, 213048, 1, 109},
	{30993, 213248, 1, 2017},
	{31014, 213252, 1, 2018},
	{31035, 213260, 1, 2017},
	{31056, 213264, 1, 2018},
	{31077, 213268, 1, 2017},
	{31101, 213272, 1, 2018},
	{31125, 213276, 1, 2017},
	{31149, 213280, 1, 2018},
	{31173, 213284, 1, 2017},
	{31197, 213288, 1, 2018},
	{31221, 213292, 1, 2017},
	{31245, 213296, 1, 2018},
	{50794, 213504, 1, 2017},
	{50813, 213508, 1, 2018},
	{50832, 213512, 1, 2017},
	{50851, 213516, 1, 2018},
	{50870, 213520, 1, 2017},
	{50889, 213524, 1, 2018},
	{50908, 213528, 1, 2017},
	{50927, 213532, 1, 2018},
	{48189, 213536, 1, 2017},
	{48208, 213540, 1, 2018},
	{48227, 213544, 1, 2017},
	{48246, 213548, 1, 2018},
	{48265, 213552, 1, 2017},
	{48284, 213556, 1, 2018},
	{48303, 213560, 1, 2017},
	{48322, 213564, 1, 2018},
	{48780, 213568, 1, 2017},
	{48800, 213572, 1, 2018},
	{48820, 213576, 1, 2017},
	{48840, 213580, 1, 2018},
	{48860, 213584, 1, 2017},
	{48880, 213588, 1, 2018},
	{48900, 213592, 1, 2017},
	{48920, 213596, 1, 2018},
	{31729, 214016, 1, 2017},
	{31751, 214020, 1, 2019},
	{31773, 214024, 1, 2017},
	{31795, 214028, 1, 2019},
	{31817, 214032, 1, 2017},
	{31839, 214036, 1, 2019},
	{31861, 214040, 1, 2017},
	{31883, 214044, 1, 2019},
	{31905, 214272, 1, 2017},
	{31927, 214276, 1, 2018},
	{31949, 214280, 1, 2017},
	{31971, 214284, 1, 2018},
	{31993, 214288, 1, 2017},
	{32015, 214292, 1, 2018},
	{32037, 214296, 1, 2017},
	{32059, 214300, 1, 2018},
	{32081, 214304, 1, 2017},
	{32103, 214308, 1, 2018},
	{32125, 214312, 1, 2017},
	{32147, 214316, 1, 2018},
	{32169, 214320, 1, 2017},
	{32191, 214324, 1, 2018},
	{32213, 214328, 1, 2017},
	{32235, 214332, 1, 2018},
	{32257, 214528, 1, 2018},
	{32277, 214532, 1, 2017},
	{32297, 214536, 1, 2018},
	{32317, 214540, 1, 2017},
	{32337, 214544, 1, 2018},
	{32357, 214548, 1, 2017},
	{32377, 214552, 1, 2018},
	{32397, 214556, 1, 2017},
	{32417, 214560, 1, 2018},
	{32437, 214564, 1, 2017},
	{32457, 214568, 1, 2018},
	{32477, 214572, 1, 2017},
	{32497, 214784, 1, 2017},
	{32516, 214788, 1, 2018},
	{32535, 214792, 1, 2017},
	{32554, 214796, 1, 2018},
	{32573, 214800, 1, 2017},
	{32592, 214804, 1, 2018},
	{32611, 214808, 1, 2017},
	{32630, 214812, 1, 2018},
	{32649, 214816, 1, 2017},
	{32668, 214820, 1, 2018},
	{32687, 214824, 1, 2017},
	{32706, 214828, 1, 2018},
	{32725, 214832, 1, 2017},
	{32744, 214836, 1, 2018},
	{32763, 214840, 1, 2017},
	{32782, 214844, 1, 2018},
	{32801, 214848, 1, 2017},
	{32820, 214852, 1, 2018},
	{32839, 214856, 1, 2017},
	{32858, 214860, 1, 2018},
	{32877, 214864, 1, 2017},
	{32897, 214868, 1, 2018},
	{32917, 214872, 1, 2017},
	{32937, 214876, 1, 2018},
	{32957, 214880, 1, 2017},
	{32977, 214884, 1, 2018},
	{32997, 214888, 1, 2017},
	{33017, 214892, 1, 2018},
	{33037, 214896, 1, 2017},
	{33057, 214900, 1, 2018},
	{33077, 214904, 1, 2017},
	{33097, 214908, 1, 2018},
	{33117, 215296, 1, 2017},
	{33136, 215300, 1, 2018},
	{33155, 215304, 1, 2017},
	{33174, 215308, 1, 2018},
	{33193, 215312, 1, 2017},
	{33212, 215316, 1, 2018},
	{33231, 215320, 1, 2017},
	{33250, 215324, 1, 2018},
	{33311, 215552, 1, 2017},
	{33331, 215556, 1, 2018},
	{33351, 215560, 1, 2017},
	{33371, 215564, 1, 2018},
	{33391, 215568, 1, 2017},
	{33411, 215572, 1, 2018},
	{33431, 215576, 1, 2017},
	{33451, 215580, 1, 2018},
	{33471, 215808, 1, 2017},
	{33490, 215812, 1, 2018},
	{33509, 215816, 1, 2017},
	{33528, 215820, 1, 2018},
	{33547, 216064, 1, 2017},
	{33566, 216068, 1, 2018},
	{33585, 216072, 1, 2017},
	{33604, 216076, 1, 2018},
	{33623, 216320, 1, 2017},
	{33643, 216324, 1, 2018},
	{33663, 216328, 1, 2017},
	{33683, 216332, 1, 2018},
	{33703, 216336, 1, 2017},
	{33723, 216340, 1, 2018},
	{33743, 216344, 1, 2017},
	{33763, 216348, 1, 2018},
	{50946, 216576, 1, 2017},
	{50966, 216580, 1, 2018},
	{50986, 216584, 1, 2017},
	{51006, 216588, 1, 2018},
	{51026, 216592, 1, 2017},
	{51046, 216596, 1, 2018},
	{51066, 216600, 1, 2017},
	{51086, 216604, 1, 2018},
	{51106, 216640, 1, 2017},
	{51126, 216644, 1, 2018},
	{51146, 216648, 1, 2017},
	{51166, 216652, 1, 2018},
	{51186, 216656, 1, 2017},
	{51206, 216660, 1, 2018},
	{51226, 216664, 1, 2017},
	{51246, 216668, 1, 2018},
	{34615, 217112, 1, 2017},
	{34634, 217116, 1, 2018},
	{34653, 217120, 1, 2017},
	{34672, 217124, 1, 2018},
	{34691, 217128, 1, 2017},
	{34710, 217132, 1, 2018},
	{34729, 217136, 1, 2017},
	{34748, 217140, 1, 2018},
	{34767, 217344, 1, 2017},
	{34786, 217348, 1, 2018},
	{34805, 217352, 1, 2017},
	{34824, 217356, 1, 2018},
	{34843, 217360, 1, 2017},
	{34862, 217364, 1, 2018},
	{34881, 217368, 1, 2017},
	{34900, 217372, 1, 2018},
	{34919, 217600, 1, 2017},
	{34939, 217604, 1, 2018},
	{34959, 217608, 1, 2017},
	{34979, 217612, 1, 2018},
	{34999, 217856, 1, 2017},
	{35019, 217860, 1, 2018},
	{35039, 217864, 1, 2017},
	{35059, 217868, 1, 2018},
	{35079, 217872, 1, 2017},
	{35099, 217876, 1, 2018},
	{35119, 217880, 1, 2017},
	{35139, 217884, 1, 2018},
	{35162, 218112, 1, 2020},
	{35187, 218116, 2, 2021},
	{35211, 218144, 1, 2020},
	{35237, 218148, 2, 2021},
	{36301, 221184, 5, 5355},
	{36325, 221188, 4, 5360},
	{36350, 221192, 5, 5355},
	{36374, 221196, 5, 5355},
	{36398, 221200, 4, 5360},
	{36423, 221204, 5, 5355},
	{36447, 221208, 4, 5360},
	{36472, 221212, 5, 5355},
	{36496, 221216, 4, 2032},
	{36512, 221220, 5, 5355},
	{36536, 221224, 3, 2036},
	{36570, 221228, 3, 2039},
	{36604, 221232, 3, 2042},
	{36629, 221236, 3, 2045},
	{36654, 221240, 3, 5364},
	{36679, 221248, 1, 2048},
	{36694, 221252, 1, 1953},
	{36717, 221256, 1, 2049},
	{36740, 221260, 1, 2050},
	{36758, 221264, 2, 2051},
	{36776, 221268, 4, 2053},
	{36796, 221440, 22, 5367},
	{36821, 221444, 22, 5367},
	{36846, 221448, 13, 5389},
	{36874, 221452, 13, 5389},
	{36902, 221456, 13, 5389},
	{36930, 221460, 13, 5389},
	{51426, 221696, 2, 3435},
	{51449, 221700, 2, 3435},
	{51472, 221704, 2, 3435},
	{51495, 221708, 2, 3435},
	{48097, 221712, 5, 2111},
	{48120, 221716, 2, 3435},
	{48143, 221720, 2, 3435},
	{48166, 221724, 2, 3435},
	{51518, 221728, 4, 2116},
	{48684, 221744, 5, 2111},
	{48708, 221748, 5, 2111},
	{48732, 221752, 2, 3435},
	{48756, 221756, 2, 3435},
	{51542, 221760, 4, 2116},
	{51567, 221764, 4, 2116},
	{48658, 221776, 1, 3476},
	{37388, 222208, 5, 2111},
	{37414, 222212, 4, 2116},
	{37441, 222216, 5, 2111},
	{37467, 222220, 4, 2116},
	{37494, 222224, 3, 2167},
	{37547, 222228, 3, 2167},
	{37600, 222464, 5, 2111},
	{37626, 222468, 4, 2116},
	{37653, 222472, 1, 2023},
	{37679, 222476, 1, 2023},
	{37705, 222480, 1, 2023},
	{37731, 222484, 1, 2023},
	{37757, 222488, 1, 2023},
	{37783, 222492, 1, 2023},
	{37809, 222496, 1, 2023},
	{37835, 222720, 5, 2111},
	{37859, 222724, 5, 2111},
	{37883, 222728, 5, 2111},
	{37907, 222732, 5, 2111},
	{37931, 222736, 4, 2116},
	{37956, 222740, 4, 2116},
	{37981, 222744, 4, 2116},
	{38006, 222748, 4, 2116},
	{38031, 222752, 1, 2155},
	{38055, 222756, 1, 2155},
	{38079, 222760, 8, 2120},
	{38100, 222976, 6, 3634},
	{38123, 222980, 6, 3634},
	{38146, 222984, 6, 3634},
	{38169, 222988, 6, 3634},
	{38192, 222992, 6, 3634},
	{38215, 222996, 6, 3634},
	{38238, 223000, 6, 3634},
	{38261, 223004, 6, 3634},
	{38284, 223008, 6, 3634},
	{38307, 223012, 6, 3634},
	{38330, 223016, 6, 3634},
	{38354, 223020, 6, 3634},
	{38378, 223024, 6, 3634},
	{38402, 223028, 6, 3634},
	{38426, 223032, 6, 3634},
	{38450, 223036, 6, 3634},
	{38474, 223104, 9, 3617},
	{51592, 223108, 2, 3667},
	{38494, 223112, 1, 2141},
	{38589, 223488, 5, 2111},
	{38612, 223492, 5, 2111},
	{38635, 223496, 3, 2167},
	{38658, 223500, 3, 2167},
	{38681, 223504, 4, 2116},
	{38705, 223508, 4, 2116},
	{38729, 223744, 5, 2111},
	{38753, 223748, 5, 2111},
	{38777, 223752, 5, 2111},
	{38801, 223756, 5, 2111},
	{38825, 223760, 4, 2116},
	{38850, 224000, 5, 2155},
	{38873, 224004, 4, 2160},
	{38897, 224008, 3, 2164},
	{38920, 224256, 5, 2155},
	{38943, 224260, 4, 2160},
	{38967, 224264, 3, 2164},
	{38990, 224512, 5, 2111},
	{39014, 224516, 4, 2116},
	{39039, 224520, 5, 2111},
	{39063, 224524, 4, 2116},
	{39088, 224528, 3, 2167},
	{39112, 224532, 3, 2167},
	{51612, 224768, 5, 2111},
	{51636, 224772, 4, 2105},
	{51661, 224776, 5, 2111},
	{51685, 224780, 4, 2105},
	{51710, 224784, 3, 2167},
	{51734, 224788, 3, 2167},
	{51758, 224832, 5, 2111},
	{51782, 224836, 4, 2105},
	{51807, 224840, 5, 2111},
	{51831, 224844, 4, 2105},
	{51856, 224848, 3, 2167},
	{51880, 224852, 3, 2167},
	{39813, 225280, 12, 2170},
	{39835, 225284, 5, 2182},
	{39858, 225288, 4, 2187},
	{39882, 225292, 2, 2191},
	{39905, 225296, 2, 2191},
	{39928, 225300, 2, 2191},
	{39951, 225536, 5, 2111},
	{39974, 225540, 4, 2116},
	{39998, 225544, 5, 2111},
	{40021, 225548, 4, 2116},
	{40045, 225552, 5, 2111},
	{40068, 225560, 5, 2111},
	{40091, 225792, 4, 2193},
	{40112, 225796, 1, 2197},
	{40141, 225800, 2, 2198},
	{40170, 225804, 1, 2200},
	{40196, 225808, 7, 2201},
	{40270, 225812, 1, 4271},
	{40293, 225816, 1, 2213},
	{52025, 225820, 2, 4272},
	{52058, 225824, 2, 4272},
	{52091, 225828, 2, 4272},
	{52124, 225832, 2, 4272},
	{52156, 225836, 2, 4272},
	{52188, 225840, 2, 4272},
	{52220, 225844, 2, 4272},
	{52253, 225848, 2, 4272},
	{52285, 225856, 2, 4272},
	{52317, 225860, 2, 4272},
	{52350, 225864, 2, 4272},
	{52383, 225868, 2, 4272},
	{52416, 225872, 2, 4272},
	{52448, 225876, 2, 4272},
	{52480, 225880, 2, 4272},
	{52513, 225884, 2, 4272},
	{52546, 225888, 2, 4272},
	{52612, 225896, 2, 4272},
	{40316, 225900, 1, 4271},
	{40343, 225904, 1, 2213},
	{40225, 225908, 1, 2208},
	{40244, 225912, 1, 4274},
	{54999, 225932, 2, 4272},
	{55032, 225936, 2, 5402},
	{41234, 226040, 1, 2290},
	{41213, 226044, 1, 2290},
	{41006, 226048, 2, 2280},
	{41023, 226052, 1, 2282},
	{41047, 226056, 1, 2282},
	{41071, 226060, 4, 2283},
	{41097, 226064, 3, 2287},
	{41126, 226068, 1, 704},
	{41155, 226072, 3, 2287},
	{41184, 226076, 1, 704},
	{41261, 226304, 5, 2182},
	{41285, 226308, 4, 2187},
	{41310, 226312, 2, 2191},
	{41334, 226316, 5, 2182},
	{41358, 226320, 4, 2187},
	{41383, 226324, 2, 2191},
	{41407, 226328, 10, 2291},
	{41432, 226560, 5, 2301},
	{41459, 226564, 5, 2301},
	{41486, 226568, 6, 2306},
	{41517, 226608, 5, 2301},
	{41545, 226612, 5, 2301},
	{41573, 226616, 5, 2301},
	{41601, 226620, 5, 2301},
	{41629, 226624, 5, 2301},
	{41657, 226628, 5, 2301},
	{41685, 226632, 5, 2301},
	{41713, 226636, 5, 2301},
	{41741, 226640, 6, 2306},
	{195, 880, 4, 2317},
	{42792, 881},
	{26615, 882},
	{42804, 1008},
	{42815, 1009},
	{26803, 1010, 3, 2321},
	{42826, 1040, 1, 2324},
	{42839, 1041, 5, 2325},
	{42852, 1042, 1, 2330},
	{42865, 1043, 1, 1810},
	{26637, 1044, 7, 2331},
	{42893, 1280, 6, 2350},
	{42908, 1281},
	{26574, 1282},
	{42792, 1283},
	{26615, 1284},
};

static const struct si_field sid_fields_table[] = {
	/* 0 */
	{55065, 0xF},
	{55074, 0xF0},
	{55084, 0x100},
	{55095, 0x200},
	{55100, 0x400},
	{55227, 0x1FF000, 257, 0},
	{55235, 0x800000},
	{55245, 0x8000000},
	{55258, 0x10000000},
	{55264, 0xE0000000},
	/* 10 */
	{55268, 0x1},
	{55272, 0x6},
	{55281, 0x18},
	{55291, 0x20},
	{55296, 0x40},
	{55304, 0x80},
	{55314, 0x100},
	{55325, 0x200},
	{55331, 0x400},
	{55336, 0x800},
	{55342, 0x1000},
	{55353, 0x2000},
	{55358, 0x4000},
	{55363, 0x8000},
	{55114, 0x10000},
	{55378, 0x20000},
	{55386, 0x40000},
	{55398, 0x80000},
	{55406, 0x800000},
	{55417, 0x8000000},
	/* 30 */
	{55429, 0x1FF, 257, 0},
	{55434, 0x400},
	{55442, 0x800},
	{55455, 0x7000},
	{55463, 0x8000},
	{55474, 0xF0000},
	{55485, 0xF00000},
	{55501, 0x1000000},
	{55515, 0x10000000},
	{55527, 0xE0000000},
	/* 40 */
	{50450, 0xF},
	{55535, 0x30},
	{55543, 0xC0},
	{55551, 0xF00},
	{55557, 0x1000},
	{28872, 0x6000},
	{55563, 0x8000},
	{55575, 0xF0000},
	{55581, 0xF00000},
	{55587, 0x7000000},
	{55596, 0x38000000},
	{55605, 0xC0000000},
	/* 52 */
	{55611, 0xFF},
	{55621, 0xFF00},
	{55631, 0xFF0000},
	{55641, 0xF000000},
	/* 56 */
	{55651, 0x1FF},
	{55660, 0x1FF000},
	{55669, 0xF000000},
	/* 59 */
	{55686, 0xF},
	{55693, 0x70},
	{55701, 0x80},
	{55715, 0xF00},
	{55724, 0x7000},
	{55733, 0x8000},
	{55746, 0x3F0000},
	{55751, 0xC00000},
	{55761, 0x1000000},
	{55775, 0x2000000},
	{55787, 0xFC000000},
	/* 70 */
	{1082, 0xFFFFFFFF},
	/* 71 */
	{1096, 0xFFFF},
	/* 72 */
	{1110, 0xFFFFFFFF},
	/* 73 */
	{55515, 0x1},
	{55794, 0x2},
	{55800, 0x4},
	{55814, 0x8},
	{55829, 0x3F0},
	{55834, 0x1F800},
	{55746, 0xFC0000},
	{55839, 0x1000000},
	{55849, 0xFE000000},
	/* 82 */
	{55858, 0xFFFFFFFF},
	/* 83 */
	{50450, 0x1F},
	{55535, 0x300},
	{55865, 0x3C00},
	{55872, 0x10000},
	{28872, 0xC0000},
	/* 88 */
	{55587, 0xF},
	{55543, 0x30},
	{55605, 0x300},
	{55596, 0x7000},
	{55878, 0x1F0000},
	{55581, 0xF000000},
	{55884, 0x60000000},
	/* 95 */
	{55897, 0x1},
	{55905, 0x6},
	/* 97 */
	{55920, 0x3},
	/* 98 */
	{30340, 0x3F},
	{10065, 0xFC0},
	{10083, 0x3F000},
	{30315, 0xFC0000},
	/* 102 */
	{55929, 0x3},
	{55943, 0x80},
	{55961, 0x300},
	{55971, 0x400},
	{55984, 0x800},
	{55506, 0x1000},
	{55991, 0x2000},
	/* 109 */
	{391, 0xFFFFFFFF},
	/* 110 */
	{1495, 0xFFFFFFFF},
	/* 111 */
	{1506, 0xFFFFFFFF},
	/* 112 */
	{1522, 0xFFFFFFFF},
	/* 113 */
	{1597, 0xFFFFFFFF},
	/* 114 */
	{56001, 0xF},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56130, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56230, 0x4000},
	{56245, 0x8000},
	{56256, 0x10000},
	{56264, 0x20000},
	{56273, 0x40000},
	{56290, 0x80000},
	{56305, 0x100000},
	{56318, 0x200000},
	{56328, 0x400000},
	{56345, 0x800000},
	{56362, 0x1000000},
	{56371, 0x2000000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	{56407, 0x80000000},
	/* 141 */
	{56418, 0xF},
	{56441, 0x20},
	{56457, 0x80},
	{56480, 0x100},
	{56503, 0x200},
	{56522, 0x1000},
	{56531, 0x2000},
	{56540, 0x4000},
	{56548, 0x8000},
	{56557, 0x10000},
	{56572, 0x100000},
	{56580, 0x200000},
	{56588, 0x400000},
	{56597, 0x800000},
	{56606, 0x1000000},
	{56614, 0x2000000},
	{56622, 0x4000000},
	{56630, 0x10000000},
	{56372, 0x20000000},
	{56648, 0x40000000},
	{56656, 0x80000000},
	/* 162 */
	{56522, 0x2},
	{56531, 0x4},
	{56667, 0x8},
	{56371, 0x10},
	{56678, 0x20},
	{56264, 0x200000},
	{56597, 0x400000},
	{56614, 0x1000000},
	{56540, 0x2000000},
	{56572, 0x4000000},
	{56588, 0x8000000},
	{56606, 0x20000000},
	{56622, 0x40000000},
	{56648, 0x80000000},
	/* 176 */
	{56689, 0x20},
	{56718, 0x40},
	{56749, 0x80},
	{56778, 0x100},
	{56798, 0x200},
	{56818, 0x400},
	{56838, 0x800},
	{56858, 0x2000},
	{56866, 0x4000},
	{56874, 0x8000},
	{56678, 0x10000},
	{56885, 0x10000000},
	{56899, 0x20000000},
	{56667, 0x40000000},
	{56908, 0x80000000},
	/* 191 */
	{56917, 0x1},
	{56927, 0x2},
	{56937, 0x4},
	{56946, 0x8},
	{56955, 0x10},
	{56966, 0x20},
	{56977, 0x40},
	{56987, 0x80},
	{56997, 0x400},
	{57007, 0x800},
	{57024, 0x1000},
	{57032, 0x2000},
	{57045, 0x4000},
	{57063, 0x8000},
	{57074, 0x10000},
	{57083, 0x20000},
	{57104, 0x40000},
	{57115, 0x80000},
	{57142, 0x20000000},
	{57155, 0x40000000},
	{56389, 0x80000000},
	/* 212 */
	{57168, 0x1},
	{57183, 0x2},
	{57203, 0x4},
	{57219, 0x8},
	{57237, 0x10},
	{57257, 0x20},
	{57276, 0x40},
	{57295, 0x80},
	{57308, 0x100},
	{57322, 0x200},
	{57346, 0x400},
	{57362, 0x800},
	{57378, 0x1000},
	{57394, 0x2000},
	{57410, 0x10000},
	{57425, 0x20000},
	{57445, 0x40000},
	{57461, 0x80000},
	{57479, 0x100000},
	{57499, 0x200000},
	{57518, 0x400000},
	{57537, 0x800000},
	{57550, 0x1000000},
	{57564, 0x2000000},
	{57588, 0x4000000},
	{57604, 0x8000000},
	{57620, 0x10000000},
	{57636, 0x20000000},
	/* 240 */
	{57652, 0x8},
	{57671, 0x10},
	{57691, 0x40},
	{57710, 0x100},
	{57731, 0x200},
	{57749, 0x400},
	{57772, 0x2000},
	{57794, 0x10000},
	{57815, 0x20000},
	{57833, 0x40000},
	{57856, 0x200000},
	{57878, 0x400000},
	{57902, 0x800000},
	{57926, 0x1000000},
	{57949, 0x2000000},
	/* 255 */
	{57971, 0x1},
	{57990, 0x2},
	{57999, 0x10},
	{58014, 0x20},
	{58028, 0x40},
	{58047, 0x80},
	{58066, 0x100},
	{58081, 0x200},
	{58098, 0x400},
	{58120, 0x800},
	{58142, 0x1000},
	{58157, 0x2000},
	{56997, 0x4000},
	{58172, 0x8000},
	{58181, 0x10000},
	{57032, 0x20000},
	{58190, 0x40000},
	{58200, 0x80000},
	{58214, 0x100000},
	{58228, 0x200000},
	{58242, 0x400000},
	{57063, 0x800000},
	{58259, 0x1000000},
	{58272, 0x4000000},
	{58285, 0x8000000},
	{58298, 0x30000000},
	{58317, 0x40000000},
	{56380, 0x80000000},
	/* 283 */
	{58330, 0x1},
	{58348, 0x2},
	{58362, 0x4},
	{58381, 0x8},
	{58400, 0x10},
	{58415, 0x20},
	{58433, 0x40},
	{58451, 0x80},
	{58468, 0x100},
	{58483, 0x200},
	{58497, 0x400},
	{58514, 0x800},
	{58538, 0x1000},
	{58556, 0x2000},
	{58574, 0x4000},
	{58595, 0x8000},
	{58619, 0x10000},
	{58645, 0x20000},
	{58662, 0x40000},
	{58682, 0x80000},
	{58702, 0x100000},
	{58722, 0x200000},
	{58743, 0x400000},
	{58766, 0x800000},
	{58787, 0x1000000},
	{58806, 0x2000000},
	{58823, 0x4000000},
	{58839, 0x8000000},
	{58855, 0x10000000},
	{58871, 0x20000000},
	{58890, 0x40000000},
	{58902, 0x80000000},
	/* 315 */
	{58914, 0x1},
	{58933, 0x2},
	{58953, 0x4},
	{58973, 0x8},
	{58993, 0x20},
	{59014, 0x40},
	{57878, 0x80},
	{57902, 0x100},
	{59035, 0x200},
	{59062, 0x400},
	{59089, 0x800},
	{59110, 0x1000},
	{59129, 0x2000},
	/* 328 */
	{59148, 0x1},
	{59162, 0x4},
	{59177, 0x8},
	{59194, 0x80},
	{59206, 0x100},
	{59219, 0x400},
	{59234, 0x800},
	{59249, 0x1000},
	{59264, 0x2000},
	/* 337 */
	{1838, 0x3F},
	/* 338 */
	{1856, 0x1FF},
	{59279, 0x80000000},
	/* 340 */
	{1877, 0xFFFFFFFF},
	/* 341 */
	{1838, 0x7},
	/* 342 */
	{59304, 0x1000},
	{59326, 0x4000},
	{59351, 0x20000},
	{59372, 0x40000},
	{59396, 0x400000},
	{59423, 0x800000},
	{59448, 0x1000000},
	{59471, 0x8000000},
	{59491, 0x40000000},
	/* 351 */
	{1843, 0xF},
	/* 352 */
	{10011, 0xFFFFFFFF},
	/* 353 */
	{10044, 0xF},
	{38, 0x3FFFFF00},
	/* 355 */
	{738, 0x1FFFFFFF},
	{59507, 0x80000000},
	/* 357 */
	{59517, 0x3},
	{59526, 0xF0},
	{59534, 0x200},
	{59541, 0x1FC00},
	/* 361 */
	{59812, 0xFFF, 2049, 257},
	{59974, 0xFF0000, 129, 2306},
	{59986, 0x3000000},
	{59999, 0x80000000},
	/* 365 */
	{966, 0x3},
	{60014, 0x4},
	{60023, 0x8},
	{60034, 0x10},
	{60047, 0x20},
	{49737, 0x1C0},
	{60061, 0x200},
	{60074, 0x400},
	{60087, 0x800},
	{60099, 0x1000},
	{60117, 0x2000},
	{60128, 0xC000},
	{60143, 0x30000},
	{60151, 0x40000},
	{60170, 0x80000},
	{60187, 0x40000000},
	{60199, 0x80000000},
	/* 382 */
	{60213, 0xFFF},
	{60228, 0xFFF000},
	{60240, 0x1000000},
	{56251, 0x2000000},
	{60248, 0x4000000},
	{60268, 0x8000000},
	/* 388 */
	{2195, 0xFFFFFFFF},
	/* 389 */
	{13909, 0xF},
	{60356, 0x3F0, 33, 2435},
	{60360, 0x400},
	{60235, 0x800},
	{60366, 0x1000},
	/* 394 */
	{60369, 0xFFFFFFFF},
	/* 395 */
	{60382, 0xFFFF},
	{19659, 0x3FFF0000},
	{60398, 0x40000000},
	{60412, 0x80000000},
	/* 399 */
	{60427, 0xFFFFFFFF},
	/* 400 */
	{60439, 0x7},
	{60449, 0x38},
	{60459, 0x1C0},
	{60469, 0xE00},
	{17286, 0x7F000, 293, 2468},
	{64386, 0x600000},
	{64399, 0x800000},
	{64414, 0x1000000},
	{64520, 0x30000000, 4, 2761},
	{209, 0xC0000000},
	/* 410 */
	{64531, 0x7},
	{64539, 0x38},
	{64547, 0x1C0},
	{64555, 0xE00},
	{64571, 0x7000},
	{64590, 0x8000},
	{64609, 0x70000},
	{64625, 0x80000},
	{64640, 0x100000},
	{64654, 0x7E00000},
	{64665, 0x8000000},
	{64677, 0x10000000},
	{64695, 0x60000000},
	{64707, 0x80000000},
	/* 424 */
	{64720, 0xFFF},
	{64728, 0xFFF000},
	{64736, 0xF000000},
	{64745, 0xF0000000},
	/* 428 */
	{64752, 0x3FFF},
	{64761, 0xFFF},
	{64778, 0x3000},
	{64796, 0xFC000},
	{64809, 0x300000},
	{64823, 0xC00000},
	{64837, 0x3000000},
	{64846, 0xC000000},
	{64857, 0x10000000},
	{64876, 0x20000000},
	{64891, 0x40000000},
	{64906, 0x80000000},
	/* 440 */
	{64761, 0xFFF},
	{64778, 0xC0000000},
	/* 442 */
	{64922, 0x1FFFFF},
	{64941, 0xE00000},
	{64960, 0x1000000},
	{64982, 0x2000000},
	{65004, 0x4000000},
	{65020, 0x8000000},
	{65037, 0x10000000},
	{65055, 0x20000000},
	{65071, 0xC0000000},
	/* 451 */
	{65092, 0x7},
	{65102, 0x38},
	{65123, 0xC0},
	{65144, 0x180000},
	{65163, 0xC000000},
	/* 456 */
	{65533, 0x3C, 16, 2765},
	{65961, 0x7C0, 19, 2781},
	{66151, 0x3800, 7, 2800},
	{66310, 0x1C00000, 5, 2807},
	{66330, 0x6000000},
	/* 461 */
	{66435, 0x3, 4, 2812},
	{66542, 0xC, 4, 2816},
	{66654, 0x30, 4, 2820},
	{66741, 0xC0, 4, 2824},
	/* 465 */
	{60382, 0xFF},
	{64720, 0xFFF00},
	{17286, 0x1FF00000, 293, 2468},
	{66751, 0xC0000000},
	/* 469 */
	{66760, 0xFFF},
	{66547, 0xFFFC000},
	{64414, 0x80000000},
	/* 472 */
	{60439, 0x7},
	{60449, 0x38},
	{60459, 0x1C0},
	{60469, 0xE00},
	{66769, 0xF000},
	{66780, 0xF0000},
	{66791, 0x1F00000},
	{66895, 0xE000000, 6, 2828},
	{209, 0xF0000000},
	/* 481 */
	{18432, 0x1FFF},
	{66906, 0x1FFF0000},
	/* 483 */
	{66917, 0xF},
	{66929, 0xF0},
	{66937, 0xFFF00},
	{66950, 0x700000},
	{66959, 0x800000},
	{66974, 0x2000000},
	{66989, 0x4000000},
	/* 490 */
	{67001, 0xFF},
	{67017, 0x400},
	{67029, 0x18000},
	{67057, 0x60000},
	{67083, 0x80000},
	{67101, 0x100000},
	{67123, 0x200000},
	{67138, 0x400000},
	{67154, 0x800000},
	{67170, 0xFF000000},
	/* 500 */
	{67191, 0xFFFF},
	/* 501 */
	{67197, 0xFFFFFFFF},
	/* 502 */
	{67191, 0xFFFF},
	{67206, 0x3F0000},
	{67217, 0x3C00000},
	/* 505 */
	{67236, 0xFFFFFFFF},
	/* 506 */
	{67236, 0xFF},
	/* 507 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67321, 0x1000000},
	{67338, 0x2000000},
	{55971, 0x4000000},
	{55235, 0x20000000},
	/* 518 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67384, 0x80},
	{67396, 0xFF00},
	{55227, 0x1FF0000, 257, 0},
	{67411, 0x2000000},
	{67433, 0x4000000},
	{67458, 0x8000000},
	{67472, 0xF0000000},
	/* 528 */
	{67488, 0x1},
	{67505, 0x1E},
	{67531, 0x1E0},
	{67564, 0x200},
	{67585, 0x7C00},
	{67609, 0x8000},
	{67634, 0x10000},
	{67653, 0xE0000},
	/* 536 */
	{67690, 0x7},
	{67719, 0x38},
	{67751, 0x40},
	{67767, 0xFF00},
	{67796, 0xFF0000},
	/* 541 */
	{67828, 0x7F},
	/* 542 */
	{67211, 0x3F},
	/* 543 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{67855, 0x4000000},
	{67338, 0x8000000},
	{55971, 0x10000000},
	{55235, 0x80000000},
	/* 555 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{67881, 0x100},
	{67893, 0x200},
	{67905, 0x400},
	{67917, 0x800},
	{67929, 0x1000},
	{55227, 0x3FE000, 257, 0},
	{67935, 0x400000},
	{67946, 0x1000000},
	{67458, 0x8000000},
	{67472, 0xF0000000},
	/* 569 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55227, 0xFF80, 257, 0},
	{67841, 0x30000},
	{67871, 0x40000},
	{55660, 0x7F80000},
	{67963, 0x8000000},
	{67458, 0x10000000},
	/* 578 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{55227, 0x1FF00, 257, 0},
	{55660, 0x1FF00000},
	/* 584 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55660, 0xFF80},
	{55227, 0x1FF0000, 257, 0},
	/* 589 */
	{67191, 0xFFFF},
	{67975, 0x7F0000},
	/* 591 */
	{67191, 0xFFFF},
	{67206, 0x3F0000},
	{67217, 0x3C00000},
	{68000, 0xFC000000},
	/* 595 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67855, 0x1000000},
	{67338, 0x2000000},
	{55971, 0x4000000},
	{68017, 0x8000000},
	{68026, 0x60000000},
	{55235, 0x80000000},
	/* 608 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55227, 0xFF80, 257, 0},
	{68043, 0x30000},
	{67871, 0x40000},
	{55660, 0x7F80000},
	{67458, 0x8000000},
	{67472, 0xF0000000},
	/* 617 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{67855, 0x4000000},
	{55235, 0x80000000},
	/* 627 */
	{67206, 0x3F},
	{67217, 0x3C0},
	{68000, 0xFC00},
	{67191, 0xFFFF0000},
	/* 631 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67338, 0x1000000},
	{55971, 0x2000000},
	{68017, 0x4000000},
	{68060, 0x30000000},
	{55235, 0x40000000},
	/* 643 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{68077, 0x100},
	{55227, 0x3FE00, 257, 0},
	{55660, 0x7FC0000},
	{67458, 0x8000000},
	{67472, 0xF0000000},
	/* 652 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{55235, 0x40000000},
	/* 661 */
	{68088, 0x1},
	{68106, 0x2},
	{68120, 0x4},
	{68139, 0x8},
	{68159, 0x10},
	{68179, 0x20},
	{68201, 0x40},
	{68212, 0x400},
	{68230, 0x800},
	{10349, 0x1000},
	{68248, 0x2000},
	{68262, 0x4000},
	{68270, 0x8000},
	/* 674 */
	{38, 0xFFFFFFFF},
	/* 675 */
	{68280, 0xFFFFFFFF},
	/* 676 */
	{68286, 0xFFFF},
	{68302, 0xFFFF0000},
	/* 678 */
	{9853, 0x1},
	/* 679 */
	{9881, 0x1},
	/* 680 */
	{391, 0xFF},
	/* 681 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{68321, 0x1000000},
	{55235, 0x4000000},
	{68017, 0x20000000},
	{67338, 0x40000000},
	{55971, 0x80000000},
	/* 693 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{68327, 0x80},
	{68337, 0x100},
	{68347, 0x200},
	{68077, 0x400},
	{68357, 0x1800},
	{68372, 0x6000},
	{55660, 0xFF8000},
	{55227, 0x7F000000, 257, 0},
	/* 704 */
	{391, 0xF},
	/* 705 */
	{68384, 0x3FF},
	{68397, 0xF000},
	{68407, 0x3F0000},
	{68422, 0x400000},
	{68437, 0x800000},
	{68453, 0x7000000},
	/* 711 */
	{67191, 0xFFFFFFFF},
	/* 712 */
	{68468, 0xFFF},
	{68474, 0x1FFF000},
	/* 714 */
	{68483, 0xFFFFFFFF},
	/* 715 */
	{10316, 0x1},
	/* 716 */
	{68491, 0x3},
	{65616, 0x4},
	{68501, 0x8},
	{68511, 0x10},
	{68521, 0x1FFE0},
	/* 721 */
	{10366, 0xFFFFFFFF},
	/* 722 */
	{10386, 0xFFFFFFFF},
	/* 723 */
	{67488, 0x1},
	{67505, 0x1E},
	{67531, 0x1E0},
	{67564, 0x200},
	{67585, 0x7C00},
	{67609, 0x8000},
	{67634, 0x10000},
	{67653, 0xE0000},
	{68534, 0x7F00000},
	/* 732 */
	{67472, 0xF},
	/* 733 */
	{441, 0x7FF},
	/* 734 */
	{68571, 0x3FFFFFFF},
	{68579, 0x40000000},
	{68588, 0x80000000},
	/* 737 */
	{11598, 0xFFFFFFFF},
	/* 738 */
	{11598, 0xFFFF},
	/* 739 */
	{68597, 0x3FF},
	{59680, 0x400},
	/* 741 */
	{68607, 0x1},
	{68626, 0x2},
	{68647, 0x4},
	{68658, 0x8},
	{68671, 0x10},
	{68690, 0x20},
	{68715, 0x40},
	{68738, 0x80},
	{68752, 0xF00},
	{68764, 0x1000},
	/* 751 */
	{68782, 0x1},
	{68806, 0x2},
	{68827, 0x4},
	{68861, 0x8},
	{68896, 0x70},
	{68908, 0xF00},
	{68921, 0xF000},
	{68934, 0xF0000},
	{68947, 0xF00000},
	{68961, 0xF000000},
	{68979, 0xF0000000},
	/* 762 */
	{68996, 0x7FF},
	{69008, 0x1800},
	{69023, 0xFFE000},
	{69033, 0x1000000},
	{69045, 0x2000000},
	{69063, 0x3C000000},
	{69069, 0xC0000000},
	/* 769 */
	{69134, 0x3, 4, 3075},
	{69151, 0xC, 4, 3075},
	{69169, 0x30, 4, 3075},
	{69187, 0x40},
	{69208, 0x80},
	{69223, 0x100},
	{69244, 0x200},
	{69262, 0x400},
	{69279, 0x800},
	{69292, 0x1000},
	{69311, 0x6000, 4, 3075},
	{69330, 0x8000},
	{69354, 0x10000},
	{69377, 0x20000},
	{69394, 0x40000},
	{69479, 0x180000, 4, 3079},
	{69498, 0x3E00000},
	{69515, 0x4000000},
	{69539, 0x8000000},
	{69553, 0x10000000},
	{69573, 0x20000000},
	{69587, 0x40000000},
	{69607, 0x80000000},
	/* 792 */
	{69681, 0x3, 4, 3083},
	{69710, 0x1C},
	{69741, 0x20},
	{69777, 0x40},
	{69812, 0x80},
	{69840, 0x100},
	{69862, 0x200},
	{69880, 0x400},
	{69912, 0x800},
	{70033, 0x7000, 8, 3087},
	{70043, 0x38000},
	{70056, 0x1C0000},
	{70069, 0x200000},
	{70085, 0x400000},
	{70103, 0x800000},
	{70121, 0x2000000},
	/* 808 */
	{70149, 0xFFFFFFFF},
	/* 809 */
	{70159, 0x3FFF},
	{55059, 0x3FFF0000},
	/* 811 */
	{11181, 0xFFFFFFFF},
	/* 812 */
	{11201, 0xFFFFFFFF},
	/* 813 */
	{11216, 0xFF},
	/* 814 */
	{11225, 0xFFFFFFFF},
	/* 815 */
	{70165, 0xFFFF},
	{70170, 0xFFFF0000},
	/* 817 */
	{70175, 0xFFFF},
	{70180, 0xFFFF0000},
	/* 819 */
	{70194, 0x3, 4, 3095},
	{70208, 0x4},
	{70233, 0x8},
	/* 822 */
	{70251, 0xF},
	{70259, 0xF0},
	{70267, 0x1F00},
	{70275, 0x6000},
	{70283, 0x18000},
	{70291, 0x60000},
	{70299, 0x180000},
	{64414, 0xF0000000},
	/* 830 */
	{17286, 0x3, 4, 3099},
	{70338, 0xC},
	{66791, 0x1F0},
	{70393, 0x600, 4, 3103},
	{70408, 0x800},
	{70422, 0x1000},
	{70441, 0xE000},
	{70458, 0xF0000},
	{67017, 0x100000},
	{70465, 0x7800000},
	{70489, 0x8000000},
	{70504, 0x10000000},
	{70514, 0x20000000},
	{70534, 0x80000000},
	/* 844 */
	{17286, 0x1, 2, 3107},
	{66791, 0x1F0},
	{70393, 0x600, 4, 3103},
	{70408, 0x800},
	{70422, 0x1000},
	{70441, 0xE000},
	{67017, 0x100000},
	{70489, 0x8000000},
	{70577, 0x20000000},
	/* 853 */
	{70251, 0x7FF},
	{70259, 0x3FF800},
	/* 855 */
	{70251, 0x3FFFFF},
	/* 856 */
	{10044, 0xFF},
	/* 857 */
	{70649, 0x3, 4, 3109},
	{70661, 0xC, 4, 3109},
	{70673, 0x30, 4, 3109},
	{70689, 0xC0, 4, 3109},
	{70759, 0x30000, 4, 3113},
	{70771, 0xC0000, 4, 3113},
	{70783, 0x300000, 4, 3113},
	{70799, 0x1000000},
	{70810, 0x2000000},
	/* 866 */
	{30549, 0xFFFFFFFF},
	/* 867 */
	{30549, 0xFF},
	/* 868 */
	{70821, 0xFF},
	/* 869 */
	{70839, 0xFFFFFFFF},
	/* 870 */
	{70854, 0xFFFF},
	{70870, 0xFFFF0000},
	/* 872 */
	{70165, 0x7FFF},
	{70170, 0x7FFF0000},
	{70886, 0x80000000},
	/* 875 */
	{70175, 0x7FFF},
	{70180, 0x7FFF0000},
	/* 877 */
	{70974, 0xFFFF, 32769, 3117},
	/* 878 */
	{70984, 0xF},
	{70991, 0xF0},
	{71000, 0xF00},
	{71008, 0x3F000},
	{71019, 0xFC0000},
	{71030, 0xF000000},
	{71041, 0xF0000000},
	/* 885 */
	{71052, 0x1FF},
	{71071, 0x1FF0000},
	/* 887 */
	{71090, 0xF},
	{71105, 0xF0},
	{71120, 0xF00},
	{71135, 0xF000},
	{71150, 0xF0000},
	{71165, 0xF00000},
	{71180, 0xF000000},
	{71195, 0xF0000000},
	/* 895 */
	{71210, 0xF},
	{71225, 0xF0},
	{71240, 0xF00},
	{71255, 0xF000},
	{71270, 0xF0000},
	{71285, 0xF00000},
	{71300, 0xF000000},
	{71315, 0xF0000000},
	/* 903 */
	{71330, 0xFFFFFFFF},
	/* 904 */
	{71341, 0xFFFFFFFF},
	/* 905 */
	{71444, 0x3, 4, 35886},
	{71456, 0xC, 4, 35886},
	{71568, 0x30, 4, 35890},
	{71625, 0x40, 2, 35894},
	{71681, 0x80, 2, 35896},
	{71785, 0x300, 4, 35898},
	{71893, 0xC00, 4, 35902},
	{72002, 0x3000, 4, 35906},
	{72115, 0xC000, 4, 35910},
	{72217, 0x30000, 4, 35914},
	{72363, 0xC0000, 4, 35918},
	{72510, 0x300000, 4, 35922},
	{72610, 0x3000000, 4, 35926},
	{72756, 0xC000000, 4, 35930},
	{72903, 0x30000000, 4, 35934},
	/* 920 */
	{73023, 0x3, 4, 35938},
	{73194, 0xC, 4, 35942},
	{73366, 0x30, 4, 35946},
	/* 923 */
	{68961, 0x3},
	{68979, 0xC},
	/* 925 */
	{9866, 0x1},
	{73379, 0x6},
	{65163, 0x60},
	{73386, 0x100},
	{73421, 0x3000},
	{73428, 0x30000},
	{73442, 0x100000},
	/* 932 */
	{73460, 0x80000000},
	/* 933 */
	{55543, 0x3},
	/* 934 */
	{10096, 0xF},
	/* 935 */
	{73475, 0xFF},
	{73484, 0xFF00},
	{73494, 0xFF0000},
	{73505, 0xFF000000},
	/* 939 */
	{73515, 0xFF},
	{73523, 0xFF00},
	{73532, 0xFF0000},
	{73541, 0xFF000000},
	/* 943 */
	{73549, 0xFFFFFFFF},
	/* 944 */
	{73558, 0xFFFFFFFF},
	/* 945 */
	{13818, 0xFFFFFFFF},
	/* 946 */
	{13848, 0xFFFFFFFF},
	/* 947 */
	{73567, 0x3, 4, 3109},
	{73583, 0xC, 4, 3109},
	{73599, 0x30, 4, 3109},
	{73613, 0xC0, 4, 3109},
	{73629, 0x30000, 4, 3113},
	{73645, 0xC0000, 4, 3113},
	{73661, 0x300000, 4, 3113},
	{73675, 0xC00000, 4, 3113},
	{73691, 0x40000000},
	{73706, 0x80000000},
	/* 957 */
	{13887, 0xFFFFFFFF},
	/* 958 */
	{13900, 0xFFFFFFFF},
	/* 959 */
	{13915, 0xFFFFFFFF},
	/* 960 */
	{13929, 0xFFFFFFFF},
	/* 961 */
	{73721, 0x1},
	{73748, 0x7C},
	{73777, 0x100},
	{73806, 0x200},
	{73837, 0x400},
	{73865, 0x1000},
	{73893, 0x2000},
	{73923, 0x4000},
	/* 969 */
	{73949, 0x1},
	{73969, 0xE},
	{73986, 0x30},
	{74007, 0xF00},
	/* 973 */
	{74265, 0xF, 16, 35950},
	{74277, 0xF0, 16, 35950},
	{74290, 0xF00, 16, 35950},
	{74303, 0xF000, 16, 35950},
	{74318, 0xF0000, 16, 35950},
	{74334, 0xF00000, 16, 35950},
	/* 979 */
	{74350, 0xFF},
	{74365, 0xFF00},
	{74377, 0xFF0000},
	{74394, 0xFF000000},
	/* 983 */
	{74407, 0xFF},
	{74425, 0xFF00},
	{74440, 0xFF0000},
	{74460, 0xFF000000},
	/* 987 */
	{14044, 0xFFFFFFFF},
	/* 988 */
	{14063, 0xFFFFFFFF},
	/* 989 */
	{14083, 0xFFFFFFFF},
	/* 990 */
	{14102, 0xFFFFFFFF},
	/* 991 */
	{14122, 0xFFFFFFFF},
	/* 992 */
	{14141, 0xFFFFFFFF},
	/* 993 */
	{74476, 0xFFFFFFFF},
	/* 994 */
	{738, 0x3F},
	{74490, 0x300},
	{74502, 0x400},
	{74513, 0x1E000},
	{74522, 0x20000},
	{74536, 0x40000},
	{74540, 0x80000},
	{74557, 0x100000},
	{74575, 0x600000},
	{74593, 0x800000},
	{74613, 0x1000000},
	{74625, 0x2000000},
	/* 1006 */
	{738, 0x3F},
	{74490, 0x300},
	{74502, 0x400},
	{74536, 0x40000},
	{74540, 0x80000},
	{74557, 0x100000},
	{74575, 0x600000},
	{74613, 0x1000000},
	{74625, 0x2000000},
	/* 1015 */
	{74637, 0x3E},
	{74653, 0x40},
	{74666, 0x80},
	/* 1018 */
	{74679, 0x1},
	{74696, 0x2},
	{74713, 0x4},
	{74732, 0x8},
	{74753, 0x10},
	{74771, 0x20},
	{74789, 0x40},
	{74809, 0x80},
	{74830, 0x100},
	{74846, 0x200},
	{74862, 0x400},
	{74878, 0x800},
	{74894, 0x1000},
	{74909, 0x2000},
	{74923, 0x4000},
	{74943, 0x8000},
	/* 1034 */
	{74960, 0x1},
	{74975, 0x2},
	{75098, 0x1C, 5, 35966},
	{75116, 0xE0, 5, 35966},
	{75134, 0x700, 5, 35966},
	{75152, 0x3800, 5, 35966},
	{75170, 0x4000},
	/* 1041 */
	{75187, 0x3F},
	{75198, 0x40},
	{75208, 0x80},
	{75225, 0x100},
	{75241, 0x4000},
	{75261, 0x8000},
	/* 1047 */
	{75271, 0x1},
	{75289, 0x10},
	{75309, 0x100},
	{75328, 0x1000},
	{75349, 0x30000},
	{75368, 0x100000},
	{75382, 0x1000000},
	/* 1054 */
	{75490, 0xF, 5, 35971},
	/* 1055 */
	{75509, 0xF, 5, 35971},
	{75528, 0xF0, 5, 35971},
	{75547, 0xF00, 5, 35971},
	{75566, 0xF000, 5, 35971},
	{75585, 0xF0000, 5, 35971},
	/* 1060 */
	{75804, 0xF, 10, 35976},
	/* 1061 */
	{75820, 0xF, 10, 35976},
	{75839, 0xF0, 10, 35976},
	{75858, 0xF00, 10, 35976},
	{75877, 0xF000, 10, 35976},
	{75896, 0xF0000, 10, 35976},
	{75915, 0xF00000, 10, 35976},
	{75934, 0xF000000, 10, 35976},
	{75953, 0xF0000000, 10, 35976},
	/* 1069 */
	{76207, 0xF, 11, 35986},
	{76212, 0xF0, 11, 35986},
	{76217, 0xF00, 11, 35986},
	{76222, 0xF000, 11, 35986},
	{76227, 0xF0000, 11, 35986},
	{76232, 0xF00000, 11, 35986},
	{76237, 0xF000000, 11, 35986},
	{76242, 0xF0000000, 11, 35986},
	/* 1077 */
	{76321, 0xF, 16, 35997},
	{76334, 0xF0},
	{76347, 0xF00},
	{76360, 0xF000},
	{76373, 0xF0000},
	{76386, 0xF00000},
	{76399, 0xF000000},
	{76412, 0xF0000000},
	/* 1085 */
	{76425, 0x1},
	{76448, 0x2},
	{76471, 0x10},
	{76494, 0x20},
	{76517, 0x100},
	{76540, 0x200},
	{76563, 0x1000},
	{76586, 0x2000},
	{76609, 0x10000},
	{76632, 0x20000},
	{76655, 0x100000},
	{76678, 0x200000},
	{76701, 0x1000000},
	{76724, 0x2000000},
	{76747, 0x10000000},
	{76770, 0x20000000},
	{76793, 0x80000000},
	/* 1102 */
	{77084, 0x7, 8, 36013},
	{77098, 0x70, 8, 36013},
	{77246, 0x700, 8, 36021},
	{77261, 0x70000, 8, 36013},
	{77275, 0x700000, 8, 36013},
	{77289, 0x7000000, 8, 36021},
	/* 1108 */
	{77744, 0x1F, 21, 36029},
	{77246, 0xE0, 5, 36050},
	{77849, 0x1F00, 21, 36029},
	{77865, 0x1F0000, 21, 36029},
	{77289, 0xE00000, 5, 36050},
	{77880, 0x1F000000, 21, 36029},
	{77896, 0x20000000},
	{9866, 0x40000000},
	{77917, 0x80000000},
	/* 1117 */
	{77930, 0x7},
	/* 1118 */
	{11593, 0xFFFF},
	/* 1119 */
	{11593, 0xFFFFFFFF},
	/* 1120 */
	{78021, 0x3, 4, 36055},
	{78067, 0xC, 2, 36059},
	{78078, 0x10},
	{78093, 0x20},
	{78101, 0x40},
	{78112, 0x80},
	{78126, 0x100},
	{78143, 0xE0000000},
	/* 1128 */
	{78156, 0xFFFFFFF},
	/* 1129 */
	{78168, 0x3FF},
	/* 1130 */
	{78191, 0x1},
	{69142, 0x2},
	{78206, 0x4},
	{78221, 0x8},
	{70037, 0x70, 8, 3087},
	{78241, 0x80},
	{78257, 0x700, 8, 3087},
	{78269, 0x700000, 8, 3087},
	{78284, 0x40000000},
	{78318, 0x80000000},
	/* 1140 */
	{78353, 0x7},
	{78372, 0x70},
	{78388, 0x700},
	{78412, 0x7000},
	{78438, 0x10000},
	{78465, 0x20000},
	{78487, 0x40000},
	{78506, 0x80000},
	{78524, 0x100000},
	{78551, 0x200000},
	{78578, 0x7000000},
	{78603, 0x8000000},
	/* 1152 */
	{78634, 0x1},
	{78652, 0x8},
	{966, 0x70, 8, 36061},
	{77925, 0xFF0000, 256, 36069},
	/* 1156 */
	{79072, 0x1},
	{79088, 0x2},
	{79119, 0x4},
	{69200, 0x30, 4, 36325},
	{79198, 0x40},
	{79210, 0x80},
	{79234, 0x100},
	{79253, 0x200},
	{79271, 0x400},
	{79284, 0x800},
	{79306, 0x1000},
	{79396, 0x6000, 4, 36329},
	{79418, 0x8000},
	{79436, 0x10000},
	{79467, 0x20000},
	{79486, 0x700000},
	{79511, 0x800000},
	/* 1173 */
	{79544, 0x1},
	{79554, 0x2},
	{79564, 0x4},
	{79574, 0x8},
	{79584, 0x10},
	{79594, 0x20},
	{79604, 0x2000},
	{79623, 0xC000},
	{79635, 0x10000},
	{79648, 0x20000},
	{79666, 0x40000},
	{79689, 0x80000},
	{79707, 0x100000},
	{79727, 0x200000},
	{79739, 0x400000},
	{79761, 0x1000000},
	{79785, 0x2000000},
	{79811, 0x4000000},
	{79830, 0x8000000},
	{79848, 0x10000000},
	/* 1193 */
	{79868, 0x1},
	{79879, 0x2},
	{19160, 0x4},
	{79899, 0x18, 2, 36333},
	{79965, 0xE0, 3, 36335},
	{79986, 0x700, 3, 36335},
	{80006, 0x800},
	{80031, 0x1000},
	{80055, 0x2000},
	{80079, 0x10000},
	{80104, 0x80000},
	{80123, 0x100000},
	{80138, 0x200000},
	{80156, 0x400000},
	{80194, 0x800000},
	{80217, 0x1000000},
	/* 1209 */
	{80238, 0x1},
	{80256, 0x2},
	{80275, 0x4},
	{80293, 0x8},
	{80312, 0x10},
	{80330, 0x20},
	{80349, 0x100},
	{80360, 0x200},
	{80370, 0x400},
	{80381, 0x800},
	/* 1219 */
	{80397, 0x1},
	{80413, 0x2},
	{80429, 0x4},
	{80445, 0x8},
	{80461, 0x10},
	{80477, 0x20},
	{80493, 0x40},
	{80509, 0x80},
	{80525, 0x100},
	{80541, 0x200},
	{80557, 0x400},
	{80573, 0x800},
	{80589, 0x1000},
	{80605, 0x2000},
	{80621, 0x4000},
	{80637, 0x8000},
	{80653, 0x10000},
	{80672, 0x20000},
	{80690, 0x40000},
	{80717, 0x80000},
	{80739, 0x100000},
	{80757, 0x200000},
	{80777, 0x400000},
	{80800, 0x800000},
	{80823, 0x1000000},
	{80848, 0x2000000},
	{80868, 0x4000000},
	{80891, 0x8000000},
	/* 1247 */
	{80910, 0x1},
	{80929, 0x2},
	{80947, 0x4},
	{80965, 0x8},
	{80983, 0x10},
	{81001, 0x20},
	{81018, 0x40},
	{81035, 0x80},
	{81056, 0x100},
	{81073, 0x200},
	{81090, 0x400},
	{81106, 0x800},
	{81122, 0x1000},
	{81138, 0x2000},
	{81154, 0x4000},
	{81179, 0x100000},
	/* 1263 */
	{81199, 0x3},
	{81218, 0x4},
	{81237, 0x8},
	{81254, 0x10},
	/* 1267 */
	{18096, 0xFFFFFFFF},
	/* 1268 */
	{81269, 0x1},
	{81293, 0x2},
	{81313, 0x4},
	{81334, 0x8},
	{81359, 0x10},
	{81379, 0x20},
	{81395, 0x40},
	{81412, 0x80},
	{81433, 0xFF00},
	{81454, 0x40000000},
	{81475, 0x80000000},
	/* 1279 */
	{81497, 0x1},
	{81269, 0x2},
	{81293, 0x4},
	{81313, 0x8},
	{81334, 0x10},
	{81522, 0x20},
	{81535, 0x40},
	/* 1286 */
	{81564, 0x1},
	{81575, 0x2},
	/* 1288 */
	{81593, 0x1},
	{81610, 0x2},
	/* 1290 */
	{81634, 0x1},
	{81659, 0x2},
	{81680, 0x4},
	{81702, 0x8},
	{81728, 0x10},
	/* 1295 */
	{81745, 0x1E},
	{81757, 0xE0},
	{81771, 0xF00},
	{81787, 0x70000},
	{81798, 0x780000},
	/* 1300 */
	{81811, 0xFFFFFFFF},
	/* 1301 */
	{66547, 0xFFFF},
	{66440, 0xFFFF0000},
	/* 1303 */
	{81827, 0xFFFF},
	{18833, 0xFFFF0000},
	/* 1305 */
	{66440, 0xFFFF},
	/* 1306 */
	{81836, 0xFFFF},
	{81849, 0xFF0000},
	{81862, 0x10000000},
	{81880, 0x60000000},
	/* 1310 */
	{81896, 0x7},
	/* 1311 */
	{81908, 0x3},
	/* 1312 */
	{81918, 0xFFFFFFFF},
	/* 1313 */
	{81927, 0xFFFFFFFF},
	/* 1314 */
	{18426, 0xFF},
	/* 1315 */
	{18448, 0x1F, 22, 36338},
	{82285, 0x4000},
	{82298, 0x8000},
	{82311, 0x70000},
	/* 1319 */
	{18468, 0xF},
	/* 1320 */
	{18474, 0xF},
	/* 1321 */
	{82322, 0x1},
	{82332, 0x2},
	{82342, 0x4},
	{82352, 0x8},
	{19659, 0xFF00},
	{82362, 0xFF0000},
	/* 1327 */
	{82368, 0xF},
	{13821, 0xF0},
	{82375, 0xF00},
	{70877, 0xF000},
	{82382, 0xF0000},
	{82389, 0xF00000},
	{82398, 0xF000000},
	{11753, 0xF0000000},
	/* 1335 */
	{966, 0x7, 6, 36360},
	{82478, 0x8},
	{82534, 0x30, 4, 36366},
	{82543, 0x7C0},
	{82554, 0x800},
	{82567, 0x1000},
	{82578, 0x2000},
	{82590, 0x4000},
	{82603, 0x8000},
	{82621, 0x10000},
	{82637, 0x20000},
	{82656, 0x40000},
	{82670, 0x80000},
	{82688, 0x100000},
	{82706, 0x600000},
	/* 1350 */
	{82713, 0x7FF},
	{82733, 0x3FF800},
	{82753, 0xFFC00000},
	/* 1353 */
	{82777, 0x1},
	{82789, 0x2},
	{82810, 0x4},
	{82830, 0x8},
	{82855, 0x10},
	{82876, 0x20},
	{82899, 0x40},
	/* 1360 */
	{82929, 0x1},
	{82939, 0x2},
	{82954, 0x4},
	{82979, 0x8},
	{82997, 0x70},
	{83013, 0x80},
	{83018, 0x100},
	{83041, 0x200},
	{83060, 0x400},
	{83082, 0x800},
	{83098, 0x1000},
	{83114, 0x2000},
	{83130, 0x4000},
	{83149, 0x8000},
	{83175, 0x10000},
	{83190, 0x20000},
	{83230, 0x40000},
	{83257, 0x80000},
	{83280, 0xF00000},
	{83296, 0x1000000},
	{83326, 0x2000000},
	{83350, 0x4000000},
	{83371, 0x8000000},
	{83401, 0x70000000},
	/* 1384 */
	{83425, 0xFFFFFFFF},
	/* 1385 */
	{18673, 0x7FF},
	/* 1386 */
	{18687, 0x7FF},
	/* 1387 */
	{18701, 0xF},
	/* 1388 */
	{738, 0x7FFF},
	/* 1389 */
	{83430, 0x3F, 4, 36370},
	{83443, 0x3F00, 4, 36370},
	{83458, 0x3F0000, 4, 36370},
	{83473, 0xFC00000, 4, 36370},
	{83488, 0x80000000},
	/* 1394 */
	{28581, 0xFFFFFFFF},
	/* 1395 */
	{18833, 0xFFFFFFFF},
	/* 1396 */
	{203, 0x3, 3, 36374},
	{83625, 0xC, 4, 36377},
	{83705, 0x30, 4, 36381},
	{83765, 0xC0, 3, 36385},
	{83778, 0x100},
	{78093, 0x200},
	{83782, 0x400},
	{83791, 0x3800},
	/* 1404 */
	{18876, 0x1},
	{83797, 0x2},
	{83818, 0x4},
	/* 1407 */
	{266, 0xFFFFFFFF},
	/* 1408 */
	{29016, 0xFFFFFFFF},
	/* 1409 */
	{85001, 0x3F, 64, 36388},
	{60387, 0x7FFFC00},
	{85012, 0x8000000},
	/* 1412 */
	{18973, 0x1},
	{85027, 0x2},
	/* 1414 */
	{85042, 0x1},
	{85056, 0x2},
	{85072, 0x4},
	{85090, 0x8},
	{85106, 0x10},
	/* 1419 */
	{85117, 0xFFFFFFFF},
	/* 1420 */
	{85127, 0xFFFF},
	{85142, 0x10000},
	{85161, 0x20000},
	{85175, 0x40000},
	{85194, 0x80000},
	{85208, 0x100000},
	/* 1426 */
	{19087, 0x7FFF},
	/* 1427 */
	{19123, 0x1},
	/* 1428 */
	{19137, 0x1},
	/* 1429 */
	{70441, 0x1},
	{85225, 0x2},
	{85236, 0x4},
	{85253, 0x8},
	{85270, 0x3F0},
	{85287, 0xFC00},
	{85304, 0x10000},
	{85328, 0x20000},
	{67088, 0x40000},
	/* 1438 */
	{85345, 0x7, 8, 3087},
	{85358, 0xFF0},
	{85372, 0xFF000},
	{69161, 0x1000000},
	/* 1442 */
	{85385, 0x7, 8, 3087},
	{85398, 0xFF0},
	{85412, 0xFF000},
	{69179, 0x1000000},
	/* 1446 */
	{9742, 0xFF},
	{9758, 0xFF00},
	{85425, 0xFF0000},
	{85431, 0xFF000000},
	/* 1450 */
	{19659, 0x3FF},
	/* 1451 */
	{738, 0xFFFFFFFF},
	/* 1452 */
	{19652, 0x1FF},
	/* 1453 */
	{19673, 0x7FF},
	/* 1454 */
	{85437, 0x1FF},
	{85453, 0x3FE00},
	/* 1456 */
	{85469, 0xFF},
	{85483, 0xFF00},
	{85493, 0xFF0000},
	{85504, 0x1F000000},
	{85516, 0xE0000000},
	/* 1461 */
	{85576, 0x3, 4, 36452},
	{85607, 0x4, 2, 36456},
	{19742, 0x18, 4, 36458},
	{85689, 0x20, 2, 36462},
	{85754, 0xC0, 4, 36464},
	{85760, 0x100},
	{67946, 0x200},
	{85771, 0x400},
	{85791, 0x800},
	{85811, 0x1000},
	{85825, 0x2000},
	{85836, 0x4000},
	{85852, 0x78000},
	{85872, 0x180000},
	{85887, 0x200000},
	{85897, 0x400000},
	{85907, 0x800000},
	{85917, 0x1000000},
	{85932, 0x2000000},
	/* 1480 */
	{85952, 0xFF},
	{85964, 0x3F00},
	{85980, 0xFC000},
	/* 1483 */
	{209, 0x3, 3, 36468},
	{86086, 0x1C, 4, 36471},
	{86163, 0xE0, 4, 36475},
	{86172, 0x100},
	{86192, 0x200},
	{86203, 0x3C00},
	{86225, 0x4000},
	{83765, 0x18000, 3, 36385},
	{86259, 0x60000, 4, 36479},
	{86318, 0x80000, 3, 36483},
	{86370, 0x100000, 3, 36486},
	{83791, 0x3800000},
	/* 1495 */
	{86382, 0x1},
	{86403, 0x300},
	{86425, 0xC00},
	{86447, 0x3000},
	{86469, 0xC000},
	{86491, 0x10000},
	/* 1501 */
	{86504, 0xFFFFFFFF},
	/* 1502 */
	{86516, 0xFF},
	{86544, 0x100},
	/* 1504 */
	{19957, 0xFFFFFFFF},
	/* 1505 */
	{14051, 0xFFFFFFFF},
	/* 1506 */
	{9866, 0x1},
	{20099, 0x1FC},
	{86572, 0x80000000},
	/* 1509 */
	{86604, 0x1},
	{86619, 0x2},
	{86634, 0x4},
	{86649, 0x8},
	{86664, 0x70},
	{86676, 0x80},
	{86696, 0xF00},
	{86713, 0x80000000},
	/* 1517 */
	{86734, 0xF},
	{86753, 0xF0},
	{86772, 0xF00},
	{86791, 0xF000},
	/* 1521 */
	{86810, 0xF},
	{86821, 0xF0},
	{86832, 0xF00},
	{86843, 0xF000},
	{86854, 0xF0000},
	{86865, 0xF00000},
	{86876, 0xF000000},
	{86887, 0xF0000000},
	/* 1529 */
	{86898, 0xF},
	{86909, 0xF0},
	{86920, 0xF00},
	{86932, 0xF000},
	{86944, 0xF0000},
	{86956, 0xF00000},
	{86968, 0xF000000},
	{86980, 0xF0000000},
	/* 1537 */
	{86992, 0x200},
	{87010, 0x400},
	{87021, 0x800},
	{87046, 0x1000},
	{87068, 0x2000},
	/* 1542 */
	{87090, 0x7},
	{87107, 0x10},
	{87129, 0x1E000},
	{87145, 0x700000},
	{87166, 0x3000000},
	{87246, 0xC000000, 4, 36489},
	/* 1548 */
	{87272, 0x1},
	{87333, 0x6, 4, 36493},
	{87549, 0x38, 8, 36497},
	/* 1551 */
	{87560, 0xF},
	{87565, 0xF0},
	{87570, 0xF00},
	{87575, 0xF000},
	{87580, 0xF0000},
	{87585, 0xF00000},
	{87590, 0xF000000},
	{87595, 0xF0000000},
	/* 1559 */
	{87600, 0xF},
	{87605, 0xF0},
	{87610, 0xF00},
	{87615, 0xF000},
	{87620, 0xF0000},
	{87625, 0xF00000},
	{87630, 0xF000000},
	{87635, 0xF0000000},
	/* 1567 */
	{87640, 0xF},
	{87645, 0xF0},
	{87650, 0xF00},
	{87655, 0xF000},
	{87660, 0xF0000},
	{87666, 0xF00000},
	{87672, 0xF000000},
	{87678, 0xF0000000},
	/* 1575 */
	{87684, 0xF},
	{87690, 0xF0},
	{87696, 0xF00},
	{87702, 0xF000},
	{87708, 0xF0000},
	{87714, 0xF00000},
	{87720, 0xF000000},
	{87726, 0xF0000000},
	/* 1583 */
	{87732, 0xFFFF},
	{87745, 0xFFFF0000},
	/* 1585 */
	{87758, 0xFFFF},
	{87771, 0xFFFF0000},
	/* 1587 */
	{87784, 0x3},
	{67411, 0x4},
	{67433, 0x8},
	{87813, 0x60},
	/* 1591 */
	{87926, 0x3, 4, 36505},
	{87939, 0x4},
	{87950, 0x8},
	{88059, 0x70, 5, 36509},
	{88077, 0x380, 5, 36509},
	{88095, 0x1C00},
	{88118, 0x3E000},
	{88144, 0x40000},
	{88166, 0x7F80000},
	{88182, 0x8000000},
	{88204, 0x10000000},
	{88291, 0x60000000, 3, 36514},
	/* 1603 */
	{88308, 0xFFFF},
	{88324, 0xFFFF0000},
	/* 1605 */
	{88343, 0x1},
	{88360, 0x1E},
	{88384, 0x20},
	{88402, 0x3C0},
	{88427, 0x400},
	{88457, 0x800},
	{88472, 0x1000},
	{88487, 0x2000},
	{88522, 0x4000},
	{88558, 0x8000},
	{88648, 0x30000, 3, 36517},
	{88672, 0x40000},
	{88708, 0x80000},
	{88744, 0x100000},
	{88770, 0x200000},
	{88794, 0x400000},
	{88814, 0x800000},
	{88835, 0x1000000},
	{88860, 0x6000000},
	{88884, 0x18000000},
	/* 1625 */
	{88912, 0x7FF},
	{88933, 0xFF0000},
	/* 1627 */
	{88951, 0xFF},
	/* 1628 */
	{88967, 0x7F},
	/* 1629 */
	{88980, 0x7FF},
	{88989, 0x7FF00000},
	/* 1631 */
	{88980, 0x3FFFFF},
	/* 1632 */
	{68996, 0x1FFF},
	{69023, 0x3FFE000},
	{89004, 0x3C000000},
	/* 1635 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 32, 36524},
	{65183, 0x80},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89767, 0x80000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	{90066, 0x8000000},
	{90092, 0x10000000},
	{90160, 0x60000000, 3, 36576},
	{90176, 0x80000000},
	/* 1654 */
	{90190, 0x1F},
	{90206, 0x3E0},
	{90228, 0xC00},
	{70338, 0x7000},
	{90246, 0x18000},
	{90260, 0x20000},
	{90278, 0x40000},
	{90304, 0x80000},
	/* 1662 */
	{73721, 0x1},
	{90334, 0x2},
	{67029, 0xC, 3, 36579},
	{90448, 0x10, 2, 36582},
	{67057, 0x60},
	{67154, 0x180},
	{90474, 0x200},
	{90497, 0x3C00},
	{90517, 0x3C000},
	{73837, 0x40000},
	{90539, 0x80000},
	{90572, 0x100000},
	/* 1674 */
	{88980, 0x3FFF},
	/* 1675 */
	{21325, 0xFFFFFFFF},
	/* 1676 */
	{21347, 0xFFFFFFFF},
	/* 1677 */
	{70149, 0xFF},
	/* 1678 */
	{90596, 0x3FFF},
	{90608, 0xFFFC000},
	{66929, 0xF0000000},
	/* 1681 */
	{90619, 0x1FFF},
	{90630, 0x2000},
	{90642, 0x7C000},
	{90656, 0xF80000},
	{90670, 0x3000000},
	{90684, 0x4000000},
	{64414, 0x38000000},
	{90703, 0x40000000},
	/* 1689 */
	{9949, 0xFFFFFFFC},
	/* 1690 */
	{9978, 0xFFFF},
	/* 1691 */
	{24239, 0xFFFFFFFF},
	/* 1692 */
	{24259, 0xFFFFFFFF},
	/* 1693 */
	{24274, 0xFFFFFFFF},
	/* 1694 */
	{24295, 0xFFFFFFFF},
	/* 1695 */
	{24312, 0xFFFFFFFC},
	/* 1696 */
	{24334, 0xFFFF},
	/* 1697 */
	{90720, 0xFFFFFFFF},
	/* 1698 */
	{90745, 0xFFFFFFFF},
	/* 1699 */
	{90770, 0xFFFFFFFF},
	/* 1700 */
	{90794, 0xFFFFFFFF},
	/* 1701 */
	{90818, 0xFFFFFFFF},
	/* 1702 */
	{90843, 0xFFFFFFFF},
	/* 1703 */
	{90868, 0xFFFFFFFF},
	/* 1704 */
	{90892, 0xFFFFFFFF},
	/* 1705 */
	{90916, 0xFFFFFFFF},
	/* 1706 */
	{90941, 0xFFFFFFFF},
	/* 1707 */
	{90966, 0xFFFFFFFF},
	/* 1708 */
	{90990, 0xFFFFFFFF},
	/* 1709 */
	{91014, 0xFFFFFFFF},
	/* 1710 */
	{91039, 0xFFFFFFFF},
	/* 1711 */
	{91064, 0xFFFFFFFF},
	/* 1712 */
	{91088, 0xFFFFFFFF},
	/* 1713 */
	{24828, 0xFFFFFFFC},
	/* 1714 */
	{24850, 0xFFFF},
	/* 1715 */
	{24876, 0xFFFFFFFF},
	/* 1716 */
	{24899, 0xFFFFFFFF},
	/* 1717 */
	{24922, 0xFFFFFFFF},
	/* 1718 */
	{24945, 0xFFFFFFFF},
	/* 1719 */
	{24968, 0xFFFFFFFF},
	/* 1720 */
	{24991, 0xFFFFFFFF},
	/* 1721 */
	{25014, 0xFFFFFFFF},
	/* 1722 */
	{25038, 0xFFFFFFFF},
	/* 1723 */
	{25062, 0xFFFFFFFF},
	/* 1724 */
	{25086, 0xFFFFFFFF},
	/* 1725 */
	{25110, 0xFFFFFFFF},
	/* 1726 */
	{25134, 0xFFFFFFFF},
	/* 1727 */
	{25158, 0xFFFFFFFF},
	/* 1728 */
	{25182, 0xFFFFFFFF},
	/* 1729 */
	{25205, 0xFFFFFFFF},
	/* 1730 */
	{25227, 0xFFFFFFFF},
	/* 1731 */
	{25249, 0xFFFFFFFF},
	/* 1732 */
	{25270, 0xFFFFFFFF},
	/* 1733 */
	{25291, 0xFFFFFFFF},
	/* 1734 */
	{25315, 0xFFFFFFFF},
	/* 1735 */
	{91112, 0xFFFFFFFF},
	/* 1736 */
	{25388, 0xFFFFFFFF},
	/* 1737 */
	{25412, 0xFFFFFFFF},
	/* 1738 */
	{91121, 0xFFFFFFC},
	/* 1739 */
	{91137, 0x6000000},
	/* 1740 */
	{91150, 0x1},
	/* 1741 */
	{25549, 0xFFFFFFFF},
	/* 1742 */
	{25562, 0xFFFFFFFF},
	/* 1743 */
	{25575, 0xFFFFFFFF},
	/* 1744 */
	{25588, 0xFFFFFFFF},
	/* 1745 */
	{25601, 0xFFFFFFFF},
	/* 1746 */
	{25614, 0xFFFFFFFF},
	/* 1747 */
	{25627, 0xFFFFFFFF},
	/* 1748 */
	{25640, 0xFFFFFFFF},
	/* 1749 */
	{91169, 0xFFFFFFFF},
	/* 1750 */
	{91180, 0xFF},
	{91194, 0x30000},
	/* 1752 */
	{91208, 0xFFFFFFFF},
	/* 1753 */
	{25800, 0xFFFFFFFF},
	/* 1754 */
	{25823, 0xFFFFFFFF},
	/* 1755 */
	{25846, 0xFFFFFFFF},
	/* 1756 */
	{25874, 0xFFFFFFFF},
	/* 1757 */
	{25902, 0xFFFFFFFF},
	/* 1758 */
	{25930, 0xFFFFFFFF},
	/* 1759 */
	{91222, 0xFFFFFFFC},
	/* 1760 */
	{91234, 0xFFFF},
	{91246, 0x10000},
	{91137, 0x6000000},
	{26637, 0xE0000000},
	/* 1764 */
	{26187, 0xFFFFFFFC},
	/* 1765 */
	{26205, 0xFFFF},
	{91137, 0xC00000},
	/* 1767 */
	{26223, 0xFFFFFFFF},
	/* 1768 */
	{26241, 0xFFFFFFFF},
	/* 1769 */
	{26259, 0xFFFFFFFC},
	/* 1770 */
	{26277, 0xFFFF},
	{91137, 0xC00000},
	/* 1772 */
	{26295, 0xFFFFFFFF},
	/* 1773 */
	{91256, 0x3},
	{26317, 0xFFFFFFF8},
	/* 1775 */
	{26336, 0xFFFF},
	{91270, 0x10000},
	{91286, 0x100000},
	{91302, 0x3000000},
	{91318, 0xE0000000},
	/* 1780 */
	{26351, 0xFFFFFFFF},
	/* 1781 */
	{91329, 0x400},
	{91342, 0x6000},
	{91359, 0x8000},
	{91371, 0x300000},
	{91382, 0x6000000},
	{91399, 0x8000000},
	{91411, 0x60000000},
	/* 1788 */
	{91422, 0xFF},
	/* 1789 */
	{91441, 0x3F},
	/* 1790 */
	{91459, 0x8},
	{91476, 0x10},
	{91493, 0x20},
	{91520, 0x8000},
	{91540, 0x40000},
	{91557, 0x400000},
	{91573, 0x800000},
	{91587, 0x2000000},
	{91601, 0x4000000},
	{91615, 0x8000000},
	{91636, 0x10000000},
	{91661, 0x20000000},
	{91682, 0x40000000},
	/* 1803 */
	{91706, 0xFFFFFFFF},
	/* 1804 */
	{91722, 0xFFFFFFFF},
	/* 1805 */
	{91738, 0x3000000},
	{979, 0x80000000},
	/* 1807 */
	{26555, 0xFFFFFFFF},
	/* 1808 */
	{26574, 0xFFFF},
	/* 1809 */
	{26596, 0xFFFFFFFF},
	/* 1810 */
	{26615, 0xFFFF},
	/* 1811 */
	{91743, 0x3FFFFFF},
	{91754, 0x4000000},
	{91758, 0x8000000},
	{91762, 0x10000000},
	{91767, 0x20000000},
	{91772, 0x40000000},
	{91781, 0x80000000},
	/* 1818 */
	{91788, 0x1},
	{91808, 0x2},
	{91822, 0x30},
	{91834, 0x1FF0000},
	{91847, 0x10000000},
	{91862, 0x20000000},
	{91876, 0xC0000000},
	/* 1825 */
	{91886, 0x3FFFFFF},
	{91899, 0x10000000},
	/* 1827 */
	{91918, 0xFF},
	/* 1828 */
	{91937, 0xFF},
	/* 1829 */
	{91943, 0x1},
	{91957, 0x2},
	{91969, 0x10000},
	{91983, 0x1000000},
	/* 1833 */
	{1856, 0xFF},
	{59279, 0x80000000},
	/* 1835 */
	{26870, 0xFFFFF},
	/* 1836 */
	{26883, 0xFFFFF},
	/* 1837 */
	{26897, 0xFFFFF},
	/* 1838 */
	{26911, 0xFFFFF},
	/* 1839 */
	{26933, 0xFFFFF},
	/* 1840 */
	{26953, 0xFFFFF},
	/* 1841 */
	{26975, 0xFFFFF},
	/* 1842 */
	{91996, 0xFFFFFFFF},
	/* 1843 */
	{92015, 0x3},
	{9949, 0xFFFFFFFC},
	/* 1845 */
	{9978, 0xFFFF},
	{92015, 0xFFFF0000},
	/* 1847 */
	{92020, 0xFFF},
	/* 1848 */
	{92035, 0xFFFFF},
	/* 1849 */
	{92049, 0xFFFFF},
	/* 1850 */
	{92063, 0xFFFFF},
	/* 1851 */
	{27291, 0xFFFFFFE0},
	/* 1852 */
	{27310, 0xFFFF},
	/* 1853 */
	{27329, 0xFFF},
	/* 1854 */
	{27346, 0xFFFFFFFC},
	/* 1855 */
	{27364, 0xFFFF},
	/* 1856 */
	{27382, 0xFFFFF},
	/* 1857 */
	{27398, 0xFFFFFFFC},
	/* 1858 */
	{27416, 0xFFFF},
	/* 1859 */
	{27434, 0xFFFFF},
	/* 1860 */
	{27533, 0xFFFFFFFC},
	/* 1861 */
	{27547, 0xFFFF},
	/* 1862 */
	{27561, 0xFFFFF},
	/* 1863 */
	{42920, 0xFFF000},
	{91137, 0x6000000},
	{92076, 0x8000000},
	{92089, 0x10000000},
	/* 1867 */
	{92097, 0x30000},
	{92105, 0x7000000},
	{92113, 0xE0000000},
	/* 1870 */
	{27627, 0xFFFFFFFF},
	/* 1871 */
	{27638, 0xFFFFFFFC},
	/* 1872 */
	{27652, 0xFFFF},
	/* 1873 */
	{27666, 0xFFFFF},
	/* 1874 */
	{92122, 0xFFFFF},
	/* 1875 */
	{979, 0x3},
	/* 1876 */
	{27816, 0x1},
	/* 1877 */
	{9949, 0xFFFFFFFF},
	/* 1878 */
	{92135, 0x1},
	{92149, 0x2},
	{92166, 0x4},
	{92182, 0x8},
	{92197, 0x10},
	{92216, 0x20},
	{92234, 0x40},
	{92255, 0x80},
	/* 1886 */
	{92276, 0x1},
	{92292, 0x2},
	{92308, 0x40},
	{92326, 0x80},
	{92344, 0x100},
	{92362, 0x200},
	{92380, 0x400},
	{92398, 0x800},
	{92416, 0x1000},
	{92434, 0x2000},
	{92452, 0x4000},
	{92469, 0x80000},
	{92485, 0x200000},
	/* 1899 */
	{92501, 0xFF},
	{979, 0x80000000},
	/* 1901 */
	{92519, 0xF},
	{92531, 0xF0},
	{92540, 0xF00},
	{92549, 0xF000},
	{92559, 0x30000},
	{55858, 0xC0000},
	{9866, 0x100000},
	{10349, 0xFFE00000},
	/* 1909 */
	{92569, 0xFF},
	{92540, 0xFF00},
	{92531, 0xFF0000},
	{92584, 0x20000000},
	{92604, 0x40000000},
	{92630, 0x80000000},
	/* 1915 */
	{92650, 0xFFFFFFFF},
	/* 1916 */
	{18448, 0x3F, 22, 36338},
	/* 1917 */
	{38, 0xFFFF},
	/* 1918 */
	{92659, 0x1FF},
	{92725, 0x600, 4, 36584},
	/* 1920 */
	{8, 0xFFFFFFFF},
	/* 1921 */
	{28687, 0xFFFFFFFF},
	/* 1922 */
	{85127, 0xFFFF},
	{85142, 0x10000},
	{85161, 0x20000},
	{85175, 0x40000},
	{85194, 0x80000},
	{85208, 0x100000},
	{92745, 0x200000},
	{92763, 0x400000},
	{92779, 0x800000},
	/* 1931 */
	{28861, 0xFFFFFFFF},
	/* 1932 */
	{92791, 0x1FF},
	{92805, 0x3FE00},
	{92819, 0x40000},
	{92837, 0x80000},
	/* 1936 */
	{92854, 0x7},
	{92863, 0x78},
	{92872, 0x100},
	/* 1939 */
	{92882, 0x1},
	{92893, 0x7FE},
	/* 1941 */
	{92906, 0x1},
	{92920, 0x2},
	{92934, 0x4},
	/* 1944 */
	{29003, 0xFFFFFF},
	/* 1945 */
	{92948, 0xF},
	{92960, 0xFF00},
	/* 1947 */
	{445, 0xFFFF},
	{91, 0xFFFF0000},
	/* 1949 */
	{92974, 0x1},
	{92995, 0x2},
	/* 1951 */
	{93023, 0x3FFF},
	/* 1952 */
	{93031, 0x3FFF},
	/* 1953 */
	{1843, 0xFFFF},
	/* 1954 */
	{93039, 0x1},
	{93051, 0x2},
	{93063, 0x4},
	{29778, 0x8},
	{68226, 0x10},
	{30203, 0x10000},
	{93074, 0x60000},
	/* 1961 */
	{93087, 0x1},
	{69547, 0x2},
	/* 1963 */
	{30026, 0xFFFFFFFF},
	/* 1964 */
	{24906, 0x7FFFFFFF},
	/* 1965 */
	{93091, 0xFFFFFFFF},
	/* 1966 */
	{93101, 0xFFFFFFFF},
	/* 1967 */
	{30085, 0xFFFFFFFF},
	/* 1968 */
	{30103, 0xFFFFFFFF},
	/* 1969 */
	{30122, 0xFFFFFFFF},
	/* 1970 */
	{93111, 0xFFFFFFFF},
	/* 1971 */
	{385, 0xFFFFFFFF},
	/* 1972 */
	{30197, 0xFFFFFFFF},
	/* 1973 */
	{93122, 0x3F},
	{93127, 0xC0},
	{93135, 0x300},
	{93141, 0xFFFFFC00},
	/* 1977 */
	{30203, 0x1},
	{55858, 0xFFFFFFFE},
	/* 1979 */
	{8, 0xFFFF},
	{55858, 0xFFFF0000},
	/* 1981 */
	{38, 0xFFFF},
	{55858, 0xFFFF0000},
	/* 1983 */
	{30281, 0xFF},
	{55858, 0xFFFFFF00},
	/* 1985 */
	{30298, 0xFF},
	{55858, 0xFFFFFF00},
	/* 1987 */
	{30315, 0xFFFFFFFF},
	/* 1988 */
	{1, 0xFF},
	{55858, 0xFFFFFF00},
	/* 1990 */
	{441, 0x3F},
	{55858, 0xFFFFFFC0},
	/* 1992 */
	{80685, 0x1},
	{842, 0x1FFE},
	{209, 0x2000},
	{88627, 0x4000},
	{93149, 0x8000},
	{93161, 0x7FF0000},
	{93172, 0x8000000},
	{93183, 0x10000000},
	{93193, 0x20000000},
	{93127, 0xC0000000},
	/* 2002 */
	{30502, 0xFFFF},
	{55858, 0xFFFF0000},
	/* 2004 */
	{441, 0xF},
	{55858, 0xFFFFFFF0},
	/* 2006 */
	{93200, 0xFFFFFFFF},
	/* 2007 */
	{93216, 0xFFFF},
	{93227, 0xF0000},
	{93240, 0xF00000},
	{55858, 0x3F000000},
	{93248, 0x40000000},
	{9866, 0x80000000},
	/* 2013 */
	{29016, 0x7FFFFFFF},
	{30564, 0x80000000},
	/* 2015 */
	{10190, 0xFFFFFFFF},
	/* 2016 */
	{10349, 0xFFFFFFFF},
	/* 2017 */
	{31086, 0xFFFFFFFF},
	/* 2018 */
	{31110, 0xFFFFFFFF},
	/* 2019 */
	{31110, 0xFFFF},
	/* 2020 */
	{31090, 0xFFFFFFFF},
	/* 2021 */
	{31114, 0xFFFF},
	{93257, 0xFFFF0000},
	/* 2023 */
	{93271, 0x3FF},
	{93280, 0xFFC00},
	{93290, 0xF00000},
	{93299, 0xF000000},
	{93310, 0xF0000000},
	/* 2028 */
	{93321, 0x3FF},
	{93331, 0xFFC00},
	{93341, 0xF000000},
	{93352, 0xF0000000},
	/* 2032 */
	{93572, 0xF, 6, 36588},
	{93807, 0xF0, 6, 36594},
	{93980, 0x300, 4, 36600},
	{94000, 0x400},
	/* 2036 */
	{441, 0x7},
	{70026, 0x40000000},
	{9866, 0x80000000},
	/* 2039 */
	{441, 0x1F},
	{70026, 0x40000000},
	{9866, 0x80000000},
	/* 2042 */
	{441, 0xF},
	{11216, 0x40000000},
	{9866, 0x80000000},
	/* 2045 */
	{441, 0x1F},
	{11216, 0x40000000},
	{9866, 0x80000000},
	/* 2048 */
	{36687, 0xFFFFFFFF},
	/* 2049 */
	{36725, 0xFFFFFFFF},
	/* 2050 */
	{36748, 0xFFFFFFFF},
	/* 2051 */
	{11181, 0xFFFF},
	{11201, 0xFFFF0000},
	/* 2053 */
	{94022, 0x1},
	{94049, 0x2},
	{94076, 0x4},
	{966, 0x100},
	/* 2057 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{94153, 0x2000},
	{94179, 0x4000},
	{94205, 0x10000},
	{94232, 0x20000},
	{94258, 0x40000},
	{94284, 0x80000},
	{94312, 0x100000},
	{94338, 0x200000},
	{94364, 0x400000},
	{94390, 0x1000000},
	{94417, 0x2000000},
	{94444, 0x4000000},
	{94471, 0x8000000},
	{94498, 0x10000000},
	{94524, 0x20000000},
	{94553, 0x40000000},
	{94579, 0x80000000},
	/* 2077 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{94153, 0x1000},
	{94179, 0x2000},
	{94205, 0x8000},
	{94232, 0x10000},
	{94312, 0x20000},
	{94338, 0x40000},
	{94258, 0x100000},
	{94417, 0x200000},
	{94579, 0x400000},
	{94606, 0x800000},
	{94471, 0x1000000},
	{94635, 0x2000000},
	/* 2092 */
	{94606, 0x2},
	{94664, 0x4},
	{94693, 0x8},
	{94721, 0x10},
	{94747, 0x20},
	{94773, 0x40},
	{94800, 0x80},
	{94635, 0x100},
	/* 2100 */
	{94827, 0x3FF},
	{93280, 0xFFC00},
	{94837, 0xF00000},
	{94847, 0xF000000},
	{94858, 0xF0000000},
	/* 2105 */
	{93321, 0x3FF},
	{93331, 0xFFC00},
	{94869, 0xF000000},
	{94880, 0xF0000000},
	/* 2109 */
	{94827, 0x3FF},
	{94891, 0xF0000000},
	/* 2111 */
	{93271, 0x3FF},
	{93280, 0xFFC00},
	{94837, 0xF00000},
	{94858, 0xF000000},
	{94891, 0xF0000000},
	/* 2116 */
	{93321, 0x3FF},
	{93331, 0xFFC00},
	{94880, 0xF000000},
	{94869, 0xF0000000},
	/* 2120 */
	{94901, 0xF},
	{94910, 0xF0},
	{94919, 0xF00},
	{94928, 0xF000},
	{94937, 0xF0000},
	{94946, 0xF00000},
	{94955, 0xF000000},
	{94964, 0xF0000000},
	/* 2128 */
	{93271, 0x1FF},
	{94973, 0xF000},
	{93290, 0xF00000},
	{94891, 0xF0000000},
	/* 2132 */
	{55899, 0x1},
	{85754, 0x2, 4, 36464},
	{85689, 0x4, 2, 36462},
	{19742, 0x8, 4, 36458},
	{85607, 0x10, 2, 36456},
	{85576, 0x20, 4, 36452},
	{94987, 0x40},
	{94993, 0x300},
	{95003, 0x2000},
	/* 2141 */
	{95017, 0x1},
	/* 2142 */
	{95026, 0x3},
	{95040, 0xC},
	{95054, 0x30},
	{95068, 0xC0},
	{95082, 0xF00},
	{95097, 0xF000},
	{95112, 0xF0000},
	{95127, 0xF00000},
	/* 2150 */
	{36855, 0x3FF},
	{95142, 0xFFC00},
	{94837, 0xF00000},
	/* 2153 */
	{95162, 0x3FF},
	{95182, 0xFFC00},
	/* 2155 */
	{93271, 0xFF},
	{93280, 0x3FC00},
	{94837, 0xF00000},
	{94858, 0xF000000},
	{94891, 0xF0000000},
	/* 2160 */
	{93321, 0xFF},
	{93331, 0x3FC00},
	{94880, 0xF000000},
	{94869, 0xF0000000},
	/* 2164 */
	{93271, 0xFF},
	{94837, 0xF00000},
	{94891, 0xF0000000},
	/* 2167 */
	{93271, 0x3FF},
	{94837, 0xF00000},
	{94891, 0xF0000000},
	/* 2170 */
	{95202, 0x1},
	{95437, 0xE, 6, 36604},
	{95451, 0x10},
	{95472, 0x3E0},
	{95490, 0x400},
	{95575, 0x800, 2, 36610},
	{95592, 0x1000},
	{95610, 0xE000},
	{95625, 0x20000},
	{95651, 0x1C0000},
	{95674, 0x200000},
	{95702, 0xC00000},
	/* 2182 */
	{93271, 0x1FF},
	{93280, 0x7FC00},
	{94837, 0xF00000},
	{94858, 0xF000000},
	{94891, 0xF0000000},
	/* 2187 */
	{93321, 0x1FF},
	{93331, 0x7FC00},
	{94880, 0xF000000},
	{94869, 0xF0000000},
	/* 2191 */
	{93271, 0x1FF},
	{94891, 0xF0000000},
	/* 2193 */
	{65593, 0xFFF},
	{95727, 0x3000},
	{10349, 0xC000},
	{95745, 0xFFFF0000},
	/* 2197 */
	{40128, 0xFFFFFFFF},
	/* 2198 */
	{40157, 0xFFFF},
	{10349, 0xFFFF0000},
	/* 2200 */
	{95769, 0xFFFFFFFF},
	/* 2201 */
	{40204, 0xFF},
	{65593, 0x700},
	{95784, 0xF800},
	{95800, 0x1F0000},
	{95813, 0x3E00000},
	{95826, 0x7C000000},
	{10349, 0x80000000},
	/* 2208 */
	{95839, 0xFFFFFFFF},
	/* 2209 */
	{95858, 0xFF},
	{10349, 0xFFFFFF00},
	/* 2211 */
	{95880, 0x1FF},
	{10349, 0xFFFFFE00},
	/* 2213 */
	{95897, 0xFFFFFFFF},
	/* 2214 */
	{95880, 0xFF},
	{10349, 0xFFFFFF00},
	/* 2216 */
	{40378, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2218 */
	{40403, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2220 */
	{40431, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2222 */
	{40459, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2224 */
	{40482, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2226 */
	{95914, 0xFFFFFFFF},
	/* 2227 */
	{95936, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2229 */
	{95941, 0xFFFFFFFF},
	/* 2230 */
	{10349, 0x1F},
	{95962, 0xFFFFFFE0},
	/* 2232 */
	{95981, 0x7F},
	{10349, 0xFFFFFF80},
	/* 2234 */
	{95936, 0xFFFFFFFF},
	/* 2235 */
	{95981, 0x1FF},
	{10349, 0xFFFFFE00},
	/* 2237 */
	{95936, 0xFF},
	{10349, 0xFFFFFF00},
	/* 2239 */
	{95986, 0xFF},
	{96007, 0x100},
	{96017, 0x200},
	{96025, 0x400},
	{96039, 0x800},
	{96050, 0x1000},
	{96069, 0x2000},
	{96093, 0x4000},
	{96107, 0x8000},
	{10349, 0xFFFF0000},
	/* 2249 */
	{96117, 0x1},
	{96141, 0x2},
	{96165, 0x4},
	{96182, 0x8},
	{96199, 0x10},
	{96218, 0x20},
	{96235, 0x3C0},
	{10349, 0xFFFFFC00},
	/* 2257 */
	{96250, 0x1},
	{96262, 0x2},
	{96274, 0x4},
	{96284, 0x8},
	{96305, 0x10},
	{96322, 0x20},
	{96339, 0x40},
	{10349, 0xFFFFFF80},
	/* 2265 */
	{96363, 0xFFFF},
	{10349, 0xFFFF0000},
	/* 2267 */
	{96373, 0xFF},
	{10349, 0xFFFFFF00},
	/* 2269 */
	{96390, 0x7FFFF},
	{10349, 0xFFF80000},
	/* 2271 */
	{95800, 0xFF},
	{95813, 0xFF00},
	{95826, 0xFF0000},
	{96405, 0xFF000000},
	/* 2275 */
	{40204, 0xFF},
	{95784, 0xFF00},
	{10349, 0xFFFF0000},
	/* 2278 */
	{96418, 0x1},
	/* 2279 */
	{96442, 0x1},
	/* 2280 */
	{93572, 0x7, 6, 36588},
	{94000, 0x400},
	/* 2282 */
	{36855, 0xFF},
	/* 2283 */
	{9866, 0x1},
	{96460, 0x2},
	{18929, 0x4},
	{10349, 0xFFFFFFF8},
	/* 2287 */
	{96472, 0xF},
	{96477, 0x30},
	{10349, 0xFFFFFFC0},
	/* 2290 */
	{96484, 0x1},
	/* 2291 */
	{96504, 0x3},
	{96528, 0xC},
	{96552, 0x30},
	{96567, 0xC0},
	{96591, 0x300},
	{96615, 0x3C00},
	{96632, 0x7C000},
	{96650, 0x1F80000},
	{96686, 0x2000000},
	{96702, 0x4000000},
	/* 2301 */
	{93271, 0xFF},
	{96720, 0xFF00},
	{94891, 0xF000000},
	{9866, 0x10000000},
	{11216, 0x20000000},
	/* 2306 */
	{96733, 0xF},
	{96753, 0xFF00},
	{96767, 0xFF0000},
	{96780, 0x1000000},
	{96791, 0x2000000},
	{96801, 0x4000000},
	/* 2312 */
	{93271, 0x1FF},
	{94891, 0xF000000},
	{96822, 0xF0000000},
	/* 2315 */
	{93271, 0x3FF},
	{96832, 0xF0000000},
	/* 2317 */
	{92097, 0xF00, 6, 36612},
	{96884, 0x10000},
	{96896, 0x100000},
	{96911, 0xC0000000, 4, 36618},
	/* 2321 */
	{96922, 0xFFFFF},
	{96930, 0x100000},
	{55114, 0x800000},
	/* 2324 */
	{42908, 0xFFFFFFFF},
	/* 2325 */
	{26574, 0xFFFF},
	{92097, 0x300000, 4, 36622},
	{96951, 0x8000000, 2, 36618},
	{96973, 0x60000000, 4, 36626},
	{96981, 0x80000000},
	/* 2330 */
	{42792, 0xFFFFFFFF},
	/* 2331 */
	{91743, 0x3FFFFFF},
	{91754, 0x4000000, 2, 36630},
	{91758, 0x8000000, 2, 36630},
	{91762, 0x10000000, 2, 36632},
	{91767, 0x20000000, 2, 36632},
	{91772, 0x40000000},
	{97019, 0x80000000},
	/* 2338 */
	{85001, 0x3F},
	{97038, 0xF00},
	{97050, 0x1000},
	{97057, 0x2000},
	{97065, 0x4000},
	{97073, 0x8000},
	{97081, 0x10000},
	{97104, 0x60000, 4, 36634},
	{97129, 0x80000},
	{97141, 0x100000},
	{97149, 0x200000},
	{97193, 0xC00000, 3, 36638},
	/* 2350 */
	{96951, 0x1, 2, 36618},
	{91342, 0x6000},
	{92097, 0x300000, 4, 36622},
	{91382, 0x6000000},
	{96973, 0x60000000, 4, 36626},
	{96981, 0x80000000},
	/* 2356 */
	{97238, 0x3, 4, 36641},
	{97254, 0xC, 4, 36645},
	{97050, 0x10},
	{97057, 0x20},
	{97279, 0x40},
	{97286, 0x80},
	{97065, 0x100},
	{97073, 0x200},
	{97081, 0x400},
	{97104, 0x1800, 4, 36634},
	{97129, 0x2000},
	{97141, 0x4000},
	{97149, 0x8000},
	{97193, 0x30000, 3, 36638},
	{97294, 0x40000},
	/* 2371 */
	{97306, 0xFFFFF},
	/* 2372 */
	{55429, 0x1FF, 257, 0},
	{55434, 0x400},
	{55442, 0x800},
	{55455, 0x7000},
	{55463, 0x8000},
	{55474, 0xF0000},
	{55485, 0xF00000},
	{55501, 0x1000000},
	{97316, 0x10000000},
	{55527, 0xE0000000},
	/* 2382 */
	{55686, 0xF},
	{55693, 0x70},
	{55701, 0x80},
	{55715, 0xF00},
	{55724, 0x7000},
	{55751, 0xC00000},
	{55761, 0x1000000},
	{55787, 0xFC000000},
	/* 2390 */
	{42982, 0xFFFFF},
	/* 2391 */
	{56001, 0xF},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56130, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56230, 0x4000},
	{56245, 0x8000},
	{56256, 0x10000},
	{56264, 0x20000},
	{56273, 0x40000},
	{97326, 0x80000},
	{56305, 0x100000},
	{56318, 0x200000},
	{56328, 0x400000},
	{56345, 0x800000},
	{97346, 0x1000000},
	{97363, 0x2000000},
	{56362, 0x4000000},
	{56371, 0x8000000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	{56407, 0x80000000},
	/* 2420 */
	{56418, 0xF},
	{56457, 0x80},
	{56480, 0x100},
	{56503, 0x200},
	{56522, 0x1000},
	{56531, 0x2000},
	{56540, 0x4000},
	{56548, 0x8000},
	{56557, 0x10000},
	{56572, 0x100000},
	{56580, 0x200000},
	{56588, 0x400000},
	{56597, 0x800000},
	{56606, 0x1000000},
	{56614, 0x2000000},
	{56622, 0x4000000},
	{56630, 0x10000000},
	{56372, 0x20000000},
	{56648, 0x40000000},
	{56656, 0x80000000},
	/* 2440 */
	{42996, 0xFFFF},
	/* 2441 */
	{59812, 0x7FF, 2049, 257},
	{97380, 0x1000},
	{59974, 0xFF0000, 129, 2306},
	{59986, 0x3000000},
	{97405, 0x1C000000},
	{59999, 0x80000000},
	/* 2447 */
	{966, 0x3},
	{60014, 0x4},
	{60023, 0x8},
	{60034, 0x10},
	{60047, 0x20},
	{49737, 0x1C0},
	{60061, 0x200},
	{60074, 0x400},
	{60087, 0x800},
	{60099, 0x1000},
	{60117, 0x2000},
	{60128, 0xC000},
	{60143, 0x30000},
	{60151, 0x40000},
	{60170, 0x80000},
	{97417, 0x700000},
	{97432, 0x10000000},
	{97455, 0x20000000},
	{60187, 0x40000000},
	{60199, 0x80000000},
	/* 2467 */
	{60213, 0xFFF},
	{60228, 0xFFF000},
	{60240, 0x1000000},
	{56251, 0x2000000},
	{60248, 0x4000000},
	{60268, 0x8000000},
	{97471, 0xF0000000},
	/* 2474 */
	{97482, 0x1},
	{97492, 0x2},
	{97502, 0x10},
	/* 2477 */
	{60439, 0x7},
	{60449, 0x38},
	{60459, 0x1C0},
	{60469, 0xE00},
	{17286, 0x7F000, 293, 2468},
	{64386, 0x600000},
	{64399, 0x800000},
	{64414, 0x1000000},
	{97530, 0xC000000},
	{64520, 0x30000000, 4, 2761},
	{209, 0xC0000000},
	/* 2488 */
	{64922, 0x1FFFFF},
	{64941, 0xE00000},
	{64960, 0x1000000},
	{64982, 0x2000000},
	{97542, 0x4000000},
	{65020, 0x8000000},
	{65037, 0x10000000},
	{65055, 0x20000000},
	{65071, 0xC0000000},
	/* 2497 */
	{65092, 0x7},
	{65102, 0x38},
	{65123, 0xC0},
	{97565, 0x700},
	{65144, 0x180000},
	{65163, 0xC000000},
	/* 2503 */
	{18432, 0x1FFF},
	{21148, 0x3FFF},
	{66906, 0x1FFF0000},
	/* 2506 */
	{66917, 0xF},
	{66929, 0xF0},
	{66937, 0xFFF00},
	{66950, 0x700000},
	{66959, 0x800000},
	{66974, 0x2000000},
	{66989, 0x4000000},
	{70801, 0x80000000},
	/* 2514 */
	{67001, 0xFF},
	{97530, 0x300},
	{67017, 0x400},
	{67029, 0x18000},
	{67057, 0x60000},
	{67083, 0x80000},
	{67101, 0x100000},
	{67123, 0x200000},
	{67138, 0x400000},
	{67154, 0x800000},
	{67170, 0xFF000000},
	/* 2525 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{67311, 0x800000},
	{67321, 0x1000000},
	{67338, 0x2000000},
	{55971, 0x4000000},
	{97574, 0x8000000},
	{55235, 0x20000000},
	/* 2537 */
	{68607, 0x1},
	{68626, 0x2},
	{68647, 0x4},
	{68658, 0x8},
	{68671, 0x10},
	{68690, 0x20},
	{68715, 0x40},
	{68738, 0x80},
	{68752, 0xF00},
	{68764, 0x1000},
	{97593, 0x2000},
	/* 2548 */
	{69681, 0x3, 4, 3083},
	{69710, 0x1C},
	{69741, 0x20},
	{69777, 0x40},
	{69812, 0x80},
	{69840, 0x100},
	{69862, 0x200},
	{69880, 0x400},
	{69912, 0x800},
	{70033, 0x7000, 8, 3087},
	{70043, 0x38000},
	{70056, 0x1C0000},
	{70069, 0x200000},
	{70085, 0x400000},
	{70103, 0x800000},
	{70121, 0x2000000},
	{97611, 0x4000000},
	{97631, 0x18000000},
	/* 2566 */
	{97657, 0x7},
	{97689, 0x30},
	{97709, 0xC0},
	/* 2569 */
	{70649, 0x3, 4, 3109},
	{70661, 0xC, 4, 3109},
	{70673, 0x30, 4, 3109},
	{70689, 0xC0, 4, 3109},
	{70759, 0x30000, 4, 3113},
	{70771, 0xC0000, 4, 3113},
	{70783, 0x300000, 4, 3113},
	{70799, 0x1000000},
	{70810, 0x2000000},
	{97729, 0x4000000},
	{97739, 0x8000000},
	{97749, 0x10000000},
	{97763, 0x20000000},
	/* 2582 */
	{9866, 0x1},
	{73379, 0x6},
	{65163, 0x60},
	{73421, 0x3000},
	{73428, 0x30000},
	{73442, 0x300000},
	/* 2588 */
	{73567, 0x3, 4, 3109},
	{73583, 0xC, 4, 3109},
	{73599, 0x30, 4, 3109},
	{73613, 0xC0, 4, 3109},
	{73629, 0x30000, 4, 3113},
	{73645, 0xC0000, 4, 3113},
	{73661, 0x300000, 4, 3113},
	{73675, 0xC00000, 4, 3113},
	{97778, 0x1000000},
	{97794, 0x2000000},
	{97810, 0x4000000},
	{97824, 0x8000000},
	{73691, 0x40000000},
	{73706, 0x80000000},
	/* 2602 */
	{738, 0x3F},
	{74490, 0x300},
	{74502, 0x400},
	{97840, 0x800},
	{74513, 0x1E000},
	{74522, 0x20000},
	{74536, 0x40000},
	{74540, 0x80000},
	{74557, 0x100000},
	{74575, 0x600000},
	{74593, 0x800000},
	{74613, 0x1000000},
	{74625, 0x2000000},
	/* 2615 */
	{738, 0x3F},
	{74490, 0x300},
	{74502, 0x400},
	{97840, 0x800},
	{74536, 0x40000},
	{74540, 0x80000},
	{74557, 0x100000},
	{74575, 0x600000},
	{74613, 0x1000000},
	{74625, 0x2000000},
	/* 2625 */
	{74637, 0x3E},
	{74653, 0x40},
	{74666, 0x80},
	{97854, 0x1F00},
	/* 2629 */
	{75187, 0x3F},
	{75208, 0x80},
	{75225, 0x100},
	{97872, 0x3E00},
	{75241, 0x4000},
	{75261, 0x8000},
	/* 2635 */
	{97888, 0x1},
	{97913, 0x2},
	{97938, 0x4},
	{97963, 0x8},
	{97988, 0x10},
	{98013, 0x20},
	{98038, 0x40},
	{98063, 0x80},
	/* 2643 */
	{76207, 0xF, 12, 36649},
	{76212, 0xF0, 12, 36649},
	{76217, 0xF00, 12, 36649},
	{76222, 0xF000, 12, 36649},
	{76227, 0xF0000, 12, 36649},
	{76232, 0xF00000, 12, 36649},
	{76237, 0xF000000, 12, 36649},
	{76242, 0xF0000000, 12, 36649},
	/* 2651 */
	{78021, 0x3, 4, 36055},
	{78067, 0xC, 2, 36059},
	{78078, 0x10},
	{78093, 0x20},
	{78101, 0x40},
	{78143, 0xE0000000},
	/* 2657 */
	{78634, 0x1},
	{98110, 0x2},
	{78652, 0x8},
	{966, 0x70, 8, 36061},
	{77925, 0xFF0000, 256, 36069},
	/* 2662 */
	{80397, 0x1},
	{80413, 0x2},
	{80429, 0x4},
	{80445, 0x8},
	{80461, 0x10},
	{80477, 0x20},
	{80493, 0x40},
	{80509, 0x80},
	{80525, 0x100},
	{80541, 0x200},
	{80557, 0x400},
	{80573, 0x800},
	{80589, 0x1000},
	{80605, 0x2000},
	{80621, 0x4000},
	{80637, 0x8000},
	{80653, 0x10000},
	{80672, 0x20000},
	{80690, 0x40000},
	{80717, 0x80000},
	{80739, 0x100000},
	{80757, 0x200000},
	{80777, 0x400000},
	{80800, 0x800000},
	{80823, 0x1000000},
	{80848, 0x2000000},
	{80891, 0x8000000},
	{98133, 0x10000000},
	{98150, 0x20000000},
	{98175, 0x40000000},
	/* 2692 */
	{81593, 0x1},
	{81610, 0x2},
	{98201, 0x3FC},
	/* 2695 */
	{98220, 0x7},
	{98246, 0x38},
	{98275, 0x1C0},
	{98300, 0xE00},
	{98326, 0x2000},
	{98349, 0x4000},
	/* 2701 */
	{82777, 0x1},
	{82789, 0x2},
	{82810, 0x4},
	{82830, 0x8},
	{82876, 0x20},
	{82899, 0x40},
	/* 2707 */
	{203, 0x3, 3, 36374},
	{83625, 0xC, 4, 36377},
	{83705, 0x30, 4, 36381},
	{83765, 0xC0, 3, 36385},
	{83778, 0x100},
	{78093, 0x200},
	{83782, 0x400},
	{83791, 0x3800},
	{98376, 0x4000},
	/* 2716 */
	{85056, 0x2},
	{85090, 0x8},
	{85106, 0x10},
	/* 2719 */
	{70441, 0x1},
	{85225, 0x2},
	{85236, 0x4},
	{85253, 0x8},
	{85270, 0x3F0},
	{85287, 0xFC00},
	{85304, 0x10000},
	{85328, 0x20000},
	{67088, 0x40000},
	{98401, 0x180000},
	/* 2729 */
	{87090, 0x7},
	{87107, 0x10},
	{87129, 0x1E000},
	{87145, 0x700000},
	{87166, 0x3000000},
	{87246, 0xC000000, 4, 36489},
	{98420, 0x10000000},
	{98445, 0x20000000},
	/* 2737 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 25, 36661},
	{65183, 0x80},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89767, 0x80000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	{90066, 0x8000000},
	{90092, 0x10000000},
	{90160, 0x60000000, 3, 36576},
	{98486, 0x80000000},
	/* 2756 */
	{73721, 0x1},
	{90334, 0x2},
	{67029, 0xC, 3, 36579},
	{90448, 0x10, 2, 36582},
	{67057, 0x60},
	{67154, 0x180},
	{90474, 0x200},
	{90497, 0x3C00},
	{90517, 0x3C000},
	{73837, 0x40000},
	{90539, 0x80000},
	{90572, 0x100000},
	{98497, 0x200000},
	{98517, 0x400000},
	/* 2770 */
	{90619, 0x1FFF},
	{90630, 0x2000},
	{90642, 0x7C000},
	{90656, 0xF80000},
	{90670, 0x3000000},
	{90684, 0x4000000},
	{64414, 0x38000000},
	{90703, 0x40000000},
	{98538, 0x80000000},
	/* 2779 */
	{98559, 0xFFFFFF},
	{10098, 0x7000000},
	{98565, 0x8000000},
	{1, 0x70000000},
	{98576, 0x80000000},
	/* 2784 */
	{98587, 0x1},
	{26317, 0xFFFFFFF8},
	/* 2786 */
	{91943, 0x1},
	{91957, 0x2},
	{98596, 0x8000},
	{91969, 0x10000},
	{91983, 0x1000000},
	/* 2791 */
	{92097, 0x30000},
	{98611, 0x300000},
	{98626, 0xC00000},
	{92105, 0x7000000},
	{92113, 0xE0000000},
	/* 2796 */
	{203, 0x3, 3, 36374},
	{98376, 0x4000},
	/* 2798 */
	{92659, 0x3FF},
	{92725, 0xC00, 4, 36584},
	/* 2800 */
	{93039, 0x1},
	{93051, 0x2},
	{93063, 0x4},
	{30203, 0x10000},
	{93074, 0x60000},
	/* 2805 */
	{80685, 0x1},
	{842, 0x1FFE},
	{209, 0x2000},
	{88627, 0x4000},
	{93149, 0x8000},
	{93161, 0x7FF0000},
	{93172, 0x8000000},
	{93183, 0x10000000},
	{93193, 0x20000000},
	{98636, 0x40000000},
	{93127, 0x80000000},
	/* 2816 */
	{93271, 0x1FF},
	{93290, 0xF00000},
	{94891, 0xF0000000},
	/* 2819 */
	{55899, 0x1},
	{85754, 0x2, 4, 36464},
	{85689, 0x4, 2, 36462},
	{19742, 0x8, 4, 36458},
	{85607, 0x10, 2, 36456},
	{85576, 0x20, 4, 36452},
	{94987, 0x40},
	{94993, 0x300},
	{95003, 0x2000},
	{98648, 0x4000},
	{98670, 0x8000},
	{98692, 0x10000},
	{98714, 0x20000},
	{98736, 0x40000},
	{98758, 0x80000},
	/* 2834 */
	{95981, 0x7FF},
	{10349, 0xFFFFF800},
	/* 2836 */
	{95986, 0xFF},
	{96007, 0x100},
	{96017, 0x200},
	{96025, 0x400},
	{96039, 0x800},
	{96050, 0x1000},
	{96069, 0x2000},
	{96093, 0x4000},
	{96107, 0x8000},
	{98780, 0x10000},
	{98793, 0x20000},
	{98804, 0x40000},
	{98821, 0x80000},
	{98835, 0x100000},
	{98847, 0x200000},
	{98863, 0x400000},
	{10349, 0xFF800000},
	/* 2853 */
	{96117, 0x1},
	{96141, 0x2},
	{96165, 0x4},
	{98879, 0x8},
	{96235, 0xF0},
	{98899, 0x100},
	{98919, 0x200},
	{98934, 0x400},
	{10349, 0xFFFFF800},
	/* 2862 */
	{96250, 0x1},
	{98959, 0x2},
	{98982, 0x4},
	{96339, 0x8},
	{98996, 0x10},
	{96262, 0x20},
	{99023, 0x40},
	{96274, 0x80},
	{99038, 0x100},
	{96284, 0x200},
	{99051, 0x400},
	{96305, 0x800},
	{99075, 0x1000},
	{96322, 0x2000},
	{99095, 0x4000},
	{99115, 0x8000},
	{99132, 0x10000},
	{99152, 0x20000},
	{99169, 0x40000},
	/* 2881 */
	{45486, 0xFFFFFFFF},
	/* 2882 */
	{45513, 0xFFFFFFFF},
	/* 2883 */
	{738, 0xFFFF},
	{10349, 0xFFFF0000},
	/* 2885 */
	{99189, 0xFF},
	{99203, 0xFF00},
	{99226, 0xFF0000},
	{10349, 0xFF000000},
	/* 2889 */
	{99253, 0xFF},
	{99269, 0xFF00},
	{10349, 0xFFFF0000},
	/* 2892 */
	{99285, 0xFFFF},
	/* 2893 */
	{55065, 0xF},
	{55074, 0xF0},
	{55084, 0x100},
	{55095, 0x200},
	{55100, 0x400},
	{99292, 0x800},
	{55227, 0x7F000, 257, 0},
	{55258, 0x10000000},
	{55264, 0xE0000000},
	/* 2902 */
	{55268, 0x1},
	{55272, 0x6},
	{99301, 0x18},
	{55291, 0x20},
	{55296, 0x40},
	{55304, 0x80},
	{55314, 0x100},
	{55325, 0x200},
	{55331, 0x400},
	{55336, 0x800},
	{55342, 0x1000},
	{55353, 0x2000},
	{55358, 0x4000},
	{99311, 0x8000},
	{55114, 0x10000},
	{55378, 0x20000},
	{55386, 0x40000},
	{55398, 0x80000},
	{99324, 0x100000},
	{99338, 0x200000},
	{99351, 0x400000},
	{99360, 0x800000},
	{99369, 0x7000000},
	{55417, 0x8000000},
	/* 2926 */
	{55429, 0x7F, 257, 0},
	{55474, 0x3F0000},
	{55527, 0xE0000000},
	/* 2929 */
	{50450, 0xF},
	{55535, 0x30},
	{55543, 0xC0},
	{55551, 0xF00},
	{55557, 0x1000},
	{28872, 0x2000},
	{55575, 0xF0000},
	{55581, 0xF00000},
	{55587, 0x7000000},
	{55596, 0x38000000},
	{55605, 0xC0000000},
	/* 2940 */
	{55611, 0x3F},
	{55621, 0x3F00},
	{55631, 0x3F0000},
	{55641, 0xF000000},
	/* 2944 */
	{55651, 0xFF},
	{55660, 0x1FF000},
	/* 2946 */
	{55686, 0xF},
	{55693, 0x70},
	{55715, 0x1F00},
	{55724, 0xE000},
	/* 2950 */
	{1096, 0xFF},
	/* 2951 */
	{46941, 0xFFFFFFFF},
	/* 2952 */
	{99389, 0x7},
	{99397, 0x8},
	{99408, 0x10},
	{99421, 0xE0},
	{99437, 0x300},
	{99447, 0xC00},
	{99457, 0x70000},
	{55849, 0x380000},
	{99469, 0xC00000},
	{99476, 0x1000000},
	{99483, 0x6000000},
	{69274, 0x8000000},
	{99491, 0x10000000},
	/* 2965 */
	{9978, 0xFF},
	/* 2966 */
	{99508, 0x1},
	{99524, 0x2},
	{56345, 0x4},
	{99539, 0x8},
	{99555, 0x10},
	{56318, 0x20},
	{99564, 0x40},
	{99575, 0x80},
	{99585, 0x100},
	{99595, 0x200},
	{99605, 0x400},
	{99616, 0x800},
	{99627, 0x1000},
	{99639, 0x2000},
	{99648, 0x4000},
	{99658, 0x8000},
	{97346, 0x10000},
	{97363, 0x20000},
	{99667, 0x40000},
	{99685, 0x80000},
	{99700, 0x100000},
	/* 2987 */
	{99716, 0x2},
	{99731, 0x4},
	{99749, 0x8},
	{56442, 0x10},
	{99764, 0x20},
	{99780, 0x40},
	{99794, 0x100},
	{99803, 0x200},
	{99812, 0x400},
	{99833, 0x800},
	{99842, 0x1000},
	{99851, 0x2000},
	{99861, 0x4000},
	{99870, 0x10000},
	{99879, 0x20000},
	{99887, 0x80000},
	{99896, 0x100000},
	{99908, 0x200000},
	{99921, 0x400000},
	{99934, 0x20000000},
	/* 3007 */
	{99943, 0x1},
	{99953, 0x2},
	{99963, 0x4},
	{99973, 0x8},
	{99983, 0x10},
	{99993, 0x20},
	{100003, 0x40},
	{100013, 0x80},
	{100023, 0x100},
	{100033, 0x200},
	{100043, 0x400},
	{100053, 0x800},
	{100063, 0x1000},
	{100073, 0x2000},
	{100083, 0x4000},
	{100093, 0x8000},
	/* 3023 */
	{100103, 0xFF},
	/* 3024 */
	{100116, 0x3F},
	{100135, 0xFC0},
	/* 3026 */
	{56001, 0xF},
	{56230, 0x1},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56362, 0x100},
	{56130, 0x200},
	{57300, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	/* 3043 */
	{100146, 0xF},
	{100155, 0xF0},
	/* 3045 */
	{56418, 0xF},
	{100164, 0x20},
	{56457, 0x80},
	{56480, 0x100},
	{56503, 0x200},
	{56522, 0x1000},
	{56531, 0x2000},
	{56540, 0x4000},
	{56548, 0x8000},
	{100180, 0x10000},
	{100195, 0x20000},
	{100204, 0x40000},
	{100219, 0x80000},
	{56572, 0x100000},
	{100227, 0x200000},
	{56588, 0x400000},
	{56597, 0x800000},
	{56606, 0x1000000},
	{56614, 0x2000000},
	{56622, 0x4000000},
	{56630, 0x10000000},
	{56372, 0x20000000},
	{56648, 0x40000000},
	{56656, 0x80000000},
	/* 3069 */
	{56522, 0x2},
	{56531, 0x4},
	{56597, 0x400000},
	{100195, 0x800000},
	{56614, 0x1000000},
	{56540, 0x2000000},
	{56572, 0x4000000},
	{56588, 0x8000000},
	{56606, 0x20000000},
	{56622, 0x40000000},
	{56648, 0x80000000},
	/* 3080 */
	{100235, 0x1},
	{100249, 0x4},
	{100264, 0x10000},
	{100279, 0x20000},
	{100294, 0x40000},
	{100309, 0x80000},
	/* 3086 */
	{100324, 0x3F},
	/* 3087 */
	{92569, 0xFF},
	{100341, 0xFF00},
	{92531, 0xFF0000},
	{100350, 0x20000000},
	{92604, 0x40000000},
	{92630, 0x80000000},
	/* 3093 */
	{100370, 0xF},
	{100387, 0x1F00},
	/* 3095 */
	{47176, 0xFF},
	/* 3096 */
	{100402, 0x2},
	{100413, 0x20},
	{100424, 0x40},
	{100445, 0x80},
	{100465, 0xF00},
	{100487, 0x1000},
	/* 3102 */
	{100513, 0x1},
	{100521, 0x2},
	{100529, 0x2},
	{100538, 0x8},
	{100554, 0x10},
	{100570, 0x40},
	{100591, 0x80},
	{100612, 0x100},
	{100633, 0x200},
	{100641, 0x200},
	{100662, 0x400},
	{100683, 0x800},
	{100704, 0x1000},
	{100725, 0x2000},
	{100746, 0x4000},
	{100767, 0x8000},
	{100788, 0x10000},
	{100809, 0x20000},
	{100830, 0x40000},
	{100851, 0x80000},
	{100872, 0x100000},
	{100893, 0x200000},
	/* 3124 */
	{100914, 0x3FFFC},
	{100927, 0x300000},
	{100939, 0xC00000},
	{47229, 0x80000000},
	/* 3128 */
	{100949, 0x1},
	{100966, 0x80000},
	/* 3130 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{100986, 0x1000},
	{94153, 0x2000},
	{94179, 0x4000},
	{94205, 0x10000},
	{94232, 0x20000},
	{94258, 0x40000},
	{94284, 0x80000},
	{94312, 0x100000},
	{94338, 0x200000},
	{94364, 0x400000},
	{101013, 0x800000},
	{94390, 0x1000000},
	{94417, 0x2000000},
	{94444, 0x4000000},
	{101039, 0x8000000},
	{101065, 0x10000000},
	/* 3149 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{94153, 0x1000},
	{94179, 0x2000},
	{94205, 0x8000},
	{94232, 0x10000},
	{94312, 0x20000},
	{94338, 0x40000},
	{100986, 0x80000},
	{94258, 0x100000},
	{94417, 0x200000},
	/* 3161 */
	{47254, 0x3FFFF},
	/* 3162 */
	{47140, 0xFFFFFFFF},
	/* 3163 */
	{101091, 0x1},
	{101104, 0x2},
	{101108, 0x4},
	{101130, 0x8},
	{101144, 0x10},
	{101158, 0x20},
	{101176, 0x40},
	{101194, 0x80},
	{28872, 0x2000000},
	{98411, 0xC000000},
	/* 3173 */
	{91260, 0x3},
	{9949, 0xFFFFFFFC},
	/* 3175 */
	{101209, 0x3},
	{24312, 0xFFFFFFFC},
	/* 3177 */
	{24334, 0xFFFFFFFF},
	/* 3178 */
	{101230, 0x3},
	{24828, 0xFFFFFFFC},
	/* 3180 */
	{24850, 0xFFFFFFFF},
	/* 3181 */
	{91234, 0xFF},
	{91246, 0x30000},
	{26637, 0xE0000000},
	/* 3184 */
	{101251, 0x3},
	{26187, 0xFFFFFFFC},
	/* 3186 */
	{26205, 0xFF},
	/* 3187 */
	{101268, 0x3},
	{26259, 0xFFFFFFFC},
	/* 3189 */
	{26277, 0xFF},
	/* 3190 */
	{26336, 0xFF},
	{91270, 0x10000},
	{91286, 0x100000},
	{91302, 0x3000000},
	{91318, 0xE0000000},
	/* 3195 */
	{92276, 0x1},
	{92292, 0x2},
	{92308, 0x40},
	{92326, 0x80},
	{92344, 0x100},
	{92362, 0x200},
	{92380, 0x400},
	{92398, 0x800},
	{92416, 0x1000},
	{92434, 0x2000},
	{92452, 0x4000},
	{91520, 0x8000},
	{101285, 0x10000},
	{91540, 0x40000},
	{92469, 0x80000},
	{92485, 0x200000},
	{91557, 0x400000},
	{91573, 0x800000},
	{91587, 0x2000000},
	{91601, 0x4000000},
	{91615, 0x8000000},
	{91636, 0x10000000},
	{91661, 0x20000000},
	/* 3218 */
	{92501, 0xFF},
	{91738, 0x3000000},
	{101303, 0x40000000},
	{979, 0x80000000},
	/* 3222 */
	{26574, 0xFF},
	/* 3223 */
	{26615, 0xFF},
	/* 3224 */
	{91743, 0x1FFFFF},
	{91781, 0x200000},
	{101317, 0xC00000},
	{101326, 0x3000000},
	{91754, 0x4000000},
	{91758, 0x8000000},
	{91762, 0x10000000},
	{91767, 0x20000000},
	{91772, 0x40000000},
	/* 3233 */
	{91822, 0x30},
	{91834, 0xF0000},
	{91847, 0x10000000},
	{91862, 0x20000000},
	{91876, 0xC0000000},
	/* 3238 */
	{91937, 0x1},
	/* 3239 */
	{101335, 0x1},
	{101360, 0x2},
	{101398, 0x4},
	{101439, 0x8},
	{101462, 0x10},
	{101485, 0x20},
	{101509, 0x40},
	{101539, 0x80},
	{101568, 0x100},
	{101599, 0x400},
	{101625, 0x800},
	{101654, 0x1000},
	{101679, 0x2000},
	{58993, 0x4000},
	{59014, 0x8000},
	/* 3254 */
	{101714, 0x1},
	{101741, 0x4},
	{101768, 0x10},
	{101797, 0x400},
	{101826, 0x800},
	{101855, 0x1000},
	{101883, 0x2000},
	{101913, 0x4000},
	{101940, 0x8000},
	{101968, 0x10000},
	{101994, 0x20000},
	{102020, 0x800000},
	{102045, 0x1000000},
	{102071, 0x2000000},
	{102096, 0x4000000},
	{102120, 0x8000000},
	{102145, 0x10000000},
	{102174, 0x10000000},
	/* 3272 */
	{102202, 0x1},
	{102228, 0x2},
	{102254, 0x4},
	{102281, 0x10},
	{102307, 0x20},
	{102329, 0x40},
	{102350, 0x80},
	{102382, 0x100},
	{102409, 0x200},
	{102431, 0x400},
	{102455, 0x800},
	{102480, 0x1000},
	{102503, 0x2000},
	{102530, 0x4000},
	{102555, 0x8000},
	{102583, 0x10000},
	{102608, 0x20000},
	{102633, 0x40000},
	{102658, 0x80000},
	{102687, 0x100000},
	{102718, 0x200000},
	{102746, 0x400000},
	{102773, 0x800000},
	{102803, 0x1000000},
	{102830, 0x2000000},
	{102857, 0x4000000},
	{102884, 0x8000000},
	{102910, 0x10000000},
	{102934, 0x20000000},
	{102966, 0x40000000},
	{102993, 0x80000000},
	/* 3303 */
	{58330, 0x1},
	{103019, 0x40},
	{103038, 0x80},
	{103058, 0x100},
	{103077, 0x200},
	{103091, 0x400},
	{103104, 0x1000},
	{103126, 0x2000},
	{103149, 0x4000},
	{103170, 0x8000},
	{103187, 0x20000},
	{103202, 0x40000},
	{103216, 0x80000},
	{103230, 0x100000},
	{103246, 0x200000},
	{103259, 0x400000},
	/* 3319 */
	{103278, 0x80},
	{103293, 0x100},
	{58014, 0x200},
	{58028, 0x400},
	{58047, 0x800},
	{58066, 0x1000},
	{103308, 0x2000},
	{103082, 0x8000},
	{103316, 0x10000},
	{103096, 0x20000},
	{103325, 0x40000},
	{58142, 0x80000},
	{58157, 0x100000},
	{103336, 0x200000},
	{56319, 0x400000},
	{58190, 0x800000},
	{57007, 0x1000000},
	{103354, 0x2000000},
	{103251, 0x4000000},
	{56997, 0x8000000},
	{58081, 0x10000000},
	{58098, 0x20000000},
	{58120, 0x40000000},
	{56372, 0x80000000},
	/* 3343 */
	{47521, 0xFFFFFFFF},
	/* 3344 */
	{47539, 0xFFFFFFFF},
	/* 3345 */
	{1838, 0x3F},
	{103367, 0x3F00},
	{103382, 0x3F0000},
	/* 3348 */
	{47577, 0xFFFFFFFF},
	/* 3349 */
	{47598, 0x1F},
	/* 3350 */
	{103397, 0xF},
	{103420, 0x3F00},
	/* 3352 */
	{103441, 0xF},
	/* 3353 */
	{103460, 0x10},
	{103481, 0x40},
	{103503, 0x100},
	{103524, 0x1000000},
	{103532, 0x2000000},
	{103540, 0x4000000},
	{103549, 0x8000000},
	{103558, 0x10000000},
	{103566, 0x20000000},
	/* 3362 */
	{103574, 0xFF},
	{103595, 0x700},
	{103616, 0xFF00000},
	{103636, 0x70000000},
	/* 3366 */
	{103656, 0x1},
	/* 3367 */
	{103677, 0xFFFFF},
	/* 3368 */
	{103685, 0xFFFFFFF},
	{103701, 0xF0000000},
	/* 3370 */
	{103717, 0xFFFF},
	{103732, 0xFFFF0000},
	/* 3372 */
	{27310, 0xFF},
	/* 3373 */
	{27364, 0xFF},
	/* 3374 */
	{27416, 0xFF},
	/* 3375 */
	{27547, 0xFF},
	/* 3376 */
	{103748, 0xFF},
	{103758, 0xFF00},
	{103768, 0xFF0000},
	{103781, 0xFF000000},
	/* 3380 */
	{103794, 0xFF},
	{103807, 0xFF00},
	{103820, 0xFF0000},
	{103833, 0xFF000000},
	/* 3384 */
	{103846, 0xFF},
	{103857, 0xFF00},
	{103868, 0xFF0000},
	/* 3387 */
	{103879, 0x3F},
	{103893, 0x3F00},
	/* 3389 */
	{103907, 0xFF},
	{103918, 0xFF00},
	/* 3391 */
	{103929, 0x7FF},
	{103942, 0x7FF0000},
	/* 3393 */
	{103954, 0x1FF},
	/* 3394 */
	{103962, 0x7FF},
	/* 3395 */
	{103974, 0x3FF},
	/* 3396 */
	{47902, 0x7FF},
	{103982, 0x3000},
	{103993, 0x30000},
	/* 3399 */
	{47915, 0xFFFFFFFF},
	/* 3400 */
	{104007, 0x3FF},
	{104024, 0x3FF0000},
	/* 3402 */
	{104041, 0x3FF},
	{104060, 0x3FF0000},
	/* 3404 */
	{104079, 0x3FF},
	{104098, 0x3FF0000},
	/* 3406 */
	{104117, 0x3FF},
	/* 3407 */
	{104126, 0x3FF},
	{104135, 0x3FF0000},
	/* 3409 */
	{104144, 0x7FF},
	{104157, 0x7FF0000},
	/* 3411 */
	{104169, 0x7FF},
	/* 3412 */
	{104181, 0x3FF},
	{104198, 0x3FF0000},
	/* 3414 */
	{104215, 0x3FF},
	{104234, 0x3FF0000},
	/* 3416 */
	{104253, 0x3FF},
	{104272, 0x3FF0000},
	/* 3418 */
	{104291, 0x4000},
	{104317, 0x20000},
	{104347, 0x80000},
	{104370, 0x100000},
	{104394, 0x400000},
	{104418, 0x800000},
	{104440, 0x1000000},
	{104466, 0x4000000},
	{104490, 0x8000000},
	{104522, 0x20000000},
	{104544, 0x40000000},
	{104566, 0x80000000},
	/* 3430 */
	{93271, 0xFF},
	{93280, 0xFFC00},
	{94837, 0xF00000},
	{94858, 0xF000000},
	{94891, 0xF0000000},
	/* 3435 */
	{93271, 0xFF},
	{94891, 0xF0000000},
	/* 3437 */
	{104588, 0x3FF},
	/* 3438 */
	{48368, 0x1FF},
	/* 3439 */
	{48392, 0x3F},
	/* 3440 */
	{48415, 0x3F},
	/* 3441 */
	{77930, 0x7},
	{104599, 0x70000},
	/* 3443 */
	{48460, 0x3},
	{104612, 0x20},
	{104631, 0xC0},
	{104645, 0x200},
	{104657, 0x800},
	{104678, 0x1000},
	{104695, 0x2000},
	{104716, 0x1F0000},
	/* 3451 */
	{104725, 0x7F},
	{82478, 0x80},
	{104746, 0x3FFF00},
	{82543, 0xFFC00000},
	/* 3455 */
	{104763, 0x1F},
	/* 3456 */
	{104774, 0x3},
	/* 3457 */
	{100219, 0x1},
	{104792, 0x2},
	{104804, 0x4},
	{104820, 0x8},
	{104832, 0x10},
	/* 3462 */
	{104844, 0x3F},
	{104859, 0x40},
	/* 3464 */
	{104879, 0x3F},
	{104893, 0x40},
	/* 3466 */
	{100195, 0x1},
	{104912, 0x2},
	{104930, 0x4},
	{104943, 0x8},
	{104955, 0x10},
	{104967, 0x20},
	{104979, 0x40},
	{104991, 0x80},
	{105003, 0x100},
	{105015, 0x200},
	/* 3476 */
	{105029, 0xFF},
	/* 3477 */
	{18448, 0x3F, 29, 36686},
	/* 3478 */
	{203, 0x3, 2, 36374},
	/* 3479 */
	{105237, 0xF},
	{105246, 0xFF0},
	{105261, 0x1000000},
	{105276, 0x2000000},
	{105288, 0x4000000},
	{105299, 0x8000000},
	{105314, 0x10000000},
	{105329, 0x20000000},
	{105341, 0x40000000},
	{105355, 0x80000000},
	/* 3489 */
	{9866, 0x1},
	{10096, 0x1E},
	/* 3491 */
	{105237, 0xF},
	{105246, 0xFF0},
	{105261, 0x1000000},
	{105276, 0x2000000},
	{105288, 0x4000000},
	{105299, 0x8000000},
	{105314, 0x10000000},
	{105341, 0x20000000},
	{105368, 0x20000000},
	{105355, 0x80000000},
	/* 3501 */
	{105383, 0x1},
	{105396, 0x7E},
	{105413, 0x80},
	/* 3504 */
	{92659, 0x7F},
	{92725, 0x600, 4, 36584},
	/* 3506 */
	{105438, 0x6},
	{105448, 0x8},
	{105468, 0x10},
	{105477, 0xFFFF0000},
	/* 3510 */
	{105490, 0x1F},
	/* 3511 */
	{105504, 0x80000000},
	/* 3512 */
	{105512, 0x1},
	{105533, 0x6},
	{105546, 0x8},
	{105569, 0x10},
	{105589, 0x20},
	{105608, 0x10000000},
	{105619, 0x20000000},
	{105630, 0x40000000},
	{105641, 0x80000000},
	/* 3521 */
	{105237, 0xF},
	{105246, 0xFF0},
	{105261, 0x1000000},
	{105652, 0x2000000},
	{105667, 0x4000000},
	{105299, 0x8000000},
	{105314, 0x10000000},
	{105682, 0x20000000},
	{105698, 0x40000000},
	{105714, 0x80000000},
	/* 3531 */
	{105731, 0x80000000},
	/* 3532 */
	{18432, 0xFF},
	/* 3533 */
	{93271, 0x1FF},
	{93280, 0xFFC00},
	{94837, 0xF00000},
	/* 3536 */
	{105739, 0xFFFF},
	{105761, 0xFFFF0000},
	/* 3538 */
	{105237, 0xF},
	{105246, 0xFF0},
	{105261, 0x1000000},
	{105652, 0x2000000},
	{105667, 0x4000000},
	{105299, 0x8000000},
	{105314, 0x10000000},
	{105368, 0x20000000},
	{105783, 0x40000000},
	{105798, 0x80000000},
	/* 3548 */
	{105813, 0x3F},
	{105840, 0x7FC0},
	{105866, 0x1F8000},
	{105888, 0xFF800000},
	/* 3552 */
	{105913, 0x3F},
	{105937, 0xFC0},
	{105961, 0x3F000},
	{105981, 0xFC0000},
	/* 3556 */
	{106001, 0x3F},
	/* 3557 */
	{106015, 0x1},
	{106041, 0x2},
	{106064, 0x4},
	{106089, 0x8},
	{106120, 0x10},
	{106154, 0x20},
	{106174, 0xC0},
	{106201, 0x100},
	{106229, 0x200},
	{106264, 0x400},
	{106294, 0x800},
	{106329, 0x1000},
	{106359, 0x2000},
	{106382, 0x4000},
	{106421, 0x8000},
	{106453, 0x10000},
	{106489, 0x20000},
	{106519, 0x40000},
	{106565, 0x80000},
	{106606, 0x100000},
	{106656, 0x200000},
	{106706, 0x400000},
	{106757, 0x800000},
	{106805, 0x1000000},
	{105630, 0x40000000},
	{105641, 0x80000000},
	/* 3583 */
	{55858, 0xFF},
	{99292, 0x100},
	{106851, 0x200},
	{106870, 0x400},
	{106891, 0x800},
	{106910, 0x1000},
	{106932, 0x2000},
	{106953, 0x4000},
	{106976, 0x8000},
	/* 3592 */
	{107006, 0x3},
	{107022, 0xC},
	{107038, 0x30},
	{107054, 0x40},
	{107069, 0x80},
	{107087, 0x100},
	{107102, 0x200},
	{107121, 0x400},
	{107139, 0x800},
	/* 3601 */
	{107160, 0x1},
	{107176, 0x2},
	{107192, 0x4},
	/* 3604 */
	{107212, 0x7F},
	{107216, 0x380},
	{107220, 0x1FFC00},
	/* 3607 */
	{107224, 0x3F},
	{107237, 0xF00},
	{107249, 0x10000000},
	{107258, 0x20000000},
	{101194, 0x40000000},
	{101163, 0x80000000},
	/* 3613 */
	{107272, 0xF},
	{107292, 0xF00},
	{107309, 0x30000},
	{107325, 0xC0000},
	/* 3617 */
	{55899, 0x1},
	{85754, 0x2, 4, 36464},
	{85689, 0x4, 2, 36462},
	{19742, 0x8, 4, 36458},
	{85607, 0x10, 2, 36456},
	{85576, 0x20, 4, 36452},
	{94987, 0x40},
	{94993, 0x1F00},
	{95003, 0x2000},
	/* 3626 */
	{107345, 0xF0000},
	{107363, 0xF00000},
	{107381, 0xF000000},
	{107399, 0xF0000000},
	/* 3630 */
	{56251, 0x1},
	{107417, 0x2},
	{107436, 0xFFF0},
	{107451, 0xFFF0000},
	/* 3634 */
	{93271, 0x1FF},
	{94973, 0xF000},
	{107466, 0xF0000},
	{93290, 0xF00000},
	{107482, 0xF000000},
	{94891, 0xF0000000},
	/* 3640 */
	{107492, 0xFFFF},
	{107508, 0xFFFF0000},
	/* 3642 */
	{105237, 0xF},
	{105246, 0xFF0},
	{105341, 0x40000000},
	{105355, 0x80000000},
	/* 3646 */
	{50450, 0xF},
	{55535, 0x30},
	{107524, 0xFC0},
	{107534, 0x1000},
	{107544, 0x2000},
	{100103, 0x4000},
	{107555, 0x8000},
	{441, 0xFFFF0000},
	/* 3654 */
	{107565, 0xFFFFFFFF},
	/* 3655 */
	{38, 0x3FFFFF},
	/* 3656 */
	{107570, 0x1F},
	{107577, 0x20},
	{60061, 0x80},
	{107584, 0x3000},
	{60074, 0x4000},
	{60087, 0x8000},
	{107595, 0xFFFF0000},
	{107595, 0xFFFF0000},
	/* 3664 */
	{2116, 0xFFFF},
	{107607, 0xFF0000},
	{60099, 0x1000000},
	/* 3667 */
	{107616, 0xFFFF},
	{107625, 0xFFFF0000},
	/* 3669 */
	{2074, 0x3FFFFFFF},
	{107634, 0xC0000000},
	/* 3671 */
	{60213, 0x7},
	{60228, 0x70000},
	{107646, 0x20000000},
	{56251, 0x40000000},
	{68297, 0x80000000},
	/* 3676 */
	{107654, 0x7},
	{107662, 0x38},
	{107670, 0x1C0},
	{107678, 0xE00},
	{107686, 0x7000},
	{107694, 0x38000},
	{107702, 0x1C0000},
	{966, 0x600000},
	{107710, 0x1800000},
	{107723, 0x2000000},
	{55291, 0x4000000},
	{107736, 0x18000000},
	{107747, 0x20000000},
	{60034, 0x40000000},
	{64690, 0x80000000},
	/* 3691 */
	{107757, 0x80000000},
	/* 3692 */
	{49737, 0x7},
	/* 3693 */
	{107770, 0x3FFF},
	{107780, 0x3FFF0000},
	{107790, 0xC0000000},
	/* 3696 */
	{107803, 0x3FFF},
	{107819, 0x3FF0000},
	{107844, 0x78000000},
	{107869, 0x80000000},
	/* 3700 */
	{68280, 0x1},
	{68574, 0x2},
	{11216, 0x4},
	/* 3703 */
	{107883, 0xFF},
	{107892, 0xFF00},
	{107901, 0xFF0000},
	{107910, 0xFF000000},
	/* 3707 */
	{107919, 0x3F},
	{107927, 0x1F00},
	{107936, 0x1FF0000},
	/* 3710 */
	{107945, 0x3F},
	{107953, 0x1F00},
	{107962, 0x1FF0000},
	/* 3713 */
	{50450, 0xF},
	{55535, 0x30},
	{30487, 0x1C0},
	{55581, 0x1E00},
	/* 3717 */
	{60439, 0x7, 8, 36715},
	{60449, 0x38, 8, 36715},
	{60459, 0x1C0, 8, 36715},
	{60469, 0xE00, 8, 36715},
	{108235, 0x7000, 8, 36723},
	{108627, 0x78000, 16, 36731},
	{108639, 0x180000},
	{64386, 0x600000},
	{64399, 0x800000},
	{83778, 0x1000000},
	{108652, 0x2000000},
	{108664, 0x4000000},
	{83791, 0x38000000},
	{209, 0xC0000000, 4, 36747},
	/* 3731 */
	{60382, 0xFF},
	{64720, 0xFFF00},
	{108627, 0x3F00000, 64, 36751},
	{108235, 0x3C000000, 16, 36815},
	{83791, 0xC0000000},
	/* 3736 */
	{66440, 0x3FFF},
	{66547, 0xFFFC000},
	{66950, 0x70000000},
	{110722, 0x80000000},
	/* 3740 */
	{60439, 0x7, 8, 36715},
	{60449, 0x38, 8, 36715},
	{60459, 0x1C0, 8, 36715},
	{60469, 0xE00, 8, 36715},
	{66769, 0xF000},
	{66780, 0xF0000},
	{110733, 0x1F00000},
	{110746, 0x2000000},
	{83791, 0x4000000},
	{83778, 0x8000000},
	{209, 0xF0000000, 16, 36831},
	/* 3751 */
	{18432, 0x1FFF},
	{21148, 0x7FFE000},
	/* 3753 */
	{66906, 0x1FFF},
	{111057, 0x3FFE000},
	/* 3755 */
	{66937, 0xFFF},
	{67001, 0xFF000},
	{66974, 0x100000},
	{111068, 0xFFE00000},
	/* 3759 */
	{111068, 0xFFFFFFFF},
	/* 3760 */
	{64531, 0x7, 8, 36847},
	{64539, 0x38, 8, 36847},
	{64547, 0x1C0, 8, 36847},
	{64555, 0xE00},
	{64571, 0x7000, 8, 36855},
	{64590, 0x8000},
	{64609, 0x70000},
	{64625, 0x80000},
	{64640, 0x100000},
	{64654, 0x7E00000},
	{64665, 0x8000000},
	{64677, 0x10000000},
	{64695, 0x60000000, 3, 36863},
	/* 3773 */
	{64752, 0x3FFF},
	{64796, 0xFC000},
	{64809, 0x300000, 4, 36866},
	{64823, 0xC00000, 4, 36866},
	{64837, 0x3000000, 3, 36870},
	{64846, 0xC000000, 3, 36873},
	{64857, 0x10000000},
	{111809, 0x20000000},
	{111826, 0x40000000},
	/* 3782 */
	{64761, 0xFFF},
	{111842, 0x20000000},
	{64778, 0xC0000000, 4, 36876},
	/* 3785 */
	{65092, 0x7},
	{65102, 0x70},
	{111984, 0x700},
	{65144, 0x3000},
	{112005, 0x70000},
	{112029, 0x700000},
	{112038, 0x3000000},
	{112058, 0x30000000},
	{112067, 0x40000000},
	/* 3794 */
	{112117, 0x3, 4, 36880},
	{65533, 0x3C, 16, 2765},
	{65961, 0x7C0, 18, 2781},
	{66151, 0x3800, 7, 2800},
	{66310, 0x1C00000, 5, 2807},
	{66330, 0x6000000},
	/* 3800 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67321, 0x1000000},
	{112144, 0xE000000},
	{112154, 0x10000000},
	/* 3811 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67384, 0x80},
	{67396, 0xFF00},
	{55227, 0x7F0000, 257, 0},
	/* 3817 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{67855, 0x4000000},
	{112144, 0x38000000},
	{112154, 0x40000000},
	/* 3829 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{67881, 0x100},
	{67893, 0x200},
	{67905, 0x400},
	{67917, 0x800},
	{67929, 0x1000},
	{55227, 0xFE000, 257, 0},
	/* 3839 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67855, 0x1000000},
	{112144, 0xE000000},
	{112154, 0x10000000},
	/* 3850 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55227, 0x3F80, 257, 0},
	/* 3854 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{55227, 0x7F00, 257, 0},
	{55660, 0x1FF00000},
	/* 3860 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{112144, 0x7000000},
	{112154, 0x8000000},
	/* 3870 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{68077, 0x100},
	{55227, 0xFE00, 257, 0},
	/* 3876 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{112144, 0x1C000000},
	{112154, 0x20000000},
	/* 3887 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55660, 0xFF80},
	{55227, 0x7F0000, 257, 0},
	/* 3892 */
	{68088, 0x1},
	{68106, 0x2},
	{68120, 0x4},
	{68139, 0x8},
	{68159, 0x10},
	{68179, 0x20},
	{68201, 0x40},
	{112164, 0x380},
	{68212, 0x400},
	{68230, 0x800},
	{99351, 0x1000},
	{68262, 0x4000},
	/* 3904 */
	{50446, 0xFFF},
	/* 3905 */
	{391, 0xFF},
	{99360, 0x100},
	/* 3907 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{68321, 0x1000000},
	{112154, 0x2000000},
	/* 3917 */
	{68384, 0x3F},
	{112184, 0x3F},
	{68397, 0xF000},
	{68407, 0x3F0000},
	{68422, 0x400000},
	{68437, 0x800000},
	{68453, 0x7000000},
	/* 3924 */
	{112202, 0xFFFF},
	{112212, 0xFFFF0000},
	/* 3926 */
	{42962, 0x1},
	{112222, 0x2},
	{112231, 0x4},
	{112240, 0x8},
	{112248, 0x10},
	{112260, 0x20},
	{112272, 0x40},
	{112284, 0x80},
	{112296, 0x100},
	{112307, 0x200},
	{112317, 0x400},
	{112325, 0x800},
	{112351, 0x1000},
	{112364, 0x2000},
	{112375, 0x4000},
	{112385, 0x8000},
	{112399, 0x10000},
	{112415, 0x20000},
	{112431, 0x40000},
	{112447, 0x80000},
	{112458, 0x100000},
	{112475, 0x200000},
	{112491, 0x400000},
	{112510, 0x2000000},
	{112524, 0x4000000},
	{112533, 0x8000000},
	{112547, 0x30000000},
	{112562, 0x40000000},
	{112571, 0x80000000},
	/* 3955 */
	{68782, 0x1},
	{68806, 0x2},
	{68896, 0x70},
	{68908, 0xF00},
	{68921, 0xF000},
	{68934, 0xF0000},
	{68947, 0xF00000},
	{68961, 0xF000000},
	{68979, 0xF0000000},
	/* 3964 */
	{68996, 0x7FF},
	{69023, 0xFFE000},
	{69033, 0x1000000},
	{69045, 0x2000000},
	/* 3968 */
	{112585, 0xF},
	{65533, 0xF0, 16, 2765},
	{65961, 0x1F00, 18, 2781},
	{66435, 0x6000, 4, 2812},
	{66542, 0x18000, 4, 2816},
	{66654, 0x60000, 4, 2820},
	{66741, 0x180000, 4, 2824},
	/* 3975 */
	{17286, 0x3, 4, 3099},
	{70338, 0xC},
	{66151, 0xE000, 7, 2800},
	{90190, 0x700000},
	{70489, 0x8000000},
	{70504, 0x10000000},
	{70514, 0x20000000},
	{70534, 0x80000000},
	/* 3983 */
	{17286, 0x1, 2, 3107},
	{66151, 0xE000, 7, 2800},
	{90190, 0x700000},
	{70489, 0x8000000},
	{70577, 0x20000000},
	/* 3988 */
	{112604, 0x7FF},
	{112619, 0x3FF800},
	/* 3990 */
	{112635, 0x3FFFFF},
	/* 3991 */
	{50660, 0x3},
	/* 3992 */
	{75187, 0x3F},
	{75198, 0x40},
	{75241, 0x4000},
	/* 3995 */
	{11593, 0xFF},
	/* 3996 */
	{78652, 0x8},
	{966, 0x70, 6, 36061},
	{77925, 0xFF0000, 256, 36069},
	/* 3999 */
	{18448, 0x1F, 29, 36686},
	{82285, 0x4000},
	{82298, 0x8000},
	{82311, 0x70000},
	/* 4003 */
	{83430, 0x3F, 3, 36370},
	{83443, 0x3F00, 3, 36370},
	{83458, 0x3F0000, 3, 36370},
	{83473, 0xFC00000, 3, 36370},
	{83488, 0x80000000},
	/* 4008 */
	{203, 0x3, 2, 36374},
	{83625, 0xC, 4, 36377},
	{83705, 0x30, 3, 36381},
	{83765, 0xC0, 4, 36884},
	{83778, 0x100},
	{78093, 0x200},
	{83782, 0x400},
	/* 4015 */
	{85001, 0x3F, 60, 36888},
	{60387, 0x7FC0000},
	{85012, 0x8000000},
	/* 4018 */
	{89776, 0x1},
	{85225, 0x2},
	{112777, 0x4},
	{112800, 0x8},
	{112808, 0x3F0},
	{112823, 0xFC00},
	{85304, 0x10000},
	/* 4025 */
	{209, 0x3, 3, 36468},
	{86086, 0x1C, 4, 36471},
	{86163, 0xE0, 4, 36475},
	{86172, 0x100},
	{86192, 0x200},
	{86203, 0x3C00},
	{86225, 0x4000},
	{83765, 0x18000, 4, 36884},
	/* 4033 */
	{86604, 0x1},
	{86619, 0x2},
	{86634, 0x4},
	{86649, 0x8},
	{86664, 0x70},
	{86696, 0xF00},
	{86713, 0x80000000},
	/* 4040 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 24, 36524},
	{65183, 0x80},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89767, 0x80000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	/* 4055 */
	{92097, 0xF00, 5, 36612},
	{96884, 0x10000},
	{96896, 0x100000},
	{96911, 0xC0000000, 4, 36618},
	/* 4059 */
	{26574, 0xFFFF},
	{92097, 0x300000, 2, 36622},
	{96951, 0x8000000, 2, 36618},
	{96973, 0x60000000, 3, 36626},
	{96981, 0x80000000},
	/* 4064 */
	{91743, 0x1FFFFF},
	{97019, 0x200000},
	{101317, 0xC00000, 4, 36948},
	{101326, 0x3000000, 4, 36948},
	{91754, 0x4000000, 2, 36630},
	{91758, 0x8000000, 2, 36630},
	{91762, 0x10000000, 2, 36632},
	{91767, 0x20000000, 2, 36632},
	{91772, 0x40000000},
	/* 4073 */
	{96951, 0x1, 2, 36618},
	{92097, 0x300000, 2, 36622},
	{96973, 0x60000000, 3, 36626},
	{96981, 0x80000000},
	/* 4077 */
	{55065, 0xF},
	{55074, 0xF0},
	{55084, 0x100},
	{55095, 0x200},
	{55100, 0x400},
	{99292, 0x800},
	{55227, 0x1FF000, 257, 0},
	{55258, 0x10000000},
	{55264, 0xE0000000},
	/* 4086 */
	{55429, 0x1FF, 257, 0},
	{55474, 0x3F0000},
	{55527, 0xE0000000},
	/* 4089 */
	{50450, 0xF},
	{55535, 0x30},
	{55543, 0xC0},
	{55551, 0xF00},
	{55557, 0x1000},
	{28872, 0x6000},
	{55575, 0xF0000},
	{55581, 0xF00000},
	{55587, 0x7000000},
	{55596, 0x38000000},
	{55605, 0xC0000000},
	/* 4100 */
	{55686, 0xF},
	{55693, 0x70},
	{55715, 0xF00},
	{55724, 0x7000},
	/* 4104 */
	{56001, 0xF},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56130, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56230, 0x4000},
	{56362, 0x1000000},
	{57300, 0x2000000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	/* 4121 */
	{56917, 0x1},
	{56927, 0x2},
	{56937, 0x4},
	{56946, 0x8},
	{56955, 0x10},
	{56966, 0x20},
	{56977, 0x40},
	{56987, 0x80},
	{103278, 0x100},
	{103293, 0x200},
	{56997, 0x400},
	{57007, 0x800},
	{57024, 0x1000},
	{57142, 0x20000000},
	{57155, 0x40000000},
	{56389, 0x80000000},
	/* 4137 */
	{112863, 0x1},
	{112884, 0x2},
	{57652, 0x8},
	{57671, 0x10},
	{57691, 0x40},
	{57710, 0x100},
	{57731, 0x200},
	{57749, 0x400},
	{112905, 0x800},
	{112926, 0x1000},
	{57772, 0x2000},
	{57794, 0x10000},
	{57815, 0x20000},
	{57833, 0x40000},
	{112949, 0x80000},
	{112970, 0x100000},
	{57856, 0x200000},
	/* 4154 */
	{57971, 0x1},
	{57990, 0x2},
	{103278, 0x4},
	{103293, 0x8},
	{57999, 0x10},
	{58014, 0x20},
	{58028, 0x40},
	{58047, 0x80},
	{58066, 0x100},
	{58081, 0x200},
	{58098, 0x400},
	{58120, 0x800},
	{58142, 0x1000},
	{58157, 0x2000},
	{56997, 0x4000},
	{58172, 0x8000},
	{58317, 0x40000000},
	{56380, 0x80000000},
	/* 4172 */
	{58330, 0x1},
	{58348, 0x2},
	{58362, 0x4},
	{58381, 0x8},
	{58400, 0x10},
	{58415, 0x20},
	{58433, 0x40},
	{58451, 0x80},
	{58468, 0x100},
	{112993, 0x200},
	{58514, 0x800},
	{58538, 0x1000},
	{58556, 0x2000},
	{58574, 0x4000},
	{58595, 0x8000},
	{58619, 0x10000},
	{58645, 0x20000},
	{58662, 0x40000},
	{58682, 0x80000},
	{58702, 0x100000},
	{58722, 0x200000},
	{58743, 0x400000},
	{58766, 0x800000},
	{58787, 0x1000000},
	{58806, 0x2000000},
	{58823, 0x4000000},
	{58839, 0x8000000},
	{58855, 0x10000000},
	{58871, 0x20000000},
	{58890, 0x40000000},
	{58902, 0x80000000},
	/* 4203 */
	{58914, 0x1},
	{58933, 0x2},
	{58953, 0x4},
	{58973, 0x8},
	{101968, 0x10},
	{58993, 0x20},
	{59014, 0x40},
	/* 4210 */
	{107570, 0x1F},
	{107577, 0x20},
	{60061, 0x80},
	{55370, 0xF00},
	{107584, 0x3000},
	{60074, 0x4000},
	{60087, 0x8000},
	{107595, 0xFFFF0000},
	{107595, 0xFFFF0000},
	/* 4219 */
	{9978, 0xF},
	{83778, 0x10},
	/* 4221 */
	{113015, 0xFFFF},
	/* 4222 */
	{60213, 0x3FF},
	{60228, 0x3FF0000},
	{107646, 0x20000000},
	{56251, 0x40000000},
	{68297, 0x80000000},
	/* 4227 */
	{70821, 0xFFFFFFFF},
	/* 4228 */
	{91234, 0xFFFF},
	{91246, 0x10000},
	{26637, 0xE0000000},
	/* 4231 */
	{113025, 0x1000},
	{91342, 0x6000},
	{113033, 0x8000},
	{91371, 0x300000},
	{113046, 0x1000000},
	{91382, 0x6000000},
	{113054, 0x8000000},
	{91411, 0x60000000},
	/* 4239 */
	{113067, 0x7F},
	{113079, 0x3F000},
	{11573, 0x6000000},
	{92076, 0x8000000},
	/* 4243 */
	{27627, 0xFFFF},
	{92097, 0x30000},
	{92105, 0x7000000},
	{92113, 0xE0000000},
	/* 4247 */
	{93122, 0x3F},
	{93127, 0xC0},
	{93135, 0x100},
	{93141, 0xFFFFFE00},
	/* 4251 */
	{80685, 0x1},
	{842, 0x1FFE},
	{209, 0x2000},
	{88627, 0x4000},
	{93149, 0x8000},
	{93161, 0x7FF0000},
	{93172, 0x8000000},
	{93183, 0x10000000},
	{93127, 0xE0000000},
	/* 4260 */
	{93321, 0x3F},
	{93331, 0xFC00},
	/* 4262 */
	{93271, 0x3F},
	{93280, 0xFC00},
	{94837, 0xF00000},
	/* 4265 */
	{93271, 0xFF},
	{94973, 0xF000},
	{107466, 0xF0000},
	{93290, 0xF00000},
	{107482, 0xF000000},
	{94891, 0xF0000000},
	/* 4271 */
	{95880, 0xFFFFFFFF},
	/* 4272 */
	{52037, 0xFF},
	{10349, 0xFFFFFF00},
	/* 4274 */
	{95858, 0xFFFFFFFF},
	/* 4275 */
	{26574, 0xFFFF},
	{92097, 0x300000, 4, 36952},
	{96951, 0x8000000, 2, 36618},
	{96973, 0x60000000, 4, 36626},
	{96981, 0x80000000},
	/* 4280 */
	{96951, 0x1, 2, 36618},
	{91342, 0x6000},
	{92097, 0x300000, 4, 36952},
	{91382, 0x6000000},
	{96973, 0x60000000, 4, 36626},
	{96981, 0x80000000},
	/* 4286 */
	{55065, 0xF},
	{55074, 0xF0},
	{55084, 0x100},
	{55095, 0x200},
	{55100, 0x400},
	{99292, 0x800},
	{55227, 0x1FF000, 257, 0},
	{113096, 0x8000000},
	{55258, 0x10000000},
	{55264, 0xE0000000},
	/* 4296 */
	{55268, 0x1},
	{55272, 0x6},
	{55281, 0x18},
	{55291, 0x20},
	{55296, 0x40},
	{55304, 0x80},
	{55314, 0x100},
	{55325, 0x200},
	{55331, 0x400},
	{55336, 0x800},
	{55342, 0x1000},
	{55353, 0x2000},
	{55358, 0x4000},
	{99311, 0x8000},
	{55114, 0x10000},
	{55378, 0x20000},
	{55386, 0x40000},
	{55398, 0x80000},
	{99324, 0x100000},
	{99338, 0x200000},
	{113107, 0x400000},
	{99360, 0x800000},
	{55417, 0x8000000},
	/* 4319 */
	{55429, 0x1FF, 257, 0},
	{55434, 0x400},
	{55474, 0x3F0000},
	{55527, 0xE0000000},
	/* 4323 */
	{55686, 0xF},
	{55693, 0x70},
	{55715, 0xF00},
	{55724, 0x7000},
	{55733, 0x8000},
	{55746, 0xF0000},
	/* 4329 */
	{99389, 0x7},
	{99397, 0x8},
	{99408, 0x10},
	{99421, 0xE0},
	{99437, 0x300},
	{99447, 0xC00},
	{99457, 0xF0000},
	{55849, 0xF00000},
	{99469, 0x3000000},
	{99476, 0x4000000},
	{99483, 0x18000000},
	{69274, 0x20000000},
	{99491, 0x40000000},
	/* 4342 */
	{113120, 0x1},
	{55794, 0x2},
	{55800, 0x4},
	{55829, 0xF0},
	{55834, 0xF00},
	/* 4347 */
	{56001, 0xF},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56130, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56230, 0x4000},
	{56362, 0x1000000},
	{57300, 0x2000000},
	{113127, 0x4000000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	/* 4365 */
	{56917, 0x1},
	{56927, 0x2},
	{56937, 0x4},
	{56946, 0x8},
	{56955, 0x10},
	{56966, 0x20},
	{56977, 0x40},
	{56987, 0x80},
	{56997, 0x400},
	{57007, 0x800},
	{57024, 0x1000},
	{113143, 0x2000},
	{57142, 0x20000000},
	{57155, 0x40000000},
	{56389, 0x80000000},
	/* 4380 */
	{57652, 0x8},
	{57671, 0x10},
	{57691, 0x40},
	{57710, 0x100},
	{57731, 0x200},
	{57749, 0x400},
	{57772, 0x2000},
	{57794, 0x10000},
	{57815, 0x20000},
	{57833, 0x40000},
	{57856, 0x200000},
	{113156, 0x400000},
	{113180, 0x800000},
	{113204, 0x1000000},
	/* 4394 */
	{57971, 0x1},
	{57990, 0x2},
	{57999, 0x10},
	{58014, 0x20},
	{58028, 0x40},
	{58047, 0x80},
	{58066, 0x100},
	{58081, 0x200},
	{58098, 0x400},
	{58120, 0x800},
	{58142, 0x1000},
	{58157, 0x2000},
	{56997, 0x4000},
	{58172, 0x8000},
	{58181, 0x10000},
	{113143, 0x20000},
	{58272, 0x4000000},
	{58285, 0x8000000},
	{58298, 0x30000000},
	{58317, 0x40000000},
	{56380, 0x80000000},
	/* 4415 */
	{58914, 0x1},
	{58933, 0x2},
	{58953, 0x4},
	{58973, 0x8},
	{58993, 0x20},
	{59014, 0x40},
	{113156, 0x80},
	{113180, 0x100},
	{113204, 0x200},
	/* 4424 */
	{60439, 0x7, 8, 36715},
	{60449, 0x38, 8, 36715},
	{60459, 0x1C0, 8, 36715},
	{60469, 0xE00, 8, 36715},
	{108235, 0x7000, 8, 36956},
	{108627, 0x78000, 16, 36731},
	{108639, 0x180000},
	{64386, 0x600000},
	{64399, 0x800000},
	{83778, 0x1000000},
	{108652, 0x2000000},
	{108664, 0x4000000},
	{83791, 0x38000000},
	{209, 0xC0000000, 4, 36747},
	/* 4438 */
	{60382, 0xFF},
	{64720, 0xFFF00},
	{108627, 0x3F00000, 64, 36751},
	{108235, 0x3C000000, 16, 36964},
	{83791, 0xC0000000},
	/* 4443 */
	{66937, 0xFFF},
	{67001, 0xFF000},
	{66974, 0x100000},
	{67123, 0x200000},
	{67138, 0x400000},
	{67154, 0x800000},
	{113387, 0xF000000},
	{113403, 0xF0000000},
	/* 4451 */
	{113419, 0xFFFFFFFF},
	/* 4452 */
	{64531, 0x7, 8, 36847},
	{64539, 0x38, 8, 36847},
	{64547, 0x1C0, 8, 36847},
	{64555, 0xE00},
	{64571, 0x7000, 8, 36855},
	{64590, 0x8000},
	{64609, 0x70000},
	{64625, 0x80000},
	{64640, 0x100000},
	{64654, 0x7E00000},
	{64665, 0x8000000},
	{64677, 0x10000000},
	{64695, 0x60000000, 3, 36863},
	{113437, 0x80000000},
	/* 4466 */
	{64752, 0x3FFF},
	{64796, 0xFC000},
	{64809, 0x300000, 4, 36866},
	{64823, 0xC00000, 4, 36866},
	{64837, 0x3000000, 3, 36870},
	{64846, 0xC000000, 4, 36980},
	{64857, 0x10000000},
	{111809, 0x20000000},
	{111826, 0x40000000},
	{64876, 0x80000000},
	/* 4476 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{67881, 0x100},
	{67893, 0x200},
	{67905, 0x400},
	{67917, 0x800},
	{67929, 0x1000},
	{55227, 0x3FE000, 257, 0},
	{67946, 0x1000000},
	/* 4487 */
	{83778, 0x1},
	{83791, 0x6},
	/* 4489 */
	{17286, 0x3, 4, 3099},
	{70338, 0xC},
	{66151, 0xE000, 7, 2800},
	{90190, 0x700000},
	{70465, 0x7800000},
	{70489, 0x8000000},
	{70504, 0x10000000},
	{70514, 0x20000000},
	{113483, 0x40000000},
	{70534, 0x80000000},
	/* 4499 */
	{17286, 0x1, 2, 3107},
	{66151, 0xE000, 7, 2800},
	{90190, 0x700000},
	{70489, 0x8000000},
	{70577, 0x20000000},
	{113483, 0x40000000},
	/* 4505 */
	{73721, 0x1},
	{113500, 0x2},
	{73748, 0x7C},
	/* 4508 */
	{78652, 0x8},
	{966, 0x70, 7, 36061},
	{77925, 0xFF0000, 256, 36069},
	/* 4511 */
	{80397, 0x1},
	{80413, 0x2},
	{80429, 0x4},
	{80445, 0x8},
	{80461, 0x10},
	{80477, 0x20},
	{80493, 0x40},
	{80509, 0x80},
	{80525, 0x100},
	{80541, 0x200},
	{80557, 0x400},
	{80573, 0x800},
	{80589, 0x1000},
	{80605, 0x2000},
	{80621, 0x4000},
	{80637, 0x8000},
	{80653, 0x10000},
	{80672, 0x20000},
	{80690, 0x40000},
	{80717, 0x80000},
	{80739, 0x100000},
	{80757, 0x200000},
	{80777, 0x400000},
	{80800, 0x800000},
	{80823, 0x1000000},
	{80848, 0x2000000},
	{80891, 0x4000000},
	/* 4538 */
	{966, 0x7, 6, 36360},
	{82478, 0x8},
	{82534, 0x30, 4, 36366},
	{82543, 0x7C0},
	{82554, 0x800},
	{82567, 0x1000},
	{82578, 0x2000},
	{93478, 0x4000},
	{113539, 0x8000},
	{113550, 0x10000},
	{82637, 0x20000},
	{82656, 0x40000},
	{82670, 0x80000},
	{82688, 0x100000},
	{82706, 0x600000},
	/* 4553 */
	{203, 0x3, 3, 36374},
	{83625, 0xC, 4, 36377},
	{83705, 0x30, 4, 36381},
	{83765, 0x40, 2, 36385},
	{78093, 0x200},
	{83782, 0x400},
	{83791, 0x1800},
	/* 4560 */
	{85001, 0x3F, 61, 36984},
	{60387, 0x7FC0000},
	{85012, 0x8000000},
	/* 4563 */
	{85127, 0xFFFF},
	{85142, 0x10000},
	{85161, 0x20000},
	{85175, 0x40000},
	{85194, 0x80000},
	{85208, 0x100000},
	{85852, 0xF0000000},
	/* 4570 */
	{89776, 0x1},
	{85225, 0x2},
	{112777, 0x4},
	{112800, 0x8},
	{112808, 0x3F0},
	{112823, 0xFC00},
	{85304, 0x10000},
	{113561, 0x20000},
	/* 4578 */
	{209, 0x3, 3, 36468},
	{86086, 0x1C, 4, 36471},
	{86163, 0xE0, 4, 36475},
	{86172, 0x100},
	{86192, 0x200},
	{86203, 0x3C00},
	{86225, 0x4000},
	{83765, 0x8000, 2, 36385},
	{86259, 0x60000, 3, 36479},
	{83791, 0x180000},
	/* 4588 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 24, 36524},
	{65183, 0x80},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89767, 0x80000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	{90066, 0x8000000},
	{90092, 0x10000000},
	{90160, 0x60000000, 3, 36576},
	/* 4606 */
	{11573, 0x2000000},
	{83791, 0x18000000},
	/* 4608 */
	{91234, 0xFFFF},
	{91246, 0x10000},
	{91137, 0x2000000},
	{83791, 0x18000000},
	{26637, 0xE0000000},
	/* 4613 */
	{26205, 0xFFFF},
	{83791, 0x300000},
	{91137, 0x400000},
	/* 4616 */
	{26277, 0xFFFF},
	{83791, 0x300000},
	{91137, 0x400000},
	/* 4619 */
	{113575, 0xC00},
	{113025, 0x1000},
	{91342, 0x2000},
	{91371, 0x300000},
	{113585, 0xC00000},
	{113046, 0x1000000},
	{91382, 0x2000000},
	{91411, 0x60000000},
	/* 4627 */
	{92276, 0x1},
	{92292, 0x2},
	{113595, 0x4},
	{91459, 0x8},
	{92308, 0x40},
	{92326, 0x80},
	{92344, 0x100},
	{92362, 0x200},
	{92380, 0x400},
	{92398, 0x800},
	{92416, 0x1000},
	{92434, 0x2000},
	{92452, 0x4000},
	{91520, 0x8000},
	{91540, 0x40000},
	{92469, 0x80000},
	{92485, 0x200000},
	{91557, 0x400000},
	{91573, 0x800000},
	{91587, 0x2000000},
	{91601, 0x4000000},
	{91615, 0x8000000},
	{91636, 0x10000000},
	{91661, 0x20000000},
	{91682, 0x40000000},
	{113612, 0x80000000},
	/* 4653 */
	{113067, 0x7F},
	{113079, 0x3F000},
	{11573, 0x2000000},
	{83791, 0x18000000},
	/* 4657 */
	{27627, 0xFFFFFFF},
	/* 4658 */
	{113015, 0xFFFFFFFF},
	/* 4659 */
	{93216, 0xFFFF},
	{93240, 0xF0000},
	{93227, 0x300000},
	{55858, 0x3FC00000},
	{93248, 0x40000000},
	{9866, 0x80000000},
	/* 4665 */
	{60382, 0xFF},
	{64720, 0xFFF00},
	{108627, 0x3F00000, 64, 37045},
	{108235, 0x3C000000, 16, 36964},
	{83791, 0xC0000000},
	/* 4670 */
	{78634, 0x1},
	{78652, 0x8},
	{966, 0x70, 7, 36061},
	{77925, 0xFF0000, 256, 36069},
	/* 4674 */
	{85469, 0xFF},
	{85483, 0xFF00},
	{85493, 0xFF0000},
	{85504, 0xFF000000},
	/* 4678 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 31, 36524},
	{65183, 0x80},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89767, 0x80000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	{90066, 0x8000000},
	{90092, 0x10000000},
	{90160, 0x60000000, 3, 36576},
	/* 4696 */
	{80685, 0x1},
	{842, 0x1FFE},
	{209, 0x2000},
	{88627, 0x4000},
	{93149, 0x8000},
	{93161, 0xFFF0000},
	{93172, 0x10000000},
	{93183, 0x20000000},
	{93127, 0xC0000000},
	/* 4705 */
	{55065, 0xF},
	{55074, 0xF0},
	{55084, 0x100},
	{55095, 0x200},
	{55100, 0x400},
	{99292, 0x800},
	{55227, 0x1FF000, 257, 0},
	{55235, 0x800000},
	{113930, 0x1000000},
	{113943, 0x2000000},
	{55245, 0x4000000},
	{113096, 0x8000000},
	{55258, 0x10000000},
	{55264, 0xE0000000},
	/* 4719 */
	{55268, 0x1},
	{55272, 0x6},
	{55281, 0x18},
	{55291, 0x20},
	{55296, 0x40},
	{55304, 0x80},
	{55314, 0x100},
	{55325, 0x200},
	{55331, 0x400},
	{55336, 0x800},
	{55342, 0x1000},
	{55353, 0x2000},
	{55358, 0x4000},
	{99311, 0x8000},
	{55114, 0x10000},
	{55378, 0x20000},
	{55386, 0x40000},
	{55398, 0x80000},
	{99324, 0x100000},
	{99338, 0x200000},
	{113107, 0x400000},
	{55406, 0x800000},
	{55417, 0x8000000},
	/* 4742 */
	{55429, 0x1FF, 257, 0},
	{55434, 0x400},
	{55442, 0x800},
	{55455, 0x7000},
	{55474, 0x3F0000},
	{55515, 0x10000000},
	{55527, 0xE0000000},
	/* 4749 */
	{55686, 0xF},
	{55693, 0x70},
	{55715, 0xF00},
	{55724, 0x7000},
	{55733, 0x8000},
	{55746, 0x1F0000},
	{55751, 0xC00000},
	/* 4756 */
	{99389, 0x7},
	{99397, 0x8},
	{99408, 0x10},
	{99421, 0xE0},
	{99437, 0x300},
	{99447, 0xC00},
	{99457, 0xF0000},
	{99469, 0x3000000},
	{99476, 0x4000000},
	{99483, 0x18000000},
	{69274, 0x20000000},
	{99491, 0x40000000},
	{113956, 0x80000000},
	/* 4769 */
	{113120, 0x1},
	{55794, 0x2},
	{55800, 0x4},
	{55829, 0x1F0},
	{55834, 0xF800},
	{55746, 0x7C0000},
	{55849, 0xFE000000},
	/* 4776 */
	{56001, 0xF},
	{56024, 0x10},
	{56047, 0x20},
	{56070, 0x40},
	{56090, 0x80},
	{56110, 0x100},
	{56130, 0x200},
	{56150, 0x400},
	{56170, 0x800},
	{56190, 0x1000},
	{56210, 0x2000},
	{56230, 0x4000},
	{56245, 0x8000},
	{56256, 0x10000},
	{56264, 0x20000},
	{56273, 0x40000},
	{56290, 0x80000},
	{56305, 0x100000},
	{56362, 0x1000000},
	{57300, 0x2000000},
	{113127, 0x4000000},
	{56380, 0x10000000},
	{56389, 0x20000000},
	{56398, 0x40000000},
	{56407, 0x80000000},
	/* 4801 */
	{56418, 0xF},
	{56441, 0x20},
	{56457, 0x80},
	{56480, 0x100},
	{56503, 0x200},
	{56522, 0x1000},
	{56531, 0x2000},
	{56540, 0x4000},
	{56548, 0x8000},
	{100180, 0x10000},
	{100195, 0x20000},
	{100204, 0x40000},
	{100219, 0x80000},
	{56572, 0x100000},
	{100227, 0x200000},
	{56588, 0x400000},
	{56597, 0x800000},
	{56606, 0x1000000},
	{56614, 0x2000000},
	{56622, 0x4000000},
	{56630, 0x10000000},
	{56372, 0x20000000},
	{56648, 0x40000000},
	{56656, 0x80000000},
	/* 4825 */
	{56522, 0x2},
	{56531, 0x4},
	{56264, 0x200000},
	{56597, 0x400000},
	{100195, 0x800000},
	{56614, 0x1000000},
	{56540, 0x2000000},
	{56572, 0x4000000},
	{56588, 0x8000000},
	{56606, 0x20000000},
	{56622, 0x40000000},
	{56648, 0x80000000},
	/* 4837 */
	{56917, 0x1},
	{56927, 0x2},
	{56937, 0x4},
	{56946, 0x8},
	{56955, 0x10},
	{56966, 0x20},
	{56977, 0x40},
	{56987, 0x80},
	{56997, 0x400},
	{57007, 0x800},
	{57024, 0x1000},
	{57032, 0x2000},
	{57045, 0x4000},
	{57142, 0x20000000},
	{57155, 0x40000000},
	{56389, 0x80000000},
	/* 4853 */
	{57971, 0x1},
	{57990, 0x2},
	{57999, 0x10},
	{58014, 0x20},
	{58028, 0x40},
	{58047, 0x80},
	{58066, 0x100},
	{58081, 0x200},
	{58098, 0x400},
	{58120, 0x800},
	{58142, 0x1000},
	{58157, 0x2000},
	{56997, 0x4000},
	{58172, 0x8000},
	{58181, 0x10000},
	{57032, 0x20000},
	{58272, 0x4000000},
	{58285, 0x8000000},
	{58298, 0x30000000},
	{58317, 0x40000000},
	{56380, 0x80000000},
	/* 4874 */
	{60439, 0x7, 8, 36715},
	{60449, 0x38, 8, 36715},
	{60459, 0x1C0, 8, 36715},
	{60469, 0xE00, 8, 36715},
	{108235, 0x7000, 8, 37109},
	{108627, 0x78000, 16, 36731},
	{114001, 0x80000},
	{114016, 0x100000},
	{64386, 0x600000},
	{64399, 0x800000},
	{82372, 0x8000000},
	{209, 0xC0000000, 4, 36747},
	/* 4886 */
	{60382, 0xFF},
	{64720, 0xFFF00},
	{108627, 0x3F00000, 64, 37117},
	{114500, 0x3F00000, 61, 37181},
	{108235, 0x3C000000, 16, 37242},
	{115007, 0x3C000000, 16, 37258},
	{82372, 0x40000000},
	{115024, 0x80000000},
	/* 4894 */
	{60439, 0x7, 8, 36715},
	{60449, 0x38, 8, 36715},
	{60459, 0x1C0, 8, 36715},
	{60469, 0xE00, 8, 36715},
	{66769, 0xF000},
	{66780, 0xF0000},
	{66791, 0x1F00000},
	{209, 0xF0000000, 16, 36831},
	/* 4902 */
	{18432, 0x1FFF},
	{21148, 0x1FFFE000},
	{66895, 0xE0000000, 6, 2828},
	/* 4905 */
	{66906, 0x1FFF},
	{66917, 0x1E000},
	{113419, 0x1FE0000},
	{90630, 0x2000000},
	{67083, 0x4000000},
	{115036, 0x8000000},
	{66929, 0xF0000000},
	/* 4912 */
	{64752, 0x3FFF},
	{64796, 0xFC000},
	{64809, 0x300000, 4, 36866},
	{64823, 0xC00000, 4, 36866},
	{64837, 0x3000000, 3, 36870},
	{64846, 0xC000000, 4, 36980},
	{64857, 0x10000000},
	{64891, 0x20000000},
	{111826, 0x40000000},
	{64876, 0x80000000},
	/* 4922 */
	{64761, 0xFFF},
	{64707, 0x1000},
	{64778, 0xC0000000, 4, 36876},
	/* 4925 */
	{65092, 0x7},
	{65102, 0x38},
	{65123, 0xC0},
	{111984, 0x700},
	{66741, 0x7000, 4, 2824},
	{112005, 0x70000},
	{65144, 0x180000},
	{112029, 0xE00000},
	{112038, 0x3000000},
	{65163, 0xC000000},
	{112058, 0x30000000},
	{112067, 0x40000000},
	{115052, 0x80000000},
	/* 4938 */
	{67191, 0xFFFF},
	{67206, 0x3F0000},
	{67217, 0x3C00000},
	{115062, 0x3C000000},
	/* 4942 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67321, 0x1000000},
	{112154, 0x10000000},
	{55235, 0x20000000},
	/* 4953 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67384, 0x80},
	{67396, 0xFF00},
	{55227, 0x1FF0000, 257, 0},
	{67411, 0x2000000},
	{67433, 0x4000000},
	{67963, 0x8000000},
	{67458, 0x10000000},
	/* 4963 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67841, 0x3000000},
	{67855, 0x4000000},
	{112154, 0x40000000},
	{55235, 0x80000000},
	/* 4975 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{67871, 0x80},
	{67881, 0x100},
	{67893, 0x200},
	{67905, 0x400},
	{67917, 0x800},
	{67929, 0x1000},
	{55227, 0x3FE000, 257, 0},
	{67935, 0x400000},
	{67946, 0x1000000},
	{67963, 0x8000000},
	{67458, 0x10000000},
	/* 4989 */
	{68000, 0x7F},
	{67975, 0x3F80},
	/* 4991 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{67855, 0x1000000},
	{112154, 0x10000000},
	{68026, 0x60000000},
	{55235, 0x80000000},
	/* 5003 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55227, 0xFF80, 257, 0},
	{68043, 0x30000},
	{67871, 0x40000},
	{55660, 0x7F80000},
	{67963, 0x8000000},
	{67458, 0x10000000},
	/* 5012 */
	{67206, 0x3F},
	{67217, 0x3C0},
	{115062, 0x3C00},
	{67191, 0xFFFF0000},
	/* 5016 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{112154, 0x8000000},
	{68060, 0x30000000},
	{55235, 0x40000000},
	/* 5027 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{55227, 0xFF80, 257, 0},
	{55660, 0x1FF0000},
	{67963, 0x8000000},
	{67458, 0x10000000},
	/* 5034 */
	{68088, 0x1},
	{68106, 0x2},
	{68120, 0x4},
	{68139, 0x8},
	{68159, 0x10},
	{68179, 0x20},
	{68201, 0x40},
	{68212, 0x400},
	{68230, 0x800},
	{10349, 0x1000},
	{68262, 0x4000},
	/* 5045 */
	{67245, 0x3F},
	{67251, 0x3C0},
	{64932, 0xC00},
	{67300, 0xFF000, 241, 2834},
	{55291, 0x100000},
	{55084, 0x200000},
	{112133, 0x400000},
	{67311, 0x800000},
	{68321, 0x1000000},
	{112154, 0x2000000},
	{55235, 0x4000000},
	/* 5056 */
	{67350, 0x1},
	{67361, 0x3E},
	{67371, 0x40},
	{68327, 0x80},
	{68337, 0x100},
	{68347, 0x200},
	{68077, 0x400},
	{68357, 0x1800},
	{68372, 0x6000},
	{55660, 0xFF8000},
	{55227, 0x7F000000, 257, 0},
	{67963, 0x80000000},
	/* 5068 */
	{68384, 0x3FF},
	{68397, 0xF000},
	{68407, 0x3F0000},
	{68422, 0x400000},
	{68437, 0x800000},
	{68453, 0x7000000},
	{115062, 0x78000000},
	/* 5075 */
	{68996, 0x7FF},
	{69023, 0xFFE000},
	{69033, 0x1000000},
	{69045, 0x2000000},
	{69063, 0x3C000000},
	/* 5080 */
	{17286, 0x3, 4, 3099},
	{70338, 0xC},
	{66791, 0x1F0},
	{70422, 0x1000},
	{70393, 0x6000, 4, 3103},
	{70408, 0x8000},
	{70458, 0xF0000},
	{70465, 0x7800000},
	{70489, 0x8000000},
	{70504, 0x10000000},
	{70514, 0x20000000},
	{113483, 0x40000000},
	{70534, 0x80000000},
	/* 5093 */
	{17286, 0x1, 2, 3107},
	{66791, 0x1F0},
	{70422, 0x1000},
	{70393, 0x6000, 4, 3103},
	{70408, 0x8000},
	{70489, 0x8000000},
	{70577, 0x20000000},
	{113483, 0x40000000},
	/* 5101 */
	{54707, 0xFFFF},
	/* 5102 */
	{71444, 0x3, 4, 35886},
	{71456, 0xC, 4, 35886},
	{71568, 0x30, 4, 35890},
	{71625, 0x40, 2, 35894},
	{71681, 0x80, 2, 35896},
	{71785, 0x300, 4, 35898},
	{71893, 0xC00, 4, 35902},
	{72002, 0x3000, 4, 35906},
	{72115, 0xC000, 4, 35910},
	{72217, 0x30000, 4, 35914},
	{72363, 0xC0000, 4, 35918},
	{72510, 0x300000, 4, 35922},
	{72610, 0x3000000, 4, 35926},
	{72756, 0x1C000000, 5, 37274},
	{72903, 0xE0000000, 5, 37279},
	/* 5117 */
	{73023, 0x3, 4, 35938},
	{73194, 0x1C, 5, 37284},
	{73366, 0xE0, 5, 37289},
	/* 5120 */
	{73721, 0x1},
	{113500, 0x2},
	{73748, 0x7C},
	{73777, 0x100},
	{73806, 0x200},
	{73837, 0x400},
	{73865, 0x1000},
	{73893, 0x2000},
	{73923, 0x4000},
	/* 5129 */
	{80397, 0x1},
	{80413, 0x2},
	{80429, 0x4},
	{80445, 0x8},
	{80461, 0x10},
	{80477, 0x20},
	{80493, 0x40},
	{80509, 0x80},
	{80525, 0x100},
	{80541, 0x200},
	{80557, 0x400},
	{80573, 0x800},
	{80589, 0x1000},
	{80605, 0x2000},
	{80621, 0x4000},
	{80637, 0x8000},
	{80653, 0x10000},
	{80672, 0x20000},
	{80690, 0x40000},
	{80717, 0x80000},
	{80739, 0x100000},
	{80757, 0x200000},
	{80777, 0x400000},
	{80800, 0x800000},
	{80823, 0x1000000},
	{80848, 0x2000000},
	{80891, 0x4000000},
	{80868, 0x8000000},
	/* 5157 */
	{81497, 0x1},
	{81269, 0x2},
	{81293, 0x4},
	{81313, 0x8},
	{81334, 0x10},
	{81535, 0x40},
	/* 5163 */
	{81564, 0x1},
	{81575, 0x2},
	{115229, 0x4},
	/* 5166 */
	{92872, 0x1},
	{81745, 0x1E},
	{81757, 0xE0},
	{81771, 0x300},
	{81787, 0x1C00},
	{81798, 0x1E000},
	/* 5172 */
	{203, 0x3, 3, 36374},
	{83625, 0xC, 4, 36377},
	{83705, 0x30, 4, 36381},
	{83765, 0x40, 2, 36385},
	{85825, 0x100},
	{78093, 0x200},
	{83782, 0x400},
	/* 5179 */
	{85001, 0x3F, 64, 37294},
	{60387, 0x7FFFC00},
	{85012, 0x8000000},
	/* 5182 */
	{54826, 0xFFFF},
	/* 5183 */
	{85042, 0x1},
	{85056, 0x2},
	{115292, 0x4},
	{85072, 0x8},
	/* 5187 */
	{85225, 0x2},
	{112777, 0x4},
	{112800, 0x8},
	{112808, 0x3F0},
	{112823, 0xFC00},
	{85304, 0x10000},
	{67088, 0x40000},
	{115041, 0x80000},
	/* 5195 */
	{85576, 0x3, 4, 36452},
	{85607, 0x4, 2, 36456},
	{19742, 0x18, 4, 36458},
	{85689, 0x20, 2, 36462},
	{85754, 0xC0, 4, 36464},
	{67946, 0x200},
	{85771, 0x400},
	{85791, 0x800},
	{85811, 0x1000},
	{85825, 0x2000},
	{85836, 0x4000},
	{85852, 0x78000},
	{85872, 0x180000},
	/* 5208 */
	{209, 0x3, 3, 36468},
	{86086, 0x1C, 4, 36471},
	{86163, 0xE0, 4, 36475},
	{86172, 0x100},
	{86192, 0x200},
	{86225, 0x4000},
	{83765, 0x8000, 2, 36385},
	{86259, 0x60000, 4, 36479},
	/* 5216 */
	{87926, 0x3, 4, 36505},
	{87939, 0x4},
	{87950, 0x8},
	{88059, 0x70},
	{88077, 0x380},
	{88095, 0x1C00},
	{88118, 0x3E000},
	{88144, 0x40000},
	{88166, 0x7F80000},
	{88182, 0x8000000},
	{88204, 0x10000000},
	/* 5227 */
	{88343, 0x1},
	{88360, 0x1E},
	{88384, 0x20},
	{88402, 0x3C0},
	{88427, 0x400},
	{88457, 0x800},
	{88472, 0x1000},
	{88487, 0x2000},
	{88522, 0x4000},
	{88558, 0x8000},
	{88648, 0x30000},
	{88672, 0x40000},
	{88708, 0x80000},
	{88744, 0x100000},
	{88770, 0x200000},
	{88794, 0x400000},
	{88814, 0x800000},
	{88835, 0x1000000},
	/* 5245 */
	{68996, 0x7FF},
	{69023, 0xFFE000},
	{89004, 0xF000000},
	/* 5248 */
	{89065, 0x3, 4, 36520},
	{17286, 0x7C, 32, 36524},
	{89663, 0x700, 8, 36556},
	{89719, 0x1800, 4, 36564},
	{78701, 0x2000},
	{69616, 0x4000},
	{89729, 0x8000},
	{89741, 0x10000},
	{89754, 0x20000},
	{87333, 0x40000},
	{89994, 0x700000, 8, 36568},
	{90016, 0x3800000, 8, 36568},
	{90040, 0x4000000},
	{90066, 0x8000000},
	{90092, 0x10000000},
	{90160, 0x60000000, 3, 36576},
	/* 5264 */
	{90619, 0x7FF},
	{90630, 0x800},
	{70338, 0x7000},
	{90246, 0x18000},
	{90260, 0x20000},
	{90642, 0x7C0000},
	{90656, 0xF800000},
	{90670, 0x30000000},
	{115041, 0x40000000},
	{67088, 0x80000000},
	/* 5274 */
	{91234, 0xFFFF},
	{91246, 0x10000},
	{91137, 0x2000000},
	{26637, 0xE0000000},
	/* 5278 */
	{26205, 0xFFFF},
	{91137, 0x400000},
	/* 5280 */
	{26277, 0xFFFF},
	{91137, 0x400000},
	/* 5282 */
	{91329, 0x400},
	{91342, 0x2000},
	{91371, 0x300000},
	{91382, 0x2000000},
	{91411, 0x60000000},
	/* 5287 */
	{91788, 0x1},
	{91822, 0x30},
	{91834, 0xF0000},
	{91847, 0x10000000},
	{91862, 0x20000000},
	{91876, 0xC0000000},
	/* 5293 */
	{113067, 0x7F},
	{113079, 0x3F000},
	{91137, 0x2000000},
	{92089, 0x10000000},
	/* 5297 */
	{92519, 0xF},
	{92531, 0xF0},
	{100341, 0xF00},
	{115311, 0xF000},
	{92559, 0x30000},
	{55858, 0xC0000},
	{9866, 0x100000},
	{10349, 0xFFE00000},
	/* 5305 */
	{203, 0x3, 3, 36374},
	{85825, 0x100},
	/* 5307 */
	{107654, 0x7},
	{107662, 0x38},
	{107670, 0x1C0},
	{107678, 0xE00},
	{107686, 0x7000},
	{107694, 0x38000},
	{107702, 0x1C0000},
	{966, 0x600000},
	{107710, 0x1800000},
	{107723, 0x2000000},
	{115320, 0x4000000},
	{107736, 0x18000000},
	{107747, 0x20000000},
	{60034, 0x40000000},
	{64690, 0x80000000},
	/* 5322 */
	{60213, 0x3FF},
	{60228, 0x3FF0000},
	{97316, 0x10000000},
	{107646, 0x20000000},
	{56251, 0x40000000},
	{68297, 0x80000000},
	/* 5328 */
	{80685, 0x1},
	{842, 0x1FFE},
	{209, 0x2000},
	{88627, 0x4000},
	{93149, 0x8000},
	{93161, 0xFFF0000},
	{93172, 0x10000000},
	{93183, 0x20000000},
	{93193, 0x40000000},
	{93127, 0x80000000},
	/* 5338 */
	{115331, 0xF},
	{115346, 0x10},
	{115370, 0x20},
	{115390, 0x40},
	{115406, 0x80},
	{115422, 0x100},
	{115448, 0x200},
	{115465, 0x3C00},
	{115481, 0x4000},
	{115502, 0x8000},
	{115523, 0xFFFF0000},
	/* 5349 */
	{115537, 0xF},
	{115578, 0xF0},
	/* 5351 */
	{115617, 0x3},
	{115630, 0xC},
	{115643, 0x30},
	{115656, 0xC0},
	/* 5355 */
	{115669, 0x3FF},
	{115679, 0xFFC00},
	{93290, 0xF00000},
	{93299, 0xF000000},
	{93310, 0xF0000000},
	/* 5360 */
	{115689, 0x3FF},
	{115699, 0xFFC00},
	{93341, 0xF000000},
	{93352, 0xF0000000},
	/* 5364 */
	{441, 0x7},
	{11216, 0x40000000},
	{9866, 0x80000000},
	/* 5367 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{100986, 0x1000},
	{94153, 0x2000},
	{94179, 0x4000},
	{94205, 0x10000},
	{94232, 0x20000},
	{94258, 0x40000},
	{94284, 0x80000},
	{94312, 0x100000},
	{94338, 0x200000},
	{94364, 0x400000},
	{101013, 0x800000},
	{94390, 0x1000000},
	{94417, 0x2000000},
	{94444, 0x4000000},
	{101039, 0x8000000},
	{101065, 0x10000000},
	{94524, 0x20000000},
	{94553, 0x40000000},
	{94579, 0x80000000},
	/* 5389 */
	{93271, 0x3F},
	{94099, 0x400},
	{94126, 0x800},
	{94153, 0x1000},
	{94179, 0x2000},
	{94205, 0x8000},
	{94232, 0x10000},
	{94312, 0x20000},
	{94338, 0x40000},
	{100986, 0x80000},
	{94258, 0x100000},
	{94417, 0x200000},
	{94579, 0x400000},
	/* 5402 */
	{115709, 0xFF},
	{10349, 0xFFFFFF00},
};

static const char sid_strings[] =
	"NOP\0" /* 0, 1 */
	"SET_BASE\0" /* 4, 8 */
	"CLEAR_STATE\0" /* 13 */
	"INDEX_BUFFER_SIZE\0" /* 25, 38 */
	"DISPATCH_DIRECT\0" /* 43 */
	"DISPATCH_INDIRECT\0" /* 59 */
	"OCCLUSION_QUERY\0" /* 77, 91 */
	"SET_PREDICATION\0" /* 93 */
	"COND_EXEC\0" /* 109 */
	"PRED_EXEC\0" /* 119 */
	"DRAW_INDIRECT\0" /* 129 */
	"DRAW_INDEX_INDIRECT\0" /* 143 */
	"INDEX_BASE\0" /* 163 */
	"DRAW_INDEX_2\0" /* 174 */
	"CONTEXT_CONTROL\0" /* 187, 195 */
	"INDEX_TYPE\0" /* 203, 209 */
	"DRAW_INDIRECT_MULTI\0" /* 214 */
	"DRAW_INDEX_AUTO\0" /* 234, 245 */
	"DRAW_INDEX_IMMD\0" /* 250 */
	"NUM_INSTANCES\0" /* 266 */
	"DRAW_INDEX_MULTI_AUTO\0" /* 280 */
	"INDIRECT_BUFFER_SI\0" /* 302 */
	"INDIRECT_BUFFER_CONST\0" /* 321 */
	"STRMOUT_BUFFER_UPDATE\0" /* 343 */
	"DRAW_INDEX_OFFSET_2\0" /* 365 */
	"WRITE_DATA\0" /* 385, 391 */
	"DRAW_INDEX_INDIRECT_MULTI\0" /* 396 */
	"MEM_SEMAPHORE\0" /* 422 */
	"MPEG_INDEX\0" /* 436, 441, 445 */
	"WAIT_REG_MEM\0" /* 447, 456 */
	"MEM_WRITE\0" /* 460 */
	"INDIRECT_BUFFER_CIK\0" /* 470 */
	"COPY_DATA\0" /* 490 */
	"PFP_SYNC_ME\0" /* 500, 509 */
	"SURFACE_SYNC\0" /* 512 */
	"ME_INITIALIZE\0" /* 525 */
	"COND_WRITE\0" /* 539 */
	"EVENT_WRITE\0" /* 550 */
	"EVENT_WRITE_EOP\0" /* 562 */
	"RELEASE_MEM\0" /* 578 */
	"CONTEXT_REG_RMW\0" /* 590 */
	"ONE_REG_WRITE\0" /* 606 */
	"ACQUIRE_MEM\0" /* 620 */
	"REWIND\0" /* 632 */
	"LOAD_UCONFIG_REG\0" /* 639 */
	"LOAD_SH_REG\0" /* 656 */
	"LOAD_CONTEXT_REG\0" /* 668 */
	"SET_CONFIG_REG\0" /* 685 */
	"SET_CONTEXT_REG\0" /* 700 */
	"SET_SH_REG\0" /* 716 */
	"SET_SH_REG_OFFSET\0" /* 727, 738 */
	"SET_UCONFIG_REG\0" /* 745 */
	"SET_UCONFIG_REG_INDEX\0" /* 761 */
	"LOAD_CONST_RAM\0" /* 783 */
	"WRITE_CONST_RAM\0" /* 798 */
	"DUMP_CONST_RAM\0" /* 814 */
	"INCREMENT_CE_COUNTER\0" /* 829, 842 */
	"INCREMENT_DE_COUNTER\0" /* 850 */
	"WAIT_ON_CE_COUNTER\0" /* 871 */
	"SET_SH_REG_INDEX\0" /* 890 */
	"LOAD_CONTEXT_REG_INDEX\0" /* 907 */
	"IT_OPCODE_C\0" /* 930 */
	"CP_DMA\0" /* 942 */
	"DMA_DATA\0" /* 949 */
	"SQ_WAVE_MODE\0" /* 958, 966, 968 */
	"SQ_WAVE_STATUS\0" /* 971, 979 */
	"SQ_WAVE_TRAPSTS\0" /* 986 */
	"SQ_WAVE_HW_ID_LEGACY\0" /* 1002 */
	"SQ_WAVE_GPR_ALLOC\0" /* 1023 */
	"SQ_WAVE_LDS_ALLOC\0" /* 1041 */
	"SQ_WAVE_IB_STS\0" /* 1059 */
	"SQ_WAVE_PC_LO\0" /* 1074, 1082 */
	"SQ_WAVE_PC_HI\0" /* 1088, 1096 */
	"SQ_WAVE_INST_DW0\0" /* 1102, 1110 */
	"SQ_WAVE_IB_DBG1\0" /* 1119 */
	"SQ_WAVE_FLUSH_IB\0" /* 1135 */
	"SQ_WAVE_HW_ID1\0" /* 1152 */
	"SQ_WAVE_HW_ID2\0" /* 1167 */
	"SQ_WAVE_POPS_PACKER\0" /* 1182 */
	"SQ_WAVE_SCHED_MODE\0" /* 1202 */
	"SQ_WAVE_VGPR_OFFSET\0" /* 1221 */
	"SQ_WAVE_IB_STS2\0" /* 1241 */
	"SQ_WAVE_TTMP0\0" /* 1257 */
	"SQ_WAVE_TTMP1\0" /* 1271 */
	"SQ_WAVE_TTMP2\0" /* 1285 */
	"SQ_WAVE_TTMP3\0" /* 1299 */
	"SQ_WAVE_TTMP4\0" /* 1313 */
	"SQ_WAVE_TTMP5\0" /* 1327 */
	"SQ_WAVE_TTMP6\0" /* 1341 */
	"SQ_WAVE_TTMP7\0" /* 1355 */
	"SQ_WAVE_TTMP8\0" /* 1369 */
	"SQ_WAVE_TTMP9\0" /* 1383 */
	"SQ_WAVE_TTMP10\0" /* 1397 */
	"SQ_WAVE_TTMP11\0" /* 1412 */
	"SQ_WAVE_TTMP12\0" /* 1427 */
	"SQ_WAVE_TTMP13\0" /* 1442 */
	"SQ_WAVE_TTMP14\0" /* 1457 */
	"SQ_WAVE_TTMP15\0" /* 1472 */
	"SQ_WAVE_M0\0" /* 1487, 1495 */
	"SQ_WAVE_EXEC_LO\0" /* 1498, 1506 */
	"SQ_WAVE_EXEC_HI\0" /* 1514, 1522 */
	"SQ_WAVE_FLAT_SCRATCH_LO\0" /* 1530 */
	"SQ_WAVE_FLAT_SCRATCH_HI\0" /* 1554 */
	"SQ_WAVE_FLAT_XNACK_MASK\0" /* 1578, 1597 */
	"GRBM_STATUS2\0" /* 1602 */
	"GRBM_STATUS\0" /* 1615 */
	"GRBM_STATUS_SE0\0" /* 1627 */
	"GRBM_STATUS_SE1\0" /* 1643 */
	"GRBM_STATUS3\0" /* 1659 */
	"GRBM_STATUS_SE2\0" /* 1672 */
	"GRBM_STATUS_SE3\0" /* 1688 */
	"CP_CPC_STATUS\0" /* 1704 */
	"CP_CPC_BUSY_STAT\0" /* 1718 */
	"CP_CPC_STALLED_STAT1\0" /* 1735 */
	"CP_CPF_STATUS\0" /* 1756 */
	"CP_CPF_BUSY_STAT\0" /* 1770 */
	"CP_CPF_STALLED_STAT1\0" /* 1787 */
	"CP_CPC_BUSY_STAT2\0" /* 1808 */
	"CP_CPC_GRBM_FREE_COUNT\0" /* 1826, 1838, 1843 */
	"CP_CPC_SCRATCH_INDEX\0" /* 1849, 1856 */
	"CP_CPC_SCRATCH_DATA\0" /* 1870, 1877 */
	"CP_CPF_GRBM_FREE_COUNT\0" /* 1890 */
	"CP_CPF_BUSY_STAT2\0" /* 1913 */
	"CP_CPC_HALT_HYST_COUNT\0" /* 1931 */
	"SQ_THREAD_TRACE_BUF0_BASE\0" /* 1954 */
	"SQ_THREAD_TRACE_BUF0_SIZE\0" /* 1980 */
	"SQ_THREAD_TRACE_BUF1_BASE\0" /* 2006 */
	"SQ_THREAD_TRACE_BUF1_SIZE\0" /* 2032 */
	"SQ_THREAD_TRACE_WPTR\0" /* 2058, 2074 */
	"SQ_THREAD_TRACE_MASK\0" /* 2079 */
	"SQ_THREAD_TRACE_TOKEN_MASK\0" /* 2100, 2116 */
	"SQ_THREAD_TRACE_CTRL\0" /* 2127 */
	"SQ_THREAD_TRACE_STATUS\0" /* 2148 */
	"SQ_THREAD_TRACE_DROPPED_CNTR\0" /* 2171, 2195 */
	"SQ_THREAD_TRACE_GFX_DRAW_CNTR\0" /* 2200 */
	"SQ_THREAD_TRACE_GFX_MARKER_CNTR\0" /* 2230 */
	"SQ_THREAD_TRACE_HP3D_DRAW_CNTR\0" /* 2262 */
	"SQ_THREAD_TRACE_HP3D_MARKER_CNTR\0" /* 2293 */
	"SQ_EXP_0\0" /* 2326 */
	"SQ_BUF_RSRC_WORD0\0" /* 2335 */
	"SQ_BUF_RSRC_WORD1\0" /* 2353 */
	"SQ_BUF_RSRC_WORD2\0" /* 2371 */
	"SQ_BUF_RSRC_WORD3\0" /* 2389 */
	"SQ_IMG_SAMP_WORD0\0" /* 2407 */
	"SQ_IMG_SAMP_WORD1\0" /* 2425 */
	"SQ_IMG_SAMP_WORD2\0" /* 2443 */
	"SQ_IMG_SAMP_WORD3\0" /* 2461 */
	"SPI_CONFIG_CNTL\0" /* 2479 */
	"GB_ADDR_CONFIG\0" /* 2495 */
	"GB_TILE_MODE0\0" /* 2510 */
	"GB_TILE_MODE1\0" /* 2524 */
	"GB_TILE_MODE2\0" /* 2538 */
	"GB_TILE_MODE3\0" /* 2552 */
	"GB_TILE_MODE4\0" /* 2566 */
	"GB_TILE_MODE5\0" /* 2580 */
	"GB_TILE_MODE6\0" /* 2594 */
	"GB_TILE_MODE7\0" /* 2608 */
	"GB_TILE_MODE8\0" /* 2622 */
	"GB_TILE_MODE9\0" /* 2636 */
	"GB_TILE_MODE10\0" /* 2650 */
	"GB_TILE_MODE11\0" /* 2665 */
	"GB_TILE_MODE12\0" /* 2680 */
	"GB_TILE_MODE13\0" /* 2695 */
	"GB_TILE_MODE14\0" /* 2710 */
	"GB_TILE_MODE15\0" /* 2725 */
	"GB_TILE_MODE16\0" /* 2740 */
	"GB_TILE_MODE17\0" /* 2755 */
	"GB_TILE_MODE18\0" /* 2770 */
	"GB_TILE_MODE19\0" /* 2785 */
	"GB_TILE_MODE20\0" /* 2800 */
	"GB_TILE_MODE21\0" /* 2815 */
	"GB_TILE_MODE22\0" /* 2830 */
	"GB_TILE_MODE23\0" /* 2845 */
	"GB_TILE_MODE24\0" /* 2860 */
	"GB_TILE_MODE25\0" /* 2875 */
	"GB_TILE_MODE26\0" /* 2890 */
	"GB_TILE_MODE27\0" /* 2905 */
	"GB_TILE_MODE28\0" /* 2920 */
	"GB_TILE_MODE29\0" /* 2935 */
	"GB_TILE_MODE30\0" /* 2950 */
	"GB_TILE_MODE31\0" /* 2965 */
	"GB_MACROTILE_MODE0\0" /* 2980 */
	"GB_MACROTILE_MODE1\0" /* 2999 */
	"GB_MACROTILE_MODE2\0" /* 3018 */
	"GB_MACROTILE_MODE3\0" /* 3037 */
	"GB_MACROTILE_MODE4\0" /* 3056 */
	"GB_MACROTILE_MODE5\0" /* 3075 */
	"GB_MACROTILE_MODE6\0" /* 3094 */
	"GB_MACROTILE_MODE7\0" /* 3113 */
	"GB_MACROTILE_MODE8\0" /* 3132 */
	"GB_MACROTILE_MODE9\0" /* 3151 */
	"GB_MACROTILE_MODE10\0" /* 3170 */
	"GB_MACROTILE_MODE11\0" /* 3190 */
	"GB_MACROTILE_MODE12\0" /* 3210 */
	"GB_MACROTILE_MODE13\0" /* 3230 */
	"GB_MACROTILE_MODE14\0" /* 3250 */
	"GB_MACROTILE_MODE15\0" /* 3270 */
	"SQ_IMG_RSRC_WORD0\0" /* 3290 */
	"SQ_IMG_RSRC_WORD1\0" /* 3308 */
	"SQ_IMG_RSRC_WORD2\0" /* 3326 */
	"SQ_IMG_RSRC_WORD3\0" /* 3344 */
	"SQ_IMG_RSRC_WORD4\0" /* 3362 */
	"SQ_IMG_RSRC_WORD5\0" /* 3380 */
	"SQ_IMG_RSRC_WORD6\0" /* 3398 */
	"SQ_IMG_RSRC_WORD7\0" /* 3416 */
	"SPI_SHADER_PGM_RSRC4_PS\0" /* 3434 */
	"SPI_SHADER_PGM_CHKSUM_PS\0" /* 3458 */
	"SPI_SHADER_PGM_RSRC3_PS\0" /* 3483 */
	"SPI_SHADER_PGM_LO_PS\0" /* 3507 */
	"SPI_SHADER_PGM_HI_PS\0" /* 3528 */
	"SPI_SHADER_PGM_RSRC1_PS\0" /* 3549 */
	"SPI_SHADER_PGM_RSRC2_PS\0" /* 3573 */
	"SPI_SHADER_USER_DATA_PS_0\0" /* 3597 */
	"SPI_SHADER_USER_DATA_PS_1\0" /* 3623 */
	"SPI_SHADER_USER_DATA_PS_2\0" /* 3649 */
	"SPI_SHADER_USER_DATA_PS_3\0" /* 3675 */
	"SPI_SHADER_USER_DATA_PS_4\0" /* 3701 */
	"SPI_SHADER_USER_DATA_PS_5\0" /* 3727 */
	"SPI_SHADER_USER_DATA_PS_6\0" /* 3753 */
	"SPI_SHADER_USER_DATA_PS_7\0" /* 3779 */
	"SPI_SHADER_USER_DATA_PS_8\0" /* 3805 */
	"SPI_SHADER_USER_DATA_PS_9\0" /* 3831 */
	"SPI_SHADER_USER_DATA_PS_10\0" /* 3857 */
	"SPI_SHADER_USER_DATA_PS_11\0" /* 3884 */
	"SPI_SHADER_USER_DATA_PS_12\0" /* 3911 */
	"SPI_SHADER_USER_DATA_PS_13\0" /* 3938 */
	"SPI_SHADER_USER_DATA_PS_14\0" /* 3965 */
	"SPI_SHADER_USER_DATA_PS_15\0" /* 3992 */
	"SPI_SHADER_USER_DATA_PS_16\0" /* 4019 */
	"SPI_SHADER_USER_DATA_PS_17\0" /* 4046 */
	"SPI_SHADER_USER_DATA_PS_18\0" /* 4073 */
	"SPI_SHADER_USER_DATA_PS_19\0" /* 4100 */
	"SPI_SHADER_USER_DATA_PS_20\0" /* 4127 */
	"SPI_SHADER_USER_DATA_PS_21\0" /* 4154 */
	"SPI_SHADER_USER_DATA_PS_22\0" /* 4181 */
	"SPI_SHADER_USER_DATA_PS_23\0" /* 4208 */
	"SPI_SHADER_USER_DATA_PS_24\0" /* 4235 */
	"SPI_SHADER_USER_DATA_PS_25\0" /* 4262 */
	"SPI_SHADER_USER_DATA_PS_26\0" /* 4289 */
	"SPI_SHADER_USER_DATA_PS_27\0" /* 4316 */
	"SPI_SHADER_USER_DATA_PS_28\0" /* 4343 */
	"SPI_SHADER_USER_DATA_PS_29\0" /* 4370 */
	"SPI_SHADER_USER_DATA_PS_30\0" /* 4397 */
	"SPI_SHADER_USER_DATA_PS_31\0" /* 4424 */
	"SPI_SHADER_REQ_CTRL_PS\0" /* 4451 */
	"SPI_SHADER_PREF_PRI_CNTR_CTRL_PS\0" /* 4474 */
	"SPI_SHADER_USER_ACCUM_PS_0\0" /* 4507 */
	"SPI_SHADER_USER_ACCUM_PS_1\0" /* 4534 */
	"SPI_SHADER_USER_ACCUM_PS_2\0" /* 4561 */
	"SPI_SHADER_USER_ACCUM_PS_3\0" /* 4588 */
	"SPI_SHADER_PGM_RSRC4_VS\0" /* 4615 */
	"SPI_SHADER_PGM_CHKSUM_VS\0" /* 4639 */
	"SPI_SHADER_PGM_RSRC3_VS\0" /* 4664 */
	"SPI_SHADER_LATE_ALLOC_VS\0" /* 4688 */
	"SPI_SHADER_PGM_LO_VS\0" /* 4713 */
	"SPI_SHADER_PGM_HI_VS\0" /* 4734 */
	"SPI_SHADER_PGM_RSRC1_VS\0" /* 4755 */
	"SPI_SHADER_PGM_RSRC2_VS\0" /* 4779 */
	"SPI_SHADER_USER_DATA_VS_0\0" /* 4803 */
	"SPI_SHADER_USER_DATA_VS_1\0" /* 4829 */
	"SPI_SHADER_USER_DATA_VS_2\0" /* 4855 */
	"SPI_SHADER_USER_DATA_VS_3\0" /* 4881 */
	"SPI_SHADER_USER_DATA_VS_4\0" /* 4907 */
	"SPI_SHADER_USER_DATA_VS_5\0" /* 4933 */
	"SPI_SHADER_USER_DATA_VS_6\0" /* 4959 */
	"SPI_SHADER_USER_DATA_VS_7\0" /* 4985 */
	"SPI_SHADER_USER_DATA_VS_8\0" /* 5011 */
	"SPI_SHADER_USER_DATA_VS_9\0" /* 5037 */
	"SPI_SHADER_USER_DATA_VS_10\0" /* 5063 */
	"SPI_SHADER_USER_DATA_VS_11\0" /* 5090 */
	"SPI_SHADER_USER_DATA_VS_12\0" /* 5117 */
	"SPI_SHADER_USER_DATA_VS_13\0" /* 5144 */
	"SPI_SHADER_USER_DATA_VS_14\0" /* 5171 */
	"SPI_SHADER_USER_DATA_VS_15\0" /* 5198 */
	"SPI_SHADER_USER_DATA_VS_16\0" /* 5225 */
	"SPI_SHADER_USER_DATA_VS_17\0" /* 5252 */
	"SPI_SHADER_USER_DATA_VS_18\0" /* 5279 */
	"SPI_SHADER_USER_DATA_VS_19\0" /* 5306 */
	"SPI_SHADER_USER_DATA_VS_20\0" /* 5333 */
	"SPI_SHADER_USER_DATA_VS_21\0" /* 5360 */
	"SPI_SHADER_USER_DATA_VS_22\0" /* 5387 */
	"SPI_SHADER_USER_DATA_VS_23\0" /* 5414 */
	"SPI_SHADER_USER_DATA_VS_24\0" /* 5441 */
	"SPI_SHADER_USER_DATA_VS_25\0" /* 5468 */
	"SPI_SHADER_USER_DATA_VS_26\0" /* 5495 */
	"SPI_SHADER_USER_DATA_VS_27\0" /* 5522 */
	"SPI_SHADER_USER_DATA_VS_28\0" /* 5549 */
	"SPI_SHADER_USER_DATA_VS_29\0" /* 5576 */
	"SPI_SHADER_USER_DATA_VS_30\0" /* 5603 */
	"SPI_SHADER_USER_DATA_VS_31\0" /* 5630 */
	"SPI_SHADER_REQ_CTRL_VS\0" /* 5657 */
	"SPI_SHADER_PREF_PRI_CNTR_CTRL_VS\0" /* 5680 */
	"SPI_SHADER_USER_ACCUM_VS_0\0" /* 5713 */
	"SPI_SHADER_USER_ACCUM_VS_1\0" /* 5740 */
	"SPI_SHADER_USER_ACCUM_VS_2\0" /* 5767 */
	"SPI_SHADER_USER_ACCUM_VS_3\0" /* 5794 */
	"SPI_SHADER_PGM_RSRC2_GS_VS\0" /* 5821 */
	"SPI_SHADER_PGM_RSRC2_ES_VS\0" /* 5848 */
	"SPI_SHADER_PGM_RSRC2_LS_VS\0" /* 5875 */
	"SPI_SHADER_PGM_CHKSUM_GS\0" /* 5902 */
	"SPI_SHADER_PGM_RSRC4_GS\0" /* 5927 */
	"SPI_SHADER_USER_DATA_ADDR_LO_GS\0" /* 5951 */
	"SPI_SHADER_USER_DATA_ADDR_HI_GS\0" /* 5983 */
	"SPI_SHADER_PGM_LO_ES_GS\0" /* 6015 */
	"SPI_SHADER_PGM_HI_ES_GS\0" /* 6039 */
	"SPI_SHADER_PGM_RSRC3_GS\0" /* 6063 */
	"SPI_SHADER_PGM_LO_GS\0" /* 6087 */
	"SPI_SHADER_PGM_HI_GS\0" /* 6108 */
	"SPI_SHADER_PGM_RSRC1_GS\0" /* 6129 */
	"SPI_SHADER_PGM_RSRC2_GS\0" /* 6153 */
	"SPI_SHADER_USER_DATA_GS_0\0" /* 6177 */
	"SPI_SHADER_USER_DATA_GS_1\0" /* 6203 */
	"SPI_SHADER_USER_DATA_GS_2\0" /* 6229 */
	"SPI_SHADER_USER_DATA_GS_3\0" /* 6255 */
	"SPI_SHADER_USER_DATA_GS_4\0" /* 6281 */
	"SPI_SHADER_USER_DATA_GS_5\0" /* 6307 */
	"SPI_SHADER_USER_DATA_GS_6\0" /* 6333 */
	"SPI_SHADER_USER_DATA_GS_7\0" /* 6359 */
	"SPI_SHADER_USER_DATA_GS_8\0" /* 6385 */
	"SPI_SHADER_USER_DATA_GS_9\0" /* 6411 */
	"SPI_SHADER_USER_DATA_GS_10\0" /* 6437 */
	"SPI_SHADER_USER_DATA_GS_11\0" /* 6464 */
	"SPI_SHADER_USER_DATA_GS_12\0" /* 6491 */
	"SPI_SHADER_USER_DATA_GS_13\0" /* 6518 */
	"SPI_SHADER_USER_DATA_GS_14\0" /* 6545 */
	"SPI_SHADER_USER_DATA_GS_15\0" /* 6572 */
	"SPI_SHADER_USER_DATA_GS_16\0" /* 6599 */
	"SPI_SHADER_USER_DATA_GS_17\0" /* 6626 */
	"SPI_SHADER_USER_DATA_GS_18\0" /* 6653 */
	"SPI_SHADER_USER_DATA_GS_19\0" /* 6680 */
	"SPI_SHADER_USER_DATA_GS_20\0" /* 6707 */
	"SPI_SHADER_USER_DATA_GS_21\0" /* 6734 */
	"SPI_SHADER_USER_DATA_GS_22\0" /* 6761 */
	"SPI_SHADER_USER_DATA_GS_23\0" /* 6788 */
	"SPI_SHADER_USER_DATA_GS_24\0" /* 6815 */
	"SPI_SHADER_USER_DATA_GS_25\0" /* 6842 */
	"SPI_SHADER_USER_DATA_GS_26\0" /* 6869 */
	"SPI_SHADER_USER_DATA_GS_27\0" /* 6896 */
	"SPI_SHADER_USER_DATA_GS_28\0" /* 6923 */
	"SPI_SHADER_USER_DATA_GS_29\0" /* 6950 */
	"SPI_SHADER_USER_DATA_GS_30\0" /* 6977 */
	"SPI_SHADER_USER_DATA_GS_31\0" /* 7004 */
	"SPI_SHADER_REQ_CTRL_ESGS\0" /* 7031 */
	"SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS\0" /* 7056 */
	"SPI_SHADER_USER_ACCUM_ESGS_0\0" /* 7091 */
	"SPI_SHADER_USER_ACCUM_ESGS_1\0" /* 7120 */
	"SPI_SHADER_USER_ACCUM_ESGS_2\0" /* 7149 */
	"SPI_SHADER_USER_ACCUM_ESGS_3\0" /* 7178 */
	"SPI_SHADER_PGM_RSRC2_ES_GS\0" /* 7207 */
	"SPI_SHADER_PGM_RSRC3_ES\0" /* 7234 */
	"SPI_SHADER_PGM_LO_ES\0" /* 7258 */
	"SPI_SHADER_PGM_HI_ES\0" /* 7279 */
	"SPI_SHADER_PGM_RSRC1_ES\0" /* 7300 */
	"SPI_SHADER_PGM_RSRC2_ES\0" /* 7324 */
	"SPI_SHADER_USER_DATA_ES_0\0" /* 7348 */
	"SPI_SHADER_USER_DATA_ES_1\0" /* 7374 */
	"SPI_SHADER_USER_DATA_ES_2\0" /* 7400 */
	"SPI_SHADER_USER_DATA_ES_3\0" /* 7426 */
	"SPI_SHADER_USER_DATA_ES_4\0" /* 7452 */
	"SPI_SHADER_USER_DATA_ES_5\0" /* 7478 */
	"SPI_SHADER_USER_DATA_ES_6\0" /* 7504 */
	"SPI_SHADER_USER_DATA_ES_7\0" /* 7530 */
	"SPI_SHADER_USER_DATA_ES_8\0" /* 7556 */
	"SPI_SHADER_USER_DATA_ES_9\0" /* 7582 */
	"SPI_SHADER_USER_DATA_ES_10\0" /* 7608 */
	"SPI_SHADER_USER_DATA_ES_11\0" /* 7635 */
	"SPI_SHADER_USER_DATA_ES_12\0" /* 7662 */
	"SPI_SHADER_USER_DATA_ES_13\0" /* 7689 */
	"SPI_SHADER_USER_DATA_ES_14\0" /* 7716 */
	"SPI_SHADER_USER_DATA_ES_15\0" /* 7743 */
	"SPI_SHADER_PGM_RSRC2_LS_ES\0" /* 7770 */
	"SPI_SHADER_PGM_CHKSUM_HS\0" /* 7797 */
	"SPI_SHADER_PGM_RSRC4_HS\0" /* 7822 */
	"SPI_SHADER_USER_DATA_ADDR_LO_HS\0" /* 7846 */
	"SPI_SHADER_USER_DATA_ADDR_HI_HS\0" /* 7878 */
	"SPI_SHADER_PGM_LO_LS_HS\0" /* 7910 */
	"SPI_SHADER_PGM_HI_LS_HS\0" /* 7934 */
	"SPI_SHADER_PGM_RSRC3_HS\0" /* 7958 */
	"SPI_SHADER_PGM_LO_HS\0" /* 7982 */
	"SPI_SHADER_PGM_HI_HS\0" /* 8003 */
	"SPI_SHADER_PGM_RSRC1_HS\0" /* 8024 */
	"SPI_SHADER_PGM_RSRC2_HS\0" /* 8048 */
	"SPI_SHADER_USER_DATA_HS_0\0" /* 8072 */
	"SPI_SHADER_USER_DATA_HS_1\0" /* 8098 */
	"SPI_SHADER_USER_DATA_HS_2\0" /* 8124 */
	"SPI_SHADER_USER_DATA_HS_3\0" /* 8150 */
	"SPI_SHADER_USER_DATA_HS_4\0" /* 8176 */
	"SPI_SHADER_USER_DATA_HS_5\0" /* 8202 */
	"SPI_SHADER_USER_DATA_HS_6\0" /* 8228 */
	"SPI_SHADER_USER_DATA_HS_7\0" /* 8254 */
	"SPI_SHADER_USER_DATA_HS_8\0" /* 8280 */
	"SPI_SHADER_USER_DATA_HS_9\0" /* 8306 */
	"SPI_SHADER_USER_DATA_HS_10\0" /* 8332 */
	"SPI_SHADER_USER_DATA_HS_11\0" /* 8359 */
	"SPI_SHADER_USER_DATA_HS_12\0" /* 8386 */
	"SPI_SHADER_USER_DATA_HS_13\0" /* 8413 */
	"SPI_SHADER_USER_DATA_HS_14\0" /* 8440 */
	"SPI_SHADER_USER_DATA_HS_15\0" /* 8467 */
	"SPI_SHADER_USER_DATA_HS_16\0" /* 8494 */
	"SPI_SHADER_USER_DATA_HS_17\0" /* 8521 */
	"SPI_SHADER_USER_DATA_HS_18\0" /* 8548 */
	"SPI_SHADER_USER_DATA_HS_19\0" /* 8575 */
	"SPI_SHADER_USER_DATA_HS_20\0" /* 8602 */
	"SPI_SHADER_USER_DATA_HS_21\0" /* 8629 */
	"SPI_SHADER_USER_DATA_HS_22\0" /* 8656 */
	"SPI_SHADER_USER_DATA_HS_23\0" /* 8683 */
	"SPI_SHADER_USER_DATA_HS_24\0" /* 8710 */
	"SPI_SHADER_USER_DATA_HS_25\0" /* 8737 */
	"SPI_SHADER_USER_DATA_HS_26\0" /* 8764 */
	"SPI_SHADER_USER_DATA_HS_27\0" /* 8791 */
	"SPI_SHADER_USER_DATA_HS_28\0" /* 8818 */
	"SPI_SHADER_USER_DATA_HS_29\0" /* 8845 */
	"SPI_SHADER_USER_DATA_HS_30\0" /* 8872 */
	"SPI_SHADER_USER_DATA_HS_31\0" /* 8899 */
	"SPI_SHADER_REQ_CTRL_LSHS\0" /* 8926 */
	"SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS\0" /* 8951 */
	"SPI_SHADER_USER_ACCUM_LSHS_0\0" /* 8986 */
	"SPI_SHADER_USER_ACCUM_LSHS_1\0" /* 9015 */
	"SPI_SHADER_USER_ACCUM_LSHS_2\0" /* 9044 */
	"SPI_SHADER_USER_ACCUM_LSHS_3\0" /* 9073 */
	"SPI_SHADER_PGM_RSRC2_LS_HS\0" /* 9102 */
	"SPI_SHADER_PGM_RSRC3_LS\0" /* 9129 */
	"SPI_SHADER_PGM_LO_LS\0" /* 9153 */
	"SPI_SHADER_PGM_HI_LS\0" /* 9174 */
	"SPI_SHADER_PGM_RSRC1_LS\0" /* 9195 */
	"SPI_SHADER_PGM_RSRC2_LS\0" /* 9219 */
	"SPI_SHADER_USER_DATA_LS_0\0" /* 9243 */
	"SPI_SHADER_USER_DATA_LS_1\0" /* 9269 */
	"SPI_SHADER_USER_DATA_LS_2\0" /* 9295 */
	"SPI_SHADER_USER_DATA_LS_3\0" /* 9321 */
	"SPI_SHADER_USER_DATA_LS_4\0" /* 9347 */
	"SPI_SHADER_USER_DATA_LS_5\0" /* 9373 */
	"SPI_SHADER_USER_DATA_LS_6\0" /* 9399 */
	"SPI_SHADER_USER_DATA_LS_7\0" /* 9425 */
	"SPI_SHADER_USER_DATA_LS_8\0" /* 9451 */
	"SPI_SHADER_USER_DATA_LS_9\0" /* 9477 */
	"SPI_SHADER_USER_DATA_LS_10\0" /* 9503 */
	"SPI_SHADER_USER_DATA_LS_11\0" /* 9530 */
	"SPI_SHADER_USER_DATA_LS_12\0" /* 9557 */
	"SPI_SHADER_USER_DATA_LS_13\0" /* 9584 */
	"SPI_SHADER_USER_DATA_LS_14\0" /* 9611 */
	"SPI_SHADER_USER_DATA_LS_15\0" /* 9638 */
	"COMPUTE_DISPATCH_INITIATOR\0" /* 9665 */
	"COMPUTE_DIM_X\0" /* 9692 */
	"COMPUTE_DIM_Y\0" /* 9706 */
	"COMPUTE_DIM_Z\0" /* 9720 */
	"COMPUTE_START_X\0" /* 9734, 9742 */
	"COMPUTE_START_Y\0" /* 9750, 9758 */
	"COMPUTE_START_Z\0" /* 9766 */
	"COMPUTE_NUM_THREAD_X\0" /* 9782 */
	"COMPUTE_NUM_THREAD_Y\0" /* 9803 */
	"COMPUTE_NUM_THREAD_Z\0" /* 9824 */
	"COMPUTE_PIPELINESTAT_ENABLE\0" /* 9845, 9853, 9866 */
	"COMPUTE_PERFCOUNT_ENABLE\0" /* 9873, 9881 */
	"COMPUTE_PGM_LO\0" /* 9898 */
	"COMPUTE_PGM_HI\0" /* 9913 */
	"COMPUTE_DISPATCH_PKT_ADDR_LO\0" /* 9928, 9949 */
	"COMPUTE_DISPATCH_PKT_ADDR_HI\0" /* 9957, 9978 */
	"COMPUTE_DISPATCH_SCRATCH_BASE_LO\0" /* 9986, 10011 */
	"COMPUTE_DISPATCH_SCRATCH_BASE_HI\0" /* 10019, 10044 */
	"COMPUTE_PGM_RSRC1\0" /* 10052, 10065 */
	"COMPUTE_PGM_RSRC2\0" /* 10070, 10083 */
	"COMPUTE_VMID\0" /* 10088, 10096, 10098 */
	"COMPUTE_RESOURCE_LIMITS\0" /* 10101 */
	"COMPUTE_DESTINATION_EN_SE0\0" /* 10125 */
	"COMPUTE_DESTINATION_EN_SE1\0" /* 10152 */
	"COMPUTE_TMPRING_SIZE\0" /* 10179, 10190 */
	"COMPUTE_DESTINATION_EN_SE2\0" /* 10200 */
	"COMPUTE_DESTINATION_EN_SE3\0" /* 10227 */
	"COMPUTE_RESTART_X\0" /* 10254 */
	"COMPUTE_RESTART_Y\0" /* 10272 */
	"COMPUTE_RESTART_Z\0" /* 10290 */
	"COMPUTE_THREAD_TRACE_ENABLE\0" /* 10308, 10316 */
	"COMPUTE_MISC_RESERVED\0" /* 10336, 10349 */
	"COMPUTE_DISPATCH_ID\0" /* 10358, 10366 */
	"COMPUTE_THREADGROUP_ID\0" /* 10378, 10386 */
	"COMPUTE_REQ_CTRL\0" /* 10401 */
	"COMPUTE_USER_ACCUM_0\0" /* 10418 */
	"COMPUTE_USER_ACCUM_1\0" /* 10439 */
	"COMPUTE_USER_ACCUM_2\0" /* 10460 */
	"COMPUTE_USER_ACCUM_3\0" /* 10481 */
	"COMPUTE_PGM_RSRC3\0" /* 10502 */
	"COMPUTE_DDID_INDEX\0" /* 10520 */
	"COMPUTE_SHADER_CHKSUM\0" /* 10539 */
	"COMPUTE_RELAUNCH\0" /* 10561 */
	"COMPUTE_WAVE_RESTORE_ADDR_LO\0" /* 10578 */
	"COMPUTE_WAVE_RESTORE_ADDR_HI\0" /* 10607 */
	"COMPUTE_RELAUNCH2\0" /* 10636 */
	"COMPUTE_USER_DATA_0\0" /* 10654 */
	"COMPUTE_USER_DATA_1\0" /* 10674 */
	"COMPUTE_USER_DATA_2\0" /* 10694 */
	"COMPUTE_USER_DATA_3\0" /* 10714 */
	"COMPUTE_USER_DATA_4\0" /* 10734 */
	"COMPUTE_USER_DATA_5\0" /* 10754 */
	"COMPUTE_USER_DATA_6\0" /* 10774 */
	"COMPUTE_USER_DATA_7\0" /* 10794 */
	"COMPUTE_USER_DATA_8\0" /* 10814 */
	"COMPUTE_USER_DATA_9\0" /* 10834 */
	"COMPUTE_USER_DATA_10\0" /* 10854 */
	"COMPUTE_USER_DATA_11\0" /* 10875 */
	"COMPUTE_USER_DATA_12\0" /* 10896 */
	"COMPUTE_USER_DATA_13\0" /* 10917 */
	"COMPUTE_USER_DATA_14\0" /* 10938 */
	"COMPUTE_USER_DATA_15\0" /* 10959 */
	"COMPUTE_DISPATCH_TUNNEL\0" /* 10980 */
	"COMPUTE_DISPATCH_END\0" /* 11004 */
	"COMPUTE_NOWHERE\0" /* 11025, 11033 */
	"DB_RENDER_CONTROL\0" /* 11041 */
	"DB_COUNT_CONTROL\0" /* 11059 */
	"DB_DEPTH_VIEW\0" /* 11076 */
	"DB_RENDER_OVERRIDE\0" /* 11090 */
	"DB_RENDER_OVERRIDE2\0" /* 11109 */
	"DB_HTILE_DATA_BASE\0" /* 11129 */
	"DB_DEPTH_SIZE_XY\0" /* 11148 */
	"DB_DEPTH_BOUNDS_MIN\0" /* 11165, 11181 */
	"DB_DEPTH_BOUNDS_MAX\0" /* 11185, 11201 */
	"DB_STENCIL_CLEAR\0" /* 11205, 11216 */
	"DB_DEPTH_CLEAR\0" /* 11222, 11225 */
	"PA_SC_SCREEN_SCISSOR_TL\0" /* 11237 */
	"PA_SC_SCREEN_SCISSOR_BR\0" /* 11261 */
	"DB_DFSM_CONTROL\0" /* 11285 */
	"DB_RESERVED_REG_2\0" /* 11301 */
	"DB_Z_INFO\0" /* 11319 */
	"DB_STENCIL_INFO\0" /* 11329 */
	"DB_Z_READ_BASE\0" /* 11345 */
	"DB_STENCIL_READ_BASE\0" /* 11360 */
	"DB_Z_WRITE_BASE\0" /* 11381 */
	"DB_STENCIL_WRITE_BASE\0" /* 11397 */
	"DB_RESERVED_REG_1\0" /* 11419 */
	"DB_RESERVED_REG_3\0" /* 11437 */
	"DB_Z_READ_BASE_HI\0" /* 11455 */
	"DB_STENCIL_READ_BASE_HI\0" /* 11473 */
	"DB_Z_WRITE_BASE_HI\0" /* 11497 */
	"DB_STENCIL_WRITE_BASE_HI\0" /* 11516 */
	"DB_HTILE_DATA_BASE_HI\0" /* 11541 */
	"DB_RMI_L2_CACHE_CONTROL\0" /* 11563, 11573 */
	"TA_BC_BASE_ADDR\0" /* 11587, 11593, 11598 */
	"TA_BC_BASE_ADDR_HI\0" /* 11603 */
	"COHER_DEST_BASE_HI_0\0" /* 11622 */
	"COHER_DEST_BASE_HI_1\0" /* 11643 */
	"COHER_DEST_BASE_HI_2\0" /* 11664 */
	"COHER_DEST_BASE_HI_3\0" /* 11685 */
	"COHER_DEST_BASE_2\0" /* 11706 */
	"COHER_DEST_BASE_3\0" /* 11724 */
	"PA_SC_WINDOW_OFFSET\0" /* 11742, 11753 */
	"PA_SC_WINDOW_SCISSOR_TL\0" /* 11762 */
	"PA_SC_WINDOW_SCISSOR_BR\0" /* 11786 */
	"PA_SC_CLIPRECT_RULE\0" /* 11810 */
	"PA_SC_CLIPRECT_0_TL\0" /* 11830 */
	"PA_SC_CLIPRECT_0_BR\0" /* 11850 */
	"PA_SC_CLIPRECT_1_TL\0" /* 11870 */
	"PA_SC_CLIPRECT_1_BR\0" /* 11890 */
	"PA_SC_CLIPRECT_2_TL\0" /* 11910 */
	"PA_SC_CLIPRECT_2_BR\0" /* 11930 */
	"PA_SC_CLIPRECT_3_TL\0" /* 11950 */
	"PA_SC_CLIPRECT_3_BR\0" /* 11970 */
	"PA_SC_EDGERULE\0" /* 11990 */
	"PA_SU_HARDWARE_SCREEN_OFFSET\0" /* 12005 */
	"CB_TARGET_MASK\0" /* 12034 */
	"CB_SHADER_MASK\0" /* 12049 */
	"PA_SC_GENERIC_SCISSOR_TL\0" /* 12064 */
	"PA_SC_GENERIC_SCISSOR_BR\0" /* 12089 */
	"COHER_DEST_BASE_0\0" /* 12114 */
	"COHER_DEST_BASE_1\0" /* 12132 */
	"PA_SC_VPORT_SCISSOR_0_TL\0" /* 12150 */
	"PA_SC_VPORT_SCISSOR_0_BR\0" /* 12175 */
	"PA_SC_VPORT_SCISSOR_1_TL\0" /* 12200 */
	"PA_SC_VPORT_SCISSOR_1_BR\0" /* 12225 */
	"PA_SC_VPORT_SCISSOR_2_TL\0" /* 12250 */
	"PA_SC_VPORT_SCISSOR_2_BR\0" /* 12275 */
	"PA_SC_VPORT_SCISSOR_3_TL\0" /* 12300 */
	"PA_SC_VPORT_SCISSOR_3_BR\0" /* 12325 */
	"PA_SC_VPORT_SCISSOR_4_TL\0" /* 12350 */
	"PA_SC_VPORT_SCISSOR_4_BR\0" /* 12375 */
	"PA_SC_VPORT_SCISSOR_5_TL\0" /* 12400 */
	"PA_SC_VPORT_SCISSOR_5_BR\0" /* 12425 */
	"PA_SC_VPORT_SCISSOR_6_TL\0" /* 12450 */
	"PA_SC_VPORT_SCISSOR_6_BR\0" /* 12475 */
	"PA_SC_VPORT_SCISSOR_7_TL\0" /* 12500 */
	"PA_SC_VPORT_SCISSOR_7_BR\0" /* 12525 */
	"PA_SC_VPORT_SCISSOR_8_TL\0" /* 12550 */
	"PA_SC_VPORT_SCISSOR_8_BR\0" /* 12575 */
	"PA_SC_VPORT_SCISSOR_9_TL\0" /* 12600 */
	"PA_SC_VPORT_SCISSOR_9_BR\0" /* 12625 */
	"PA_SC_VPORT_SCISSOR_10_TL\0" /* 12650 */
	"PA_SC_VPORT_SCISSOR_10_BR\0" /* 12676 */
	"PA_SC_VPORT_SCISSOR_11_TL\0" /* 12702 */
	"PA_SC_VPORT_SCISSOR_11_BR\0" /* 12728 */
	"PA_SC_VPORT_SCISSOR_12_TL\0" /* 12754 */
	"PA_SC_VPORT_SCISSOR_12_BR\0" /* 12780 */
	"PA_SC_VPORT_SCISSOR_13_TL\0" /* 12806 */
	"PA_SC_VPORT_SCISSOR_13_BR\0" /* 12832 */
	"PA_SC_VPORT_SCISSOR_14_TL\0" /* 12858 */
	"PA_SC_VPORT_SCISSOR_14_BR\0" /* 12884 */
	"PA_SC_VPORT_SCISSOR_15_TL\0" /* 12910 */
	"PA_SC_VPORT_SCISSOR_15_BR\0" /* 12936 */
	"PA_SC_VPORT_ZMIN_0\0" /* 12962, 12976 */
	"PA_SC_VPORT_ZMAX_0\0" /* 12981 */
	"PA_SC_VPORT_ZMIN_1\0" /* 13000, 13014 */
	"PA_SC_VPORT_ZMAX_1\0" /* 13019 */
	"PA_SC_VPORT_ZMIN_2\0" /* 13038, 13052 */
	"PA_SC_VPORT_ZMAX_2\0" /* 13057 */
	"PA_SC_VPORT_ZMIN_3\0" /* 13076, 13090 */
	"PA_SC_VPORT_ZMAX_3\0" /* 13095 */
	"PA_SC_VPORT_ZMIN_4\0" /* 13114 */
	"PA_SC_VPORT_ZMAX_4\0" /* 13133 */
	"PA_SC_VPORT_ZMIN_5\0" /* 13152 */
	"PA_SC_VPORT_ZMAX_5\0" /* 13171 */
	"PA_SC_VPORT_ZMIN_6\0" /* 13190 */
	"PA_SC_VPORT_ZMAX_6\0" /* 13209 */
	"PA_SC_VPORT_ZMIN_7\0" /* 13228 */
	"PA_SC_VPORT_ZMAX_7\0" /* 13247 */
	"PA_SC_VPORT_ZMIN_8\0" /* 13266 */
	"PA_SC_VPORT_ZMAX_8\0" /* 13285 */
	"PA_SC_VPORT_ZMIN_9\0" /* 13304 */
	"PA_SC_VPORT_ZMAX_9\0" /* 13323 */
	"PA_SC_VPORT_ZMIN_10\0" /* 13342, 13356 */
	"PA_SC_VPORT_ZMAX_10\0" /* 13362 */
	"PA_SC_VPORT_ZMIN_11\0" /* 13382 */
	"PA_SC_VPORT_ZMAX_11\0" /* 13402 */
	"PA_SC_VPORT_ZMIN_12\0" /* 13422 */
	"PA_SC_VPORT_ZMAX_12\0" /* 13442 */
	"PA_SC_VPORT_ZMIN_13\0" /* 13462 */
	"PA_SC_VPORT_ZMAX_13\0" /* 13482 */
	"PA_SC_VPORT_ZMIN_14\0" /* 13502 */
	"PA_SC_VPORT_ZMAX_14\0" /* 13522 */
	"PA_SC_VPORT_ZMIN_15\0" /* 13542 */
	"PA_SC_VPORT_ZMAX_15\0" /* 13562 */
	"PA_SC_RASTER_CONFIG\0" /* 13582 */
	"PA_SC_RASTER_CONFIG_1\0" /* 13602 */
	"PA_SC_SCREEN_EXTENT_CONTROL\0" /* 13624 */
	"PA_SC_TILE_STEERING_OVERRIDE\0" /* 13652 */
	"CP_PERFMON_CNTX_CNTL\0" /* 13681 */
	"CP_PIPEID\0" /* 13702 */
	"CP_VMID\0" /* 13712 */
	"PA_SC_RIGHT_VERT_GRID\0" /* 13720 */
	"PA_SC_LEFT_VERT_GRID\0" /* 13742 */
	"PA_SC_HORIZ_GRID\0" /* 13763 */
	"VGT_MAX_VTX_INDX\0" /* 13780 */
	"VGT_MIN_VTX_INDX\0" /* 13797 */
	"VGT_INDX_OFFSET\0" /* 13814, 13818, 13821 */
	"VGT_MULTI_PRIM_IB_RESET_INDX\0" /* 13830, 13848 */
	"CB_RMI_GL2_CACHE_CONTROL\0" /* 13859 */
	"CB_BLEND_RED\0" /* 13884, 13887 */
	"CB_BLEND_GREEN\0" /* 13897, 13900, 13909 */
	"CB_BLEND_BLUE\0" /* 13912, 13915 */
	"CB_BLEND_ALPHA\0" /* 13926, 13929 */
	"CB_DCC_CONTROL\0" /* 13941 */
	"CB_COVERAGE_OUT_CONTROL\0" /* 13956 */
	"DB_STENCIL_CONTROL\0" /* 13980 */
	"DB_STENCILREFMASK\0" /* 13999 */
	"DB_STENCILREFMASK_BF\0" /* 14017 */
	"PA_CL_VPORT_XSCALE\0" /* 14038, 14044, 14051 */
	"PA_CL_VPORT_XOFFSET\0" /* 14057, 14063 */
	"PA_CL_VPORT_YSCALE\0" /* 14077, 14083 */
	"PA_CL_VPORT_YOFFSET\0" /* 14096, 14102 */
	"PA_CL_VPORT_ZSCALE\0" /* 14116, 14122 */
	"PA_CL_VPORT_ZOFFSET\0" /* 14135, 14141 */
	"PA_CL_VPORT_XSCALE_1\0" /* 14155 */
	"PA_CL_VPORT_XOFFSET_1\0" /* 14176 */
	"PA_CL_VPORT_YSCALE_1\0" /* 14198 */
	"PA_CL_VPORT_YOFFSET_1\0" /* 14219 */
	"PA_CL_VPORT_ZSCALE_1\0" /* 14241 */
	"PA_CL_VPORT_ZOFFSET_1\0" /* 14262 */
	"PA_CL_VPORT_XSCALE_2\0" /* 14284 */
	"PA_CL_VPORT_XOFFSET_2\0" /* 14305 */
	"PA_CL_VPORT_YSCALE_2\0" /* 14327 */
	"PA_CL_VPORT_YOFFSET_2\0" /* 14348 */
	"PA_CL_VPORT_ZSCALE_2\0" /* 14370 */
	"PA_CL_VPORT_ZOFFSET_2\0" /* 14391 */
	"PA_CL_VPORT_XSCALE_3\0" /* 14413 */
	"PA_CL_VPORT_XOFFSET_3\0" /* 14434 */
	"PA_CL_VPORT_YSCALE_3\0" /* 14456 */
	"PA_CL_VPORT_YOFFSET_3\0" /* 14477 */
	"PA_CL_VPORT_ZSCALE_3\0" /* 14499 */
	"PA_CL_VPORT_ZOFFSET_3\0" /* 14520 */
	"PA_CL_VPORT_XSCALE_4\0" /* 14542 */
	"PA_CL_VPORT_XOFFSET_4\0" /* 14563 */
	"PA_CL_VPORT_YSCALE_4\0" /* 14585 */
	"PA_CL_VPORT_YOFFSET_4\0" /* 14606 */
	"PA_CL_VPORT_ZSCALE_4\0" /* 14628 */
	"PA_CL_VPORT_ZOFFSET_4\0" /* 14649 */
	"PA_CL_VPORT_XSCALE_5\0" /* 14671 */
	"PA_CL_VPORT_XOFFSET_5\0" /* 14692 */
	"PA_CL_VPORT_YSCALE_5\0" /* 14714 */
	"PA_CL_VPORT_YOFFSET_5\0" /* 14735 */
	"PA_CL_VPORT_ZSCALE_5\0" /* 14757 */
	"PA_CL_VPORT_ZOFFSET_5\0" /* 14778 */
	"PA_CL_VPORT_XSCALE_6\0" /* 14800 */
	"PA_CL_VPORT_XOFFSET_6\0" /* 14821 */
	"PA_CL_VPORT_YSCALE_6\0" /* 14843 */
	"PA_CL_VPORT_YOFFSET_6\0" /* 14864 */
	"PA_CL_VPORT_ZSCALE_6\0" /* 14886 */
	"PA_CL_VPORT_ZOFFSET_6\0" /* 14907 */
	"PA_CL_VPORT_XSCALE_7\0" /* 14929 */
	"PA_CL_VPORT_XOFFSET_7\0" /* 14950 */
	"PA_CL_VPORT_YSCALE_7\0" /* 14972 */
	"PA_CL_VPORT_YOFFSET_7\0" /* 14993 */
	"PA_CL_VPORT_ZSCALE_7\0" /* 15015 */
	"PA_CL_VPORT_ZOFFSET_7\0" /* 15036 */
	"PA_CL_VPORT_XSCALE_8\0" /* 15058 */
	"PA_CL_VPORT_XOFFSET_8\0" /* 15079 */
	"PA_CL_VPORT_YSCALE_8\0" /* 15101 */
	"PA_CL_VPORT_YOFFSET_8\0" /* 15122 */
	"PA_CL_VPORT_ZSCALE_8\0" /* 15144 */
	"PA_CL_VPORT_ZOFFSET_8\0" /* 15165 */
	"PA_CL_VPORT_XSCALE_9\0" /* 15187 */
	"PA_CL_VPORT_XOFFSET_9\0" /* 15208 */
	"PA_CL_VPORT_YSCALE_9\0" /* 15230 */
	"PA_CL_VPORT_YOFFSET_9\0" /* 15251 */
	"PA_CL_VPORT_ZSCALE_9\0" /* 15273 */
	"PA_CL_VPORT_ZOFFSET_9\0" /* 15294 */
	"PA_CL_VPORT_XSCALE_10\0" /* 15316 */
	"PA_CL_VPORT_XOFFSET_10\0" /* 15338 */
	"PA_CL_VPORT_YSCALE_10\0" /* 15361 */
	"PA_CL_VPORT_YOFFSET_10\0" /* 15383 */
	"PA_CL_VPORT_ZSCALE_10\0" /* 15406 */
	"PA_CL_VPORT_ZOFFSET_10\0" /* 15428 */
	"PA_CL_VPORT_XSCALE_11\0" /* 15451 */
	"PA_CL_VPORT_XOFFSET_11\0" /* 15473 */
	"PA_CL_VPORT_YSCALE_11\0" /* 15496 */
	"PA_CL_VPORT_YOFFSET_11\0" /* 15518 */
	"PA_CL_VPORT_ZSCALE_11\0" /* 15541 */
	"PA_CL_VPORT_ZOFFSET_11\0" /* 15563 */
	"PA_CL_VPORT_XSCALE_12\0" /* 15586 */
	"PA_CL_VPORT_XOFFSET_12\0" /* 15608 */
	"PA_CL_VPORT_YSCALE_12\0" /* 15631 */
	"PA_CL_VPORT_YOFFSET_12\0" /* 15653 */
	"PA_CL_VPORT_ZSCALE_12\0" /* 15676 */
	"PA_CL_VPORT_ZOFFSET_12\0" /* 15698 */
	"PA_CL_VPORT_XSCALE_13\0" /* 15721 */
	"PA_CL_VPORT_XOFFSET_13\0" /* 15743 */
	"PA_CL_VPORT_YSCALE_13\0" /* 15766 */
	"PA_CL_VPORT_YOFFSET_13\0" /* 15788 */
	"PA_CL_VPORT_ZSCALE_13\0" /* 15811 */
	"PA_CL_VPORT_ZOFFSET_13\0" /* 15833 */
	"PA_CL_VPORT_XSCALE_14\0" /* 15856 */
	"PA_CL_VPORT_XOFFSET_14\0" /* 15878 */
	"PA_CL_VPORT_YSCALE_14\0" /* 15901 */
	"PA_CL_VPORT_YOFFSET_14\0" /* 15923 */
	"PA_CL_VPORT_ZSCALE_14\0" /* 15946 */
	"PA_CL_VPORT_ZOFFSET_14\0" /* 15968 */
	"PA_CL_VPORT_XSCALE_15\0" /* 15991 */
	"PA_CL_VPORT_XOFFSET_15\0" /* 16013 */
	"PA_CL_VPORT_YSCALE_15\0" /* 16036 */
	"PA_CL_VPORT_YOFFSET_15\0" /* 16058 */
	"PA_CL_VPORT_ZSCALE_15\0" /* 16081 */
	"PA_CL_VPORT_ZOFFSET_15\0" /* 16103 */
	"PA_CL_UCP_0_X\0" /* 16126 */
	"PA_CL_UCP_0_Y\0" /* 16140 */
	"PA_CL_UCP_0_Z\0" /* 16154 */
	"PA_CL_UCP_0_W\0" /* 16168 */
	"PA_CL_UCP_1_X\0" /* 16182 */
	"PA_CL_UCP_1_Y\0" /* 16196 */
	"PA_CL_UCP_1_Z\0" /* 16210 */
	"PA_CL_UCP_1_W\0" /* 16224 */
	"PA_CL_UCP_2_X\0" /* 16238 */
	"PA_CL_UCP_2_Y\0" /* 16252 */
	"PA_CL_UCP_2_Z\0" /* 16266 */
	"PA_CL_UCP_2_W\0" /* 16280 */
	"PA_CL_UCP_3_X\0" /* 16294 */
	"PA_CL_UCP_3_Y\0" /* 16308 */
	"PA_CL_UCP_3_Z\0" /* 16322 */
	"PA_CL_UCP_3_W\0" /* 16336 */
	"PA_CL_UCP_4_X\0" /* 16350 */
	"PA_CL_UCP_4_Y\0" /* 16364 */
	"PA_CL_UCP_4_Z\0" /* 16378 */
	"PA_CL_UCP_4_W\0" /* 16392 */
	"PA_CL_UCP_5_X\0" /* 16406 */
	"PA_CL_UCP_5_Y\0" /* 16420 */
	"PA_CL_UCP_5_Z\0" /* 16434 */
	"PA_CL_UCP_5_W\0" /* 16448 */
	"PA_CL_PROG_NEAR_CLIP_Z\0" /* 16462 */
	"SPI_PS_INPUT_CNTL_0\0" /* 16485 */
	"SPI_PS_INPUT_CNTL_1\0" /* 16505 */
	"SPI_PS_INPUT_CNTL_2\0" /* 16525 */
	"SPI_PS_INPUT_CNTL_3\0" /* 16545 */
	"SPI_PS_INPUT_CNTL_4\0" /* 16565 */
	"SPI_PS_INPUT_CNTL_5\0" /* 16585 */
	"SPI_PS_INPUT_CNTL_6\0" /* 16605 */
	"SPI_PS_INPUT_CNTL_7\0" /* 16625 */
	"SPI_PS_INPUT_CNTL_8\0" /* 16645 */
	"SPI_PS_INPUT_CNTL_9\0" /* 16665 */
	"SPI_PS_INPUT_CNTL_10\0" /* 16685 */
	"SPI_PS_INPUT_CNTL_11\0" /* 16706 */
	"SPI_PS_INPUT_CNTL_12\0" /* 16727 */
	"SPI_PS_INPUT_CNTL_13\0" /* 16748 */
	"SPI_PS_INPUT_CNTL_14\0" /* 16769 */
	"SPI_PS_INPUT_CNTL_15\0" /* 16790 */
	"SPI_PS_INPUT_CNTL_16\0" /* 16811 */
	"SPI_PS_INPUT_CNTL_17\0" /* 16832 */
	"SPI_PS_INPUT_CNTL_18\0" /* 16853 */
	"SPI_PS_INPUT_CNTL_19\0" /* 16874 */
	"SPI_PS_INPUT_CNTL_20\0" /* 16895 */
	"SPI_PS_INPUT_CNTL_21\0" /* 16916 */
	"SPI_PS_INPUT_CNTL_22\0" /* 16937 */
	"SPI_PS_INPUT_CNTL_23\0" /* 16958 */
	"SPI_PS_INPUT_CNTL_24\0" /* 16979 */
	"SPI_PS_INPUT_CNTL_25\0" /* 17000 */
	"SPI_PS_INPUT_CNTL_26\0" /* 17021 */
	"SPI_PS_INPUT_CNTL_27\0" /* 17042 */
	"SPI_PS_INPUT_CNTL_28\0" /* 17063 */
	"SPI_PS_INPUT_CNTL_29\0" /* 17084 */
	"SPI_PS_INPUT_CNTL_30\0" /* 17105 */
	"SPI_PS_INPUT_CNTL_31\0" /* 17126 */
	"SPI_VS_OUT_CONFIG\0" /* 17147 */
	"SPI_PS_INPUT_ENA\0" /* 17165 */
	"SPI_PS_INPUT_ADDR\0" /* 17182 */
	"SPI_INTERP_CONTROL_0\0" /* 17200 */
	"SPI_PS_IN_CONTROL\0" /* 17221 */
	"SPI_BARYC_CNTL\0" /* 17239 */
	"SPI_TMPRING_SIZE\0" /* 17254 */
	"SPI_SHADER_IDX_FORMAT\0" /* 17271, 17286 */
	"SPI_SHADER_POS_FORMAT\0" /* 17293 */
	"SPI_SHADER_Z_FORMAT\0" /* 17315 */
	"SPI_SHADER_COL_FORMAT\0" /* 17335 */
	"SX_PS_DOWNCONVERT\0" /* 17357 */
	"SX_BLEND_OPT_EPSILON\0" /* 17375 */
	"SX_BLEND_OPT_CONTROL\0" /* 17396 */
	"SX_MRT0_BLEND_OPT\0" /* 17417 */
	"SX_MRT1_BLEND_OPT\0" /* 17435 */
	"SX_MRT2_BLEND_OPT\0" /* 17453 */
	"SX_MRT3_BLEND_OPT\0" /* 17471 */
	"SX_MRT4_BLEND_OPT\0" /* 17489 */
	"SX_MRT5_BLEND_OPT\0" /* 17507 */
	"SX_MRT6_BLEND_OPT\0" /* 17525 */
	"SX_MRT7_BLEND_OPT\0" /* 17543 */
	"CB_BLEND0_CONTROL\0" /* 17561 */
	"CB_BLEND1_CONTROL\0" /* 17579 */
	"CB_BLEND2_CONTROL\0" /* 17597 */
	"CB_BLEND3_CONTROL\0" /* 17615 */
	"CB_BLEND4_CONTROL\0" /* 17633 */
	"CB_BLEND5_CONTROL\0" /* 17651 */
	"CB_BLEND6_CONTROL\0" /* 17669 */
	"CB_BLEND7_CONTROL\0" /* 17687 */
	"CS_COPY_STATE\0" /* 17705 */
	"GFX_COPY_STATE\0" /* 17719 */
	"PA_CL_POINT_X_RAD\0" /* 17734 */
	"PA_CL_POINT_Y_RAD\0" /* 17752 */
	"PA_CL_POINT_SIZE\0" /* 17770 */
	"PA_CL_POINT_CULL_RAD\0" /* 17787 */
	"VGT_DMA_BASE_HI\0" /* 17808 */
	"VGT_DMA_BASE\0" /* 17824 */
	"VGT_DRAW_INITIATOR\0" /* 17837 */
	"VGT_IMMED_DATA\0" /* 17856 */
	"VGT_EVENT_ADDRESS_REG\0" /* 17871 */
	"GE_MAX_OUTPUT_PER_SUBGROUP\0" /* 17893 */
	"DB_DEPTH_CONTROL\0" /* 17920 */
	"DB_EQAA\0" /* 17937 */
	"CB_COLOR_CONTROL\0" /* 17945 */
	"DB_SHADER_CONTROL\0" /* 17962 */
	"PA_CL_CLIP_CNTL\0" /* 17980 */
	"PA_SU_SC_MODE_CNTL\0" /* 17996 */
	"PA_CL_VTE_CNTL\0" /* 18015 */
	"PA_CL_VS_OUT_CNTL\0" /* 18030 */
	"PA_CL_NANINF_CNTL\0" /* 18048 */
	"PA_SU_LINE_STIPPLE_CNTL\0" /* 18066 */
	"PA_SU_LINE_STIPPLE_SCALE\0" /* 18090, 18096 */
	"PA_SU_PRIM_FILTER_CNTL\0" /* 18115 */
	"PA_SU_SMALL_PRIM_FILTER_CNTL\0" /* 18138 */
	"PA_CL_OBJPRIM_ID_CNTL\0" /* 18167 */
	"PA_CL_NGG_CNTL\0" /* 18189 */
	"PA_SU_OVER_RASTERIZATION_CNTL\0" /* 18204 */
	"PA_STEREO_CNTL\0" /* 18234 */
	"PA_STATE_STEREO_X\0" /* 18249 */
	"PA_SU_POINT_SIZE\0" /* 18267 */
	"PA_SU_POINT_MINMAX\0" /* 18284 */
	"PA_SU_LINE_CNTL\0" /* 18303 */
	"PA_SC_LINE_STIPPLE\0" /* 18319 */
	"VGT_OUTPUT_PATH_CNTL\0" /* 18338 */
	"VGT_HOS_CNTL\0" /* 18359 */
	"VGT_HOS_MAX_TESS_LEVEL\0" /* 18372 */
	"VGT_HOS_MIN_TESS_LEVEL\0" /* 18395 */
	"VGT_HOS_REUSE_DEPTH\0" /* 18418, 18426, 18432 */
	"VGT_GROUP_PRIM_TYPE\0" /* 18438, 18448 */
	"VGT_GROUP_FIRST_DECR\0" /* 18458, 18468, 18474 */
	"VGT_GROUP_DECR\0" /* 18479 */
	"VGT_GROUP_VECT_0_CNTL\0" /* 18494 */
	"VGT_GROUP_VECT_1_CNTL\0" /* 18516 */
	"VGT_GROUP_VECT_0_FMT_CNTL\0" /* 18538 */
	"VGT_GROUP_VECT_1_FMT_CNTL\0" /* 18564 */
	"VGT_GS_MODE\0" /* 18590 */
	"VGT_GS_ONCHIP_CNTL\0" /* 18602 */
	"PA_SC_MODE_CNTL_0\0" /* 18621 */
	"PA_SC_MODE_CNTL_1\0" /* 18639 */
	"VGT_ENHANCE\0" /* 18657, 18666 */
	"VGT_GS_PER_ES\0" /* 18669, 18673 */
	"VGT_ES_PER_GS\0" /* 18683, 18687 */
	"VGT_GS_PER_VS\0" /* 18697, 18701 */
	"VGT_GSVS_RING_OFFSET_1\0" /* 18711 */
	"VGT_GSVS_RING_OFFSET_2\0" /* 18734 */
	"VGT_GSVS_RING_OFFSET_3\0" /* 18757 */
	"VGT_GS_OUT_PRIM_TYPE\0" /* 18780 */
	"IA_ENHANCE\0" /* 18801 */
	"VGT_DMA_SIZE\0" /* 18812 */
	"VGT_DMA_MAX_SIZE\0" /* 18825, 18833 */
	"VGT_DMA_INDEX_TYPE\0" /* 18842 */
	"WD_ENHANCE\0" /* 18861 */
	"VGT_PRIMITIVEID_EN\0" /* 18872, 18876 */
	"VGT_DMA_NUM_INSTANCES\0" /* 18891 */
	"VGT_PRIMITIVEID_RESET\0" /* 18913, 18929 */
	"VGT_EVENT_INITIATOR\0" /* 18935 */
	"VGT_MULTI_PRIM_IB_RESET_EN\0" /* 18955, 18973 */
	"VGT_DRAW_PAYLOAD_CNTL\0" /* 18982 */
	"VGT_INSTANCE_STEP_RATE_0\0" /* 19004 */
	"VGT_INSTANCE_STEP_RATE_1\0" /* 19029 */
	"IA_MULTI_VGT_PARAM\0" /* 19054 */
	"VGT_ESGS_RING_ITEMSIZE\0" /* 19073, 19087 */
	"VGT_GSVS_RING_ITEMSIZE\0" /* 19096 */
	"VGT_REUSE_OFF\0" /* 19119, 19123 */
	"VGT_VTX_CNT_EN\0" /* 19133, 19137 */
	"DB_HTILE_SURFACE\0" /* 19148, 19160 */
	"DB_SRESULTS_COMPARE_STATE0\0" /* 19165 */
	"DB_SRESULTS_COMPARE_STATE1\0" /* 19192 */
	"DB_PRELOAD_CONTROL\0" /* 19219 */
	"VGT_STRMOUT_BUFFER_SIZE_0\0" /* 19238 */
	"VGT_STRMOUT_VTX_STRIDE_0\0" /* 19264 */
	"VGT_STRMOUT_BUFFER_OFFSET_0\0" /* 19289 */
	"VGT_STRMOUT_BUFFER_SIZE_1\0" /* 19317 */
	"VGT_STRMOUT_VTX_STRIDE_1\0" /* 19343 */
	"VGT_STRMOUT_BUFFER_OFFSET_1\0" /* 19368 */
	"VGT_STRMOUT_BUFFER_SIZE_2\0" /* 19396 */
	"VGT_STRMOUT_VTX_STRIDE_2\0" /* 19422 */
	"VGT_STRMOUT_BUFFER_OFFSET_2\0" /* 19447 */
	"VGT_STRMOUT_BUFFER_SIZE_3\0" /* 19475 */
	"VGT_STRMOUT_VTX_STRIDE_3\0" /* 19501 */
	"VGT_STRMOUT_BUFFER_OFFSET_3\0" /* 19526 */
	"VGT_STRMOUT_DRAW_OPAQUE_OFFSET\0" /* 19554 */
	"VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE\0" /* 19585 */
	"VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE\0" /* 19628, 19652, 19659 */
	"VGT_GS_MAX_VERT_OUT\0" /* 19666, 19673, 19682 */
	"GE_NGG_SUBGRP_CNTL\0" /* 19686 */
	"VGT_TESS_DISTRIBUTION\0" /* 19705 */
	"VGT_SHADER_STAGES_EN\0" /* 19727, 19742 */
	"VGT_LS_HS_CONFIG\0" /* 19748 */
	"VGT_GS_VERT_ITEMSIZE\0" /* 19765 */
	"VGT_GS_VERT_ITEMSIZE_1\0" /* 19786 */
	"VGT_GS_VERT_ITEMSIZE_2\0" /* 19809 */
	"VGT_GS_VERT_ITEMSIZE_3\0" /* 19832 */
	"VGT_TF_PARAM\0" /* 19855 */
	"DB_ALPHA_TO_MASK\0" /* 19868 */
	"VGT_DISPATCH_DRAW_INDEX\0" /* 19885 */
	"PA_SU_POLY_OFFSET_DB_FMT_CNTL\0" /* 19909 */
	"PA_SU_POLY_OFFSET_CLAMP\0" /* 19939, 19957 */
	"PA_SU_POLY_OFFSET_FRONT_SCALE\0" /* 19963 */
	"PA_SU_POLY_OFFSET_FRONT_OFFSET\0" /* 19993 */
	"PA_SU_POLY_OFFSET_BACK_SCALE\0" /* 20024 */
	"PA_SU_POLY_OFFSET_BACK_OFFSET\0" /* 20053 */
	"VGT_GS_INSTANCE_CNT\0" /* 20083, 20099 */
	"VGT_STRMOUT_CONFIG\0" /* 20103 */
	"VGT_STRMOUT_BUFFER_CONFIG\0" /* 20122 */
	"VGT_DMA_EVENT_INITIATOR\0" /* 20148 */
	"PA_SC_CENTROID_PRIORITY_0\0" /* 20172 */
	"PA_SC_CENTROID_PRIORITY_1\0" /* 20198 */
	"PA_SC_LINE_CNTL\0" /* 20224 */
	"PA_SC_AA_CONFIG\0" /* 20240 */
	"PA_SU_VTX_CNTL\0" /* 20256 */
	"PA_CL_GB_VERT_CLIP_ADJ\0" /* 20271 */
	"PA_CL_GB_VERT_DISC_ADJ\0" /* 20294 */
	"PA_CL_GB_HORZ_CLIP_ADJ\0" /* 20317 */
	"PA_CL_GB_HORZ_DISC_ADJ\0" /* 20340 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0\0" /* 20363 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1\0" /* 20397 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2\0" /* 20431 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3\0" /* 20465 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0\0" /* 20499 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1\0" /* 20533 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2\0" /* 20567 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3\0" /* 20601 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0\0" /* 20635 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1\0" /* 20669 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2\0" /* 20703 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3\0" /* 20737 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0\0" /* 20771 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1\0" /* 20805 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2\0" /* 20839 */
	"PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3\0" /* 20873 */
	"PA_SC_AA_MASK_X0Y0_X1Y0\0" /* 20907 */
	"PA_SC_AA_MASK_X0Y1_X1Y1\0" /* 20931 */
	"PA_SC_SHADER_CONTROL\0" /* 20955 */
	"PA_SC_BINNER_CNTL_0\0" /* 20976 */
	"PA_SC_BINNER_CNTL_1\0" /* 20996 */
	"PA_SC_CONSERVATIVE_RASTERIZATION_CNTL\0" /* 21016 */
	"PA_SC_NGG_MODE_CNTL\0" /* 21054 */
	"VGT_VERTEX_REUSE_BLOCK_CNTL\0" /* 21074 */
	"VGT_OUT_DEALLOC_CNTL\0" /* 21102 */
	"CB_COLOR0_BASE\0" /* 21123 */
	"CB_COLOR0_PITCH\0" /* 21138, 21148 */
	"CB_COLOR0_SLICE\0" /* 21154 */
	"CB_COLOR0_VIEW\0" /* 21170 */
	"CB_COLOR0_INFO\0" /* 21185 */
	"CB_COLOR0_ATTRIB\0" /* 21200 */
	"CB_COLOR0_DCC_CONTROL\0" /* 21217 */
	"CB_COLOR0_CMASK\0" /* 21239 */
	"CB_COLOR0_CMASK_SLICE\0" /* 21255 */
	"CB_COLOR0_FMASK\0" /* 21277 */
	"CB_COLOR0_FMASK_SLICE\0" /* 21293 */
	"CB_COLOR0_CLEAR_WORD0\0" /* 21315, 21325 */
	"CB_COLOR0_CLEAR_WORD1\0" /* 21337, 21347 */
	"CB_COLOR0_DCC_BASE\0" /* 21359 */
	"CB_COLOR1_BASE\0" /* 21378 */
	"CB_COLOR1_PITCH\0" /* 21393 */
	"CB_COLOR1_SLICE\0" /* 21409 */
	"CB_COLOR1_VIEW\0" /* 21425 */
	"CB_COLOR1_INFO\0" /* 21440 */
	"CB_COLOR1_ATTRIB\0" /* 21455 */
	"CB_COLOR1_DCC_CONTROL\0" /* 21472 */
	"CB_COLOR1_CMASK\0" /* 21494 */
	"CB_COLOR1_CMASK_SLICE\0" /* 21510 */
	"CB_COLOR1_FMASK\0" /* 21532 */
	"CB_COLOR1_FMASK_SLICE\0" /* 21548 */
	"CB_COLOR1_CLEAR_WORD0\0" /* 21570 */
	"CB_COLOR1_CLEAR_WORD1\0" /* 21592 */
	"CB_COLOR1_DCC_BASE\0" /* 21614 */
	"CB_COLOR2_BASE\0" /* 21633 */
	"CB_COLOR2_PITCH\0" /* 21648 */
	"CB_COLOR2_SLICE\0" /* 21664 */
	"CB_COLOR2_VIEW\0" /* 21680 */
	"CB_COLOR2_INFO\0" /* 21695 */
	"CB_COLOR2_ATTRIB\0" /* 21710 */
	"CB_COLOR2_DCC_CONTROL\0" /* 21727 */
	"CB_COLOR2_CMASK\0" /* 21749 */
	"CB_COLOR2_CMASK_SLICE\0" /* 21765 */
	"CB_COLOR2_FMASK\0" /* 21787 */
	"CB_COLOR2_FMASK_SLICE\0" /* 21803 */
	"CB_COLOR2_CLEAR_WORD0\0" /* 21825 */
	"CB_COLOR2_CLEAR_WORD1\0" /* 21847 */
	"CB_COLOR2_DCC_BASE\0" /* 21869 */
	"CB_COLOR3_BASE\0" /* 21888 */
	"CB_COLOR3_PITCH\0" /* 21903 */
	"CB_COLOR3_SLICE\0" /* 21919 */
	"CB_COLOR3_VIEW\0" /* 21935 */
	"CB_COLOR3_INFO\0" /* 21950 */
	"CB_COLOR3_ATTRIB\0" /* 21965 */
	"CB_COLOR3_DCC_CONTROL\0" /* 21982 */
	"CB_COLOR3_CMASK\0" /* 22004 */
	"CB_COLOR3_CMASK_SLICE\0" /* 22020 */
	"CB_COLOR3_FMASK\0" /* 22042 */
	"CB_COLOR3_FMASK_SLICE\0" /* 22058 */
	"CB_COLOR3_CLEAR_WORD0\0" /* 22080 */
	"CB_COLOR3_CLEAR_WORD1\0" /* 22102 */
	"CB_COLOR3_DCC_BASE\0" /* 22124 */
	"CB_COLOR4_BASE\0" /* 22143 */
	"CB_COLOR4_PITCH\0" /* 22158 */
	"CB_COLOR4_SLICE\0" /* 22174 */
	"CB_COLOR4_VIEW\0" /* 22190 */
	"CB_COLOR4_INFO\0" /* 22205 */
	"CB_COLOR4_ATTRIB\0" /* 22220 */
	"CB_COLOR4_DCC_CONTROL\0" /* 22237 */
	"CB_COLOR4_CMASK\0" /* 22259 */
	"CB_COLOR4_CMASK_SLICE\0" /* 22275 */
	"CB_COLOR4_FMASK\0" /* 22297 */
	"CB_COLOR4_FMASK_SLICE\0" /* 22313 */
	"CB_COLOR4_CLEAR_WORD0\0" /* 22335 */
	"CB_COLOR4_CLEAR_WORD1\0" /* 22357 */
	"CB_COLOR4_DCC_BASE\0" /* 22379 */
	"CB_COLOR5_BASE\0" /* 22398 */
	"CB_COLOR5_PITCH\0" /* 22413 */
	"CB_COLOR5_SLICE\0" /* 22429 */
	"CB_COLOR5_VIEW\0" /* 22445 */
	"CB_COLOR5_INFO\0" /* 22460 */
	"CB_COLOR5_ATTRIB\0" /* 22475 */
	"CB_COLOR5_DCC_CONTROL\0" /* 22492 */
	"CB_COLOR5_CMASK\0" /* 22514 */
	"CB_COLOR5_CMASK_SLICE\0" /* 22530 */
	"CB_COLOR5_FMASK\0" /* 22552 */
	"CB_COLOR5_FMASK_SLICE\0" /* 22568 */
	"CB_COLOR5_CLEAR_WORD0\0" /* 22590 */
	"CB_COLOR5_CLEAR_WORD1\0" /* 22612 */
	"CB_COLOR5_DCC_BASE\0" /* 22634 */
	"CB_COLOR6_BASE\0" /* 22653 */
	"CB_COLOR6_PITCH\0" /* 22668 */
	"CB_COLOR6_SLICE\0" /* 22684 */
	"CB_COLOR6_VIEW\0" /* 22700 */
	"CB_COLOR6_INFO\0" /* 22715 */
	"CB_COLOR6_ATTRIB\0" /* 22730 */
	"CB_COLOR6_DCC_CONTROL\0" /* 22747 */
	"CB_COLOR6_CMASK\0" /* 22769 */
	"CB_COLOR6_CMASK_SLICE\0" /* 22785 */
	"CB_COLOR6_FMASK\0" /* 22807 */
	"CB_COLOR6_FMASK_SLICE\0" /* 22823 */
	"CB_COLOR6_CLEAR_WORD0\0" /* 22845 */
	"CB_COLOR6_CLEAR_WORD1\0" /* 22867 */
	"CB_COLOR6_DCC_BASE\0" /* 22889 */
	"CB_COLOR7_BASE\0" /* 22908 */
	"CB_COLOR7_PITCH\0" /* 22923 */
	"CB_COLOR7_SLICE\0" /* 22939 */
	"CB_COLOR7_VIEW\0" /* 22955 */
	"CB_COLOR7_INFO\0" /* 22970 */
	"CB_COLOR7_ATTRIB\0" /* 22985 */
	"CB_COLOR7_DCC_CONTROL\0" /* 23002 */
	"CB_COLOR7_CMASK\0" /* 23024 */
	"CB_COLOR7_CMASK_SLICE\0" /* 23040 */
	"CB_COLOR7_FMASK\0" /* 23062 */
	"CB_COLOR7_FMASK_SLICE\0" /* 23078 */
	"CB_COLOR7_CLEAR_WORD0\0" /* 23100 */
	"CB_COLOR7_CLEAR_WORD1\0" /* 23122 */
	"CB_COLOR7_DCC_BASE\0" /* 23144 */
	"CB_COLOR0_BASE_EXT\0" /* 23163 */
	"CB_COLOR1_BASE_EXT\0" /* 23182 */
	"CB_COLOR2_BASE_EXT\0" /* 23201 */
	"CB_COLOR3_BASE_EXT\0" /* 23220 */
	"CB_COLOR4_BASE_EXT\0" /* 23239 */
	"CB_COLOR5_BASE_EXT\0" /* 23258 */
	"CB_COLOR6_BASE_EXT\0" /* 23277 */
	"CB_COLOR7_BASE_EXT\0" /* 23296 */
	"CB_COLOR0_CMASK_BASE_EXT\0" /* 23315 */
	"CB_COLOR1_CMASK_BASE_EXT\0" /* 23340 */
	"CB_COLOR2_CMASK_BASE_EXT\0" /* 23365 */
	"CB_COLOR3_CMASK_BASE_EXT\0" /* 23390 */
	"CB_COLOR4_CMASK_BASE_EXT\0" /* 23415 */
	"CB_COLOR5_CMASK_BASE_EXT\0" /* 23440 */
	"CB_COLOR6_CMASK_BASE_EXT\0" /* 23465 */
	"CB_COLOR7_CMASK_BASE_EXT\0" /* 23490 */
	"CB_COLOR0_FMASK_BASE_EXT\0" /* 23515 */
	"CB_COLOR1_FMASK_BASE_EXT\0" /* 23540 */
	"CB_COLOR2_FMASK_BASE_EXT\0" /* 23565 */
	"CB_COLOR3_FMASK_BASE_EXT\0" /* 23590 */
	"CB_COLOR4_FMASK_BASE_EXT\0" /* 23615 */
	"CB_COLOR5_FMASK_BASE_EXT\0" /* 23640 */
	"CB_COLOR6_FMASK_BASE_EXT\0" /* 23665 */
	"CB_COLOR7_FMASK_BASE_EXT\0" /* 23690 */
	"CB_COLOR0_DCC_BASE_EXT\0" /* 23715 */
	"CB_COLOR1_DCC_BASE_EXT\0" /* 23738 */
	"CB_COLOR2_DCC_BASE_EXT\0" /* 23761 */
	"CB_COLOR3_DCC_BASE_EXT\0" /* 23784 */
	"CB_COLOR4_DCC_BASE_EXT\0" /* 23807 */
	"CB_COLOR5_DCC_BASE_EXT\0" /* 23830 */
	"CB_COLOR6_DCC_BASE_EXT\0" /* 23853 */
	"CB_COLOR7_DCC_BASE_EXT\0" /* 23876 */
	"CB_COLOR0_ATTRIB2\0" /* 23899 */
	"CB_COLOR1_ATTRIB2\0" /* 23917 */
	"CB_COLOR2_ATTRIB2\0" /* 23935 */
	"CB_COLOR3_ATTRIB2\0" /* 23953 */
	"CB_COLOR4_ATTRIB2\0" /* 23971 */
	"CB_COLOR5_ATTRIB2\0" /* 23989 */
	"CB_COLOR6_ATTRIB2\0" /* 24007 */
	"CB_COLOR7_ATTRIB2\0" /* 24025 */
	"CB_COLOR0_ATTRIB3\0" /* 24043 */
	"CB_COLOR1_ATTRIB3\0" /* 24061 */
	"CB_COLOR2_ATTRIB3\0" /* 24079 */
	"CB_COLOR3_ATTRIB3\0" /* 24097 */
	"CB_COLOR4_ATTRIB3\0" /* 24115 */
	"CB_COLOR5_ATTRIB3\0" /* 24133 */
	"CB_COLOR6_ATTRIB3\0" /* 24151 */
	"CB_COLOR7_ATTRIB3\0" /* 24169 */
	"CP_EOP_DONE_ADDR_LO\0" /* 24187 */
	"CP_EOP_DONE_ADDR_HI\0" /* 24207 */
	"CP_EOP_DONE_DATA_LO\0" /* 24227, 24239 */
	"CP_EOP_DONE_DATA_HI\0" /* 24247, 24259 */
	"CP_EOP_LAST_FENCE_LO\0" /* 24267, 24274 */
	"CP_EOP_LAST_FENCE_HI\0" /* 24288, 24295 */
	"CP_STREAM_OUT_ADDR_LO\0" /* 24309, 24312 */
	"CP_STREAM_OUT_ADDR_HI\0" /* 24331, 24334 */
	"CP_NUM_PRIM_WRITTEN_COUNT0_LO\0" /* 24353 */
	"CP_NUM_PRIM_WRITTEN_COUNT0_HI\0" /* 24383 */
	"CP_NUM_PRIM_NEEDED_COUNT0_LO\0" /* 24413 */
	"CP_NUM_PRIM_NEEDED_COUNT0_HI\0" /* 24442 */
	"CP_NUM_PRIM_WRITTEN_COUNT1_LO\0" /* 24471 */
	"CP_NUM_PRIM_WRITTEN_COUNT1_HI\0" /* 24501 */
	"CP_NUM_PRIM_NEEDED_COUNT1_LO\0" /* 24531 */
	"CP_NUM_PRIM_NEEDED_COUNT1_HI\0" /* 24560 */
	"CP_NUM_PRIM_WRITTEN_COUNT2_LO\0" /* 24589 */
	"CP_NUM_PRIM_WRITTEN_COUNT2_HI\0" /* 24619 */
	"CP_NUM_PRIM_NEEDED_COUNT2_LO\0" /* 24649 */
	"CP_NUM_PRIM_NEEDED_COUNT2_HI\0" /* 24678 */
	"CP_NUM_PRIM_WRITTEN_COUNT3_LO\0" /* 24707 */
	"CP_NUM_PRIM_WRITTEN_COUNT3_HI\0" /* 24737 */
	"CP_NUM_PRIM_NEEDED_COUNT3_LO\0" /* 24767 */
	"CP_NUM_PRIM_NEEDED_COUNT3_HI\0" /* 24796 */
	"CP_PIPE_STATS_ADDR_LO\0" /* 24825, 24828 */
	"CP_PIPE_STATS_ADDR_HI\0" /* 24847, 24850 */
	"CP_VGT_IAVERT_COUNT_LO\0" /* 24869, 24876 */
	"CP_VGT_IAVERT_COUNT_HI\0" /* 24892, 24899, 24906 */
	"CP_VGT_IAPRIM_COUNT_LO\0" /* 24915, 24922 */
	"CP_VGT_IAPRIM_COUNT_HI\0" /* 24938, 24945 */
	"CP_VGT_GSPRIM_COUNT_LO\0" /* 24961, 24968 */
	"CP_VGT_GSPRIM_COUNT_HI\0" /* 24984, 24991 */
	"CP_VGT_VSINVOC_COUNT_LO\0" /* 25007, 25014 */
	"CP_VGT_VSINVOC_COUNT_HI\0" /* 25031, 25038 */
	"CP_VGT_GSINVOC_COUNT_LO\0" /* 25055, 25062 */
	"CP_VGT_GSINVOC_COUNT_HI\0" /* 25079, 25086 */
	"CP_VGT_HSINVOC_COUNT_LO\0" /* 25103, 25110 */
	"CP_VGT_HSINVOC_COUNT_HI\0" /* 25127, 25134 */
	"CP_VGT_DSINVOC_COUNT_LO\0" /* 25151, 25158 */
	"CP_VGT_DSINVOC_COUNT_HI\0" /* 25175, 25182 */
	"CP_PA_CINVOC_COUNT_LO\0" /* 25199, 25205 */
	"CP_PA_CINVOC_COUNT_HI\0" /* 25221, 25227 */
	"CP_PA_CPRIM_COUNT_LO\0" /* 25243, 25249 */
	"CP_PA_CPRIM_COUNT_HI\0" /* 25264, 25270 */
	"CP_SC_PSINVOC_COUNT0_LO\0" /* 25285, 25291 */
	"CP_SC_PSINVOC_COUNT0_HI\0" /* 25309, 25315 */
	"CP_SC_PSINVOC_COUNT1_LO\0" /* 25333 */
	"CP_SC_PSINVOC_COUNT1_HI\0" /* 25357 */
	"CP_VGT_CSINVOC_COUNT_LO\0" /* 25381, 25388 */
	"CP_VGT_CSINVOC_COUNT_HI\0" /* 25405, 25412 */
	"CP_EOP_DONE_DOORBELL\0" /* 25429 */
	"CP_STREAM_OUT_DOORBELL\0" /* 25450 */
	"CP_SEM_DOORBELL\0" /* 25473 */
	"CP_PIPE_STATS_CONTROL\0" /* 25489 */
	"CP_STREAM_OUT_CONTROL\0" /* 25511 */
	"CP_STRMOUT_CNTL\0" /* 25533 */
	"SCRATCH_REG0\0" /* 25549 */
	"SCRATCH_REG1\0" /* 25562 */
	"SCRATCH_REG2\0" /* 25575 */
	"SCRATCH_REG3\0" /* 25588 */
	"SCRATCH_REG4\0" /* 25601 */
	"SCRATCH_REG5\0" /* 25614 */
	"SCRATCH_REG6\0" /* 25627 */
	"SCRATCH_REG7\0" /* 25640 */
	"CP_PIPE_STATS_DOORBELL\0" /* 25653 */
	"CP_APPEND_DDID_CNT\0" /* 25676 */
	"CP_APPEND_DATA_HI\0" /* 25695 */
	"CP_APPEND_LAST_CS_FENCE_HI\0" /* 25713 */
	"CP_APPEND_LAST_PS_FENCE_HI\0" /* 25740 */
	"SCRATCH_UMSK\0" /* 25767 */
	"SCRATCH_ADDR\0" /* 25780 */
	"CP_PFP_ATOMIC_PREOP_LO\0" /* 25793, 25800 */
	"CP_PFP_ATOMIC_PREOP_HI\0" /* 25816, 25823 */
	"CP_PFP_GDS_ATOMIC0_PREOP_LO\0" /* 25839, 25846 */
	"CP_PFP_GDS_ATOMIC0_PREOP_HI\0" /* 25867, 25874 */
	"CP_PFP_GDS_ATOMIC1_PREOP_LO\0" /* 25895, 25902 */
	"CP_PFP_GDS_ATOMIC1_PREOP_HI\0" /* 25923, 25930 */
	"CP_APPEND_ADDR_LO\0" /* 25951 */
	"CP_APPEND_ADDR_HI\0" /* 25969 */
	"CP_APPEND_DATA\0" /* 25987 */
	"CP_APPEND_LAST_CS_FENCE\0" /* 26002 */
	"CP_APPEND_LAST_PS_FENCE\0" /* 26026 */
	"CP_ATOMIC_PREOP_LO\0" /* 26050 */
	"CP_ATOMIC_PREOP_HI\0" /* 26069 */
	"CP_GDS_ATOMIC0_PREOP_LO\0" /* 26088 */
	"CP_GDS_ATOMIC0_PREOP_HI\0" /* 26112 */
	"CP_GDS_ATOMIC1_PREOP_LO\0" /* 26136 */
	"CP_GDS_ATOMIC1_PREOP_HI\0" /* 26160 */
	"CP_ME_MC_WADDR_LO\0" /* 26184, 26187 */
	"CP_ME_MC_WADDR_HI\0" /* 26202, 26205 */
	"CP_ME_MC_WDATA_LO\0" /* 26220, 26223 */
	"CP_ME_MC_WDATA_HI\0" /* 26238, 26241 */
	"CP_ME_MC_RADDR_LO\0" /* 26256, 26259 */
	"CP_ME_MC_RADDR_HI\0" /* 26274, 26277 */
	"CP_SEM_WAIT_TIMER\0" /* 26292, 26295 */
	"CP_SIG_SEM_ADDR_LO\0" /* 26310, 26317 */
	"CP_SIG_SEM_ADDR_HI\0" /* 26329, 26336 */
	"CP_WAIT_REG_MEM_TIMEOUT\0" /* 26348, 26351 */
	"CP_WAIT_SEM_ADDR_LO\0" /* 26372 */
	"CP_WAIT_SEM_ADDR_HI\0" /* 26392 */
	"CP_DMA_PFP_CONTROL\0" /* 26412 */
	"CP_DMA_ME_CONTROL\0" /* 26431 */
	"CP_COHER_BASE_HI\0" /* 26449 */
	"CP_COHER_START_DELAY\0" /* 26466 */
	"CP_COHER_CNTL\0" /* 26487 */
	"CP_COHER_SIZE\0" /* 26501 */
	"CP_COHER_BASE\0" /* 26515 */
	"CP_COHER_STATUS\0" /* 26529 */
	"CP_DMA_ME_SRC_ADDR\0" /* 26545, 26555 */
	"CP_DMA_ME_SRC_ADDR_HI\0" /* 26564, 26574 */
	"CP_DMA_ME_DST_ADDR\0" /* 26586, 26596 */
	"CP_DMA_ME_DST_ADDR_HI\0" /* 26605, 26615 */
	"CP_DMA_ME_COMMAND\0" /* 26627, 26637 */
	"CP_DMA_PFP_SRC_ADDR\0" /* 26645 */
	"CP_DMA_PFP_SRC_ADDR_HI\0" /* 26665 */
	"CP_DMA_PFP_DST_ADDR\0" /* 26688 */
	"CP_DMA_PFP_DST_ADDR_HI\0" /* 26708 */
	"CP_DMA_PFP_COMMAND\0" /* 26731 */
	"CP_DMA_CNTL\0" /* 26750 */
	"CP_DMA_READ_TAGS\0" /* 26762 */
	"CP_COHER_SIZE_HI\0" /* 26779 */
	"CP_PFP_IB_CONTROL\0" /* 26796, 26803 */
	"CP_PFP_LOAD_CONTROL\0" /* 26814 */
	"CP_SCRATCH_INDEX\0" /* 26834 */
	"CP_SCRATCH_DATA\0" /* 26851 */
	"CP_RB_OFFSET\0" /* 26867, 26870 */
	"CP_IB1_OFFSET\0" /* 26880, 26883 */
	"CP_IB2_OFFSET\0" /* 26894, 26897 */
	"CP_IB1_PREAMBLE_BEGIN\0" /* 26908, 26911 */
	"CP_IB1_PREAMBLE_END\0" /* 26930, 26933 */
	"CP_IB2_PREAMBLE_BEGIN\0" /* 26950, 26953 */
	"CP_IB2_PREAMBLE_END\0" /* 26972, 26975 */
	"CP_CE_IB1_OFFSET\0" /* 26992 */
	"CP_CE_IB2_OFFSET\0" /* 27009 */
	"CP_CE_COUNTER\0" /* 27026 */
	"CP_DMA_ME_CMD_ADDR_LO\0" /* 27040 */
	"CP_DMA_ME_CMD_ADDR_HI\0" /* 27062 */
	"CP_DMA_PFP_CMD_ADDR_LO\0" /* 27084 */
	"CP_DMA_PFP_CMD_ADDR_HI\0" /* 27107 */
	"CP_APPEND_CMD_ADDR_LO\0" /* 27130 */
	"CP_APPEND_CMD_ADDR_HI\0" /* 27152 */
	"CP_CE_INIT_CMD_BUFSZ\0" /* 27174 */
	"CP_CE_IB1_CMD_BUFSZ\0" /* 27195 */
	"CP_CE_IB2_CMD_BUFSZ\0" /* 27215 */
	"CP_IB1_CMD_BUFSZ\0" /* 27235 */
	"CP_IB2_CMD_BUFSZ\0" /* 27252 */
	"CP_ST_CMD_BUFSZ\0" /* 27269 */
	"CP_CE_INIT_BASE_LO\0" /* 27285, 27291 */
	"CP_CE_INIT_BASE_HI\0" /* 27304, 27310 */
	"CP_CE_INIT_BUFSZ\0" /* 27323, 27329 */
	"CP_CE_IB1_BASE_LO\0" /* 27340, 27346 */
	"CP_CE_IB1_BASE_HI\0" /* 27358, 27364 */
	"CP_CE_IB1_BUFSZ\0" /* 27376, 27382 */
	"CP_CE_IB2_BASE_LO\0" /* 27392, 27398 */
	"CP_CE_IB2_BASE_HI\0" /* 27410, 27416 */
	"CP_CE_IB2_BUFSZ\0" /* 27428, 27434 */
	"CP_IB1_BASE_LO\0" /* 27444 */
	"CP_IB1_BASE_HI\0" /* 27459 */
	"CP_IB1_BUFSZ\0" /* 27474 */
	"CP_IB2_BASE_LO\0" /* 27487 */
	"CP_IB2_BASE_HI\0" /* 27502 */
	"CP_IB2_BUFSZ\0" /* 27517 */
	"CP_ST_BASE_LO\0" /* 27530, 27533 */
	"CP_ST_BASE_HI\0" /* 27544, 27547 */
	"CP_ST_BUFSZ\0" /* 27558, 27561 */
	"CP_EOP_DONE_EVENT_CNTL\0" /* 27570 */
	"CP_EOP_DONE_DATA_CNTL\0" /* 27593 */
	"CP_EOP_DONE_CNTX_ID\0" /* 27615, 27627 */
	"CP_DB_BASE_LO\0" /* 27635, 27638 */
	"CP_DB_BASE_HI\0" /* 27649, 27652 */
	"CP_DB_BUFSZ\0" /* 27663, 27666 */
	"CP_DB_CMD_BUFSZ\0" /* 27675 */
	"CP_CE_DB_BASE_LO\0" /* 27691 */
	"CP_CE_DB_BASE_HI\0" /* 27708 */
	"CP_CE_DB_BUFSZ\0" /* 27725 */
	"CP_CE_DB_CMD_BUFSZ\0" /* 27740 */
	"CP_PFP_COMPLETION_STATUS\0" /* 27759 */
	"CP_CE_COMPLETION_STATUS\0" /* 27784 */
	"CP_PRED_NOT_VISIBLE\0" /* 27808, 27816 */
	"CP_PFP_METADATA_BASE_ADDR\0" /* 27828 */
	"CP_PFP_METADATA_BASE_ADDR_HI\0" /* 27854 */
	"CP_CE_METADATA_BASE_ADDR\0" /* 27883 */
	"CP_CE_METADATA_BASE_ADDR_HI\0" /* 27908 */
	"CP_DRAW_INDX_INDR_ADDR\0" /* 27936 */
	"CP_DRAW_INDX_INDR_ADDR_HI\0" /* 27959 */
	"CP_DISPATCH_INDR_ADDR\0" /* 27985 */
	"CP_DISPATCH_INDR_ADDR_HI\0" /* 28007 */
	"CP_INDEX_BASE_ADDR\0" /* 28032 */
	"CP_INDEX_BASE_ADDR_HI\0" /* 28051 */
	"CP_INDEX_TYPE\0" /* 28073 */
	"CP_GDS_BKUP_ADDR\0" /* 28087 */
	"CP_GDS_BKUP_ADDR_HI\0" /* 28104 */
	"CP_SAMPLE_STATUS\0" /* 28124 */
	"CP_ME_COHER_CNTL\0" /* 28141 */
	"CP_ME_COHER_SIZE\0" /* 28158 */
	"CP_ME_COHER_SIZE_HI\0" /* 28175 */
	"CP_ME_COHER_BASE\0" /* 28195 */
	"CP_ME_COHER_BASE_HI\0" /* 28212 */
	"CP_ME_COHER_STATUS\0" /* 28232 */
	"RLC_GPM_PERF_COUNT_0\0" /* 28251 */
	"RLC_GPM_PERF_COUNT_1\0" /* 28272 */
	"GRBM_GFX_INDEX\0" /* 28293 */
	"VGT_ESGS_RING_SIZE_UMD\0" /* 28308 */
	"VGT_GSVS_RING_SIZE_UMD\0" /* 28331 */
	"VGT_PRIMITIVE_TYPE\0" /* 28354 */
	"VGT_INDEX_TYPE\0" /* 28373 */
	"VGT_STRMOUT_BUFFER_FILLED_SIZE_0\0" /* 28388 */
	"VGT_STRMOUT_BUFFER_FILLED_SIZE_1\0" /* 28421 */
	"VGT_STRMOUT_BUFFER_FILLED_SIZE_2\0" /* 28454 */
	"VGT_STRMOUT_BUFFER_FILLED_SIZE_3\0" /* 28487 */
	"GE_MIN_VTX_INDX\0" /* 28520 */
	"GE_INDX_OFFSET\0" /* 28536 */
	"GE_MULTI_PRIM_IB_RESET_EN\0" /* 28551 */
	"VGT_NUM_INDICES\0" /* 28577, 28581 */
	"VGT_NUM_INSTANCES\0" /* 28593 */
	"VGT_TF_RING_SIZE_UMD\0" /* 28611 */
	"VGT_HS_OFFCHIP_PARAM_UMD\0" /* 28632 */
	"VGT_TF_MEMORY_BASE_UMD\0" /* 28657 */
	"GE_DMA_FIRST_INDEX\0" /* 28680, 28687 */
	"WD_POS_BUF_BASE\0" /* 28699 */
	"WD_POS_BUF_BASE_HI\0" /* 28715 */
	"WD_CNTL_SB_BUF_BASE\0" /* 28734 */
	"WD_CNTL_SB_BUF_BASE_HI\0" /* 28754 */
	"WD_INDEX_BUF_BASE\0" /* 28777 */
	"WD_INDEX_BUF_BASE_HI\0" /* 28795 */
	"IA_MULTI_VGT_PARAM_PIPED\0" /* 28816 */
	"GE_MAX_VTX_INDX\0" /* 28841 */
	"VGT_INSTANCE_BASE_ID\0" /* 28857, 28861, 28872 */
	"GE_CNTL\0" /* 28878 */
	"GE_USER_VGPR1\0" /* 28886 */
	"GE_USER_VGPR2\0" /* 28900 */
	"GE_USER_VGPR3\0" /* 28914 */
	"GE_STEREO_CNTL\0" /* 28928 */
	"GE_PC_ALLOC\0" /* 28943 */
	"VGT_TF_MEMORY_BASE_HI_UMD\0" /* 28955 */
	"GE_USER_VGPR_EN\0" /* 28981 */
	"PA_SU_LINE_STIPPLE_VALUE\0" /* 28997, 29003, 29016 */
	"PA_SC_LINE_STIPPLE_STATE\0" /* 29022 */
	"PA_SC_SCREEN_EXTENT_MIN_0\0" /* 29047 */
	"PA_SC_SCREEN_EXTENT_MAX_0\0" /* 29073 */
	"PA_SC_SCREEN_EXTENT_MIN_1\0" /* 29099 */
	"PA_SC_SCREEN_EXTENT_MAX_1\0" /* 29125 */
	"PA_SC_P3D_TRAP_SCREEN_HV_EN\0" /* 29151 */
	"PA_SC_P3D_TRAP_SCREEN_H\0" /* 29179 */
	"PA_SC_P3D_TRAP_SCREEN_V\0" /* 29203 */
	"PA_SC_P3D_TRAP_SCREEN_OCCURRENCE\0" /* 29227 */
	"PA_SC_P3D_TRAP_SCREEN_COUNT\0" /* 29260 */
	"PA_SC_HP3D_TRAP_SCREEN_HV_EN\0" /* 29288 */
	"PA_SC_HP3D_TRAP_SCREEN_H\0" /* 29317 */
	"PA_SC_HP3D_TRAP_SCREEN_V\0" /* 29342 */
	"PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE\0" /* 29367 */
	"PA_SC_HP3D_TRAP_SCREEN_COUNT\0" /* 29401 */
	"PA_SC_TRAP_SCREEN_HV_EN\0" /* 29430 */
	"PA_SC_TRAP_SCREEN_H\0" /* 29454 */
	"PA_SC_TRAP_SCREEN_V\0" /* 29474 */
	"PA_SC_TRAP_SCREEN_OCCURRENCE\0" /* 29494 */
	"PA_SC_TRAP_SCREEN_COUNT\0" /* 29523 */
	"SQ_THREAD_TRACE_USERDATA_0\0" /* 29547 */
	"SQ_THREAD_TRACE_USERDATA_1\0" /* 29574 */
	"SQ_THREAD_TRACE_USERDATA_2\0" /* 29601 */
	"SQ_THREAD_TRACE_USERDATA_3\0" /* 29628 */
	"SQ_THREAD_TRACE_USERDATA_4\0" /* 29655 */
	"SQ_THREAD_TRACE_USERDATA_5\0" /* 29682 */
	"SQ_THREAD_TRACE_USERDATA_6\0" /* 29709 */
	"SQ_THREAD_TRACE_USERDATA_7\0" /* 29736 */
	"SQC_CACHES\0" /* 29763 */
	"SQC_WRITEBACK\0" /* 29774, 29778 */
	"TA_CS_BC_BASE_ADDR\0" /* 29788 */
	"TA_CS_BC_BASE_ADDR_HI\0" /* 29807 */
	"DB_OCCLUSION_COUNT0_LOW\0" /* 29829 */
	"DB_OCCLUSION_COUNT0_HI\0" /* 29853 */
	"DB_OCCLUSION_COUNT1_LOW\0" /* 29876 */
	"DB_OCCLUSION_COUNT1_HI\0" /* 29900 */
	"DB_OCCLUSION_COUNT2_LOW\0" /* 29923 */
	"DB_OCCLUSION_COUNT2_HI\0" /* 29947 */
	"DB_OCCLUSION_COUNT3_LOW\0" /* 29970 */
	"DB_OCCLUSION_COUNT3_HI\0" /* 29994 */
	"DB_ZPASS_COUNT_LOW\0" /* 30017, 30026 */
	"DB_ZPASS_COUNT_HI\0" /* 30036 */
	"GDS_RD_ADDR\0" /* 30054 */
	"GDS_RD_DATA\0" /* 30066 */
	"GDS_RD_BURST_ADDR\0" /* 30078, 30085 */
	"GDS_RD_BURST_COUNT\0" /* 30096, 30103 */
	"GDS_RD_BURST_DATA\0" /* 30115, 30122 */
	"GDS_WR_ADDR\0" /* 30133 */
	"GDS_WR_DATA\0" /* 30145 */
	"GDS_WR_BURST_ADDR\0" /* 30157 */
	"GDS_WR_BURST_DATA\0" /* 30175 */
	"GDS_WRITE_COMPLETE\0" /* 30193, 30197, 30203 */
	"GDS_ATOM_CNTL\0" /* 30212 */
	"GDS_ATOM_COMPLETE\0" /* 30226 */
	"GDS_ATOM_BASE\0" /* 30244 */
	"GDS_ATOM_SIZE\0" /* 30258 */
	"GDS_ATOM_OFFSET0\0" /* 30272, 30281 */
	"GDS_ATOM_OFFSET1\0" /* 30289, 30298 */
	"GDS_ATOM_DST\0" /* 30306, 30315 */
	"GDS_ATOM_OP\0" /* 30319 */
	"GDS_ATOM_SRC0\0" /* 30331, 30340 */
	"GDS_ATOM_SRC0_U\0" /* 30345 */
	"GDS_ATOM_SRC1\0" /* 30361 */
	"GDS_ATOM_SRC1_U\0" /* 30375 */
	"GDS_ATOM_READ0\0" /* 30391 */
	"GDS_ATOM_READ0_U\0" /* 30406 */
	"GDS_ATOM_READ1\0" /* 30423 */
	"GDS_ATOM_READ1_U\0" /* 30438 */
	"GDS_GWS_RESOURCE_CNTL\0" /* 30455 */
	"GDS_GWS_RESOURCE\0" /* 30477, 30487 */
	"GDS_GWS_RESOURCE_CNT\0" /* 30494, 30502 */
	"GDS_OA_CNTL\0" /* 30515 */
	"GDS_OA_COUNTER\0" /* 30527 */
	"GDS_OA_ADDRESS\0" /* 30542, 30549 */
	"GDS_OA_INCDEC\0" /* 30557, 30564 */
	"GDS_OA_RING_SIZE\0" /* 30571 */
	"SPI_CONFIG_CNTL_REMAP\0" /* 30588 */
	"SPI_CONFIG_CNTL_1_REMAP\0" /* 30610 */
	"SPI_CONFIG_CNTL_2_REMAP\0" /* 30634 */
	"SPI_WAVE_LIMIT_CNTL_REMAP\0" /* 30658 */
	"CPG_PERFCOUNTER1_LO\0" /* 30684 */
	"CPG_PERFCOUNTER1_HI\0" /* 30704 */
	"CPG_PERFCOUNTER0_LO\0" /* 30724 */
	"CPG_PERFCOUNTER0_HI\0" /* 30744 */
	"CPC_PERFCOUNTER1_LO\0" /* 30764 */
	"CPC_PERFCOUNTER1_HI\0" /* 30784 */
	"CPC_PERFCOUNTER0_LO\0" /* 30804 */
	"CPC_PERFCOUNTER0_HI\0" /* 30824 */
	"CPF_PERFCOUNTER1_LO\0" /* 30844 */
	"CPF_PERFCOUNTER1_HI\0" /* 30864 */
	"CPF_PERFCOUNTER0_LO\0" /* 30884 */
	"CPF_PERFCOUNTER0_HI\0" /* 30904 */
	"CPF_LATENCY_STATS_DATA\0" /* 30924 */
	"CPG_LATENCY_STATS_DATA\0" /* 30947 */
	"CPC_LATENCY_STATS_DATA\0" /* 30970 */
	"GRBM_PERFCOUNTER0_LO\0" /* 30993 */
	"GRBM_PERFCOUNTER0_HI\0" /* 31014 */
	"GRBM_PERFCOUNTER1_LO\0" /* 31035 */
	"GRBM_PERFCOUNTER1_HI\0" /* 31056 */
	"GRBM_SE0_PERFCOUNTER_LO\0" /* 31077, 31086, 31090 */
	"GRBM_SE0_PERFCOUNTER_HI\0" /* 31101, 31110, 31114 */
	"GRBM_SE1_PERFCOUNTER_LO\0" /* 31125 */
	"GRBM_SE1_PERFCOUNTER_HI\0" /* 31149 */
	"GRBM_SE2_PERFCOUNTER_LO\0" /* 31173 */
	"GRBM_SE2_PERFCOUNTER_HI\0" /* 31197 */
	"GRBM_SE3_PERFCOUNTER_LO\0" /* 31221 */
	"GRBM_SE3_PERFCOUNTER_HI\0" /* 31245 */
	"GE_PERFCOUNTER0_LO\0" /* 31269 */
	"GE_PERFCOUNTER0_HI\0" /* 31288 */
	"GE_PERFCOUNTER1_LO\0" /* 31307 */
	"GE_PERFCOUNTER1_HI\0" /* 31326 */
	"GE_PERFCOUNTER2_LO\0" /* 31345 */
	"GE_PERFCOUNTER2_HI\0" /* 31364 */
	"GE_PERFCOUNTER3_LO\0" /* 31383 */
	"GE_PERFCOUNTER3_HI\0" /* 31402 */
	"GE_PERFCOUNTER4_LO\0" /* 31421 */
	"GE_PERFCOUNTER4_HI\0" /* 31440 */
	"GE_PERFCOUNTER5_LO\0" /* 31459 */
	"GE_PERFCOUNTER5_HI\0" /* 31478 */
	"GE_PERFCOUNTER6_LO\0" /* 31497 */
	"GE_PERFCOUNTER6_HI\0" /* 31516 */
	"GE_PERFCOUNTER7_LO\0" /* 31535 */
	"GE_PERFCOUNTER7_HI\0" /* 31554 */
	"GE_PERFCOUNTER8_LO\0" /* 31573 */
	"GE_PERFCOUNTER8_HI\0" /* 31592 */
	"GE_PERFCOUNTER9_LO\0" /* 31611 */
	"GE_PERFCOUNTER9_HI\0" /* 31630 */
	"GE_PERFCOUNTER10_LO\0" /* 31649 */
	"GE_PERFCOUNTER10_HI\0" /* 31669 */
	"GE_PERFCOUNTER11_LO\0" /* 31689 */
	"GE_PERFCOUNTER11_HI\0" /* 31709 */
	"PA_SU_PERFCOUNTER0_LO\0" /* 31729 */
	"PA_SU_PERFCOUNTER0_HI\0" /* 31751 */
	"PA_SU_PERFCOUNTER1_LO\0" /* 31773 */
	"PA_SU_PERFCOUNTER1_HI\0" /* 31795 */
	"PA_SU_PERFCOUNTER2_LO\0" /* 31817 */
	"PA_SU_PERFCOUNTER2_HI\0" /* 31839 */
	"PA_SU_PERFCOUNTER3_LO\0" /* 31861 */
	"PA_SU_PERFCOUNTER3_HI\0" /* 31883 */
	"PA_SC_PERFCOUNTER0_LO\0" /* 31905 */
	"PA_SC_PERFCOUNTER0_HI\0" /* 31927 */
	"PA_SC_PERFCOUNTER1_LO\0" /* 31949 */
	"PA_SC_PERFCOUNTER1_HI\0" /* 31971 */
	"PA_SC_PERFCOUNTER2_LO\0" /* 31993 */
	"PA_SC_PERFCOUNTER2_HI\0" /* 32015 */
	"PA_SC_PERFCOUNTER3_LO\0" /* 32037 */
	"PA_SC_PERFCOUNTER3_HI\0" /* 32059 */
	"PA_SC_PERFCOUNTER4_LO\0" /* 32081 */
	"PA_SC_PERFCOUNTER4_HI\0" /* 32103 */
	"PA_SC_PERFCOUNTER5_LO\0" /* 32125 */
	"PA_SC_PERFCOUNTER5_HI\0" /* 32147 */
	"PA_SC_PERFCOUNTER6_LO\0" /* 32169 */
	"PA_SC_PERFCOUNTER6_HI\0" /* 32191 */
	"PA_SC_PERFCOUNTER7_LO\0" /* 32213 */
	"PA_SC_PERFCOUNTER7_HI\0" /* 32235 */
	"SPI_PERFCOUNTER0_HI\0" /* 32257 */
	"SPI_PERFCOUNTER0_LO\0" /* 32277 */
	"SPI_PERFCOUNTER1_HI\0" /* 32297 */
	"SPI_PERFCOUNTER1_LO\0" /* 32317 */
	"SPI_PERFCOUNTER2_HI\0" /* 32337 */
	"SPI_PERFCOUNTER2_LO\0" /* 32357 */
	"SPI_PERFCOUNTER3_HI\0" /* 32377 */
	"SPI_PERFCOUNTER3_LO\0" /* 32397 */
	"SPI_PERFCOUNTER4_HI\0" /* 32417 */
	"SPI_PERFCOUNTER4_LO\0" /* 32437 */
	"SPI_PERFCOUNTER5_HI\0" /* 32457 */
	"SPI_PERFCOUNTER5_LO\0" /* 32477 */
	"SQ_PERFCOUNTER0_LO\0" /* 32497 */
	"SQ_PERFCOUNTER0_HI\0" /* 32516 */
	"SQ_PERFCOUNTER1_LO\0" /* 32535 */
	"SQ_PERFCOUNTER1_HI\0" /* 32554 */
	"SQ_PERFCOUNTER2_LO\0" /* 32573 */
	"SQ_PERFCOUNTER2_HI\0" /* 32592 */
	"SQ_PERFCOUNTER3_LO\0" /* 32611 */
	"SQ_PERFCOUNTER3_HI\0" /* 32630 */
	"SQ_PERFCOUNTER4_LO\0" /* 32649 */
	"SQ_PERFCOUNTER4_HI\0" /* 32668 */
	"SQ_PERFCOUNTER5_LO\0" /* 32687 */
	"SQ_PERFCOUNTER5_HI\0" /* 32706 */
	"SQ_PERFCOUNTER6_LO\0" /* 32725 */
	"SQ_PERFCOUNTER6_HI\0" /* 32744 */
	"SQ_PERFCOUNTER7_LO\0" /* 32763 */
	"SQ_PERFCOUNTER7_HI\0" /* 32782 */
	"SQ_PERFCOUNTER8_LO\0" /* 32801 */
	"SQ_PERFCOUNTER8_HI\0" /* 32820 */
	"SQ_PERFCOUNTER9_LO\0" /* 32839 */
	"SQ_PERFCOUNTER9_HI\0" /* 32858 */
	"SQ_PERFCOUNTER10_LO\0" /* 32877 */
	"SQ_PERFCOUNTER10_HI\0" /* 32897 */
	"SQ_PERFCOUNTER11_LO\0" /* 32917 */
	"SQ_PERFCOUNTER11_HI\0" /* 32937 */
	"SQ_PERFCOUNTER12_LO\0" /* 32957 */
	"SQ_PERFCOUNTER12_HI\0" /* 32977 */
	"SQ_PERFCOUNTER13_LO\0" /* 32997 */
	"SQ_PERFCOUNTER13_HI\0" /* 33017 */
	"SQ_PERFCOUNTER14_LO\0" /* 33037 */
	"SQ_PERFCOUNTER14_HI\0" /* 33057 */
	"SQ_PERFCOUNTER15_LO\0" /* 33077 */
	"SQ_PERFCOUNTER15_HI\0" /* 33097 */
	"SX_PERFCOUNTER0_LO\0" /* 33117 */
	"SX_PERFCOUNTER0_HI\0" /* 33136 */
	"SX_PERFCOUNTER1_LO\0" /* 33155 */
	"SX_PERFCOUNTER1_HI\0" /* 33174 */
	"SX_PERFCOUNTER2_LO\0" /* 33193 */
	"SX_PERFCOUNTER2_HI\0" /* 33212 */
	"SX_PERFCOUNTER3_LO\0" /* 33231 */
	"SX_PERFCOUNTER3_HI\0" /* 33250 */
	"GCEA_PERFCOUNTER2_LO\0" /* 33269 */
	"GCEA_PERFCOUNTER2_HI\0" /* 33290 */
	"GDS_PERFCOUNTER0_LO\0" /* 33311 */
	"GDS_PERFCOUNTER0_HI\0" /* 33331 */
	"GDS_PERFCOUNTER1_LO\0" /* 33351 */
	"GDS_PERFCOUNTER1_HI\0" /* 33371 */
	"GDS_PERFCOUNTER2_LO\0" /* 33391 */
	"GDS_PERFCOUNTER2_HI\0" /* 33411 */
	"GDS_PERFCOUNTER3_LO\0" /* 33431 */
	"GDS_PERFCOUNTER3_HI\0" /* 33451 */
	"TA_PERFCOUNTER0_LO\0" /* 33471 */
	"TA_PERFCOUNTER0_HI\0" /* 33490 */
	"TA_PERFCOUNTER1_LO\0" /* 33509 */
	"TA_PERFCOUNTER1_HI\0" /* 33528 */
	"TD_PERFCOUNTER0_LO\0" /* 33547 */
	"TD_PERFCOUNTER0_HI\0" /* 33566 */
	"TD_PERFCOUNTER1_LO\0" /* 33585 */
	"TD_PERFCOUNTER1_HI\0" /* 33604 */
	"TCP_PERFCOUNTER0_LO\0" /* 33623 */
	"TCP_PERFCOUNTER0_HI\0" /* 33643 */
	"TCP_PERFCOUNTER1_LO\0" /* 33663 */
	"TCP_PERFCOUNTER1_HI\0" /* 33683 */
	"TCP_PERFCOUNTER2_LO\0" /* 33703 */
	"TCP_PERFCOUNTER2_HI\0" /* 33723 */
	"TCP_PERFCOUNTER3_LO\0" /* 33743 */
	"TCP_PERFCOUNTER3_HI\0" /* 33763 */
	"GL2C_PERFCOUNTER0_LO\0" /* 33783 */
	"GL2C_PERFCOUNTER0_HI\0" /* 33804 */
	"GL2C_PERFCOUNTER1_LO\0" /* 33825 */
	"GL2C_PERFCOUNTER1_HI\0" /* 33846 */
	"GL2C_PERFCOUNTER2_LO\0" /* 33867 */
	"GL2C_PERFCOUNTER2_HI\0" /* 33888 */
	"GL2C_PERFCOUNTER3_LO\0" /* 33909 */
	"GL2C_PERFCOUNTER3_HI\0" /* 33930 */
	"GL2A_PERFCOUNTER0_LO\0" /* 33951 */
	"GL2A_PERFCOUNTER0_HI\0" /* 33972 */
	"GL2A_PERFCOUNTER1_LO\0" /* 33993 */
	"GL2A_PERFCOUNTER1_HI\0" /* 34014 */
	"GL2A_PERFCOUNTER2_LO\0" /* 34035 */
	"GL2A_PERFCOUNTER2_HI\0" /* 34056 */
	"GL2A_PERFCOUNTER3_LO\0" /* 34077 */
	"GL2A_PERFCOUNTER3_HI\0" /* 34098 */
	"GL1C_PERFCOUNTER0_LO\0" /* 34119 */
	"GL1C_PERFCOUNTER0_HI\0" /* 34140 */
	"GL1C_PERFCOUNTER1_LO\0" /* 34161 */
	"GL1C_PERFCOUNTER1_HI\0" /* 34182 */
	"GL1C_PERFCOUNTER2_LO\0" /* 34203 */
	"GL1C_PERFCOUNTER2_HI\0" /* 34224 */
	"GL1C_PERFCOUNTER3_LO\0" /* 34245 */
	"GL1C_PERFCOUNTER3_HI\0" /* 34266 */
	"CHC_PERFCOUNTER0_LO\0" /* 34287 */
	"CHC_PERFCOUNTER0_HI\0" /* 34307 */
	"CHC_PERFCOUNTER1_LO\0" /* 34327 */
	"CHC_PERFCOUNTER1_HI\0" /* 34347 */
	"CHC_PERFCOUNTER2_LO\0" /* 34367 */
	"CHC_PERFCOUNTER2_HI\0" /* 34387 */
	"CHC_PERFCOUNTER3_LO\0" /* 34407 */
	"CHC_PERFCOUNTER3_HI\0" /* 34427 */
	"CHCG_PERFCOUNTER0_LO\0" /* 34447 */
	"CHCG_PERFCOUNTER0_HI\0" /* 34468 */
	"CHCG_PERFCOUNTER1_LO\0" /* 34489 */
	"CHCG_PERFCOUNTER1_HI\0" /* 34510 */
	"CHCG_PERFCOUNTER2_LO\0" /* 34531 */
	"CHCG_PERFCOUNTER2_HI\0" /* 34552 */
	"CHCG_PERFCOUNTER3_LO\0" /* 34573 */
	"CHCG_PERFCOUNTER3_HI\0" /* 34594 */
	"CB_PERFCOUNTER0_LO\0" /* 34615 */
	"CB_PERFCOUNTER0_HI\0" /* 34634 */
	"CB_PERFCOUNTER1_LO\0" /* 34653 */
	"CB_PERFCOUNTER1_HI\0" /* 34672 */
	"CB_PERFCOUNTER2_LO\0" /* 34691 */
	"CB_PERFCOUNTER2_HI\0" /* 34710 */
	"CB_PERFCOUNTER3_LO\0" /* 34729 */
	"CB_PERFCOUNTER3_HI\0" /* 34748 */
	"DB_PERFCOUNTER0_LO\0" /* 34767 */
	"DB_PERFCOUNTER0_HI\0" /* 34786 */
	"DB_PERFCOUNTER1_LO\0" /* 34805 */
	"DB_PERFCOUNTER1_HI\0" /* 34824 */
	"DB_PERFCOUNTER2_LO\0" /* 34843 */
	"DB_PERFCOUNTER2_HI\0" /* 34862 */
	"DB_PERFCOUNTER3_LO\0" /* 34881 */
	"DB_PERFCOUNTER3_HI\0" /* 34900 */
	"RLC_PERFCOUNTER0_LO\0" /* 34919 */
	"RLC_PERFCOUNTER0_HI\0" /* 34939 */
	"RLC_PERFCOUNTER1_LO\0" /* 34959 */
	"RLC_PERFCOUNTER1_HI\0" /* 34979 */
	"RMI_PERFCOUNTER0_LO\0" /* 34999 */
	"RMI_PERFCOUNTER0_HI\0" /* 35019 */
	"RMI_PERFCOUNTER1_LO\0" /* 35039 */
	"RMI_PERFCOUNTER1_HI\0" /* 35059 */
	"RMI_PERFCOUNTER2_LO\0" /* 35079 */
	"RMI_PERFCOUNTER2_HI\0" /* 35099 */
	"RMI_PERFCOUNTER3_LO\0" /* 35119 */
	"RMI_PERFCOUNTER3_HI\0" /* 35139 */
	"GC_ATC_L2_PERFCOUNTER_LO\0" /* 35159, 35162 */
	"GC_ATC_L2_PERFCOUNTER_HI\0" /* 35184, 35187 */
	"GCMC_VM_L2_PERFCOUNTER_LO\0" /* 35209, 35211 */
	"GCMC_VM_L2_PERFCOUNTER_HI\0" /* 35235, 35237 */
	"GCVML2_PERFCOUNTER2_0_LO\0" /* 35261 */
	"GCVML2_PERFCOUNTER2_1_LO\0" /* 35286 */
	"GCVML2_PERFCOUNTER2_0_HI\0" /* 35311 */
	"GCVML2_PERFCOUNTER2_1_HI\0" /* 35336 */
	"GC_ATC_L2_PERFCOUNTER2_LO\0" /* 35361 */
	"GC_ATC_L2_PERFCOUNTER2_HI\0" /* 35387 */
	"UTCL1_PERFCOUNTER0_LO\0" /* 35413 */
	"UTCL1_PERFCOUNTER0_HI\0" /* 35435 */
	"UTCL1_PERFCOUNTER1_LO\0" /* 35457 */
	"UTCL1_PERFCOUNTER1_HI\0" /* 35479 */
	"GCR_PERFCOUNTER0_LO\0" /* 35501 */
	"GCR_PERFCOUNTER0_HI\0" /* 35521 */
	"GCR_PERFCOUNTER1_LO\0" /* 35541 */
	"GCR_PERFCOUNTER1_HI\0" /* 35561 */
	"PA_PH_PERFCOUNTER0_LO\0" /* 35581 */
	"PA_PH_PERFCOUNTER0_HI\0" /* 35603 */
	"PA_PH_PERFCOUNTER1_LO\0" /* 35625 */
	"PA_PH_PERFCOUNTER1_HI\0" /* 35647 */
	"PA_PH_PERFCOUNTER2_LO\0" /* 35669 */
	"PA_PH_PERFCOUNTER2_HI\0" /* 35691 */
	"PA_PH_PERFCOUNTER3_LO\0" /* 35713 */
	"PA_PH_PERFCOUNTER3_HI\0" /* 35735 */
	"PA_PH_PERFCOUNTER4_LO\0" /* 35757 */
	"PA_PH_PERFCOUNTER4_HI\0" /* 35779 */
	"PA_PH_PERFCOUNTER5_LO\0" /* 35801 */
	"PA_PH_PERFCOUNTER5_HI\0" /* 35823 */
	"PA_PH_PERFCOUNTER6_LO\0" /* 35845 */
	"PA_PH_PERFCOUNTER6_HI\0" /* 35867 */
	"PA_PH_PERFCOUNTER7_LO\0" /* 35889 */
	"PA_PH_PERFCOUNTER7_HI\0" /* 35911 */
	"GL1A_PERFCOUNTER0_LO\0" /* 35933 */
	"GL1A_PERFCOUNTER0_HI\0" /* 35954 */
	"GL1A_PERFCOUNTER1_LO\0" /* 35975 */
	"GL1A_PERFCOUNTER1_HI\0" /* 35996 */
	"GL1A_PERFCOUNTER2_LO\0" /* 36017 */
	"GL1A_PERFCOUNTER2_HI\0" /* 36038 */
	"GL1A_PERFCOUNTER3_LO\0" /* 36059 */
	"GL1A_PERFCOUNTER3_HI\0" /* 36080 */
	"CHA_PERFCOUNTER0_LO\0" /* 36101 */
	"CHA_PERFCOUNTER0_HI\0" /* 36121 */
	"CHA_PERFCOUNTER1_LO\0" /* 36141 */
	"CHA_PERFCOUNTER1_HI\0" /* 36161 */
	"CHA_PERFCOUNTER2_LO\0" /* 36181 */
	"CHA_PERFCOUNTER2_HI\0" /* 36201 */
	"CHA_PERFCOUNTER3_LO\0" /* 36221 */
	"CHA_PERFCOUNTER3_HI\0" /* 36241 */
	"GUS_PERFCOUNTER2_LO\0" /* 36261 */
	"GUS_PERFCOUNTER2_HI\0" /* 36281 */
	"CPG_PERFCOUNTER1_SELECT\0" /* 36301 */
	"CPG_PERFCOUNTER0_SELECT1\0" /* 36325 */
	"CPG_PERFCOUNTER0_SELECT\0" /* 36350 */
	"CPC_PERFCOUNTER1_SELECT\0" /* 36374 */
	"CPC_PERFCOUNTER0_SELECT1\0" /* 36398 */
	"CPF_PERFCOUNTER1_SELECT\0" /* 36423 */
	"CPF_PERFCOUNTER0_SELECT1\0" /* 36447 */
	"CPF_PERFCOUNTER0_SELECT\0" /* 36472 */
	"CP_PERFMON_CNTL\0" /* 36496 */
	"CPC_PERFCOUNTER0_SELECT\0" /* 36512 */
	"CPF_TC_PERF_COUNTER_WINDOW_SELECT\0" /* 36536 */
	"CPG_TC_PERF_COUNTER_WINDOW_SELECT\0" /* 36570 */
	"CPF_LATENCY_STATS_SELECT\0" /* 36604 */
	"CPG_LATENCY_STATS_SELECT\0" /* 36629 */
	"CPC_LATENCY_STATS_SELECT\0" /* 36654 */
	"CP_DRAW_OBJECT\0" /* 36679, 36687 */
	"CP_DRAW_OBJECT_COUNTER\0" /* 36694 */
	"CP_DRAW_WINDOW_MASK_HI\0" /* 36717, 36725 */
	"CP_DRAW_WINDOW_HI\0" /* 36740, 36748 */
	"CP_DRAW_WINDOW_LO\0" /* 36758 */
	"CP_DRAW_WINDOW_CNTL\0" /* 36776 */
	"GRBM_PERFCOUNTER0_SELECT\0" /* 36796 */
	"GRBM_PERFCOUNTER1_SELECT\0" /* 36821 */
	"GRBM_SE0_PERFCOUNTER_SELECT\0" /* 36846, 36855 */
	"GRBM_SE1_PERFCOUNTER_SELECT\0" /* 36874 */
	"GRBM_SE2_PERFCOUNTER_SELECT\0" /* 36902 */
	"GRBM_SE3_PERFCOUNTER_SELECT\0" /* 36930 */
	"GRBM_PERFCOUNTER0_SELECT_HI\0" /* 36958 */
	"GRBM_PERFCOUNTER1_SELECT_HI\0" /* 36986 */
	"GE_PERFCOUNTER0_SELECT\0" /* 37014 */
	"GE_PERFCOUNTER0_SELECT1\0" /* 37037 */
	"GE_PERFCOUNTER1_SELECT\0" /* 37061 */
	"GE_PERFCOUNTER1_SELECT1\0" /* 37084 */
	"GE_PERFCOUNTER2_SELECT\0" /* 37108 */
	"GE_PERFCOUNTER2_SELECT1\0" /* 37131 */
	"GE_PERFCOUNTER3_SELECT\0" /* 37155 */
	"GE_PERFCOUNTER3_SELECT1\0" /* 37178 */
	"GE_PERFCOUNTER4_SELECT\0" /* 37202 */
	"GE_PERFCOUNTER5_SELECT\0" /* 37225 */
	"GE_PERFCOUNTER6_SELECT\0" /* 37248 */
	"GE_PERFCOUNTER7_SELECT\0" /* 37271 */
	"GE_PERFCOUNTER8_SELECT\0" /* 37294 */
	"GE_PERFCOUNTER9_SELECT\0" /* 37317 */
	"GE_PERFCOUNTER10_SELECT\0" /* 37340 */
	"GE_PERFCOUNTER11_SELECT\0" /* 37364 */
	"PA_SU_PERFCOUNTER0_SELECT\0" /* 37388 */
	"PA_SU_PERFCOUNTER0_SELECT1\0" /* 37414 */
	"PA_SU_PERFCOUNTER1_SELECT\0" /* 37441 */
	"PA_SU_PERFCOUNTER1_SELECT1\0" /* 37467 */
	"PA_SU_PERFCOUNTER2_SELECT\0" /* 37494 */
	"PA_SU_PERFCOUNTER2_SELECT1\0" /* 37520 */
	"PA_SU_PERFCOUNTER3_SELECT\0" /* 37547 */
	"PA_SU_PERFCOUNTER3_SELECT1\0" /* 37573 */
	"PA_SC_PERFCOUNTER0_SELECT\0" /* 37600 */
	"PA_SC_PERFCOUNTER0_SELECT1\0" /* 37626 */
	"PA_SC_PERFCOUNTER1_SELECT\0" /* 37653 */
	"PA_SC_PERFCOUNTER2_SELECT\0" /* 37679 */
	"PA_SC_PERFCOUNTER3_SELECT\0" /* 37705 */
	"PA_SC_PERFCOUNTER4_SELECT\0" /* 37731 */
	"PA_SC_PERFCOUNTER5_SELECT\0" /* 37757 */
	"PA_SC_PERFCOUNTER6_SELECT\0" /* 37783 */
	"PA_SC_PERFCOUNTER7_SELECT\0" /* 37809 */
	"SPI_PERFCOUNTER0_SELECT\0" /* 37835 */
	"SPI_PERFCOUNTER1_SELECT\0" /* 37859 */
	"SPI_PERFCOUNTER2_SELECT\0" /* 37883 */
	"SPI_PERFCOUNTER3_SELECT\0" /* 37907 */
	"SPI_PERFCOUNTER0_SELECT1\0" /* 37931 */
	"SPI_PERFCOUNTER1_SELECT1\0" /* 37956 */
	"SPI_PERFCOUNTER2_SELECT1\0" /* 37981 */
	"SPI_PERFCOUNTER3_SELECT1\0" /* 38006 */
	"SPI_PERFCOUNTER4_SELECT\0" /* 38031 */
	"SPI_PERFCOUNTER5_SELECT\0" /* 38055 */
	"SPI_PERFCOUNTER_BINS\0" /* 38079 */
	"SQ_PERFCOUNTER0_SELECT\0" /* 38100 */
	"SQ_PERFCOUNTER1_SELECT\0" /* 38123 */
	"SQ_PERFCOUNTER2_SELECT\0" /* 38146 */
	"SQ_PERFCOUNTER3_SELECT\0" /* 38169 */
	"SQ_PERFCOUNTER4_SELECT\0" /* 38192 */
	"SQ_PERFCOUNTER5_SELECT\0" /* 38215 */
	"SQ_PERFCOUNTER6_SELECT\0" /* 38238 */
	"SQ_PERFCOUNTER7_SELECT\0" /* 38261 */
	"SQ_PERFCOUNTER8_SELECT\0" /* 38284 */
	"SQ_PERFCOUNTER9_SELECT\0" /* 38307 */
	"SQ_PERFCOUNTER10_SELECT\0" /* 38330 */
	"SQ_PERFCOUNTER11_SELECT\0" /* 38354 */
	"SQ_PERFCOUNTER12_SELECT\0" /* 38378 */
	"SQ_PERFCOUNTER13_SELECT\0" /* 38402 */
	"SQ_PERFCOUNTER14_SELECT\0" /* 38426 */
	"SQ_PERFCOUNTER15_SELECT\0" /* 38450 */
	"SQ_PERFCOUNTER_CTRL\0" /* 38474 */
	"SQ_PERFCOUNTER_CTRL2\0" /* 38494 */
	"GCEA_PERFCOUNTER2_SELECT\0" /* 38515 */
	"GCEA_PERFCOUNTER2_SELECT1\0" /* 38540 */
	"GCEA_PERFCOUNTER2_MODE\0" /* 38566 */
	"SX_PERFCOUNTER0_SELECT\0" /* 38589 */
	"SX_PERFCOUNTER1_SELECT\0" /* 38612 */
	"SX_PERFCOUNTER2_SELECT\0" /* 38635 */
	"SX_PERFCOUNTER3_SELECT\0" /* 38658 */
	"SX_PERFCOUNTER0_SELECT1\0" /* 38681 */
	"SX_PERFCOUNTER1_SELECT1\0" /* 38705 */
	"GDS_PERFCOUNTER0_SELECT\0" /* 38729 */
	"GDS_PERFCOUNTER1_SELECT\0" /* 38753 */
	"GDS_PERFCOUNTER2_SELECT\0" /* 38777 */
	"GDS_PERFCOUNTER3_SELECT\0" /* 38801 */
	"GDS_PERFCOUNTER0_SELECT1\0" /* 38825 */
	"TA_PERFCOUNTER0_SELECT\0" /* 38850 */
	"TA_PERFCOUNTER0_SELECT1\0" /* 38873 */
	"TA_PERFCOUNTER1_SELECT\0" /* 38897 */
	"TD_PERFCOUNTER0_SELECT\0" /* 38920 */
	"TD_PERFCOUNTER0_SELECT1\0" /* 38943 */
	"TD_PERFCOUNTER1_SELECT\0" /* 38967 */
	"TCP_PERFCOUNTER0_SELECT\0" /* 38990 */
	"TCP_PERFCOUNTER0_SELECT1\0" /* 39014 */
	"TCP_PERFCOUNTER1_SELECT\0" /* 39039 */
	"TCP_PERFCOUNTER1_SELECT1\0" /* 39063 */
	"TCP_PERFCOUNTER2_SELECT\0" /* 39088 */
	"TCP_PERFCOUNTER3_SELECT\0" /* 39112 */
	"GL2C_PERFCOUNTER0_SELECT\0" /* 39136 */
	"GL2C_PERFCOUNTER0_SELECT1\0" /* 39161 */
	"GL2C_PERFCOUNTER1_SELECT\0" /* 39187 */
	"GL2C_PERFCOUNTER1_SELECT1\0" /* 39212 */
	"GL2C_PERFCOUNTER2_SELECT\0" /* 39238 */
	"GL2C_PERFCOUNTER3_SELECT\0" /* 39263 */
	"GL2A_PERFCOUNTER0_SELECT\0" /* 39288 */
	"GL2A_PERFCOUNTER0_SELECT1\0" /* 39313 */
	"GL2A_PERFCOUNTER1_SELECT\0" /* 39339 */
	"GL2A_PERFCOUNTER1_SELECT1\0" /* 39364 */
	"GL2A_PERFCOUNTER2_SELECT\0" /* 39390 */
	"GL2A_PERFCOUNTER3_SELECT\0" /* 39415 */
	"GL1C_PERFCOUNTER0_SELECT\0" /* 39440 */
	"GL1C_PERFCOUNTER0_SELECT1\0" /* 39465 */
	"GL1C_PERFCOUNTER1_SELECT\0" /* 39491 */
	"GL1C_PERFCOUNTER2_SELECT\0" /* 39516 */
	"GL1C_PERFCOUNTER3_SELECT\0" /* 39541 */
	"CHC_PERFCOUNTER0_SELECT\0" /* 39566 */
	"CHC_PERFCOUNTER0_SELECT1\0" /* 39590 */
	"CHC_PERFCOUNTER1_SELECT\0" /* 39615 */
	"CHC_PERFCOUNTER2_SELECT\0" /* 39639 */
	"CHC_PERFCOUNTER3_SELECT\0" /* 39663 */
	"CHCG_PERFCOUNTER0_SELECT\0" /* 39687 */
	"CHCG_PERFCOUNTER0_SELECT1\0" /* 39712 */
	"CHCG_PERFCOUNTER1_SELECT\0" /* 39738 */
	"CHCG_PERFCOUNTER2_SELECT\0" /* 39763 */
	"CHCG_PERFCOUNTER3_SELECT\0" /* 39788 */
	"CB_PERFCOUNTER_FILTER\0" /* 39813 */
	"CB_PERFCOUNTER0_SELECT\0" /* 39835 */
	"CB_PERFCOUNTER0_SELECT1\0" /* 39858 */
	"CB_PERFCOUNTER1_SELECT\0" /* 39882 */
	"CB_PERFCOUNTER2_SELECT\0" /* 39905 */
	"CB_PERFCOUNTER3_SELECT\0" /* 39928 */
	"DB_PERFCOUNTER0_SELECT\0" /* 39951 */
	"DB_PERFCOUNTER0_SELECT1\0" /* 39974 */
	"DB_PERFCOUNTER1_SELECT\0" /* 39998 */
	"DB_PERFCOUNTER1_SELECT1\0" /* 40021 */
	"DB_PERFCOUNTER2_SELECT\0" /* 40045 */
	"DB_PERFCOUNTER3_SELECT\0" /* 40068 */
	"RLC_SPM_PERFMON_CNTL\0" /* 40091 */
	"RLC_SPM_PERFMON_RING_BASE_LO\0" /* 40112, 40128 */
	"RLC_SPM_PERFMON_RING_BASE_HI\0" /* 40141, 40157 */
	"RLC_SPM_PERFMON_RING_SIZE\0" /* 40170 */
	"RLC_SPM_PERFMON_SEGMENT_SIZE\0" /* 40196, 40204 */
	"RLC_SPM_RING_RDPTR\0" /* 40225 */
	"RLC_SPM_SEGMENT_THRESHOLD\0" /* 40244 */
	"RLC_SPM_SE_MUXSEL_ADDR\0" /* 40270 */
	"RLC_SPM_SE_MUXSEL_DATA\0" /* 40293 */
	"RLC_SPM_GLOBAL_MUXSEL_ADDR\0" /* 40316 */
	"RLC_SPM_GLOBAL_MUXSEL_DATA\0" /* 40343 */
	"RLC_SPM_DESER_START_SKEW\0" /* 40370, 40378 */
	"RLC_SPM_GLOBALS_SAMPLE_SKEW\0" /* 40395, 40403 */
	"RLC_SPM_GLOBALS_MUXSEL_SKEW\0" /* 40423, 40431 */
	"RLC_SPM_SE_SAMPLE_SKEW\0" /* 40451, 40459 */
	"RLC_SPM_SE_MUXSEL_SKEW\0" /* 40474, 40482 */
	"RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR\0" /* 40497 */
	"RLC_SPM_GLB_SAMPLEDELAY_IND_DATA\0" /* 40530 */
	"RLC_SPM_SE_SAMPLEDELAY_IND_ADDR\0" /* 40563 */
	"RLC_SPM_SE_SAMPLEDELAY_IND_DATA\0" /* 40595 */
	"RLC_SPM_RING_WRPTR\0" /* 40627 */
	"RLC_SPM_ACCUM_DATARAM_ADDR\0" /* 40646 */
	"RLC_SPM_ACCUM_DATARAM_DATA\0" /* 40673 */
	"RLC_SPM_ACCUM_CTRLRAM_ADDR\0" /* 40700 */
	"RLC_SPM_ACCUM_CTRLRAM_DATA\0" /* 40727 */
	"RLC_SPM_ACCUM_STATUS\0" /* 40754 */
	"RLC_SPM_ACCUM_CTRL\0" /* 40775 */
	"RLC_SPM_ACCUM_MODE\0" /* 40794 */
	"RLC_SPM_ACCUM_THRESHOLD\0" /* 40813 */
	"RLC_SPM_ACCUM_SAMPLES_REQUESTED\0" /* 40837 */
	"RLC_SPM_ACCUM_DATARAM_WRCOUNT\0" /* 40869 */
	"RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE\0" /* 40899 */
	"RLC_SPM_PERFMON_GLB_SEGMENT_SIZE\0" /* 40935 */
	"RLC_SPM_VIRT_CTRL\0" /* 40968 */
	"RLC_SPM_VIRT_STATUS\0" /* 40986 */
	"RLC_PERFMON_CNTL\0" /* 41006 */
	"RLC_PERFCOUNTER0_SELECT\0" /* 41023 */
	"RLC_PERFCOUNTER1_SELECT\0" /* 41047 */
	"RLC_GPU_IOV_PERF_CNT_CNTL\0" /* 41071 */
	"RLC_GPU_IOV_PERF_CNT_WR_ADDR\0" /* 41097 */
	"RLC_GPU_IOV_PERF_CNT_WR_DATA\0" /* 41126 */
	"RLC_GPU_IOV_PERF_CNT_RD_ADDR\0" /* 41155 */
	"RLC_GPU_IOV_PERF_CNT_RD_DATA\0" /* 41184 */
	"RLC_PERFMON_CLK_CNTL\0" /* 41213 */
	"RLC_PERFMON_CLK_CNTL_UCODE\0" /* 41234 */
	"RMI_PERFCOUNTER0_SELECT\0" /* 41261 */
	"RMI_PERFCOUNTER0_SELECT1\0" /* 41285 */
	"RMI_PERFCOUNTER1_SELECT\0" /* 41310 */
	"RMI_PERFCOUNTER2_SELECT\0" /* 41334 */
	"RMI_PERFCOUNTER2_SELECT1\0" /* 41358 */
	"RMI_PERFCOUNTER3_SELECT\0" /* 41383 */
	"RMI_PERF_COUNTER_CNTL\0" /* 41407 */
	"GC_ATC_L2_PERFCOUNTER0_CFG\0" /* 41429, 41432 */
	"GC_ATC_L2_PERFCOUNTER1_CFG\0" /* 41456, 41459 */
	"GC_ATC_L2_PERFCOUNTER_RSLT_CNTL\0" /* 41483, 41486 */
	"GCMC_VM_L2_PERFCOUNTER0_CFG\0" /* 41515, 41517 */
	"GCMC_VM_L2_PERFCOUNTER1_CFG\0" /* 41543, 41545 */
	"GCMC_VM_L2_PERFCOUNTER2_CFG\0" /* 41571, 41573 */
	"GCMC_VM_L2_PERFCOUNTER3_CFG\0" /* 41599, 41601 */
	"GCMC_VM_L2_PERFCOUNTER4_CFG\0" /* 41627, 41629 */
	"GCMC_VM_L2_PERFCOUNTER5_CFG\0" /* 41655, 41657 */
	"GCMC_VM_L2_PERFCOUNTER6_CFG\0" /* 41683, 41685 */
	"GCMC_VM_L2_PERFCOUNTER7_CFG\0" /* 41711, 41713 */
	"GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL\0" /* 41739, 41741 */
	"GCVML2_PERFCOUNTER2_0_SELECT\0" /* 41772 */
	"GCVML2_PERFCOUNTER2_1_SELECT\0" /* 41801 */
	"GCVML2_PERFCOUNTER2_0_SELECT1\0" /* 41830 */
	"GCVML2_PERFCOUNTER2_1_SELECT1\0" /* 41860 */
	"GCVML2_PERFCOUNTER2_0_MODE\0" /* 41890 */
	"GCVML2_PERFCOUNTER2_1_MODE\0" /* 41917 */
	"GC_ATC_L2_PERFCOUNTER2_SELECT\0" /* 41944 */
	"GC_ATC_L2_PERFCOUNTER2_SELECT1\0" /* 41974 */
	"GC_ATC_L2_PERFCOUNTER2_MODE\0" /* 42005 */
	"GCR_PERFCOUNTER0_SELECT\0" /* 42033 */
	"GCR_PERFCOUNTER0_SELECT1\0" /* 42057 */
	"GCR_PERFCOUNTER1_SELECT\0" /* 42082 */
	"UTCL1_PERFCOUNTER0_SELECT\0" /* 42106 */
	"UTCL1_PERFCOUNTER1_SELECT\0" /* 42132 */
	"PA_PH_PERFCOUNTER0_SELECT\0" /* 42158 */
	"PA_PH_PERFCOUNTER0_SELECT1\0" /* 42184 */
	"PA_PH_PERFCOUNTER1_SELECT\0" /* 42211 */
	"PA_PH_PERFCOUNTER2_SELECT\0" /* 42237 */
	"PA_PH_PERFCOUNTER3_SELECT\0" /* 42263 */
	"PA_PH_PERFCOUNTER4_SELECT\0" /* 42289 */
	"PA_PH_PERFCOUNTER5_SELECT\0" /* 42315 */
	"PA_PH_PERFCOUNTER6_SELECT\0" /* 42341 */
	"PA_PH_PERFCOUNTER7_SELECT\0" /* 42367 */
	"PA_PH_PERFCOUNTER1_SELECT1\0" /* 42393 */
	"PA_PH_PERFCOUNTER2_SELECT1\0" /* 42420 */
	"PA_PH_PERFCOUNTER3_SELECT1\0" /* 42447 */
	"GL1A_PERFCOUNTER0_SELECT\0" /* 42474 */
	"GL1A_PERFCOUNTER0_SELECT1\0" /* 42499 */
	"GL1A_PERFCOUNTER1_SELECT\0" /* 42525 */
	"GL1A_PERFCOUNTER2_SELECT\0" /* 42550 */
	"GL1A_PERFCOUNTER3_SELECT\0" /* 42575 */
	"CHA_PERFCOUNTER0_SELECT\0" /* 42600 */
	"CHA_PERFCOUNTER0_SELECT1\0" /* 42624 */
	"CHA_PERFCOUNTER1_SELECT\0" /* 42649 */
	"CHA_PERFCOUNTER2_SELECT\0" /* 42673 */
	"CHA_PERFCOUNTER3_SELECT\0" /* 42697 */
	"GUS_PERFCOUNTER2_SELECT\0" /* 42721 */
	"GUS_PERFCOUNTER2_SELECT1\0" /* 42745 */
	"GUS_PERFCOUNTER2_MODE\0" /* 42770 */
	"DST_ADDR_LO\0" /* 42792 */
	"IB_BASE_LO\0" /* 42804 */
	"IB_BASE_HI\0" /* 42815 */
	"CP_DMA_WORD0\0" /* 42826 */
	"CP_DMA_WORD1\0" /* 42839 */
	"CP_DMA_WORD2\0" /* 42852 */
	"CP_DMA_WORD3\0" /* 42865 */
	"RELEASE_MEM_OP\0" /* 42878 */
	"DMA_DATA_WORD0\0" /* 42893 */
	"SRC_ADDR_LO\0" /* 42908 */
	"GCR_CNTL\0" /* 42920 */
	"SQ_WAVE_ACTIVE\0" /* 42929 */
	"SQ_WAVE_VALID_AND_IDLE\0" /* 42944, 42962 */
	"SQ_WAVE_SHADER_CYCLES\0" /* 42967, 42982 */
	"CP_CPC_PRIV_VIOLATION_ADDR\0" /* 42989, 42996 */
	"SQ_THREAD_TRACE_STATUS2\0" /* 43016 */
	"SH_RESERVED_REG0\0" /* 43040 */
	"SH_RESERVED_REG1\0" /* 43057 */
	"DB_VRS_OVERRIDE_CNTL\0" /* 43074 */
	"CONTEXT_RESERVED_REG0\0" /* 43095 */
	"CONTEXT_RESERVED_REG1\0" /* 43117 */
	"SX_PS_DOWNCONVERT_CONTROL\0" /* 43139 */
	"PA_CL_VRS_CNTL\0" /* 43165 */
	"SCRATCH_REG_ATOMIC\0" /* 43180 */
	"UCONFIG_RESERVED_REG0\0" /* 43199 */
	"UCONFIG_RESERVED_REG1\0" /* 43221 */
	"CP_CE_ATOMIC_PREOP_LO\0" /* 43243 */
	"CP_CE_ATOMIC_PREOP_HI\0" /* 43265 */
	"CP_CE_GDS_ATOMIC0_PREOP_LO\0" /* 43287 */
	"CP_CE_GDS_ATOMIC0_PREOP_HI\0" /* 43314 */
	"CP_CE_GDS_ATOMIC1_PREOP_LO\0" /* 43341 */
	"CP_CE_GDS_ATOMIC1_PREOP_HI\0" /* 43368 */
	"GE1_PERFCOUNTER0_LO\0" /* 43395 */
	"GE1_PERFCOUNTER0_HI\0" /* 43415 */
	"GE1_PERFCOUNTER1_LO\0" /* 43435 */
	"GE1_PERFCOUNTER1_HI\0" /* 43455 */
	"GE1_PERFCOUNTER2_LO\0" /* 43475 */
	"GE1_PERFCOUNTER2_HI\0" /* 43495 */
	"GE1_PERFCOUNTER3_LO\0" /* 43515 */
	"GE1_PERFCOUNTER3_HI\0" /* 43535 */
	"GE2_DIST_PERFCOUNTER0_LO\0" /* 43555 */
	"GE2_DIST_PERFCOUNTER0_HI\0" /* 43580 */
	"GE2_DIST_PERFCOUNTER1_LO\0" /* 43605 */
	"GE2_DIST_PERFCOUNTER1_HI\0" /* 43630 */
	"GE2_DIST_PERFCOUNTER2_LO\0" /* 43655 */
	"GE2_DIST_PERFCOUNTER2_HI\0" /* 43680 */
	"GE2_DIST_PERFCOUNTER3_LO\0" /* 43705 */
	"GE2_DIST_PERFCOUNTER3_HI\0" /* 43730 */
	"GE2_SE_PERFCOUNTER0_LO\0" /* 43755 */
	"GE2_SE_PERFCOUNTER0_HI\0" /* 43778 */
	"GE2_SE_PERFCOUNTER1_LO\0" /* 43801 */
	"GE2_SE_PERFCOUNTER1_HI\0" /* 43824 */
	"GE2_SE_PERFCOUNTER2_LO\0" /* 43847 */
	"GE2_SE_PERFCOUNTER2_HI\0" /* 43870 */
	"GE2_SE_PERFCOUNTER3_LO\0" /* 43893 */
	"GE2_SE_PERFCOUNTER3_HI\0" /* 43916 */
	"GCEA_PERFCOUNTER_LO\0" /* 43939 */
	"GCEA_PERFCOUNTER_HI\0" /* 43959 */
	"GCUTCL2_PERFCOUNTER_LO\0" /* 43979 */
	"GCUTCL2_PERFCOUNTER_HI\0" /* 44002 */
	"GUS_PERFCOUNTER_LO\0" /* 44025 */
	"GUS_PERFCOUNTER_HI\0" /* 44044 */
	"SDMA0_PERFCNT_PERFCOUNTER_LO\0" /* 44063 */
	"SDMA0_PERFCNT_PERFCOUNTER_HI\0" /* 44092 */
	"SDMA0_PERFCOUNTER0_LO\0" /* 44121 */
	"SDMA0_PERFCOUNTER0_HI\0" /* 44143 */
	"SDMA0_PERFCOUNTER1_LO\0" /* 44165 */
	"SDMA0_PERFCOUNTER1_HI\0" /* 44187 */
	"SDMA1_PERFCNT_PERFCOUNTER_LO\0" /* 44209 */
	"SDMA1_PERFCNT_PERFCOUNTER_HI\0" /* 44238 */
	"SDMA1_PERFCOUNTER0_LO\0" /* 44267 */
	"SDMA1_PERFCOUNTER0_HI\0" /* 44289 */
	"SDMA1_PERFCOUNTER1_LO\0" /* 44311 */
	"SDMA1_PERFCOUNTER1_HI\0" /* 44333 */
	"SDMA2_PERFCNT_PERFCOUNTER_LO\0" /* 44355 */
	"SDMA2_PERFCNT_PERFCOUNTER_HI\0" /* 44384 */
	"SDMA2_PERFCOUNTER0_LO\0" /* 44413 */
	"SDMA2_PERFCOUNTER0_HI\0" /* 44435 */
	"SDMA2_PERFCOUNTER1_LO\0" /* 44457 */
	"SDMA2_PERFCOUNTER1_HI\0" /* 44479 */
	"SDMA3_PERFCNT_PERFCOUNTER_LO\0" /* 44501 */
	"SDMA3_PERFCNT_PERFCOUNTER_HI\0" /* 44530 */
	"SDMA3_PERFCOUNTER0_LO\0" /* 44559 */
	"SDMA3_PERFCOUNTER0_HI\0" /* 44581 */
	"SDMA3_PERFCOUNTER1_LO\0" /* 44603 */
	"SDMA3_PERFCOUNTER1_HI\0" /* 44625 */
	"GE1_PERFCOUNTER0_SELECT\0" /* 44647 */
	"GE1_PERFCOUNTER0_SELECT1\0" /* 44671 */
	"GE1_PERFCOUNTER1_SELECT\0" /* 44696 */
	"GE1_PERFCOUNTER1_SELECT1\0" /* 44720 */
	"GE1_PERFCOUNTER2_SELECT\0" /* 44745 */
	"GE1_PERFCOUNTER2_SELECT1\0" /* 44769 */
	"GE1_PERFCOUNTER3_SELECT\0" /* 44794 */
	"GE1_PERFCOUNTER3_SELECT1\0" /* 44818 */
	"GE2_DIST_PERFCOUNTER0_SELECT\0" /* 44843 */
	"GE2_DIST_PERFCOUNTER0_SELECT1\0" /* 44872 */
	"GE2_DIST_PERFCOUNTER1_SELECT\0" /* 44902 */
	"GE2_DIST_PERFCOUNTER1_SELECT1\0" /* 44931 */
	"GE2_DIST_PERFCOUNTER2_SELECT\0" /* 44961 */
	"GE2_DIST_PERFCOUNTER2_SELECT1\0" /* 44990 */
	"GE2_DIST_PERFCOUNTER3_SELECT\0" /* 45020 */
	"GE2_DIST_PERFCOUNTER3_SELECT1\0" /* 45049 */
	"GE2_SE_PERFCOUNTER0_SELECT\0" /* 45079 */
	"GE2_SE_PERFCOUNTER0_SELECT1\0" /* 45106 */
	"GE2_SE_PERFCOUNTER1_SELECT\0" /* 45134 */
	"GE2_SE_PERFCOUNTER1_SELECT1\0" /* 45161 */
	"GE2_SE_PERFCOUNTER2_SELECT\0" /* 45189 */
	"GE2_SE_PERFCOUNTER2_SELECT1\0" /* 45216 */
	"GE2_SE_PERFCOUNTER3_SELECT\0" /* 45244 */
	"GE2_SE_PERFCOUNTER3_SELECT1\0" /* 45271 */
	"GCEA_PERFCOUNTER0_CFG\0" /* 45299 */
	"GCEA_PERFCOUNTER1_CFG\0" /* 45321 */
	"GCEA_PERFCOUNTER_RSLT_CNTL\0" /* 45343 */
	"GDS_PERFCOUNTER1_SELECT1\0" /* 45370 */
	"GDS_PERFCOUNTER2_SELECT1\0" /* 45395 */
	"GDS_PERFCOUNTER3_SELECT1\0" /* 45420 */
	"RLC_SPM_PERFMON_SWA_SEGMENT_SIZE\0" /* 45445 */
	"RLC_SPM_GFXCLOCK_HIGHCOUNT\0" /* 45478, 45486 */
	"RLC_SPM_GFXCLOCK_LOWCOUNT\0" /* 45505, 45513 */
	"RLC_SPM_PERFMON_SWA_SE3TO0_SEGMENT_SIZE\0" /* 45531 */
	"RLC_SPM_GLOBAL_MUXSEL_ADDR_OFFSET\0" /* 45571 */
	"RLC_SPM_SE_MUXSEL_ADDR_OFFSET\0" /* 45605 */
	"RLC_SPM_ACCUM_SWA_DATARAM_ADDR\0" /* 45635 */
	"RLC_SPM_ACCUM_SWA_DATARAM_DATA\0" /* 45666 */
	"RLC_SPM_ACCUM_CTRLRAM_ADDR_OFFSET\0" /* 45697 */
	"RLC_SPM_PERFMON_SWA_GLB_SEGMENT_SIZE\0" /* 45731 */
	"RLC_SPM_ACCUM_DATARAM_32BITCNTRS_REGIONS\0" /* 45768 */
	"GCUTCL2_PERFCOUNTER0_CFG\0" /* 45809 */
	"GCUTCL2_PERFCOUNTER1_CFG\0" /* 45834 */
	"GCUTCL2_PERFCOUNTER2_CFG\0" /* 45859 */
	"GCUTCL2_PERFCOUNTER3_CFG\0" /* 45884 */
	"GCUTCL2_PERFCOUNTER_RSLT_CNTL\0" /* 45909 */
	"GUS_PERFCOUNTER0_CFG\0" /* 45939 */
	"GUS_PERFCOUNTER1_CFG\0" /* 45960 */
	"GUS_PERFCOUNTER_RSLT_CNTL\0" /* 45981 */
	"SDMA0_PERFCNT_PERFCOUNTER0_CFG\0" /* 46007 */
	"SDMA0_PERFCNT_PERFCOUNTER1_CFG\0" /* 46038 */
	"SDMA0_PERFCNT_PERFCOUNTER_RSLT_CNTL\0" /* 46069 */
	"SDMA0_PERFCNT_MISC_CNTL\0" /* 46105 */
	"SDMA0_PERFCOUNTER0_SELECT\0" /* 46129 */
	"SDMA0_PERFCOUNTER0_SELECT1\0" /* 46155 */
	"SDMA0_PERFCOUNTER1_SELECT\0" /* 46182 */
	"SDMA0_PERFCOUNTER1_SELECT1\0" /* 46208 */
	"SDMA1_PERFCNT_PERFCOUNTER0_CFG\0" /* 46235 */
	"SDMA1_PERFCNT_PERFCOUNTER1_CFG\0" /* 46266 */
	"SDMA1_PERFCNT_PERFCOUNTER_RSLT_CNTL\0" /* 46297 */
	"SDMA1_PERFCNT_MISC_CNTL\0" /* 46333 */
	"SDMA1_PERFCOUNTER0_SELECT\0" /* 46357 */
	"SDMA1_PERFCOUNTER0_SELECT1\0" /* 46383 */
	"SDMA1_PERFCOUNTER1_SELECT\0" /* 46410 */
	"SDMA1_PERFCOUNTER1_SELECT1\0" /* 46436 */
	"SDMA2_PERFCNT_PERFCOUNTER0_CFG\0" /* 46463 */
	"SDMA2_PERFCNT_PERFCOUNTER1_CFG\0" /* 46494 */
	"SDMA2_PERFCNT_PERFCOUNTER_RSLT_CNTL\0" /* 46525 */
	"SDMA2_PERFCNT_MISC_CNTL\0" /* 46561 */
	"SDMA2_PERFCOUNTER0_SELECT\0" /* 46585 */
	"SDMA2_PERFCOUNTER0_SELECT1\0" /* 46611 */
	"SDMA2_PERFCOUNTER1_SELECT\0" /* 46638 */
	"SDMA2_PERFCOUNTER1_SELECT1\0" /* 46664 */
	"SDMA3_PERFCNT_PERFCOUNTER0_CFG\0" /* 46691 */
	"SDMA3_PERFCNT_PERFCOUNTER1_CFG\0" /* 46722 */
	"SDMA3_PERFCNT_PERFCOUNTER_RSLT_CNTL\0" /* 46753 */
	"SDMA3_PERFCNT_MISC_CNTL\0" /* 46789 */
	"SDMA3_PERFCOUNTER0_SELECT\0" /* 46813 */
	"SDMA3_PERFCOUNTER0_SELECT1\0" /* 46839 */
	"SDMA3_PERFCOUNTER1_SELECT\0" /* 46866 */
	"SDMA3_PERFCOUNTER1_SELECT1\0" /* 46892 */
	"SQ_WAVE_HW_ID\0" /* 46919 */
	"SQ_WAVE_INST_DW1\0" /* 46933, 46941 */
	"SQ_WAVE_IB_DBG0\0" /* 46950 */
	"SQ_WAVE_TBA_LO\0" /* 46966 */
	"SQ_WAVE_TBA_HI\0" /* 46981 */
	"SQ_WAVE_TMA_LO\0" /* 46996 */
	"SQ_WAVE_TMA_HI\0" /* 47011 */
	"SRBM_STATUS2\0" /* 47026 */
	"SRBM_STATUS\0" /* 47039 */
	"SRBM_STATUS3\0" /* 47051 */
	"GRBM_CNTL\0" /* 47064 */
	"GRBM_SKEW_CNTL\0" /* 47074 */
	"GRBM_PWR_CNTL\0" /* 47089 */
	"GRBM_SOFT_RESET\0" /* 47103 */
	"GRBM_DEBUG_CNTL\0" /* 47119 */
	"GRBM_DEBUG_DATA\0" /* 47135, 47140 */
	"GRBM_GFX_CLKEN_CNTL\0" /* 47151 */
	"GRBM_WAIT_IDLE_CLOCKS\0" /* 47171, 47176 */
	"GRBM_DEBUG\0" /* 47193 */
	"GRBM_DEBUG_SNAPSHOT\0" /* 47204 */
	"GRBM_READ_ERROR\0" /* 47224, 47229 */
	"GRBM_INT_CNTL\0" /* 47240 */
	"DEBUG_INDEX\0" /* 47254 */
	"GRBM_NOWHERE\0" /* 47266 */
	"GRBM_SCRATCH_REG0\0" /* 47279 */
	"GRBM_SCRATCH_REG1\0" /* 47297 */
	"GRBM_SCRATCH_REG2\0" /* 47315 */
	"GRBM_SCRATCH_REG3\0" /* 47333 */
	"GRBM_SCRATCH_REG4\0" /* 47351 */
	"GRBM_SCRATCH_REG5\0" /* 47369 */
	"GRBM_SCRATCH_REG6\0" /* 47387 */
	"GRBM_SCRATCH_REG7\0" /* 47405 */
	"SQ_INTERRUPT_WORD_AUTO\0" /* 47423 */
	"CP_STALLED_STAT3\0" /* 47446 */
	"CP_STALLED_STAT1\0" /* 47463 */
	"CP_STALLED_STAT2\0" /* 47480 */
	"CP_BUSY_STAT\0" /* 47497 */
	"CP_STAT\0" /* 47510 */
	"CP_ME_HEADER_DUMP\0" /* 47518, 47521 */
	"CP_PFP_HEADER_DUMP\0" /* 47536, 47539 */
	"CP_GRBM_FREE_COUNT\0" /* 47555 */
	"CP_CE_HEADER_DUMP\0" /* 47574, 47577 */
	"CP_MC_PACK_DELAY_CNT\0" /* 47592, 47598 */
	"CP_CSF_STAT\0" /* 47613 */
	"CP_CSF_CNTL\0" /* 47625 */
	"CP_ME_CNTL\0" /* 47637 */
	"CP_CNTX_STAT\0" /* 47648 */
	"CP_ME_PREEMPTION\0" /* 47661 */
	"CP_RB2_RPTR\0" /* 47678 */
	"CP_RB1_RPTR\0" /* 47690 */
	"CP_RB0_RPTR\0" /* 47702 */
	"CP_RB_WPTR_DELAY\0" /* 47714 */
	"CP_RB_WPTR_POLL_CNTL\0" /* 47731 */
	"CP_ROQ1_THRESHOLDS\0" /* 47752 */
	"CP_ROQ2_THRESHOLDS\0" /* 47771 */
	"CP_STQ_THRESHOLDS\0" /* 47790 */
	"CP_QUEUE_THRESHOLDS\0" /* 47808 */
	"CP_MEQ_THRESHOLDS\0" /* 47828 */
	"CP_ROQ_AVAIL\0" /* 47846 */
	"CP_STQ_AVAIL\0" /* 47859 */
	"CP_ROQ2_AVAIL\0" /* 47872 */
	"CP_MEQ_AVAIL\0" /* 47886 */
	"CP_CMD_INDEX\0" /* 47899, 47902 */
	"CP_CMD_DATA\0" /* 47912, 47915 */
	"CP_ROQ_RB_STAT\0" /* 47924 */
	"CP_ROQ_IB1_STAT\0" /* 47939 */
	"CP_ROQ_IB2_STAT\0" /* 47955 */
	"CP_STQ_STAT\0" /* 47971 */
	"CP_MEQ_STAT\0" /* 47983 */
	"CP_CEQ1_AVAIL\0" /* 47995 */
	"CP_CEQ2_AVAIL\0" /* 48009 */
	"CP_CE_ROQ_RB_STAT\0" /* 48023 */
	"CP_CE_ROQ_IB1_STAT\0" /* 48041 */
	"CP_CE_ROQ_IB2_STAT\0" /* 48060 */
	"CP_INT_STAT_DEBUG\0" /* 48079 */
	"IA_PERFCOUNTER0_SELECT\0" /* 48097 */
	"IA_PERFCOUNTER1_SELECT\0" /* 48120 */
	"IA_PERFCOUNTER2_SELECT\0" /* 48143 */
	"IA_PERFCOUNTER3_SELECT\0" /* 48166 */
	"IA_PERFCOUNTER0_LO\0" /* 48189 */
	"IA_PERFCOUNTER0_HI\0" /* 48208 */
	"IA_PERFCOUNTER1_LO\0" /* 48227 */
	"IA_PERFCOUNTER1_HI\0" /* 48246 */
	"IA_PERFCOUNTER2_LO\0" /* 48265 */
	"IA_PERFCOUNTER2_HI\0" /* 48284 */
	"IA_PERFCOUNTER3_LO\0" /* 48303 */
	"IA_PERFCOUNTER3_HI\0" /* 48322 */
	"VGT_VTX_VECT_EJECT_REG\0" /* 48341 */
	"VGT_DMA_DATA_FIFO_DEPTH\0" /* 48364, 48368 */
	"VGT_DMA_REQ_FIFO_DEPTH\0" /* 48388, 48392 */
	"VGT_DRAW_INIT_FIFO_DEPTH\0" /* 48411, 48415 */
	"VGT_LAST_COPY_STATE\0" /* 48436 */
	"VGT_CACHE_INVALIDATION\0" /* 48456, 48460 */
	"VGT_ESGS_RING_SIZE\0" /* 48479 */
	"VGT_GSVS_RING_SIZE\0" /* 48498 */
	"VGT_FIFO_DEPTHS\0" /* 48517 */
	"VGT_GS_VERTEX_REUSE\0" /* 48533 */
	"VGT_MC_LAT_CNTL\0" /* 48553 */
	"IA_CNTL_STATUS\0" /* 48569 */
	"VGT_DEBUG_CNTL\0" /* 48584 */
	"VGT_DEBUG_DATA\0" /* 48599 */
	"IA_DEBUG_CNTL\0" /* 48614 */
	"IA_DEBUG_DATA\0" /* 48628 */
	"VGT_CNTL_STATUS\0" /* 48642 */
	"VGT_PERFCOUNTER_SEID_MASK\0" /* 48658 */
	"VGT_PERFCOUNTER0_SELECT\0" /* 48684 */
	"VGT_PERFCOUNTER1_SELECT\0" /* 48708 */
	"VGT_PERFCOUNTER2_SELECT\0" /* 48732 */
	"VGT_PERFCOUNTER3_SELECT\0" /* 48756 */
	"VGT_PERFCOUNTER0_LO\0" /* 48780 */
	"VGT_PERFCOUNTER0_HI\0" /* 48800 */
	"VGT_PERFCOUNTER1_LO\0" /* 48820 */
	"VGT_PERFCOUNTER1_HI\0" /* 48840 */
	"VGT_PERFCOUNTER2_LO\0" /* 48860 */
	"VGT_PERFCOUNTER2_HI\0" /* 48880 */
	"VGT_PERFCOUNTER3_LO\0" /* 48900 */
	"VGT_PERFCOUNTER3_HI\0" /* 48920 */
	"CGTT_VGT_CLK_CTRL\0" /* 48940 */
	"IA_VMID_OVERRIDE\0" /* 48958 */
	"CGTT_IA_CLK_CTRL\0" /* 48975 */
	"VGT_TF_RING_SIZE\0" /* 48992 */
	"VGT_SYS_CONFIG\0" /* 49009 */
	"VGT_HS_OFFCHIP_PARAM\0" /* 49024 */
	"VGT_TF_MEMORY_BASE\0" /* 49045 */
	"CC_GC_SHADER_ARRAY_CONFIG\0" /* 49064 */
	"GC_USER_SHADER_ARRAY_CONFIG\0" /* 49090 */
	"PA_SU_DEBUG_CNTL\0" /* 49118 */
	"PA_SU_DEBUG_DATA\0" /* 49135 */
	"PA_CL_CNTL_STATUS\0" /* 49152 */
	"PA_CL_ENHANCE\0" /* 49170 */
	"CGTT_PA_CLK_CTRL\0" /* 49184 */
	"PA_SU_CNTL_STATUS\0" /* 49201 */
	"PA_SC_FIFO_DEPTH_CNTL\0" /* 49219 */
	"PA_SC_FORCE_EOV_MAX_CNTS\0" /* 49241 */
	"CGTT_SC_CLK_CTRL\0" /* 49266 */
	"PA_SC_FIFO_SIZE\0" /* 49283 */
	"PA_SC_IF_FIFO_SIZE\0" /* 49299 */
	"PA_SC_DEBUG_CNTL\0" /* 49318 */
	"PA_SC_DEBUG_DATA\0" /* 49335 */
	"PA_SC_ENHANCE\0" /* 49352 */
	"SQ_CONFIG\0" /* 49366 */
	"SQC_CONFIG\0" /* 49376 */
	"SQ_RANDOM_WAVE_PRI\0" /* 49387 */
	"SQ_REG_CREDITS\0" /* 49406 */
	"SQ_FIFO_SIZES\0" /* 49421 */
	"CC_SQC_BANK_DISABLE\0" /* 49435 */
	"USER_SQC_BANK_DISABLE\0" /* 49455 */
	"SQ_DEBUG_STS_GLOBAL\0" /* 49477 */
	"SQ_ALU_CLK_CTRL\0" /* 49497 */
	"SQ_TEX_CLK_CTRL\0" /* 49513 */
	"CGTT_SQ_CLK_CTRL\0" /* 49529 */
	"CGTT_SQG_CLK_CTRL\0" /* 49546 */
	"SQ_IND_INDEX\0" /* 49564 */
	"SQ_IND_DATA\0" /* 49577 */
	"SQ_TIME_HI\0" /* 49589 */
	"SQ_TIME_LO\0" /* 49600 */
	"SQ_THREAD_TRACE_BASE\0" /* 49611 */
	"SQ_THREAD_TRACE_SIZE\0" /* 49632 */
	"SQ_THREAD_TRACE_PERF_MASK\0" /* 49653 */
	"SQ_THREAD_TRACE_MODE\0" /* 49679 */
	"SQ_THREAD_TRACE_CNTR\0" /* 49700 */
	"SQ_THREAD_TRACE_HIWATER\0" /* 49721, 49737 */
	"SQ_POWER_THROTTLE\0" /* 49745 */
	"SQ_POWER_THROTTLE2\0" /* 49763 */
	"SQ_LB_CTR_CTRL\0" /* 49782 */
	"SQ_LB_DATA_ALU_CYCLES\0" /* 49797 */
	"SQ_LB_DATA_TEX_CYCLES\0" /* 49819 */
	"SQ_LB_DATA_ALU_STALLS\0" /* 49841 */
	"SQ_LB_DATA_TEX_STALLS\0" /* 49863 */
	"SQC_SECDED_CNT\0" /* 49885 */
	"SQ_SEC_CNT\0" /* 49900 */
	"SQ_DED_CNT\0" /* 49911 */
	"SQ_DED_INFO\0" /* 49922 */
	"SPI_SHADER_TBA_LO_PS\0" /* 49934 */
	"SPI_SHADER_TBA_HI_PS\0" /* 49955 */
	"SPI_SHADER_TMA_LO_PS\0" /* 49976 */
	"SPI_SHADER_TMA_HI_PS\0" /* 49997 */
	"SPI_SHADER_TBA_LO_VS\0" /* 50018 */
	"SPI_SHADER_TBA_HI_VS\0" /* 50039 */
	"SPI_SHADER_TMA_LO_VS\0" /* 50060 */
	"SPI_SHADER_TMA_HI_VS\0" /* 50081 */
	"SPI_SHADER_TBA_LO_GS\0" /* 50102 */
	"SPI_SHADER_TBA_HI_GS\0" /* 50123 */
	"SPI_SHADER_TMA_LO_GS\0" /* 50144 */
	"SPI_SHADER_TMA_HI_GS\0" /* 50165 */
	"SPI_SHADER_TBA_LO_ES\0" /* 50186 */
	"SPI_SHADER_TBA_HI_ES\0" /* 50207 */
	"SPI_SHADER_TMA_LO_ES\0" /* 50228 */
	"SPI_SHADER_TMA_HI_ES\0" /* 50249 */
	"SPI_SHADER_TBA_LO_HS\0" /* 50270 */
	"SPI_SHADER_TBA_HI_HS\0" /* 50291 */
	"SPI_SHADER_TMA_LO_HS\0" /* 50312 */
	"SPI_SHADER_TMA_HI_HS\0" /* 50333 */
	"SPI_SHADER_TBA_LO_LS\0" /* 50354 */
	"SPI_SHADER_TBA_HI_LS\0" /* 50375 */
	"SPI_SHADER_TMA_LO_LS\0" /* 50396 */
	"SPI_SHADER_TMA_HI_LS\0" /* 50417 */
	"COMPUTE_MAX_WAVE_ID\0" /* 50438, 50446, 50450 */
	"COMPUTE_TBA_LO\0" /* 50458 */
	"COMPUTE_TBA_HI\0" /* 50473 */
	"COMPUTE_TMA_LO\0" /* 50488 */
	"COMPUTE_TMA_HI\0" /* 50503 */
	"COMPUTE_STATIC_THREAD_MGMT_SE0\0" /* 50518 */
	"COMPUTE_STATIC_THREAD_MGMT_SE1\0" /* 50549 */
	"SDMA0_STATUS_REG\0" /* 50580 */
	"SDMA1_STATUS_REG\0" /* 50597 */
	"DB_DEPTH_INFO\0" /* 50614 */
	"DB_DEPTH_SIZE\0" /* 50628 */
	"DB_DEPTH_SLICE\0" /* 50642 */
	"CP_RINGID\0" /* 50657, 50660 */
	"CP_CPC_MC_CNTL\0" /* 50667 */
	"SQ_THREAD_TRACE_BASE2\0" /* 50682 */
	"SQ_THREAD_TRACE_TOKEN_MASK2\0" /* 50704 */
	"COMPUTE_STATIC_THREAD_MGMT_SE2\0" /* 50732 */
	"COMPUTE_STATIC_THREAD_MGMT_SE3\0" /* 50763 */
	"WD_PERFCOUNTER0_LO\0" /* 50794 */
	"WD_PERFCOUNTER0_HI\0" /* 50813 */
	"WD_PERFCOUNTER1_LO\0" /* 50832 */
	"WD_PERFCOUNTER1_HI\0" /* 50851 */
	"WD_PERFCOUNTER2_LO\0" /* 50870 */
	"WD_PERFCOUNTER2_HI\0" /* 50889 */
	"WD_PERFCOUNTER3_LO\0" /* 50908 */
	"WD_PERFCOUNTER3_HI\0" /* 50927 */
	"TCC_PERFCOUNTER0_LO\0" /* 50946 */
	"TCC_PERFCOUNTER0_HI\0" /* 50966 */
	"TCC_PERFCOUNTER1_LO\0" /* 50986 */
	"TCC_PERFCOUNTER1_HI\0" /* 51006 */
	"TCC_PERFCOUNTER2_LO\0" /* 51026 */
	"TCC_PERFCOUNTER2_HI\0" /* 51046 */
	"TCC_PERFCOUNTER3_LO\0" /* 51066 */
	"TCC_PERFCOUNTER3_HI\0" /* 51086 */
	"TCA_PERFCOUNTER0_LO\0" /* 51106 */
	"TCA_PERFCOUNTER0_HI\0" /* 51126 */
	"TCA_PERFCOUNTER1_LO\0" /* 51146 */
	"TCA_PERFCOUNTER1_HI\0" /* 51166 */
	"TCA_PERFCOUNTER2_LO\0" /* 51186 */
	"TCA_PERFCOUNTER2_HI\0" /* 51206 */
	"TCA_PERFCOUNTER3_LO\0" /* 51226 */
	"TCA_PERFCOUNTER3_HI\0" /* 51246 */
	"TCS_PERFCOUNTER0_LO\0" /* 51266 */
	"TCS_PERFCOUNTER0_HI\0" /* 51286 */
	"TCS_PERFCOUNTER1_LO\0" /* 51306 */
	"TCS_PERFCOUNTER1_HI\0" /* 51326 */
	"TCS_PERFCOUNTER2_LO\0" /* 51346 */
	"TCS_PERFCOUNTER2_HI\0" /* 51366 */
	"TCS_PERFCOUNTER3_LO\0" /* 51386 */
	"TCS_PERFCOUNTER3_HI\0" /* 51406 */
	"WD_PERFCOUNTER0_SELECT\0" /* 51426 */
	"WD_PERFCOUNTER1_SELECT\0" /* 51449 */
	"WD_PERFCOUNTER2_SELECT\0" /* 51472 */
	"WD_PERFCOUNTER3_SELECT\0" /* 51495 */
	"IA_PERFCOUNTER0_SELECT1\0" /* 51518 */
	"VGT_PERFCOUNTER0_SELECT1\0" /* 51542 */
	"VGT_PERFCOUNTER1_SELECT1\0" /* 51567 */
	"SQ_PERFCOUNTER_MASK\0" /* 51592 */
	"TCC_PERFCOUNTER0_SELECT\0" /* 51612 */
	"TCC_PERFCOUNTER0_SELECT1\0" /* 51636 */
	"TCC_PERFCOUNTER1_SELECT\0" /* 51661 */
	"TCC_PERFCOUNTER1_SELECT1\0" /* 51685 */
	"TCC_PERFCOUNTER2_SELECT\0" /* 51710 */
	"TCC_PERFCOUNTER3_SELECT\0" /* 51734 */
	"TCA_PERFCOUNTER0_SELECT\0" /* 51758 */
	"TCA_PERFCOUNTER0_SELECT1\0" /* 51782 */
	"TCA_PERFCOUNTER1_SELECT\0" /* 51807 */
	"TCA_PERFCOUNTER1_SELECT1\0" /* 51831 */
	"TCA_PERFCOUNTER2_SELECT\0" /* 51856 */
	"TCA_PERFCOUNTER3_SELECT\0" /* 51880 */
	"TCS_PERFCOUNTER0_SELECT\0" /* 51904 */
	"TCS_PERFCOUNTER0_SELECT1\0" /* 51928 */
	"TCS_PERFCOUNTER1_SELECT\0" /* 51953 */
	"TCS_PERFCOUNTER2_SELECT\0" /* 51977 */
	"TCS_PERFCOUNTER3_SELECT\0" /* 52001 */
	"RLC_SPM_CPG_PERFMON_SAMPLE_DELAY\0" /* 52025, 52037 */
	"RLC_SPM_CPC_PERFMON_SAMPLE_DELAY\0" /* 52058 */
	"RLC_SPM_CPF_PERFMON_SAMPLE_DELAY\0" /* 52091 */
	"RLC_SPM_CB_PERFMON_SAMPLE_DELAY\0" /* 52124 */
	"RLC_SPM_DB_PERFMON_SAMPLE_DELAY\0" /* 52156 */
	"RLC_SPM_PA_PERFMON_SAMPLE_DELAY\0" /* 52188 */
	"RLC_SPM_GDS_PERFMON_SAMPLE_DELAY\0" /* 52220 */
	"RLC_SPM_IA_PERFMON_SAMPLE_DELAY\0" /* 52253 */
	"RLC_SPM_SC_PERFMON_SAMPLE_DELAY\0" /* 52285 */
	"RLC_SPM_TCC_PERFMON_SAMPLE_DELAY\0" /* 52317 */
	"RLC_SPM_TCA_PERFMON_SAMPLE_DELAY\0" /* 52350 */
	"RLC_SPM_TCP_PERFMON_SAMPLE_DELAY\0" /* 52383 */
	"RLC_SPM_TA_PERFMON_SAMPLE_DELAY\0" /* 52416 */
	"RLC_SPM_TD_PERFMON_SAMPLE_DELAY\0" /* 52448 */
	"RLC_SPM_VGT_PERFMON_SAMPLE_DELAY\0" /* 52480 */
	"RLC_SPM_SPI_PERFMON_SAMPLE_DELAY\0" /* 52513 */
	"RLC_SPM_SQG_PERFMON_SAMPLE_DELAY\0" /* 52546 */
	"RLC_SPM_TCS_PERFMON_SAMPLE_DELAY\0" /* 52579 */
	"RLC_SPM_SX_PERFMON_SAMPLE_DELAY\0" /* 52612 */
	"RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY\0" /* 52644 */
	"RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY\0" /* 52678 */
	"RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY\0" /* 52712 */
	"RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY\0" /* 52746 */
	"COMPUTE_WAVE_RESTORE_CONTROL\0" /* 52780 */
	"CP_CE_RB_OFFSET\0" /* 52809 */
	"SPI_SHADER_USER_DATA_ES_16\0" /* 52825 */
	"SPI_SHADER_USER_DATA_ES_17\0" /* 52852 */
	"SPI_SHADER_USER_DATA_ES_18\0" /* 52879 */
	"SPI_SHADER_USER_DATA_ES_19\0" /* 52906 */
	"SPI_SHADER_USER_DATA_ES_20\0" /* 52933 */
	"SPI_SHADER_USER_DATA_ES_21\0" /* 52960 */
	"SPI_SHADER_USER_DATA_ES_22\0" /* 52987 */
	"SPI_SHADER_USER_DATA_ES_23\0" /* 53014 */
	"SPI_SHADER_USER_DATA_ES_24\0" /* 53041 */
	"SPI_SHADER_USER_DATA_ES_25\0" /* 53068 */
	"SPI_SHADER_USER_DATA_ES_26\0" /* 53095 */
	"SPI_SHADER_USER_DATA_ES_27\0" /* 53122 */
	"SPI_SHADER_USER_DATA_ES_28\0" /* 53149 */
	"SPI_SHADER_USER_DATA_ES_29\0" /* 53176 */
	"SPI_SHADER_USER_DATA_ES_30\0" /* 53203 */
	"SPI_SHADER_USER_DATA_ES_31\0" /* 53230 */
	"SPI_SHADER_USER_DATA_LS_16\0" /* 53257 */
	"SPI_SHADER_USER_DATA_LS_17\0" /* 53284 */
	"SPI_SHADER_USER_DATA_LS_18\0" /* 53311 */
	"SPI_SHADER_USER_DATA_LS_19\0" /* 53338 */
	"SPI_SHADER_USER_DATA_LS_20\0" /* 53365 */
	"SPI_SHADER_USER_DATA_LS_21\0" /* 53392 */
	"SPI_SHADER_USER_DATA_LS_22\0" /* 53419 */
	"SPI_SHADER_USER_DATA_LS_23\0" /* 53446 */
	"SPI_SHADER_USER_DATA_LS_24\0" /* 53473 */
	"SPI_SHADER_USER_DATA_LS_25\0" /* 53500 */
	"SPI_SHADER_USER_DATA_LS_26\0" /* 53527 */
	"SPI_SHADER_USER_DATA_LS_27\0" /* 53554 */
	"SPI_SHADER_USER_DATA_LS_28\0" /* 53581 */
	"SPI_SHADER_USER_DATA_LS_29\0" /* 53608 */
	"SPI_SHADER_USER_DATA_LS_30\0" /* 53635 */
	"SPI_SHADER_USER_DATA_LS_31\0" /* 53662 */
	"SPI_SHADER_USER_DATA_COMMON_0\0" /* 53689 */
	"SPI_SHADER_USER_DATA_COMMON_1\0" /* 53719 */
	"SPI_SHADER_USER_DATA_COMMON_2\0" /* 53749 */
	"SPI_SHADER_USER_DATA_COMMON_3\0" /* 53779 */
	"SPI_SHADER_USER_DATA_COMMON_4\0" /* 53809 */
	"SPI_SHADER_USER_DATA_COMMON_5\0" /* 53839 */
	"SPI_SHADER_USER_DATA_COMMON_6\0" /* 53869 */
	"SPI_SHADER_USER_DATA_COMMON_7\0" /* 53899 */
	"SPI_SHADER_USER_DATA_COMMON_8\0" /* 53929 */
	"SPI_SHADER_USER_DATA_COMMON_9\0" /* 53959 */
	"SPI_SHADER_USER_DATA_COMMON_10\0" /* 53989 */
	"SPI_SHADER_USER_DATA_COMMON_11\0" /* 54020 */
	"SPI_SHADER_USER_DATA_COMMON_12\0" /* 54051 */
	"SPI_SHADER_USER_DATA_COMMON_13\0" /* 54082 */
	"SPI_SHADER_USER_DATA_COMMON_14\0" /* 54113 */
	"SPI_SHADER_USER_DATA_COMMON_15\0" /* 54144 */
	"SPI_SHADER_USER_DATA_COMMON_16\0" /* 54175 */
	"SPI_SHADER_USER_DATA_COMMON_17\0" /* 54206 */
	"SPI_SHADER_USER_DATA_COMMON_18\0" /* 54237 */
	"SPI_SHADER_USER_DATA_COMMON_19\0" /* 54268 */
	"SPI_SHADER_USER_DATA_COMMON_20\0" /* 54299 */
	"SPI_SHADER_USER_DATA_COMMON_21\0" /* 54330 */
	"SPI_SHADER_USER_DATA_COMMON_22\0" /* 54361 */
	"SPI_SHADER_USER_DATA_COMMON_23\0" /* 54392 */
	"SPI_SHADER_USER_DATA_COMMON_24\0" /* 54423 */
	"SPI_SHADER_USER_DATA_COMMON_25\0" /* 54454 */
	"SPI_SHADER_USER_DATA_COMMON_26\0" /* 54485 */
	"SPI_SHADER_USER_DATA_COMMON_27\0" /* 54516 */
	"SPI_SHADER_USER_DATA_COMMON_28\0" /* 54547 */
	"SPI_SHADER_USER_DATA_COMMON_29\0" /* 54578 */
	"SPI_SHADER_USER_DATA_COMMON_30\0" /* 54609 */
	"SPI_SHADER_USER_DATA_COMMON_31\0" /* 54640 */
	"DB_Z_INFO2\0" /* 54671 */
	"DB_STENCIL_INFO2\0" /* 54682 */
	"CB_MRT0_EPITCH\0" /* 54699, 54707 */
	"CB_MRT1_EPITCH\0" /* 54714 */
	"CB_MRT2_EPITCH\0" /* 54729 */
	"CB_MRT3_EPITCH\0" /* 54744 */
	"CB_MRT4_EPITCH\0" /* 54759 */
	"CB_MRT5_EPITCH\0" /* 54774 */
	"CB_MRT6_EPITCH\0" /* 54789 */
	"CB_MRT7_EPITCH\0" /* 54804 */
	"VGT_GS_MAX_PRIMS_PER_SUBGROUP\0" /* 54819, 54826 */
	"CP_APPEND_DATA_LO\0" /* 54849 */
	"CP_APPEND_LAST_CS_FENCE_LO\0" /* 54867 */
	"CP_APPEND_LAST_PS_FENCE_LO\0" /* 54894 */
	"VGT_TF_MEMORY_BASE_HI\0" /* 54921 */
	"SPI_CONFIG_CNTL_1\0" /* 54943 */
	"SPI_CONFIG_CNTL_2\0" /* 54961 */
	"SPI_WAVE_LIMIT_CNTL\0" /* 54979 */
	"RLC_SPM_RMI_PERFMON_SAMPLE_DELAY\0" /* 54999 */
	"RLC_SPM_PERFMON_SAMPLE_DELAY_MAX\0" /* 55032, 55059 */
	"FP_ROUND\0" /* 55065 */
	"FP_DENORM\0" /* 55074 */
	"DX10_CLAMP\0" /* 55084 */
	"IEEE\0" /* 55095 */
	"LOD_CLAMPED\0" /* 55100 */
	"INVALID\0" /* 55112, 55114 */
	"INPUT_DENORMAL\0" /* 55120 */
	"DIVIDE_BY_ZERO\0" /* 55135 */
	"OVERFLOW\0" /* 55150 */
	"UNDERFLOW\0" /* 55159 */
	"INEXACT\0" /* 55169, 55171 */
	"INT_DIVIDE_BY_ZERO\0" /* 55177 */
	"ADDRESS_WATCH\0" /* 55196 */
	"MEMORY_VIOLATION\0" /* 55210 */
	"EXCP_EN\0" /* 55227 */
	"FP16_OVFL\0" /* 55235 */
	"DISABLE_PERF\0" /* 55245 */
	"VSKIP\0" /* 55258 */
	"CSP\0" /* 55264 */
	"SCC\0" /* 55268 */
	"SPI_PRIO\0" /* 55272 */
	"USER_PRIO\0" /* 55281 */
	"PRIV\0" /* 55291 */
	"TRAP_EN\0" /* 55296 */
	"TTRACE_EN\0" /* 55304 */
	"EXPORT_RDY\0" /* 55314 */
	"EXECZ\0" /* 55325 */
	"VCCZ\0" /* 55331 */
	"IN_TG\0" /* 55336 */
	"IN_BARRIER\0" /* 55342 */
	"HALT\0" /* 55353 */
	"TRAP\0" /* 55358 */
	"TTRACE_SIMD_EN\0" /* 55363, 55370 */
	"ECC_ERR\0" /* 55378 */
	"SKIP_EXPORT\0" /* 55386 */
	"PERF_EN\0" /* 55398 */
	"FATAL_HALT\0" /* 55406 */
	"MUST_EXPORT\0" /* 55417 */
	"EXCP\0" /* 55429 */
	"SAVECTX\0" /* 55434 */
	"ILLEGAL_INST\0" /* 55442 */
	"EXCP_HI\0" /* 55455 */
	"BUFFER_OOB\0" /* 55463 */
	"EXCP_CYCLE\0" /* 55474 */
	"EXCP_GROUP_MASK\0" /* 55485 */
	"EXCP_WAVE64HI\0" /* 55501, 55506 */
	"XNACK_ERROR\0" /* 55515 */
	"DP_RATE\0" /* 55527 */
	"SIMD_ID\0" /* 55535 */
	"PIPE_ID\0" /* 55543 */
	"CU_ID\0" /* 55551 */
	"SH_ID\0" /* 55557 */
	"WAVE_ID_MSB\0" /* 55563 */
	"TG_ID\0" /* 55575 */
	"VM_ID\0" /* 55581 */
	"QUEUE_ID\0" /* 55587 */
	"STATE_ID\0" /* 55596 */
	"ME_ID\0" /* 55605 */
	"VGPR_BASE\0" /* 55611 */
	"VGPR_SIZE\0" /* 55621 */
	"SGPR_BASE\0" /* 55631 */
	"SGPR_SIZE\0" /* 55641 */
	"LDS_BASE\0" /* 55651 */
	"LDS_SIZE\0" /* 55660 */
	"VGPR_SHARED_SIZE\0" /* 55669 */
	"VM_CNT\0" /* 55686 */
	"EXP_CNT\0" /* 55693 */
	"LGKM_CNT_BIT4\0" /* 55701 */
	"LGKM_CNT\0" /* 55715 */
	"VALU_CNT\0" /* 55724 */
	"FIRST_REPLAY\0" /* 55733 */
	"RCNT\0" /* 55746 */
	"VM_CNT_HI\0" /* 55751 */
	"LGKM_CNT_BIT5\0" /* 55761 */
	"REPLAY_W64H\0" /* 55775 */
	"VS_CNT\0" /* 55787 */
	"XNACK\0" /* 55794 */
	"TA_NEED_RESET\0" /* 55800 */
	"XNACK_OVERRIDE\0" /* 55814 */
	"XCNT\0" /* 55829 */
	"QCNT\0" /* 55834 */
	"WAVE_IDLE\0" /* 55839 */
	"MISC_CNT\0" /* 55849 */
	"UNUSED\0" /* 55858 */
	"WGP_ID\0" /* 55865 */
	"SA_ID\0" /* 55872 */
	"WG_ID\0" /* 55878 */
	"COMPAT_LEVEL\0" /* 55884 */
	"POPS_EN\0" /* 55897, 55899 */
	"POPS_PACKER_ID\0" /* 55905 */
	"DEP_MODE\0" /* 55920 */
	"INST_PREFETCH\0" /* 55929 */
	"RESOURCE_OVERRIDE\0" /* 55943 */
	"MEM_ORDER\0" /* 55961 */
	"FWD_PROGRESS\0" /* 55971 */
	"WAVE64\0" /* 55984 */
	"SUBV_LOOP\0" /* 55991 */
	"ME0PIPE1_CMDFIFO_AVAIL\0" /* 56001 */
	"ME0PIPE1_CF_RQ_PENDING\0" /* 56024 */
	"ME0PIPE1_PF_RQ_PENDING\0" /* 56047 */
	"ME1PIPE0_RQ_PENDING\0" /* 56070 */
	"ME1PIPE1_RQ_PENDING\0" /* 56090 */
	"ME1PIPE2_RQ_PENDING\0" /* 56110 */
	"ME1PIPE3_RQ_PENDING\0" /* 56130 */
	"ME2PIPE0_RQ_PENDING\0" /* 56150 */
	"ME2PIPE1_RQ_PENDING\0" /* 56170 */
	"ME2PIPE2_RQ_PENDING\0" /* 56190 */
	"ME2PIPE3_RQ_PENDING\0" /* 56210 */
	"RLC_RQ_PENDING\0" /* 56230 */
	"UTCL2_BUSY\0" /* 56245, 56251 */
	"EA_BUSY\0" /* 56256 */
	"RMI_BUSY\0" /* 56264 */
	"UTCL2_RQ_PENDING\0" /* 56273 */
	"CPF_RQ_PENDING\0" /* 56290 */
	"EA_LINK_BUSY\0" /* 56305 */
	"SDMA_BUSY\0" /* 56318, 56319 */
	"SDMA0_RQ_PENDING\0" /* 56328 */
	"SDMA1_RQ_PENDING\0" /* 56345 */
	"RLC_BUSY\0" /* 56362 */
	"TCP_BUSY\0" /* 56371, 56372 */
	"CPF_BUSY\0" /* 56380 */
	"CPC_BUSY\0" /* 56389 */
	"CPG_BUSY\0" /* 56398 */
	"CPAXI_BUSY\0" /* 56407 */
	"ME0PIPE0_CMDFIFO_AVAIL\0" /* 56418 */
	"RSMU_RQ_PENDING\0" /* 56441, 56442 */
	"ME0PIPE0_CF_RQ_PENDING\0" /* 56457 */
	"ME0PIPE0_PF_RQ_PENDING\0" /* 56480 */
	"GDS_DMA_RQ_PENDING\0" /* 56503 */
	"DB_CLEAN\0" /* 56522 */
	"CB_CLEAN\0" /* 56531 */
	"TA_BUSY\0" /* 56540 */
	"GDS_BUSY\0" /* 56548 */
	"GE_BUSY_NO_DMA\0" /* 56557 */
	"SX_BUSY\0" /* 56572 */
	"GE_BUSY\0" /* 56580 */
	"SPI_BUSY\0" /* 56588 */
	"BCI_BUSY\0" /* 56597 */
	"SC_BUSY\0" /* 56606 */
	"PA_BUSY\0" /* 56614 */
	"DB_BUSY\0" /* 56622 */
	"CP_COHERENCY_BUSY\0" /* 56630 */
	"CB_BUSY\0" /* 56648 */
	"GUI_ACTIVE\0" /* 56656 */
	"UTCL1_BUSY\0" /* 56667 */
	"GL1CC_BUSY\0" /* 56678 */
	"GRBM_RLC_INTR_CREDIT_PENDING\0" /* 56689 */
	"GRBM_UTCL2_INTR_CREDIT_PENDING\0" /* 56718 */
	"GRBM_CPF_INTR_CREDIT_PENDING\0" /* 56749 */
	"MESPIPE0_RQ_PENDING\0" /* 56778 */
	"MESPIPE1_RQ_PENDING\0" /* 56798 */
	"MESPIPE2_RQ_PENDING\0" /* 56818 */
	"MESPIPE3_RQ_PENDING\0" /* 56838 */
	"PH_BUSY\0" /* 56858 */
	"CH_BUSY\0" /* 56866 */
	"GL2CC_BUSY\0" /* 56874 */
	"GUS_LINK_BUSY\0" /* 56885 */
	"GUS_BUSY\0" /* 56899 */
	"PMM_BUSY\0" /* 56908 */
	"MEC1_BUSY\0" /* 56917 */
	"MEC2_BUSY\0" /* 56927 */
	"DC0_BUSY\0" /* 56937 */
	"DC1_BUSY\0" /* 56946 */
	"RCIU1_BUSY\0" /* 56955 */
	"RCIU2_BUSY\0" /* 56966 */
	"ROQ1_BUSY\0" /* 56977 */
	"ROQ2_BUSY\0" /* 56987 */
	"TCIU_BUSY\0" /* 56997 */
	"SCRATCH_RAM_BUSY\0" /* 57007 */
	"QU_BUSY\0" /* 57024 */
	"UTCL2IU_BUSY\0" /* 57032 */
	"SAVE_RESTORE_BUSY\0" /* 57045 */
	"GCRIU_BUSY\0" /* 57063 */
	"MES_BUSY\0" /* 57074 */
	"MES_SCRATCH_RAM_BUSY\0" /* 57083 */
	"RCIU3_BUSY\0" /* 57104 */
	"MES_INSTRUCTION_CACHE_BUSY\0" /* 57115 */
	"CPG_CPC_BUSY\0" /* 57142 */
	"CPF_CPC_BUSY\0" /* 57155 */
	"MEC1_LOAD_BUSY\0" /* 57168 */
	"MEC1_SEMAPOHRE_BUSY\0" /* 57183 */
	"MEC1_MUTEX_BUSY\0" /* 57203 */
	"MEC1_MESSAGE_BUSY\0" /* 57219 */
	"MEC1_EOP_QUEUE_BUSY\0" /* 57237 */
	"MEC1_IQ_QUEUE_BUSY\0" /* 57257 */
	"MEC1_IB_QUEUE_BUSY\0" /* 57276 */
	"MEC1_TC_BUSY\0" /* 57295, 57300 */
	"MEC1_DMA_BUSY\0" /* 57308 */
	"MEC1_PARTIAL_FLUSH_BUSY\0" /* 57322 */
	"MEC1_PIPE0_BUSY\0" /* 57346 */
	"MEC1_PIPE1_BUSY\0" /* 57362 */
	"MEC1_PIPE2_BUSY\0" /* 57378 */
	"MEC1_PIPE3_BUSY\0" /* 57394 */
	"MEC2_LOAD_BUSY\0" /* 57410 */
	"MEC2_SEMAPOHRE_BUSY\0" /* 57425 */
	"MEC2_MUTEX_BUSY\0" /* 57445 */
	"MEC2_MESSAGE_BUSY\0" /* 57461 */
	"MEC2_EOP_QUEUE_BUSY\0" /* 57479 */
	"MEC2_IQ_QUEUE_BUSY\0" /* 57499 */
	"MEC2_IB_QUEUE_BUSY\0" /* 57518 */
	"MEC2_TC_BUSY\0" /* 57537 */
	"MEC2_DMA_BUSY\0" /* 57550 */
	"MEC2_PARTIAL_FLUSH_BUSY\0" /* 57564 */
	"MEC2_PIPE0_BUSY\0" /* 57588 */
	"MEC2_PIPE1_BUSY\0" /* 57604 */
	"MEC2_PIPE2_BUSY\0" /* 57620 */
	"MEC2_PIPE3_BUSY\0" /* 57636 */
	"RCIU_TX_FREE_STALL\0" /* 57652 */
	"RCIU_PRIV_VIOLATION\0" /* 57671 */
	"TCIU_TX_FREE_STALL\0" /* 57691 */
	"MEC1_DECODING_PACKET\0" /* 57710 */
	"MEC1_WAIT_ON_RCIU\0" /* 57731 */
	"MEC1_WAIT_ON_RCIU_READ\0" /* 57749 */
	"MEC1_WAIT_ON_ROQ_DATA\0" /* 57772 */
	"MEC2_DECODING_PACKET\0" /* 57794 */
	"MEC2_WAIT_ON_RCIU\0" /* 57815 */
	"MEC2_WAIT_ON_RCIU_READ\0" /* 57833 */
	"MEC2_WAIT_ON_ROQ_DATA\0" /* 57856 */
	"UTCL2IU_WAITING_ON_FREE\0" /* 57878 */
	"UTCL2IU_WAITING_ON_TAGS\0" /* 57902 */
	"UTCL1_WAITING_ON_TRANS\0" /* 57926 */
	"GCRIU_WAITING_ON_FREE\0" /* 57949 */
	"POST_WPTR_GFX_BUSY\0" /* 57971 */
	"CSF_BUSY\0" /* 57990 */
	"ROQ_ALIGN_BUSY\0" /* 57999 */
	"ROQ_RING_BUSY\0" /* 58014 */
	"ROQ_INDIRECT1_BUSY\0" /* 58028 */
	"ROQ_INDIRECT2_BUSY\0" /* 58047 */
	"ROQ_STATE_BUSY\0" /* 58066 */
	"ROQ_CE_RING_BUSY\0" /* 58081 */
	"ROQ_CE_INDIRECT1_BUSY\0" /* 58098 */
	"ROQ_CE_INDIRECT2_BUSY\0" /* 58120 */
	"SEMAPHORE_BUSY\0" /* 58142 */
	"INTERRUPT_BUSY\0" /* 58157 */
	"HQD_BUSY\0" /* 58172 */
	"PRT_BUSY\0" /* 58181 */
	"RCIU_BUSY\0" /* 58190 */
	"RCIU_GFX_BUSY\0" /* 58200 */
	"RCIU_CMP_BUSY\0" /* 58214 */
	"ROQ_DATA_BUSY\0" /* 58228 */
	"ROQ_CE_DATA_BUSY\0" /* 58242 */
	"MES_HQD_BUSY\0" /* 58259 */
	"CPF_GFX_BUSY\0" /* 58272 */
	"CPF_CMP_BUSY\0" /* 58285 */
	"GRBM_CPF_STAT_BUSY\0" /* 58298 */
	"CPC_CPF_BUSY\0" /* 58317 */
	"REG_BUS_FIFO_BUSY\0" /* 58330 */
	"CSF_RING_BUSY\0" /* 58348 */
	"CSF_INDIRECT1_BUSY\0" /* 58362 */
	"CSF_INDIRECT2_BUSY\0" /* 58381 */
	"CSF_STATE_BUSY\0" /* 58400 */
	"CSF_CE_INDR1_BUSY\0" /* 58415 */
	"CSF_CE_INDR2_BUSY\0" /* 58433 */
	"CSF_ARBITER_BUSY\0" /* 58451 */
	"CSF_INPUT_BUSY\0" /* 58468 */
	"CSF_DATA_BUSY\0" /* 58483 */
	"CSF_CE_DATA_BUSY\0" /* 58497 */
	"HPD_PROCESSING_EOP_BUSY\0" /* 58514 */
	"HQD_DISPATCH_BUSY\0" /* 58538 */
	"HQD_IQ_TIMER_BUSY\0" /* 58556 */
	"HQD_DMA_OFFLOAD_BUSY\0" /* 58574 */
	"HQD_WAIT_SEMAPHORE_BUSY\0" /* 58595 */
	"HQD_SIGNAL_SEMAPHORE_BUSY\0" /* 58619 */
	"HQD_MESSAGE_BUSY\0" /* 58645 */
	"HQD_PQ_FETCHER_BUSY\0" /* 58662 */
	"HQD_IB_FETCHER_BUSY\0" /* 58682 */
	"HQD_IQ_FETCHER_BUSY\0" /* 58702 */
	"HQD_EOP_FETCHER_BUSY\0" /* 58722 */
	"HQD_CONSUMED_RPTR_BUSY\0" /* 58743 */
	"HQD_FETCHER_ARB_BUSY\0" /* 58766 */
	"HQD_ROQ_ALIGN_BUSY\0" /* 58787 */
	"HQD_ROQ_EOP_BUSY\0" /* 58806 */
	"HQD_ROQ_IQ_BUSY\0" /* 58823 */
	"HQD_ROQ_PQ_BUSY\0" /* 58839 */
	"HQD_ROQ_IB_BUSY\0" /* 58855 */
	"HQD_WPTR_POLL_BUSY\0" /* 58871 */
	"HQD_PQ_BUSY\0" /* 58890 */
	"HQD_IB_BUSY\0" /* 58902 */
	"RING_FETCHING_DATA\0" /* 58914 */
	"INDR1_FETCHING_DATA\0" /* 58933 */
	"INDR2_FETCHING_DATA\0" /* 58953 */
	"STATE_FETCHING_DATA\0" /* 58973 */
	"TCIU_WAITING_ON_FREE\0" /* 58993 */
	"TCIU_WAITING_ON_TAGS\0" /* 59014 */
	"GFX_UTCL1_WAITING_ON_TRANS\0" /* 59035 */
	"CMP_UTCL1_WAITING_ON_TRANS\0" /* 59062 */
	"RCIU_WAITING_ON_FREE\0" /* 59089 */
	"DATA_FETCHING_DATA\0" /* 59110 */
	"GCRIU_WAIT_ON_FREE\0" /* 59129 */
	"MES_LOAD_BUSY\0" /* 59148 */
	"MES_MUTEX_BUSY\0" /* 59162 */
	"MES_MESSAGE_BUSY\0" /* 59177 */
	"MES_TC_BUSY\0" /* 59194 */
	"MES_DMA_BUSY\0" /* 59206 */
	"MES_PIPE0_BUSY\0" /* 59219 */
	"MES_PIPE1_BUSY\0" /* 59234 */
	"MES_PIPE2_BUSY\0" /* 59249 */
	"MES_PIPE3_BUSY\0" /* 59264 */
	"SCRATCH_INDEX_64BIT_MODE\0" /* 59279 */
	"MES_HQD_DISPATCH_BUSY\0" /* 59304 */
	"MES_HQD_DMA_OFFLOAD_BUSY\0" /* 59326 */
	"MES_HQD_MESSAGE_BUSY\0" /* 59351 */
	"MES_HQD_PQ_FETCHER_BUSY\0" /* 59372 */
	"MES_HQD_CONSUMED_RPTR_BUSY\0" /* 59396 */
	"MES_HQD_FETCHER_ARB_BUSY\0" /* 59423 */
	"MES_HQD_ROQ_ALIGN_BUSY\0" /* 59448 */
	"MES_HQD_ROQ_PQ_BUSY\0" /* 59471 */
	"MES_HQD_PQ_BUSY\0" /* 59491 */
	"BUFFER_ID\0" /* 59507 */
	"SIMD_SEL\0" /* 59517 */
	"WGP_SEL\0" /* 59526 */
	"SA_SEL\0" /* 59534 */
	"WTYPE_INCLUDE\0" /* 59541 */
	"TOKEN_EXCLUDE_VMEMEXEC\0" /* 59555 */
	"TOKEN_EXCLUDE_ALUEXEC\0" /* 59578 */
	"TOKEN_EXCLUDE_VALUINST\0" /* 59600 */
	"TOKEN_EXCLUDE_WAVERDY\0" /* 59623 */
	"TOKEN_EXCLUDE_IMMED1\0" /* 59645 */
	"TOKEN_EXCLUDE_IMMEDIATE\0" /* 59666, 59680 */
	"TOKEN_EXCLUDE_REG\0" /* 59690 */
	"TOKEN_EXCLUDE_EVENT\0" /* 59708 */
	"TOKEN_EXCLUDE_INST\0" /* 59728 */
	"TOKEN_EXCLUDE_UTILCTR\0" /* 59747 */
	"TOKEN_EXCLUDE_WAVEALLOC\0" /* 59769 */
	"TOKEN_EXCLUDE_PERF\0" /* 59793 */
	"TOKEN_EXCLUDE\0" /* 59812 */
	"REG_INCLUDE_SQDEC\0" /* 59826 */
	"REG_INCLUDE_SHDEC\0" /* 59844 */
	"REG_INCLUDE_GFXUDEC\0" /* 59862 */
	"REG_INCLUDE_COMP\0" /* 59882 */
	"REG_INCLUDE_CONTEXT\0" /* 59899 */
	"REG_INCLUDE_CONFIG\0" /* 59919 */
	"REG_INCLUDE_OTHER\0" /* 59938 */
	"REG_INCLUDE_READS\0" /* 59956 */
	"REG_INCLUDE\0" /* 59974 */
	"INST_EXCLUDE\0" /* 59986 */
	"REG_DETAIL_ALL\0" /* 59999 */
	"ALL_VMID\0" /* 60014 */
	"CH_PERF_EN\0" /* 60023 */
	"INTERRUPT_EN\0" /* 60034 */
	"DOUBLE_BUFFER\0" /* 60047 */
	"REG_STALL_EN\0" /* 60061 */
	"SPI_STALL_EN\0" /* 60074 */
	"SQ_STALL_EN\0" /* 60087 */
	"REG_DROP_ON_STALL\0" /* 60099 */
	"UTIL_TIMER\0" /* 60117 */
	"WAVESTART_MODE\0" /* 60128 */
	"RT_FREQ\0" /* 60143 */
	"SYNC_COUNT_MARKERS\0" /* 60151 */
	"SYNC_COUNT_DRAWS\0" /* 60170 */
	"CAPTURE_ALL\0" /* 60187 */
	"DRAW_EVENT_EN\0" /* 60199 */
	"FINISH_PENDING\0" /* 60213 */
	"FINISH_DONE\0" /* 60228, 60235 */
	"UTC_ERR\0" /* 60240 */
	"EVENT_CNTR_OVERFLOW\0" /* 60248 */
	"EVENT_CNTR_STALL\0" /* 60268 */
	"SQ_EXP_MRT\0" /* 60285 */
	"SQ_EXP_MRTZ\0" /* 60296 */
	"SQ_EXP_NULL\0" /* 60308 */
	"SQ_EXP_POS\0" /* 60320 */
	"SQ_EXP_PRIM\0" /* 60331 */
	"SQ_EXP_PARAM\0" /* 60343 */
	"TGT\0" /* 60356 */
	"COMPR\0" /* 60360 */
	"VM\0" /* 60366 */
	"BASE_ADDRESS\0" /* 60369 */
	"BASE_ADDRESS_HI\0" /* 60382, 60387 */
	"CACHE_SWIZZLE\0" /* 60398 */
	"SWIZZLE_ENABLE\0" /* 60412 */
	"NUM_RECORDS\0" /* 60427 */
	"DST_SEL_X\0" /* 60439 */
	"DST_SEL_Y\0" /* 60449 */
	"DST_SEL_Z\0" /* 60459 */
	"DST_SEL_W\0" /* 60469 */
	"IMG_FORMAT_INVALID\0" /* 60479 */
	"IMG_FORMAT_8_UNORM\0" /* 60498 */
	"IMG_FORMAT_8_SNORM\0" /* 60517 */
	"IMG_FORMAT_8_USCALED\0" /* 60536 */
	"IMG_FORMAT_8_SSCALED\0" /* 60557 */
	"IMG_FORMAT_8_UINT\0" /* 60578 */
	"IMG_FORMAT_8_SINT\0" /* 60596 */
	"IMG_FORMAT_16_UNORM\0" /* 60614 */
	"IMG_FORMAT_16_SNORM\0" /* 60634 */
	"IMG_FORMAT_16_USCALED\0" /* 60654 */
	"IMG_FORMAT_16_SSCALED\0" /* 60676 */
	"IMG_FORMAT_16_UINT\0" /* 60698 */
	"IMG_FORMAT_16_SINT\0" /* 60717 */
	"IMG_FORMAT_16_FLOAT\0" /* 60736 */
	"IMG_FORMAT_8_8_UNORM\0" /* 60756 */
	"IMG_FORMAT_8_8_SNORM\0" /* 60777 */
	"IMG_FORMAT_8_8_USCALED\0" /* 60798 */
	"IMG_FORMAT_8_8_SSCALED\0" /* 60821 */
	"IMG_FORMAT_8_8_UINT\0" /* 60844 */
	"IMG_FORMAT_8_8_SINT\0" /* 60864 */
	"IMG_FORMAT_32_UINT\0" /* 60884 */
	"IMG_FORMAT_32_SINT\0" /* 60903 */
	"IMG_FORMAT_32_FLOAT\0" /* 60922 */
	"IMG_FORMAT_16_16_UNORM\0" /* 60942 */
	"IMG_FORMAT_16_16_SNORM\0" /* 60965 */
	"IMG_FORMAT_16_16_USCALED\0" /* 60988 */
	"IMG_FORMAT_16_16_SSCALED\0" /* 61013 */
	"IMG_FORMAT_16_16_UINT\0" /* 61038 */
	"IMG_FORMAT_16_16_SINT\0" /* 61060 */
	"IMG_FORMAT_16_16_FLOAT\0" /* 61082 */
	"IMG_FORMAT_10_11_11_UNORM\0" /* 61105 */
	"IMG_FORMAT_10_11_11_SNORM\0" /* 61131 */
	"IMG_FORMAT_10_11_11_USCALED\0" /* 61157 */
	"IMG_FORMAT_10_11_11_SSCALED\0" /* 61185 */
	"IMG_FORMAT_10_11_11_UINT\0" /* 61213 */
	"IMG_FORMAT_10_11_11_SINT\0" /* 61238 */
	"IMG_FORMAT_10_11_11_FLOAT\0" /* 61263 */
	"IMG_FORMAT_11_11_10_UNORM\0" /* 61289 */
	"IMG_FORMAT_11_11_10_SNORM\0" /* 61315 */
	"IMG_FORMAT_11_11_10_USCALED\0" /* 61341 */
	"IMG_FORMAT_11_11_10_SSCALED\0" /* 61369 */
	"IMG_FORMAT_11_11_10_UINT\0" /* 61397 */
	"IMG_FORMAT_11_11_10_SINT\0" /* 61422 */
	"IMG_FORMAT_11_11_10_FLOAT\0" /* 61447 */
	"IMG_FORMAT_10_10_10_2_UNORM\0" /* 61473 */
	"IMG_FORMAT_10_10_10_2_SNORM\0" /* 61501 */
	"IMG_FORMAT_10_10_10_2_USCALED\0" /* 61529 */
	"IMG_FORMAT_10_10_10_2_SSCALED\0" /* 61559 */
	"IMG_FORMAT_10_10_10_2_UINT\0" /* 61589 */
	"IMG_FORMAT_10_10_10_2_SINT\0" /* 61616 */
	"IMG_FORMAT_2_10_10_10_UNORM\0" /* 61643 */
	"IMG_FORMAT_2_10_10_10_SNORM\0" /* 61671 */
	"IMG_FORMAT_2_10_10_10_USCALED\0" /* 61699 */
	"IMG_FORMAT_2_10_10_10_SSCALED\0" /* 61729 */
	"IMG_FORMAT_2_10_10_10_UINT\0" /* 61759 */
	"IMG_FORMAT_2_10_10_10_SINT\0" /* 61786 */
	"IMG_FORMAT_8_8_8_8_UNORM\0" /* 61813 */
	"IMG_FORMAT_8_8_8_8_SNORM\0" /* 61838 */
	"IMG_FORMAT_8_8_8_8_USCALED\0" /* 61863 */
	"IMG_FORMAT_8_8_8_8_SSCALED\0" /* 61890 */
	"IMG_FORMAT_8_8_8_8_UINT\0" /* 61917 */
	"IMG_FORMAT_8_8_8_8_SINT\0" /* 61941 */
	"IMG_FORMAT_32_32_UINT\0" /* 61965 */
	"IMG_FORMAT_32_32_SINT\0" /* 61987 */
	"IMG_FORMAT_32_32_FLOAT\0" /* 62009 */
	"IMG_FORMAT_16_16_16_16_UNORM\0" /* 62032 */
	"IMG_FORMAT_16_16_16_16_SNORM\0" /* 62061 */
	"IMG_FORMAT_16_16_16_16_USCALED\0" /* 62090 */
	"IMG_FORMAT_16_16_16_16_SSCALED\0" /* 62121 */
	"IMG_FORMAT_16_16_16_16_UINT\0" /* 62152 */
	"IMG_FORMAT_16_16_16_16_SINT\0" /* 62180 */
	"IMG_FORMAT_16_16_16_16_FLOAT\0" /* 62208 */
	"IMG_FORMAT_32_32_32_UINT\0" /* 62237 */
	"IMG_FORMAT_32_32_32_SINT\0" /* 62262 */
	"IMG_FORMAT_32_32_32_FLOAT\0" /* 62287 */
	"IMG_FORMAT_32_32_32_32_UINT\0" /* 62313 */
	"IMG_FORMAT_32_32_32_32_SINT\0" /* 62341 */
	"IMG_FORMAT_32_32_32_32_FLOAT\0" /* 62369 */
	"IMG_FORMAT_8_SRGB\0" /* 62398 */
	"IMG_FORMAT_8_8_SRGB\0" /* 62416 */
	"IMG_FORMAT_8_8_8_8_SRGB\0" /* 62436 */
	"IMG_FORMAT_6E4_FLOAT\0" /* 62460 */
	"IMG_FORMAT_5_9_9_9_FLOAT\0" /* 62481 */
	"IMG_FORMAT_5_6_5_UNORM\0" /* 62506 */
	"IMG_FORMAT_1_5_5_5_UNORM\0" /* 62529 */
	"IMG_FORMAT_5_5_5_1_UNORM\0" /* 62554 */
	"IMG_FORMAT_4_4_4_4_UNORM\0" /* 62579 */
	"IMG_FORMAT_4_4_UNORM\0" /* 62604 */
	"IMG_FORMAT_1_UNORM\0" /* 62625 */
	"IMG_FORMAT_1_REVERSED_UNORM\0" /* 62644 */
	"IMG_FORMAT_32_FLOAT_CLAMP\0" /* 62672 */
	"IMG_FORMAT_8_24_UNORM\0" /* 62698 */
	"IMG_FORMAT_8_24_UINT\0" /* 62720 */
	"IMG_FORMAT_24_8_UNORM\0" /* 62741 */
	"IMG_FORMAT_24_8_UINT\0" /* 62763 */
	"IMG_FORMAT_X24_8_32_UINT\0" /* 62784 */
	"IMG_FORMAT_X24_8_32_FLOAT\0" /* 62809 */
	"IMG_FORMAT_GB_GR_UNORM\0" /* 62835 */
	"IMG_FORMAT_GB_GR_SNORM\0" /* 62858 */
	"IMG_FORMAT_GB_GR_UINT\0" /* 62881 */
	"IMG_FORMAT_GB_GR_SRGB\0" /* 62903 */
	"IMG_FORMAT_BG_RG_UNORM\0" /* 62925 */
	"IMG_FORMAT_BG_RG_SNORM\0" /* 62948 */
	"IMG_FORMAT_BG_RG_UINT\0" /* 62971 */
	"IMG_FORMAT_BG_RG_SRGB\0" /* 62993 */
	"IMG_FORMAT_FMASK8_S2_F1\0" /* 63015 */
	"IMG_FORMAT_FMASK8_S4_F1\0" /* 63039 */
	"IMG_FORMAT_FMASK8_S8_F1\0" /* 63063 */
	"IMG_FORMAT_FMASK8_S2_F2\0" /* 63087 */
	"IMG_FORMAT_FMASK8_S4_F2\0" /* 63111 */
	"IMG_FORMAT_FMASK8_S4_F4\0" /* 63135 */
	"IMG_FORMAT_FMASK16_S16_F1\0" /* 63159 */
	"IMG_FORMAT_FMASK16_S8_F2\0" /* 63185 */
	"IMG_FORMAT_FMASK32_S16_F2\0" /* 63210 */
	"IMG_FORMAT_FMASK32_S8_F4\0" /* 63236 */
	"IMG_FORMAT_FMASK32_S8_F8\0" /* 63261 */
	"IMG_FORMAT_FMASK64_S16_F4\0" /* 63286 */
	"IMG_FORMAT_FMASK64_S16_F8\0" /* 63312 */
	"IMG_FORMAT_BC1_UNORM\0" /* 63338 */
	"IMG_FORMAT_BC1_SRGB\0" /* 63359 */
	"IMG_FORMAT_BC2_UNORM\0" /* 63379 */
	"IMG_FORMAT_BC2_SRGB\0" /* 63400 */
	"IMG_FORMAT_BC3_UNORM\0" /* 63420 */
	"IMG_FORMAT_BC3_SRGB\0" /* 63441 */
	"IMG_FORMAT_BC4_UNORM\0" /* 63461 */
	"IMG_FORMAT_BC4_SNORM\0" /* 63482 */
	"IMG_FORMAT_BC5_UNORM\0" /* 63503 */
	"IMG_FORMAT_BC5_SNORM\0" /* 63524 */
	"IMG_FORMAT_BC6_UFLOAT\0" /* 63545 */
	"IMG_FORMAT_BC6_SFLOAT\0" /* 63567 */
	"IMG_FORMAT_BC7_UNORM\0" /* 63589 */
	"IMG_FORMAT_BC7_SRGB\0" /* 63610 */
	"IMG_FORMAT_MM_8_UNORM\0" /* 63630 */
	"IMG_FORMAT_MM_8_UINT\0" /* 63652 */
	"IMG_FORMAT_MM_8_8_UNORM\0" /* 63673 */
	"IMG_FORMAT_MM_8_8_UINT\0" /* 63697 */
	"IMG_FORMAT_MM_8_8_8_8_UNORM\0" /* 63720 */
	"IMG_FORMAT_MM_8_8_8_8_UINT\0" /* 63748 */
	"IMG_FORMAT_MM_VYUY8_UNORM\0" /* 63775 */
	"IMG_FORMAT_MM_VYUY8_UINT\0" /* 63801 */
	"IMG_FORMAT_MM_10_11_11_UNORM\0" /* 63826 */
	"IMG_FORMAT_MM_10_11_11_UINT\0" /* 63855 */
	"IMG_FORMAT_MM_2_10_10_10_UNORM\0" /* 63883 */
	"IMG_FORMAT_MM_2_10_10_10_UINT\0" /* 63914 */
	"IMG_FORMAT_MM_16_16_16_16_UNORM\0" /* 63944 */
	"IMG_FORMAT_MM_16_16_16_16_UINT\0" /* 63976 */
	"IMG_FORMAT_MM_10_IN_16_UNORM\0" /* 64007 */
	"IMG_FORMAT_MM_10_IN_16_UINT\0" /* 64036 */
	"IMG_FORMAT_MM_10_IN_16_16_UNORM\0" /* 64064 */
	"IMG_FORMAT_MM_10_IN_16_16_UINT\0" /* 64096 */
	"IMG_FORMAT_MM_10_IN_16_16_16_16_UNORM \0" /* 64127 */
	"IMG_FORMAT_MM_10_IN_16_16_16_16_UINT\0" /* 64166 */
	"IMG_FORMAT_7E3_FLOAT\0" /* 64203 */
	"IMG_FORMAT_YCBCR_UNORM\0" /* 64224 */
	"IMG_FORMAT_YCBCR_SNORM\0" /* 64247 */
	"IMG_FORMAT_YCBCR_USCALED\0" /* 64270 */
	"IMG_FORMAT_YCBCR_SSCALED\0" /* 64295 */
	"IMG_FORMAT_YCBCR_UINT\0" /* 64320 */
	"IMG_FORMAT_YCBCR_SINT\0" /* 64342 */
	"IMG_FORMAT_YCBCR_SRGB\0" /* 64364 */
	"INDEX_STRIDE\0" /* 64386 */
	"ADD_TID_ENABLE\0" /* 64399 */
	"RESOURCE_LEVEL\0" /* 64414 */
	"OOB_SELECT_STRUCTURED_WITH_OFFSET\0" /* 64429 */
	"OOB_SELECT_STRUCTURED\0" /* 64463 */
	"OOB_SELECT_DISABLED\0" /* 64485 */
	"OOB_SELECT_RAW\0" /* 64505, 64516 */
	"OOB_SELECT\0" /* 64520 */
	"CLAMP_X\0" /* 64531 */
	"CLAMP_Y\0" /* 64539 */
	"CLAMP_Z\0" /* 64547 */
	"MAX_ANISO_RATIO\0" /* 64555 */
	"DEPTH_COMPARE_FUNC\0" /* 64571 */
	"FORCE_UNNORMALIZED\0" /* 64590 */
	"ANISO_THRESHOLD\0" /* 64609 */
	"MC_COORD_TRUNC\0" /* 64625 */
	"FORCE_DEGAMMA\0" /* 64640 */
	"ANISO_BIAS\0" /* 64654 */
	"TRUNC_COORD\0" /* 64665 */
	"DISABLE_CUBE_WRAP\0" /* 64677, 64690 */
	"FILTER_MODE\0" /* 64695 */
	"SKIP_DEGAMMA\0" /* 64707 */
	"MIN_LOD\0" /* 64720 */
	"MAX_LOD\0" /* 64728 */
	"PERF_MIP\0" /* 64736 */
	"PERF_Z\0" /* 64745 */
	"LOD_BIAS\0" /* 64752 */
	"BORDER_COLOR_PTR\0" /* 64761 */
	"BORDER_COLOR_TYPE\0" /* 64778 */
	"LOD_BIAS_SEC\0" /* 64796 */
	"XY_MAG_FILTER\0" /* 64809 */
	"XY_MIN_FILTER\0" /* 64823 */
	"Z_FILTER\0" /* 64837 */
	"MIP_FILTER\0" /* 64846 */
	"MIP_POINT_PRECLAMP\0" /* 64857 */
	"ANISO_OVERRIDE\0" /* 64876 */
	"BLEND_ZERO_PRT\0" /* 64891 */
	"DERIV_ADJUST_EN\0" /* 64906 */
	"GPR_WRITE_PRIORITY\0" /* 64922, 64932 */
	"EXP_PRIORITY_ORDER\0" /* 64941 */
	"ENABLE_SQG_TOP_EVENTS\0" /* 64960 */
	"ENABLE_SQG_BOP_EVENTS\0" /* 64982 */
	"RSRC_MGMT_RESET\0" /* 65004 */
	"TTRACE_STALL_ALL\0" /* 65020 */
	"ALLOC_ARB_LRU_ENA\0" /* 65037 */
	"EXP_ARB_LRU_ENA\0" /* 65055 */
	"PS_PKR_PRIORITY_CNTL\0" /* 65071 */
	"NUM_PIPES\0" /* 65092 */
	"PIPE_INTERLEAVE_SIZE\0" /* 65102 */
	"MAX_COMPRESSED_FRAGS\0" /* 65123 */
	"NUM_SHADER_ENGINES\0" /* 65144 */
	"NUM_RB_PER_SE\0" /* 65163 */
	"ARRAY_LINEAR_GENERAL\0" /* 65177, 65183 */
	"ARRAY_LINEAR_ALIGNED\0" /* 65198 */
	"ARRAY_1D_TILED_THIN1\0" /* 65219 */
	"ARRAY_1D_TILED_THICK\0" /* 65240 */
	"ARRAY_2D_TILED_THIN1\0" /* 65261 */
	"ARRAY_PRT_TILED_THIN1\0" /* 65282 */
	"ARRAY_PRT_2D_TILED_THIN1\0" /* 65304 */
	"ARRAY_2D_TILED_THICK\0" /* 65329 */
	"ARRAY_2D_TILED_XTHICK\0" /* 65350 */
	"ARRAY_PRT_TILED_THICK\0" /* 65372 */
	"ARRAY_PRT_2D_TILED_THICK\0" /* 65394 */
	"ARRAY_PRT_3D_TILED_THIN1\0" /* 65419 */
	"ARRAY_3D_TILED_THIN1\0" /* 65444 */
	"ARRAY_3D_TILED_THICK\0" /* 65465 */
	"ARRAY_3D_TILED_XTHICK\0" /* 65486 */
	"ARRAY_PRT_3D_TILED_THICK\0" /* 65508 */
	"ARRAY_MODE\0" /* 65533 */
	"ADDR_SURF_P2\0" /* 65544 */
	"ADDR_SURF_P2_RESERVED0\0" /* 65557 */
	"ADDR_SURF_P2_RESERVED1\0" /* 65580, 65593 */
	"ADDR_SURF_P2_RESERVED2\0" /* 65603, 65616 */
	"ADDR_SURF_P4_8x16\0" /* 65626 */
	"ADDR_SURF_P4_16x16\0" /* 65644 */
	"ADDR_SURF_P4_16x32\0" /* 65663 */
	"ADDR_SURF_P4_32x32\0" /* 65682 */
	"ADDR_SURF_P8_16x16_8x16\0" /* 65701 */
	"ADDR_SURF_P8_16x32_8x16\0" /* 65725 */
	"ADDR_SURF_P8_32x32_8x16\0" /* 65749 */
	"ADDR_SURF_P8_16x32_16x16\0" /* 65773 */
	"ADDR_SURF_P8_32x32_16x16\0" /* 65798 */
	"ADDR_SURF_P8_32x32_16x32\0" /* 65823 */
	"ADDR_SURF_P8_32x64_32x32\0" /* 65848 */
	"ADDR_SURF_P8_RESERVED0\0" /* 65873 */
	"ADDR_SURF_P16_32x32_8x16\0" /* 65896 */
	"ADDR_SURF_P16_32x32_16x16\0" /* 65921 */
	"ADDR_SURF_P16\0" /* 65947 */
	"PIPE_CONFIG\0" /* 65961 */
	"ADDR_SURF_TILE_SPLIT_64B\0" /* 65973 */
	"ADDR_SURF_TILE_SPLIT_128B\0" /* 65998 */
	"ADDR_SURF_TILE_SPLIT_256B\0" /* 66024 */
	"ADDR_SURF_TILE_SPLIT_512B\0" /* 66050 */
	"ADDR_SURF_TILE_SPLIT_1KB\0" /* 66076 */
	"ADDR_SURF_TILE_SPLIT_2KB\0" /* 66101 */
	"ADDR_SURF_TILE_SPLIT_4KB\0" /* 66126 */
	"TILE_SPLIT\0" /* 66151 */
	"ADDR_SURF_DISPLAY_MICRO_TILING\0" /* 66162 */
	"ADDR_SURF_THIN_MICRO_TILING\0" /* 66193 */
	"ADDR_SURF_DEPTH_MICRO_TILING\0" /* 66221 */
	"ADDR_SURF_ROTATED_MICRO_TILING\0" /* 66250 */
	"ADDR_SURF_THICK_MICRO_TILING\0" /* 66281 */
	"MICRO_TILE_MODE_NEW\0" /* 66310 */
	"SAMPLE_SPLIT\0" /* 66330 */
	"ADDR_SURF_BANK_WIDTH_1\0" /* 66343 */
	"ADDR_SURF_BANK_WIDTH_2\0" /* 66366 */
	"ADDR_SURF_BANK_WIDTH_4\0" /* 66389 */
	"ADDR_SURF_BANK_WIDTH_8\0" /* 66412 */
	"BANK_WIDTH\0" /* 66435, 66440 */
	"ADDR_SURF_BANK_HEIGHT_1\0" /* 66446 */
	"ADDR_SURF_BANK_HEIGHT_2\0" /* 66470 */
	"ADDR_SURF_BANK_HEIGHT_4\0" /* 66494 */
	"ADDR_SURF_BANK_HEIGHT_8\0" /* 66518 */
	"BANK_HEIGHT\0" /* 66542, 66547 */
	"ADDR_SURF_MACRO_ASPECT_1\0" /* 66554 */
	"ADDR_SURF_MACRO_ASPECT_2\0" /* 66579 */
	"ADDR_SURF_MACRO_ASPECT_4\0" /* 66604 */
	"ADDR_SURF_MACRO_ASPECT_8\0" /* 66629 */
	"MACRO_TILE_ASPECT\0" /* 66654 */
	"ADDR_SURF_2_BANK\0" /* 66672 */
	"ADDR_SURF_4_BANK\0" /* 66689 */
	"ADDR_SURF_8_BANK\0" /* 66706 */
	"ADDR_SURF_16_BANK\0" /* 66723 */
	"NUM_BANKS\0" /* 66741 */
	"WIDTH_LO\0" /* 66751 */
	"WIDTH_HI\0" /* 66760 */
	"BASE_LEVEL\0" /* 66769 */
	"LAST_LEVEL\0" /* 66780 */
	"SW_MODE\0" /* 66791 */
	"BC_SWIZZLE_XYZW\0" /* 66799 */
	"BC_SWIZZLE_XWYZ\0" /* 66815 */
	"BC_SWIZZLE_WZYX\0" /* 66831 */
	"BC_SWIZZLE_WXYZ\0" /* 66847 */
	"BC_SWIZZLE_ZYXW\0" /* 66863 */
	"BC_SWIZZLE_YXWZ\0" /* 66879 */
	"BC_SWIZZLE\0" /* 66895 */
	"BASE_ARRAY\0" /* 66906 */
	"ARRAY_PITCH\0" /* 66917 */
	"MAX_MIP\0" /* 66929 */
	"MIN_LOD_WARN\0" /* 66937 */
	"PERF_MOD\0" /* 66950 */
	"CORNER_SAMPLES\0" /* 66959 */
	"LOD_HDW_CNT_EN\0" /* 66974 */
	"PRT_DEFAULT\0" /* 66989 */
	"COUNTER_BANK_ID\0" /* 67001 */
	"ITERATE_256\0" /* 67017 */
	"MAX_UNCOMPRESSED_BLOCK_SIZE\0" /* 67029 */
	"MAX_COMPRESSED_BLOCK_SIZE\0" /* 67057 */
	"META_PIPE_ALIGNED\0" /* 67083, 67088 */
	"WRITE_COMPRESS_ENABLE\0" /* 67101 */
	"COMPRESSION_EN\0" /* 67123 */
	"ALPHA_IS_ON_MSB\0" /* 67138 */
	"COLOR_TRANSFORM\0" /* 67154 */
	"META_DATA_ADDRESS_LO\0" /* 67170 */
	"CU_EN\0" /* 67191 */
	"CHECKSUM\0" /* 67197 */
	"WAVE_LIMIT\0" /* 67206, 67211 */
	"LOCK_LOW_THRESHOLD\0" /* 67217 */
	"MEM_BASE\0" /* 67236 */
	"VGPRS\0" /* 67245 */
	"SGPRS\0" /* 67251 */
	"FP_32_DENORMS\0" /* 67257 */
	"FP_64_DENORMS\0" /* 67271 */
	"FP_ALL_DENORMS\0" /* 67285 */
	"FLOAT_MODE\0" /* 67300 */
	"IEEE_MODE\0" /* 67311 */
	"CU_GROUP_DISABLE\0" /* 67321 */
	"MEM_ORDERED\0" /* 67338 */
	"SCRATCH_EN\0" /* 67350 */
	"USER_SGPR\0" /* 67361 */
	"TRAP_PRESENT\0" /* 67371 */
	"WAVE_CNT_EN\0" /* 67384 */
	"EXTRA_LDS_SIZE\0" /* 67396 */
	"LOAD_COLLISION_WAVEID\0" /* 67411 */
	"LOAD_INTRAWAVE_COLLISION\0" /* 67433 */
	"USER_SGPR_MSB\0" /* 67458 */
	"SHARED_VGPR_CNT\0" /* 67472 */
	"SOFT_GROUPING_EN\0" /* 67488 */
	"NUMBER_OF_REQUESTS_PER_CU\0" /* 67505 */
	"SOFT_GROUPING_ALLOCATION_TIMEOUT\0" /* 67531 */
	"HARD_LOCK_HYSTERESIS\0" /* 67564 */
	"HARD_LOCK_LOW_THRESHOLD\0" /* 67585 */
	"PRODUCER_REQUEST_LOCKOUT\0" /* 67609 */
	"GLOBAL_SCANNING_EN\0" /* 67634 */
	"ALLOCATION_RATE_THROTTLING_THRESHOLD\0" /* 67653 */
	"TOTAL_WAVE_COUNT_HIER_SELECT\0" /* 67690 */
	"PER_TYPE_WAVE_COUNT_HIER_SELECT\0" /* 67719 */
	"GROUP_UPDATE_EN\0" /* 67751 */
	"TOTAL_WAVE_COUNT_COEFFICIENT\0" /* 67767 */
	"PER_TYPE_WAVE_COUNT_COEFFICIENT\0" /* 67796 */
	"CONTRIBUTION\0" /* 67828 */
	"VGPR_COMP_CNT\0" /* 67841 */
	"CU_GROUP_ENABLE\0" /* 67855 */
	"OC_LDS_EN\0" /* 67871 */
	"SO_BASE0_EN\0" /* 67881 */
	"SO_BASE1_EN\0" /* 67893 */
	"SO_BASE2_EN\0" /* 67905 */
	"SO_BASE3_EN\0" /* 67917 */
	"SO_EN\0" /* 67929 */
	"PC_BASE_EN\0" /* 67935 */
	"DISPATCH_DRAW_EN\0" /* 67946 */
	"SKIP_USGPR0\0" /* 67963 */
	"SPI_SHADER_LATE_ALLOC_GS\0" /* 67975 */
	"GROUP_FIFO_DEPTH\0" /* 68000 */
	"WGP_MODE\0" /* 68017 */
	"GS_VGPR_COMP_CNT\0" /* 68026 */
	"ES_VGPR_COMP_CNT\0" /* 68043 */
	"LS_VGPR_COMP_CNT\0" /* 68060 */
	"TG_SIZE_EN\0" /* 68077 */
	"COMPUTE_SHADER_EN\0" /* 68088 */
	"PARTIAL_TG_EN\0" /* 68106 */
	"FORCE_START_AT_000\0" /* 68120 */
	"ORDERED_APPEND_ENBL\0" /* 68139 */
	"ORDERED_APPEND_MODE\0" /* 68159 */
	"USE_THREAD_DIMENSIONS\0" /* 68179 */
	"ORDER_MODE\0" /* 68201 */
	"SCALAR_L1_INV_VOL\0" /* 68212, 68226 */
	"VECTOR_L1_INV_VOL\0" /* 68230 */
	"TUNNEL_ENABLE\0" /* 68248 */
	"RESTORE\0" /* 68262 */
	"CS_W32_EN\0" /* 68270 */
	"START\0" /* 68280 */
	"NUM_THREAD_FULL\0" /* 68286, 68297 */
	"NUM_THREAD_PARTIAL\0" /* 68302 */
	"BULKY\0" /* 68321 */
	"TGID_X_EN\0" /* 68327 */
	"TGID_Y_EN\0" /* 68337 */
	"TGID_Z_EN\0" /* 68347 */
	"TIDIG_COMP_CNT\0" /* 68357 */
	"EXCP_EN_MSB\0" /* 68372 */
	"WAVES_PER_SH\0" /* 68384 */
	"TG_PER_CU\0" /* 68397 */
	"LOCK_THRESHOLD\0" /* 68407 */
	"SIMD_DEST_CNTL\0" /* 68422 */
	"FORCE_SIMD_DIST\0" /* 68437 */
	"CU_GROUP_COUNT\0" /* 68453 */
	"WAVES\0" /* 68468 */
	"WAVESIZE\0" /* 68474 */
	"RESTART\0" /* 68483 */
	"SEND_SEID\0" /* 68491 */
	"RESERVED3\0" /* 68501 */
	"RESERVED4\0" /* 68511 */
	"WAVE_ID_BASE\0" /* 68521 */
	"DEDICATED_PREALLOCATION_BUFFER_LIMIT\0" /* 68534 */
	"PAYLOAD\0" /* 68571, 68574 */
	"IS_EVENT\0" /* 68579 */
	"IS_STATE\0" /* 68588 */
	"OFF_DELAY\0" /* 68597 */
	"DEPTH_CLEAR_ENABLE\0" /* 68607 */
	"STENCIL_CLEAR_ENABLE\0" /* 68626 */
	"DEPTH_COPY\0" /* 68647 */
	"STENCIL_COPY\0" /* 68658 */
	"RESUMMARIZE_ENABLE\0" /* 68671 */
	"STENCIL_COMPRESS_DISABLE\0" /* 68690 */
	"DEPTH_COMPRESS_DISABLE\0" /* 68715 */
	"COPY_CENTROID\0" /* 68738 */
	"COPY_SAMPLE\0" /* 68752 */
	"DECOMPRESS_ENABLE\0" /* 68764 */
	"ZPASS_INCREMENT_DISABLE\0" /* 68782 */
	"PERFECT_ZPASS_COUNTS\0" /* 68806 */
	"DISABLE_CONSERVATIVE_ZPASS_COUNTS\0" /* 68827 */
	"ENHANCED_CONSERVATIVE_ZPASS_COUNTS\0" /* 68861 */
	"SAMPLE_RATE\0" /* 68896 */
	"ZPASS_ENABLE\0" /* 68908 */
	"ZFAIL_ENABLE\0" /* 68921 */
	"SFAIL_ENABLE\0" /* 68934 */
	"DBFAIL_ENABLE\0" /* 68947 */
	"SLICE_EVEN_ENABLE\0" /* 68961 */
	"SLICE_ODD_ENABLE\0" /* 68979 */
	"SLICE_START\0" /* 68996 */
	"SLICE_START_HI\0" /* 69008 */
	"SLICE_MAX\0" /* 69023 */
	"Z_READ_ONLY\0" /* 69033 */
	"STENCIL_READ_ONLY\0" /* 69045 */
	"MIPID\0" /* 69063 */
	"SLICE_MAX_HI\0" /* 69069 */
	"FORCE_OFF\0" /* 69082 */
	"FORCE_ENABLE\0" /* 69092 */
	"FORCE_DISABLE\0" /* 69105 */
	"FORCE_RESERVED\0" /* 69119 */
	"FORCE_HIZ_ENABLE\0" /* 69134, 69142 */
	"FORCE_HIS_ENABLE0\0" /* 69151, 69161 */
	"FORCE_HIS_ENABLE1\0" /* 69169, 69179 */
	"FORCE_SHADER_Z_ORDER\0" /* 69187, 69200 */
	"FAST_Z_DISABLE\0" /* 69208 */
	"FAST_STENCIL_DISABLE\0" /* 69223 */
	"NOOP_CULL_DISABLE\0" /* 69244 */
	"FORCE_COLOR_KILL\0" /* 69262, 69274 */
	"FORCE_Z_READ\0" /* 69279 */
	"FORCE_STENCIL_READ\0" /* 69292 */
	"FORCE_FULL_Z_RANGE\0" /* 69311 */
	"FORCE_QC_SMASK_CONFLICT\0" /* 69330 */
	"DISABLE_VIEWPORT_CLAMP\0" /* 69354 */
	"IGNORE_SC_ZRANGE\0" /* 69377 */
	"DISABLE_FULLY_COVERED\0" /* 69394 */
	"FORCE_SUMM_OFF\0" /* 69416 */
	"FORCE_SUMM_MINZ\0" /* 69431 */
	"FORCE_SUMM_MAXZ\0" /* 69447 */
	"FORCE_SUMM_BOTH\0" /* 69463 */
	"FORCE_Z_LIMIT_SUMM\0" /* 69479 */
	"MAX_TILES_IN_DTT\0" /* 69498 */
	"DISABLE_TILE_RATE_TILES\0" /* 69515 */
	"FORCE_Z_DIRTY\0" /* 69539, 69547 */
	"FORCE_STENCIL_DIRTY\0" /* 69553 */
	"FORCE_Z_VALID\0" /* 69573 */
	"FORCE_STENCIL_VALID\0" /* 69587 */
	"PRESERVE_COMPRESSION\0" /* 69607, 69616 */
	"PSLC_AUTO\0" /* 69628 */
	"PSLC_ON_HANG_ONLY\0" /* 69638 */
	"PSLC_ASAP\0" /* 69656 */
	"PSLC_COUNTDOWN\0" /* 69666 */
	"PARTIAL_SQUAD_LAUNCH_CONTROL\0" /* 69681 */
	"PARTIAL_SQUAD_LAUNCH_COUNTDOWN\0" /* 69710 */
	"DISABLE_ZMASK_EXPCLEAR_OPTIMIZATION\0" /* 69741 */
	"DISABLE_SMEM_EXPCLEAR_OPTIMIZATION\0" /* 69777 */
	"DISABLE_COLOR_ON_VALIDATION\0" /* 69812 */
	"DECOMPRESS_Z_ON_FLUSH\0" /* 69840 */
	"DISABLE_REG_SNOOP\0" /* 69862 */
	"DEPTH_BOUNDS_HIER_DEPTH_DISABLE\0" /* 69880 */
	"SEPARATE_HIZS_FUNC_ENABLE\0" /* 69912 */
	"FRAG_NEVER\0" /* 69938 */
	"FRAG_LESS\0" /* 69949 */
	"FRAG_EQUAL\0" /* 69959 */
	"FRAG_LEQUAL\0" /* 69970 */
	"FRAG_GREATER\0" /* 69982 */
	"FRAG_NOTEQUAL\0" /* 69995 */
	"FRAG_GEQUAL\0" /* 70009 */
	"FRAG_ALWAYS\0" /* 70021, 70026 */
	"HIZ_ZFUNC\0" /* 70033, 70037 */
	"HIS_SFUNC_FF\0" /* 70043 */
	"HIS_SFUNC_BF\0" /* 70056 */
	"PRESERVE_ZRANGE\0" /* 70069 */
	"PRESERVE_SRESULTS\0" /* 70085 */
	"DISABLE_FAST_PASS\0" /* 70103 */
	"ALLOW_PARTIAL_RES_HIER_KILL\0" /* 70121 */
	"BASE_256B\0" /* 70149 */
	"X_MAX\0" /* 70159 */
	"TL_X\0" /* 70165 */
	"TL_Y\0" /* 70170 */
	"BR_X\0" /* 70175 */
	"BR_Y\0" /* 70180 */
	"FORCE_ON\0" /* 70185 */
	"PUNCHOUT_MODE\0" /* 70194 */
	"POPS_DRAIN_PS_ON_OVERLAP\0" /* 70208 */
	"DISALLOW_OVERFLOW\0" /* 70233 */
	"FIELD_1\0" /* 70251 */
	"FIELD_2\0" /* 70259 */
	"FIELD_3\0" /* 70267 */
	"FIELD_4\0" /* 70275 */
	"FIELD_5\0" /* 70283 */
	"FIELD_6\0" /* 70291 */
	"FIELD_7\0" /* 70299 */
	"Z_INVALID\0" /* 70307 */
	"Z_16\0" /* 70317 */
	"Z_24\0" /* 70322 */
	"Z_32_FLOAT\0" /* 70327 */
	"NUM_SAMPLES\0" /* 70338 */
	"FAULT_ZERO\0" /* 70350 */
	"FAULT_ONE\0" /* 70361 */
	"FAULT_FAIL\0" /* 70371 */
	"FAULT_PASS\0" /* 70382 */
	"FAULT_BEHAVIOR\0" /* 70393 */
	"ITERATE_FLUSH\0" /* 70408 */
	"PARTIALLY_RESIDENT\0" /* 70422 */
	"RESERVED_FIELD_1\0" /* 70441 */
	"MAXMIP\0" /* 70458 */
	"DECOMPRESS_ON_N_ZPLANES\0" /* 70465 */
	"ALLOW_EXPCLEAR\0" /* 70489 */
	"READ_SIZE\0" /* 70504 */
	"TILE_SURFACE_ENABLE\0" /* 70514 */
	"ZRANGE_PRECISION\0" /* 70534 */
	"STENCIL_INVALID\0" /* 70551 */
	"STENCIL_8\0" /* 70567 */
	"TILE_STENCIL_DISABLE\0" /* 70577 */
	"CACHE_LRU_WR\0" /* 70598 */
	"CACHE_STREAM\0" /* 70611 */
	"CACHE_BYPASS\0" /* 70624 */
	"UNCACHED_WR\0" /* 70637 */
	"Z_WR_POLICY\0" /* 70649 */
	"S_WR_POLICY\0" /* 70661 */
	"HTILE_WR_POLICY\0" /* 70673 */
	"ZPCPSD_WR_POLICY\0" /* 70689 */
	"CACHE_LRU_RD\0" /* 70706 */
	"CACHE_NOA\0" /* 70719 */
	"UNCACHED_RD\0" /* 70729 */
	"RESERVED_RDPOLICY\0" /* 70741 */
	"Z_RD_POLICY\0" /* 70759 */
	"S_RD_POLICY\0" /* 70771 */
	"HTILE_RD_POLICY\0" /* 70783 */
	"Z_BIG_PAGE\0" /* 70799, 70801 */
	"S_BIG_PAGE\0" /* 70810 */
	"DEST_BASE_HI_256B\0" /* 70821 */
	"DEST_BASE_256B\0" /* 70839 */
	"WINDOW_X_OFFSET\0" /* 70854 */
	"WINDOW_Y_OFFSET\0" /* 70870, 70877 */
	"WINDOW_OFFSET_DISABLE\0" /* 70886 */
	"IN_20\0" /* 70908 */
	"IN_21\0" /* 70914 */
	"IN_210\0" /* 70920 */
	"IN_30\0" /* 70927 */
	"IN_31\0" /* 70933 */
	"IN_310\0" /* 70939 */
	"IN_32\0" /* 70946 */
	"IN_320\0" /* 70952 */
	"IN_321\0" /* 70959 */
	"IN_3210\0" /* 70966 */
	"CLIP_RULE\0" /* 70974 */
	"ER_TRI\0" /* 70984 */
	"ER_POINT\0" /* 70991 */
	"ER_RECT\0" /* 71000 */
	"ER_LINE_LR\0" /* 71008 */
	"ER_LINE_RL\0" /* 71019 */
	"ER_LINE_TB\0" /* 71030 */
	"ER_LINE_BT\0" /* 71041 */
	"HW_SCREEN_OFFSET_X\0" /* 71052 */
	"HW_SCREEN_OFFSET_Y\0" /* 71071 */
	"TARGET0_ENABLE\0" /* 71090 */
	"TARGET1_ENABLE\0" /* 71105 */
	"TARGET2_ENABLE\0" /* 71120 */
	"TARGET3_ENABLE\0" /* 71135 */
	"TARGET4_ENABLE\0" /* 71150 */
	"TARGET5_ENABLE\0" /* 71165 */
	"TARGET6_ENABLE\0" /* 71180 */
	"TARGET7_ENABLE\0" /* 71195 */
	"OUTPUT0_ENABLE\0" /* 71210 */
	"OUTPUT1_ENABLE\0" /* 71225 */
	"OUTPUT2_ENABLE\0" /* 71240 */
	"OUTPUT3_ENABLE\0" /* 71255 */
	"OUTPUT4_ENABLE\0" /* 71270 */
	"OUTPUT5_ENABLE\0" /* 71285 */
	"OUTPUT6_ENABLE\0" /* 71300 */
	"OUTPUT7_ENABLE\0" /* 71315 */
	"VPORT_ZMIN\0" /* 71330 */
	"VPORT_ZMAX\0" /* 71341 */
	"RASTER_CONFIG_RB_MAP_0\0" /* 71352 */
	"RASTER_CONFIG_RB_MAP_1\0" /* 71375 */
	"RASTER_CONFIG_RB_MAP_2\0" /* 71398 */
	"RASTER_CONFIG_RB_MAP_3\0" /* 71421 */
	"RB_MAP_PKR0\0" /* 71444 */
	"RB_MAP_PKR1\0" /* 71456 */
	"RASTER_CONFIG_RB_XSEL2_0\0" /* 71468 */
	"RASTER_CONFIG_RB_XSEL2_1\0" /* 71493 */
	"RASTER_CONFIG_RB_XSEL2_2\0" /* 71518 */
	"RASTER_CONFIG_RB_XSEL2_3\0" /* 71543 */
	"RB_XSEL2\0" /* 71568 */
	"RASTER_CONFIG_RB_XSEL_0\0" /* 71577 */
	"RASTER_CONFIG_RB_XSEL_1\0" /* 71601 */
	"RB_XSEL\0" /* 71625 */
	"RASTER_CONFIG_RB_YSEL_0\0" /* 71633 */
	"RASTER_CONFIG_RB_YSEL_1\0" /* 71657 */
	"RB_YSEL\0" /* 71681 */
	"RASTER_CONFIG_PKR_MAP_0\0" /* 71689 */
	"RASTER_CONFIG_PKR_MAP_1\0" /* 71713 */
	"RASTER_CONFIG_PKR_MAP_2\0" /* 71737 */
	"RASTER_CONFIG_PKR_MAP_3\0" /* 71761 */
	"PKR_MAP\0" /* 71785 */
	"RASTER_CONFIG_PKR_XSEL_0\0" /* 71793 */
	"RASTER_CONFIG_PKR_XSEL_1\0" /* 71818 */
	"RASTER_CONFIG_PKR_XSEL_2\0" /* 71843 */
	"RASTER_CONFIG_PKR_XSEL_3\0" /* 71868 */
	"PKR_XSEL\0" /* 71893 */
	"RASTER_CONFIG_PKR_YSEL_0\0" /* 71902 */
	"RASTER_CONFIG_PKR_YSEL_1\0" /* 71927 */
	"RASTER_CONFIG_PKR_YSEL_2\0" /* 71952 */
	"RASTER_CONFIG_PKR_YSEL_3\0" /* 71977 */
	"PKR_YSEL\0" /* 72002 */
	"RASTER_CONFIG_PKR_XSEL2_0\0" /* 72011 */
	"RASTER_CONFIG_PKR_XSEL2_1\0" /* 72037 */
	"RASTER_CONFIG_PKR_XSEL2_2\0" /* 72063 */
	"RASTER_CONFIG_PKR_XSEL2_3\0" /* 72089 */
	"PKR_XSEL2\0" /* 72115 */
	"RASTER_CONFIG_SC_MAP_0\0" /* 72125 */
	"RASTER_CONFIG_SC_MAP_1\0" /* 72148 */
	"RASTER_CONFIG_SC_MAP_2\0" /* 72171 */
	"RASTER_CONFIG_SC_MAP_3\0" /* 72194 */
	"SC_MAP\0" /* 72217 */
	"RASTER_CONFIG_SC_XSEL_8_WIDE_TILE\0" /* 72224 */
	"RASTER_CONFIG_SC_XSEL_16_WIDE_TILE\0" /* 72258 */
	"RASTER_CONFIG_SC_XSEL_32_WIDE_TILE\0" /* 72293 */
	"RASTER_CONFIG_SC_XSEL_64_WIDE_TILE\0" /* 72328 */
	"SC_XSEL\0" /* 72363 */
	"RASTER_CONFIG_SC_YSEL_8_WIDE_TILE\0" /* 72371 */
	"RASTER_CONFIG_SC_YSEL_16_WIDE_TILE\0" /* 72405 */
	"RASTER_CONFIG_SC_YSEL_32_WIDE_TILE\0" /* 72440 */
	"RASTER_CONFIG_SC_YSEL_64_WIDE_TILE\0" /* 72475 */
	"SC_YSEL\0" /* 72510 */
	"RASTER_CONFIG_SE_MAP_0\0" /* 72518 */
	"RASTER_CONFIG_SE_MAP_1\0" /* 72541 */
	"RASTER_CONFIG_SE_MAP_2\0" /* 72564 */
	"RASTER_CONFIG_SE_MAP_3\0" /* 72587 */
	"SE_MAP\0" /* 72610 */
	"RASTER_CONFIG_SE_XSEL_8_WIDE_TILE\0" /* 72617 */
	"RASTER_CONFIG_SE_XSEL_16_WIDE_TILE\0" /* 72651 */
	"RASTER_CONFIG_SE_XSEL_32_WIDE_TILE\0" /* 72686 */
	"RASTER_CONFIG_SE_XSEL_64_WIDE_TILE\0" /* 72721 */
	"SE_XSEL\0" /* 72756 */
	"RASTER_CONFIG_SE_YSEL_8_WIDE_TILE\0" /* 72764 */
	"RASTER_CONFIG_SE_YSEL_16_WIDE_TILE\0" /* 72798 */
	"RASTER_CONFIG_SE_YSEL_32_WIDE_TILE\0" /* 72833 */
	"RASTER_CONFIG_SE_YSEL_64_WIDE_TILE\0" /* 72868 */
	"SE_YSEL\0" /* 72903 */
	"RASTER_CONFIG_SE_PAIR_MAP_0\0" /* 72911 */
	"RASTER_CONFIG_SE_PAIR_MAP_1\0" /* 72939 */
	"RASTER_CONFIG_SE_PAIR_MAP_2\0" /* 72967 */
	"RASTER_CONFIG_SE_PAIR_MAP_3\0" /* 72995 */
	"SE_PAIR_MAP\0" /* 73023 */
	"RASTER_CONFIG_SE_PAIR_XSEL_8_WIDE_TILE\0" /* 73035 */
	"RASTER_CONFIG_SE_PAIR_XSEL_16_WIDE_TILE\0" /* 73074 */
	"RASTER_CONFIG_SE_PAIR_XSEL_32_WIDE_TILE\0" /* 73114 */
	"RASTER_CONFIG_SE_PAIR_XSEL_64_WIDE_TILE\0" /* 73154 */
	"SE_PAIR_XSEL\0" /* 73194 */
	"RASTER_CONFIG_SE_PAIR_YSEL_8_WIDE_TILE\0" /* 73207 */
	"RASTER_CONFIG_SE_PAIR_YSEL_16_WIDE_TILE\0" /* 73246 */
	"RASTER_CONFIG_SE_PAIR_YSEL_32_WIDE_TILE\0" /* 73286 */
	"RASTER_CONFIG_SE_PAIR_YSEL_64_WIDE_TILE\0" /* 73326 */
	"SE_PAIR_YSEL\0" /* 73366 */
	"NUM_SE\0" /* 73379 */
	"DISABLE_SRBSL_DB_OPTIMIZED_PACKING\0" /* 73386 */
	"NUM_SC\0" /* 73421 */
	"NUM_RB_PER_SC\0" /* 73428 */
	"NUM_PACKER_PER_SC\0" /* 73442 */
	"PERFMON_ENABLE\0" /* 73460 */
	"LEFT_QTR\0" /* 73475 */
	"LEFT_HALF\0" /* 73484 */
	"RIGHT_HALF\0" /* 73494 */
	"RIGHT_QTR\0" /* 73505 */
	"TOP_QTR\0" /* 73515 */
	"TOP_HALF\0" /* 73523 */
	"BOT_HALF\0" /* 73532 */
	"BOT_QTR\0" /* 73541 */
	"MAX_INDX\0" /* 73549 */
	"MIN_INDX\0" /* 73558 */
	"CMASK_WR_POLICY\0" /* 73567 */
	"FMASK_WR_POLICY\0" /* 73583 */
	"DCC_WR_POLICY\0" /* 73599 */
	"COLOR_WR_POLICY\0" /* 73613 */
	"CMASK_RD_POLICY\0" /* 73629 */
	"FMASK_RD_POLICY\0" /* 73645 */
	"DCC_RD_POLICY\0" /* 73661 */
	"COLOR_RD_POLICY\0" /* 73675 */
	"FMASK_BIG_PAGE\0" /* 73691 */
	"COLOR_BIG_PAGE\0" /* 73706 */
	"OVERWRITE_COMBINER_DISABLE\0" /* 73721 */
	"OVERWRITE_COMBINER_WATERMARK\0" /* 73748 */
	"DISABLE_CONSTANT_ENCODE_AC01\0" /* 73777 */
	"DISABLE_CONSTANT_ENCODE_SINGLE\0" /* 73806 */
	"DISABLE_CONSTANT_ENCODE_REG\0" /* 73837 */
	"DISABLE_ELIMFC_SKIP_OF_AC01\0" /* 73865 */
	"DISABLE_ELIMFC_SKIP_OF_SINGLE\0" /* 73893 */
	"ENABLE_ELIMFC_SKIP_OF_REG\0" /* 73923 */
	"COVERAGE_OUT_ENABLE\0" /* 73949 */
	"COVERAGE_OUT_MRT\0" /* 73969 */
	"COVERAGE_OUT_CHANNEL\0" /* 73986 */
	"COVERAGE_OUT_SAMPLES\0" /* 74007 */
	"STENCIL_KEEP\0" /* 74028 */
	"STENCIL_ZERO\0" /* 74041 */
	"STENCIL_ONES\0" /* 74054 */
	"STENCIL_REPLACE_TEST\0" /* 74067 */
	"STENCIL_REPLACE_OP\0" /* 74088 */
	"STENCIL_ADD_CLAMP\0" /* 74107 */
	"STENCIL_SUB_CLAMP\0" /* 74125 */
	"STENCIL_INVERT\0" /* 74143 */
	"STENCIL_ADD_WRAP\0" /* 74158 */
	"STENCIL_SUB_WRAP\0" /* 74175 */
	"STENCIL_AND\0" /* 74192 */
	"STENCIL_OR\0" /* 74204 */
	"STENCIL_XOR\0" /* 74215 */
	"STENCIL_NAND\0" /* 74227 */
	"STENCIL_NOR\0" /* 74240 */
	"STENCIL_XNOR\0" /* 74252 */
	"STENCILFAIL\0" /* 74265 */
	"STENCILZPASS\0" /* 74277 */
	"STENCILZFAIL\0" /* 74290 */
	"STENCILFAIL_BF\0" /* 74303 */
	"STENCILZPASS_BF\0" /* 74318 */
	"STENCILZFAIL_BF\0" /* 74334 */
	"STENCILTESTVAL\0" /* 74350 */
	"STENCILMASK\0" /* 74365 */
	"STENCILWRITEMASK\0" /* 74377 */
	"STENCILOPVAL\0" /* 74394 */
	"STENCILTESTVAL_BF\0" /* 74407 */
	"STENCILMASK_BF\0" /* 74425 */
	"STENCILWRITEMASK_BF\0" /* 74440 */
	"STENCILOPVAL_BF\0" /* 74460 */
	"DATA_REGISTER\0" /* 74476, 74481 */
	"DEFAULT_VAL\0" /* 74490 */
	"FLAT_SHADE\0" /* 74502 */
	"CYL_WRAP\0" /* 74513 */
	"PT_SPRITE_TEX\0" /* 74522 */
	"DUP\0" /* 74536 */
	"FP16_INTERP_MODE\0" /* 74540 */
	"USE_DEFAULT_ATTR1\0" /* 74557 */
	"DEFAULT_VAL_ATTR1\0" /* 74575 */
	"PT_SPRITE_TEX_ATTR1\0" /* 74593 */
	"ATTR0_VALID\0" /* 74613 */
	"ATTR1_VALID\0" /* 74625 */
	"VS_EXPORT_COUNT\0" /* 74637 */
	"VS_HALF_PACK\0" /* 74653 */
	"NO_PC_EXPORT\0" /* 74666 */
	"PERSP_SAMPLE_ENA\0" /* 74679 */
	"PERSP_CENTER_ENA\0" /* 74696 */
	"PERSP_CENTROID_ENA\0" /* 74713 */
	"PERSP_PULL_MODEL_ENA\0" /* 74732 */
	"LINEAR_SAMPLE_ENA\0" /* 74753 */
	"LINEAR_CENTER_ENA\0" /* 74771 */
	"LINEAR_CENTROID_ENA\0" /* 74789 */
	"LINE_STIPPLE_TEX_ENA\0" /* 74809 */
	"POS_X_FLOAT_ENA\0" /* 74830 */
	"POS_Y_FLOAT_ENA\0" /* 74846 */
	"POS_Z_FLOAT_ENA\0" /* 74862 */
	"POS_W_FLOAT_ENA\0" /* 74878 */
	"FRONT_FACE_ENA\0" /* 74894 */
	"ANCILLARY_ENA\0" /* 74909 */
	"SAMPLE_COVERAGE_ENA\0" /* 74923 */
	"POS_FIXED_PT_ENA\0" /* 74943 */
	"FLAT_SHADE_ENA\0" /* 74960 */
	"PNT_SPRITE_ENA\0" /* 74975 */
	"SPI_PNT_SPRITE_SEL_0\0" /* 74990 */
	"SPI_PNT_SPRITE_SEL_1\0" /* 75011 */
	"SPI_PNT_SPRITE_SEL_S\0" /* 75032 */
	"SPI_PNT_SPRITE_SEL_T\0" /* 75053 */
	"SPI_PNT_SPRITE_SEL_NONE\0" /* 75074, 75093 */
	"PNT_SPRITE_OVRD_X\0" /* 75098 */
	"PNT_SPRITE_OVRD_Y\0" /* 75116 */
	"PNT_SPRITE_OVRD_Z\0" /* 75134 */
	"PNT_SPRITE_OVRD_W\0" /* 75152 */
	"PNT_SPRITE_TOP_1\0" /* 75170 */
	"NUM_INTERP\0" /* 75187 */
	"PARAM_GEN\0" /* 75198 */
	"OFFCHIP_PARAM_EN\0" /* 75208 */
	"LATE_PC_DEALLOC\0" /* 75225 */
	"BC_OPTIMIZE_DISABLE\0" /* 75241 */
	"PS_W32_EN\0" /* 75261 */
	"PERSP_CENTER_CNTL\0" /* 75271 */
	"PERSP_CENTROID_CNTL\0" /* 75289 */
	"LINEAR_CENTER_CNTL\0" /* 75309 */
	"LINEAR_CENTROID_CNTL\0" /* 75328 */
	"POS_FLOAT_LOCATION\0" /* 75349 */
	"POS_FLOAT_ULC\0" /* 75368 */
	"FRONT_FACE_ALL_BITS\0" /* 75382 */
	"SPI_SHADER_NONE\0" /* 75402 */
	"SPI_SHADER_1COMP\0" /* 75418 */
	"SPI_SHADER_2COMP\0" /* 75435 */
	"SPI_SHADER_4COMPRESS\0" /* 75452 */
	"SPI_SHADER_4COMP\0" /* 75473 */
	"IDX0_EXPORT_FORMAT\0" /* 75490 */
	"POS0_EXPORT_FORMAT\0" /* 75509 */
	"POS1_EXPORT_FORMAT\0" /* 75528 */
	"POS2_EXPORT_FORMAT\0" /* 75547 */
	"POS3_EXPORT_FORMAT\0" /* 75566 */
	"POS4_EXPORT_FORMAT\0" /* 75585 */
	"SPI_SHADER_ZERO\0" /* 75604 */
	"SPI_SHADER_32_R\0" /* 75620 */
	"SPI_SHADER_32_GR\0" /* 75636 */
	"SPI_SHADER_32_AR\0" /* 75653 */
	"SPI_SHADER_FP16_ABGR\0" /* 75670 */
	"SPI_SHADER_UNORM16_ABGR\0" /* 75691 */
	"SPI_SHADER_SNORM16_ABGR\0" /* 75715 */
	"SPI_SHADER_UINT16_ABGR\0" /* 75739 */
	"SPI_SHADER_SINT16_ABGR\0" /* 75762 */
	"SPI_SHADER_32_ABGR\0" /* 75785 */
	"Z_EXPORT_FORMAT\0" /* 75804 */
	"COL0_EXPORT_FORMAT\0" /* 75820 */
	"COL1_EXPORT_FORMAT\0" /* 75839 */
	"COL2_EXPORT_FORMAT\0" /* 75858 */
	"COL3_EXPORT_FORMAT\0" /* 75877 */
	"COL4_EXPORT_FORMAT\0" /* 75896 */
	"COL5_EXPORT_FORMAT\0" /* 75915 */
	"COL6_EXPORT_FORMAT\0" /* 75934 */
	"COL7_EXPORT_FORMAT\0" /* 75953 */
	"SX_RT_EXPORT_NO_CONVERSION\0" /* 75972 */
	"SX_RT_EXPORT_32_R\0" /* 75999 */
	"SX_RT_EXPORT_32_A\0" /* 76017 */
	"SX_RT_EXPORT_10_11_11\0" /* 76035 */
	"SX_RT_EXPORT_2_10_10_10\0" /* 76057 */
	"SX_RT_EXPORT_8_8_8_8\0" /* 76081 */
	"SX_RT_EXPORT_5_6_5\0" /* 76102 */
	"SX_RT_EXPORT_1_5_5_5\0" /* 76121 */
	"SX_RT_EXPORT_4_4_4_4\0" /* 76142 */
	"SX_RT_EXPORT_16_16_GR\0" /* 76163 */
	"SX_RT_EXPORT_16_16_AR\0" /* 76185 */
	"MRT0\0" /* 76207 */
	"MRT1\0" /* 76212 */
	"MRT2\0" /* 76217 */
	"MRT3\0" /* 76222 */
	"MRT4\0" /* 76227 */
	"MRT5\0" /* 76232 */
	"MRT6\0" /* 76237 */
	"MRT7\0" /* 76242 */
	"11BIT_FORMAT\0" /* 76247 */
	"10BIT_FORMAT\0" /* 76260 */
	"8BIT_FORMAT\0" /* 76273 */
	"6BIT_FORMAT\0" /* 76285 */
	"5BIT_FORMAT\0" /* 76297 */
	"4BIT_FORMAT\0" /* 76309 */
	"MRT0_EPSILON\0" /* 76321 */
	"MRT1_EPSILON\0" /* 76334 */
	"MRT2_EPSILON\0" /* 76347 */
	"MRT3_EPSILON\0" /* 76360 */
	"MRT4_EPSILON\0" /* 76373 */
	"MRT5_EPSILON\0" /* 76386 */
	"MRT6_EPSILON\0" /* 76399 */
	"MRT7_EPSILON\0" /* 76412 */
	"MRT0_COLOR_OPT_DISABLE\0" /* 76425 */
	"MRT0_ALPHA_OPT_DISABLE\0" /* 76448 */
	"MRT1_COLOR_OPT_DISABLE\0" /* 76471 */
	"MRT1_ALPHA_OPT_DISABLE\0" /* 76494 */
	"MRT2_COLOR_OPT_DISABLE\0" /* 76517 */
	"MRT2_ALPHA_OPT_DISABLE\0" /* 76540 */
	"MRT3_COLOR_OPT_DISABLE\0" /* 76563 */
	"MRT3_ALPHA_OPT_DISABLE\0" /* 76586 */
	"MRT4_COLOR_OPT_DISABLE\0" /* 76609 */
	"MRT4_ALPHA_OPT_DISABLE\0" /* 76632 */
	"MRT5_COLOR_OPT_DISABLE\0" /* 76655 */
	"MRT5_ALPHA_OPT_DISABLE\0" /* 76678 */
	"MRT6_COLOR_OPT_DISABLE\0" /* 76701 */
	"MRT6_ALPHA_OPT_DISABLE\0" /* 76724 */
	"MRT7_COLOR_OPT_DISABLE\0" /* 76747 */
	"MRT7_ALPHA_OPT_DISABLE\0" /* 76770 */
	"PIXEN_ZERO_OPT_DISABLE\0" /* 76793 */
	"BLEND_OPT_PRESERVE_NONE_IGNORE_ALL\0" /* 76816 */
	"BLEND_OPT_PRESERVE_ALL_IGNORE_NONE\0" /* 76851 */
	"BLEND_OPT_PRESERVE_C1_IGNORE_C0\0" /* 76886 */
	"BLEND_OPT_PRESERVE_C0_IGNORE_C1\0" /* 76918 */
	"BLEND_OPT_PRESERVE_A1_IGNORE_A0\0" /* 76950 */
	"BLEND_OPT_PRESERVE_A0_IGNORE_A1\0" /* 76982 */
	"BLEND_OPT_PRESERVE_NONE_IGNORE_A0\0" /* 77014 */
	"BLEND_OPT_PRESERVE_NONE_IGNORE_NONE\0" /* 77048 */
	"COLOR_SRC_OPT\0" /* 77084 */
	"COLOR_DST_OPT\0" /* 77098 */
	"OPT_COMB_NONE\0" /* 77112 */
	"OPT_COMB_ADD\0" /* 77126 */
	"OPT_COMB_SUBTRACT\0" /* 77139 */
	"OPT_COMB_MIN\0" /* 77157 */
	"OPT_COMB_MAX\0" /* 77170 */
	"OPT_COMB_REVSUBTRACT\0" /* 77183 */
	"OPT_COMB_BLEND_DISABLED\0" /* 77204 */
	"OPT_COMB_SAFE_ADD\0" /* 77228 */
	"COLOR_COMB_FCN\0" /* 77246 */
	"ALPHA_SRC_OPT\0" /* 77261 */
	"ALPHA_DST_OPT\0" /* 77275 */
	"ALPHA_COMB_FCN\0" /* 77289 */
	"BLEND_ZERO\0" /* 77304 */
	"BLEND_ONE\0" /* 77315 */
	"BLEND_SRC_COLOR\0" /* 77325 */
	"BLEND_ONE_MINUS_SRC_COLOR\0" /* 77341 */
	"BLEND_SRC_ALPHA\0" /* 77367 */
	"BLEND_ONE_MINUS_SRC_ALPHA\0" /* 77383 */
	"BLEND_DST_ALPHA\0" /* 77409 */
	"BLEND_ONE_MINUS_DST_ALPHA\0" /* 77425 */
	"BLEND_DST_COLOR\0" /* 77451 */
	"BLEND_ONE_MINUS_DST_COLOR\0" /* 77467 */
	"BLEND_SRC_ALPHA_SATURATE\0" /* 77493 */
	"BLEND_BOTH_SRC_ALPHA\0" /* 77518 */
	"BLEND_BOTH_INV_SRC_ALPHA\0" /* 77539 */
	"BLEND_CONSTANT_COLOR\0" /* 77564 */
	"BLEND_ONE_MINUS_CONSTANT_COLOR\0" /* 77585 */
	"BLEND_SRC1_COLOR\0" /* 77616 */
	"BLEND_INV_SRC1_COLOR\0" /* 77633 */
	"BLEND_SRC1_ALPHA\0" /* 77654 */
	"BLEND_INV_SRC1_ALPHA\0" /* 77671 */
	"BLEND_CONSTANT_ALPHA\0" /* 77692 */
	"BLEND_ONE_MINUS_CONSTANT_ALPHA\0" /* 77713 */
	"COLOR_SRCBLEND\0" /* 77744 */
	"COMB_DST_PLUS_SRC\0" /* 77759 */
	"COMB_SRC_MINUS_DST\0" /* 77777 */
	"COMB_MIN_DST_SRC\0" /* 77796 */
	"COMB_MAX_DST_SRC\0" /* 77813 */
	"COMB_DST_MINUS_SRC\0" /* 77830 */
	"COLOR_DESTBLEND\0" /* 77849 */
	"ALPHA_SRCBLEND\0" /* 77865 */
	"ALPHA_DESTBLEND\0" /* 77880 */
	"SEPARATE_ALPHA_BLEND\0" /* 77896 */
	"DISABLE_ROP3\0" /* 77917, 77925 */
	"SRC_STATE_ID\0" /* 77930 */
	"DI_SRC_SEL_DMA\0" /* 77943 */
	"DI_SRC_SEL_IMMEDIATE\0" /* 77958 */
	"DI_SRC_SEL_AUTO_INDEX\0" /* 77979 */
	"DI_SRC_SEL_RESERVED\0" /* 78001 */
	"SOURCE_SELECT\0" /* 78021 */
	"DI_MAJOR_MODE_0\0" /* 78035 */
	"DI_MAJOR_MODE_1\0" /* 78051 */
	"MAJOR_MODE\0" /* 78067 */
	"SPRITE_EN_R6XX\0" /* 78078 */
	"NOT_EOP\0" /* 78093 */
	"USE_OPAQUE\0" /* 78101 */
	"UNROLLED_INST\0" /* 78112 */
	"GRBM_SKEW_NO_DEC\0" /* 78126 */
	"REG_RT_INDEX\0" /* 78143 */
	"ADDRESS_LOW\0" /* 78156 */
	"MAX_VERTS_PER_SUBGROUP\0" /* 78168 */
	"STENCIL_ENABLE\0" /* 78191 */
	"Z_WRITE_ENABLE\0" /* 78206 */
	"DEPTH_BOUNDS_ENABLE\0" /* 78221 */
	"BACKFACE_ENABLE\0" /* 78241 */
	"STENCILFUNC\0" /* 78257 */
	"STENCILFUNC_BF\0" /* 78269 */
	"ENABLE_COLOR_WRITES_ON_DEPTH_FAIL\0" /* 78284 */
	"DISABLE_COLOR_WRITES_ON_DEPTH_PASS\0" /* 78318 */
	"MAX_ANCHOR_SAMPLES\0" /* 78353 */
	"PS_ITER_SAMPLES\0" /* 78372 */
	"MASK_EXPORT_NUM_SAMPLES\0" /* 78388 */
	"ALPHA_TO_MASK_NUM_SAMPLES\0" /* 78412 */
	"HIGH_QUALITY_INTERSECTIONS\0" /* 78438 */
	"INCOHERENT_EQAA_READS\0" /* 78465 */
	"INTERPOLATE_COMP_Z\0" /* 78487 */
	"INTERPOLATE_SRC_Z\0" /* 78506 */
	"STATIC_ANCHOR_ASSOCIATIONS\0" /* 78524 */
	"ALPHA_TO_MASK_EQAA_DISABLE\0" /* 78551 */
	"OVERRASTERIZATION_AMOUNT\0" /* 78578 */
	"ENABLE_POSTZ_OVERRASTERIZATION\0" /* 78603 */
	"DISABLE_DUAL_QUAD\0" /* 78634 */
	"DEGAMMA_ENABLE\0" /* 78652 */
	"CB_DISABLE\0" /* 78667 */
	"CB_NORMAL\0" /* 78678 */
	"CB_ELIMINATE_FAST_CLEAR\0" /* 78688, 78701 */
	"CB_RESOLVE\0" /* 78712 */
	"CB_DECOMPRESS\0" /* 78723 */
	"CB_FMASK_DECOMPRESS\0" /* 78737 */
	"CB_DCC_DECOMPRESS\0" /* 78757 */
	"CB_RESERVED\0" /* 78775 */
	"ROP3_CLEAR\0" /* 78787 */
	"X_0X05\0" /* 78798 */
	"X_0X0A\0" /* 78805 */
	"X_0X0F\0" /* 78812 */
	"ROP3_NOR\0" /* 78819 */
	"ROP3_AND_INVERTED\0" /* 78828 */
	"ROP3_COPY_INVERTED\0" /* 78846 */
	"ROP3_AND_REVERSE\0" /* 78865 */
	"X_0X50\0" /* 78882 */
	"ROP3_INVERT\0" /* 78889 */
	"X_0X5A\0" /* 78901 */
	"X_0X5F\0" /* 78908 */
	"ROP3_XOR\0" /* 78915 */
	"ROP3_NAND\0" /* 78924 */
	"ROP3_AND\0" /* 78934 */
	"ROP3_EQUIVALENT\0" /* 78943 */
	"X_0XA0\0" /* 78959 */
	"X_0XA5\0" /* 78966 */
	"ROP3_NO_OP\0" /* 78973 */
	"X_0XAF\0" /* 78984 */
	"ROP3_OR_INVERTED\0" /* 78991 */
	"ROP3_COPY\0" /* 79008 */
	"ROP3_OR_REVERSE\0" /* 79018 */
	"ROP3_OR\0" /* 79034 */
	"X_0XF0\0" /* 79042 */
	"X_0XF5\0" /* 79049 */
	"X_0XFA\0" /* 79056 */
	"ROP3_SET\0" /* 79063 */
	"Z_EXPORT_ENABLE\0" /* 79072 */
	"STENCIL_TEST_VAL_EXPORT_ENABLE\0" /* 79088 */
	"STENCIL_OP_VAL_EXPORT_ENABLE\0" /* 79119 */
	"LATE_Z\0" /* 79148 */
	"EARLY_Z_THEN_LATE_Z\0" /* 79155 */
	"RE_Z\0" /* 79175 */
	"EARLY_Z_THEN_RE_Z\0" /* 79180 */
	"KILL_ENABLE\0" /* 79198 */
	"COVERAGE_TO_MASK_ENABLE\0" /* 79210 */
	"MASK_EXPORT_ENABLE\0" /* 79234 */
	"EXEC_ON_HIER_FAIL\0" /* 79253 */
	"EXEC_ON_NOOP\0" /* 79271 */
	"ALPHA_TO_MASK_DISABLE\0" /* 79284 */
	"DEPTH_BEFORE_SHADER\0" /* 79306 */
	"EXPORT_ANY_Z\0" /* 79326 */
	"EXPORT_LESS_THAN_Z\0" /* 79339 */
	"EXPORT_GREATER_THAN_Z\0" /* 79358 */
	"EXPORT_RESERVED\0" /* 79380 */
	"CONSERVATIVE_Z_EXPORT\0" /* 79396 */
	"DUAL_QUAD_DISABLE\0" /* 79418 */
	"PRIMITIVE_ORDERED_PIXEL_SHADER\0" /* 79436 */
	"EXEC_IF_OVERLAPPED\0" /* 79467 */
	"POPS_OVERLAP_NUM_SAMPLES\0" /* 79486 */
	"PRE_SHADER_DEPTH_COVERAGE_ENABLE\0" /* 79511 */
	"UCP_ENA_0\0" /* 79544 */
	"UCP_ENA_1\0" /* 79554 */
	"UCP_ENA_2\0" /* 79564 */
	"UCP_ENA_3\0" /* 79574 */
	"UCP_ENA_4\0" /* 79584 */
	"UCP_ENA_5\0" /* 79594 */
	"PS_UCP_Y_SCALE_NEG\0" /* 79604 */
	"PS_UCP_MODE\0" /* 79623 */
	"CLIP_DISABLE\0" /* 79635 */
	"UCP_CULL_ONLY_ENA\0" /* 79648 */
	"BOUNDARY_EDGE_FLAG_ENA\0" /* 79666 */
	"DX_CLIP_SPACE_DEF\0" /* 79689 */
	"DIS_CLIP_ERR_DETECT\0" /* 79707 */
	"VTX_KILL_OR\0" /* 79727 */
	"DX_RASTERIZATION_KILL\0" /* 79739 */
	"DX_LINEAR_ATTR_CLIP_ENA\0" /* 79761 */
	"VTE_VPORT_PROVOKE_DISABLE\0" /* 79785 */
	"ZCLIP_NEAR_DISABLE\0" /* 79811 */
	"ZCLIP_FAR_DISABLE\0" /* 79830 */
	"ZCLIP_PROG_NEAR_ENA\0" /* 79848 */
	"CULL_FRONT\0" /* 79868 */
	"CULL_BACK\0" /* 79879 */
	"X_DISABLE_POLY_MODE\0" /* 79889, 79899 */
	"X_DUAL_MODE\0" /* 79909 */
	"X_DRAW_POINTS\0" /* 79921 */
	"X_DRAW_LINES\0" /* 79935 */
	"X_DRAW_TRIANGLES\0" /* 79948 */
	"POLYMODE_FRONT_PTYPE\0" /* 79965 */
	"POLYMODE_BACK_PTYPE\0" /* 79986 */
	"POLY_OFFSET_FRONT_ENABLE\0" /* 80006 */
	"POLY_OFFSET_BACK_ENABLE\0" /* 80031 */
	"POLY_OFFSET_PARA_ENABLE\0" /* 80055 */
	"VTX_WINDOW_OFFSET_ENABLE\0" /* 80079 */
	"PROVOKING_VTX_LAST\0" /* 80104 */
	"PERSP_CORR_DIS\0" /* 80123 */
	"MULTI_PRIM_IB_ENA\0" /* 80138 */
	"RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF\0" /* 80156 */
	"NEW_QUAD_DECOMPOSITION\0" /* 80194 */
	"KEEP_TOGETHER_ENABLE\0" /* 80217 */
	"VPORT_X_SCALE_ENA\0" /* 80238 */
	"VPORT_X_OFFSET_ENA\0" /* 80256 */
	"VPORT_Y_SCALE_ENA\0" /* 80275 */
	"VPORT_Y_OFFSET_ENA\0" /* 80293 */
	"VPORT_Z_SCALE_ENA\0" /* 80312 */
	"VPORT_Z_OFFSET_ENA\0" /* 80330 */
	"VTX_XY_FMT\0" /* 80349 */
	"VTX_Z_FMT\0" /* 80360 */
	"VTX_W0_FMT\0" /* 80370 */
	"PERFCOUNTER_REF\0" /* 80381 */
	"CLIP_DIST_ENA_0\0" /* 80397 */
	"CLIP_DIST_ENA_1\0" /* 80413 */
	"CLIP_DIST_ENA_2\0" /* 80429 */
	"CLIP_DIST_ENA_3\0" /* 80445 */
	"CLIP_DIST_ENA_4\0" /* 80461 */
	"CLIP_DIST_ENA_5\0" /* 80477 */
	"CLIP_DIST_ENA_6\0" /* 80493 */
	"CLIP_DIST_ENA_7\0" /* 80509 */
	"CULL_DIST_ENA_0\0" /* 80525 */
	"CULL_DIST_ENA_1\0" /* 80541 */
	"CULL_DIST_ENA_2\0" /* 80557 */
	"CULL_DIST_ENA_3\0" /* 80573 */
	"CULL_DIST_ENA_4\0" /* 80589 */
	"CULL_DIST_ENA_5\0" /* 80605 */
	"CULL_DIST_ENA_6\0" /* 80621 */
	"CULL_DIST_ENA_7\0" /* 80637 */
	"USE_VTX_POINT_SIZE\0" /* 80653 */
	"USE_VTX_EDGE_FLAG\0" /* 80672, 80685 */
	"USE_VTX_RENDER_TARGET_INDX\0" /* 80690 */
	"USE_VTX_VIEWPORT_INDX\0" /* 80717 */
	"USE_VTX_KILL_FLAG\0" /* 80739 */
	"VS_OUT_MISC_VEC_ENA\0" /* 80757 */
	"VS_OUT_CCDIST0_VEC_ENA\0" /* 80777 */
	"VS_OUT_CCDIST1_VEC_ENA\0" /* 80800 */
	"VS_OUT_MISC_SIDE_BUS_ENA\0" /* 80823 */
	"USE_VTX_GS_CUT_FLAG\0" /* 80848 */
	"USE_VTX_SHD_OBJPRIM_ID\0" /* 80868 */
	"USE_VTX_LINE_WIDTH\0" /* 80891 */
	"VTE_XY_INF_DISCARD\0" /* 80910 */
	"VTE_Z_INF_DISCARD\0" /* 80929 */
	"VTE_W_INF_DISCARD\0" /* 80947 */
	"VTE_0XNANINF_IS_0\0" /* 80965 */
	"VTE_XY_NAN_RETAIN\0" /* 80983 */
	"VTE_Z_NAN_RETAIN\0" /* 81001 */
	"VTE_W_NAN_RETAIN\0" /* 81018 */
	"VTE_W_RECIP_NAN_IS_0\0" /* 81035 */
	"VS_XY_NAN_TO_INF\0" /* 81056 */
	"VS_XY_INF_RETAIN\0" /* 81073 */
	"VS_Z_NAN_TO_INF\0" /* 81090 */
	"VS_Z_INF_RETAIN\0" /* 81106 */
	"VS_W_NAN_TO_INF\0" /* 81122 */
	"VS_W_INF_RETAIN\0" /* 81138 */
	"VS_CLIP_DIST_INF_DISCARD\0" /* 81154 */
	"VTE_NO_OUTPUT_NEG_0\0" /* 81179 */
	"LINE_STIPPLE_RESET\0" /* 81199 */
	"EXPAND_FULL_LENGTH\0" /* 81218 */
	"FRACTIONAL_ACCUM\0" /* 81237 */
	"DIAMOND_ADJUST\0" /* 81254 */
	"TRIANGLE_FILTER_DISABLE\0" /* 81269 */
	"LINE_FILTER_DISABLE\0" /* 81293 */
	"POINT_FILTER_DISABLE\0" /* 81313 */
	"RECTANGLE_FILTER_DISABLE\0" /* 81334 */
	"TRIANGLE_EXPAND_ENA\0" /* 81359 */
	"LINE_EXPAND_ENA\0" /* 81379 */
	"POINT_EXPAND_ENA\0" /* 81395 */
	"RECTANGLE_EXPAND_ENA\0" /* 81412 */
	"PRIM_EXPAND_CONSTANT\0" /* 81433 */
	"XMAX_RIGHT_EXCLUSION\0" /* 81454 */
	"YMAX_BOTTOM_EXCLUSION\0" /* 81475 */
	"SMALL_PRIM_FILTER_ENABLE\0" /* 81497 */
	"SRBSL_ENABLE\0" /* 81522 */
	"SC_1XMSAA_COMPATIBLE_DISABLE\0" /* 81535 */
	"OBJ_ID_SEL\0" /* 81564 */
	"ADD_PIPED_PRIM_ID\0" /* 81575 */
	"VERTEX_REUSE_OFF\0" /* 81593 */
	"INDEX_BUF_EDGE_FLAG_ENA\0" /* 81610 */
	"DISCARD_0_AREA_TRIANGLES\0" /* 81634 */
	"DISCARD_0_AREA_LINES\0" /* 81659 */
	"DISCARD_0_AREA_POINTS\0" /* 81680 */
	"DISCARD_0_AREA_RECTANGLES\0" /* 81702 */
	"USE_PROVOKING_ZW\0" /* 81728 */
	"STEREO_MODE\0" /* 81745 */
	"RT_SLICE_MODE\0" /* 81757 */
	"RT_SLICE_OFFSET\0" /* 81771 */
	"VP_ID_MODE\0" /* 81787 */
	"VP_ID_OFFSET\0" /* 81798 */
	"STEREO_X_OFFSET\0" /* 81811 */
	"MIN_SIZE\0" /* 81827 */
	"LINE_PATTERN\0" /* 81836 */
	"REPEAT_COUNT\0" /* 81849 */
	"PATTERN_BIT_ORDER\0" /* 81862 */
	"AUTO_RESET_CNTL\0" /* 81880 */
	"PATH_SELECT\0" /* 81896 */
	"TESS_MODE\0" /* 81908 */
	"MAX_TESS\0" /* 81918 */
	"MIN_TESS\0" /* 81927 */
	"DI_PT_NONE\0" /* 81936 */
	"DI_PT_POINTLIST\0" /* 81947, 81953 */
	"DI_PT_LINELIST\0" /* 81963 */
	"DI_PT_LINESTRIP\0" /* 81978, 81984 */
	"DI_PT_TRILIST\0" /* 81994 */
	"DI_PT_TRIFAN\0" /* 82008 */
	"DI_PT_TRISTRIP\0" /* 82021, 82027 */
	"DI_PT_2D_RECTANGLE\0" /* 82036 */
	"DI_PT_UNUSED_1\0" /* 82055 */
	"DI_PT_PATCH\0" /* 82070 */
	"DI_PT_LINELIST_ADJ\0" /* 82082 */
	"DI_PT_LINESTRIP_ADJ\0" /* 82101 */
	"DI_PT_TRILIST_ADJ\0" /* 82121 */
	"DI_PT_TRISTRIP_ADJ\0" /* 82139 */
	"DI_PT_UNUSED_3\0" /* 82158 */
	"DI_PT_UNUSED_4\0" /* 82173 */
	"DI_PT_TRI_WITH_WFLAGS\0" /* 82188 */
	"DI_PT_RECTLIST\0" /* 82210, 82216 */
	"DI_PT_LINELOOP\0" /* 82225 */
	"DI_PT_QUADLIST\0" /* 82240 */
	"DI_PT_QUADSTRIP\0" /* 82255 */
	"DI_PT_POLYGON\0" /* 82271 */
	"RETAIN_ORDER\0" /* 82285 */
	"RETAIN_QUADS\0" /* 82298 */
	"PRIM_ORDER\0" /* 82311 */
	"COMP_X_EN\0" /* 82322 */
	"COMP_Y_EN\0" /* 82332 */
	"COMP_Z_EN\0" /* 82342 */
	"COMP_W_EN\0" /* 82352 */
	"SHIFT\0" /* 82362 */
	"X_CONV\0" /* 82368, 82372 */
	"Y_CONV\0" /* 82375 */
	"Z_CONV\0" /* 82382 */
	"Z_OFFSET\0" /* 82389 */
	"W_CONV\0" /* 82398 */
	"GS_OFF\0" /* 82405 */
	"GS_SCENARIO_A\0" /* 82412 */
	"GS_SCENARIO_B\0" /* 82426 */
	"GS_SCENARIO_G\0" /* 82440 */
	"GS_SCENARIO_C\0" /* 82454 */
	"SPRITE_EN\0" /* 82468 */
	"RESERVED_0\0" /* 82478 */
	"GS_CUT_1024\0" /* 82489 */
	"GS_CUT_512\0" /* 82501 */
	"GS_CUT_256\0" /* 82512 */
	"GS_CUT_128\0" /* 82523 */
	"CUT_MODE\0" /* 82534 */
	"RESERVED_1\0" /* 82543 */
	"GS_C_PACK_EN\0" /* 82554 */
	"RESERVED_2\0" /* 82567 */
	"ES_PASSTHRU\0" /* 82578 */
	"COMPUTE_MODE\0" /* 82590 */
	"FAST_COMPUTE_MODE\0" /* 82603 */
	"ELEMENT_INFO_EN\0" /* 82621 */
	"PARTIAL_THD_AT_EOI\0" /* 82637 */
	"SUPPRESS_CUTS\0" /* 82656 */
	"ES_WRITE_OPTIMIZE\0" /* 82670 */
	"GS_WRITE_OPTIMIZE\0" /* 82688 */
	"ONCHIP\0" /* 82706 */
	"ES_VERTS_PER_SUBGRP\0" /* 82713 */
	"GS_PRIMS_PER_SUBGRP\0" /* 82733 */
	"GS_INST_PRIMS_IN_SUBGRP\0" /* 82753 */
	"MSAA_ENABLE\0" /* 82777 */
	"VPORT_SCISSOR_ENABLE\0" /* 82789 */
	"LINE_STIPPLE_ENABLE\0" /* 82810 */
	"SEND_UNLIT_STILES_TO_PKR\0" /* 82830 */
	"SCALE_LINE_WIDTH_PAD\0" /* 82855 */
	"ALTERNATE_RBS_PER_TILE\0" /* 82876 */
	"COARSE_TILE_STARTS_ON_EVEN_RB\0" /* 82899 */
	"WALK_SIZE\0" /* 82929 */
	"WALK_ALIGNMENT\0" /* 82939 */
	"WALK_ALIGN8_PRIM_FITS_ST\0" /* 82954 */
	"WALK_FENCE_ENABLE\0" /* 82979 */
	"WALK_FENCE_SIZE\0" /* 82997 */
	"SUPERTILE_WALK_ORDER_ENABLE\0" /* 83013, 83018 */
	"TILE_COVER_DISABLE\0" /* 83041 */
	"TILE_COVER_NO_SCISSOR\0" /* 83060 */
	"ZMM_LINE_EXTENT\0" /* 83082 */
	"ZMM_LINE_OFFSET\0" /* 83098 */
	"ZMM_RECT_EXTENT\0" /* 83114 */
	"KILL_PIX_POST_HI_Z\0" /* 83130 */
	"KILL_PIX_POST_DETAIL_MASK\0" /* 83149 */
	"PS_ITER_SAMPLE\0" /* 83175 */
	"MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE\0" /* 83190 */
	"MULTI_GPU_SUPERTILE_ENABLE\0" /* 83230 */
	"GPU_ID_OVERRIDE_ENABLE\0" /* 83257 */
	"GPU_ID_OVERRIDE\0" /* 83280 */
	"MULTI_GPU_PRIM_DISCARD_ENABLE\0" /* 83296 */
	"FORCE_EOV_CNTDWN_ENABLE\0" /* 83326 */
	"FORCE_EOV_REZ_ENABLE\0" /* 83350 */
	"OUT_OF_ORDER_PRIMITIVE_ENABLE\0" /* 83371 */
	"OUT_OF_ORDER_WATER_MARK\0" /* 83401 */
	"MISC\0" /* 83425 */
	"OUTPRIM_TYPE\0" /* 83430 */
	"OUTPRIM_TYPE_1\0" /* 83443 */
	"OUTPRIM_TYPE_2\0" /* 83458 */
	"OUTPRIM_TYPE_3\0" /* 83473 */
	"UNIQUE_TYPE_PER_STREAM\0" /* 83488 */
	"VGT_INDEX_16\0" /* 83511 */
	"VGT_INDEX_32\0" /* 83524 */
	"VGT_INDEX_8\0" /* 83537 */
	"VGT_DMA_SWAP_NONE\0" /* 83549 */
	"VGT_DMA_SWAP_16_BIT\0" /* 83567 */
	"VGT_DMA_SWAP_32_BIT\0" /* 83587 */
	"VGT_DMA_SWAP_WORD\0" /* 83607 */
	"SWAP_MODE\0" /* 83625 */
	"VGT_DMA_BUF_MEM\0" /* 83635 */
	"VGT_DMA_BUF_RING\0" /* 83651 */
	"VGT_DMA_BUF_SETUP\0" /* 83668 */
	"VGT_DMA_PTR_UPDATE\0" /* 83686 */
	"BUF_TYPE\0" /* 83705 */
	"VGT_POLICY_LRU\0" /* 83714 */
	"VGT_POLICY_STREAM\0" /* 83729 */
	"VGT_POLICY_BYPASS\0" /* 83747 */
	"RDREQ_POLICY\0" /* 83765 */
	"ATC\0" /* 83778 */
	"REQ_PATH\0" /* 83782 */
	"MTYPE\0" /* 83791 */
	"DISABLE_RESET_ON_EOI\0" /* 83797 */
	"NGG_DISABLE_PROVOK_REUSE\0" /* 83818 */
	"Reserved_0x00\0" /* 83843 */
	"SAMPLE_STREAMOUTSTATS1\0" /* 83857 */
	"SAMPLE_STREAMOUTSTATS2\0" /* 83880 */
	"SAMPLE_STREAMOUTSTATS3\0" /* 83903 */
	"CACHE_FLUSH_TS\0" /* 83926 */
	"CONTEXT_DONE\0" /* 83941 */
	"CACHE_FLUSH\0" /* 83954 */
	"CS_PARTIAL_FLUSH\0" /* 83966 */
	"VGT_STREAMOUT_SYNC\0" /* 83983 */
	"SET_FE_ID\0" /* 84002 */
	"VGT_STREAMOUT_RESET\0" /* 84012 */
	"END_OF_PIPE_INCR_DE\0" /* 84032 */
	"END_OF_PIPE_IB_END\0" /* 84052 */
	"RST_PIX_CNT\0" /* 84071 */
	"BREAK_BATCH\0" /* 84083 */
	"VS_PARTIAL_FLUSH\0" /* 84095 */
	"PS_PARTIAL_FLUSH\0" /* 84112 */
	"FLUSH_HS_OUTPUT\0" /* 84129 */
	"FLUSH_DFSM\0" /* 84145 */
	"RESET_TO_LOWEST_VGT\0" /* 84156 */
	"CACHE_FLUSH_AND_INV_TS_EVENT\0" /* 84176 */
	"ZPASS_DONE\0" /* 84205 */
	"CACHE_FLUSH_AND_INV_EVENT\0" /* 84216 */
	"PERFCOUNTER_START\0" /* 84242 */
	"PERFCOUNTER_STOP\0" /* 84260 */
	"PIPELINESTAT_START\0" /* 84277 */
	"PIPELINESTAT_STOP\0" /* 84296 */
	"PERFCOUNTER_SAMPLE\0" /* 84314 */
	"FLUSH_ES_OUTPUT\0" /* 84333 */
	"BIN_CONF_OVERRIDE_CHECK\0" /* 84349 */
	"SAMPLE_PIPELINESTAT\0" /* 84373 */
	"SO_VGTSTREAMOUT_FLUSH\0" /* 84393 */
	"SAMPLE_STREAMOUTSTATS\0" /* 84415 */
	"RESET_VTX_CNT\0" /* 84437 */
	"BLOCK_CONTEXT_DONE\0" /* 84451 */
	"CS_CONTEXT_DONE\0" /* 84470 */
	"VGT_FLUSH\0" /* 84486 */
	"TGID_ROLLOVER\0" /* 84496 */
	"SQ_NON_EVENT\0" /* 84510 */
	"SC_SEND_DB_VPZ\0" /* 84523 */
	"BOTTOM_OF_PIPE_TS\0" /* 84538 */
	"FLUSH_SX_TS\0" /* 84556 */
	"DB_CACHE_FLUSH_AND_INV\0" /* 84568 */
	"FLUSH_AND_INV_DB_DATA_TS\0" /* 84591 */
	"FLUSH_AND_INV_DB_META\0" /* 84616 */
	"FLUSH_AND_INV_CB_DATA_TS\0" /* 84638 */
	"FLUSH_AND_INV_CB_META\0" /* 84663 */
	"CS_DONE\0" /* 84685 */
	"PS_DONE\0" /* 84693 */
	"FLUSH_AND_INV_CB_PIXEL_DATA\0" /* 84701 */
	"SX_CB_RAT_ACK_REQUEST\0" /* 84729 */
	"THREAD_TRACE_START\0" /* 84751 */
	"THREAD_TRACE_STOP\0" /* 84770 */
	"THREAD_TRACE_MARKER\0" /* 84788 */
	"THREAD_TRACE_DRAW\0" /* 84808 */
	"THREAD_TRACE_FINISH\0" /* 84826 */
	"PIXEL_PIPE_STAT_CONTROL\0" /* 84846 */
	"PIXEL_PIPE_STAT_DUMP\0" /* 84870 */
	"PIXEL_PIPE_STAT_RESET\0" /* 84891 */
	"CONTEXT_SUSPEND\0" /* 84913 */
	"OFFCHIP_HS_DEALLOC\0" /* 84929 */
	"ENABLE_NGG_PIPELINE\0" /* 84948 */
	"ENABLE_LEGACY_PIPELINE\0" /* 84968 */
	"DRAW_DONE\0" /* 84991 */
	"EVENT_TYPE\0" /* 85001 */
	"EXTENDED_EVENT\0" /* 85012 */
	"MATCH_ALL_BITS\0" /* 85027 */
	"OBJPRIM_ID_EN\0" /* 85042 */
	"EN_REG_RT_INDEX\0" /* 85056 */
	"OBJECT_ID_INST_EN\0" /* 85072 */
	"EN_PRIM_PAYLOAD\0" /* 85090 */
	"EN_DRAW_VP\0" /* 85106 */
	"STEP_RATE\0" /* 85117 */
	"PRIMGROUP_SIZE\0" /* 85127 */
	"PARTIAL_VS_WAVE_ON\0" /* 85142 */
	"SWITCH_ON_EOP\0" /* 85161 */
	"PARTIAL_ES_WAVE_ON\0" /* 85175 */
	"SWITCH_ON_EOI\0" /* 85194 */
	"WD_SWITCH_ON_EOP\0" /* 85208 */
	"FULL_CACHE\0" /* 85225 */
	"RESERVED_FIELD_2\0" /* 85236 */
	"RESERVED_FIELD_3\0" /* 85253 */
	"RESERVED_FIELD_4\0" /* 85270 */
	"RESERVED_FIELD_5\0" /* 85287 */
	"DST_OUTSIDE_ZERO_TO_ONE\0" /* 85304 */
	"RESERVED_FIELD_6\0" /* 85328 */
	"COMPAREFUNC0\0" /* 85345 */
	"COMPAREVALUE0\0" /* 85358 */
	"COMPAREMASK0\0" /* 85372 */
	"COMPAREFUNC1\0" /* 85385 */
	"COMPAREVALUE1\0" /* 85398 */
	"COMPAREMASK1\0" /* 85412 */
	"MAX_X\0" /* 85425 */
	"MAX_Y\0" /* 85431 */
	"PRIM_AMP_FACTOR\0" /* 85437 */
	"THDS_PER_SUBGRP\0" /* 85453 */
	"ACCUM_ISOLINE\0" /* 85469 */
	"ACCUM_TRI\0" /* 85483 */
	"ACCUM_QUAD\0" /* 85493 */
	"DONUT_SPLIT\0" /* 85504 */
	"TRAP_SPLIT\0" /* 85516 */
	"LS_STAGE_OFF\0" /* 85527 */
	"LS_STAGE_ON\0" /* 85540 */
	"CS_STAGE_ON\0" /* 85552 */
	"RESERVED_LS\0" /* 85564 */
	"LS_EN\0" /* 85576 */
	"HS_STAGE_OFF\0" /* 85582 */
	"HS_STAGE_ON\0" /* 85595 */
	"HS_EN\0" /* 85607 */
	"ES_STAGE_OFF\0" /* 85613 */
	"ES_STAGE_DS\0" /* 85626 */
	"ES_STAGE_REAL\0" /* 85638 */
	"RESERVED_ES\0" /* 85652 */
	"GS_STAGE_OFF\0" /* 85664 */
	"GS_STAGE_ON\0" /* 85677 */
	"GS_EN\0" /* 85689 */
	"VS_STAGE_REAL\0" /* 85695 */
	"VS_STAGE_DS\0" /* 85709 */
	"VS_STAGE_COPY_SHADER\0" /* 85721 */
	"RESERVED_VS\0" /* 85742 */
	"VS_EN\0" /* 85754 */
	"DYNAMIC_HS\0" /* 85760 */
	"DIS_DEALLOC_ACCUM_0\0" /* 85771 */
	"DIS_DEALLOC_ACCUM_1\0" /* 85791 */
	"VS_WAVE_ID_EN\0" /* 85811 */
	"PRIMGEN_EN\0" /* 85825 */
	"ORDERED_ID_MODE\0" /* 85836 */
	"MAX_PRIMGRP_IN_WAVE\0" /* 85852 */
	"GS_FAST_LAUNCH\0" /* 85872 */
	"HS_W32_EN\0" /* 85887 */
	"GS_W32_EN\0" /* 85897 */
	"VS_W32_EN\0" /* 85907 */
	"NGG_WAVE_ID_EN\0" /* 85917 */
	"PRIMGEN_PASSTHRU_EN\0" /* 85932 */
	"NUM_PATCHES\0" /* 85952, 85956 */
	"HS_NUM_INPUT_CP\0" /* 85964 */
	"HS_NUM_OUTPUT_CP\0" /* 85980 */
	"TESS_ISOLINE\0" /* 85997 */
	"TESS_TRIANGLE\0" /* 86010 */
	"TESS_QUAD\0" /* 86024 */
	"PART_INTEGER\0" /* 86034 */
	"PART_POW2\0" /* 86047 */
	"PART_FRAC_ODD\0" /* 86057 */
	"PART_FRAC_EVEN\0" /* 86071 */
	"PARTITIONING\0" /* 86086 */
	"OUTPUT_POINT\0" /* 86099 */
	"OUTPUT_LINE\0" /* 86112 */
	"OUTPUT_TRIANGLE_CW\0" /* 86124 */
	"OUTPUT_TRIANGLE_CCW\0" /* 86143 */
	"TOPOLOGY\0" /* 86163 */
	"RESERVED_REDUC_AXIS\0" /* 86172 */
	"DEPRECATED\0" /* 86192 */
	"NUM_DS_WAVES_PER_SIMD\0" /* 86203 */
	"DISABLE_DONUTS\0" /* 86225, 86233 */
	"NO_DIST\0" /* 86240 */
	"TRAPEZOIDS\0" /* 86248 */
	"DISTRIBUTION_MODE\0" /* 86259 */
	"PRE_CLAMP_TF1\0" /* 86277 */
	"POST_CLAMP_TF1\0" /* 86291 */
	"DISABLE_TF1\0" /* 86306 */
	"DETECT_ONE\0" /* 86318 */
	"PRE_CLAMP_TF0\0" /* 86329 */
	"POST_CLAMP_TF0\0" /* 86343 */
	"DISABLE_TF0\0" /* 86358 */
	"DETECT_ZERO\0" /* 86370 */
	"ALPHA_TO_MASK_ENABLE\0" /* 86382 */
	"ALPHA_TO_MASK_OFFSET0\0" /* 86403 */
	"ALPHA_TO_MASK_OFFSET1\0" /* 86425 */
	"ALPHA_TO_MASK_OFFSET2\0" /* 86447 */
	"ALPHA_TO_MASK_OFFSET3\0" /* 86469 */
	"OFFSET_ROUND\0" /* 86491 */
	"MATCH_INDEX\0" /* 86504 */
	"POLY_OFFSET_NEG_NUM_DB_BITS\0" /* 86516 */
	"POLY_OFFSET_DB_IS_FLOAT_FMT\0" /* 86544 */
	"EN_MAX_VERT_OUT_PER_GS_INSTANCE\0" /* 86572 */
	"STREAMOUT_0_EN\0" /* 86604 */
	"STREAMOUT_1_EN\0" /* 86619 */
	"STREAMOUT_2_EN\0" /* 86634 */
	"STREAMOUT_3_EN\0" /* 86649 */
	"RAST_STREAM\0" /* 86664 */
	"EN_PRIMS_NEEDED_CNT\0" /* 86676 */
	"RAST_STREAM_MASK\0" /* 86696 */
	"USE_RAST_STREAM_MASK\0" /* 86713 */
	"STREAM_0_BUFFER_EN\0" /* 86734 */
	"STREAM_1_BUFFER_EN\0" /* 86753 */
	"STREAM_2_BUFFER_EN\0" /* 86772 */
	"STREAM_3_BUFFER_EN\0" /* 86791 */
	"DISTANCE_0\0" /* 86810 */
	"DISTANCE_1\0" /* 86821 */
	"DISTANCE_2\0" /* 86832 */
	"DISTANCE_3\0" /* 86843 */
	"DISTANCE_4\0" /* 86854 */
	"DISTANCE_5\0" /* 86865 */
	"DISTANCE_6\0" /* 86876 */
	"DISTANCE_7\0" /* 86887 */
	"DISTANCE_8\0" /* 86898 */
	"DISTANCE_9\0" /* 86909 */
	"DISTANCE_10\0" /* 86920 */
	"DISTANCE_11\0" /* 86932 */
	"DISTANCE_12\0" /* 86944 */
	"DISTANCE_13\0" /* 86956 */
	"DISTANCE_14\0" /* 86968 */
	"DISTANCE_15\0" /* 86980 */
	"EXPAND_LINE_WIDTH\0" /* 86992 */
	"LAST_PIXEL\0" /* 87010 */
	"PERPENDICULAR_ENDCAP_ENA\0" /* 87021 */
	"DX10_DIAMOND_TEST_ENA\0" /* 87046 */
	"EXTRA_DX_DY_PRECISION\0" /* 87068 */
	"MSAA_NUM_SAMPLES\0" /* 87090 */
	"AA_MASK_CENTROID_DTMN\0" /* 87107 */
	"MAX_SAMPLE_DIST\0" /* 87129 */
	"MSAA_EXPOSED_SAMPLES\0" /* 87145 */
	"DETAIL_TO_EXPOSED_MODE\0" /* 87166 */
	"INPUT_COVERAGE\0" /* 87189 */
	"INPUT_INNER_COVERAGE\0" /* 87204 */
	"INPUT_DEPTH_COVERAGE\0" /* 87225 */
	"COVERAGE_TO_SHADER_SELECT\0" /* 87246 */
	"PIX_CENTER\0" /* 87272 */
	"X_TRUNCATE\0" /* 87283 */
	"X_ROUND\0" /* 87294 */
	"X_ROUND_TO_EVEN\0" /* 87302 */
	"X_ROUND_TO_ODD\0" /* 87318 */
	"ROUND_MODE\0" /* 87333 */
	"X_16_8_FIXED_POINT_1_16TH\0" /* 87344 */
	"X_16_8_FIXED_POINT_1_8TH\0" /* 87370 */
	"X_16_8_FIXED_POINT_1_4TH\0" /* 87395 */
	"X_16_8_FIXED_POINT_1_2\0" /* 87420 */
	"X_16_8_FIXED_POINT_1\0" /* 87443 */
	"X_16_8_FIXED_POINT_1_256TH\0" /* 87464 */
	"X_14_10_FIXED_POINT_1_1024TH\0" /* 87491 */
	"X_12_12_FIXED_POINT_1_4096TH\0" /* 87520 */
	"QUANT_MODE\0" /* 87549 */
	"S0_X\0" /* 87560 */
	"S0_Y\0" /* 87565 */
	"S1_X\0" /* 87570 */
	"S1_Y\0" /* 87575 */
	"S2_X\0" /* 87580 */
	"S2_Y\0" /* 87585 */
	"S3_X\0" /* 87590 */
	"S3_Y\0" /* 87595 */
	"S4_X\0" /* 87600 */
	"S4_Y\0" /* 87605 */
	"S5_X\0" /* 87610 */
	"S5_Y\0" /* 87615 */
	"S6_X\0" /* 87620 */
	"S6_Y\0" /* 87625 */
	"S7_X\0" /* 87630 */
	"S7_Y\0" /* 87635 */
	"S8_X\0" /* 87640 */
	"S8_Y\0" /* 87645 */
	"S9_X\0" /* 87650 */
	"S9_Y\0" /* 87655 */
	"S10_X\0" /* 87660 */
	"S10_Y\0" /* 87666 */
	"S11_X\0" /* 87672 */
	"S11_Y\0" /* 87678 */
	"S12_X\0" /* 87684 */
	"S12_Y\0" /* 87690 */
	"S13_X\0" /* 87696 */
	"S13_Y\0" /* 87702 */
	"S14_X\0" /* 87708 */
	"S14_Y\0" /* 87714 */
	"S15_X\0" /* 87720 */
	"S15_Y\0" /* 87726 */
	"AA_MASK_X0Y0\0" /* 87732 */
	"AA_MASK_X1Y0\0" /* 87745 */
	"AA_MASK_X0Y1\0" /* 87758 */
	"AA_MASK_X1Y1\0" /* 87771 */
	"REALIGN_DQUADS_AFTER_N_WAVES\0" /* 87784 */
	"WAVE_BREAK_REGION_SIZE\0" /* 87813 */
	"BINNING_ALLOWED\0" /* 87836 */
	"FORCE_BINNING_ON\0" /* 87852 */
	"DISABLE_BINNING_USE_NEW_SC\0" /* 87869 */
	"DISABLE_BINNING_USE_LEGACY_SC\0" /* 87896 */
	"BINNING_MODE\0" /* 87926 */
	"BIN_SIZE_X\0" /* 87939 */
	"BIN_SIZE_Y\0" /* 87950 */
	"BIN_SIZE_32_PIXELS\0" /* 87961 */
	"BIN_SIZE_64_PIXELS\0" /* 87980 */
	"BIN_SIZE_128_PIXELS\0" /* 87999 */
	"BIN_SIZE_256_PIXELS\0" /* 88019 */
	"BIN_SIZE_512_PIXELS\0" /* 88039 */
	"BIN_SIZE_X_EXTEND\0" /* 88059 */
	"BIN_SIZE_Y_EXTEND\0" /* 88077 */
	"CONTEXT_STATES_PER_BIN\0" /* 88095 */
	"PERSISTENT_STATES_PER_BIN\0" /* 88118 */
	"DISABLE_START_OF_PRIM\0" /* 88144 */
	"FPOVS_PER_BATCH\0" /* 88166 */
	"OPTIMAL_BIN_SELECTION\0" /* 88182 */
	"FLUSH_ON_BINNING_TRANSITION\0" /* 88204 */
	"BIN_MAP_MODE_NONE\0" /* 88232 */
	"BIN_MAP_MODE_RTA_INDEX\0" /* 88250 */
	"BIN_MAP_MODE_POPS\0" /* 88273 */
	"BIN_MAPPING_MODE\0" /* 88291 */
	"MAX_ALLOC_COUNT\0" /* 88308 */
	"MAX_PRIM_PER_BATCH\0" /* 88324 */
	"OVER_RAST_ENABLE\0" /* 88343 */
	"OVER_RAST_SAMPLE_SELECT\0" /* 88360 */
	"UNDER_RAST_ENABLE\0" /* 88384 */
	"UNDER_RAST_SAMPLE_SELECT\0" /* 88402 */
	"PBB_UNCERTAINTY_REGION_ENABLE\0" /* 88427 */
	"ZMM_TRI_EXTENT\0" /* 88457 */
	"ZMM_TRI_OFFSET\0" /* 88472 */
	"OVERRIDE_OVER_RAST_INNER_TO_NORMAL\0" /* 88487 */
	"OVERRIDE_UNDER_RAST_INNER_TO_NORMAL\0" /* 88522 */
	"DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE\0" /* 88558 */
	"SC_HALF_LSB\0" /* 88602 */
	"SC_LSB_ONE_SIDED\0" /* 88614, 88627 */
	"SC_LSB_TWO_SIDED\0" /* 88631 */
	"UNCERTAINTY_REGION_MODE\0" /* 88648 */
	"OUTER_UNCERTAINTY_EDGERULE_OVERRIDE\0" /* 88672 */
	"INNER_UNCERTAINTY_EDGERULE_OVERRIDE\0" /* 88708 */
	"NULL_SQUAD_AA_MASK_ENABLE\0" /* 88744 */
	"COVERAGE_AA_MASK_ENABLE\0" /* 88770 */
	"PREZ_AA_MASK_ENABLE\0" /* 88794 */
	"POSTZ_AA_MASK_ENABLE\0" /* 88814 */
	"CENTROID_SAMPLE_OVERRIDE\0" /* 88835 */
	"UNCERTAINTY_REGION_MULT\0" /* 88860 */
	"UNCERTAINTY_REGION_PBB_MULT\0" /* 88884 */
	"MAX_DEALLOCS_IN_WAVE\0" /* 88912 */
	"MAX_FPOVS_IN_WAVE\0" /* 88933 */
	"VTX_REUSE_DEPTH\0" /* 88951 */
	"DEALLOC_DIST\0" /* 88967 */
	"TILE_MAX\0" /* 88980 */
	"FMASK_TILE_MAX\0" /* 88989 */
	"MIP_LEVEL\0" /* 89004 */
	"ENDIAN_NONE\0" /* 89014 */
	"ENDIAN_8IN16\0" /* 89026 */
	"ENDIAN_8IN32\0" /* 89039 */
	"ENDIAN_8IN64\0" /* 89052 */
	"ENDIAN\0" /* 89065 */
	"COLOR_INVALID\0" /* 89072 */
	"COLOR_8\0" /* 89086 */
	"COLOR_16\0" /* 89094 */
	"COLOR_8_8\0" /* 89103 */
	"COLOR_32\0" /* 89113 */
	"COLOR_16_16\0" /* 89122 */
	"COLOR_10_11_11\0" /* 89134 */
	"COLOR_11_11_10\0" /* 89149 */
	"COLOR_10_10_10_2\0" /* 89164 */
	"COLOR_2_10_10_10\0" /* 89181 */
	"COLOR_8_8_8_8\0" /* 89198 */
	"COLOR_32_32\0" /* 89212 */
	"COLOR_16_16_16_16\0" /* 89224 */
	"COLOR_RESERVED_13\0" /* 89242 */
	"COLOR_32_32_32_32\0" /* 89260 */
	"COLOR_RESERVED_15\0" /* 89278 */
	"COLOR_5_6_5\0" /* 89296 */
	"COLOR_1_5_5_5\0" /* 89308 */
	"COLOR_5_5_5_1\0" /* 89322 */
	"COLOR_4_4_4_4\0" /* 89336 */
	"COLOR_8_24\0" /* 89350 */
	"COLOR_24_8\0" /* 89361 */
	"COLOR_X24_8_32_FLOAT\0" /* 89372 */
	"COLOR_RESERVED_23\0" /* 89393 */
	"COLOR_RESERVED_24\0" /* 89411 */
	"COLOR_RESERVED_25\0" /* 89429 */
	"COLOR_RESERVED_26\0" /* 89447 */
	"COLOR_RESERVED_27\0" /* 89465 */
	"COLOR_RESERVED_28\0" /* 89483 */
	"COLOR_RESERVED_29\0" /* 89501 */
	"COLOR_RESERVED_30\0" /* 89519 */
	"COLOR_2_10_10_10_6E4\0" /* 89537 */
	"NUMBER_UNORM\0" /* 89558 */
	"NUMBER_SNORM\0" /* 89571 */
	"NUMBER_USCALED\0" /* 89584 */
	"NUMBER_SSCALED\0" /* 89599 */
	"NUMBER_UINT\0" /* 89614 */
	"NUMBER_SINT\0" /* 89626 */
	"NUMBER_SRGB\0" /* 89638 */
	"NUMBER_FLOAT\0" /* 89650 */
	"NUMBER_TYPE\0" /* 89663 */
	"SWAP_STD\0" /* 89675 */
	"SWAP_ALT\0" /* 89684 */
	"SWAP_STD_REV\0" /* 89693 */
	"SWAP_ALT_REV\0" /* 89706 */
	"COMP_SWAP\0" /* 89719 */
	"BLEND_CLAMP\0" /* 89729 */
	"BLEND_BYPASS\0" /* 89741 */
	"SIMPLE_FLOAT\0" /* 89754 */
	"CMASK_IS_LINEAR\0" /* 89767, 89776 */
	"FORCE_OPT_AUTO\0" /* 89783 */
	"FORCE_OPT_DISABLE\0" /* 89798 */
	"FORCE_OPT_ENABLE_IF_SRC_A_0\0" /* 89816 */
	"FORCE_OPT_ENABLE_IF_SRC_RGB_0\0" /* 89844 */
	"FORCE_OPT_ENABLE_IF_SRC_ARGB_0\0" /* 89874 */
	"FORCE_OPT_ENABLE_IF_SRC_A_1\0" /* 89905 */
	"FORCE_OPT_ENABLE_IF_SRC_RGB_1\0" /* 89933 */
	"FORCE_OPT_ENABLE_IF_SRC_ARGB_1\0" /* 89963 */
	"BLEND_OPT_DONT_RD_DST\0" /* 89994 */
	"BLEND_OPT_DISCARD_PIXEL\0" /* 90016 */
	"FMASK_COMPRESSION_DISABLE\0" /* 90040 */
	"FMASK_COMPRESS_1FRAG_ONLY\0" /* 90066 */
	"DCC_ENABLE\0" /* 90092 */
	"CMASK_ADDR_TILED\0" /* 90103 */
	"CMASK_ADDR_LINEAR\0" /* 90120 */
	"CMASK_ADDR_COMPATIBLE\0" /* 90138 */
	"CMASK_ADDR_TYPE\0" /* 90160 */
	"ALT_TILE_MODE\0" /* 90176 */
	"TILE_MODE_INDEX\0" /* 90190 */
	"FMASK_TILE_MODE_INDEX\0" /* 90206 */
	"FMASK_BANK_HEIGHT\0" /* 90228 */
	"NUM_FRAGMENTS\0" /* 90246 */
	"FORCE_DST_ALPHA_1\0" /* 90260 */
	"DISABLE_FMASK_NOFETCH_OPT\0" /* 90278 */
	"LIMIT_COLOR_FETCH_TO_256B_MAX\0" /* 90304 */
	"KEY_CLEAR_ENABLE\0" /* 90334 */
	"MAX_BLOCK_SIZE_64B\0" /* 90351 */
	"MAX_BLOCK_SIZE_128B\0" /* 90370 */
	"MAX_BLOCK_SIZE_256B\0" /* 90390 */
	"MIN_BLOCK_SIZE_32B\0" /* 90410 */
	"MIN_BLOCK_SIZE_64B\0" /* 90429 */
	"MIN_COMPRESSED_BLOCK_SIZE\0" /* 90448 */
	"INDEPENDENT_64B_BLOCKS\0" /* 90474 */
	"LOSSY_RGB_PRECISION\0" /* 90497 */
	"LOSSY_ALPHA_PRECISION\0" /* 90517 */
	"ENABLE_CONSTANT_ENCODE_REG_WRITE\0" /* 90539 */
	"INDEPENDENT_128B_BLOCKS\0" /* 90572 */
	"MIP0_HEIGHT\0" /* 90596 */
	"MIP0_WIDTH\0" /* 90608 */
	"MIP0_DEPTH\0" /* 90619 */
	"META_LINEAR\0" /* 90630 */
	"COLOR_SW_MODE\0" /* 90642 */
	"FMASK_SW_MODE\0" /* 90656 */
	"RESOURCE_TYPE\0" /* 90670 */
	"CMASK_PIPE_ALIGNED\0" /* 90684 */
	"DCC_PIPE_ALIGNED\0" /* 90703 */
	"NUM_PRIM_WRITTEN_CNT0_LO\0" /* 90720 */
	"NUM_PRIM_WRITTEN_CNT0_HI\0" /* 90745 */
	"NUM_PRIM_NEEDED_CNT0_LO\0" /* 90770 */
	"NUM_PRIM_NEEDED_CNT0_HI\0" /* 90794 */
	"NUM_PRIM_WRITTEN_CNT1_LO\0" /* 90818 */
	"NUM_PRIM_WRITTEN_CNT1_HI\0" /* 90843 */
	"NUM_PRIM_NEEDED_CNT1_LO\0" /* 90868 */
	"NUM_PRIM_NEEDED_CNT1_HI\0" /* 90892 */
	"NUM_PRIM_WRITTEN_CNT2_LO\0" /* 90916 */
	"NUM_PRIM_WRITTEN_CNT2_HI\0" /* 90941 */
	"NUM_PRIM_NEEDED_CNT2_LO\0" /* 90966 */
	"NUM_PRIM_NEEDED_CNT2_HI\0" /* 90990 */
	"NUM_PRIM_WRITTEN_CNT3_LO\0" /* 91014 */
	"NUM_PRIM_WRITTEN_CNT3_HI\0" /* 91039 */
	"NUM_PRIM_NEEDED_CNT3_LO\0" /* 91064 */
	"NUM_PRIM_NEEDED_CNT3_HI\0" /* 91088 */
	"OBSOLETE\0" /* 91112 */
	"DOORBELL_OFFSET\0" /* 91121 */
	"CACHE_POLICY\0" /* 91137 */
	"OFFSET_UPDATE_DONE\0" /* 91150 */
	"LAST_FENCE\0" /* 91169 */
	"OBSOLETE_UMSK\0" /* 91180 */
	"OBSOLETE_SWAP\0" /* 91194 */
	"OBSOLETE_ADDR\0" /* 91208 */
	"MEM_ADDR_LO\0" /* 91222 */
	"MEM_ADDR_HI\0" /* 91234 */
	"CS_PS_SEL\0" /* 91246 */
	"SEM_ADDR_SWAP\0" /* 91256, 91260 */
	"SEM_USE_MAILBOX\0" /* 91270 */
	"SEM_SIGNAL_TYPE\0" /* 91286 */
	"SEM_CLIENT_CODE\0" /* 91302 */
	"SEM_SELECT\0" /* 91318 */
	"MEMLOG_CLEAR\0" /* 91329 */
	"SRC_CACHE_POLICY\0" /* 91342 */
	"SRC_VOLATLE\0" /* 91359 */
	"DST_SELECT\0" /* 91371 */
	"DST_CACHE_POLICY\0" /* 91382 */
	"DST_VOLATLE\0" /* 91399 */
	"SRC_SELECT\0" /* 91411 */
	"COHER_BASE_HI_256B\0" /* 91422 */
	"START_DELAY_COUNT\0" /* 91441 */
	"TC_NC_ACTION_ENA\0" /* 91459 */
	"TC_WC_ACTION_ENA\0" /* 91476 */
	"TC_INV_METADATA_ACTION_ENA\0" /* 91493 */
	"TCL1_VOL_ACTION_ENA\0" /* 91520 */
	"TC_WB_ACTION_ENA\0" /* 91540 */
	"TCL1_ACTION_ENA\0" /* 91557 */
	"TC_ACTION_ENA\0" /* 91573 */
	"CB_ACTION_ENA\0" /* 91587 */
	"DB_ACTION_ENA\0" /* 91601 */
	"SH_KCACHE_ACTION_ENA\0" /* 91615 */
	"SH_KCACHE_VOL_ACTION_ENA\0" /* 91636 */
	"SH_ICACHE_ACTION_ENA\0" /* 91661 */
	"SH_KCACHE_WB_ACTION_ENA\0" /* 91682 */
	"COHER_SIZE_256B\0" /* 91706 */
	"COHER_BASE_256B\0" /* 91722 */
	"MEID\0" /* 91738 */
	"BYTE_COUNT\0" /* 91743 */
	"SAS\0" /* 91754 */
	"DAS\0" /* 91758 */
	"SAIC\0" /* 91762 */
	"DAIC\0" /* 91767 */
	"RAW_WAIT\0" /* 91772 */
	"DIS_WC\0" /* 91781 */
	"UTCL1_FAULT_CONTROL\0" /* 91788 */
	"WATCH_CONTROL\0" /* 91808 */
	"MIN_AVAILSZ\0" /* 91822 */
	"BUFFER_DEPTH\0" /* 91834 */
	"PIO_FIFO_EMPTY\0" /* 91847 */
	"PIO_FIFO_FULL\0" /* 91862 */
	"PIO_COUNT\0" /* 91876 */
	"DMA_READ_TAG\0" /* 91886 */
	"DMA_READ_TAG_VALID\0" /* 91899 */
	"COHER_SIZE_HI_256B\0" /* 91918 */
	"IB_EN\0" /* 91937 */
	"CONFIG_REG_EN\0" /* 91943 */
	"CNTX_REG_EN\0" /* 91957 */
	"SH_GFX_REG_EN\0" /* 91969 */
	"SH_CS_REG_EN\0" /* 91983 */
	"CONST_ENGINE_COUNT\0" /* 91996 */
	"RSVD\0" /* 92015 */
	"INIT_CMD_REQSZ\0" /* 92020 */
	"IB1_CMD_REQSZ\0" /* 92035 */
	"IB2_CMD_REQSZ\0" /* 92049 */
	"ST_CMD_REQSZ\0" /* 92063 */
	"EOP_VOLATILE\0" /* 92076 */
	"EXECUTE\0" /* 92089 */
	"DST_SEL\0" /* 92097 */
	"INT_SEL\0" /* 92105 */
	"DATA_SEL\0" /* 92113 */
	"DB_CMD_REQSZ\0" /* 92122 */
	"Z_PASS_ACITVE\0" /* 92135 */
	"STREAMOUT_ACTIVE\0" /* 92149 */
	"PIPELINE_ACTIVE\0" /* 92166 */
	"STIPPLE_ACTIVE\0" /* 92182 */
	"VGT_BUFFERS_ACTIVE\0" /* 92197 */
	"SCREEN_EXT_ACTIVE\0" /* 92216 */
	"DRAW_INDIRECT_ACTIVE\0" /* 92234 */
	"DISP_INDIRECT_ACTIVE\0" /* 92255 */
	"DEST_BASE_0_ENA\0" /* 92276 */
	"DEST_BASE_1_ENA\0" /* 92292 */
	"CB0_DEST_BASE_ENA\0" /* 92308 */
	"CB1_DEST_BASE_ENA\0" /* 92326 */
	"CB2_DEST_BASE_ENA\0" /* 92344 */
	"CB3_DEST_BASE_ENA\0" /* 92362 */
	"CB4_DEST_BASE_ENA\0" /* 92380 */
	"CB5_DEST_BASE_ENA\0" /* 92398 */
	"CB6_DEST_BASE_ENA\0" /* 92416 */
	"CB7_DEST_BASE_ENA\0" /* 92434 */
	"DB_DEST_BASE_ENA\0" /* 92452 */
	"DEST_BASE_2_ENA\0" /* 92469 */
	"DEST_BASE_3_ENA\0" /* 92485 */
	"MATCHING_GFX_CNTX\0" /* 92501 */
	"FEATURE_SEL\0" /* 92519 */
	"SE_INDEX\0" /* 92531 */
	"SA_INDEX\0" /* 92540 */
	"WGP_INDEX\0" /* 92549 */
	"EVENT_SEL\0" /* 92559 */
	"INSTANCE_INDEX\0" /* 92569 */
	"SA_BROADCAST_WRITES\0" /* 92584 */
	"INSTANCE_BROADCAST_WRITES\0" /* 92604 */
	"SE_BROADCAST_WRITES\0" /* 92630 */
	"MEM_SIZE\0" /* 92650 */
	"OFFCHIP_BUFFERING\0" /* 92659 */
	"X_8K_DWORDS\0" /* 92677 */
	"X_4K_DWORDS\0" /* 92689 */
	"X_2K_DWORDS\0" /* 92701 */
	"X_1K_DWORDS\0" /* 92713 */
	"OFFCHIP_GRANULARITY\0" /* 92725 */
	"EN_INST_OPT_BASIC\0" /* 92745 */
	"EN_INST_OPT_ADV\0" /* 92763 */
	"HW_USE_ONLY\0" /* 92779 */
	"PRIM_GRP_SIZE\0" /* 92791 */
	"VERT_GRP_SIZE\0" /* 92805 */
	"BREAK_WAVE_AT_EOI\0" /* 92819 */
	"PACKET_TO_ONE_PA\0" /* 92837 */
	"RT_SLICE\0" /* 92854 */
	"VIEWPORT\0" /* 92863 */
	"EN_STEREO\0" /* 92872 */
	"OVERSUB_EN\0" /* 92882 */
	"NUM_PC_LINES\0" /* 92893 */
	"EN_USER_VGPR1\0" /* 92906 */
	"EN_USER_VGPR2\0" /* 92920 */
	"EN_USER_VGPR3\0" /* 92934 */
	"CURRENT_PTR\0" /* 92948 */
	"CURRENT_COUNT\0" /* 92960 */
	"ENABLE_HV_PRE_SHADER\0" /* 92974 */
	"FORCE_PRE_SHADER_ALL_PIXELS\0" /* 92995 */
	"X_COORD\0" /* 93023 */
	"Y_COORD\0" /* 93031 */
	"TARGET_INST\0" /* 93039 */
	"TARGET_DATA\0" /* 93051 */
	"INVALIDATE\0" /* 93063 */
	"L2_WB_POLICY\0" /* 93074 */
	"DWB\0" /* 93087 */
	"READ_ADDR\0" /* 93091 */
	"READ_DATA\0" /* 93101 */
	"WRITE_ADDR\0" /* 93111 */
	"AINC\0" /* 93122 */
	"UNUSED1\0" /* 93127 */
	"DMODE\0" /* 93135 */
	"UNUSED2\0" /* 93141 */
	"RELEASE_ALL\0" /* 93149 */
	"HEAD_QUEUE\0" /* 93161 */
	"HEAD_VALID\0" /* 93172 */
	"HEAD_FLAG\0" /* 93183 */
	"HALTED\0" /* 93193 */
	"SPACE_AVAILABLE\0" /* 93200 */
	"DS_ADDRESS\0" /* 93216 */
	"CRAWLER_TYPE\0" /* 93227 */
	"CRAWLER\0" /* 93240 */
	"NO_ALLOC\0" /* 93248 */
	"COMPARE_VALUE\0" /* 93257 */
	"PERF_SEL\0" /* 93271 */
	"PERF_SEL1\0" /* 93280 */
	"SPM_MODE\0" /* 93290 */
	"CNTR_MODE1\0" /* 93299 */
	"CNTR_MODE0\0" /* 93310 */
	"PERF_SEL2\0" /* 93321 */
	"PERF_SEL3\0" /* 93331 */
	"CNTR_MODE3\0" /* 93341 */
	"CNTR_MODE2\0" /* 93352 */
	"CP_PERFMON_STATE_DISABLE_AND_RESET\0" /* 93363 */
	"CP_PERFMON_STATE_START_COUNTING\0" /* 93398 */
	"CP_PERFMON_STATE_STOP_COUNTING\0" /* 93430 */
	"CP_PERFMON_STATE_RESERVED_3\0" /* 93461, 93478 */
	"CP_PERFMON_STATE_DISABLE_AND_RESET_PHANTOM\0" /* 93489 */
	"CP_PERFMON_STATE_COUNT_AND_DUMP_PHANTOM\0" /* 93532 */
	"PERFMON_STATE\0" /* 93572 */
	"STRM_PERFMON_STATE_DISABLE_AND_RESET\0" /* 93586 */
	"STRM_PERFMON_STATE_START_COUNTING\0" /* 93623 */
	"STRM_PERFMON_STATE_STOP_COUNTING\0" /* 93657 */
	"STRM_PERFMON_STATE_RESERVED_3\0" /* 93690 */
	"STRM_PERFMON_STATE_DISABLE_AND_RESET_PHANTOM\0" /* 93720 */
	"STRM_PERFMON_STATE_COUNT_AND_DUMP_PHANTOM\0" /* 93765 */
	"SPM_PERFMON_STATE\0" /* 93807 */
	"CP_PERFMON_ENABLE_MODE_ALWAYS_COUNT\0" /* 93825 */
	"CP_PERFMON_ENABLE_MODE_RESERVED_1\0" /* 93861 */
	"CP_PERFMON_ENABLE_MODE_COUNT_CONTEXT_TRUE\0" /* 93895 */
	"CP_PERFMON_ENABLE_MODE_COUNT_CONTEXT_FALSE\0" /* 93937 */
	"PERFMON_ENABLE_MODE\0" /* 93980 */
	"PERFMON_SAMPLE_ENABLE\0" /* 94000 */
	"DISABLE_DRAW_WINDOW_LO_MAX\0" /* 94022 */
	"DISABLE_DRAW_WINDOW_LO_MIN\0" /* 94049 */
	"DISABLE_DRAW_WINDOW_HI\0" /* 94076 */
	"DB_CLEAN_USER_DEFINED_MASK\0" /* 94099 */
	"CB_CLEAN_USER_DEFINED_MASK\0" /* 94126 */
	"TA_BUSY_USER_DEFINED_MASK\0" /* 94153 */
	"SX_BUSY_USER_DEFINED_MASK\0" /* 94179 */
	"SPI_BUSY_USER_DEFINED_MASK\0" /* 94205 */
	"SC_BUSY_USER_DEFINED_MASK\0" /* 94232 */
	"PA_BUSY_USER_DEFINED_MASK\0" /* 94258 */
	"GRBM_BUSY_USER_DEFINED_MASK\0" /* 94284 */
	"DB_BUSY_USER_DEFINED_MASK\0" /* 94312 */
	"CB_BUSY_USER_DEFINED_MASK\0" /* 94338 */
	"CP_BUSY_USER_DEFINED_MASK\0" /* 94364 */
	"GDS_BUSY_USER_DEFINED_MASK\0" /* 94390 */
	"BCI_BUSY_USER_DEFINED_MASK\0" /* 94417 */
	"RLC_BUSY_USER_DEFINED_MASK\0" /* 94444 */
	"TCP_BUSY_USER_DEFINED_MASK\0" /* 94471 */
	"GE_BUSY_USER_DEFINED_MASK\0" /* 94498 */
	"UTCL2_BUSY_USER_DEFINED_MASK\0" /* 94524 */
	"EA_BUSY_USER_DEFINED_MASK\0" /* 94553 */
	"RMI_BUSY_USER_DEFINED_MASK\0" /* 94579 */
	"UTCL1_BUSY_USER_DEFINED_MASK\0" /* 94606 */
	"GL1CC_BUSY_USER_DEFINED_MASK\0" /* 94635 */
	"GL2CC_BUSY_USER_DEFINED_MASK\0" /* 94664 */
	"SDMA_BUSY_USER_DEFINED_MASK\0" /* 94693 */
	"CH_BUSY_USER_DEFINED_MASK\0" /* 94721 */
	"PH_BUSY_USER_DEFINED_MASK\0" /* 94747 */
	"PMM_BUSY_USER_DEFINED_MASK\0" /* 94773 */
	"GUS_BUSY_USER_DEFINED_MASK\0" /* 94800 */
	"PERF_SEL0\0" /* 94827 */
	"CNTR_MODE\0" /* 94837 */
	"PERF_MODE0\0" /* 94847 */
	"PERF_MODE1\0" /* 94858 */
	"PERF_MODE2\0" /* 94869 */
	"PERF_MODE3\0" /* 94880 */
	"PERF_MODE\0" /* 94891 */
	"BIN0_MIN\0" /* 94901 */
	"BIN0_MAX\0" /* 94910 */
	"BIN1_MIN\0" /* 94919 */
	"BIN1_MAX\0" /* 94928 */
	"BIN2_MIN\0" /* 94937 */
	"BIN2_MAX\0" /* 94946 */
	"BIN3_MIN\0" /* 94955 */
	"BIN3_MAX\0" /* 94964 */
	"SQC_BANK_MASK\0" /* 94973 */
	"CS_EN\0" /* 94987 */
	"CNTR_RATE\0" /* 94993 */
	"DISABLE_FLUSH\0" /* 95003 */
	"FORCE_EN\0" /* 95017 */
	"COMPARE_MODE0\0" /* 95026 */
	"COMPARE_MODE1\0" /* 95040 */
	"COMPARE_MODE2\0" /* 95054 */
	"COMPARE_MODE3\0" /* 95068 */
	"COMPARE_VALUE0\0" /* 95082 */
	"COMPARE_VALUE1\0" /* 95097 */
	"COMPARE_VALUE2\0" /* 95112 */
	"COMPARE_VALUE3\0" /* 95127 */
	"PERFCOUNTER_SELECT1\0" /* 95142 */
	"PERFCOUNTER_SELECT2\0" /* 95162 */
	"PERFCOUNTER_SELECT3\0" /* 95182 */
	"OP_FILTER_ENABLE\0" /* 95202 */
	"CB_PERF_OP_FILTER_SEL_WRITE_ONLY\0" /* 95219 */
	"CB_PERF_OP_FILTER_SEL_NEEDS_DESTINATION\0" /* 95252 */
	"CB_PERF_OP_FILTER_SEL_RESOLVE\0" /* 95292 */
	"CB_PERF_OP_FILTER_SEL_DECOMPRESS\0" /* 95322 */
	"CB_PERF_OP_FILTER_SEL_FMASK_DECOMPRESS\0" /* 95355 */
	"CB_PERF_OP_FILTER_SEL_ELIMINATE_FAST_CLEAR\0" /* 95394 */
	"OP_FILTER_SEL\0" /* 95437 */
	"FORMAT_FILTER_ENABLE\0" /* 95451 */
	"FORMAT_FILTER_SEL\0" /* 95472 */
	"CLEAR_FILTER_ENABLE\0" /* 95490 */
	"CB_PERF_CLEAR_FILTER_SEL_NONCLEAR\0" /* 95510 */
	"CB_PERF_CLEAR_FILTER_SEL_CLEAR\0" /* 95544 */
	"CLEAR_FILTER_SEL\0" /* 95575 */
	"MRT_FILTER_ENABLE\0" /* 95592 */
	"MRT_FILTER_SEL\0" /* 95610 */
	"NUM_SAMPLES_FILTER_ENABLE\0" /* 95625 */
	"NUM_SAMPLES_FILTER_SEL\0" /* 95651 */
	"NUM_FRAGMENTS_FILTER_ENABLE\0" /* 95674 */
	"NUM_FRAGMENTS_FILTER_SEL\0" /* 95702 */
	"PERFMON_RING_MODE\0" /* 95727 */
	"PERFMON_SAMPLE_INTERVAL\0" /* 95745 */
	"RING_BASE_SIZE\0" /* 95769 */
	"GLOBAL_NUM_LINE\0" /* 95784 */
	"SE0_NUM_LINE\0" /* 95800 */
	"SE1_NUM_LINE\0" /* 95813 */
	"SE2_NUM_LINE\0" /* 95826 */
	"PERFMON_RING_RDPTR\0" /* 95839 */
	"NUM_SEGMENT_THRESHOLD\0" /* 95858 */
	"PERFMON_SEL_ADDR\0" /* 95880 */
	"PERFMON_SEL_DATA\0" /* 95897 */
	"GLB_SAMPLEDELAY_INDEX\0" /* 95914 */
	"data\0" /* 95936 */
	"SE_SAMPLEDELAY_INDEX\0" /* 95941 */
	"PERFMON_RING_WRPTR\0" /* 95962 */
	"addr\0" /* 95981 */
	"NumbSamplesCompleted\0" /* 95986 */
	"AccumDone\0" /* 96007 */
	"SpmDone\0" /* 96017 */
	"AccumOverflow\0" /* 96025 */
	"AccumArmed\0" /* 96039 */
	"SequenceInProgress\0" /* 96050 */
	"FinalSequenceInProgress\0" /* 96069 */
	"AllFifosEmpty\0" /* 96093 */
	"FSMIsIdle\0" /* 96107 */
	"StrobeResetPerfMonitors\0" /* 96117 */
	"StrobeStartAccumulation\0" /* 96141 */
	"StrobeRearmAccum\0" /* 96165 */
	"StrobeSpmDoneInt\0" /* 96182 */
	"StrobeAccumDoneInt\0" /* 96199 */
	"StrobeResetAccum\0" /* 96218 */
	"StrobeStartSpm\0" /* 96235 */
	"EnableAccum\0" /* 96250 */
	"AutoAccumEn\0" /* 96262 */
	"AutoSpmEn\0" /* 96274 */
	"Globals_LoadOverride\0" /* 96284 */
	"SE0_LoadOverride\0" /* 96305 */
	"SE1_LoadOverride\0" /* 96322 */
	"AutoResetPerfmonDisable\0" /* 96339 */
	"Threshold\0" /* 96363 */
	"SamplesRequested\0" /* 96373 */
	"DataRamWrCount\0" /* 96390 */
	"SE3_NUM_LINE\0" /* 96405 */
	"PauseSpmSamplingRequest\0" /* 96418 */
	"SpmSamplingPaused\0" /* 96442 */
	"MODE_SELECT\0" /* 96460 */
	"VFID\0" /* 96472 */
	"CNT_ID\0" /* 96477 */
	"PERFMON_CLOCK_STATE\0" /* 96484 */
	"TRANS_BASED_PERF_EN_SEL\0" /* 96504 */
	"EVENT_BASED_PERF_EN_SEL\0" /* 96528 */
	"TC_PERF_EN_SEL\0" /* 96552 */
	"PERF_EVENT_WINDOW_MASK0\0" /* 96567 */
	"PERF_EVENT_WINDOW_MASK1\0" /* 96591 */
	"PERF_COUNTER_CID\0" /* 96615 */
	"PERF_COUNTER_VMID\0" /* 96632 */
	"PERF_COUNTER_BURST_LENGTH_THRESHOLD\0" /* 96650 */
	"PERF_SOFT_RESET\0" /* 96686 */
	"PERF_CNTR_SPM_SEL\0" /* 96702 */
	"PERF_SEL_END\0" /* 96720 */
	"PERF_COUNTER_SELECT\0" /* 96733 */
	"START_TRIGGER\0" /* 96753 */
	"STOP_TRIGGER\0" /* 96767 */
	"ENABLE_ANY\0" /* 96780 */
	"CLEAR_ALL\0" /* 96791 */
	"STOP_ALL_ON_SATURATE\0" /* 96801 */
	"CNTL_MODE\0" /* 96822 */
	"COUNTER_MODE\0" /* 96832 */
	"MEM_MAPPED_REGISTER\0" /* 96845 */
	"MEM_GRBM\0" /* 96865 */
	"TC_L2\0" /* 96874 */
	"GDS\0" /* 96880 */
	"WR_ONE_ADDR\0" /* 96884 */
	"WR_CONFIRM\0" /* 96896 */
	"PFP\0" /* 96907 */
	"ENGINE_SEL\0" /* 96911 */
	"IB_SIZE\0" /* 96922 */
	"CHAIN\0" /* 96930 */
	"DST_ADDR_TC_L2\0" /* 96936 */
	"ENGINE\0" /* 96951 */
	"SRC_ADDR_TC_L2\0" /* 96958 */
	"SRC_SEL\0" /* 96973 */
	"CP_SYNC\0" /* 96981 */
	"MEMORY\0" /* 96989 */
	"INCREMENT\0" /* 96996 */
	"NO_INCREMENT\0" /* 97006 */
	"DISABLE_WR_CONFIRM\0" /* 97019 */
	"EVENT_INDEX\0" /* 97038 */
	"GLM_WB\0" /* 97050 */
	"GLM_INV\0" /* 97057 */
	"GLV_INV\0" /* 97065 */
	"GL1_INV\0" /* 97073 */
	"GL2_US\0" /* 97081 */
	"GL2_ALL\0" /* 97088 */
	"GL2_VOL\0" /* 97096 */
	"GL2_RANGE\0" /* 97104 */
	"GL2_FIRST_LAST\0" /* 97114 */
	"GL2_DISCARD\0" /* 97129 */
	"GL2_INV\0" /* 97141 */
	"GL2_WB\0" /* 97149 */
	"SEQ_PARALLEL\0" /* 97156 */
	"SEQ_FORWARD\0" /* 97169 */
	"SEQ_REVERSE\0" /* 97181 */
	"SEQ\0" /* 97193 */
	"GLI_NOP\0" /* 97197 */
	"GLI_ALL\0" /* 97205 */
	"GLI_RANGE\0" /* 97213 */
	"GLI_FIRST_LAST\0" /* 97223 */
	"GLI_INV\0" /* 97238 */
	"GL1_ALL\0" /* 97246 */
	"GL1_RANGE\0" /* 97254 */
	"GL1_FIRST_LAST\0" /* 97264 */
	"GLK_WB\0" /* 97279 */
	"GLK_INV\0" /* 97286 */
	"RANGE_IS_PA\0" /* 97294 */
	"WAVE_SLOT\0" /* 97306 */
	"UTC_ERROR\0" /* 97316 */
	"SDMA_SCH_RQ_PENDING\0" /* 97326 */
	"SDMA2_RQ_PENDING\0" /* 97346 */
	"SDMA3_RQ_PENDING\0" /* 97363 */
	"BOP_EVENTS_TOKEN_INCLUDE\0" /* 97380 */
	"REG_EXCLUDE\0" /* 97405 */
	"LOWATER_OFFSET\0" /* 97417 */
	"AUTO_FLUSH_PADDING_DIS\0" /* 97432 */
	"AUTO_FLUSH_MODE\0" /* 97455 */
	"OWNER_VMID\0" /* 97471 */
	"BUF0_FULL\0" /* 97482 */
	"BUF1_FULL\0" /* 97492 */
	"PACKET_LOST_BUF_NO_LOCKDOWN\0" /* 97502 */
	"LLC_NOALLOC\0" /* 97530 */
	"FORCE_HALF_RATE_PC_EXP\0" /* 97542 */
	"NUM_PKRS\0" /* 97565 */
	"LOAD_PROVOKING_VTX\0" /* 97574 */
	"PS_INVOKE_DISABLE\0" /* 97593 */
	"FORCE_VRS_RATE_FINE\0" /* 97611 */
	"CENTROID_COMPUTATION_MODE\0" /* 97631 */
	"VRS_OVERRIDE_RATE_COMBINER_MODE\0" /* 97657 */
	"VRS_OVERRIDE_RATE_X\0" /* 97689 */
	"VRS_OVERRIDE_RATE_Y\0" /* 97709 */
	"Z_NOALLOC\0" /* 97729 */
	"S_NOALLOC\0" /* 97739 */
	"HTILE_NOALLOC\0" /* 97749 */
	"ZPCPSD_NOALLOC\0" /* 97763 */
	"CMASK_L3_BYPASS\0" /* 97778 */
	"FMASK_L3_BYPASS\0" /* 97794 */
	"DCC_L3_BYPASS\0" /* 97810 */
	"COLOR_L3_BYPASS\0" /* 97824 */
	"ROTATE_PC_PTR\0" /* 97840 */
	"PRIM_EXPORT_COUNT\0" /* 97854 */
	"NUM_PRIM_INTERP\0" /* 97872 */
	"MRT0_FMT_MAPPING_DISABLE\0" /* 97888 */
	"MRT1_FMT_MAPPING_DISABLE\0" /* 97913 */
	"MRT2_FMT_MAPPING_DISABLE\0" /* 97938 */
	"MRT3_FMT_MAPPING_DISABLE\0" /* 97963 */
	"MRT4_FMT_MAPPING_DISABLE\0" /* 97988 */
	"MRT5_FMT_MAPPING_DISABLE\0" /* 98013 */
	"MRT6_FMT_MAPPING_DISABLE\0" /* 98038 */
	"MRT7_FMT_MAPPING_DISABLE\0" /* 98063 */
	"SX_RT_EXPORT_9_9_9_E5\0" /* 98088 */
	"ENABLE_1FRAG_PS_INVOKE\0" /* 98110 */
	"USE_VTX_VRS_RATE\0" /* 98133 */
	"BYPASS_VTX_RATE_COMBINER\0" /* 98150 */
	"BYPASS_PRIM_RATE_COMBINER\0" /* 98175 */
	"VERTEX_REUSE_DEPTH\0" /* 98201 */
	"VERTEX_RATE_COMBINER_MODE\0" /* 98220 */
	"PRIMITIVE_RATE_COMBINER_MODE\0" /* 98246 */
	"HTILE_RATE_COMBINER_MODE\0" /* 98275 */
	"SAMPLE_ITER_COMBINER_MODE\0" /* 98300 */
	"EXPOSE_VRS_PIXELS_MASK\0" /* 98326 */
	"CMASK_RATE_HINT_FORCE_ZERO\0" /* 98349 */
	"DISABLE_INSTANCE_PACKING\0" /* 98376 */
	"VRS_HTILE_ENCODING\0" /* 98401, 98411 */
	"SAMPLE_COVERAGE_ENCODING\0" /* 98420 */
	"COVERED_CENTROID_IS_CENTER\0" /* 98445 */
	"COLOR_5_9_9_9\0" /* 98472 */
	"NBC_TILING\0" /* 98486 */
	"SKIP_LOW_COMP_RATIO\0" /* 98497 */
	"DCC_COMPRESS_DISABLE\0" /* 98517 */
	"VRS_RATE_HINT_ENABLE\0" /* 98538 */
	"IMMED\0" /* 98559 */
	"reserved27\0" /* 98565 */
	"reserved31\0" /* 98576 */
	"SEM_PRIV\0" /* 98587 */
	"UCONFIG_REG_EN\0" /* 98596 */
	"ACTION_PIPE_ID\0" /* 98611 */
	"ACTION_ID\0" /* 98626 */
	"HEAD_QUEUE1\0" /* 98636 */
	"DISABLE_ME0PIPE0_PERF\0" /* 98648 */
	"DISABLE_ME0PIPE1_PERF\0" /* 98670 */
	"DISABLE_ME1PIPE0_PERF\0" /* 98692 */
	"DISABLE_ME1PIPE1_PERF\0" /* 98714 */
	"DISABLE_ME1PIPE2_PERF\0" /* 98736 */
	"DISABLE_ME1PIPE3_PERF\0" /* 98758 */
	"SwaAccumDone\0" /* 98780 */
	"SwaSpmDone\0" /* 98793 */
	"SwaAccumOverflow\0" /* 98804 */
	"SwaAccumArmed\0" /* 98821 */
	"AllSegsDone\0" /* 98835 */
	"RearmSwaPending\0" /* 98847 */
	"RearmSppPending\0" /* 98863 */
	"StrobeResetSpmBlock\0" /* 98879 */
	"StrobeRearmSwaAccum\0" /* 98899 */
	"StrobeStartSwa\0" /* 98919 */
	"StrobePerfmonSampleWires\0" /* 98934 */
	"EnableSpmWithAccumMode\0" /* 98959 */
	"EnableSPPMode\0" /* 98982 */
	"SwaAutoResetPerfmonDisable\0" /* 98996 */
	"SwaAutoAccumEn\0" /* 99023 */
	"SwaAutoSpmEn\0" /* 99038 */
	"Globals_SwaLoadOverride\0" /* 99051 */
	"SE0_SwaLoadOverride\0" /* 99075 */
	"SE1_SwaLoadOverride\0" /* 99095 */
	"SE2_LoadOverride\0" /* 99115 */
	"SE2_SwaLoadOverride\0" /* 99132 */
	"SE3_LoadOverride\0" /* 99152 */
	"SE3_SwaLoadOverride\0" /* 99169 */
	"global_offset\0" /* 99189 */
	"spmwithaccum_se_offset\0" /* 99203 */
	"spmwithaccum_global_offset\0" /* 99226 */
	"spp_addr_region\0" /* 99253 */
	"swa_addr_region\0" /* 99269 */
	"CMD_OP\0" /* 99285 */
	"DEBUG_EN\0" /* 99292 */
	"WAVE_PRIO\0" /* 99301 */
	"TTRACE_CU_EN\0" /* 99311 */
	"COND_DBG_USER\0" /* 99324 */
	"COND_DBG_SYS\0" /* 99338 */
	"DATA_ATC\0" /* 99351 */
	"INST_ATC\0" /* 99360 */
	"DISPATCH_CACHE_CTRL\0" /* 99369 */
	"IBUF_ST\0" /* 99389 */
	"PC_INVALID\0" /* 99397 */
	"NEED_NEXT_DW\0" /* 99408 */
	"NO_PREFETCH_CNT\0" /* 99421 */
	"IBUF_RPTR\0" /* 99437 */
	"IBUF_WPTR\0" /* 99447 */
	"INST_STR_ST\0" /* 99457 */
	"ECC_ST\0" /* 99469 */
	"IS_HYB\0" /* 99476 */
	"HYB_CNT\0" /* 99483 */
	"NEED_KILL_IFETCH\0" /* 99491 */
	"SDMA_RQ_PENDING\0" /* 99508 */
	"TST_RQ_PENDING\0" /* 99524 */
	"VCE0_RQ_PENDING\0" /* 99539 */
	"VP8_BUSY\0" /* 99555 */
	"SDMA1_BUSY\0" /* 99564 */
	"VCE0_BUSY\0" /* 99575 */
	"XDMA_BUSY\0" /* 99585 */
	"CHUB_BUSY\0" /* 99595 */
	"SDMA2_BUSY\0" /* 99605 */
	"SDMA3_BUSY\0" /* 99616 */
	"SAMSCP_BUSY\0" /* 99627 */
	"ISP_BUSY\0" /* 99639 */
	"VCE1_BUSY\0" /* 99648 */
	"ODE_BUSY\0" /* 99658 */
	"SAMSCP_RQ_PENDING\0" /* 99667 */
	"ISP_RQ_PENDING\0" /* 99685 */
	"VCE1_RQ_PENDING\0" /* 99700 */
	"UVD_RQ_PENDING\0" /* 99716 */
	"SAMMSP_RQ_PENDING\0" /* 99731 */
	"ACP_RQ_PENDING\0" /* 99749 */
	"GRBM_RQ_PENDING\0" /* 99764 */
	"HI_RQ_PENDING\0" /* 99780 */
	"VMC_BUSY\0" /* 99794 */
	"MCB_BUSY\0" /* 99803 */
	"MCB_NON_DISPLAY_BUSY\0" /* 99812 */
	"MCC_BUSY\0" /* 99833 */
	"MCD_BUSY\0" /* 99842 */
	"VMC1_BUSY\0" /* 99851 */
	"SEM_BUSY\0" /* 99861 */
	"ACP_BUSY\0" /* 99870 */
	"IH_BUSY\0" /* 99879 */
	"UVD_BUSY\0" /* 99887 */
	"SAMMSP_BUSY\0" /* 99896 */
	"GCATCL2_BUSY\0" /* 99908 */
	"OSATCL2_BUSY\0" /* 99921 */
	"BIF_BUSY\0" /* 99934 */
	"MCC0_BUSY\0" /* 99943 */
	"MCC1_BUSY\0" /* 99953 */
	"MCC2_BUSY\0" /* 99963 */
	"MCC3_BUSY\0" /* 99973 */
	"MCC4_BUSY\0" /* 99983 */
	"MCC5_BUSY\0" /* 99993 */
	"MCC6_BUSY\0" /* 100003 */
	"MCC7_BUSY\0" /* 100013 */
	"MCD0_BUSY\0" /* 100023 */
	"MCD1_BUSY\0" /* 100033 */
	"MCD2_BUSY\0" /* 100043 */
	"MCD3_BUSY\0" /* 100053 */
	"MCD4_BUSY\0" /* 100063 */
	"MCD5_BUSY\0" /* 100073 */
	"MCD6_BUSY\0" /* 100083 */
	"MCD7_BUSY\0" /* 100093 */
	"READ_TIMEOUT\0" /* 100103 */
	"SKEW_TOP_THRESHOLD\0" /* 100116 */
	"SKEW_COUNT\0" /* 100135 */
	"REQ_TYPE\0" /* 100146 */
	"RSP_TYPE\0" /* 100155 */
	"SRBM_RQ_PENDING\0" /* 100164 */
	"WD_BUSY_NO_DMA\0" /* 100180 */
	"VGT_BUSY\0" /* 100195 */
	"IA_BUSY_NO_DMA\0" /* 100204 */
	"IA_BUSY\0" /* 100219 */
	"WD_BUSY\0" /* 100227 */
	"SOFT_RESET_CP\0" /* 100235 */
	"SOFT_RESET_RLC\0" /* 100249 */
	"SOFT_RESET_GFX\0" /* 100264 */
	"SOFT_RESET_CPF\0" /* 100279 */
	"SOFT_RESET_CPC\0" /* 100294 */
	"SOFT_RESET_CPG\0" /* 100309 */
	"GRBM_DEBUG_INDEX\0" /* 100324 */
	"SH_INDEX\0" /* 100341 */
	"SH_BROADCAST_WRITES\0" /* 100350 */
	"PREFIX_DELAY_CNT\0" /* 100370 */
	"POST_DELAY_CNT\0" /* 100387 */
	"IGNORE_RDY\0" /* 100402 */
	"IGNORE_FAO\0" /* 100413 */
	"DISABLE_READ_TIMEOUT\0" /* 100424 */
	"SNAPSHOT_FREE_CNTRS\0" /* 100445 */
	"HYSTERESIS_GUI_ACTIVE\0" /* 100465 */
	"GFX_CLOCK_DOMAIN_OVERRIDE\0" /* 100487 */
	"CPF_RDY\0" /* 100513 */
	"CPG_RDY\0" /* 100521 */
	"SRBM_RDY\0" /* 100529 */
	"WD_ME0PIPE0_RDY\0" /* 100538 */
	"WD_ME0PIPE1_RDY\0" /* 100554 */
	"SE0SPI_ME0PIPE0_RDY0\0" /* 100570 */
	"SE0SPI_ME0PIPE1_RDY0\0" /* 100591 */
	"SE1SPI_ME0PIPE0_RDY0\0" /* 100612 */
	"GDS_RDY\0" /* 100633 */
	"SE1SPI_ME0PIPE1_RDY0\0" /* 100641 */
	"SE2SPI_ME0PIPE0_RDY0\0" /* 100662 */
	"SE2SPI_ME0PIPE1_RDY0\0" /* 100683 */
	"SE3SPI_ME0PIPE0_RDY0\0" /* 100704 */
	"SE3SPI_ME0PIPE1_RDY0\0" /* 100725 */
	"SE0SPI_ME0PIPE0_RDY1\0" /* 100746 */
	"SE0SPI_ME0PIPE1_RDY1\0" /* 100767 */
	"SE1SPI_ME0PIPE0_RDY1\0" /* 100788 */
	"SE1SPI_ME0PIPE1_RDY1\0" /* 100809 */
	"SE2SPI_ME0PIPE0_RDY1\0" /* 100830 */
	"SE2SPI_ME0PIPE1_RDY1\0" /* 100851 */
	"SE3SPI_ME0PIPE0_RDY1\0" /* 100872 */
	"SE3SPI_ME0PIPE1_RDY1\0" /* 100893 */
	"READ_ADDRESS\0" /* 100914 */
	"READ_PIPEID\0" /* 100927 */
	"READ_MEID\0" /* 100939 */
	"RDERR_INT_ENABLE\0" /* 100949 */
	"GUI_IDLE_INT_ENABLE\0" /* 100966 */
	"VGT_BUSY_USER_DEFINED_MASK\0" /* 100986 */
	"IA_BUSY_USER_DEFINED_MASK\0" /* 101013 */
	"TC_BUSY_USER_DEFINED_MASK\0" /* 101039 */
	"WD_BUSY_USER_DEFINED_MASK\0" /* 101065 */
	"THREAD_TRACE\0" /* 101091 */
	"WLT\0" /* 101104 */
	"THREAD_TRACE_BUF_FULL\0" /* 101108 */
	"REG_TIMESTAMP\0" /* 101130 */
	"CMD_TIMESTAMP\0" /* 101144 */
	"HOST_CMD_OVERFLOW\0" /* 101158, 101163 */
	"HOST_REG_OVERFLOW\0" /* 101176 */
	"IMMED_OVERFLOW\0" /* 101194 */
	"STREAM_OUT_ADDR_SWAP\0" /* 101209 */
	"PIPE_STATS_ADDR_SWAP\0" /* 101230 */
	"ME_MC_WADDR_SWAP\0" /* 101251 */
	"ME_MC_RADDR_SWAP\0" /* 101268 */
	"TC_VOL_ACTION_ENA\0" /* 101285 */
	"PHASE1_STATUS\0" /* 101303 */
	"SRC_SWAP\0" /* 101317 */
	"DST_SWAP\0" /* 101326 */
	"CE_TO_CSF_NOT_RDY_TO_RCV\0" /* 101335 */
	"CE_TO_RAM_INIT_FETCHER_NOT_RDY_TO_RCV\0" /* 101360 */
	"CE_WAITING_ON_DATA_FROM_RAM_INIT_FETCHER\0" /* 101398 */
	"CE_TO_RAM_INIT_NOT_RDY\0" /* 101439 */
	"CE_TO_RAM_DUMP_NOT_RDY\0" /* 101462 */
	"CE_TO_RAM_WRITE_NOT_RDY\0" /* 101485 */
	"CE_TO_INC_FIFO_NOT_RDY_TO_RCV\0" /* 101509 */
	"CE_TO_WR_FIFO_NOT_RDY_TO_RCV\0" /* 101539 */
	"CE_TO_MIU_WRITE_NOT_RDY_TO_RCV\0" /* 101568 */
	"CE_WAITING_ON_BUFFER_DATA\0" /* 101599 */
	"CE_WAITING_ON_CE_BUFFER_FLAG\0" /* 101625 */
	"CE_WAITING_ON_DE_COUNTER\0" /* 101654 */
	"CE_WAITING_ON_DE_COUNTER_UNDERFLOW\0" /* 101679 */
	"RBIU_TO_DMA_NOT_RDY_TO_RCV\0" /* 101714 */
	"RBIU_TO_SEM_NOT_RDY_TO_RCV\0" /* 101741 */
	"RBIU_TO_MEMWR_NOT_RDY_TO_RCV\0" /* 101768 */
	"ME_HAS_ACTIVE_CE_BUFFER_FLAG\0" /* 101797 */
	"ME_HAS_ACTIVE_DE_BUFFER_FLAG\0" /* 101826 */
	"ME_STALLED_ON_TC_WR_CONFIRM\0" /* 101855 */
	"ME_STALLED_ON_ATOMIC_RTN_DATA\0" /* 101883 */
	"ME_WAITING_ON_MC_READ_DATA\0" /* 101913 */
	"ME_WAITING_ON_REG_READ_DATA\0" /* 101940 */
	"MIU_WAITING_ON_RDREQ_FREE\0" /* 101968 */
	"MIU_WAITING_ON_WRREQ_FREE\0" /* 101994 */
	"RCIU_WAITING_ON_GDS_FREE\0" /* 102020 */
	"RCIU_WAITING_ON_GRBM_FREE\0" /* 102045 */
	"RCIU_WAITING_ON_VGT_FREE\0" /* 102071 */
	"RCIU_STALLED_ON_ME_READ\0" /* 102096 */
	"RCIU_STALLED_ON_DMA_READ\0" /* 102120 */
	"RCIU_HALTED_BY_REG_VIOLATION\0" /* 102145 */
	"RCIU_STALLED_ON_APPEND_READ\0" /* 102174 */
	"PFP_TO_CSF_NOT_RDY_TO_RCV\0" /* 102202 */
	"PFP_TO_MEQ_NOT_RDY_TO_RCV\0" /* 102228 */
	"PFP_TO_RCIU_NOT_RDY_TO_RCV\0" /* 102254 */
	"PFP_TO_VGT_WRITES_PENDING\0" /* 102281 */
	"PFP_RCIU_READ_PENDING\0" /* 102307 */
	"PFP_MIU_READ_PENDING\0" /* 102329 */
	"PFP_TO_MIU_WRITE_NOT_RDY_TO_RCV\0" /* 102350 */
	"PFP_WAITING_ON_BUFFER_DATA\0" /* 102382 */
	"ME_WAIT_ON_CE_COUNTER\0" /* 102409 */
	"ME_WAIT_ON_AVAIL_BUFFER\0" /* 102431 */
	"GFX_CNTX_NOT_AVAIL_TO_ME\0" /* 102455 */
	"ME_RCIU_NOT_RDY_TO_RCV\0" /* 102480 */
	"ME_TO_CONST_NOT_RDY_TO_RCV\0" /* 102503 */
	"ME_WAITING_DATA_FROM_PFP\0" /* 102530 */
	"ME_WAITING_ON_PARTIAL_FLUSH\0" /* 102555 */
	"MEQ_TO_ME_NOT_RDY_TO_RCV\0" /* 102583 */
	"STQ_TO_ME_NOT_RDY_TO_RCV\0" /* 102608 */
	"ME_WAITING_DATA_FROM_STQ\0" /* 102633 */
	"PFP_STALLED_ON_TC_WR_CONFIRM\0" /* 102658 */
	"PFP_STALLED_ON_ATOMIC_RTN_DATA\0" /* 102687 */
	"EOPD_FIFO_NEEDS_SC_EOP_DONE\0" /* 102718 */
	"EOPD_FIFO_NEEDS_WR_CONFIRM\0" /* 102746 */
	"STRMO_WR_OF_PRIM_DATA_PENDING\0" /* 102773 */
	"PIPE_STATS_WR_DATA_PENDING\0" /* 102803 */
	"APPEND_RDY_WAIT_ON_CS_DONE\0" /* 102830 */
	"APPEND_RDY_WAIT_ON_PS_DONE\0" /* 102857 */
	"APPEND_WAIT_ON_WR_CONFIRM\0" /* 102884 */
	"APPEND_ACTIVE_PARTITION\0" /* 102910 */
	"APPEND_WAITING_TO_SEND_MEMWRITE\0" /* 102934 */
	"SURF_SYNC_NEEDS_IDLE_CNTXS\0" /* 102966 */
	"SURF_SYNC_NEEDS_ALL_CLEAN\0" /* 102993 */
	"COHER_CNT_NEQ_ZERO\0" /* 103019 */
	"PFP_PARSING_PACKETS\0" /* 103038 */
	"ME_PARSING_PACKETS\0" /* 103058 */
	"RCIU_PFP_BUSY\0" /* 103077, 103082 */
	"RCIU_ME_BUSY\0" /* 103091, 103096 */
	"SEM_CMDFIFO_NOT_EMPTY\0" /* 103104 */
	"SEM_FAILED_AND_HOLDING\0" /* 103126 */
	"SEM_POLLING_FOR_PASS\0" /* 103149 */
	"GFX_CONTEXT_BUSY\0" /* 103170 */
	"ME_PARSER_BUSY\0" /* 103187 */
	"EOP_DONE_BUSY\0" /* 103202 */
	"STRM_OUT_BUSY\0" /* 103216 */
	"PIPE_STATS_BUSY\0" /* 103230 */
	"RCIU_CE_BUSY\0" /* 103246, 103251 */
	"CE_PARSING_PACKETS\0" /* 103259 */
	"MIU_RDREQ_BUSY\0" /* 103278 */
	"MIU_WRREQ_BUSY\0" /* 103293 */
	"DC_BUSY\0" /* 103308 */
	"MEQ_BUSY\0" /* 103316 */
	"QUERY_BUSY\0" /* 103325 */
	"SURFACE_SYNC_BUSY\0" /* 103336 */
	"CPC_CPG_BUSY\0" /* 103354 */
	"FREE_COUNT_GDS\0" /* 103367 */
	"FREE_COUNT_PFP\0" /* 103382 */
	"BUFFER_SLOTS_ALLOCATED\0" /* 103397 */
	"BUFFER_REQUEST_COUNT\0" /* 103420 */
	"FETCH_BUFFER_DEPTH\0" /* 103441 */
	"CE_INVALIDATE_ICACHE\0" /* 103460 */
	"PFP_INVALIDATE_ICACHE\0" /* 103481 */
	"ME_INVALIDATE_ICACHE\0" /* 103503 */
	"CE_HALT\0" /* 103524 */
	"CE_STEP\0" /* 103532 */
	"PFP_HALT\0" /* 103540 */
	"PFP_STEP\0" /* 103549 */
	"ME_HALT\0" /* 103558 */
	"ME_STEP\0" /* 103566 */
	"ACTIVE_HP3D_CONTEXTS\0" /* 103574 */
	"CURRENT_HP3D_CONTEXT\0" /* 103595 */
	"ACTIVE_GFX_CONTEXTS\0" /* 103616 */
	"CURRENT_GFX_CONTEXT\0" /* 103636 */
	"ME_CNTXSW_PREEMPTION\0" /* 103656 */
	"RB_RPTR\0" /* 103677 */
	"PRE_WRITE_TIMER\0" /* 103685 */
	"PRE_WRITE_LIMIT\0" /* 103701 */
	"POLL_FREQUENCY\0" /* 103717 */
	"IDLE_POLL_COUNT\0" /* 103732 */
	"RB1_START\0" /* 103748 */
	"RB2_START\0" /* 103758 */
	"R0_IB1_START\0" /* 103768 */
	"R1_IB1_START\0" /* 103781 */
	"R2_IB1_START\0" /* 103794 */
	"R0_IB2_START\0" /* 103807 */
	"R1_IB2_START\0" /* 103820 */
	"R2_IB2_START\0" /* 103833 */
	"STQ0_START\0" /* 103846 */
	"STQ1_START\0" /* 103857 */
	"STQ2_START\0" /* 103868 */
	"ROQ_IB1_START\0" /* 103879 */
	"ROQ_IB2_START\0" /* 103893 */
	"MEQ1_START\0" /* 103907 */
	"MEQ2_START\0" /* 103918 */
	"ROQ_CNT_RING\0" /* 103929 */
	"ROQ_CNT_IB1\0" /* 103942 */
	"STQ_CNT\0" /* 103954 */
	"ROQ_CNT_IB2\0" /* 103962 */
	"MEQ_CNT\0" /* 103974 */
	"CMD_ME_SEL\0" /* 103982 */
	"CMD_QUEUE_SEL\0" /* 103993 */
	"ROQ_RPTR_PRIMARY\0" /* 104007 */
	"ROQ_WPTR_PRIMARY\0" /* 104024 */
	"ROQ_RPTR_INDIRECT1\0" /* 104041 */
	"ROQ_WPTR_INDIRECT1\0" /* 104060 */
	"ROQ_RPTR_INDIRECT2\0" /* 104079 */
	"ROQ_WPTR_INDIRECT2\0" /* 104098 */
	"STQ_RPTR\0" /* 104117 */
	"MEQ_RPTR\0" /* 104126 */
	"MEQ_WPTR\0" /* 104135 */
	"CEQ_CNT_RING\0" /* 104144 */
	"CEQ_CNT_IB1\0" /* 104157 */
	"CEQ_CNT_IB2\0" /* 104169 */
	"CEQ_RPTR_PRIMARY\0" /* 104181 */
	"CEQ_WPTR_PRIMARY\0" /* 104198 */
	"CEQ_RPTR_INDIRECT1\0" /* 104215 */
	"CEQ_WPTR_INDIRECT1\0" /* 104234 */
	"CEQ_RPTR_INDIRECT2\0" /* 104253 */
	"CEQ_WPTR_INDIRECT2\0" /* 104272 */
	"CP_ECC_ERROR_INT_ASSERTED\0" /* 104291 */
	"WRM_POLL_TIMEOUT_INT_ASSERTED\0" /* 104317 */
	"CNTX_BUSY_INT_ASSERTED\0" /* 104347 */
	"CNTX_EMPTY_INT_ASSERTED\0" /* 104370 */
	"PRIV_INSTR_INT_ASSERTED\0" /* 104394 */
	"PRIV_REG_INT_ASSERTED\0" /* 104418 */
	"OPCODE_ERROR_INT_ASSERTED\0" /* 104440 */
	"TIME_STAMP_INT_ASSERTED\0" /* 104466 */
	"RESERVED_BIT_ERROR_INT_ASSERTED\0" /* 104490 */
	"GENERIC2_INT_ASSERTED\0" /* 104522 */
	"GENERIC1_INT_ASSERTED\0" /* 104544 */
	"GENERIC0_INT_ASSERTED\0" /* 104566 */
	"PRIM_COUNT\0" /* 104588 */
	"DST_STATE_ID\0" /* 104599 */
	"VS_NO_EXTRA_BUFFER\0" /* 104612 */
	"AUTO_INVLD_EN\0" /* 104631 */
	"USE_GS_DONE\0" /* 104645 */
	"DIS_RANGE_FULL_INVLD\0" /* 104657 */
	"GS_LATE_ALLOC_EN\0" /* 104678 */
	"STREAMOUT_FULL_FLUSH\0" /* 104695 */
	"ES_LIMIT\0" /* 104716 */
	"VS_DEALLOC_TBL_DEPTH\0" /* 104725 */
	"CLIPP_FIFO_DEPTH\0" /* 104746 */
	"VERT_REUSE\0" /* 104763 */
	"MC_TIME_STAMP_RES\0" /* 104774 */
	"IA_DMA_BUSY\0" /* 104792 */
	"IA_DMA_REQ_BUSY\0" /* 104804 */
	"IA_GRP_BUSY\0" /* 104820 */
	"IA_ADC_BUSY\0" /* 104832 */
	"VGT_DEBUG_INDX\0" /* 104844 */
	"VGT_DEBUG_SEL_BUS_B\0" /* 104859 */
	"IA_DEBUG_INDX\0" /* 104879 */
	"IA_DEBUG_SEL_BUS_B\0" /* 104893 */
	"VGT_OUT_INDX_BUSY\0" /* 104912 */
	"VGT_OUT_BUSY\0" /* 104930 */
	"VGT_PT_BUSY\0" /* 104943 */
	"VGT_TE_BUSY\0" /* 104955 */
	"VGT_VR_BUSY\0" /* 104967 */
	"VGT_PI_BUSY\0" /* 104979 */
	"VGT_GS_BUSY\0" /* 104991 */
	"VGT_HS_BUSY\0" /* 105003 */
	"VGT_TE11_BUSY\0" /* 105015 */
	"PERF_SEID_IGNORE_MASK\0" /* 105029 */
	"DI_PT_UNUSED_0\0" /* 105051 */
	"DI_PT_2D_COPY_RECT_LIST_V0\0" /* 105066 */
	"DI_PT_2D_COPY_RECT_LIST_V1\0" /* 105093 */
	"DI_PT_2D_COPY_RECT_LIST_V2\0" /* 105120 */
	"DI_PT_2D_COPY_RECT_LIST_V3\0" /* 105147 */
	"DI_PT_2D_FILL_RECT_LIST\0" /* 105174 */
	"DI_PT_2D_LINE_STRIP\0" /* 105198 */
	"DI_PT_2D_TRI_STRIP\0" /* 105218 */
	"ON_DELAY\0" /* 105237 */
	"OFF_HYSTERESIS\0" /* 105246 */
	"SOFT_OVERRIDE7\0" /* 105261 */
	"PERF_ENABLE\0" /* 105276 */
	"DBG_ENABLE\0" /* 105288 */
	"SOFT_OVERRIDE4\0" /* 105299 */
	"SOFT_OVERRIDE3\0" /* 105314 */
	"GS_OVERRIDE\0" /* 105329 */
	"CORE_OVERRIDE\0" /* 105341 */
	"REG_OVERRIDE\0" /* 105355 */
	"SOFT_OVERRIDE2\0" /* 105368 */
	"DUAL_CORE_EN\0" /* 105383 */
	"MAX_LS_HS_THDGRP\0" /* 105396 */
	"ADC_EVENT_FILTER_DISABLE\0" /* 105413 */
	"DPFP_RATE\0" /* 105438 */
	"SQC_BALANCE_DISABLE\0" /* 105448 */
	"HALF_LDS\0" /* 105468 */
	"INACTIVE_CUS\0" /* 105477 */
	"SU_DEBUG_INDX\0" /* 105490 */
	"CL_BUSY\0" /* 105504 */
	"CLIP_VTX_REORDER_ENA\0" /* 105512 */
	"NUM_CLIP_SEQ\0" /* 105533 */
	"CLIPPED_PRIM_SEQ_STALL\0" /* 105546 */
	"VE_NAN_PROC_DISABLE\0" /* 105569 */
	"XTRA_DEBUG_REG_SEL\0" /* 105589 */
	"ECO_SPARE3\0" /* 105608 */
	"ECO_SPARE2\0" /* 105619 */
	"ECO_SPARE1\0" /* 105630 */
	"ECO_SPARE0\0" /* 105641 */
	"SOFT_OVERRIDE6\0" /* 105652 */
	"SOFT_OVERRIDE5\0" /* 105667 */
	"SU_CLK_OVERRIDE\0" /* 105682 */
	"CL_CLK_OVERRIDE\0" /* 105698 */
	"REG_CLK_OVERRIDE\0" /* 105714 */
	"SU_BUSY\0" /* 105731 */
	"FORCE_EOV_MAX_CLK_CNT\0" /* 105739 */
	"FORCE_EOV_MAX_REZ_CNT\0" /* 105761 */
	"SOFT_OVERRIDE1\0" /* 105783 */
	"SOFT_OVERRIDE0\0" /* 105798 */
	"SC_FRONTEND_PRIM_FIFO_SIZE\0" /* 105813 */
	"SC_BACKEND_PRIM_FIFO_SIZE\0" /* 105840 */
	"SC_HIZ_TILE_FIFO_SIZE\0" /* 105866 */
	"SC_EARLYZ_TILE_FIFO_SIZE\0" /* 105888 */
	"SC_DB_TILE_IF_FIFO_SIZE\0" /* 105913 */
	"SC_DB_QUAD_IF_FIFO_SIZE\0" /* 105937 */
	"SC_SPI_IF_FIFO_SIZE\0" /* 105961 */
	"SC_BCI_IF_FIFO_SIZE\0" /* 105981 */
	"SC_DEBUG_INDX\0" /* 106001 */
	"ENABLE_PA_SC_OUT_OF_ORDER\0" /* 106015 */
	"DISABLE_SC_DB_TILE_FIX\0" /* 106041 */
	"DISABLE_AA_MASK_FULL_FIX\0" /* 106064 */
	"ENABLE_1XMSAA_SAMPLE_LOCATIONS\0" /* 106089 */
	"ENABLE_1XMSAA_SAMPLE_LOC_CENTROID\0" /* 106120 */
	"DISABLE_SCISSOR_FIX\0" /* 106154 */
	"DISABLE_PW_BUBBLE_COLLAPSE\0" /* 106174 */
	"SEND_UNLIT_STILES_TO_PACKER\0" /* 106201 */
	"DISABLE_DUALGRAD_PERF_OPTIMIZATION\0" /* 106229 */
	"DISABLE_SC_PROCESS_RESET_PRIM\0" /* 106264 */
	"DISABLE_SC_PROCESS_RESET_SUPERTILE\0" /* 106294 */
	"DISABLE_SC_PROCESS_RESET_TILE\0" /* 106329 */
	"DISABLE_PA_SC_GUIDANCE\0" /* 106359 */
	"DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS\0" /* 106382 */
	"ENABLE_MULTICYCLE_BUBBLE_FREEZE\0" /* 106421 */
	"DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE\0" /* 106453 */
	"ENABLE_OUT_OF_ORDER_POLY_MODE\0" /* 106489 */
	"DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST\0" /* 106519 */
	"DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING\0" /* 106565 */
	"ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY\0" /* 106606 */
	"DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING\0" /* 106656 */
	"DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING\0" /* 106706 */
	"DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS\0" /* 106757 */
	"ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID\0" /* 106805 */
	"DISABLE_SCA_BYPASS\0" /* 106851 */
	"DISABLE_IB_DEP_CHECK\0" /* 106870 */
	"ENABLE_SOFT_CLAUSE\0" /* 106891 */
	"EARLY_TA_DONE_DISABLE\0" /* 106910 */
	"DUA_FLAT_LOCK_ENABLE\0" /* 106932 */
	"DUA_LDS_BYPASS_DISABLE\0" /* 106953 */
	"DUA_FLAT_LDS_PINGPONG_DISABLE\0" /* 106976 */
	"INST_CACHE_SIZE\0" /* 107006 */
	"DATA_CACHE_SIZE\0" /* 107022 */
	"MISS_FIFO_DEPTH\0" /* 107038 */
	"HIT_FIFO_DEPTH\0" /* 107054 */
	"FORCE_ALWAYS_MISS\0" /* 107069 */
	"FORCE_IN_ORDER\0" /* 107087 */
	"IDENTITY_HASH_BANK\0" /* 107102 */
	"IDENTITY_HASH_SET\0" /* 107121 */
	"PER_VMID_INV_DISABLE\0" /* 107139 */
	"INST_INVALIDATE\0" /* 107160 */
	"DATA_INVALIDATE\0" /* 107176 */
	"INVALIDATE_VOLATILE\0" /* 107192 */
	"RET\0" /* 107212 */
	"RUI\0" /* 107216 */
	"RNG\0" /* 107220 */
	"SRBM_CREDITS\0" /* 107224 */
	"CMD_CREDITS\0" /* 107237 */
	"REG_BUSY\0" /* 107249 */
	"SRBM_OVERFLOW\0" /* 107258 */
	"INTERRUPT_FIFO_SIZE\0" /* 107272 */
	"TTRACE_FIFO_SIZE\0" /* 107292 */
	"EXPORT_BUF_SIZE\0" /* 107309 */
	"VMEM_DATA_FIFO_SIZE\0" /* 107325 */
	"SQC0_BANK_DISABLE\0" /* 107345 */
	"SQC1_BANK_DISABLE\0" /* 107363 */
	"SQC2_BANK_DISABLE\0" /* 107381 */
	"SQC3_BANK_DISABLE\0" /* 107399 */
	"INTERRUPT_MSG_BUSY\0" /* 107417 */
	"WAVE_LEVEL_SH0\0" /* 107436 */
	"WAVE_LEVEL_SH1\0" /* 107451 */
	"SQC_CLIENT_MASK\0" /* 107466 */
	"SIMD_MASK\0" /* 107482 */
	"FORCE_CU_ON_SH0\0" /* 107492 */
	"FORCE_CU_ON_SH1\0" /* 107508 */
	"THREAD_ID\0" /* 107524 */
	"AUTO_INCR\0" /* 107534 */
	"FORCE_READ\0" /* 107544 */
	"UNINDEXED\0" /* 107555 */
	"TIME\0" /* 107565 */
	"CU_SEL\0" /* 107570 */
	"SH_SEL\0" /* 107577 */
	"VM_ID_MASK\0" /* 107584 */
	"RANDOM_SEED\0" /* 107595 */
	"REG_MASK\0" /* 107607 */
	"SH0_MASK\0" /* 107616 */
	"SH1_MASK\0" /* 107625 */
	"READ_OFFSET\0" /* 107634 */
	"NEW_BUF\0" /* 107646 */
	"MASK_PS\0" /* 107654 */
	"MASK_VS\0" /* 107662 */
	"MASK_GS\0" /* 107670 */
	"MASK_ES\0" /* 107678 */
	"MASK_HS\0" /* 107686 */
	"MASK_LS\0" /* 107694 */
	"MASK_CS\0" /* 107702 */
	"CAPTURE_MODE\0" /* 107710 */
	"AUTOFLUSH_EN\0" /* 107723 */
	"ISSUE_MASK\0" /* 107736 */
	"TEST_MODE\0" /* 107747 */
	"RESET_BUFFER\0" /* 107757 */
	"MIN_POWER\0" /* 107770 */
	"MAX_POWER\0" /* 107780 */
	"PHASE_OFFSET\0" /* 107790 */
	"MAX_POWER_DELTA\0" /* 107803 */
	"SHORT_TERM_INTERVAL_SIZE\0" /* 107819 */
	"LONG_TERM_INTERVAL_RATIO\0" /* 107844 */
	"USE_REF_CLOCK\0" /* 107869 */
	"INST_SEC\0" /* 107883 */
	"INST_DED\0" /* 107892 */
	"DATA_SEC\0" /* 107901 */
	"DATA_DED\0" /* 107910 */
	"LDS_SEC\0" /* 107919 */
	"SGPR_SEC\0" /* 107927 */
	"VGPR_SEC\0" /* 107936 */
	"LDS_DED\0" /* 107945 */
	"SGPR_DED\0" /* 107953 */
	"VGPR_DED\0" /* 107962 */
	"SQ_SEL_0\0" /* 107971 */
	"SQ_SEL_1\0" /* 107980 */
	"SQ_SEL_RESERVED_0\0" /* 107989 */
	"SQ_SEL_RESERVED_1\0" /* 108007 */
	"SQ_SEL_X\0" /* 108025 */
	"SQ_SEL_Y\0" /* 108034 */
	"SQ_SEL_Z\0" /* 108043 */
	"SQ_SEL_W\0" /* 108052 */
	"BUF_NUM_FORMAT_UNORM\0" /* 108061 */
	"BUF_NUM_FORMAT_SNORM\0" /* 108082 */
	"BUF_NUM_FORMAT_USCALED\0" /* 108103 */
	"BUF_NUM_FORMAT_SSCALED\0" /* 108126 */
	"BUF_NUM_FORMAT_UINT\0" /* 108149 */
	"BUF_NUM_FORMAT_SINT\0" /* 108169 */
	"BUF_NUM_FORMAT_SNORM_OGL\0" /* 108189 */
	"BUF_NUM_FORMAT_FLOAT\0" /* 108214 */
	"NUM_FORMAT\0" /* 108235 */
	"BUF_DATA_FORMAT_INVALID\0" /* 108246 */
	"BUF_DATA_FORMAT_8\0" /* 108270 */
	"BUF_DATA_FORMAT_16\0" /* 108288 */
	"BUF_DATA_FORMAT_8_8\0" /* 108307 */
	"BUF_DATA_FORMAT_32\0" /* 108327 */
	"BUF_DATA_FORMAT_16_16\0" /* 108346 */
	"BUF_DATA_FORMAT_10_11_11\0" /* 108368 */
	"BUF_DATA_FORMAT_11_11_10\0" /* 108393 */
	"BUF_DATA_FORMAT_10_10_10_2\0" /* 108418 */
	"BUF_DATA_FORMAT_2_10_10_10\0" /* 108445 */
	"BUF_DATA_FORMAT_8_8_8_8\0" /* 108472 */
	"BUF_DATA_FORMAT_32_32\0" /* 108496 */
	"BUF_DATA_FORMAT_16_16_16_16\0" /* 108518 */
	"BUF_DATA_FORMAT_32_32_32\0" /* 108546 */
	"BUF_DATA_FORMAT_32_32_32_32\0" /* 108571 */
	"BUF_DATA_FORMAT_RESERVED_15\0" /* 108599 */
	"DATA_FORMAT\0" /* 108627 */
	"ELEMENT_SIZE\0" /* 108639 */
	"HASH_ENABLE\0" /* 108652 */
	"HEAP\0" /* 108664 */
	"SQ_RSRC_BUF\0" /* 108669 */
	"SQ_RSRC_BUF_RSVD_1\0" /* 108681 */
	"SQ_RSRC_BUF_RSVD_2\0" /* 108700 */
	"SQ_RSRC_BUF_RSVD_3\0" /* 108719 */
	"IMG_DATA_FORMAT_INVALID\0" /* 108738 */
	"IMG_DATA_FORMAT_8\0" /* 108762 */
	"IMG_DATA_FORMAT_16\0" /* 108780 */
	"IMG_DATA_FORMAT_8_8\0" /* 108799 */
	"IMG_DATA_FORMAT_32\0" /* 108819 */
	"IMG_DATA_FORMAT_16_16\0" /* 108838 */
	"IMG_DATA_FORMAT_10_11_11\0" /* 108860 */
	"IMG_DATA_FORMAT_11_11_10\0" /* 108885 */
	"IMG_DATA_FORMAT_10_10_10_2\0" /* 108910 */
	"IMG_DATA_FORMAT_2_10_10_10\0" /* 108937 */
	"IMG_DATA_FORMAT_8_8_8_8\0" /* 108964 */
	"IMG_DATA_FORMAT_32_32\0" /* 108988 */
	"IMG_DATA_FORMAT_16_16_16_16\0" /* 109010 */
	"IMG_DATA_FORMAT_32_32_32\0" /* 109038 */
	"IMG_DATA_FORMAT_32_32_32_32\0" /* 109063 */
	"IMG_DATA_FORMAT_RESERVED_15\0" /* 109091 */
	"IMG_DATA_FORMAT_5_6_5\0" /* 109119 */
	"IMG_DATA_FORMAT_1_5_5_5\0" /* 109141 */
	"IMG_DATA_FORMAT_5_5_5_1\0" /* 109165 */
	"IMG_DATA_FORMAT_4_4_4_4\0" /* 109189 */
	"IMG_DATA_FORMAT_8_24\0" /* 109213 */
	"IMG_DATA_FORMAT_24_8\0" /* 109234 */
	"IMG_DATA_FORMAT_X24_8_32\0" /* 109255 */
	"IMG_DATA_FORMAT_RESERVED_23\0" /* 109280 */
	"IMG_DATA_FORMAT_RESERVED_24\0" /* 109308 */
	"IMG_DATA_FORMAT_RESERVED_25\0" /* 109336 */
	"IMG_DATA_FORMAT_RESERVED_26\0" /* 109364 */
	"IMG_DATA_FORMAT_RESERVED_27\0" /* 109392 */
	"IMG_DATA_FORMAT_RESERVED_28\0" /* 109420 */
	"IMG_DATA_FORMAT_RESERVED_29\0" /* 109448 */
	"IMG_DATA_FORMAT_RESERVED_30\0" /* 109476 */
	"IMG_DATA_FORMAT_RESERVED_31\0" /* 109504 */
	"IMG_DATA_FORMAT_GB_GR\0" /* 109532 */
	"IMG_DATA_FORMAT_BG_RG\0" /* 109554 */
	"IMG_DATA_FORMAT_5_9_9_9\0" /* 109576 */
	"IMG_DATA_FORMAT_BC1\0" /* 109600 */
	"IMG_DATA_FORMAT_BC2\0" /* 109620 */
	"IMG_DATA_FORMAT_BC3\0" /* 109640 */
	"IMG_DATA_FORMAT_BC4\0" /* 109660 */
	"IMG_DATA_FORMAT_BC5\0" /* 109680 */
	"IMG_DATA_FORMAT_BC6\0" /* 109700 */
	"IMG_DATA_FORMAT_BC7\0" /* 109720 */
	"IMG_DATA_FORMAT_RESERVED_42\0" /* 109740 */
	"IMG_DATA_FORMAT_RESERVED_43\0" /* 109768 */
	"IMG_DATA_FORMAT_FMASK8_S2_F1\0" /* 109796 */
	"IMG_DATA_FORMAT_FMASK8_S4_F1\0" /* 109825 */
	"IMG_DATA_FORMAT_FMASK8_S8_F1\0" /* 109854 */
	"IMG_DATA_FORMAT_FMASK8_S2_F2\0" /* 109883 */
	"IMG_DATA_FORMAT_FMASK8_S4_F2\0" /* 109912 */
	"IMG_DATA_FORMAT_FMASK8_S4_F4\0" /* 109941 */
	"IMG_DATA_FORMAT_FMASK16_S16_F1\0" /* 109970 */
	"IMG_DATA_FORMAT_FMASK16_S8_F2\0" /* 110001 */
	"IMG_DATA_FORMAT_FMASK32_S16_F2\0" /* 110031 */
	"IMG_DATA_FORMAT_FMASK32_S8_F4\0" /* 110062 */
	"IMG_DATA_FORMAT_FMASK32_S8_F8\0" /* 110092 */
	"IMG_DATA_FORMAT_FMASK64_S16_F4\0" /* 110122 */
	"IMG_DATA_FORMAT_FMASK64_S16_F8\0" /* 110153 */
	"IMG_DATA_FORMAT_4_4\0" /* 110184 */
	"IMG_DATA_FORMAT_6_5_5\0" /* 110204 */
	"IMG_DATA_FORMAT_1\0" /* 110226 */
	"IMG_DATA_FORMAT_1_REVERSED\0" /* 110244 */
	"IMG_DATA_FORMAT_32_AS_8\0" /* 110271 */
	"IMG_DATA_FORMAT_32_AS_8_8\0" /* 110295 */
	"IMG_DATA_FORMAT_32_AS_32_32_32_32\0" /* 110321 */
	"IMG_NUM_FORMAT_UNORM\0" /* 110355 */
	"IMG_NUM_FORMAT_SNORM\0" /* 110376 */
	"IMG_NUM_FORMAT_USCALED\0" /* 110397 */
	"IMG_NUM_FORMAT_SSCALED\0" /* 110420 */
	"IMG_NUM_FORMAT_UINT\0" /* 110443 */
	"IMG_NUM_FORMAT_SINT\0" /* 110463 */
	"IMG_NUM_FORMAT_SNORM_OGL\0" /* 110483 */
	"IMG_NUM_FORMAT_FLOAT\0" /* 110508 */
	"IMG_NUM_FORMAT_RESERVED_8\0" /* 110529 */
	"IMG_NUM_FORMAT_SRGB\0" /* 110555 */
	"IMG_NUM_FORMAT_UBNORM\0" /* 110575 */
	"IMG_NUM_FORMAT_UBNORM_OGL\0" /* 110597 */
	"IMG_NUM_FORMAT_UBINT\0" /* 110623 */
	"IMG_NUM_FORMAT_UBSCALED\0" /* 110644 */
	"IMG_NUM_FORMAT_RESERVED_14\0" /* 110668 */
	"IMG_NUM_FORMAT_RESERVED_15\0" /* 110695 */
	"INTERLACED\0" /* 110722 */
	"TILING_INDEX\0" /* 110733 */
	"POW2_PAD\0" /* 110746 */
	"SQ_RSRC_IMG_RSVD_0\0" /* 110755 */
	"SQ_RSRC_IMG_RSVD_1\0" /* 110774 */
	"SQ_RSRC_IMG_RSVD_2\0" /* 110793 */
	"SQ_RSRC_IMG_RSVD_3\0" /* 110812 */
	"SQ_RSRC_IMG_RSVD_4\0" /* 110831 */
	"SQ_RSRC_IMG_RSVD_5\0" /* 110850 */
	"SQ_RSRC_IMG_RSVD_6\0" /* 110869 */
	"SQ_RSRC_IMG_RSVD_7\0" /* 110888 */
	"SQ_RSRC_IMG_1D\0" /* 110907 */
	"SQ_RSRC_IMG_2D\0" /* 110922 */
	"SQ_RSRC_IMG_3D\0" /* 110937 */
	"SQ_RSRC_IMG_CUBE\0" /* 110952 */
	"SQ_RSRC_IMG_1D_ARRAY\0" /* 110969 */
	"SQ_RSRC_IMG_2D_ARRAY\0" /* 110990 */
	"SQ_RSRC_IMG_2D_MSAA\0" /* 111011 */
	"SQ_RSRC_IMG_2D_MSAA_ARRAY\0" /* 111031 */
	"LAST_ARRAY\0" /* 111057 */
	"UNUNSED\0" /* 111068 */
	"SQ_TEX_WRAP\0" /* 111076 */
	"SQ_TEX_MIRROR\0" /* 111088 */
	"SQ_TEX_CLAMP_LAST_TEXEL\0" /* 111102 */
	"SQ_TEX_MIRROR_ONCE_LAST_TEXEL\0" /* 111126 */
	"SQ_TEX_CLAMP_HALF_BORDER\0" /* 111156 */
	"SQ_TEX_MIRROR_ONCE_HALF_BORDER\0" /* 111181 */
	"SQ_TEX_CLAMP_BORDER\0" /* 111212 */
	"SQ_TEX_MIRROR_ONCE_BORDER\0" /* 111232 */
	"SQ_TEX_DEPTH_COMPARE_NEVER\0" /* 111258 */
	"SQ_TEX_DEPTH_COMPARE_LESS\0" /* 111285 */
	"SQ_TEX_DEPTH_COMPARE_EQUAL\0" /* 111311 */
	"SQ_TEX_DEPTH_COMPARE_LESSEQUAL\0" /* 111338 */
	"SQ_TEX_DEPTH_COMPARE_GREATER\0" /* 111369 */
	"SQ_TEX_DEPTH_COMPARE_NOTEQUAL\0" /* 111398 */
	"SQ_TEX_DEPTH_COMPARE_GREATEREQUAL\0" /* 111428 */
	"SQ_TEX_DEPTH_COMPARE_ALWAYS\0" /* 111462 */
	"SQ_IMG_FILTER_MODE_BLEND\0" /* 111490 */
	"SQ_IMG_FILTER_MODE_MIN\0" /* 111515 */
	"SQ_IMG_FILTER_MODE_MAX\0" /* 111538 */
	"SQ_TEX_XY_FILTER_POINT\0" /* 111561 */
	"SQ_TEX_XY_FILTER_BILINEAR\0" /* 111584 */
	"SQ_TEX_XY_FILTER_ANISO_POINT\0" /* 111610 */
	"SQ_TEX_XY_FILTER_ANISO_BILINEAR\0" /* 111639 */
	"SQ_TEX_Z_FILTER_NONE\0" /* 111671 */
	"SQ_TEX_Z_FILTER_POINT\0" /* 111692 */
	"SQ_TEX_Z_FILTER_LINEAR\0" /* 111714 */
	"SQ_TEX_MIP_FILTER_NONE\0" /* 111737 */
	"SQ_TEX_MIP_FILTER_POINT\0" /* 111760 */
	"SQ_TEX_MIP_FILTER_LINEAR\0" /* 111784 */
	"DISABLE_LSB_CEIL\0" /* 111809 */
	"FILTER_PREC_FIX\0" /* 111826 */
	"UPGRADED_DEPTH\0" /* 111842 */
	"SQ_TEX_BORDER_COLOR_TRANS_BLACK\0" /* 111857 */
	"SQ_TEX_BORDER_COLOR_OPAQUE_BLACK\0" /* 111889 */
	"SQ_TEX_BORDER_COLOR_OPAQUE_WHITE\0" /* 111922 */
	"SQ_TEX_BORDER_COLOR_REGISTER\0" /* 111955 */
	"BANK_INTERLEAVE_SIZE\0" /* 111984 */
	"SHADER_ENGINE_TILE_SIZE\0" /* 112005 */
	"NUM_GPUS\0" /* 112029 */
	"MULTI_GPU_TILE_SIZE\0" /* 112038 */
	"ROW_SIZE\0" /* 112058 */
	"NUM_LOWER_PIPES\0" /* 112067 */
	"ADDR_SURF_THICK_MICRO_TILING_GFX6\0" /* 112083 */
	"MICRO_TILE_MODE\0" /* 112117 */
	"DEBUG_MODE\0" /* 112133 */
	"CACHE_CTL\0" /* 112144 */
	"CDBG_USER\0" /* 112154 */
	"DISPATCH_CACHE_CNTL\0" /* 112164 */
	"WAVES_PER_SH_GFX6\0" /* 112184 */
	"SH0_CU_EN\0" /* 112202 */
	"SH1_CU_EN\0" /* 112212 */
	"REG_IDLE\0" /* 112222 */
	"RB_EMPTY\0" /* 112231 */
	"RB_FULL\0" /* 112240 */
	"RB_CMD_IDLE\0" /* 112248 */
	"RB_CMD_FULL\0" /* 112260 */
	"IB_CMD_IDLE\0" /* 112272 */
	"IB_CMD_FULL\0" /* 112284 */
	"BLOCK_IDLE\0" /* 112296 */
	"INSIDE_IB\0" /* 112307 */
	"EX_IDLE\0" /* 112317 */
	"EX_IDLE_POLL_TIMER_EXPIRE\0" /* 112325 */
	"PACKET_READY\0" /* 112351 */
	"MC_WR_IDLE\0" /* 112364 */
	"SRBM_IDLE\0" /* 112375 */
	"CONTEXT_EMPTY\0" /* 112385 */
	"DELTA_RPTR_FULL\0" /* 112399 */
	"RB_MC_RREQ_IDLE\0" /* 112415 */
	"IB_MC_RREQ_IDLE\0" /* 112431 */
	"MC_RD_IDLE\0" /* 112447 */
	"DELTA_RPTR_EMPTY\0" /* 112458 */
	"MC_RD_RET_STALL\0" /* 112475 */
	"MC_RD_NO_POLL_IDLE\0" /* 112491 */
	"PREV_CMD_IDLE\0" /* 112510 */
	"SEM_IDLE\0" /* 112524 */
	"SEM_REQ_STALL\0" /* 112533 */
	"SEM_RESP_STATE\0" /* 112547 */
	"INT_IDLE\0" /* 112562 */
	"INT_REQ_STALL\0" /* 112571 */
	"ADDR5_SWIZZLE_MASK\0" /* 112585 */
	"PITCH_TILE_MAX\0" /* 112604 */
	"HEIGHT_TILE_MAX\0" /* 112619 */
	"SLICE_TILE_MAX\0" /* 112635 */
	"VGT_POLICY_RESERVED\0" /* 112650 */
	"Reserved_0x09\0" /* 112670 */
	"Reserved_0x0E\0" /* 112684 */
	"FLUSH_LS_OUTPUT\0" /* 112698 */
	"Reserved_0x13\0" /* 112714 */
	"FLUSH_GS_OUTPUT\0" /* 112728 */
	"Reserved_0x25\0" /* 112744 */
	"THREAD_TRACE_FLUSH\0" /* 112758 */
	"HTILE_USES_PRELOAD_WIN\0" /* 112777 */
	"PRELOAD\0" /* 112800 */
	"PREFETCH_WIDTH\0" /* 112808 */
	"PREFETCH_HEIGHT\0" /* 112823 */
	"8_IN_16\0" /* 112839 */
	"8_IN_32\0" /* 112847 */
	"8_IN_64\0" /* 112855 */
	"MIU_RDREQ_FREE_STALL\0" /* 112863 */
	"MIU_WRREQ_FREE_STALL\0" /* 112884 */
	"MEC1_WAIT_ON_MC_READ\0" /* 112905 */
	"MEC1_WAIT_ON_MC_WR_ACK\0" /* 112926 */
	"MEC2_WAIT_ON_MC_READ\0" /* 112949 */
	"MEC2_WAIT_ON_MC_WR_ACK\0" /* 112970 */
	"OUTSTANDING_READ_TAGS\0" /* 112993 */
	"INST_MASK\0" /* 113015 */
	"SRC_ATC\0" /* 113025 */
	"SRC_VOLATILE\0" /* 113033 */
	"DST_ATC\0" /* 113046 */
	"DST_VOLATILE\0" /* 113054 */
	"WBINV_TC_OP\0" /* 113067 */
	"WBINV_ACTION_ENA\0" /* 113079 */
	"GPR_IDX_EN\0" /* 113096 */
	"ALLOW_REPLAY\0" /* 113107 */
	"IXNACK\0" /* 113120 */
	"TCC_CC_RESIDENT\0" /* 113127 */
	"ATCL2IU_BUSY\0" /* 113143 */
	"ATCL2IU_WAITING_ON_FREE\0" /* 113156 */
	"ATCL2IU_WAITING_ON_TAGS\0" /* 113180 */
	"ATCL1_WAITING_ON_TRANS\0" /* 113204 */
	"BUF_NUM_FORMAT_RESERVED_6\0" /* 113227 */
	"IMG_NUM_FORMAT_RESERVED_6\0" /* 113253 */
	"IMG_NUM_FORMAT_RESERVED_10\0" /* 113279 */
	"IMG_NUM_FORMAT_RESERVED_11\0" /* 113306 */
	"IMG_NUM_FORMAT_RESERVED_12\0" /* 113333 */
	"IMG_NUM_FORMAT_RESERVED_13\0" /* 113360 */
	"LOST_ALPHA_BITS\0" /* 113387 */
	"LOST_COLOR_BITS\0" /* 113403 */
	"META_DATA_ADDRESS\0" /* 113419 */
	"COMPAT_MODE\0" /* 113437 */
	"SQ_TEX_MIP_FILTER_POINT_ANISO_ADJ\0" /* 113449 */
	"CLEAR_DISALLOWED\0" /* 113483 */
	"OVERWRITE_COMBINER_MRT_SHARING_DISABLE\0" /* 113500 */
	"RESERVED_4\0" /* 113539 */
	"RESERVED_5\0" /* 113550 */
	"TC_COMPATIBLE\0" /* 113561 */
	"SRC_MTYPE\0" /* 113575 */
	"DST_MTYPE\0" /* 113585 */
	"TC_SD_ACTION_ENA\0" /* 113595 */
	"SH_SD_ACTION_ENA\0" /* 113612 */
	"IMG_DATA_FORMAT_16_AS_32_32\0" /* 113629 */
	"IMG_DATA_FORMAT_8_AS_8_8_8_8\0" /* 113657 */
	"IMG_DATA_FORMAT_ETC2_RGB\0" /* 113686 */
	"IMG_DATA_FORMAT_ETC2_RGBA\0" /* 113711 */
	"IMG_DATA_FORMAT_ETC2_R\0" /* 113737 */
	"IMG_DATA_FORMAT_ETC2_RG\0" /* 113760 */
	"IMG_DATA_FORMAT_ETC2_RGBA1\0" /* 113784 */
	"IMG_DATA_FORMAT_16_AS_16_16_16_16\0" /* 113811 */
	"IMG_DATA_FORMAT_16_AS_32_32_32_32\0" /* 113845 */
	"IMG_DATA_FORMAT_8_AS_32\0" /* 113879 */
	"IMG_DATA_FORMAT_8_AS_32_32\0" /* 113903 */
	"POPS_PACKER0\0" /* 113930 */
	"POPS_PACKER1\0" /* 113943 */
	"NO_PREFETCH_CNT_HI\0" /* 113956 */
	"BUF_NUM_FORMAT_UNORM_UINT\0" /* 113975 */
	"USER_VM_ENABLE\0" /* 114001 */
	"USER_VM_MODE\0" /* 114016 */
	"IMG_DATA_FORMAT_6E4\0" /* 114029 */
	"IMG_DATA_FORMAT_FMASK\0" /* 114049 */
	"IMG_DATA_FORMAT_ASTC_2D_LDR\0" /* 114071 */
	"IMG_DATA_FORMAT_ASTC_2D_HDR\0" /* 114099 */
	"IMG_DATA_FORMAT_ASTC_2D_LDR_SRGB\0" /* 114127 */
	"IMG_DATA_FORMAT_ASTC_3D_LDR\0" /* 114160 */
	"IMG_DATA_FORMAT_ASTC_3D_HDR\0" /* 114188 */
	"IMG_DATA_FORMAT_ASTC_3D_LDR_SRGB\0" /* 114216 */
	"IMG_DATA_FORMAT_N_IN_16\0" /* 114249 */
	"IMG_DATA_FORMAT_N_IN_16_16\0" /* 114273 */
	"IMG_DATA_FORMAT_N_IN_16_16_16_16\0" /* 114300 */
	"IMG_DATA_FORMAT_N_IN_16_AS_16_16_16_16\0" /* 114333 */
	"IMG_DATA_FORMAT_RESERVED_56\0" /* 114372 */
	"IMG_DATA_FORMAT_RESERVED_59\0" /* 114400 */
	"IMG_DATA_FORMAT_RESERVED_60\0" /* 114428 */
	"IMG_DATA_FORMAT_S8_16\0" /* 114456 */
	"IMG_DATA_FORMAT_S8_32\0" /* 114478 */
	"DATA_FORMAT_STENCIL\0" /* 114500 */
	"IMG_NUM_FORMAT_UNORM_UINT\0" /* 114520 */
	"IMG_NUM_FORMAT_FMASK_8_2_1\0" /* 114546 */
	"IMG_NUM_FORMAT_FMASK_8_4_1\0" /* 114573 */
	"IMG_NUM_FORMAT_FMASK_8_8_1\0" /* 114600 */
	"IMG_NUM_FORMAT_FMASK_8_2_2\0" /* 114627 */
	"IMG_NUM_FORMAT_FMASK_8_4_2\0" /* 114654 */
	"IMG_NUM_FORMAT_FMASK_8_4_4\0" /* 114681 */
	"IMG_NUM_FORMAT_FMASK_16_16_1\0" /* 114708 */
	"IMG_NUM_FORMAT_FMASK_16_8_2\0" /* 114737 */
	"IMG_NUM_FORMAT_FMASK_32_16_2\0" /* 114765 */
	"IMG_NUM_FORMAT_FMASK_32_8_4\0" /* 114794 */
	"IMG_NUM_FORMAT_FMASK_32_8_8\0" /* 114822 */
	"IMG_NUM_FORMAT_FMASK_64_16_4\0" /* 114850 */
	"IMG_NUM_FORMAT_FMASK_64_16_8\0" /* 114879 */
	"IMG_NUM_FORMAT_FMASK_RESERVED_13\0" /* 114908 */
	"IMG_NUM_FORMAT_FMASK_RESERVED_14\0" /* 114941 */
	"IMG_NUM_FORMAT_FMASK_RESERVED_15\0" /* 114974 */
	"NUM_FORMAT_FMASK\0" /* 115007 */
	"META_DIRECT\0" /* 115024 */
	"META_RB_ALIGNED\0" /* 115036, 115041 */
	"SE_ENABLE\0" /* 115052 */
	"SIMD_DISABLE\0" /* 115062 */
	"RASTER_CONFIG_SE_XSEL_128_WIDE_TILE\0" /* 115075 */
	"RASTER_CONFIG_SE_YSEL_128_WIDE_TILE\0" /* 115111 */
	"RASTER_CONFIG_SE_PAIR_XSEL_128_WIDE_TILE\0" /* 115147 */
	"RASTER_CONFIG_SE_PAIR_YSEL_128_WIDE_TILE\0" /* 115188 */
	"EN_32BIT_OBJPRIMID\0" /* 115229 */
	"Available_0x1c\0" /* 115248 */
	"Available_0x1d\0" /* 115263 */
	"Reserved_0x3f\0" /* 115278 */
	"EN_PIPELINE_PRIMID\0" /* 115292 */
	"CU_INDEX\0" /* 115311 */
	"TC_PERF_EN\0" /* 115320 */
	"VTX_DONE_DELAY\0" /* 115331 */
	"INTERP_ONE_PRIM_PER_ROW\0" /* 115346 */
	"BATON_RESET_DISABLE\0" /* 115370 */
	"PC_LIMIT_ENABLE\0" /* 115390 */
	"PC_LIMIT_STRICT\0" /* 115406 */
	"CRC_SIMD_ID_WADDR_DISABLE\0" /* 115422 */
	"LBPW_CU_CHK_MODE\0" /* 115448 */
	"LBPW_CU_CHK_CNT\0" /* 115465 */
	"CSC_PWR_SAVE_DISABLE\0" /* 115481 */
	"CSG_PWR_SAVE_DISABLE\0" /* 115502 */
	"PC_LIMIT_SIZE\0" /* 115523 */
	"CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD\0" /* 115537 */
	"CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD\0" /* 115578 */
	"PS_WAVE_GRAN\0" /* 115617 */
	"VS_WAVE_GRAN\0" /* 115630 */
	"GS_WAVE_GRAN\0" /* 115643 */
	"HS_WAVE_GRAN\0" /* 115656 */
	"CNTR_SEL0\0" /* 115669 */
	"CNTR_SEL1\0" /* 115679 */
	"CNTR_SEL2\0" /* 115689 */
	"CNTR_SEL3\0" /* 115699 */
	"PERFMON_MAX_SAMPLE_DELAY\0" /* 115709 */;

static const int sid_strings_offsets[] = {
	/* 0 */ -1, 55112, 55120, -1, 55135, -1, -1, -1, 55150, -1, -1, -1, -1, -1, -1, -1, 55159, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55169, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55177, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55196, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 55210,
	/* 257 */ -1, 59555, 59578, -1, 59600, -1, -1, -1, 59623, -1, -1, -1, -1, -1, -1, -1, 59645, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59666, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59690, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59708, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59728, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59747, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59769, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59793,
	/* 2306 */ -1, 59826, 59844, -1, 59862, -1, -1, -1, 59882, -1, -1, -1, -1, -1, -1, -1, 59899, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59919, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59938, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59956,
	/* 2435 */ 60285, -1, -1, -1, -1, -1, -1, -1, 60296, 60308, -1, -1, 60320, -1, -1, -1, -1, -1, -1, -1, 60331, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 60343,
	/* 2468 */ 60479, 60498, 60517, 60536, 60557, 60578, 60596, 60614, 60634, 60654, 60676, 60698, 60717, 60736, 60756, 60777, 60798, 60821, 60844, 60864, 60884, 60903, 60922, 60942, 60965, 60988, 61013, 61038, 61060, 61082, 61105, 61131, 61157, 61185, 61213, 61238, 61263, 61289, 61315, 61341, 61369, 61397, 61422, 61447, 61473, 61501, 61529, 61559, 61589, 61616, 61643, 61671, 61699, 61729, 61759, 61786, 61813, 61838, 61863, 61890, 61917, 61941, 61965, 61987, 62009, 62032, 62061, 62090, 62121, 62152, 62180, 62208, 62237, 62262, 62287, 62313, 62341, 62369, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62398, 62416, 62436, 62460, 62481, 62506, 62529, 62554, 62579, 62604, 62625, 62644, 62672, 62698, 62720, 62741, 62763, 62784, 62809, 62835, 62858, 62881, 62903, 62925, 62948, 62971, 62993, -1, 63015, 63039, 63063, 63087, 63111, 63135, 63159, 63185, 63210, 63236, 63261, 63286, 63312, 63338, 63359, 63379, 63400, 63420, 63441, 63461, 63482, 63503, 63524, 63545, 63567, 63589, 63610, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 63630, 63652, 63673, 63697, 63720, 63748, 63775, 63801, 63826, 63855, 63883, 63914, 63944, 63976, 64007, 64036, 64064, 64096, 64127, 64166, 64203, 64224, 64247, 64270, 64295, 64320, 64342, 64364,
	/* 2761 */ 64429, 64463, 64485, 64505,
	/* 2765 */ 65177, 65198, 65219, 65240, 65261, 65282, 65304, 65329, 65350, 65372, 65394, 65419, 65444, 65465, 65486, 65508,
	/* 2781 */ 65544, 65557, 65580, 65603, 65626, 65644, 65663, 65682, 65701, 65725, 65749, 65773, 65798, 65823, 65848, 65873, 65896, 65921, 65947,
	/* 2800 */ 65973, 65998, 66024, 66050, 66076, 66101, 66126,
	/* 2807 */ 66162, 66193, 66221, 66250, 66281,
	/* 2812 */ 66343, 66366, 66389, 66412,
	/* 2816 */ 66446, 66470, 66494, 66518,
	/* 2820 */ 66554, 66579, 66604, 66629,
	/* 2824 */ 66672, 66689, 66706, 66723,
	/* 2828 */ 66799, 66815, 66831, 66847, 66863, 66879,
	/* 2834 */ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67257, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67271, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67285,
	/* 3075 */ 69082, 69092, 69105, 69119,
	/* 3079 */ 69416, 69431, 69447, 69463,
	/* 3083 */ 69628, 69638, 69656, 69666,
	/* 3087 */ 69938, 69949, 69959, 69970, 69982, 69995, 70009, 70021,
	/* 3095 */ 245, 70185, 69082, 10349,
	/* 3099 */ 70307, 70317, 70322, 70327,
	/* 3103 */ 70350, 70361, 70371, 70382,
	/* 3107 */ 70551, 70567,
	/* 3109 */ 70598, 70611, 70624, 70637,
	/* 3113 */ 70706, 70719, 70729, 70741,
	/* 3117 */ -1, 19682, 12976, -1, 13014, -1, -1, -1, 13356, -1, -1, -1, -1, -1, -1, -1, 13052, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70908, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70914, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70920, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13090, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70927, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70933, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70939, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70946, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70952, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70959, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70966,
	/* 35886 */ 71352, 71375, 71398, 71421,
	/* 35890 */ 71468, 71493, 71518, 71543,
	/* 35894 */ 71577, 71601,
	/* 35896 */ 71633, 71657,
	/* 35898 */ 71689, 71713, 71737, 71761,
	/* 35902 */ 71793, 71818, 71843, 71868,
	/* 35906 */ 71902, 71927, 71952, 71977,
	/* 35910 */ 72011, 72037, 72063, 72089,
	/* 35914 */ 72125, 72148, 72171, 72194,
	/* 35918 */ 72224, 72258, 72293, 72328,
	/* 35922 */ 72371, 72405, 72440, 72475,
	/* 35926 */ 72518, 72541, 72564, 72587,
	/* 35930 */ 72617, 72651, 72686, 72721,
	/* 35934 */ 72764, 72798, 72833, 72868,
	/* 35938 */ 72911, 72939, 72967, 72995,
	/* 35942 */ 73035, 73074, 73114, 73154,
	/* 35946 */ 73207, 73246, 73286, 73326,
	/* 35950 */ 74028, 74041, 74054, 74067, 74088, 74107, 74125, 74143, 74158, 74175, 74192, 74204, 74215, 74227, 74240, 74252,
	/* 35966 */ 74990, 75011, 75032, 75053, 75074,
	/* 35971 */ 75402, 75418, 75435, 75452, 75473,
	/* 35976 */ 75604, 75620, 75636, 75653, 75670, 75691, 75715, 75739, 75762, 75785,
	/* 35986 */ 75972, 75999, 76017, 76035, 76057, 76081, 76102, 76121, 76142, 76163, 76185,
	/* 35997 */ 55171, 76247, -1, 76260, -1, -1, 76273, -1, -1, -1, -1, 76285, -1, 76297, -1, 76309,
	/* 36013 */ 76816, 76851, 76886, 76918, 76950, 76982, 77014, 77048,
	/* 36021 */ 77112, 77126, 77139, 77157, 77170, 77183, 77204, 77228,
	/* 36029 */ 77304, 77315, 77325, 77341, 77367, 77383, 77409, 77425, 77451, 77467, 77493, 77518, 77539, 77564, 77585, 77616, 77633, 77654, 77671, 77692, 77713,
	/* 36050 */ 77759, 77777, 77796, 77813, 77830,
	/* 36055 */ 77943, 77958, 77979, 78001,
	/* 36059 */ 78035, 78051,
	/* 36061 */ 78667, 78678, 78688, 78712, 78723, 78737, 78757, 78775,
	/* 36069 */ 78787, -1, -1, -1, -1, 78798, -1, -1, -1, -1, 78805, -1, -1, -1, -1, 78812, -1, 78819, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78828, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78846, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78865, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78882, -1, -1, -1, -1, 78889, -1, -1, -1, -1, 78901, -1, -1, -1, -1, 78908, -1, -1, -1, -1, -1, -1, 78915, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78924, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78934, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78943, -1, -1, -1, -1, -1, -1, 78959, -1, -1, -1, -1, 78966, -1, -1, -1, -1, 78973, -1, -1, -1, -1, 78984, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 78991, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79008, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79018, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 79034, -1, 79042, -1, -1, -1, -1, 79049, -1, -1, -1, -1, 79056, -1, -1, -1, -1, 79063,
	/* 36325 */ 79148, 79155, 79175, 79180,
	/* 36329 */ 79326, 79339, 79358, 79380,
	/* 36333 */ 79889, 79909,
	/* 36335 */ 79921, 79935, 79948,
	/* 36338 */ 81936, 81947, 81963, 81978, 81994, 82008, 82021, 82036, 82055, 82070, 82082, 82101, 82121, 82139, 82158, 82173, 82188, 82210, 82225, 82240, 82255, 82271,
	/* 36360 */ 82405, 82412, 82426, 82440, 82454, 82468,
	/* 36366 */ 82489, 82501, 82512, 82523,
	/* 36370 */ 81953, 81984, 82027, 82216,
	/* 36374 */ 83511, 83524, 83537,
	/* 36377 */ 83549, 83567, 83587, 83607,
	/* 36381 */ 83635, 83651, 83668, 83686,
	/* 36385 */ 83714, 83729, 83747,
	/* 36388 */ 83843, 83857, 83880, 83903, 83926, 83941, 83954, 83966, 83983, 84002, 84012, 84032, 84052, 84071, 84083, 84095, 84112, 84129, 84145, 84156, 84176, 84205, 84216, 84242, 84260, 84277, 84296, 84314, 84333, 84349, 84373, 84393, 84415, 84437, 84451, 84470, 84486, 84496, 84510, 84523, 84538, 84556, 84568, 84591, 84616, 84638, 84663, 84685, 84693, 84701, 84729, 84751, 84770, 84788, 84808, 84826, 84846, 84870, 84891, 84913, 84929, 84948, 84968, 84991,
	/* 36452 */ 85527, 85540, 85552, 85564,
	/* 36456 */ 85582, 85595,
	/* 36458 */ 85613, 85626, 85638, 85652,
	/* 36462 */ 85664, 85677,
	/* 36464 */ 85695, 85709, 85721, 85742,
	/* 36468 */ 85997, 86010, 86024,
	/* 36471 */ 86034, 86047, 86057, 86071,
	/* 36475 */ 86099, 86112, 86124, 86143,
	/* 36479 */ 86240, 85956, 86233, 86248,
	/* 36483 */ 86277, 86291, 86306,
	/* 36486 */ 86329, 86343, 86358,
	/* 36489 */ 87189, 87204, 87225, 64516,
	/* 36493 */ 87283, 87294, 87302, 87318,
	/* 36497 */ 87344, 87370, 87395, 87420, 87443, 87464, 87491, 87520,
	/* 36505 */ 87836, 87852, 87869, 87896,
	/* 36509 */ 87961, 87980, 87999, 88019, 88039,
	/* 36514 */ 88232, 88250, 88273,
	/* 36517 */ 88602, 88614, 88631,
	/* 36520 */ 89014, 89026, 89039, 89052,
	/* 36524 */ 89072, 89086, 89094, 89103, 89113, 89122, 89134, 89149, 89164, 89181, 89198, 89212, 89224, 89242, 89260, 89278, 89296, 89308, 89322, 89336, 89350, 89361, 89372, 89393, 89411, 89429, 89447, 89465, 89483, 89501, 89519, 89537,
	/* 36556 */ 89558, 89571, 89584, 89599, 89614, 89626, 89638, 89650,
	/* 36564 */ 89675, 89684, 89693, 89706,
	/* 36568 */ 89783, 89798, 89816, 89844, 89874, 89905, 89933, 89963,
	/* 36576 */ 90103, 90120, 90138,
	/* 36579 */ 90351, 90370, 90390,
	/* 36582 */ 90410, 90429,
	/* 36584 */ 92677, 92689, 92701, 92713,
	/* 36588 */ 93363, 93398, 93430, 93461, 93489, 93532,
	/* 36594 */ 93586, 93623, 93657, 93690, 93720, 93765,
	/* 36600 */ 93825, 93861, 93895, 93937,
	/* 36604 */ 95219, 95252, 95292, 95322, 95355, 95394,
	/* 36610 */ 95510, 95544,
	/* 36612 */ 96845, 96865, 96874, 96880, 10349, 456,
	/* 36618 */ 509, 96907, 18666, 968,
	/* 36622 */ 26596, 96880, 11033, 96936,
	/* 36626 */ 26555, 96880, 391, 96958,
	/* 36630 */ 96989, 74481,
	/* 36632 */ 96996, 97006,
	/* 36634 */ 97088, 97096, 97104, 97114,
	/* 36638 */ 97156, 97169, 97181,
	/* 36641 */ 97197, 97205, 97213, 97223,
	/* 36645 */ 97246, -1, 97254, 97264,
	/* 36649 */ 75972, 75999, 76017, 76035, 76057, 76081, 76102, 76121, 76142, 76163, 76185, 98088,
	/* 36661 */ 89072, 89086, 89094, 89103, 89113, 89122, 89134, 89149, 89164, 89181, 89198, 89212, 89224, -1, 89260, -1, 89296, 89308, 89322, 89336, 89350, 89361, 89372, -1, 98472,
	/* 36686 */ 81936, 81947, 81963, 81978, 81994, 82008, 82021, 105051, 82055, 82070, 82082, 82101, 82121, 82139, 82158, 82173, 82188, 82210, 82225, 82240, 82255, 82271, 105066, 105093, 105120, 105147, 105174, 105198, 105218,
	/* 36715 */ 107971, 107980, 107989, 108007, 108025, 108034, 108043, 108052,
	/* 36723 */ 108061, 108082, 108103, 108126, 108149, 108169, 108189, 108214,
	/* 36731 */ 108246, 108270, 108288, 108307, 108327, 108346, 108368, 108393, 108418, 108445, 108472, 108496, 108518, 108546, 108571, 108599,
	/* 36747 */ 108669, 108681, 108700, 108719,
	/* 36751 */ 108738, 108762, 108780, 108799, 108819, 108838, 108860, 108885, 108910, 108937, 108964, 108988, 109010, 109038, 109063, 109091, 109119, 109141, 109165, 109189, 109213, 109234, 109255, 109280, 109308, 109336, 109364, 109392, 109420, 109448, 109476, 109504, 109532, 109554, 109576, 109600, 109620, 109640, 109660, 109680, 109700, 109720, 109740, 109768, 109796, 109825, 109854, 109883, 109912, 109941, 109970, 110001, 110031, 110062, 110092, 110122, 110153, 110184, 110204, 110226, 110244, 110271, 110295, 110321,
	/* 36815 */ 110355, 110376, 110397, 110420, 110443, 110463, 110483, 110508, 110529, 110555, 110575, 110597, 110623, 110644, 110668, 110695,
	/* 36831 */ 110755, 110774, 110793, 110812, 110831, 110850, 110869, 110888, 110907, 110922, 110937, 110952, 110969, 110990, 111011, 111031,
	/* 36847 */ 111076, 111088, 111102, 111126, 111156, 111181, 111212, 111232,
	/* 36855 */ 111258, 111285, 111311, 111338, 111369, 111398, 111428, 111462,
	/* 36863 */ 111490, 111515, 111538,
	/* 36866 */ 111561, 111584, 111610, 111639,
	/* 36870 */ 111671, 111692, 111714,
	/* 36873 */ 111737, 111760, 111784,
	/* 36876 */ 111857, 111889, 111922, 111955,
	/* 36880 */ 66162, 66193, 66221, 112083,
	/* 36884 */ 83714, 83729, 83747, 112650,
	/* 36888 */ 83843, 83857, 83880, 83903, 83926, 83941, 83954, 83966, 83983, 112670, 84012, 84032, 84052, 84071, 112684, 84095, 84112, 84129, 112698, 112714, 84176, 84205, 84216, 84242, 84260, 84277, 84296, 84314, 84333, 112728, 84373, 84393, 84415, 84437, 84451, 84470, 84486, 112744, 84510, 84523, 84538, 84556, 84568, 84591, 84616, 84638, 84663, 84685, 84693, 84701, 84729, 84751, 84770, 84788, 112758, 84826, 84846, 84870, 84891, 84913,
	/* 36948 */ 75093, 112839, 112847, 112855,
	/* 36952 */ 26596, 96880, -1, 96936,
	/* 36956 */ 108061, 108082, 108103, 108126, 108149, 108169, 113227, 108214,
	/* 36964 */ 110355, 110376, 110397, 110420, 110443, 110463, 113253, 110508, 110529, 110555, 113279, 113306, 113333, 113360, 110668, 110695,
	/* 36980 */ 111737, 111760, 111784, 113449,
	/* 36984 */ 83843, 83857, 83880, 83903, 83926, 83941, 83954, 83966, 83983, 112670, 84012, 84032, 84052, 84071, 112684, 84095, 84112, 84129, 112698, 112714, 84176, 84205, 84216, 84242, 84260, 84277, 84296, 84314, 84333, 112728, 84373, 84393, 84415, 84437, 84451, 84470, 84486, 84496, 84510, 84523, 84538, 84556, 84568, 84591, 84616, 84638, 84663, 84685, 84693, 84701, 84729, 84751, 84770, 84788, 112758, 84826, 84846, 84870, 84891, 84913, 84929,
	/* 37045 */ 108738, 108762, 108780, 108799, 108819, 108838, 108860, 108885, 108910, 108937, 108964, 108988, 109010, 109038, 109063, 113629, 109119, 109141, 109165, 109189, 109213, 109234, 109255, 113657, 113686, 113711, 113737, 113760, 113784, 109448, 109476, 109504, 109532, 109554, 109576, 109600, 109620, 109640, 109660, 109680, 109700, 109720, 113811, 113845, 109796, 109825, 109854, 109883, 109912, 109941, 109970, 110001, 110031, 110062, 110092, 110122, 110153, 110184, 110204, 110226, 110244, 113879, 113903, 110321,
	/* 37109 */ 108061, 108082, 108103, 108126, 108149, 108169, 113975, 108214,
	/* 37117 */ 108738, 108762, 108780, 108799, 108819, 108838, 108860, 108885, 108910, 108937, 108964, 108988, 109010, 109038, 109063, 109091, 109119, 109141, 109165, 109189, 109213, 109234, 109255, 113657, 113686, 113711, 113737, 113760, 113784, 109448, 109476, 114029, 109532, 109554, 109576, 109600, 109620, 109640, 109660, 109680, 109700, 109720, 113629, 113811, 113845, 114049, 114071, 114099, 114127, 114160, 114188, 114216, 114249, 114273, 114300, 114333, 114372, 110184, 110204, 114400, 114428, 113879, 113903, 110321,
	/* 37181 */ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 114456, 114478,
	/* 37242 */ 110355, 110376, 110397, 110420, 110443, 110463, 114520, 110508, 110529, 110555, 113279, 113306, 113333, 113360, 110668, 110695,
	/* 37258 */ 114546, 114573, 114600, 114627, 114654, 114681, 114708, 114737, 114765, 114794, 114822, 114850, 114879, 114908, 114941, 114974,
	/* 37274 */ 72617, 72651, 72686, 72721, 115075,
	/* 37279 */ 72764, 72798, 72833, 72868, 115111,
	/* 37284 */ 73035, 73074, 73114, 73154, 115147,
	/* 37289 */ 73207, 73246, 73286, 73326, 115188,
	/* 37294 */ 83843, 83857, 83880, 83903, 83926, 83941, 83954, 83966, 83983, 112670, 84012, 84032, 84052, 84071, 84083, 84095, 84112, 84129, 84145, 84156, 84176, 84205, 84216, 84242, 84260, 84277, 84296, 84314, 115248, 115263, 84373, 84393, 84415, 84437, 84451, 84470, 84486, 84496, 84510, 84523, 84538, 84556, 84568, 84591, 84616, 84638, 84663, 84685, 84693, 84701, 84729, 84751, 84770, 84788, 112758, 84826, 84846, 84870, 84891, 84913, 84929, 84948, 84968, 115278,
};

#endif
